<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * admin.php. This script forsees in some (most) general admin tasks
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */
require_once "initiate.php";

global $lang, $database, $host, $user, $pass;



if (isset($_REQUEST['phpinfo'])) {

	MustBeAdmin();
	phpinfo();
	exit;

} elseif ($_REQUEST['ExportSettings']) {

	MustBeAdmin();
	ExportSettings();
	exit;

}

if (is_administrator())
{
	$GLOBALS["InAdminSection"] = true;
}

ShowHeaders();

if (ipi($_REQUEST['BeThisUser']) && (is_administrator() || CheckFunctionAccess("UserAdminSudo") == "ok")) {

	if (!is_administrator($_REQUEST['BeThisUser'])) {

		if (!is_administrator()) {
			// User with privilege to log in as other user
			if (GetGroup($GLOBALS['USERID']) == GetGroup($_REQUEST['BeThisUser'])) {
				PrintAD("You can only log in as a user not belonging to your own group. Access denied.");
				EndHTML();
				exit;
			}
		}

		log_msg("Administrative user " . GetUserName($GLOBALS['USERID']) . " switched to the profile of user " . GetUserName($_REQUEST['BeThisUser']));
		mcq("UPDATE CRMsessions SET userid=" . $_REQUEST['BeThisUser'] . " WHERE temp='" . mres($GLOBALS['sessionid']) . "'");
		$GLOBALS['USERID'] = $_REQUEST['BeThisUser'];
		?>
			<script type="text/javascript">
			<!--
				alert('You are now logged in as <?php echo GetUserName($_REQUEST['BeThisUser']);?>. You have to\nlog out and in again to go back to your own account.');
				window.location.href = 'index.php';
			//-->
			</script>
		<?php
		EndHTML();
		exit;
	} else {
		PrintAD("You cannot log in as another administrator, that would be unethical. Sorry.");
	}
}

/* beyond this point only admin functions */

MustBeAdmin();
if ($_GET['charset'] == 1) {
    create_charset_queries_for_deploy($_GET['print']);
} elseif ($_GET['basicstats'] == 1) {
	foreach (db_GetFlatArray("SELECT item FROM CRMstats GROUP BY item") AS $item) {
		print CreateHighChartFromSQLNEW($item, "#records", "SELECT DATE(timestamp_last_change), `count` FROM CRMstats WHERE item='" . mres($item) . "' ORDER BY id", "line", "", "", true);
	}
} elseif (isset($_REQUEST['check_database_fields'])) {
	check_database_fields();
} elseif (isset($_REQUEST['dropds'])) {

	AdminChangesDropCache(true);
	print '<h1>Data structures dropped</h1>';

	$autodrop = GetAttribute('user','AutoDropDS', $GLOBALS['userid']);
    if ($autodrop == '') {
        SetAttribute('user', 'AutoDropDS', 'Yes', $GLOBALS['USERID'], array('Yes', 'No'));
    }
    $dropds = 'Automatically drop the datastructure on change of relevant settings (slower): <u><div style="display: inline;" id="JS_attr_user-AutoDropDS-' . $GLOBALS['userid'] . '">' . AttributeAjaxEditElement('user', 'AutoDropDS', $GLOBALS['USERID'], true) . '</div></u>.';
	print $dropds;
} elseif ($_REQUEST['DropAllCache']) {
	DropAllCache();
	print " <span class=\"okmsg\">Done</span>";
} elseif (isset($_GET['AnalyzeTables'])) {
	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $props) {
	mcq("ANALYZE TABLE `CRM" . $props['name_in_database'] . "`");
	}
	print "<span class=\"okmsg\">Done</span>";
} elseif (isset($_REQUEST['recreate_mysql_triggers'])) {
	$triggers = return_mysql_trigger_queries();
	print '<pre>';
	foreach ($triggers AS $sql) {
		print htme($sql) . "\n";
		mcq($sql);
	}
	print '</pre>';
	print " <span class=\"okmsg\">Done</span>";
} elseif (isset($_REQUEST['create_indices'])) {
	print "<span class=\"okmsg\">Done</span>";
	create_indices();

} elseif (isset($_GET['CalendarAdmin'])) {

	CalendarAdmin();

} elseif (ipi($_REQUEST['normalize'])) {

	NormalizeField($_REQUEST['normalize'], $_REQUEST['action']);

} elseif ($_REQUEST['checkfiles'] == 1) {

	$do = false;
	if ($_REQUEST['do_deletes'] == 1) {
		$do = true;
	}
	find_and_delete_orphaned_files_in_db_and_on_disk($do);

} elseif (isset($_REQUEST['MailQueueManager'])) {

	MailQueueManager();

} elseif (isset($_REQUEST['get_list_options_and_descriptions'])) {

	print '<table class="crm filtertable"><thead><tr><th>Tag</th><th>Description</th><th>Valid options</th><th>Default value</th></tr></thead>';
	foreach (get_list_options_and_descriptions() AS $tag => $arr) {
		print '<tr><td>' . htme($tag) . '</td><td>' . htme($arr['Description']) . '</td><td>' . htme(implode(", ", $arr['Valid'])) . '</td><td>' . htme($arr['Default']) . '</tr></tr>';
	}
	print '</table>';

} elseif (ipi($_REQUEST['get_default_form_for_table'])) {

	print '<h1>Sample default form without childs</h1>';
	print "<textarea rows=\"5\" cols=\"150\">" . ReturnDefaultFormForTable("t" . $_REQUEST['get_default_form_for_table'], true, true, true) . "</textarea>";

	print '<h1>Sample default form with childs</h1>';
	print "<textarea rows=\"5\" cols=\"150\">" . ReturnDefaultFormForTable("t" . $_REQUEST['get_default_form_for_table'], true, true, true, true, false) . ReturnDefaultFormForTable("t" . $_REQUEST['get_default_form_for_table'], true, true, true, true, true) . "</textarea>";

	$dst = "t" . $_REQUEST['get_default_form_for_table'];

	print '<h1>Sample PDF template</h1>';
	print "<textarea rows=\"5\" cols=\"150\">" . htme(ReturnDefaultPDFTemplateForTable("t" . $_REQUEST['get_default_form_for_table']), 0, false) . '</textarea>';

	print '<h1>Sample PDF template with childs</h1>';
	print "<textarea rows=\"5\" cols=\"150\">" . htme(ReturnDefaultPDFTemplateForTable("t" . $_REQUEST['get_default_form_for_table']), 0, true) . '</textarea>';

//	print "<textarea rows=\"5\" cols=\"150\">" . ReturnDefaultFormForTable("t" . $_REQUEST['get_default_form_for_table'], true, true, true, true, false) . "</textarea>";

} elseif (isset($_REQUEST['FindAndReplace'])) {

	print "<form name='farForm' id='JS_farForm' action='' method='post'>";
	if ($_POST['far_field'] != "" && $_POST['lookFor'] != "" && ($_POST['goReplace'] || $_POST['far_field'] == "%%all_config%%")) {

		if ($_POST['far_field'] != "%%all_config%%") {
			$tmp = explode(".", $_POST['far_field']);
			$table = "CRM" . $tmp[0];
			$sql = "UPDATE " . $table . " SET CRM" . $_POST['far_field'] . " = REPLACE(CRM" . $_POST['far_field'] . ",'" . mres($_POST['lookFor']) . "','" . mres($_POST['replaceWith']) . "') WHERE CRM" . $_POST['far_field'] . " LIKE '%" . $_POST['lookFor'] . "%'";
			mcq($sql);
		} else {


			$fields = array("extrafields.name","extrafields.remarks", "extrafields.displaylistname", "extrafields.defaultval", "flextabledefs.tablename", "flextabledefs.addlinktext", "flextabledefs.comment", "flextabledefs.headerhtml", "languages.TEXT", "modules.module_name", "modules.module_description", "modules.module_code","templates.templatename", "templates.content", "templates.template_subject", "extrafields.calculation");

			foreach ($fields AS $field) {
				$tmp = explode(".", $field);
				$table = "CRM" . $tmp[0];
				$sql = "UPDATE " . $table . " SET CRM" . $field . " = REPLACE(CRM" . $field . ",'" . mres($_POST['lookFor']) . "','" . mres($_POST['replaceWith']) . "') WHERE CRM" . $field . " LIKE '%" . mres($_POST['lookFor']) . "%'";
				mcq($sql);
				print "Updated: " . $field . "<br>";
			}


			// options moet nog (serialized)

		}

		print "Replacements made.";
	} elseif ($_POST['far_field'] != "" && $_POST['lookFor'] != "") {
		$tmp = explode(".", $_POST['far_field']);
		$table = "CRM" . $tmp[0];
		$tmp = db_GetValue("SELECT COUNT(*) FROM " . $table . " WHERE CRM" . $_POST['far_field'] . " LIKE '%" . $_POST['lookFor'] . "%'");
		print $tmp . " records will be changed. Continue?<br><br>";
		print "<input type=\"submit\" name=\"farSubmit\" id=\"JS_farSubmit\" value=\"Replace!\">";
		print "<input type=\"hidden\" name=\"FindAndReplace\" id=\"JS_FindAndReplace\" value=\"1\">";
		print "<input type=\"hidden\" name=\"goReplace\" id=\"JS_goReplace\" value=\"1\">";
		print "<input type=\"hidden\" name=\"far_field\" id=\"JS_far_field\" value=\"". htme($_POST['far_field']) . "\">";
		print "<input type=\"hidden\" name=\"lookFor\" id=\"JS_lookFor\" value=\"". htme($_POST['lookFor']) . "\">";
		print "<input type=\"hidden\" name=\"replaceWith\" id=\"JS_replaceWith\" value=\"" . htme($_POST['replaceWith']) . "\">";
	} else {

		print "In field:<br>";
		$fields = array("templates.content" => "All template contents", "templates.template_subject" => "All template subjects", "templates.templatename" => "All template names", "extrafields.options" => "All field options", "binfiles.filename" => "All filenames (binfiles)", "%%all_config%%" => "All configuration items, no confirmation");


		$tmp = db_GetArray("SELECT id,tabletype, name FROM CRMextrafields WHERE deleted='n'");
		foreach ($tmp AS $field) {
			if (is_numeric($field['tabletype'])) $field['tabletype'] = "flextable" . $field['tabletype'];
			$fields[$field['tabletype'] . ".EFID" . $field['id']] = $field['name'] . " (" . $field['tabletype'] . ")";
		}
		print "<select name=\"far_field\" id=\"JS_far_field\">";
		foreach ($fields AS $field => $desc) {
			print "<option value=\"" . $field . "\">" . $desc . "</option>";
		}
		print "</select>";
		print " " . ReturnDropDownSearchField("JS_far_field");

		print "<br>Replace all occurrences of:<br>";
		print "<input type='text' name='lookFor' id='JS_lookFor' size='50'>";
		print "<br>with:<br>";
		print "<input type=\"text\" name=\"replaceWith\" id=\"JS_replaceWith\" size=\"50\"><br><br>";
		print "<input type=\"submit\" name=\"farSubmit\" id=\"JS_farSubmit\" value=\"Next step\">";
		print "<input type=\"hidden\" name=\"FindAndReplace\" id=\"JS_FindAndReplace\" value=\"1\">";

	}
	print "</form>";
} elseif ($_REQUEST['UpdateTemplate']) {

	$filename = GetTemplateName($_REQUEST['UpdateTemplate']);
	print "<h1>Update template " . htme($_REQUEST['UpdateTemplate'] . ": " . $filename) . "</h1>";

	if ($_FILES['userfile'] <> "") {
		print "<div>Received file: " . htme($_FILES['userfile']['name']) . "</div>";
		if ($filename <> $_FILES['userfile']['name']) {
			print '<div class="errmsg">Filenames must be the same</div>';
		} else {
			mcq("UPDATE CRMtemplates SET binary_content='" . mres(file_get_contents($_FILES['userfile']['tmp_name'])) . "' WHERE templateid='" . mres($_REQUEST['UpdateTemplate']) . "'");
			print '<div class="okmsg">Template updated</div>';
		}
	} else {

		print "<form method='post' action='' enctype='multipart/form-data'><input type='hidden' name='max_file_size' value='52428800'><input type='hidden' name='templates' value='1'><input name='userfile' type='file'> <input type='submit' value='Update template'>";
		print "<input type='hidden' name='UpdateTemplate' value='" . htme($_REQUEST['UpdateTemplate']) . "'>";
		print "</form>";
	}

} elseif (isset($_REQUEST['ArchiveLog'])) {

	ArchiveLog($_REQUEST['log'], $_REQUEST['date_from']);

} elseif ($_REQUEST['excessfields']) {

	DropUnusedFieldsFromDatabase();

} elseif ($_REQUEST['DeleteOldVersions'] == 1) {

	DeleteOldVersions();

} elseif ($_REQUEST['RecalculateCalculations']) {

	print '<pre>';
	recalc_calculations("", true, true);
	print '</pre>';
	print "All calculations were recalculated.";

	qlog(INFO, "All calculations were recalculated.");

	$_REQUEST['datman'] = 1;
} elseif ($_REQUEST['RunCompression']) {

	ProcessArchiving();

} elseif ($_REQUEST['ImportSettings']) {

	ImportSettings();

} elseif ($_REQUEST['log']) {

	list($number_of_records, $output) = make_list(array("table" => "uselog"));
	print $output;

} elseif (isset($_REQUEST['GeneralFiles']) || isset($_REQUEST['SystemFiles'])  || isset($_REQUEST['PublicFiles'])) {


	if ($_POST['reimport']) {
		$fid = $_POST['reimport'];
		/* a fileid of an export file was given, to re-import */
		$filename = GetFileName($fid);
		if (strpos($filename, "_archive_b4_") !== false) {
			$filename1 = CopyFileToDisk($fid);
			$filename2 = tempnam(GetSetting("TMP_FILE_PATH"),"log_archive_uncompressed_");
			scmd("tar -xvzOf $filename1 > $filename2");
			unlink($filename1);
			print exec("file $filename2");
			$fp = fopen($filename2, "r");
			if ($fp) {
				while (($line = fgets($fp)) !== false) {
					// process the line read.
					mcq($line);
				}

				fclose($fp);
				mcq("UPDATE CRMbinfiles SET filename = REPLACE(filename, 'b4_', 'b4-REIMPORTED_') WHERE fileid='" . $fid . "'");
			} else {
				// error opening the file.
				print 'Error. Did nothing.<br>';
			}
			unlink($filename2);
		} else {
			PrintAD("This is not an Interleave archive file");
		}

	}

	$tag = "";
	$output = '';
	if (isset($_REQUEST['GeneralFiles'])) {

		print '<h1>General purpose files</h1>';
		print "<div>These files are accessible for every user with a valid session.</div>";
		print "<div>To refer to these files, create a hyperlink in your template to csv.php?fileid={file-id}.</div>";
		print '<form name="generalfiles" id="JS_generalfiles" method="post" action="">';
		print FileUploadBox('generalpurpose', 0, 0);
		print '</form>';

		list($number_of_records, $output) = make_list(array("table" => "files", "listid" => "generalpurposefiles", "hiddenfilter" => array("files-type" => array("generalpurpose"))));

	} elseif (isset($_REQUEST['PublicFiles'])) {

		print '<h1>Public files</h1>';
		print "<div>These files are accessible for the whole world, even if not logged in.</div>";
		print "<div>To refer to these files, create a hyperlink in your template to publicfile.php?filename={{filename}}.</div>";
		print '<form name="publicfiles" id="JS_publicfiles" method="post" action="">';
		print FileUploadBox('public', 0, 0);
		print '</form>';

		list($number_of_records, $output) = make_list(array("table" => "files", "listid" => "publicfiles", "hiddenfilter" => array("files-type" => array("public"))));

	} else {

		print '<h1>System files</h1>';
		print "<div>These files are only accessible for administrators.</div>";
		print '<form name="generalfiles" id="JS_generalfiles" method="post" action="">';
		print FileUploadBox('system', 0, 0);
		print '</form>';
		list($number_of_records, $output) = make_list(array("table" => "files", "listid" => "systemfiles", "hiddenfilter" => array("files-type" => array("system"))));
		print '<form name="import_export" method="post" action="admin.php?SystemFiles=1">Re-import exported archive file (enter fileid): <input  size="4" name="reimport" id="JS_reimport"> <input type="submit" value="Import"></form>';
	}
	print $output;

} elseif ($_REQUEST['templates']) {

	$dnd = false;
	if (!$_REQUEST['t1'] && !$template_to_edit) {
		$_REQUEST['t1'] = "add";
	    $_REQUEST['nav'] = "add";
		$dnd = true;
	}

	$tabbs = array();

	$tabbs["html"] =        array("admin.php?templates=1&amp;nav=html&amp;t1=html","Plain HTML/CSS", "All plain HTML and CSS templates ");
	$tabbs["htmlforms"] =   array("admin.php?templates=1&amp;nav=htmlforms&amp;t1=htmlf" ,"Forms",  "Record forms");
	$tabbs["dashtemplates"] =   array("admin.php?templates=1&amp;nav=dashtemplates&amp;t1=dash"   , "Dashboard",  "Templates used for custom made dashboards");
	$tabbs["htmlreports"] = array("admin.php?templates=1&amp;nav=htmlreports&amp;t1=htmlr" , "HTML Summary page reports",  "Summary page report templates");

	$tabbs["pdfreports"] =  array("admin.php?templates=1&amp;nav=pdfreports&amp;t1=pdfr"   , "PDF Reports",  "PDF templates (in HTML)");


	if ($_REQUEST['nav'] == "taglist") {
			print "Tag overview";
			print "<table class='crm'><tr><td>";
			AvailableTags();
			print "</td></tr></table>";
			EndHTML();
			exit;
	} elseif (!$_FILES['userfile']['tmp_name'] =="" && !$_FILES['userfile']['name']=="" && !$_FILES['userfile']['size']=="" && !$_FILES['userfile']['type']=="") {

			//  A file was attached

			// Read contents of uploaded file into variable

				$fp=fopen($_FILES['userfile']['tmp_name'] ,"rb");
				$filecontent=fread($fp,filesize($_FILES['userfile']['tmp_name'] ));
				fclose($fp);

				 mcq("INSERT INTO CRMtemplates(templatename, templatetype, content, binary_content, timestamp_last_change) VALUES('". mres($_FILES['userfile']['name']) . "','" . mres($_REQUEST['filetype']) . "','%%BLOB%%','" . mres($filecontent) . "',NOW())");

				unset($filecontent);
				unset($_FILES['userfile']['tmp_name'] );
				unset($_FILES['userfile']['name']);
				unset($_FILES['userfile']['size']);
				unset($_FILES['userfile']['type']);
				print '<div class="okmsg">Template created</div>';
	}


	$template_to_edit = $_REQUEST['editHTMLtemplate'];
	$template_to_dup = $_REQUEST['duplicate'];

	if ($_REQUEST['new_HTML_template']) {
		qlog(INFO, "Empty HTML template created");
		mcq("INSERT INTO CRMtemplates(templatename, templatetype, content, timestamp_last_change) VALUES('". mres($_REQUEST['new_HTML_template']) . "','" . mres($_REQUEST['filetype']) . "','',NOW())");
		$t = db_GetInsertId();
		print '<div class="okmsg">Template created</div>';
		mcq("INSERT INTO CRMtemplateaccessrules (template) VALUES(" . $t . ")");
		print '<div class="warnmsg">This newly created template is accessible only for administrators. <a onclick="PopFancyBox(\'\',\'choose_templaterights.php?nonavbar=1&amp;template=' . $t . '\')">Change this here</a>.</div>';
		$template_to_edit = $t;
	} elseif ($template_to_edit == 'duplicate' && ipi($template_to_dup)) {

		/* we copy everything except the page id to avoid duplicate page id's */

		$sql = "INSERT INTO CRMtemplates(templatename, templatetype, template_subject, stylesheet, orientation, content, binary_content) SELECT CONCAT(templatename, '-duplicate'), templatetype, template_subject, stylesheet, orientation, content, binary_content FROM CRMtemplates WHERE templateid='" . mres($template_to_dup) . "'";
		mcq($sql);
		$template_to_edit = db_GetInsertId();
		$sql = "INSERT INTO CRMtemplateaccessrules(template, `group`, `read`) SELECT '" . $template_to_edit . "',`group`, `read` FROM CRMtemplateaccessrules WHERE template='" . $template_to_dup . "'";
		mcq($sql);


	}

	if ($template_to_edit) {



		if ($_REQUEST['saveHTMLtemplate'] && isset($_REQUEST['data'])) {

			$_REQUEST['subject'] = RemoveFieldnamesFromTags($_REQUEST['subject']);
			//AdminChangesDropCache();

			if ($_REQUEST['stylesheet'] == "") $_REQUEST['stylesheet'] = "0";

			// Versioning
			//mcq("INSERT INTO CRMtemplates (binary_content, content, orientation, page_id, stylesheet, template_subject, templatename, templatetype) SELECT binary_content, content, orientation, page_id, stylesheet, template_subject, templatename, templatetype FROM CRMtemplates WHERE templateid='" . $_REQUEST['saveHTMLtemplate'] . "'");
			//$new = db_GetInsertId();
			//mcq("UPDATE CRMtemplates SET version_belonging_to = '" . $_REQUEST['saveHTMLtemplate'] . "' WHERE templateid='" . $new . "'");

			$sql = "UPDATE CRMtemplates SET orientation='" . mres($_REQUEST['orientation']) . "', template_subject='" . mres($_REQUEST['subject']) . "', templatename='" . mres($_REQUEST['newfilename']) . "', stylesheet='" . mres($_REQUEST['stylesheet']) . "',page_id='" . mres($_REQUEST['page_id']) . "' WHERE templateid='" . mres($_REQUEST['saveHTMLtemplate']) . "'";

			if (GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_REPORT_PDF" || GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_PLAIN") {
				$FormatNumbers = GetAttribute("template", "FormatNumbers", $_REQUEST['saveHTMLtemplate']);
				if ($FormatNumbers == "") SetAttribute("template", "FormatNumbers", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));
			}
			if (GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_PLAIN" || GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_HTML") {
				$headers = GetAttribute("template", "ShowHeaders", $_REQUEST['saveHTMLtemplate']);
				if ($headers == "") {
					SetAttribute("template", "ShowHeaders", "Yes", $_REQUEST['saveHTMLtemplate'], array('Yes', 'No'));
				}
			}
			$DontUseHTMLEditor = GetAttribute("template", "DontUseHTMLEditor", $_REQUEST['saveHTMLtemplate']);
			if ($DontUseHTMLEditor == "") SetAttribute("template", "DontUseHTMLEditor", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

			if (GetTemplateType($_REQUEST['saveHTMLtemplate']) == "TEMPLATE_REPORT_PDF") {
				$AllowUserToEditParsedResultBeforeCreatingPDF = GetAttribute("template", "AllowUserToEditParsedResultBeforeCreatingPDF", $_REQUEST['saveHTMLtemplate']);
				if ($AllowUserToEditParsedResultBeforeCreatingPDF == "") SetAttribute("template", "AllowUserToEditParsedResultBeforeCreatingPDF", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

				$EditBeforeParseHTML = GetAttribute("template", "EditBeforeParseHTML", $_REQUEST['saveHTMLtemplate']);
				if ($EditBeforeParseHTML == "") SetAttribute("template", "EditBeforeParseHTML", "Please review your document", $_REQUEST['saveHTMLtemplate']);

				$EditBeforeParseButtonText = GetAttribute("template", "EditBeforeParseButtonText", $_REQUEST['saveHTMLtemplate']);
				if ($EditBeforeParseButtonText == "") SetAttribute("template", "EditBeforeParseButtonText", "Download PDF document", $_REQUEST['saveHTMLtemplate']);

				$HideHeader = GetAttribute("template", "HideHeader", $_REQUEST['saveHTMLtemplate']);
				if ($HideHeader == "") SetAttribute("template", "HideHeader", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

				$HideFooter = GetAttribute("template", "HideFooter", $_REQUEST['saveHTMLtemplate']);
				if ($HideFooter == "") SetAttribute("template", "HideFooter", "No", $_REQUEST['saveHTMLtemplate'], array('No', 'Yes'));

				$LogoFileLocation = GetAttribute("template", "LogoFileLocation", $_REQUEST['saveHTMLtemplate']);
				if ($LogoFileLocation == "") SetAttribute("template", "LogoFileLocation", "images/interleave.gif", $_REQUEST['saveHTMLtemplate']);

				$PDFPageDimensions = GetAttribute("template", "PDFPageDimensions", $_REQUEST['saveHTMLtemplate']);
				if ($PDFPageDimensions == "") SetAttribute("template", "PDFPageDimensions", "{{none}}", $_REQUEST['saveHTMLtemplate']);

				$FooterContent = GetAttribute("template", "FooterContent", $_REQUEST['saveHTMLtemplate']);
				if ($FooterContent == "") SetAttribute("template", "FooterContent", "{{none}}", $_REQUEST['saveHTMLtemplate']);

			}

			mcq($sql);



			if ($_REQUEST['data'] != "unsupported") {

				SetAttribute("template", "SaveComments " . date('Y-m-d H:i:s') . " " . GetUserName($GLOBALS['USERID']), $_REQUEST['saveComments'], $_REQUEST['saveHTMLtemplate']);
				$sql = "UPDATE CRMtemplates SET content='" . mres(RemoveFieldnamesFromTags($_REQUEST['data'])) . "' WHERE templateid='" . mres($_REQUEST['saveHTMLtemplate']) . "'";
				mcq($sql);

				update_tslc_for_all_related_templates(mres($_REQUEST['saveHTMLtemplate']));


			}
		}
		$sql = "SELECT * FROM CRMtemplates WHERE CRMtemplates.templateid='" . mres($template_to_edit)  . "' AND LEFT(templatetype,8)='TEMPLATE'";

		$row = db_GetRow($sql);

		print showchilds("templates", $template_to_edit);

		$table = "templates";
		$recordid = $row['templateid'];
		print familytree($table, $recordid, $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
		print "<h1>" . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["singular"] . " " . get_refer_layout_for_record($table, $recordid)) . "</h1>";

		print "<form id='editHTMLtemplateform' method='post' action=''>";
		print '<input type="hidden" name="starttable" value="' . htme($_REQUEST['starttable']) . '">';
		print '<input type="hidden" name="startrecordid" value="' . htme($_REQUEST['startrecordid']) . '">';
		print '<input type="hidden" name="fromlist" value="' . htme($_REQUEST['fromlist']) . '">';
		print "<input type='hidden' name='templates' value='1'>";
		print "<input type='hidden' name='editHTMLtemplate' value='" . $template_to_edit . "'>";
		print "<input type='hidden' name='saveHTMLtemplate' value='" . $template_to_edit . "'>";

		print "<table class='form-table'>";

		if ($row['templatename'] == "Default form") {

			print "<tr><td>File name</td><td><input type='text' size='70' name='newfilenameblabla' disabled value='" . htme($row['templatename']) . "'><input type='hidden' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
			print "<tr><td>Subject/description</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";

		} else {
			if ($row['templatetype'] == "TEMPLATE_REPORT_PDF" || $row['templatetype'] == "TEMPLATE_PLAIN") {
				print "<tr><td>Header title &amp; internal name</td><td><input type='text' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
				print "<tr><td>File name (tags are allowed)</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";
			} elseif ($row['templatetype'] == "TEMPLATE_PLAIN") {
				print "<tr><td>File name</td><td><input type='text' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
				print "<tr><td>Subject/description</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";
			} else {
				print "<tr><td>File name</td><td><input type='text' size='70' name='newfilename' value='" . htme($row['templatename']) . "'></td></tr>";
				print "<tr><td>Subject/description</td><td><input type='text' size='70' name='subject' value='" . htme(AddFieldnamesToTags($row['template_subject'])) . "'></td></tr>";
			}
		}
		if ($row['templatetype'] == "TEMPLATE_HTML" || $row['templatetype'] == "TEMPLATE_MENU" || $row['templatetype'] == "TEMPLATE_DASHBOARD" || $row['templatetype'] == "TEMPLATE_HTML_FORM" || $row['templatetype'] == "TEMPLATE_PDF" || $row['templatetype'] == "TEMPLATE_REPORT_PDF") {
			print "<tr><td>Style sheet</td><td>";
			print "<select name='stylesheet'>";
			print "<option value=''>System default CSS template</option>";
			$ins = "";
			if ($row['stylesheet'] == 2147483647) {
					$ins = "selected";
				}
			print "<option value='2147483647' " . $ins . ">No CSS template</option>";

			foreach (GetStyleSheets() AS $sheet) {
				$ins = "";
				if ($row['stylesheet'] == $sheet['templateid']) {
					$ins = "selected";
				}
				print "<option value='" . $sheet['templateid'] . "' " . $ins . ">" . $sheet['templatename'] . " (" . AddFieldnamesToTags($sheet['template_subject']) . ")</option>";
			}
			print "</select></td></tr>";
		}

		if ($row['templatetype'] == "TEMPLATE_REPORT_PDF") {
			print "<tr><td>Page orientation</td><td><select name='orientation'>";
			print "<option value='P'>Portrait</option>";
			$sel = "";
			if ($row['orientation'] == "L") $sel = "selected";
			print "<option value='L' " . $sel . ">Landscape</option>";
			print "</select></td></tr>";
		}

		print "<tr><td>Page id</td><td><input type=\"text\" name=\"page_id\" id=\"JS_page_id\" size=\"20\" value=\"" . htme($row['page_id']) . "\"> To be used to open this template by referring to page.php?{{Page id}} or /{{Page id}} (with url beautification)";
		print "<tr><td>Comments/changes</td><td><input type=\"text\" name=\"saveComments\" id=\"JS_saveComments\" size=\"70\">&nbsp; <input type='submit' value='Save'> ";
		print '<a onclick="PopFancyBoxDimensioned(\'\',\'record.php?table=templates&amp;record=' . $template_to_edit . '&amp;delete=1&amp;nonavbar=1&amp;ParentAjaxHandler=templates\',300,500)" class="likebutton deletebutton">Delete</a>';

		print AttributeLink("template", $template_to_edit, "Attributes", "", true);


        if (ipi($row['templateid']))
        {
                $listoptions = array();
                $listoptions["table"] = "templateaccessrules";
                $listoptions["hiddenfilter"]["templateaccessrules-template"][] = $row['templateid'];
                $listoptions["type_of_list"] = "sublist";
                list($number_of_records, $output) = make_list($listoptions);
                //print $output;
                print ' <input type="button" onclick="PopFancyBox(\'\',\'choose_templaterights.php?template=' . $row['templateid'] . '&amp;nonavbar=1\')" value="' . $number_of_records . ' access rules">';
        }
		print '&nbsp;<input type="button" onclick="document.location.href=\'admin.php?templates=1&amp;editHTMLtemplate=duplicate&amp;duplicate=' . htme($template_to_edit) . '\'" value="Duplicate">';
		print "</td></tr>";
		print '<tr><td colspan="2">';
		if (GetTemplateType($template_to_edit) != "TEMPLATE_PLAIN") {
			$ls = new SaferScript("<?php ?>" . GetTemplate($template_to_edit) . "<?php ?>");

			$ls->allowHarmlessCalls();

			print_r($ls->parse());
		}

		print '</td></tr>';
		print "<tr><td colspan='2'>";
		$noedit = false;



		if ($row['templatetype'] == "TEMPLATE_CSS" || $row['templatetype'] == "TEMPLATE_XML" || $row['templatetype'] == "TEMPLATE_JAVASCRIPT" || $_REQUEST['code_editor']) {
			$syntax = "text/css";
			$nobacklink = false;
			if ($row['templatetype'] == "TEMPLATE_CSS") {
				$nobacklink = true;
			} elseif ($row['templatetype'] == "TEMPLATE_JAVASCRIPT") {
				$syntax = "text/javascript";
				$nobacklink = true;
			} elseif ($row['templatetype'] == "TEMPLATE_XML") {
				$syntax = "application/xml";
				$nobacklink = true;
			} else {
				$syntax = "application/x-httpd-php";
				if (strstr($row['content'], "<?php")) {
					print ValidatePHPSyntax($row['content']) . "<br>";
				}
			}
			if (!$nobacklink) {
				print "<a href='admin.php?templates=1&amp;nav=" . $_REQUEST['nav'] . "&amp;editHTMLtemplate=" . $template_to_edit . 	"&amp;code_editor=0&amp;fromlist=" . htme($_REQUEST['fromlist']) . "'> [switch to WYSIWYG-editor]</a> ";
			}
			print "<textarea id='csscode' rows='35' cols='140' name='data'>" . htme(AddFieldnamesToTags((parse_old_template_to_new_template($row['content'])))) . "</textarea>";

			print make_code_editor("csscode", $syntax);

		} elseif ($row['templatetype'] == "TEMPLATE_DASHBOARD" || $row['templatetype'] == "TEMPLATE_MENU" || strstr($row['templatetype'], "TEMPLATE_HTML") || $row['templatetype'] == "TEMPLATE_REPORT_PDF") {

			print "<a href='admin.php?templates=1&amp;nav=" . $_REQUEST['nav'] . "&amp;editHTMLtemplate=" . $template_to_edit . "&amp;code_editor=1&amp;fromlist=" . htme($_REQUEST['fromlist']) . "'> [switch to code-editor]</a> ";

			foreach (db_GetArray("SELECT * FROM CRMattributes WHERE identifier='template' AND entity='" . mres($template_to_edit) . "' AND attribute LIKE 'SaveComments%' ORDER BY STR_TO_DATE(SUBSTRING(attribute,14,19), '%Y-%m-%d %H:%i:%s') DESC") AS $rowx) {
				print "<div>" . str_replace("SaveComments ", "", $rowx['attribute']) . " :: " . htme($rowx['value']) . "</div>";
			}


			print "<textarea id='editor' rows='70' cols='140' name='data'>" . htme(AddFieldnamesToTags(($row['content']))) . "</textarea>";
			if (GetAttribute("template", "DontUseHTMLEditor", $template_to_edit) != "Yes") {
				//2015-06-10 Jeroen dit stylesheet overruled alle andere stylesgeet in de editor; dit zou alleen in gebruik moeten zijn bij emails
				$templatecss = "";
				if ($row['stylesheet'] > 0)
				{
					$templatecss = "csv.php?GetCSS=" . $row['stylesheet'] . "&nodefault=1&amp;" . date('U');
				}
				// make_html_editor($id, $protectedSource, $templatecss, $enter_is_div, $height = '500', $width = '100%', $table = '', $record = '')
				/* determine most likely table */
				$tid = mres($template_to_edit);

				/* 1. if a template is bound to a table it's always bingo */
				$t = db_GetValue("SELECT CONCAT('t', recordid) FROM CRMflextabledefs WHERE formid='" . $tid . "'");
				$mlt = '';
				if ($t!='') {
					$mlt = $t;
				} else {
					$t = db_GetValue("SELECT CONCAT('t', tabletype) FROM CRMextrafields WHERE fieldtype='Comment' AND options='" . $t . "'");
					if ($t!='') {
						$mlt = $t;
					} else {

					}

				}

				print make_html_editor("editor", true, $templatecss, true, 500, '100%', $mlt, '');

			}
		} else {
			print "This file cannot be edited on-line<input type='hidden' name='data' value='unsupported'>";
			print '<br><br><a href="csv.php?templateid=' .  htme($template_to_edit) . '">Download document</a><br><br><a href="admin.php?UpdateTemplate=' . htme($template_to_edit) . '">Update/overwite this template</a>';
			$noedit = true;
		}
		print "</td></tr>";

		if (ipi($row['templateid']))
		{
			print '<tr><td colspan="2"><ul>';
			foreach (db_GetArray("SELECT templateid, templatename FROM CRMtemplates WHERE content LIKE '%@TEMPLATE" . $row['templateid'] . "%' AND version_belonging_to=0") as $row)
			{
				print '<li>This template is used on template <a href="admin.php?templates=1&amp;editHTMLtemplate=' . $row['templateid'] . '">' . $row['templateid'] . ' ' . htme($row['templatename']) . '</a></li>';
			}
			$num = preg_match_all("/\@TEMPLATE([0-9]+)\@/", $row['content'], $matches);
			for ($x = 0; $x < $num; $x++)
			{
				print '<li>This template uses template <a href="admin.php?templates=1&amp;editHTMLtemplate=' . $matches[1][$x] . '">' . $matches[1][$x] . ' ' . htme(GetTemplateName($matches[1][$x])) . '</a></li>';
			}
			print '</ul></td></tr>';
		}

		if (!$noedit) {
			print "<tr><td><input type='submit' value='Save'></td><td></td></tr>";
		}

		print "<tr><td colspan='2'>";
		if ($template_to_edit) {
			AvailableTags();
		}

		print "</td></tr>";
		print "</table>";
		print "</form>";
	} else {

		if (!$dnd) {
			$c = db_GetArray("SELECT CRMtemplates.templateid, CRMtemplates.page_id FROM CRMtemplates WHERE CRMtemplates.templatetype IN ('TEMPLATE_HTML_FORM','TEMPLATE_HTML') AND CRMtemplates.version_belonging_to=0 AND CRMtemplates.templateid NOT IN (SELECT CRMflextabledefs.formid FROM CRMflextabledefs)");

			$d = array();
			$e = array();
			$f = array();
			foreach ($c AS $tid2) {
				$tid = $tid2[0];

				$sql = "SELECT COUNT(*) FROM CRMtemplates WHERE (CRMtemplates.content LIKE '%template_to_use=" . $tid . "%' OR CRMtemplates.content LIKE '%template=" . $tid . "%' OR CRMtemplates.content LIKE '%template_id=" . $tid . "%' OR CRMtemplates.content LIKE '%template_to_use_open=" . $tid . "%'";
				if ($tid2[1] != '') {
					$sql .= " OR CRMtemplates.content LIKE '%" . mres($tid2[1]) . "%' OR CRMtemplates.content LIKE '%" . mres(urlencode($tid2[1])) . "%'";
				}
				$sql .= " OR CRMtemplates.content LIKE '%#TEMPLATE" . $tid2[0] . "#%' ";
				$sql .= " OR CRMtemplates.content LIKE '%@TEMPLATE" . $tid2[0] . "@%' ";
				$sql .= ") AND version_belonging_to=0";



				if (db_GetValue($sql) == 0) {
					$d[] = $tid2;
				}
			}

			foreach ($d AS $tid) {

				if (db_GetValue("SELECT COUNT(*) FROM CRMextrafields WHERE CRMextrafields.fieldtype='comment' AND options='" . $tid[0] . "'") == 0) {
					$e[] = $tid;
				}
			}
			$ft = array();
			foreach ($e AS $tid) {

				if (db_GetValue("SELECT COUNT(*) FROM CRMruleactions WHERE CRMruleactions.template='" . $tid[0] . "'") == 0) {
					$ft[] = $tid;
				}
			}
			$ft2 = array();
			foreach ($ft AS $tid) {

				if (db_GetValue("SELECT COUNT(*) FROM CRMflextabledefs WHERE CRMflextabledefs.tablename='" . $tid[1] . "'") == 0) {
					$ft2[] = $tid;
				}
			}
			foreach ($ft2 AS $tid) {

				if (db_GetValue("SELECT COUNT(*) FROM CRMuserprofiles WHERE CRMuserprofiles.DASHBOARDFILEID='" . $tid[0] . "' OR CRMuserprofiles.webappmenu='" . $tid[0] . "'") == 0) {
					$f[] = $tid;
				}
			}

			$tids = array();
			if (count($f) > 0) {
				foreach ($f as $g) {
					$tids[] = $g[0];
				}

				print '<div class="warnmsg">There are ' . count($tids) . ' FORM and HTML templates rarely used or not used at all. <a href="admin.php?templates=1&t1=all&showunused=1">List them</a>. ';
				//foreach ($tids AS $tid) {
					//print '<a href="admin.php?templates=1&editHTMLtemplate=' .  $tid . '">' . $tid . '</a>, ';

				//<a href="admin.php?templates=1&amp;t1=all&amp;deltemplates=1">Delete them</a>.'
				print '</div>';
				if ($_GET['showunused'] == 1) {
					print '<div><em>Searched for: template_to_use=[id], template_to_use_open=[id], template=[id], template_id=[id], and the page id (urlencoded and plain), excluded page id\'s with the same name as a table, table forms, comment-field-templates, rule-action templates, dashboard- and webappmenus.</em></div>';
				}
				//$sql = "DELETE FROM CRMtemplates WHERE templateid IN (" . implode(",", $tids) . ") OR version_belonging_to IN (" . implode(",", $tids) . ")";
				//print $sql;
				if ($_REQUEST['deltemplates'] == 1) {
				//	mcq($sql);
				}
			}

			$ins = "";
			$lo = array("table" => "templates", "hiddenfilter" => array("templates-version_belonging_to" => array("0")));

			if ($_REQUEST['type'] != "") {
				$lo["hiddenfilter"]["templates-templatetype"] = array($_REQUEST['type']);
			}
			if ($_GET['showunused'] == 1) {
				foreach ($tids AS $tid) {
					$lo["hiddenfilter"]["templates-templateid"][] = $tid;
				}
			}
			list($number_of_records, $output) = make_list($lo);
			print $output;

		}
		if ($_REQUEST['t1']=="add" || $_REQUEST['t1']=="") {
			print "<h1>Create a new template</h1>";
			print "<form method='post' action=''>";
			print "Name <input type='text' name='new_HTML_template'><br>";
			print "Document type <select name='filetype'><option value='TEMPLATE_HTML'>HTML Plain template</option><option value='TEMPLATE_HTML_FORM'>HTML Form template</option><option value='TEMPLATE_DASHBOARD'>HTML Dashboard template</option><option value='TEMPLATE_MENU'>HTML Menu template</option><option value='TEMPLATE_REPORT_PDF'>HTML/PDF Report template</option><option value='TEMPLATE_CSS'>CSS Stylesheet</option><option value='TEMPLATE_XML'>XML template</option><option value='TEMPLATE_JAVASCRIPT'>Javascript</option></select><br>";
			print "<input type='submit' value='Create' class='addbutton'><input type='hidden' name='templates' value='1'>";
			print "</form>";

			print "<ul><li>HTML Plain template: A plain HTML template to use as email, a page (custom tab) or as comment field</li>";
			print "<li>HTML Summary page report template: A template to use as a report on the summary page</li>";
			print "<li>HTML/PDF Report template: A template to use as a PDF-report</li>";
			print "<li>CSS template: Cascading stylesheet</li>";
			print "</ul>";

			print "<h2>Upload a template</h2>";
			print "<form method='post' enctype='multipart/form-data' action=''>";
			print "<input type='hidden' name='max_file_size' value='52428800'><input type='hidden' name='templates' value='1'><input name='userfile' type='file'><br>";
			print "Document type <select name='filetype'><option value='TEMPLATE_PLAIN'>Other type (can be any of .docx, .xlsx, .rtf and all OO formats)</option></select><br>";
			print "<input type='submit' value='Upload' class='addbutton'>";
			print "</form>";
		}
	}

} elseif ($_REQUEST['ViewJournal']) {

	list($number_of_records, $output) = make_list(array("table" => "journal", "use_adaptive_filters" => false));
	print $output;

} elseif ($_REQUEST['ViewDataJournal']) {

	list($number_of_records, $output) = make_list(array("table" => "datajournal", "use_adaptive_filters" => false));
	print $output;

} elseif ($_GET["editsetting"] != "") {

	//either settingid (like "23") or setting value (like "title") is allowed
	$setting = db_GetRow("SELECT * FROM CRMsettings WHERE settingid='" . mres($_GET["editsetting"]) . "' OR setting='" . mres($_GET["editsetting"]) . "'");

	if ($setting["settingid"] > 0)
	{
		if ($_POST["save"] == 1)
		{
			if ($_POST["value"] != $setting["value"])
			{
				//no validation of input
				journal($setting["settingid"], "setting " . $setting["setting"] . " updated from '" . $setting["value"] . "' to '" . $_POST["value"] . "'", "settings");
				DataJournal($setting["settingid"], $setting["value"], $_POST["value"], "setting", "settings");
				mcq("UPDATE CRMsettings SET value='" . mres($_POST["value"]) . "' WHERE settingid=" . $setting["settingid"]);
				AdminChangesDropCache();
			}
			print '<div class="okmsg">' . htme($setting['setting']) . ' is saved</div>';
			if ($_GET['fromlist'] != "")
			{
				print '<script type="text/javascript">window.location.href=\'' . jsencode(base64_decode($_GET['fromlist'])) . '\';</script>';
			}
		}
		else
		{
			$multiline = false;
			$html = false;
			$options = array();
			$display_empty_option = false;
			if (($setting["setting"] == "SYSWIDECSS") || ($setting["setting"] == "WebAppCSS"))
			{
				$display_empty_option = true;
				$options = db_GetAssocArray("SELECT templateid, templatename FROM CRMtemplates WHERE templatetype='TEMPLATE_CSS' AND version_belonging_to='0' ORDER BY templatename");
			}
			else if ($setting["setting"] == "EXCELFILEFORMAT")
			{
				$options = array("2003" => "2003 (.XLS) File format", "2007" => "2007 (.XLSX) File format (true color, date support)");
			}
			else if ($setting["setting"] == "MINIMUMPASSWORDSTRENGTH")
			{
				$options = array("1" => "Weak: 6 or more chars (unsafe)", "2" => "Medium: 7 or more chars (lowercase letter + number OR uppercase letter + number OR lowercase letter + uppercase letter)", "3" => "Strong: 8 or more chars (lowercase letter + uppercase letter + number + other digit)");
			}
			else if ($setting["setting"] == "FILECOMPRESSIONLEVEL")
			{
				$options = array("A" => "Don't compress at all (except old versions of files)", "B1" => "Compress files older than 1 year", "C1" => "Compress files older than 6 months", "D" => "Compress all files");
			}
			else if ($setting["setting"] == "DASHBOARDTEMPLATE")
			{
				$display_empty_option = true;
				$options = db_GetAssocArray("SELECT templateid, templatename FROM CRMtemplates WHERE templatetype='TEMPLATE_DASHBOARD' AND version_belonging_to='0' ORDER BY templatename");
			}
			else if ($setting["setting"] == "MenuTemplateId")
			{
				$display_empty_option = true;
				$options = db_GetAssocArray("SELECT templateid, templatename FROM CRMtemplates WHERE templatetype='TEMPLATE_MENU' AND version_belonging_to='0' ORDER BY templatename");
			}
			else if ($setting["setting"] == "DateFormat")
			{
				$options = array("dd-mm-yyyy", "yyyy-mm-dd", "mm-dd-yyyy");
			}
			else if (($setting["setting"] == "UseMailQueue") || ($setting["setting"] == "ShowMinimalErrorMessages") || ($setting["setting"] == "EnableEntityLocking") || ($setting["setting"] == "ENABLEFILEVERSIONING") || ($setting["setting"] == "ENABLEFILEVERSIONING") || ($setting["setting"] == "USE_AUTOSAVE") || ($setting["setting"] == "ALLOWLOGONPAGEPASSCHANGE") || ($setting["setting"] == "ONEMAILPERTRIGGER") || ($setting["setting"] == "DisableAllInternalMessagePopups") || ($setting["setting"] == "MAINTENANCE_MODE") || ($setting["setting"] == "AllowFoldersInFilelists") || ($setting["setting"] == "BindSessionToIP") || ($setting["setting"] == "WebAppRedirectMobileClients") || ($setting["setting"] == "HighlightSearchesInForms") || ($setting["setting"] == "RequireTwoPhaseAuthenticationForEveryOne") || ($setting["setting"] == "RequireTwoPhaseAuthenticationPerIPForAdmins") || ($setting["setting"] == "TwoPhaseAuthenticationTrustAllLocalIPRanges") || ($setting["setting"] == "UseBrowserPreferredLanguage") || ($setting["setting"] == "UseURLBeautification") || ($setting["setting"] == "WebAppEnabled") || ($setting["setting"] == "SecurePDFsWithRandomPassword") || ($setting["setting"] == "NotificationsEnabled"))
			{
				$options = array("No", "Yes");
			}
			else if ($setting["setting"] == "MailMethod")
			{
				$options = array("smtp", "sendmail");
			}
			else if ($setting["setting"] == "DefaultExcel2007FontSize")
			{
				$options = array("11", "12", "13", "14", "15", "16", "17", "18", "19", "20");
			}
			else if ($setting["setting"] == "DefaultExcel2007Font")
			{
				$options = array("Tahoma", "Arial", "Helvetica", "Times New Roman");
			}
			else if (($setting["setting"] == "NumberOfModuleToIncludeInAllPageloads") || ($setting["setting"] == "ModuleToEvaluateOnEveryListBuild") || ($setting["setting"] == "TwoPhaseAuthenticationModuleNum"))
			{
				$display_empty_option = true;
				$options = db_GetAssocArray("SELECT mid, module_name FROM CRMmodules WHERE version_belonging_to='0' ORDER BY module_name");
			}
			else if ($setting["setting"] == "DevelopmentOrProduction")
			{
				$options = array("Development", "Production");
			}
			else if ($setting["setting"] == "OffloadFilesPolicy")
			{
				$options = array("Don't offload files to disk", "After a year", "After 6 months", "After 3 months", "After 1 month", "After 1 week", "After 1 day");
			}
			else if ($setting["setting"] == "UseSkinCSS")
			{
				$display_empty_option = true;
				$options = array("No" => "crm_dft", "Yes" => "Skin CRM (+crm_dft)", "Apple" => "Apple (+crm_dft)", "Black and blue" => "Black and blue", "Colorful" => "Colorful");
			}
			else if ($setting["setting"] == "TemplateNoOfJavascriptFileToIncludeInEveryPage")
			{
				$display_empty_option = true;
				$options = db_GetAssocArray("SELECT templateid, templatename FROM CRMtemplates WHERE version_belonging_to='0' ORDER BY templatename");
			}
			else if ($setting["setting"] == "DefaultLanguage")
			{
				$options = db_GetFlatArray("SELECT LANGID FROM CRMlanguages GROUP BY LANGID");
			}
			else if ($setting["setting"] == "TwoPhaseAuthenticationRequired")
			{
				$display_empty_option = true;
				$options = array("Every time", "Unknown IP", "First login");
			}
			else if (($setting["setting"] == "CAL_MAXHOUR") || ($setting["setting"] == "CAL_MINHOUR"))
			{
				$options = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23");
			}
			else if ($setting["setting"] == "CalendarAvailableViews")
			{
				$options = array("month,week,day", "month,week,day,multiweek", "month,week", "month,week,multiweek", "month,day", "month,day,multiweek", "week,day", "week,day,multiweek", "month", "week", "day", "multiweek");
			}
			else if (($setting["setting"] == "LoginPageMessage") || ($setting["setting"] == "BODY_ADMIN_ERRORMSG") || ($setting["setting"] == "UserImportTableHTML") || ($setting["setting"] == "WRONGSERVERMESSAGE"))
			{
				$multiline = true;
				//$html = true;
			}

			print backtolist($_GET['fromlist']);

			$journalicon = '<div id="journal-icon"><a title="Journal" href="journal.php?table=settings&amp;recordid='.$setting["settingid"].'&amp;nonavbar=1" onclick="PopFancyBoxLarge(\'\', this.href); return false;">';
			$journalicon .= '<span class="fa fa-book"></span>';
			$journalicon .= '</a></div>&nbsp;';

			print $journalicon;

			print '<h1>Setting ' . htme($setting["setting"]) . '</h1>';
			print '<div>' . htme($setting['discription']) . '</div>';
//			print '<div>Last update: ' . from_iso_datetime($setting["timestamp_last_change"]) . '</div>';
			print '<form method="post" action="">';
			print '<input type="hidden" name="save" value="1">';
			if ($multiline)
			{
				print '<textarea name="value" cols="120" rows="15" id="editsetting">' . htme($setting["value"]) . '</textarea>';
				if ($html)
				{
					print make_html_editor("editsetting", true);
				}
			}
			else if (count($options) > 0)
			{
				$is_assoc = is_assoc($options);
				$current_value_found = false;
				print '<select name="value" id="editsetting">';
				if ($display_empty_option)
				{
					print '<option value=""';
					if ($setting["value"] == $value)
					{
						print ' selected';
						$current_value_found = true;
					}
					print '></option>';
				}
				foreach ($options as $value => $text)
				{
					//if a NON associative array is passed $value is numeric; we need to use $text instead
					if (!$is_assoc)
					{
						$value = $text;
					}
					print '<option value="' . htme($value) . '"';
					if ($setting["value"] == $value)
					{
						print ' selected';
						$current_value_found = true;
					}
					print '>' . htme($text) . '</option>';
				}
				//to prevent the loss of a unselectable option
				if (!$current_value_found)
				{
					print '<option value="' . htme($setting["value"]) . '" selected>VALUE NOT FOUND: ' . htme($setting["value"]) . '</option>';
				}
				print '</select>';
				if (count($options) > 5)
				{
					print ReturnDropDownSearchField("editsetting");
				}
			}
			else
			{
				print '<input type="text" name="value" value="' . htme($setting["value"]) . '" size="70" id="editsetting">';
			}
			print '<div><input type="submit" value="Save"></div>';
			print '</form>';
		}
	}
	else
	{
		print '<div class="errmsg">Record access denied or record does not exist</div>';
	}
}
else if ($_GET["settings"] == 1)
{
	list($number_of_records, $output) = make_list(array("table" => "settings"));
	print $output;

} elseif ($_REQUEST['ImportSettings']) {

	ImportSettings();

} elseif ($_REQUEST['deldb'] && $_REQUEST['daba']) {	// Delete a repository

	$_REQUEST['daba']--;
	if (!$_REQUEST['Confirmed']) {
		$curpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'");

		DB_Connect($_REQUEST['daba']);

		$foreignpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='yes'");

		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to delete this repository");
				EndHTML();
				exit;
		}

		$title = GetSetting("title");

		$dabb = $_REQUEST['daba'];
		$_REQUEST['daba']++;

		print "<tr><td>";
		$deltables = "";
		foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $props) {
			$deltables.= "<br>DROP TABLE `CRM" . $props['name_in_database'] . "`";
		}

		print "Are you sure you want to delete repository '" . $title . "' running on database " . $database[$dabb] . "?<div class='warnmsg'>WARNING! All your data in repository " . $title . " will be deleted!</div><br><br>SQL statements: <br><table><tr><td>" . $deltables . "</td></tr></table><br><br><a href='admin.php?deldb=1&amp;daba=" . $_REQUEST['daba'] . "&amp;Confirmed=1'>yes</a>";
	} else {
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);

		DB_Connect($_REQUEST['daba']);


		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='yes'";
		$foreignpassword = db_GetValue($sql);

		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to delete this repository");
				EndHTML();
				exit;
		}

		$title = GetSetting("title");

//		$sql = "DROP DATABASE $database[$_REQUEST['daba']]";
		$deltables = array();
		$p = 0;
		foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $props) {
			$deltables[$p++] = "DROP TABLE `CRM" . $props['name_in_database'] . "`";
		}
		for ($t=0;$t<$p;$t++) {
			//print "<br>$deltables[$t]";
			mcq($deltables[$t]);
		}
		print "Repository $title was deleted.<br><br>";

	}
} elseif ($_REQUEST['sessionscheck'] && $_REQUEST['daba']) {

		$_REQUEST['daba']--;

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);

		DB_Connect($_REQUEST['daba']);
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='yes'";
		$foreignpassword = db_GetValue($sql);

		if ($curpassword<>$foreignpassword) {

				PrintAD("access to function denied");

		} else {

			if ($_REQUEST['sessionscheck']=="delsessions") {
					$sql="DELETE FROM CRMsessions";
					mcq($sql);
					print "Sessions table " . $_REQUEST['daba'] . ":" . $database[$_REQUEST['daba']] . " was emptied.";

					EndHTML();
					exit;
			}

			print "You can safely empty this table <em>but all people currently using this repository will loose their session requiring them to login again.</em> Please mind that when you are working in this repository, you will loose your session too after emptying the sessions table.";
			$_REQUEST['daba']++;

			print "<br><a href='admin.php?sessionscheck=delsessions&amp;daba=" . $_REQUEST['daba'] . "'>Click here to empty the session table.</a>";

			list($number_of_records, $output) = make_list(array("table" => "sessions"));
			print $output;

		}

} elseif ($_REQUEST['checkcfg'] && $_REQUEST['daba']) {

		$_REQUEST['daba']--;
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);

		if (DB_Connect($_REQUEST['daba'])) {
		} else {
			print "<span class='errmsg'>This database doesn't exist!</span>";
			EndHTML();
			exit;
		}

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='yes'";
		$foreignpassword = db_GetValue($sql);
		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to access the Edit Fields function unauthorized");
				EndHTML();
				exit;
		}
		check_config();

} elseif ($_REQUEST['checkcfg'] && $_REQUEST['daba']) {

		$_REQUEST['daba']--;
		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);
		if (DB_Connect($_REQUEST['daba'])) {
		} else {
			print "<span class='errmsg'>This database doesn't exist!</span>";
			EndHTML();
			exit;
		}

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='yes'";
		$foreignpassword = db_GetValue($sql);
		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to access the Edit Fields function unauthorized");
				EndHTML();
				exit;
		}
		check_config();

} elseif ($_REQUEST['ts'] && $_REQUEST['daba']) {	// Show table status in plain text

		$_REQUEST['daba']--;

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'";
		$curpassword = db_GetValue($sql);
		if (DB_Connect($_REQUEST['daba'])) {
		} else {
			print "<span class='errmsg'>This database doesn't exist!</span>";
			EndHTML();
			exit;
		}

		$sql = "SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "' AND administrator='yes'";
		$foreignpassword = db_GetValue($sql);
		if ($curpassword<>$foreignpassword) {
				print "<tr><tr>";
				PrintAD("access to function denied");
				log_msg("Somebody (" . $GLOBALS['USERNAME'] . ") tried to access the table status overview unauthorized");
				EndHTML();
				exit;
		}
		$title = GetSetting("title");
		print "<table><tr><td>Table status query for database $title</td></tr></table>";
		$sql = "SHOW TABLE STATUS";
		print PHT($sql, "", "", "crm sortable filtertable");

} elseif ($_REQUEST['manageres']) {

		$tabbs = array();
		$tabbs[] = array("admin.php?reposman=1&amp;resman=1&amp;manageres=1", "Current repositories");
		$tabbs[] = array("install.php?AddRepository=1&amp;step=1","New repository");

		PlainNav($tabbs);


		print "<strong>Repository management</strong><br>";
		print "In this section you can add and remove your Interleave repositories as well as edit your extra<br>fields of all repositories where you (" . $GLOBALS['USERNAME'] . ") have an <strong>admin</strong> account with the same password as in this repository.<br><br>Please note that when you run several repositories in one database, the displayed size will be the sum of all repository sizes!<br><br>";

		print "<table class='crm sortable'>";
		print "<thead><tr><th>ResId</th><th>Host</th><th>Database</th><th>Repository title</th><th>Status</th><th>Size</th><th>DB version</th><th>Sessions</th><th>Total records</th><th>Maintenance mode</th><th></th><th></th><th></th><th></th><th></th></tr></thead>";
		print "<tbody>";
		// Get all possible Interleave repository titles from all possible databases
		$row = DB_GetRow("SELECT password FROM CRMloginusers WHERE id='" . mres($GLOBALS['USERID']) . "'");
		$curpassword = $row['password'];
		for ($r=0;$r<64;$r++) {
			if ($host[$r]) {
					if (DB_Connect($r)) {
					} else {
						// removed slave connect
						$host[$r] = $host[$r];

					}
			}
		}
		require $GLOBALS['CONFIGFILE'];
		$tot_size = 0;
		$tot_rec = 0;
		if (sizeof($pass)>0) {

				for ($r=0;$r<64;$r++) {
					if ($user[$r]) {
						if (DB_Connect($r)) {

								SwitchToRepos($r);
								$row = DB_GetRow("SELECT password FROM CRMloginusers WHERE name='" . mres($GLOBALS['USERNAME']) . "' AND administrator='yes'");
								$foreignpassword = $row['password'];
								$size = 0;
								$DBVERSION = "";
								if ($curpassword==$foreignpassword) {

									$title = GetSetting('title');
									$DBVERSION = GetSetting('DBVERSION');
									$maintenance_mode = GetSetting('MAINTENANCE_MODE');;


									$sql = "SELECT COUNT(*) FROM CRMsessions";
									$sess = db_GetValue($sql);
									$sql = "SHOW TABLE STATUS";
									foreach (db_GetArray($sql) as $stat)
									{
										$size += $stat["Data_length"];
										$size += $stat["Index_length"];
									}

									$tot_size += (($size/1024)/1024);
									$size = FormatNumber((($size/1024)/1024),2) . " MB";
									if ($DBVERSION=="") {
										$DBVERSION="Prior to 1.9.0";
									}
									if ($DBVERSION == $GLOBALS['VERSION']) {
										$DBVERSION = "<span class='okmsg'>" . $DBVERSION . "</span>";
									} elseif ($DBVERSION > $GLOBALS['VERSION']) {
									} elseif ($DBVERSION < $GLOBALS['VERSION']) {
										$DBVERSION = "<span class='errmsg'>" . $DBVERSION . "</span>";
									}

									$bla = CountTotalNumOfRecords();
									$ins = "";
									if ($GLOBALS['FAULT']) {
										$ins = "<span class='errmsg'>ERROR " . $GLOBALS['FAULT'] . "</span>";
										unset($GLOBALS['FAULT']);
									} else {
										$ins = "<span class='okmsg'>OK</span>";
									}
									print "<tr><td>$r</td><td>" . $host[$r] . "</td><td>$database[$r]</td><td>$title</td><td>" . $ins . "</td><td>" . $size . "</td><td>$DBVERSION</td><td>$sess</td>";
									unset($size);

									if ($bla) {
										print "<td>" . FormatNumber($bla,0) . "</td>";
										$tot_rec = $tot_rec + $bla;
									} else {
										print "<td>n/a</td>";
									}


									if ($maintenance_mode == "Yes") {
										print "<td><div class='warnmsg'>" . $maintenance_mode . "</div></td>";
									} else {
										print "<td><div class='okmsg'>" . $maintenance_mode . "</div></td>";
									}

									print "<td><a onclick=\"PopFancyBoxExtraLarge('Table status', 'admin.php?ts=1&amp;daba=" . ($r+1) . "&amp;nonavbar=1');\"><span class=\"fa fa-table\"></span></a></td><td><a href='admin.php?sessionscheck=1&amp;daba=" . ($r+1) . "'><span class=\"fa fa-users\"></span></a>&nbsp;</td><td><a href='admin.php?checkcfg=1&amp;daba=" . ($r+1) . "'><span class=\"fa fa-wrench\"></span></a></td><td><a href='admin.php?deldb=1&amp;daba=" . ($r+1) . "'><span class=\"fa fa-times\"></span></a></td>";

									print "</tr>";
								} else {
									print "<tr><td>$r</td><td>$host[$r]</td><td>$database[$r]</td><td><span class='errmsg'>Access denied or non-existent </span></td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td></tr>";
								}

						} else {
							 print "<tr><td>$r</td><td>$host[$r]</td><td>$database[$r]</td><td>n/a</td><td><span class='errmsg'>Database host unreachable</span></td><td></td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td></tr>";
						}

						}
					}
					?>
			<?php
				}
					SwitchToRepos($GLOBALS['repository']);

		print "</tbody>";
		print "</table>";
		SwitchToRepos($GLOBALS['repository']);
		print "<br>Total records: " . FormatNumber($tot_rec,0) . " - Total size: " . ceil($tot_size) . " MB<br><br>";

} elseif ($_REQUEST['checkdb']) {

	CheckDB(true, 1);

} elseif ($_REQUEST['IntermediateDatabaseUpgrade'] == 1) {

	IntermediateDatabaseUpgrade();

} elseif ($_REQUEST['PerformDatabaseMaintenance']) {

	ini_set('display_errors', true);
	print '<h1>PerformDatabaseMaintenance (duedate)</h1>';
	require "dbupgrade.php";
	print '<pre>';
	PerformDatabaseMaintenance(true);
	print '</pre>';

} elseif ($_REQUEST['syscon'] || $_REQUEST['datman'] || $_REQUEST['actions']) {

	$USE_APC = false;
	if (function_exists("apc_fetch")) {
		$USE_APC = true;
	}

	$toprint = "";
	if ($_REQUEST['syscon']) {

		$toprint .= admin_inpage_nav(get_adminglobal_nav_items(), "System configuration");

		$toprint .= '<form method="get" action="listadmin.php">';
		$toprint .= '<input type="hidden" name="searchadmin" value="1">';
		$toprint .= '<input type="search" placeholder="search" name="search" value=""> ';
		$toprint .= '<input type="checkbox" name="whole_word_only" id="whole_word_only" value="1"> <label for="whole_word_only">whole word only</label> ';
		$toprint .= '<input type="submit" value="Search whole config">';
		$toprint .= '</form>';


	} elseif ($_REQUEST['sysman']) {

	} elseif ($_REQUEST['datman']) {

		$toprint .= admin_inpage_nav(get_datamanagement_nav_items(), "Data management");

	} elseif ($_REQUEST['actions']) {

		$toprint = "";
		$toprint .= "<h1>Actions</h1><form name='qb4nd' id='JS_qb4nd' action='admin.php?actions=1' method='post'>";
		$toprint .= "<table>";
		$toprint .= "<tr><td><a href='mailto:" . htme(implode(",", db_GetFlatArray("SELECT EMAIL FROM CRMloginusers WHERE active='yes' GROUP BY EMAIL"))) . "'>Send e-mail to all users</a><div>Send an e-mail to all Interleave users.</div></td></tr>";
		if ($_REQUEST['emm']) {

			UpdateSetting("MAINTENANCE_MODE", "Yes");

		} elseif ($_REQUEST['dmm']) {

			UpdateSetting("MAINTENANCE_MODE", "No");

		}
		if (GetSetting("MAINTENANCE_MODE") == "Yes") {
			$toprint .= "<tr><td><a href='admin.php?actions=1&amp;dmm=1'>Disable maintenance mode</a><div>Disable maintenance mode. This will re-enable logins from non-admin users</div></td></tr>";
		} else {
			$toprint .= "<tr><td><a href='admin.php?actions=1&amp;emm=1'>Enable maintenance mode</a><div>Disables logins from non-admin users. Use this when performing site maintenance.</div></td></tr>";
		}
		if (GetSetting("DevelopmentOrProduction") == "Development") {

			if ($_POST['qb4nd_content']) {
				$t = array();
				foreach ($_POST['qb4nd_content'] AS $line) {
					$lines = explode("|", $line);
					foreach ($lines AS $row) {
						if (trim($row) != "" && !stristr($row, "DROP DATABASE")) {
							if (substr($row, strlen($row)-1,1) != ";") {
								$row .= ";";
							}
							$t[] = $row;
						}
					}
				}

				SetAttribute("system", "QueriesBeforeNextDeploy", $t, 1);
			}
			if ($_POST['qfnd_content']) {
				$t = array();
				foreach ($_POST['qfnd_content'] AS $line) {
					$lines = explode("|", $line);
					foreach ($lines AS $row) {
						if (trim($row) != "" && !stristr($row, "DROP DATABASE")) {
							if (substr($row, strlen($row)-1,1) != ";") {
								$row .= ";";
							}
						$t[] = $row;
						}
					}
				}
				SetAttribute("system", "QueriesForNextDeploy", $t, 1);

			}

			$qb4nd = GetAttribute("system", "QueriesBeforeNextDeploy", 1);

			$toprint .= "<tr><td>Queries to be ran <strong>before</strong> next deploy (use | to seperate lines when pasting)<br>";
			foreach ($qb4nd AS $query) {
				$toprint .= "<input type='text' size='150' name='qb4nd_content[]' value='" . htme($query). "'>";
			}
			$toprint .= "<input type='text' size='150' name='qb4nd_content[]' value='' placeholder='Add query'>";
			$toprint .= "<input type='submit' name='submit2' value='Save'>";
			$qfnd = GetAttribute("system", "QueriesForNextDeploy", 1);

			$toprint .= "<tr><td>Queries to be ran <strong>after</strong> next deploy (use | to seperate lines when pasting)<br>";
			foreach ($qfnd AS $query) {
				$toprint .= "<input type='text' size='150' name='qfnd_content[]' value='" . htme($query). "'>";
			}
			$toprint .= "<input type='text' size='150' name='qfnd_content[]' value='' placeholder='Add query'>";



			$toprint .= "<input type='submit' name='submit1' value='Save'>";
			$toprint .= "</td></tr>";
		}



		$toprint .= "</table></form>";
	}



	print "<div class='adminLinkTable'>";

	print $toprint;

	print "</div>";

	log_msg("Administrative section accessed");

} elseif ($_REQUEST['Details'] == 1) {

	print "<h2>System information</h2>";
	require "config/config.inc.php";
	print "<table>";
	print "<tr><td colspan=\"2\"><strong>Host information</strong></td></tr>";
	print "<tr><td>Database name</td><td>" . $database[$GLOBALS['repository']] . "</td></tr>";
	print "<tr><td>Database hostname</td><td>&quot;" . $host[$GLOBALS['repository']] . "&quot;</td></tr>";
	print "<tr><td>Database user</td><td>&quot;" . $user[$GLOBALS['repository']] . "&quot;</td></tr>";
	print "<tr><td>Webserver hostname</td><td>" . gethostname() . "</td></tr>";
	print "<tr><td>Server id</td><td>" . $_SERVER['SERVER_SOFTWARE'] . "</td></tr>";
	print "<tr><td>PHP Version</td><td>" . phpversion() . "</td></tr>";

	print "<tr><td colspan=\"2\"><h2>Repository information</strong></td></tr>";
	print "<tr><td>Repository title</td><td>" .GetSetting("title") . "</td></tr>";
	print "<tr><td>Interleave version</td><td>" .$GLOBALS['CRM_VERSION'] . "</td></tr>";
	print "<tr><td>Record count</td><td>" . FormatNumber(CountTotalNumOfRecords(), 0) . "</td></tr>";

	$size = 0;
	$tot_size = 0;
	foreach (db_GetArray("SHOW TABLE STATUS") as $stat)
	{
		$size += $stat["Data_length"];
		$size += $stat["Index_length"];
	}

	$tot_size += (($size/1024)/1024);
	$size = FormatNumber((($size/1024)/1024),2) . " MB";

	print "<tr><td>Database size</td><td>" . $size . "</td></tr>";
	print "<tr><td>User accounts</td><td>" . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMloginusers WHERE active='yes'"), 0) . "</td></tr>";
	print "<tr><td>Unique logins last 30 days</td><td>" . FormatNumber(count(db_GetArray("SELECT qs,timestamp_last_change,COUNT(*) FROM CRMuselog WHERE qs LIKE 'Login %' AND UNIX_TIMESTAMP(timestamp_last_change) >" . date('U', strtotime("30 days ago")) . " GROUP BY qs")), 0) . "</td></tr>";
	print "<tr><td>Total logins last 30 days</td><td>" . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE qs LIKE 'Login %' AND UNIX_TIMESTAMP(timestamp_last_change) >" . date('U', strtotime("30 days ago")) . ""), 0) . "</td></tr>";
	print "<tr><td>Total non-admin logins last 30 days</td><td>" . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMuselog, CRMloginusers WHERE qs LIKE 'Login %' AND REPLACE(qs,'Login ', '') = CRMloginusers.name AND CRMloginusers.administrator!='yes' AND UNIX_TIMESTAMP(CRMuselog.timestamp_last_change) >" . date('U', strtotime("30 days ago")) . ""), 0) . "</td></tr>";
	print "</table>";

} else {


	print "<h1>System information</h1>";
	print "<p>Support tickets and feature requests can be submitted in the <a href='http://support.interleave.nl/' onclick=\"window.open(this.href); return false;\">Interleave Support &amp; Development repository</a>. When submitting a support request, always include the information as much information about your specific installation in your initial post.</p>";

	print "<h2>Commercial support / consultancy / hosting</h2><p>For hosting, consultancy or support of a more commercial nature the boys at <a href=\"http://atomos.nl\">Atomos Applications</a> are always happy to help! Visit the Interleave web site at <a href='http://www.interleave.nl' onclick=\"window.open(this.href); return false;\">http://www.interleave.nl</a> for new releases and the latest documentation.</p>";

	print "<h2>Details</h2>";
	print "<p><a onclick=\"PopFancyBoxLarge('', 'admin.php?Details=1&amp;nonavbar=1');\">Show installation details</a></p>";

	list($number_of_records, $output) = make_list(array("table" => "sessions", "perpage" => 5));
	print $output;
}
EndHTML();

?>
