<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This script handles ajax calls for record.php
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
*/

/* start interleave */
require ("initiate.php");


/* declare */
$access = false;
$current_record = false;

/* most directives are GET, some are payload */
$method 	= $_GET['method'];
$return 	= array();

/* annotator uses PUT/GET/POST/DELETE; we cannot use $_REQUEST */

$payload = json_decode(file_get_contents("php://input"), true);

$record 	= $payload['record'];
if (ipi($_GET['record'])) {
	$record 	= $_GET['record'];
}
$table		= $payload['table'];
if ($_GET['table'] != '') {
	$table	 	= $_GET['table'];
}

/* get relevant payload items */
$image_selection 		= $payload['image_selection'];
$quote 					= $payload['quote'];
$text 					= $payload['text'];
$ranges 				= $payload['ranges'];
$id	 					= $payload['id'];
$uri 					= $_GET['uri'];

/* default reality */
$access = false;

/* for now, we only accept file annotations */
if ($table == 'files' && ipi($record)) {

	/* get record and table were the file refers to */
	$t = db_GetRow("SELECT type, koppelid FROM CRMbinfiles WHERE fileid='" . mres($record) . "'");

	/* check record access to the parent record */
	if (CheckIfAttachingIsAllowed($t['koppelid'], binfiles_table_to_ds_tablename($t['type']))) {

			$access = true;
	}

} else {

	/* we support any combination table-record for annotations but since we don't check access it's effectively disabled at the moment */

}

if ($access) {

	/* default to prevent saving the exact same attribute as teh one we fetched */
	$changed = false;

	/* get current annotations from attributes */
	$current_annotations = GetAttribute($table, "Annotations", $record);

	/* create empty annotation attribute if not set */
	if (!is_array($current_annotations)) {
		$current_annotations = array();
	}

	/* not used */
	if ($method == 'get_root') {

		$return = array("name" => "Annotator Store API", "version" => "2.0.0");

	} elseif ($method == 'create_annotation') {

		/* create unique id */
		$id = md5($text . $quote);

		/* standard array */
		$current_annotations[$id] = array(

			"consumer"	=> "interleave",
			"id"		=> $id,
			"text" 		=> $text,
			"quote" 	=> $quote,
			"uri" 		=> $uri,
			"ranges" 	=> $ranges,
			"image_selection" => $image_selection,
			"created" 	=> date("Y-m-d\TH:i:s.uO"),
		);

		/* return complete annotation */
		$return = $current_annotations[$id];
		$changed = true;

	} elseif ($method == 'update_annotation') {

		/* we only allow updating the text */
		$current_annotations[$id]["updated"] 	= date("Y-m-d\TH:i:s.uO");
		$current_annotations[$id]["text"]		= $text;

		/* return complete annotation */
		$return = $current_annotations[$id];
		$changed = true;

	} elseif ($method == 'delete_annotation') {

		/* delete = unset in array */
		unset($current_annotations[$id]);
		$return["id"] = "";
		$changed = true;

	} elseif ($method == 'get_annotations') {

		/* two-row array: "rows" and "total */
		$return["rows"] = array();
		$return["total"] = count($current_annotations);

		/* if an id is given, return only the given id */
		foreach ($current_annotations AS $lid => $anno) {
			if ($id && $lid == $id) {
				$return = $anno;
			} elseif ($id == '') {
				$return["rows"][] = $anno;
			}
		}
	}

	if ($changed) {
		/* save annotations attribute */
		SetAttribute($table, "Annotations", $current_annotations, $record, false);
	}

} else {

	/* return access denied message */
	$return["message"] = "Access denied";
}

/* give correct headers */
header("Content-Length: " . strlen(json_encode($return)));
header("Content-Type: application/json");

/* print result */
print json_encode($return);

/* close */
EndHTML(false);
?>
