<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file sets an array with attribute documentation items.
 * It is included in attribute.php
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
*/

// Attribute documentation

// ATDOCS = array
// Element key name will be STRSTR matched against processing attribute name
// Each element should contain an array:
// atdocs[keyname][0] = <h1> description
// atdocs[keyname][1] = <p> details



$atdocs = array();

$atdocs["AddExtraSelectCondionToQueryLinkText"] =							array("AddExtraSelectCondionToQueryLinkText", "The text to show (as a link) to re-apply the ExtraSelectCondition.");
$atdocs["AllowUserToEditParsedResultBeforeCreatingPDF"] =					array("AllowUserToEditParsedResultBeforeCreatingPDF", "When set, the user will have the opportunity to edit de already parsed document (in the rich text editor) just before it gets parsed to PDF, thus enabling the user to put in some remarks or to correct stuff.");
$atdocs["AllowUsersToSwitchThisTriggerOff"] =								array("AllowUsersToSwitchThisTriggerOff","When set to Yes, this trigger can be switched off by a user on the profile prferences page.");
$atdocs["AlwaysAttachAllAttachmentsWhenMailing"] =							array("AlwaysAttachAllAttachmentsWhenMailing","When set, all record attachments will be attached to the e-mail.");
$atdocs["AutoUpdateDiaryField"] =											array("AutoUpdateDiaryField","When set, the diary field will auto reload every 20 seconds. This enables realtime chat between multiple users using the diary field.");
$atdocs["BackToListAfterSave"] =											array("BackToListAfterSave","When set, the browser will be redirected back to the list after saving a record.");
$atdocs["BlindReferenceFieldLayout"] =										array("BlindReferenceFieldLayout", "The layout (template) to use for this field. Use tags. If left unset, the flextable general reference layout template will be used.");
$atdocs["ButtonClickConfirmMessage"] =										array("ButtonClickConfirmMessage","The (popup) message to display for confirmation, e.g. 'Are you sure?'.");
$atdocs["CSVExportBookmarks"] =												array("CSVExportBookmarks", "Remembering export column settings.");
$atdocs["CustomValidationFunctionPHP"] =									array("Custom PHP-enabled client side field validation", "Use PHP to check if an entered value is valid. This script will be called via AJAX, so the user will be informed immediately. To calculate use \$recordid. When appliccable the flextable number is in \$flextable. The submitted value is stored in \$value. You need to return (which, in this case, means leave behind) a variable called \$result which can contain &quot;nok&quot; or &quot;ok&quot;. Additionally, the \$result variable may also be returned as an array, where \$result[0] contains &quot;nok&quot; or &quot;ok&quot; and \$result[1] contains the message to show to the user (in a popup). \$result[2] could even contain a correction on the value which will be put back in the form (e.g. uppercased). To re-set the field to nothing, return '{{{emtpy}}}'. The module will be parsed so you can use tags. When this code ran by server side validator, the variable \$serverside will be true.");
$atdocs["DateFormat"] =														array("DateFormat","The format of the date.");
$atdocs["DenyDownloads"] =													array("DenyDownloads", "Set this attribute to Yes to deny *all* downloads from this table.");
$atdocs["EditBeforeParseButtonText"] =										array("EditBeforeParseButtonText", "The text printed on the button which actually generates the PDF after the user edited the parsed HTML.");
$atdocs["EditBeforeParseHTML"] =											array("EditBeforeParseHTML", "The content of this attribute will be shown above the rich-text editor showing the pre-parsed document.");
$atdocs["ExtraSelectCondition"] =											array("ExtraSelectCondition", "Extra condition when selecting table rows. This condition will be applied by default for all users viewing the list. Only when viewing it in HTML. The condition must be valid SQL , e.g. &quot;EFID134='Not yet processed'&quot; Use attributes AddExtraSelectCondionToQueryLinkText and RemoveExtraSelectCondionFromQueryLinkText to set links for disabling and re-applying the extra select condition.");
$atdocs["HideFooter"] =														array("HideFooter", "Disable the footer completely in the resulting PDF (TCPDF library only)");
$atdocs["HideHeader"] =														array("HideHeader", "Disable the header completely in the resulting PDF  (TCPDF library only)");
$atdocs["IncludeInSystemWideSearches"] =									array("IncludeInSystemWideSearches", "Set to 'No' if you don't want this flextable to show on the search page (summary.php).");
$atdocs["IncludeParentTableInSearches"] =									array("IncludeParentTableInSearches","If set, a search query will include the parent table.");
$atdocs["IncludeThisTableInSearchesFromParentTable"] =						array("IncludeThisTableInSearchesFromParentTable","If set this table will also be searched through when a user searches in the parent table.");
$atdocs["LanguagePack"] =													array("LanguagePack","The language pack.");
$atdocs["LastActivity"] =													array("LastActivity","Last activity of this user.");
$atdocs["LastLogin"] =														array("LastLogin","This user's last login.");
$atdocs["LastLogout"] =														array("LastLogout","This user's last logout.");
$atdocs["LastRecordDedup"] =												array("LastRecordDedup3", "Remembering where we left off the last time we de-duplicated this table.");
$atdocs["MaximumLength"] =													array("MaximumLength","The maximum input length in characters (requires HTML5-enabled browser).");
$atdocs["MaximumValue"] =													array("MaximumValue","The maximum value (requires HTML5-enabled browser).");
$atdocs["MinimumValue"] =													array("MinimumValue","The minimum value (requires HTML5-enabled browser).");
$atdocs["ModuleRunCount"] =													array("ModuleRunCount","Remembering how many times a module has been ran.");
$atdocs["NoResultsMessage"] =												array("NoResultsMessage","The message which is displayed when no records were found.");
$atdocs["RefreshByAjaxOnChangeOfField"] =									array("RefreshByAjaxOnChangeOfField","Enter the field number(s) of field(s) (comma seperated) which should trigger an ajax-reload of this field. Use &quot;All&quot; to refresh on any change, but be careful and watch your performance.");
$atdocs["RemoveExtraSelectCondionFromQueryLinkText"] =						array("RemoveExtraSelectCondionFromQueryLinkText", "The text to show (as a link) to disable the ExtraSelectCondition.");
$atdocs["RepopulateByAjax"] =												array("RepopulateByAjax", "When set, any change of any field in the same form will cause this field to reload in the background.");
$atdocs["RunAsUser"] =														array("RunAsUser","The module will be ran using the credentials of this user.");
$atdocs["RunWithSystemRights"] =											array("RunWithSystemRights","When set, the system will assume the first administrator account found before running this trigger.");
$atdocs["ShowInlineDeleteLink"] =											array("ShowInlineDeleteLink","When set, a small red icon will be shown in the list enabling the user to delete records directly from the list.");
$atdocs["ShowInlineDuplicateLink"] =										array("ShowInlineDuplicateLink","When set, a small gray icon will be shown in the list enabling the user to duplicate records directly from the list.");
$atdocs["ShowSelectionsWhenInline"] =										array("ShowSelectionsWhenInline","Whether or not to show the selections when a list is displayed on a form.");
$atdocs["ShowSelectionsWhenNotInline"] =									array("ShowSelectionsWhenNotInline","Whether or not to show the selections when a list is *not* displayed on a form.");
$atdocs["TemplateUseCount"] =												array("TemplateUseCount","Remembering the number of times a template is used.");
$atdocs["UsePopupAlsoWhenViewingPlainList"] =								array("UsePopupAlsoWhenViewingPlainList","When set, all records in this table will show in a popup, even when clicking on them from a plain list.");
$atdocs["WhenAttachingFilesToMailAlsoAttachEarlierMailAttachements"] = 		array("WhenAttachingFilesToMailAlsoAttachEarlierMailAttachements","See attribute name. Good luck.");
$atdocs["WhenAttachingMailToRecordAlsoAttachAnyGeneratedReports"] = 		array("WhenAttachingMailToRecordAlsoAttachAnyGeneratedReports","See attribute name. Good luck.");
$atdocs["Placeholder"] =													array("Placeholder", "Gray text which is shown in this field before a user clicks in it (HTML5 only). You can use XONLY and NEWONLY tags.");
$atdocs["DeleteConfirmationMessage"] =										array("DeleteConfirmationMessage", "The text which is displayed (as confirmation question) when a user clicks the inline delete icon or the in-form delete button.");
$atdocs["UsePlanningCalendar"] =											array("UsePlanningCalendar", "When set to Yes, this field will show a large calendar popup to select the date. It will show other appointments of the same field in this calerdar to allow easy planning.");
$atdocs["UsePlanningCalendarMatchOnFields"] =								array("UsePlanningCalendarMatchOnFields", "When using the UsePlanningCalendar option, the current appointments which will be shown are by default based on the same field. To add more fields to match add the field number to this setting. You can add as much as you want, comma separated.");
$atdocs["UsePlanningCalendarDescription"] =									array("UsePlanningCalendarDescription", "Template to be parsed as description (when shown in the calendar).");
$atdocs["FieldsOnFormWhichMustHaveAValueCSV"] =								array("FieldsOnFormWhichMustHaveAValueCSV", "A comma-seperated list of field-id's. These fields must have a value in order to click on this specific button.");
$atdocs["NotAllRequiredFieldsAreEnteredMessage"] =							array("NotAllRequiredFieldsAreEnteredMessage", "The message which is displayed when not all fields set in FieldsOnFormWhichMustHaveAValueCSV have a value.");
$atdocs["AlternateFROMAddress"] =											array("AlternateFROMAddress", "When emailing, use this address instead of any other address (this setting overrules everything, but NOT the global UNIFIED_FROM setting). Form: 'Firstname Lastname &lt;firstname@lastname.com&gt;' or just firstname@lastname.com.");
$atdocs["AlwaysRecalculateWhenNightlyCronIsRan"] = array("AlwaysRecalculateWhenNightlyCronIsRan", "When set to Yes, this field will be recalculated when the duedate-notify-cron is ran. This used to be default behaviour, but it's not anymore.");
$atdocs["DisableAutoSave"] = array("DisableAutoSave", "Set to Yes to disable autosave for this field.");
$atdocs["LogoFileLocation"] = array("LogoFileLocation", "The relative path to the PDF header logo image (working directory is the Interleave root). To refer to a file in Interleave, just enter the file number (TCPDF library only)");
$atdocs["PDFPageDimensions"] = array("PDFPageDimensions", "The dimensions which should be used when generating the PDF. Format: widthxheight, e.g. 100x200, in millimeters  (TCPDF library only)");
$atdocs["IgnoreCellClick"] = array("IgnoreCellClick", "When set to yes, clicking this cell in a list will not bring the user to the referring record");
$atdocs["WhenSearchingAlsoSearchThroughBinaryAttachments"] = array("WhenSearchingAlsoSearchThroughBinaryAttachments", "When set to no, attachments beloning to records in this table will not be searched through when searching in this table.");
$atdocs["PerFieldSearchEnable"] = array("PerFieldSearchEnable", "When set to Yes, per-column free-text filters are enabled enabling users to perform a free-text search in a single column");
$atdocs["OnlineEditMode"] = array("OnlineEditMode", "When set, development aids will appear");
$atdocs["RunInAjax"] = array("RunInAjax", "Whether or not to run this module inside an ajax div");
$atdocs["ShowHeaders"] = array("ShowHeaders", "Whether or not to show the headers (menu, javascript etc) when running this module");
$atdocs["MaximumLenghth"] = array("MaximumLenghth", "The maximum length of the value");
$atdocs["HasFileAttachments"] = array("HasFileAttachments", "Set this option to Yes to enable file attachments for this table. Set to No for performance reasons only.");
$atdocs["UseThisFieldForAccessRestriction"] = array("UseThisFieldForAccessRestriction", "When set to read or write, this user of group will be limited to these records (and below). Only for user and group fields.");
$atdocs["FormComment"] = array("FormComment", "When set this comment will be show behind the form element (in a tooltip)");
$atdocs["DataStructureAccessReasons"] = array("DataStructureAccessReasons", "No documentation yet");
$atdocs["DontRequireTPAWhenFromIPCSV"] = array("DontRequireTPAWhenFromIPCSV", "No documentation yet");
$atdocs["PasswordNeverExpires"] = array("PasswordNeverExpires", "No documentation yet");
$atdocs["TPALog"] = array("TPALog", "No documentation yet");
$atdocs["CreateEmptyRecordOnAdd"] = array("CreateEmptyRecordOnAdd", "When set, an ampty record will be created immediately when the user starts to add a record (and thus, autosave will work immediately, but you could have useless or incomplete records.");
$atdocs["EnableReferFieldFilter"] = array("EnableReferFieldFilter", "No documentation yet");
$atdocs["IncludeChildTablesInSearches"] = array("IncludeChildTablesInSearches", "No documentation yet");
$atdocs["PopUpSize"] = array("PopUpSize", "No documentation yet");
$atdocs["PutCellDataInOwnDivInLists"] = array("PutCellDataInOwnDivInLists", "No documentation yet");
$atdocs["TableIsPartOfConfiguration"] = array("TableIsPartOfConfiguration", "No documentation yet");
$atdocs["DontFetchDQS"] = array("DontFetchDQS", "No documentation yet");
$atdocs["MassUpdatePopup"] = array("MassUpdatePopup", "No documentation yet");
$atdocs["DQSMethod"] = array("DQSMethod", "No documentation yet");
$atdocs["ShowOnUserEditPage"] = array("ShowOnUserEditPage", "No documentation yet");
$atdocs["WebDAVDirectoryName"] = array("WebDAVDirectoryName", "When set, this flextable will be available as a webdav folder.");
$atdocs["ShowFromToFieldsInListFilters"] = array("ShowFromToFieldsInListFilters", "No documentation yet");
$atdocs["InlineAddIconURLExtras"] = array("InlineAddIconURLExtras", "No documentation yet");
$atdocs["ListOptionsForChildTable"] = array("ListOptionsForChildTable", "E.g. hiddenfilter[t2-f29][]=@t18-f103-t1-recordid@&nextoption=1");
$atdocs["FormatNumbers"] = array("FormatNumbers", "No documentation yet");
$atdocs["AddIdentifierClass"] = array("AddIdentifierClass", "Adds a class e.g. f23 to this field in lists (on td/dd)");
$atdocs["InteractiveAlwaysInline"] = array("InteractiveAlwaysInline", "When set to 'Yes' *and* the field is interactive in lists for the user, it will always be shown inline, not as a clickable link.");
$atdocs["Interactive"] = array("Interactive", "Set to Yes to make this an interactive field for everybody regardless their group.");
$atdocs["FilenameForDownloadsTemplate"] =	array("FilenameForDownloadsTemplate", "When downloading files from this table, the filename will be set up accoding to this template. You can use PHP and general tags.");
$atdocs["AutoSizeOnInput"] =				array("AutoSizeOnInput", "Autosize the width of this field when a user enters values");
$atdocs["ExcludeFromSearches"] =			array("ExcludeFromSearches", "Exclude this field in searches");
$atdocs["ShowFieldHistory"] =				array("ShowFieldHistory", "When enabled, a small icon will be shown behind the field, which when clicked will give historical information about the field's value over time.");
$atdocs["JavascriptActionAfterSubmit"] =	array("JavascriptActionAfterSubmit", "To excute arbitrary javascript code after a form submit, enter it here.");
$atdocs["DontUseHTMLEditor"] =				array("DontUseHTMLEditor", "Enable to disable the WYSIWYG editor.");
$atdocs["NumericDatabaseField"] =			array("NumericDatabaseField", "Set to Yes to make this field an INT or DECIMAL in the database instead of VARCHAR(21)");
$atdocs["TriggerQueriesForDeploy"] =				array("TriggerQueriesForDeploy", "Invisible attribute to hold drop/create trigger queries for next deploy");
$atdocs["MainTable"] =				array("MainTable", "Set to Yes to mark this table as a 'main' table (e.g. important table)");
$atdocs["allowed_to_change_once_set"] =				array("allowed_to_change_once_set", "Enable this attribute to mark this field as unchangeable once set. This security measure applies to all groups (except administrators).");
$atdocs["resetpasswordcode_validity"] =				array("resetpasswordcode_validity", "Internal");
$atdocs["UnauthenticatedCommandlineAccess"] =				array("UnauthenticatedCommandlineAccess", "When set, this module can be ran on the command line (using module.php) without any authentication. Be sure to set RunAsUser.");
$atdocs["resetpasswordcode"] =				array("resetpasswordcode", "Internal");
$atdocs["UnauthenticatedAccess"] =				array("UnauthenticatedAccess", "When set, this module can be ran online using mod.php without any authentication. Be sure to set RunAsUser.");
$atdocs["ChangeAlertMessage"] =				array("ChangeAlertMessage", "The message to be displayed when changing the value of this field (to a non-empty value)");
$atdocs["CheckBoxCheckedByDefault"] =				array("CheckBoxCheckedByDefault", "Whether or not this checkbox should be checked by default");
$atdocs["LengthNatural"] =				array("LengthNatural", "The length of the natural part of this number. Only adjust this for very large numbers.");
$atdocs["AddRowEnabledOnSublistsOnAutoForms"] = array("AddRowEnabledOnSublistsOnAutoForms", "When set, the addrow will be enabled by default when this list is printed as a sublist on an autoform.");
$atdocs["UsePhysicalDelete"] = array("UsePhysicalDelete", "When set, records will be deleted physically instead of logically. Enabling this will make the table dramatically faster, especially on large tables.");

$atdocs["AddRowLocation"] =				array("AddRowLocation", "The location of the add-row (when enabled)");
$atdocs["DoNotLock"] =				array("DoNotLock", "When set, locking for this table will be disabled.");
$atdocs["ImportHeaderHTMLText"] =				array("ImportHeaderHTMLText", "The text to show when importing records into this table.");
$atdocs["TemplateForNewEmptyInterleaveDocuments"] =				array("TemplateForNewEmptyInterleaveDocuments", "The template number of the template to use when creating an empty Interleave document.");
$atdocs["ContentsOfDivWhileLoadingViaAjax"] =				array("ContentsOfDivWhileLoadingViaAjax", "The 'Please wait..' text to show when this module is loading in an Ajax call");
$atdocs["DontBufferOutput"] =				array("DontBufferOutput", "Stream directly instead of buffuring and flushing the output.");
$atdocs["AutoDropDS"] =				array("AutoDropDS", "Whether or not to semi-intelligently drop the datastructures when making changes.");
$atdocs["UserNeedsToDropDS"] =				array("UserNeedsToDropDS", "Internal");
$atdocs["FieldGroupName"] =				array("FieldGroupName", "To group fields together, give them the same group name. To create sub-groups, divide by ' - ' e.g. 'Personal - Family details'.");
$atdocs["InheritWriteAccessFromParent"] =				array("InheritWriteAccessFromParent", "Whether or not to inherit write access permissions from the parent using this reference.");
$atdocs["ShowSeconds"] = array("ShowSeconds", "Whether or not to show the seconds in date/time view");


if (isset($_REQUEST['smd'])) { // show missing documentation

	print '<textarea rows=100 cols=200>';
	require_once "initiate.php";
	mustbeadmin();
	foreach (db_GetFlatArray("SELECT DISTINCT(attribute) FROM CRMattributes WHERE attribute NOT LIKE '%SaveComments%' AND attribute NOT LIKE 'List-layout-%' AND attribute NOT LIKE 'List-lastview-%'  AND attribute NOT LIKE '%SelectionNew%' AND attribute NOT LIKE '%list-%' AND attribute NOT LIKE 'FlexTableColumns%' AND attribute NOT LIKE 'FlexTableFilters%' AND attribute NOT LIKE 'SaveAction%' AND attribute NOT LIKE 'FlexTableSort%' AND attribute NOT LIKE 'LastCalendar%' AND attribute NOT LIKE 'SavedSelections%' AND attribute NOT LIKE 'FlexTableFilters%'") AS $att) {
		$found = false;
		foreach ($atdocs AS $key => $value) {
			if (strstr($att, $key)) {
				$found = true;
			} else {

			}
		}
		if (!$found) print '$atdocs["' . $att . '"] =				array("' . $att . '", "No documentation yet");' . "\n";
	}
	print '</textarea>';
	EndHTML(false);
	exit;
}

?>
