<?php
/* ********************************************************************
* Interleave
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* This handles editing attributes
*
* Check http://www.interleave.nl/ for more information
*
* BUILD / RELEASE :: 6.2.0.20151223
*
**********************************************************************
*/

$GLOBALS['PATHTOINTERLEAVE'] = dirname(realpath($argv[0])) . "/";
//remove command-line-utils subdir
$GLOBALS['PATHTOINTERLEAVE'] = str_replace("command-line-utils/", "", $GLOBALS['PATHTOINTERLEAVE']);

$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
foreach ($argv AS $ar) {
    if (substr($ar, 0, 4) == "cfg=") {
	$cfg = str_replace("cfg=", "", $ar);
	$GLOBALS['CONFIGFILE'] = $cfg;
    }
}
print 'Using path: ' . $GLOBALS['PATHTOINTERLEAVE'] . "\n";
require_once($GLOBALS['PATHTOINTERLEAVE'] . "adminfunctions.php");

$repository = $argv[1];
$username = $argv[2];
$password = $argv[3];

if (($repository == "") || ($username == "") || ($password == ""))
{
    print "usage: php ./cmd.php [repository] [username] [password] (or \"NOPASS\") [cfg=/path/to/config.inc.php]\n";
    exit;
}

$GLOBALS['CMDLINE'] = true;
$GLOBALS['overriderepository'] = $repository;
$GLOBALS['cmdline_username'] = $username;
$GLOBALS['cmdline_password'] = $password;
require($GLOBALS['PATHTOINTERLEAVE'] . "initiate.php");

if (!$GLOBALS['CONFIGFILE']) {
	$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
}

//JH 2015-12-03 WE WERKEN altijd maar met 1 repos
//$GLOBALS['REPOSLIMIT'] = "none";
$GLOBALS['REPOSLIMIT'] = $GLOBALS['repository'];


$GLOBALS['CL'] = "Yes";
$GLOBALS['ONLY_LOCAL'] = true;
// Set error reporting level
error_reporting(E_ERROR);

//$GLOBALS['NO_INSERTS_TO_LOG'] = true;


//$GLOBALS['logtext'] = false;
$GLOBALS['ShowTraceLink'] == false;

		if ($GLOBALS["VERSION"] <> GetSetting("DBVERSION") && (!stristr($_SERVER['PHP_SELF'],"upgrade.php"))) {

			print "The database version (" . GetSetting("DBVERSION") . ") is incompatible with the software version (" . $GLOBALS["VERSION"] . ").\n";
			print "Since this is the administrative interface, you can still continue. Be careful!\n";
		}

		print "Core version     : " . $GLOBALS["VERSION"] . "\n";
		print "Database version : " . GetSetting("DBVERSION") . "\n";


		$ditisdeeerste = 0;
		for ($t=0;$t<64;$t++) {
			ClearAllRunningCache();
			if (db_Connect($t)) {
				if (!$ditisdeeerste) {
					$ditisdeeerste = $t;
				}
				mcq("UPDATE CRMloginusers SET TRACE='Off'");
			}
		}

		print "\n";
		ProcessCommand("use " . $ditisdeeerste);

		$cmdt = "";
		if ($argv[1] && !strstr($argv[1],"cmd.php") &&  substr($argv[1],0,4) != "cfg=") {
			unset($argv[0]);
			foreach ($argv AS $cmd) {
			 $cmdt .= $cmd . " ";

			}
			ProcessCommand(trim($cmdt));
		} elseif ($commando && !strstr($commando,"cmd.php")) {
			$commando = explode(";", $commando);
			foreach ($commando AS $cmd) {
				ProcessCommand($cmd);
		 	}

		} else {

			while ($command <> "exit" && $command <> "\q") {

				$command = Menu();
				if ($command == "\\") {
					ProcessCommand($last_command);
				} else {
					$last_command = $command;
					ProcessCommand($command);
				}
			}
		}

//EndHTML(false);





function ProcessCommand($command) {
	global $table_prefix, $short, $web, $host, $auto, $database;
	if (substr($command, 0, 3) == "sh " || substr($command, 0, 2) == "x ") {
		$command = "@@@@@" . $command;
		$command = str_replace("@@@@@sh ", "show ", $command);
		$command = str_replace("@@@@@x ", "exec ", $command);
	}

	if ($command == "show tables") $command = "tables";

	if (substr($command, 0, 2) == "f ") $command = str_replace("f ", "show ftrecord ", $command);

	if (substr($command, 0, 3) == "ft ") $command = str_replace("ft ", "ftinfo ", $command);
	if (substr($command, 0, 3) == "ef ") $command = str_replace("ef ", "efinfo ", $command);

	if (substr($command, 0, 5) == "time ") {

		$command = str_replace("time ", "", $command);
		print "\nStart time : " . date('U') . " which is " . date('c') . "\n";
		$start = date('U');
		ProcessCommand($command);
		print "End time   : " . date('U') . " which is " . date('c') . "\n";
		print "Duration   : " . (date('U') - $start) . " seconds.\n";
		print "Done       : " . $GLOBALS['TIMES_DB_CONNECTS'] . " database connections were set up.\n";
		unset($GLOBALS['TIMES_DB_CONNECTS']);
		return(true);
	}

	if ($command == "exec maintenance") {
		ProcessCommand("exec db repair");
		ProcessCommand("exec db optimize");
		ProcessCommand("exec drop cache");
		ProcessCommand("exec db check auto");
	} elseif ($command == "show all") {
		print "\nRepositories:\n";
		ProcessCommand("show repos");
		print "\nCurrent sessions:\n";
		ProcessCommand("show users");
		print "\nRepository activity:\n";
		ProcessCommand("show act");
	} elseif ($command == "exec db index") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print "Indexing " . GetSetting("title") . "...\n";
				ExtractIndexData(false, true);
				print "Done!\n\n";
			}
		}
	} elseif ($command == "exec db index all") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print "Indexing " .GetSetting("title") . "...\n";
				ExtractIndexData(false, false);
				print "Done!\n\n";
			}
		}
	} elseif (substr($command, 0, 4) == "use ") {
		db_Connect(str_replace("use ", "", $command));
		$GLOBALS['REPOSINUSE'] = str_replace("use ", "", $command);
		print "OK: " . GetSetting("title") . "\n";
	} elseif (substr($command, 0, 6) == "limit ") {
		$limit = str_replace("limit ", "", $command);
		if ($limit == "off") {
			print "OK: " . GetSetting("title") . "\n";
			print "OK: Limit deleted\n";
			$GLOBALS['REPOSLIMIT'] = "none";
		} else {

			db_Connect($limit);
			$GLOBALS['REPOSLIMIT'] = $limit;
			print "OK: " . GetSetting("title") . "\n";
			print "OK: Only this repository will exist for this session\n";
		}
	} elseif ($command == "tables") {
		$tmp = GetFlextableDefinitions();
		print "Tables in " . GetSetting("title") . "\n";

		print " -----------------------------------------------------\n";
		print " | Num  | Name                           | Records   |\n";
		print " -----------------------------------------------------\n";

		foreach ($tmp AS $row) {
			$cnt = db_GetValue("SELECT COUNT(*) FROM CRMflextable" . $row['recordid']);
			print " | t" . fillout($row['recordid'], 3) . " | " . fillout($row['tablename'],30) . " | " . fillout($cnt,10) . "|\n";
		}
		print " -----------------------------------------------------\n";
	} elseif (substr($command, 0, 7) == "fields ") {
		$tmp = GetFlexTableNames(str_replace("fields ", "", $command));
		print "Extra fields of table " . str_replace("fields ", "", $command) . ": " . $tmp[0] . "\n";

		print " -------------------------------------------------------------------------------------\n";
		print " | Type                         | Field                                              |\n";
		print " -------------------------------------------------------------------------------------\n";
		$tmp = db_GetArray("SELECT fieldtype, CONCAT(id, ': ', name) FROM CRMextrafields WHERE tabletype='" . str_replace("fields ", "", $command) . "'");

		foreach ($tmp AS $row) {
			print " | " . fillout($row[0], 20) . "\t\t| " . fillout($row[1],50) . " |\n";
		}
		print " -------------------------------------------------------------------------------------\n";
	} elseif (substr($command, 0, 7) == "ftinfo ") {
		$tmp = GetFlexTableNames(str_replace("ftinfo ", "", $command));
		print "Flextable " . str_replace("ftinfo ", "", $command) . ": " . $tmp[0] . "\n";
		print " -------------------------------------------------------------------------------------\n";
		print " | Field                        | Value                                              |\n";
		print " -------------------------------------------------------------------------------------\n";
		$tmp = GetFlextableDefinitions(str_replace("ftinfo ", "", $command), false, true);

		foreach ($tmp[0] AS $key => $val) {
			if (!is_numeric($key)) {
				print " | " . fillout($key, 20) . "\t\t| " . fillout($val,50) . " |\n";
			}
		}
		print " -------------------------------------------------------------------------------------\n";

	} elseif (substr($command, 0, 13) == "show journal ") {
		$e = str_replace("show journal ", "", $command);
		$tmp  = db_GetArray("SELECT * FROM CRMjournal WHERE eid='" . mres($e) . "'");

		print " ---------------------------------------------------------------------------------------------------------\n";
		print " | User                                         | Message                                                |\n";
		print " ---------------------------------------------------------------------------------------------------------\n";
		foreach ($tmp AS $value) {
			if (!is_numeric($key)) {
				print " | " . fillout(GetUserName($value['user']), 44) . " | " . fillout($value['message'],54) . " |\n";
			}
		}
		print " ---------------------------------------------------------------------------------------------------------\n";

	} elseif (substr($command, 0, 14) == "show ftrecord ") {
		$e = explode(",", str_replace("show ftrecord ", "", $command));
		$table = $e[0];
		$record = $e[1];
		$tmp  = db_GetRow("SELECT * FROM CRMflextable" . mres($table) . " WHERE recordid='" . mres($record) . "'");

		print " ---------------------------------------------------------------------------------------------------------\n";
		print " | Field                                        | Value                                                  |\n";
		print " ---------------------------------------------------------------------------------------------------------\n";
		foreach ($tmp AS $key => $value) {
			if (!is_numeric($key)) {
				if (substr($key, 0, 4) == "EFID") {
					$key = fillout(str_replace("EFID", "", $key),3) . " ". GetExtraFieldName(str_replace("EFID", "", $key));
				}
				print " | " . fillout($key, 44) . " | " . fillout($value,54) . " |\n";
			}
		}
		print " ---------------------------------------------------------------------------------------------------------\n";

	} elseif (substr($command, 0, 15) == "show attr user ") {
		$user = str_replace("show attr user ", "", $command);

		print "Show attributes of user " . $user . ": " . GetUserName($user) . ", " . GetUserEmail($user) . "\n";
		print " ---------------------------------------------------------------------------------------------------------\n";
		print " | Field                                        | Value                                                  |\n";
		print " ---------------------------------------------------------------------------------------------------------\n";
		$tmp = db_GetArray("SELECT attribute, value FROM CRMattributes WHERE entity='" . mres($user) . "' and identifier='user'");
		foreach ($tmp AS $row) {
			print " | " . fillout($row[0], 44) . " | " . fillout($row[1],54) . " |\n";
		}
		print " ---------------------------------------------------------------------------------------------------------\n";
	} elseif ($command == "exec mailq") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				if (GetSetting("USEMAILQUEUE") == "Yes") {
					print "Processing mail queue of repository " . GetSetting("title") . "...\n";
					ProcessMailQueue();
				}
			}
		}
	} elseif ($command == "exec drop mailq") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				if (GetSetting("USEMAILQUEUE") == "Yes") {
					mcq("UPDATE CRMmailqueue SET status = 'error' WHERE status='unsent'");
				}
			}
		}
	} elseif ($command == "exec offload") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				OffloadFilesToDisk();
			}
		}
	} elseif ($command == "exec load-in") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				LoadOffloadedFilesBackIntoDB();
			}
		}

	} elseif ($command == "show mailq") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				if (GetSetting("USEMAILQUEUE") == "Yes") {
					print str_repeat("-", 104) . "\n";
					print " Mail queue of repository " . fillout(GetSetting("title"), 77) . "|\n";
					print str_repeat("-", 104) . "\n";
					print " " . fillout("id", 5) . " | ";
					print fillout("User", 15) . " | ";
					print fillout("From", 20) . " | ";
					print fillout("To", 20) . " | ";
					print fillout("Timestamp added", 20) . " | ";
					print fillout("Status", 6) . " | ";
					print "\n";
					print str_repeat("-", 104) . "\n";
					$tmp = db_GetArray("SELECT queueid,user,`from`,`to`,date_queued,status FROM CRMmailqueue WHERE status = 'unsent'");
					$queuecounter = 0;
					foreach ($tmp AS $u) {
						print " " . fillout($u['queueid'], 5) . " | ";
						print fillout(GetUserName($u['user']), 15) . " | ";
						print fillout($u['from'], 20) . " | ";
						print fillout($u['to'], 20) . " | ";
						print fillout($u['date_queued'], 20) . " | ";
						print fillout($u['status'], 6) . " | ";
						$queuecounter++;
						print "\n";
					}
					if ($queuecounter == 0) {
						print fillout(" Queue is empty", 103) . "|\n";
					} else {
						print str_repeat("-", 104) . "\n";
						print fillout(" " . $queuecounter . " mails in queue", 103) . "|\n";
					}
					print str_repeat("-", 104) . "\n";
					print "\n";
				}
			}
		}
	} elseif ($command == "exec db compress") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print "\nCompressing " . GetSetting("title") . "...\n";
				ProcessArchiving();
//				print "Done!\n\n";
			}
		}
	} elseif ($command == "exec db uncompress") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print "Uncompressing " . GetSetting("title") . "...\n";
				UnCompressAllFiles();
				print "Done!\n\n";
			}
		}

	} elseif ($command == "exec queryset") {
		$q = array();


		include($GLOBALS['CONFIGFILE']);
		for ($t=0;$t<64;$t++) {
			if (DB_Connect($t, false) && !$slave[$t]) {
					print "\n\nWorking on repository " . $t . ", " . GetSetting("title") . "\n";
					foreach ($q AS $qu) {
						$qu = str_replace("PRFX@@@@@@@", "CRM", $qu);
						print $qu . "\n";
						mcq($qu);
					}
				}
		}

	} elseif ($command == "exec snapshot create") {

		ProcessCommand("show repos");
		print "Enter number of database create system restore point for:\n";
		print "Interleave > ";
		$db_to_process = readln();

		while ($result <> "1" && $result<>"2" && $result<>"3") {
			print "1. Configuration snapshot without users and profiles\n";
			print "2. Configuration snapshot with users and profiles\n";
			print "3. Complete database snapshot (all tables)\n";
			print "Interleave > ";
			$result = readln();
		}
		if ($result == "1") {
			$typeofsnapshot = "nousers";
		} elseif ($result == "2") {
			$typeofsnapshot = "withusers";
		} elseif ($result == "3") {
			$typeofsnapshot = "wholedb";
		}
		print "Description :\n";
		print "Interleave > ";
		$desc = readln();

		db_Connect($db_to_process);

		CreateConfigurationSnapshot($db_to_process, $desc, true, $typeofsnapshot);

		db_Connect($db_to_process);


	}  elseif ($command == "exec snapshot restore") {

		ProcessCommand("show repos");
		print "Enter number of database restore snapshot for:\n";
		print "Interleave > ";
		$db_to_process = readln();

		db_Connect($db_to_process);
		print "\n-----------------------------------------------------------------------------------------------------------\n";
		print " " . fillout("Num",3) . " | Creation date/time  | " . fillout("Description",30) . " | " . fillout("Type", 30) . " | " . fillout("Size", 10) . " |\n";
		print "-----------------------------------------------------------------------------------------------------------\n";
		$tmp = db_GetArray("SELECT id, datetime, comment, snapshottype, LENGTH(config) AS bytes FROM " .  "CRM" . "configsnapshots ORDER BY datetime DESC");
		foreach ($tmp AS $row) {
			if ($row['snapshottype'] == "withusers") {
				$row['snapshottype'] = "Configuration snapshot with users & profiles";
			} elseif ($row['snapshottype'] == "nousers") {
				$row['snapshottype'] = "Configuration snapshot without users & profiles";
			} elseif ($row['snapshottype'] == "wholedb") {
				$row['snapshottype'] = "Complete database snapshot";
			}
			print " " . fillout($row['id'],3) . " | " . $row['datetime'] . " | " . fillout($row['comment'],30) . " | " . fillout($row['snapshottype'], 30) . " | " . fillout(FormatNumber($row['bytes'] / 1024, 0) . "K", 10) . " |\n";
		}
		print "-----------------------------------------------------------------------------------------------------------\n";
		print "Enter number of snapshot to restore:\n";
		print "Interleave > ";
		$restorepoint = readln();

		print "Are your sure? (y|n) :\n";
		print "Interleave > ";
		$confirm = readln();

		if ($confirm == "y") {
			RestoreConfigurationSnaphot($db_to_process, $restorepoint, true);
		} else {
			print "OK Quitting.\n";
		}

		db_Connect($db_to_process);


	} elseif ($command == "exec cache test") {
		print "\nWarning: this test may cause heavy load on your database server!\n";
		ProcessCommand("show repos");
		print "Enter number of database to test:\n";
		print "Interleave > ";
		$db_to_process = readln();
		CheckIfCacheIsUsefull($database[$db_to_process]);
		mcq("TRUNCATE TABLE CRMaccesscache");

	} elseif ($command == "show author") {
		sh_auth();
	} elseif ($command == "exec config fix") {
		for ($t=0;$t<64;$t++) {
			if (DB_Connect($t, false)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				check_config($table_prefix[$t]);
			}
		}
	} elseif ($command == "set mm on") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				mcq("UPDATE CRMsettings SET value='Yes' WHERE setting='MAINTENANCE_MODE'");
			}
		}
		print "Maintenance mode enabled on all repositories.\n";
	} elseif ($command == "exec db repair") {
		print "\nRunning REPAIR TABLE on all tables on all repositories.\n";

		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {

				$x = 1;
				foreach ($GLOBALS['TABLES_IN_USE'] AS $table) {
					print "\015" . fillout(GetSetting("title"),40) . ": " . $x . "/" . sizeof($GLOBALS['TABLES_IN_USE']);
					$x++;
					$res = mcq("REPAIR TABLE " . $table);

				}
				print " done.\n";
			}
		}
	} elseif ($command == "exec db optimize") {
		print "\nRunning OPTIMIZE TABLE on all tables on all repositories.\n";
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {

				$x = 1;
				foreach ($GLOBALS['TABLES_IN_USE'] AS $table) {
					print "\015" . fillout(GetSetting("title"), 40) . ": " . $x . "/" . sizeof($GLOBALS['TABLES_IN_USE']);
					$x++;
					$res = mcq("OPTIMIZE TABLE " . $table);
				}
				print " done.\n";
			}
		}

	} elseif ($command == "exec db tn") {
		for ($t=0;$t<64;$t++) {
			ClearAllRunningCache();
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print "Start: " . GetSetting("title") . "\n";
				GenerateImageThumbnails("all", true);
			}
		}
	} elseif ($command == "set mm off") {

		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				mcq("UPDATE CRMsettings SET value='No' WHERE setting='MAINTENANCE_MODE'");
			}
		}
		print "Maintenance mode disabled on all repositories.\n";


	} elseif ($command == "exec drop cache") {
			print "\nDeleting all cache on all repositories.\n";
			for ($t=0;$t<64;$t++) {
				ClearAllRunningCache();
				if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
					print "Delete cache on " . fillout(GetSetting("title"), 40) . " : ";
					DropAllCache();
					print "done.\n";
				}
			}

	} elseif ($command == "exec eval") {

		print "Which command to evaluate? (warning: eval will be run only once!) (" . GetSetting("title") . ")\n";
		print "PHP > ";
		$cmd = readln();
		eval($cmd);
		/*
		for ($t=0;$t<64;$t++) {
			if (DB_Connect($t, false)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				eval($cmd);
				print fillout("Repository " . $t, 40) . "\nCommand evaluated (master)\n";

			}
			if (DB_Connect($t, true)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				eval($cmd);
				print fillout("Repository " . $t, 40) . "\nCommand evaluated (slave)\n";

			}

		}
		*/
	} elseif ($command == "exec sql") {

		foreach ($table_prefix AS $pr) {
				if (!$t) {
					$t = $pr;
				}
				if ($t <> $pr) {
					$strange = true;
				}
				$t = $pr;
			}
		if ($strange) {
			print "You NEED to use PRFX@@@@@@@ as table prefix. The routine will replace that with the appropriate table prefix.\n";
		}
		print "Which query to execute?\n";
		print "SQL > ";
		$sql = readln();
		for ($t=0;$t<64;$t++) {
			if (DB_Connect($t, false)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print fillout(GetSetting("title"), 40) . "Query executed (master)\n";
				mcq(str_replace("PRFX@@@@@@@", "CRM", $sql));
			}
			//if (DB_Connect($t, true)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
			//	print fillout(GetSetting("title"), 40) . "Query executed (slave)\n";
			//	mcq(str_replace("PRFX@@@@@@@", "CRM", $sql));
			//}

		}

	} elseif ($command == "exec db check" || $command == "exec db check auto") {

		//$short = true;
		$web = false;
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				if ($command == "exec db check auto") {
					$auto = true;
				}
				CheckDB();
			} else {
				//print "Failed to connect to repository " . $t . "\n";
			}
		}
	} elseif ($command == "exec trace") {
		ProcessCommand("show users");
		print "Enter the number of the user you want to trace > ";
		$usernum = readln();
		$repos = $GLOBALS['utt'][$usernum][0];
		$user = $GLOBALS['utt'][$usernum][1];
		db_Connect($repos);
		mcq("UPDATE CRMloginusers SET TRACE='On' WHERE id='" . mres($user) . "'");
		print "Trace flag set .... Due to PHP limitations, you can only stop tracing by killing this script\n";
		print "with CTRL-C. Please log on to cmd.php after that again; the trace will automatically be disabled.\n";
		print "If you don't do that, the trace will be enabled until the users logs out, generating lots of data.\n";
		$key = "TRACE" . $repos . $user;
		$codes = array();
		while (1==1) {
			sleep(1);
			if ($last_epoch) {
				$t = DB_GetArray("SELECT * FROM CRMcache WHERE LEFT(value," . strlen($key) . ")='" . mres($key) . "' AND epoch>=" . $last_epoch);
			} else {
				$t = DB_GetArray("SELECT * FROM CRMcache WHERE LEFT(value," . strlen($key) . ")='" . mres($key) . "'");
			}
			foreach ($t AS $row) {
				$code = md5($row['value']);
				if (!in_array($code, $codes)) {
					print str_replace($key . ": ", "", $row['value']) . "";
				}
				array_push($codes, $code);
				$last_epoch = $row['epoch'];
			}
		}

	} elseif ($command == "show users") {
		$users = 0;
		$GLOBALS['utt'] = array();
		print "Num " . fillout("User",20) . " " . fillout("Last activity",20) . " " . fillout("Session expire",20) . "\n";
		for ($t=0;$t<64;$t++) {
			if (DB_Connect($t, false)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {

				print "\n ---- " . GetSetting("title") . ":\n\n";
				foreach (db_GetArray($sql) AS $row) {
					$users++;
					$timeout_sec =  $row['exptime'] + (GetSetting("timeout") * 60);
					print fillout($users,3) . " " . fillout(GetUserNameByName($row['name']),20) . " " . fillout(date('Y-m-d H:i:s',$row['exptime']),20) . " " . fillout(date('Y-m-d H:i:s',$timeout_sec),20) . "\n";

					$one = true;
					$GLOBALS['utt'][$users] = array($t,GetUserID($row['name']));

				}
				if (!$one) {
//					print "No sessions.\n";
				} else {
					unset($one);
				}
			} else {
			}
		}
	//	print "=========================================================================\n";
		print "\nTotal active sessions: " . $users . "\n";
	//	print "=========================================================================\n";
	} elseif ($command == "exec drop users") {
		print "Are you sure? (y/n)\n";
		print "Interleave > ";
		$answer = readln();
		if ($answer == "y") {
			for ($t=0;$t<64;$t++) {
				if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {

					mcq("DELETE FROM CRMsessions");
				}
			}
			print "All user sessions ended on all repositories.\n\n";
		}
	} elseif ($command == "show proc ---- DISABLED") {
		include($GLOBALS['CONFIGFILE']);
		print "" . fillout("PID",5) . " " . fillout("Start",20) . " " . fillout("File",20) . " " . fillout("User",15) . " " .  fillout("Status", 10) . " Repository\n";
		for ($t=0;$t<64;$t++) {
				if (DB_Connect($t, $false)&& ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
					$t2 = DB_GetArray("SELECT * FROM CRMprocesses WHERE result='running'");
					foreach ($t2 AS $row) {
						print "" . fillout($row[0],5) . " " . fillout($row[1],20) . " " . fillout($row[2],20) . " " . fillout(GetUserName($row[3]),15) . " " . fillout($row[4],10) . " " . GetSetting("title") . "\n";
					}
				}
		}
	} elseif ($command == "exec func check") {
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				print "=========================================================================\n";
				print "Repository \"" . GetSetting("title") . "\"\n";
				print CheckDatabaseSettings();
			}
		}
	} elseif ($command == "show act" || $command == "show act csv") {
		if ($command == "show act csv") {
			print "Score;Avg hits p/day;Tot. hits;Age (days);Accounts;Repository\n";
		} else {
			print "\nThe following statistics are based on the uselog. If you ever purged the uselog table this information might not be accurate.\n";
			print "Score formula: score = (avg. hits per day) * (days used)\n\n";
			print "--------------------------------------------------------------------------------------------------------------------\n";
			print "  Score     | Avg hits p/used day | Tot. hits | Days used   | Accounts  | Repository                               |\n";
			print "--------------------------------------------------------------------------------------------------------------------\n";
		}
		$rest = array();
		$nums = 1;
		for ($t=0;$t<64;$t++) {
			if (DB_Connect($t, false)  && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {

				$res = db_GetRow("SELECT COUNT(*) FROM CRMloginusers");
				$users = $res[0];
				$res = db_GetRow("SELECT COUNT(*) FROM CRMuselog");
				$tothits = $res[0];

				unset($tt);
				$tt = array();
				$sql = "SELECT timestamp_last_change, UNIX_TIMESTAMP(timestamp_last_change) AS epoch, date_format(timestamp_last_change, '%a %M %e, %Y %H:%i') AS ts, date_format(timestamp_last_change, '%a %M %e') AS ts2, count(*) AS ct FROM CRMuselog GROUP BY ts2 ORDER BY id";

				foreach (db_GetArray($sql) AS $row) {
					if (!$arh) {
						if ($row['epoch']) {
							$tmp = (date('U') - $row['epoch']);
							$aid = ($tmp / 86400);
							$arh = true;
						//	print GetSetting("title") . " Date: " . date('U') . " eopch: " . $row['epoch'] . "\n";
						//	print GetSetting("title") . " Oldest is $aid days ago " . $row['epoch'] . "\n" ;
						}
					}
					$num = $num + $row['ct'];
					$count++;
				}

				$avg = $num / $count;
				$aid = $count;
				$score = ceil($aid) * ceil($avg);

				$tavg += $avg;
				$ttothits += $tothits;
				$devide++;
				$taid += $aid;
				$tusers += $users;

				if ($command == "show act csv") {
					array_push($rest,"" . (($nums)) . ";" .  (ceil($avg)) . ";" . ($tothits) . ";" . (ceil($aid)) . ";" . ($users) . ";" . (GetSetting("title")) . "\n");
				} else {
					array_push($rest,"  " . fillout(($nums), 10) . "| " .  fillout(ceil($avg),20) . "| " . fillout($tothits, 10) . "| " . fillout(ceil($aid),12) . "| " . fillout($users,10) . "| " . fillout(GetSetting("title"),41) . "|\n");
				}
				$nums++;
				unset($avg);
				unset($count);
				unset($num);
				unset($aid);
				unset($arh);
				unset($score);
			}
		}
		sort($rest, SORT_NUMERIC);
		foreach ($rest AS $line) {
			print $line;
		}

		if ($command <> "show act csv") {
			print "--------------------------------------------------------------------------------------------------------------------\n";
			print "  " . fillout(("Total"), 10) . "| " .  fillout(ceil($tavg/$devide),20) . "| " . fillout($ttothits, 10) . "| " . fillout(($taid),12) . "| " . fillout($tusers,10) . "| " . fillout("+ ",41) . "|\n";
			print "--------------------------------------------------------------------------------------------------------------------\n";
		} else {
			print "Total;" .  (ceil($tavg/$devide)) . ";" . $ttothits . ";" . $taid . ";" . $tusers . ";\n";
		}

	} elseif ($command == "show repos" || $command == "show repos balance") {
		if ($command == "show repos") {
			print ReturnReposList();
		} else {
			print ReturnReposList(true);
		}
	} elseif ($command == "show logins") {
		print "\nLogins today\n";
		print "-------------------------------------------------------------------------------------------------------------\n";
		print fillout("User", 30) . "| " . fillout("IP-address",20) . "| " . fillout("Time", 20) . " | " . fillout("Repository", 30) . " |\n";
		print "-------------------------------------------------------------------------------------------------------------\n";
		$done = array();
		$totnum = 0;
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				$p = db_GetArray("SELECT ip, qs, user, timestamp_last_change FROM CRMuselog WHERE qs LIKE 'Login %' AND LEFT(timestamp_last_change, 10) = '" . date('Y-m-d') . "'");
				foreach ($p AS $row) {
					print fillout($row['qs'], 30) . "| " . fillout($row['ip'],20) . "| " . fillout($row['timestamp_last_change'],20) . " | " . fillout(GetSetting("title"),30) . " |\n";
					if (!in_array($row['qs'], $done)) {
						array_push($done, $row['qs']);
					}
					$totnum ++;
				}
			}
		}
		print "-------------------------------------------------------------------------------------------------------------\n";
		print "Total logins today: " . $totnum . ", unique logins: " . sizeof($done) . "\n";

	} elseif ($command == "show modules" || $command == "exec module" || $command == "edit module") {
		print "\nAvailable modules\n";
		print "------------------------------------------------------------------------------------------------------\n";
		print fillout("id", 5) . "| " . fillout("Name", 20) . " | " . fillout("Desc.",30) . " | " . fillout("Res.", 4) . " | " . fillout("Repository", 30) . " |\n";
		print "------------------------------------------------------------------------------------------------------\n";
		$done = array();
		$modules = array();
		$count = 1;
		for ($t=0;$t<64;$t++) {
			if (db_Connect($t) && ($t == $GLOBALS['REPOSLIMIT'] || $GLOBALS['REPOSLIMIT'] == "none")) {
				$sql = "SELECT * FROM CRMmodules WHERE version_belonging_to='0' ORDER BY module_name";
				foreach (db_GetArray($sql) AS $row) {
					print "" . fillout($count,5) . "| " . fillout(trim($row['module_name']),20) . " | " . fillout($row['module_description'],30) . " | " . fillout($row['module_last_run_result'], 4) . " | " . fillout(GetSetting("title"),30) . " |\n";
					$modules[$count] = array("repository" => $t, "mid" => $row['mid']);
					$count++;
				}
			}
		}
		print "------------------------------------------------------------------------------------------------------\n";
		print ($count-1) . " modules available.\n";
		if ($command == "exec module") {
			print "\nA module will always run only within its own repository context.\nPlease enter the number of the module to run from the list above.\n";
			print "Module number or 0 to cancel > ";
			$modnum = readln();
			if ($modnum != "0") {
				print "Running module " . $modnum . " which is module " . $modules[$modnum]['mid'] . " from repository " . $modules[$modnum]['repository'] . "\n";
				db_Connect($modules[$modnum]['repository']);
				$res = RunModule($modules[$modnum]['mid'], false, true, false, false);
				$res = eregi_replace("</tr>", "\n", $res);
				$res = eregi_replace("</td><td>", "\t\t", $res);
				$res = eregi_replace("<br>", "\n", $res);
				$res = eregi_replace("<br />", "\n", $res);
				print strip_tags($res);
			}
		} elseif ($command == "edit module") {
			print "Module number or 0 to cancel > ";
			$modnum = readln();
			if ($modnum != "0") {
				print "Editing module " . $modnum . " which is module " . $modules[$modnum]['mid'] . " from repository " . $modules[$modnum]['repository'] . "\n";
				db_Connect($modules[$modnum]['repository']);
				$tmp = GetSetting('TMP_FILE_PATH');
				print "Editor command [mcedit -c] > ";
				$editor = readln();
				if ($editor == "") $editor = "mcedit -c";
				$mod_body = db_GetRow("SELECT * FROM CRMmodules WHERE mid='" . mres($modules[$modnum]['mid']) . "'");
				$epoch = date('U');
				$file = $tmp . "/" . randomstring(10, true) . "_" . $epoch . "_cmdInterleaveEdit.php";
				print "Created " . $file . "\n";
				$fp = fopen($file, "w");
				fputs($fp, $mod_body['module_code']);
				fclose($fp);
				passthru($editor . " " . $file);
				$newcode = file_get_contents($file);
				print "Save new code to database? [y|n] > ";
				$yesno = readln();
				if ($yesno == "y") {
					mcq("UPDATE CRMmodules SET module_code='" . mres($newcode) . "' WHERE mid='" . mres($modules[$modnum]['mid']) . "'");
					print "Module saved\n";
				} else {
					print "Module not saved\n";
				}
				unlink($file);
			}
        }
    } elseif ($command == "report") {

        ProcessCommand("show tables");
        print 'Which table? > ';
        $table = readln();
        print 'Report type (excel|json|html|pdf|xml|all) (comma-separated) > ';
        $reporttype = readln();
        if ($reporttype == 'all') {
            $reps = array("excel", "json", "html", "pdf", "html");
        } else {
            $reps = explode(",", $reporttype);
        }

        print 'All data or configured list columns? (1 for all) > ';
        $alldata = readln();
        if ($alldata == 1) {
            $alldate = true;
        } else {
            $alldata = false;
        }

        print 'Filename to save (including path excluding extension) > ';

        $filename = readln();
        $listoptions = array();
        foreach ($reps AS $reporttype) {
            print "Create " . $reporttype . " report ... \n";
            file_put_contents($filename . "." . str_replace("excel", "xlsx", $reporttype), CreateDefaultReport($table, $reporttype, $filename . "." . $reporttype, '', $listoptions, $alldata, false));
            print "Done.\n";
        }



    } elseif ($command == "exec recalc") {
        print 'Recalculating calculations...' . "\n";
        recalc_calculations("", true, true);
    } elseif ($command == "exec resize") {
        print 'Resizing images...' . "\n";
        resize_images();
	} elseif ($command == "show help" || $command == "help") {

		print "\n >>> Unless specified otherwise all actions here apply to all repostories. <<<\n\n";
		print "-----------------------------------------------------------------------------------------\n";
		print "  Command              | Explanation                                                    |\n";
		print "-----------------------------------------------------------------------------------------\n";
		print "  show repos           | Show repository list                                           |\n";
		print "  show help            | Show (this) command list                                       |\n";
		print "  show users           | Show current user sessions                                     |\n";
		print "  show logins          | Show today's logins                                            |\n";
		print "  show act             | Show activity                                                  |\n";
		print "  show act csv         | Show activity (character separated values)                     |\n";
        print "                       |                                                                |\n";
		print "  report               | Create default report                                          |\n";
		print "                       |                                                                |\n";
		print "  ftinfo [num]         | Show flextable properties of flextable [num]                   |\n";
		print "  efinfo [num]         | Show extra field properties of field [num]                     |\n";
		print "  fields [num]         | Show fields of table [num]                                     |\n";
		print "  tables               | Show flextable definitions                                     |\n";
		print "                       |                                                                |\n";
		print "  show ftrecord x,y    | Show contents of record y of flextable x                       |\n";
		print "  show attr user [num] | Show attributes of user [num]                                  |\n";

		print "                       |                                                                |\n";

		print "  set mm on            | Enable maintenance mode                                        |\n";
		print "  set mm off           | Disable maintenance mode                                       |\n";
		print "  set pcon on          | Enable use of persistent DB connections (default)              |\n";
		print "  set pcon off         | Disable use of persistent DB connections                       |\n";
		print "                       |                                                                |\n";
		print "  exec sql             | Execute an SQL-query                                           |\n";
		print "  exec eval            | Open PHP/Interleave prompt                                     |\n";
		print "  exec trace           | Trace a user session                                           |\n";
		print "                       |                                                                |\n";
		print "  exec db check        | Check for errors (prompt before deleting anything)             |\n";
		print "  exec db check auto   | Check for errors (auto-delete)                                 |\n";
		print "  exec db repair       | Run REPAIR TABLE commmand on all tables                        |\n";
		print "  exec db optimize     | Run OPTIMIZE TABLE commmand on all tables                      |\n";
		print "  exec db index (all)  | Update fast search index (add 'all' to force)                  |\n";
		print "  exec db tn           | Create thumbnail index of JPEG & GIF attachments               |\n";
		print "  exec db compress     | Run the file compression archiver                              |\n";
        print "  exec db uncompress   | Uncompress all files in all repositories                       |\n";
		print "                       |                                                                |\n";
		print "  exec func check      | Check for functional warnings                                  |\n";
		print "  exec config fix      | Check for double config entries (and delete duplicates)        |\n";
		print "  exec maintenance     | Run check db with auto delete, OPTIMIZE and REPAIR             |\n";
		print "  exec drop users      | End all user sessions                                          |\n";
		print "  exec drop cache      | Empty all form, published page, thumbnail and access cache     |\n";
		print "  exec offload         | Offload files to disk (when configured, see system attributes) |\n";
		print "  exec load-in         | Re-insert files offloaded files into the databe                |\n";
        print "                       |                                                                |\n";
        print "  exec recalc          | Recalculate all calculations                                   |\n";
        print "  exec resize          | Resize images (when appliccable)                               |\n";
		print "                       |                                                                |\n";
		print "  show mailq           | Show e-mails currently queued for transport                    |\n";
		print "  exec mailq           | Process the mail queue                                         |\n";
		print "  exec drop mailq      | Set status of all unsent messages to 'error' (cancel sending)  |\n";
		print "                       |                                                                |\n";
		print "  show modules         | Show list of available modules                                 |\n";
		print "  exec module          | Run a module (list will be presented)                          |\n";
		print "  edit module          | Edit a module (list will be presented)                         |\n";
		print "                       |                                                                |\n";

		print "  \                    | Re-run last command                                            |\n";
		print "  exit                 | Exit program                                                   |\n";
		print "                       |                                                                |\n";
		print "  Tip of the day       | * You can use 'sh' and 'x' as replacement for 'show' and 'exec'|\n";
		print "                       | * Use 'time' as command prefix to time your command            |\n";
		print "                       | * ftinfo and efinfo can also be called using ft and ef.        |\n";
		print "-----------------------------------------------------------------------------------------\n";
		print "\n Enter option below.\n";
	} elseif ($command == "Are there any easter eggs in this script?") {
		print "No, there aren't any down here.\n";
	} elseif ($command <> "exit" && $command <> "\q") {
		print $command . ": Unrecognized command.\n";
	}

}



function Menu() {
	if ($GLOBALS['REPOSLIMIT'] != "none") {
		db_Connect($GLOBALS['REPOSLIMIT']);
		$ins = "(only) ";
	} else {
		db_Connect($GLOBALS['REPOSINUSE']);
		$ins = "";
	}
	print " \nInterleave (" . GetSetting("title") . ") " . $ins . "> ";
	$a = readln();
	return($a);
}

function sh_auth() {
?>
ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooO
ooooooooooooooooooooooooooo===oooooooDDoo=ooooooooooooooooooooooooooooooooo#
ooooooooooooooooooooooooo====ooDDDODDDDDDo==ooooooooooooooooooooooooooooooo#
oooooooooooooooooooooooo===oooDDOOOOOOODDooo===oooDooooooooooooooooooooooooN
oooooooooooooooooooDDo=====ooDDOOOOOODDoDDooo===oooDDoooooooooooooooooooooo#
oooooooooooooooDDDDooooooooDOOOOOOOOOODoo==oo====oDooDoooooooooooooooooooooO
ooooooooooooooDDDDDooo===ooDDOXXOOOOODDDoo========oDDDDDDDDDDDoDDDDDDDDDDDDN
oooooooooooooDDDDo======ooDDOOOODDOODDooo===eee===oDDDDDDoooooooooooooooooo#
ooooooooooooDDoooooo=====ooDOOODoDOODDo==eee======ooDDDOODooooooooooooooooo#
oooooooooooDDoDDooDDDDDDoo==ooDo=ooDDD=========oooooDDOOOODDoooooooooooooooN
oooooooooDDDDDDooDOOOODDooooooooo==oDooDDDoo=e==oDDDDDODOOODoooooooooooooooN
ooooooooDODDDoooDDODDo=ooo=========oooooDoooo===oDDDDDDDOOODDDoooooooooooooO
ooooooooODDDooooDDDo====eeeaaaaaeeeee=ee====oDo=ooOOOOOODDDOOOoooooooooooooO
oooooooDOOOoo=oooDo===eeaaaaaaaaaaaaaaaaaeee==o==oDOOOOOOOOOOODooooooooooooN
ooooooDOOOOoo====oo==eeeaaaaaaaaaaaaaaaaaaaaee==ooDOXXOOODDODDDDooooooooooo#
ooooooDOXOOoo====oo==eeaaaaaaaaaaaaaaaaaaaaaaa==ooOOXXXOOOOODooDoooooooooooN
oooooDOXXXXDoo===oo=eeeeaaaaaaaaaaaaaaaaaaaaaee=oDOOXXXXOODDDooooooooooooooN
ooooDOOXXXXODDoo=oo=eeeeeeaaaaaaaaaaaaaaaaaaaee=oDOXXXXOOODDDDDDoooooooooooO
ooooDOXXXXXXXODDooo=eeeeeeeaaaaaaaaaaaaaaaaaeeeeoDOXXXXOOOOODDDDDooooooooooO
oooooOXXXXXXXXXDDDo=eeeeeeaaaaaaaaaaaaaaaaaeeeee=oOXXXXXOOODDDDDDooooooooooO
oooooDOOXOOOXXXOODDo=eeeeaaaaaaaaaaaaaaaaaaaaaeeeeoOOOOODDDoDDDOODoooooooooO
oooooDDOOOOOOOXOODoo=eeeaaaaaaaaaaaaa)aaaaaaaaaeeee=oDDDDDDDDDOODDoooooooooN
ooooDOOOOOOOOOOODDo==eeeeeaaaaaaaaaaaaaaaaeeeeeeeee=oDoDDOXXOOOODDDooooooooO
=ooooDOOOOOOOOODoDDo=======o==eeeaaaaaae===oo==oo==ooDDoDOXXXOXXODooooooooo#
==ooooOOOOXXXODDoDooooooo=oDooo=eeaaaee=ooooo==ooooooooDDOXXXOOXODooooooooo#
====ooooDDOOOODoooDDoooDDoDooooDo=eee=oDo===oOOXDooooDOODDOXoDOODoooooooooo#
===oooee=e=DOOOODDoooDoDOOD==ooDo=eaaeoDo====DDDooo==o=oooDOooDODooooooooooN
===oooaa=eeDDDDooo============ooo=eaee=oo=====e=====o===ooDDee==Doooooooooo#
===oooea=eeoDooo=oo===========oo=eeaee==oo==eeee=====e==ooooeee=oDoooooooooN
===ooooe=ee=oooo=================eeaeee====ee=eeeeeeee==oo==e=e=oDooooooooo#
===oooD=eeee=oooo===eeeeeeeeee===eeaae===eeeeeeeeeeeee=oDo==e==eDDooooooooo#
===oooDD=e=e=ooDo===eeeeeeaeee===eeaae====eaaaaaeeeeee=oDo=eaeeoDDDooooooooN
===oooDDo=eee=oDo===eeeeaaaee====eeaaee====eeeaaeeeee==oDoeeaeeDDDooooooooo#
====ooDDD=eeeeoDoo==eeeeeeeee==oo=eee=o====eeeeeeeeee=ooDoeee=DDDDooooooooo#
=====ooDDD=eeeoDDo==eeeeeeeeee===o==oo====eeeeeeeeee==ooDDDDDDDDDooooooooooO
=====ooDDDDDoDODDoo==eeeeeeeee=====o===eeeeeeeeeeeee==ooDDDDDDDDoooooooooooN
=====ooDDDDDDOODDoo==eeeeeeeeee==eee=eeeeeeeeeeeeeee==ooDDDDDDDDooooooooooo#
=====ooDDDDDDOOOooo==eeeeee===================eeeeee==ooDDDDDDDDooooooooooo#
======ooDDDDDDDODoo===eee==DODooo=ee=e=e==oDDo=eeee===ooDDDDDDDDoooooooooooO
======ooDDDDDDDODDo===eee===oDDoDo=eee==ooDo===eee===ooDDDDDDDDDooooooooooo#
=======ooDDDDDDDDDoooo=ee=ee==oooooo=ooooo===eeee====ooDDDDDDDDDoooooooooooN
========oDDDDDDDDDDoooo=eeeeee====eeee======eeee====ooDoDDDDDDDDooooooooooo#
========ooDDDDDDDDDDooo==eeeeee==========eeeeeee===ooDooDDDDDDDooooooooooooO
=========oDDDDDDDDDOODoo==eee=eeeee===eeeeeeeee===ooo==o=DDDDooooooooooooooN
=========ooDDDDDDDDDDODoo==eeeeeeeeeeeeeeeeeee=o=ooo===oa=DooooooooooooooooO
===========ooooDDDDDDDDDDo==e=eeeeeeeeeeeeeee=oooDo=e===aeoOooooooooooooooo#
=============ooDDDDDDDoDDDD===eeeeeeeeeeeee==ooDo=eee==a)eeoXDoooooooooooooO
==============ooDDDDDDooDDDDo===eeeeeee====oooo=eeee==a)aeeaDXDoooooooooooo#
==============oooDDDDDDooDDDDDDoo=======oooooo=eeeee=a))aeea=XXXODoooooooooO
==============oooDDDDDDoooooooDDDoooooooooo==eeeeee=a())eaaaeXX#XXXDoooooooN
===============oooDDDD=Dooooooooooooooo=====eeeeeee)(()aaa))eXX#XXXXXODooooO
================oooDDDeoDooo=========eee==eeeeeeee)(()aaa))a=XXXXXXXXX#XXOOO
================ooooOO==DoDoo==eeeeeeeee==eeeeeaa((((a)a)))eeXX##XXXXXX#X#X#
===========oooDDOOXX#X=e=ooooo==eeeeee===eeeeaa)((((a)a)))aaoXX##XXXXXXXXX#O
======oDDOOXX########X==eeooooo============e)a)((()a)a)(()aaDX###XXXXXXXXX##
=ooDOX##############XXoeeea=oooo=======eeea)a(((()))a((()aaaOXX##XXXXXXXXX##
X###################Xooeeea)e==o=======ea)))((((a)))((()aaaaXX###XXXXXXXXXX#
###################Xoe==eeaa))e======eaa)a)((((a)a)(()a)a))eXX##XXXXXXXXXXXN
##################XO=ee==eea)()aeeeea)a)a(((()a)a)(()a)a)((DXXXXXXXXXXXXXXXN
##################X=eae==eaaaeeeeee=aa))(((())))((()a))((()XXXXXXXXXXXXXXXXN
#################XD==aa==ea=DeeDDooo=e)((((a)a)((())))((()=XXXXXXXXXXXXXXXXN
################XXeeeaa==ee=oDDODooooea)(())a)((())))((()aDXXXXXXXXXXXXXXXXN
#################oeeeaa==eeaaeoo====e===ea))(((())))((()))OXXXXXXXXXXXXXXXXO
<?php
}
?>
