<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file takes care of file delivery; attachments, javascripts,
 * stylesheets, thumbnails and spreadsheets.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */

$GLOBALS['dontsetnewsessiontime'] = true;
require_once "initiate.php";

if ($_GET['cxlsx']) {

    $obj = PopStashValue($_GET['cxlsx']);

	RealExcel($obj['sheet'], "array", $obj['filename']);

	EndHTML(false);

} elseif (ipi($_GET['cpdf'])) {

    /* a call for a download of some html currently in stash, only used by PDFDownloadLink */
    $obj = PopStashValue($_GET['cpdf']);
    list($obj['html'], $files_to_delete) = replace_images_for_pdf_and_mails($obj['html'], 'html');
    $pdf = HTML2PDF($obj['html']);
    foreach ($files_to_delete AS $ftd) {
        unlink($ftd);
    }
    $filename = $obj['filename'];

    if (strtolower(substr($filename, strlen($filename)-4, 4)) != ".pdf") $filename .= ".pdf";

    header("Content-Type: application/pdf");
    header("Content-Disposition: attachment; filename=\"" . clean_filename($filename) . "\"");
    print $pdf;

    EndHTML(false);

} elseif (ipi($_GET['pdfreport'])) {

	if (GetTemplateType($_GET['pdfreport']) == 'TEMPLATE_REPORT_PDF') {
		$pdf = GetPDFReport($_GET['pdfreport'], "", "");
		header("Content-Disposition: attachment; filename=\"" . $pdf["filename"] . "\"");
		header("Content-Type: application/pdf");
		print $pdf["pdf"];

	} else {
		Show404();
	}
	EndHTML(false);

} elseif (isset($_GET['GetJSON'])) {
    //header("Content-Disposition: attachment; filename=\"" . $_GET["filename"] . "\"");
	header("Content-type: application/json; charset=UTF-8");
    print PopStashValue($_GET['GetJSON']);
	EndHTML(false);

} elseif (isset($_GET['GetDefaultReport']) && is_administrator()) { /* for now, only administrators - potentionally a user could download the entire database */

    $listoptions = ConvertTagOptionsToListOptions($_GET['listoptions']);

    CreateDefaultReport($_GET['table'], $_GET['reporttype'], $_GET['filename'], '', $listoptions, $_GET['alldata'], true);

	EndHTML(false);

} elseif (isset($_GET['GetJS'])) {
	//header("Expires: Thu, 16 Jan 2020 20:00:00 GMT");

	//header("Last-Modified: " . gmdate('D, d M Y H:i:s', $lmd) . ' GMT');
	header("Content-Type: application/javascript; charset=utf-8");
	//print ReturnStandardJavascript();
	//print PrintExtraFieldForceJavascript();
	EndHTML(false);

} elseif ($_GET['GetCSS']) {

	/* stylesheets, default and custom */

	$css = "";
	$no_default = false;
	$lmd =0;
	$lmd2 =0;

	if ($_GET['GetCSS'] == "2147483647") { // dirty catch for no css at all

		/* this means we don't want any css at all */
		$no_default = true;

	} elseif (ipi($_GET['GetCSS']) && GetTemplateType($_GET['GetCSS']) == "TEMPLATE_CSS") {

		/* a request for a specific css file ON TOP OF THE DEFAULT*/
		$css .= GetTemplate($_GET['GetCSS']);
		$lmd = strtotime(GetTemplateLastModificationDate($_GET['GetCSS']));

	}

	if ($_GET['nodefault'] == "" && !$no_default) {

		$templateid = GetSetting("SYSWIDECSS");
		$lmd2 = strtotime(GetTemplateLastModificationDate($templateid));

		$css .= GetTemplate($templateid);

		/* we use the most recent last-mod-date */
		if ($lmd2 > $lmd) $lmd = $lmd2;
	}

//JH 2017-10-23 not needed anymore because of <body class="groupX">
//    $css = StripGroupOnlyTags(ParseTemplateInclusions($css));

	if ($_SERVER['HTTP_IF_MODIFIED_SINCE'] != '' && strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) == $lmd) {

		 header('HTTP/1.1 304 Not Modified');

	} else {

		header("Last-Modified: " . gmdate('D, d M Y H:i:s', $lmd) . ' GMT');
		header("Content-Type: text/css; charset=utf-8");
		print $css;

	}

	EndHTML(false);

} elseif ($_GET['getcustomjs'] == 1) {

	$jstemplate = GetSetting("TemplateNoOfJavascriptFileToIncludeInEveryPage");
	$lmd = strtotime(GetTemplateLastModificationDate($jstemplate));
	if ($_SERVER['HTTP_IF_MODIFIED_SINCE'] != '' && strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) == $lmd) {

		 header('HTTP/1.1 304 Not Modified');

	} else {
		$template = GetTemplate($jstemplate);
		header("Content-Type: application/javascript; charset=utf-8");
		header("Last-Modified: " . gmdate('D, d M Y H:i:s', $lmd) . ' GMT');
		print $template;

	}
	EndHTML(false);

} elseif (is_administrator() && ipi($_GET['templateid'])) {

	header("Content-Type: application/octet-stream");
	header("Content-Disposition: attachment; filename=\"" . GetTemplateName($_GET['templateid']) . "\"");
	print db_GetValue("SELECT binary_content FROM CRMtemplates WHERE templateid='" . mres($_GET['templateid']) . "'");
	EndHTML(false);

} elseif (ipi($_GET['fileid']) || ipi($_GET['minitn']) || ipi($_GET['tn'])) {

	$fileid = 0;

	/* general purpose file delivery */
	if (ipi($_GET['fileid'])) {

		/* a regular file */
		$fileid = $_GET['fileid'];

	} elseif (ipi($_GET['minitn'])) {

		/* a mini thumbnail */
		$fileid = $_GET['minitn'];

	} elseif (ipi($_GET['tn'])) {

		/* a normal thumbnail */
		$fileid = $_GET['tn'];

	}

	if (CheckTableRecordAccess("files", $fileid) != "nok") {

		$addlog = "";
		$filename = GetFileName($fileid);

	    $lmd = strtotime(GetBlobLastModificationDate($fileid));
        $lastdownload = strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']);

		if ($lmd < $lastdownload) {

			$addlog = " (304 Not Modified)";
			header('HTTP/1.1 304 Not Modified');


		} else {

			$filetype = GetFileType($fileid);
			$blob = "";

			if (ipi($_GET['fileid'])) {

                /* a regular file */
				$blob = GetFileContent($fileid);
                $filetype = GetFileType($fileid);

                if (substr($filename, strlen($filename)-11, 11) == '.interleave') {

                    $filename = substr($filename, 0, strlen($filename)-11) . ".pdf";

                    /* an interleave specific doument ending in .interleave - it's plain html but we serve it as pdf */

                    list($blob, $files_to_delete) = replace_images_for_pdf_and_mails($blob, 'html');

                    $blob = HTML2PDF($blob);

                    foreach ($files_to_delete AS $ftd) {
                        unlink($ftd);
                    }

                    $filetype = 'application/pdf';

                } elseif ($filetype == 'image/jpg' || $filetype == 'image/jpeg' || $filetype == 'image/gif'  || $filetype == 'image/png') {

                    $autorotate = false;
                    $setwidth = 'aspect';
                    $setheight = 'aspect';
                    $copyrightmsg = '';

                    if ($_GET['autorotate'] != '') $autorotate = true;
                    if (ipi($_GET['width'] != '')) $setwidth = $_GET['width'];
                    if (ipi($_GET['height'] != '')) $setheight = $_GET['height'];
                    if ($_GET['copyrightmessage'] != '') $copyrightmsg = $_GET['copyrightmessage'];


                    if ($autorotate || ipi($setwidth) || $copyrightmsg != '') {
                        $blob = ResizeImage($blob, $setwidth, $setheight, "0,0,0", "104,104,104", $copyrightmsg, $autorotate);
                    }
                }

			} elseif (ipi($_GET['minitn'])) {

				/* a mini thumbnail */
				$blob = GetMiniThumbnail($fileid);

			} elseif (ipi($_GET['tn'])) {

				/* a normal thumbnail */
				$blob = GetImageThumbnail($fileid);

			}

			$content_disposition = "attachment";
			if ($_GET['displayinline'] == 1) {
				$content_disposition = "inline";
			}

			header("Content-Type: " . $filetype);
			header("Content-Disposition: " . $content_disposition . "; filename=\"" . $filename . "\"");
			header("Last-Modified: " . gmdate('D, d M Y H:i:s', $lmd) . ' GMT');

			print $blob;
		}

		//JH20161010 thumbnail downloads are not journaled; is this ok? => HF Yes (too many log lines)
		if (ipi($_GET['fileid'])) {
			log_msg("File id " . $fileid . " downloaded" . $addlog);
			list($tt, $record) = db_GetRow("SELECT type, koppelid FROM CRMbinfiles WHERE fileid='" . $fileid . "'");
			journal($record, "File id " . $fileid . " [" . $filename . "] downloaded", $tt);
		}
		EndHTML(false);
	} else {
		Show404();
		EndHTML(false);
	}
} else {
	PrintAD("Don't know what to do");
	EndHTML(false);
}

?>
