<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file enables users to compare tables
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */

require "initiate.php";
$debug = false;
if (isset($_REQUEST['debug']) && is_administrator()) {
	$debug = true;
}

if (is_administrator())
{
	$GLOBALS["InAdminSection"] = true;
}

$reload = false;
$ref_ins = '';
$perc = '';
$error = false;
$submitform = false;
$nobutton = false;
$worker = '';
$mem = '';


ShowHeaders();

print "<form id=\"dedupForm\" method=\"post\" action=\"dedup.php\">";

if (!$_REQUEST['Worker'] && !$_REQUEST['Reloaded']) { // No session exists, create one and ask some questions

		$worker = PushStashValue(array("table" => "unknown"));

	$tables = array();
	$set = false;

	if (is_administrator()) {
		$ft = GetFlextableDefinitions();
		foreach ($ft AS $f) {
			$tables[$f['recordid']] = $f['tablename'];
		}
		//$tables['users'] = "Users";
		$set = true;
	} else {
		foreach (GetFlextableDefinitions() AS $ft) {
			$configname = "AllowedTodedupFT" . $ft['recordid'];
			if (CheckFunctionAccess($configname) == "ok") {
				$tables[$ft['recordid']] = $ft['tablename'];
				$set = true;
			}
		}
		if (CheckFunctionAccess("AllowedTodedupUsers") == "ok") {
			//$tables['users'] = "Users";
			//$set = true;
		}

	}

	if ($set) {
		print "Choose table to de-duplicate: ";
		print "<select name=\"tableId\" id=\"JS_table\">";
		foreach ($tables AS $table => $name) {
			print "<option value=\"" . $table . "\">" . htme($name) . "</option>";
		}
		print "</select>";
	} else {
		PrintAD("You're not allowed to use this functionality");
		$error = true;
	}
} else {
	print "<a href=\"dedup.php\">Stop / start over</a><br>";

	$mem = "";
	$stillbusy = false;

	$worker = $_REQUEST['Worker'];
	if ($_REQUEST['tableId'] != "") {
		$mem['table'] = $_REQUEST['tableId'];
	}
	if ($worker == "new") {
		$worker = PushStashValue($mem);
	}

	if (isset($_REQUEST['Reloaded'])) {
		$worker = $_REQUEST['Reloaded'];
		$mem = PopStashValue($worker);
		print "<h1>Processed " . count($mem['processed']) . " records but no " . $mem['percentage'] . "% duplicates found in the last set</h1><h2>Please wait while the system searches.</h2>";
		$stillbusy = true;
	} else {
		$mem = PopStashValue($worker);
	}

	if ($_REQUEST['tableId'] == "" && ($mem['table'] == "unknown" || $mem['table'] == "")) {

		PrintAD("No table id received");

	} elseif (is_array($_REQUEST['fieldName']) || $mem['field']) {

		if (is_numeric($_REQUEST['percentage']) && $_REQUEST['percentage'] > 0 && $_REQUEST['percentage'] < 101 && $mem['percentage'] == "") {
			$mem['percentage'] = $_REQUEST['percentage'];
		} elseif ($mem['percentage'] == "") {
			$mem['percentage'] = 95;
		}


		if (!$mem['enrich']) {
			if ($_REQUEST['Enrich'] != "") {
				$mem['enrich'] = $_REQUEST['Enrich'];
				$mem['keepnewest'] = false;
				if ($mem['enrich'] == "yes-auto" || $mem['enrich'] == "yes-auto-newest") {
					if ($mem['enrich'] == "yes-auto-newest") $mem['keepnewest'] = true;
					$mem['AutoFeed'] = true;
					$mem['enrich'] = "yes";
				} elseif ($mem['enrich'] == "no-auto" || $mem['enrich'] == "no-auto-newest") {
					if ($mem['enrich'] == "no-auto-newest") $mem['keepnewest'] = true;
					$mem['AutoFeed'] = true;
					$mem['enrich'] = "no";
				} elseif ($mem['enrich'] == "yes-auto-dry" || $mem['enrich'] == "yes-auto-dry-newest") {
					if ($mem['enrich'] == "yes-auto-dry-newest") $mem['keepnewest'] = true;
					$mem['AutoFeed'] = true;
					$mem['DryRun'] = true;
					$mem['enrich'] = "yes";
				} elseif ($mem['enrich'] == "no-auto-dry" || $mem['enrich'] == "no-auto-dry-newest") {
					if ($mem['enrich'] == "no-auto-dry-newest") $mem['keepnewest'] = true;
					$mem['AutoFeed'] = true;
					$mem['DryRun'] = true;
					$mem['enrich'] = "no";
				} elseif ($mem['enrich'] == "yes-confirm" || $mem['enrich'] == "yes-confirm-newest") {
					if ($mem['enrich'] == "yes-confirm-newest") $mem['keepnewest'] = true;
					$mem['AutoFeed'] = false;
					$mem['DryRun'] = false;
					$mem['enrich'] = "yes";
					$mem['enrich-confirm'] = true;
				} else {
					$mem['AutoFeed'] = false;
					$mem['DryRun'] = false;
				}

			} else {
				$mem['enrich'] = "yes";
			}
		}
//DA($mem);
		if (!$mem['field']) {

			if (count($_REQUEST['fieldName']) > 1) {
				$mem['compareFields'] = array();
				$mem['field'] = " CONCAT(''";
				foreach ($_REQUEST['fieldName'] AS $f) {
					$mem['field'] .= ", " . mres($f) . ", ' '";
					$mem['compareFields'][] = $f;
					$mem['extra_where'] .= " AND " . mres($f) . " != ''";
				}
				$mem['field'] .= ")";



			} else {
				$mem['compareFields'] = array($_REQUEST['fieldName'][0]);
				$mem['field'] = "`" . mres($_REQUEST['fieldName'][0]) . "`";
			}

		}
		if (!$mem['rowcounter']) {
			$mem['rowcounter'] = 0;
		}


		$ins = "";

			$items = "SELECT recordid AS rec, " . ($mem['field']) . " AS value FROM CRMflextable" . ($mem['table']) . " WHERE " . $mem['field'] . " !='' " . $mem['extra_where'];
			if ($GLOBALS['UC']['PersonalDataStructure']["t" . $mem['table']]["logical_delete"]) {
				$items .= " AND deleted='n'";
			}
			$id = "recordid";
			if ($mem['percentage'] == 100) {
				$tmplist = db_GetArray("SELECT " . $mem['field'] . ", COUNT(*) as cnt FROM CRMflextable" . $mem['table'] . " GROUP BY " . $mem['field'] . " HAVING cnt > 1");
				$items .= " AND " . $mem['field'] . " IN(''";
				foreach ($tmplist AS $proc) {
					$items .= ",'" . mres($proc[0]) . "'";
				}
				$items .= ")";
			} else {
				$items .= " AND " . $id . " NOT IN(0";
				foreach ($mem['processed'] AS $proc) {
					$items .= "," . $proc;
				}
				$items .= ")";
			}

			$table = "flextable" . $mem['table'];

			if ($GLOBALS['UC']['PersonalDataStructure']["t" . $mem['table']]["logical_delete"]) {
				$ins = " WHERE deleted='n'";
			}


			if ($_REQUEST['restoresession']) {
				$mem['restoresession'] = GetAttribute("user", "LastRecordDedup" . $mem['table'], $GLOBALS['USERID']);
				//print "RESTORE: " . $mem['restoresession'];
			}
			if ($mem['restoresession']) {
				$items .= " AND recordid>=" . $mem['restoresession'];
			}

			$items .= " ORDER BY recordid ";
			if ($mem['keepnewest']) {
				$items .= " DESC";
			}


	//	print $items;
		// Process commands

		if (is_numeric($_REQUEST['Keep']) && is_array($_REQUEST['processingRecords'])) {
			print "<h1>Deleted " . (count($_REQUEST['processingRecords'])-1) . " records, kept 1</h1>";
			$keep = $_REQUEST['Keep'];
			$keeping = db_GetRow("SELECT * FROM CRM" . $table . " WHERE " . $id . " = " . $keep);

			$to_del = $_REQUEST['processingRecords']; // Except $keep!
			$sql = array();
			$confirm = array();
			$rstd = array();

			foreach ($to_del AS $rtd) {

				if ($rtd != $keep) {

					foreach (GetFlextableDefinitions() AS $ft) {
						if ("flextable" . $ft['recordid'] == $table) { // It's me!

								$refs = db_GetArray("SELECT id, tabletype FROM CRMextrafields WHERE fieldtype='Reference to FlexTable' AND options='" .
								str_replace("flextable", "", $table) . "'");

								foreach ($refs AS $ref) {
									if (is_numeric($ref[1])) $ref[1] = "flextable" . $ref[1];
									if ($ref[1] == 'user') $ref[1] = "loginusers";
									if ($ref[1] == 'group') $ref[1] = "userprofiles";
									$sql[] = "UPDATE CRM" . $ref[1] . " SET EFID" . $ref[0] . "=" . $keep . ", timestamp_last_change=timestamp_last_change WHERE EFID" . $ref[0] . "='" . $rtd . "'";
									$sql[] = "INSERT INTO CRMjournal(eid, user, message, type) VALUES(" . $keep . "," . $GLOBALS['USERID'] . ",'Flextable record edited / kept (dedup)', 'flextable" . $ref[1] . "')";

								}
						}
					}

					if ($mem['enrich'] == "yes") {
						$rtdRow = db_GetRow("SELECT * FROM CRM" . $table . " WHERE " . $id . " = " . $rtd);
						foreach ($rtdRow AS $rtdField => $rtdValue) {
							if (!is_numeric($rtdField)) {
								if ($keeping[$rtdField] == "" && $rtdValue != "") {
									$Ttable = $table;
									if ($Ttable == 'user') $Ttable = "loginusers";
									if ($Ttable == 'group') $Ttable = "userprofiles";

									$sql[] = "UPDATE CRM" . $Ttable . " SET " . $rtdField . "= '" . mres($rtdValue) . "' , timestamp_last_change=timestamp_last_change WHERE " . $id . " = " . $keep . " AND (" . $rtdField . " = '' OR " . $rtdField . "=0 OR " . $rtdField . " ='0000-00-00' OR " . $rtdField . "='0000-00-00 00:00:00')";

									$sql[] = "INSERT INTO CRMjournal(eid, user, message, type) VALUES(" . $keep . "," . $GLOBALS['USERID'] . ",'Record edited / enriched (dedup) : " . $rtdField . " was empty, updated to [" . mres($rtdValue) . "]', '" . $table . "')";
									if ($mem['enrich-confirm']) {
										$confirm[] = array("Field" => GetExtraFieldName(str_replace("EFID", "", $rtdField)), "OldValue" => db_GetValue("SELECT ". $rtdField . " FROM CRM" . $table . " WHERE " . $id . " = " . $keep), "NewValue" => db_GetValue("SELECT ". $rtdField . " FROM CRM" . $table . " WHERE " . $id . " = " . $keep) . ", " . $rtdValue);
									}
								}
							}
						}
					}
					
					//$sql[] = "UPDATE CRM" . $table . " SET deleted='y' WHERE recordid=" . $rtd;
					$rstd[] = $rtd;
					//$sql[] = "INSERT INTO CRMjournal(eid, user, message, type) VALUES(" . $rtd . "," . $GLOBALS['USERID'] . ",'Record edited / deleted (dedup)', '" . $table . "')";
				}

			}
//DA($sql);
			if ($mem['DryRun']) {

				foreach ($sql AS $q) {
					$mem['queries'][] = $q;
				}
				print count($mem['queries']) . " queries generated but not executed. Queries will be shown when deduplication is finished.<br>";
			} else {
				foreach ($sql AS $q) {
					mcq($q);
				}
				foreach ($rstd AS $rtd) {
					delete_record(str_replace("flextable", "t", $table), $rtd, true);
				}

				print count($sql) . " queries executed.<br>";
			}
		}
//		DA($mem['queries']);

		// End process commands
		if (!$stillbusy) {
			if ($mem['AutoFeed']) {
				print "<h1>Processing...</h1>";
			} else {
				print "<h1>Records shown below are " . $mem['percentage'] . "% or more alike based on the compare field(s). Select the one you wish to keep. <input type=\"submit\" value=\"skip this set\"></h1>";
				print "Only showing matches of " . $mem['percentage'] . "% and higher.";
				if ($mem['enrich'] == "yes") {
					print " Missing data which is available in records to be deleted will be added to the record being kept.";
				}

			}
			$nobutton = true;
		}
		print "<br><br>";

		$count =0;
		$rescount =0;
		if (!is_array($mem['processed'])) $mem['processed'] = array();

		$hit = false;
		$result = array();
		$start = date('U');
		//print "<h1>" . $items . "</h1>";
		foreach (db_GetArray($items) as $item1) {
			if (!in_array($item1[0], $mem['processed'])) {
				$mem['processed'][] = $item1[0];
				foreach (db_GetArray($items) as $item2) {
					if (!in_array($item2[0],$mem['processed'])) {
						$count++;
						if ($item1[0] != $item2[0]) {
							$perc = '';
							if ($mem['percentage'] < 100) {
								similar_text(strtolower($item1[1]), strtolower($item2[1]), $perc);
							} elseif ($mem['percentage'] == 100) {
								if ($item1[1] == $item2[1]) {
									$perc = 100;
								} else {
									$perc = 0; // doesn't matter
								}
							} else {
								print "<span class=\"errmsg\">Error: percentage not understood</span>";
								$perc = -1;
							}
							if ($perc >= $mem['percentage']) {
								if (!in_array($item1[0], $result)) $result[] = $item1[0];
								if (!in_array($item2[0], $result)) $result[] = $item2[0];
								$mem['processed'][] = $item2[0];
								$hit = true;
							}
						}

					}
				}
			}
			$mem['rowcounter']++;
			if ($hit) {
				break;
			}
			if (date('U') > ($start + 20)) {
				$reload = true;
				$submitform = true;
				break;
			}
		}



		if ($reload) {
			print "<input type=\"hidden\" name=\"Reloaded\" value=\"" . $worker . "\">";
		} else {
			if (count($result) > 0) {

				print "<table class=\"crm\">";
				print "<thead><tr><th>Record</th><th>";
				foreach ($mem['compareFields'] AS $cf) {
					print GetExtraFieldName(str_replace("EFID", "", $cf)) . " " ;
				}
				print "</th><th>Last modification</th><th>Data record completeness</th><th>Referring records</th><th>Match</th><th>Exclude</th><th>Choose record to keep</th></tr></thead>";
				$first = "";
				$num = 0;
				foreach ($result AS $record) {

					$row = db_GetRow("SELECT * FROM CRM" . $table . " WHERE " . $id . "=" . $record);
					$score = 0;
					foreach ($row AS $test) {
						if ($test != "") {
							$score++;
						}
					}
					$firstrow = false;
					if ($first == "") {
						$firstrow = true;
						SetAttribute("user", "LastRecordDedup" . $mem['table'],$record, $GLOBALS['USERID']);
						foreach ($mem['compareFields'] AS $cf) {
							$first .= $row[$cf] . " ";
						}
					}
					print "<tr id=\"ROW" . $row[$id] . "\"><td>" . $row[$id] . "<input type=\"hidden\" name=\"processingRecords[]\" value=\"" . $row[$id] . "\"></td><td>";
					foreach ($mem['compareFields'] AS $cf) {
						print htme($row[$cf]) . " ";
					}

					print "</td>";
					print "<td>" . $row['timestamp_last_change'] . "</td>";

					print "<td>" . $score . "/" . count($row) . "</td>";

					$refrec = 0;

					foreach (GetFlextableDefinitions() AS $ft) {

						if ("flextable" . $ft['recordid'] == $table) { // It's me!

								$refs = db_GetArray("SELECT id, tabletype FROM CRMextrafields WHERE fieldtype='Reference to FlexTable' AND options='" . str_replace("flextable", "", $table) . "'");

								foreach ($refs AS $ref) {
									if (is_numeric($ref[1])) $ref[1] = "flextable" . $ref[1];
									if ($ref[1] == 'user') $ref[1] = "loginusers";
									if ($ref[1] == 'group') $ref[1] = "userprofiles";
									$sql = "SELECT COUNT(*) FROM CRM" . $ref[1] . " WHERE EFID" . $ref[0] . "='" . $record . "'";
									$refrec += db_GetValue($sql);

								}
						}
					}

					print "<td>" . $refrec . $ref_ins . "</td>";

					$tcp = "";
					foreach ($mem['compareFields'] AS $cf) {
						$tcp .= $row[$cf] . " ";
					}
					similar_text(strtolower($first), strtolower($tcp), $perc);

					print "<td>" . FormatNumber($perc) . " %</td>";
					print "<td><a onclick=\"$(document.getElementById('ROW" . $row[$id] . "')).remove();\">[exclude]</td>";
					if ($firstrow && $mem['AutoFeed']) {
						$ins = " checked";
						$submitform = true;
					} else {
						$ins = "";
					}
					print "<td><input type=\"radio\" " . $ins . " name=\"Keep\" value=\"" . $row[$id] . "\" onclick=\"document.forms['dedupForm'].submit();\"></td>";
					print "</tr>";
				}


				print "</table>";
			} else {
				print "Done.";
				if ($mem['DryRun']) {
					print " This was a dry run; no changes were made. The generated queries are printed below.<br>";
					print "<textarea rows='10' cols='100'>";
					foreach ($mem['queries'] AS $q) {
						print htme($q) . "\n";
					}
					print "</textarea>";
					if (isset($_REQUEST['Snd'])) {
						$body = "";
						foreach ($mem['queries'] AS $q) {
							$body .= ($q) . "\n";
						}
						AddMessage("admin", $GLOBALS['USERID'], "Deduplication result.", $body);
						AddMessage($GLOBALS['USERID'], $GLOBALS['USERID'], "Deduplication result.", $body);

						print "<br><br>OK: administrator notified (message cc'd to " . GetUserName($GLOBALS['USERID']) . ")";
					} else {
						print "<br><br><a href='dedup.php?Worker=" . $worker . "&Snd'>Send this set of queries to your Interleave administrator.</a>";
					}
				}
			}
		}




	} else {
		$mem['table'] = $_REQUEST['tableId'];
		if ($mem['table'] && $mem['table'] != "unknown" && !CheckIfUserIsAllowedTodedupInTable($mem['table'])) {

			PrintAD("You're not allowed to use this functionality");
			$error = true;

		} else {
			print "<h1>Deduplicate ";
			if (is_numeric($mem['table'])) {
				print "&quot;" . GetFlextableName($mem['table']) . "&quot;";
			} else {
				print "&quot;" . $lang[$mem['table']] . "&quot; table";
			}
			print "</h1>";
			$list = GetExtraFlexTableFields($mem['table'], false, false, true);

			print "<h2>Select field or a combination of fields to compare on</h2><div class=\"scrolldiv\">";
			foreach ($list AS $ef) {
				print "<input type=\"checkbox\" name=\"fieldName[]\" value=\"EFID" . htme($ef['id']) . "\" id=\"JS_CBEFID" . htme($ef['id']) . "\"><label for=\"JS_CBEFID" . htme($ef['id']) . "\">" . htme($ef['name']) . "</label><br>";
			}
			print "</div>";

			print "<br>...and show fields with <input type=\"text\" name=\"percentage\" value=\"95\" size=\"2\"> % match and up.<br><br>Method :
				<select name=\"Enrich\">
					<option value=\"yes\">ask me every time, keep oldest record, migrate all existing data to the record which is kept</option>
					<!-- <option value=\"yes-confirm\">ask me every time, keep oldest record, migrate all existing data to the record which is kept after confirmation from me</option> //-->

					<!-- <option value=\"yes-confirm-newest\">ask me every time, keep newest record, migrate all existing data to the record which is kept after confirmation from me</option> //-->
					<option value=\"no\">ask me every time and just delete duplicate records</option>
					<option value=\"yes-auto-dry\">process automatically, keep oldest record, migrate all existing data to the record which is kept but don't make any changes (dry run)</option>
					<option value=\"no-auto-dry\">process automatically, keep oldest record, and just delete the duplicates but don't make any changes  (dry run)</option>
					<option value=\"yes-auto\">process automatically, keep oldest record, migrate all existing data to the record which is kept</option>
					<option value=\"no-auto\">process automatically, keep oldest record, and just delete the duplicates</option>
					<option value=\"yes-auto-dry-newest\">process automatically, keep newest record, migrate all existing data to the record which is kept but don't make any changes (dry run)</option>
					<option value=\"no-auto-dry-newest\">process automatically, keep newest record, and just delete the duplicates but don't make any changes  (dry run)</option>
					<option value=\"yes-auto-newest\">process automatically, keep newest record, migrate all existing data to the record which is kept</option>
					<option value=\"no-auto-newest\">process automatically, keep newest record, and just delete the duplicates</option>
				</select>
				.<br>";


			$LastRecord = GetAttribute("user", "LastRecordDedup" . $mem['table'], $GLOBALS['USERID']);
			if ($LastRecord > 0) {
				print "<br><br><input type=\"submit\" name=\"restoresession\" value=\"Restore last session; start at row " . $LastRecord . "\"><br><br>";
			}
		}

	}
}


if (!$error && !$submitform && !$nobutton) {
	print "<input type=\"submit\" name=\"submitButton\" value=\"" . $lang['go'] . "\">";
}

print "<input type=\"hidden\" id=\"JS_Worker\" name=\"Worker\" value=\"" . $worker . "\">";

print "</form>";

UpdateStashvalue($worker, $mem);
if ($debug) DA($mem);

if ($submitform) {
	?>
	<script type="text/javascript">
	<!--
		document.forms['dedupForm'].submit();
	//-->
	</script>
	<?php
}

EndHTML();

function CheckIfUserIsAllowedTodedupInTable($tableid) {
	if (is_administrator()) {
		return true;
	} elseif ($tableid == "users" && CheckFunctionAccess("AllowedTodedupUsers") == "ok") {
		return true;
	} elseif (is_numeric($tableid) && CheckFunctionAccess("AllowedTodedupFT" . $tableid) == "ok") {
		return true;
	} else {
		return false;
	}
}
?>
