<?php

/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This is the "e-mail in" plugin for Interleave
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */


// SENDMAIL SYNTAX; Create an alias in your /etc/mail/aliases called:
//
//	crm:  "|/path/to/php /path/to/email_in.php [command line args, see below]

$GLOBALS['EMAIL_RAWBODY'] = "";
$fp = fopen("php://stdin", "r");
while (!feof($fp)) {
	$GLOBALS['EMAIL_RAWBODY'] .= fgets($fp,1024);
}

$runmodule = 0;

$GLOBALS['PATHTOINTERLEAVE'] = dirname(realpath($argv[0])) . "/";

$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
foreach ($argv AS $ar) {
	if (substr($ar, 0, 4) == "cfg=") {
		$cfg = str_replace("cfg=", "", $ar);
		$GLOBALS['CONFIGFILE'] = $cfg;
	}
	if (substr($ar, 0, 10) == "runmodule=") {
		$runmodule = str_replace("runmodule=", "", $ar);
	}
}

require_once $GLOBALS['PATHTOINTERLEAVE'] . "adminfunctions.php";

// Check if this is done using the command line (e.g. not the web)
CheckIfShell();

$repository = 0;
$username = "";
$password = "";

if ($argv[1]) {
	$repository = $argv[1];
}
if ($argv[2]) {
	$username = $argv[2];
}
if ($argv[3]) {
	$password = $argv[3];
}

if ($argv[1]=="-help" || $argv[1]=="--help" || $argv[1]=="help" || $argv[1]=="-h" ||  $username=="" || $password==""  ) {
	print "usage: php ./email_in.php [repository] [username] [password] (or \"NOPASS\") [runmodule=XX] [cfg=/path/to/config.inc.php]\n";
	exit(0);
}
if (!$username || !$password) {
	echo "You MUST give all required information as arguments!\n";
	exit(1);
}

$GLOBALS['CMDLINE'] = true;
$GLOBALS['DontUpgradeTheDatabase'] = true;

$GLOBALS['overriderepository'] = $repository;
$GLOBALS['cmdline_username'] = $username;
$GLOBALS['cmdline_password'] = $password;
require "initiate.php";

$GLOBALS['CMDLINE'] = false;

$incomingmail = InterleaveMimeParse($GLOBALS['EMAIL_RAWBODY']);
$attachmentcounter = 0;
$GLOBALS['Attachments'] = array();

$body = "";
$charset = "";
$is_html = false;
//we geven voorkeur aan text/plain, als die niet gevonden wordt zoeken we naar text/html
foreach (array("text/plain", "text/html") as $contenttype)
{
	//we zoeken eerst 2 lagen diep
	$outer = 1;
	while (is_array($incomingmail["part" . $outer]))
	{
		$inner = 1;
		while (is_array($incomingmail["part" . $outer]["part" . $inner]))
		{
			if (($body == "") && ($incomingmail["part" . $outer]["part" . $inner]["body"] != "") && ($incomingmail["part" . $outer]["part" . $inner]["headers"]["content-disposition"] == "") && ($incomingmail["part" . $outer]["part" . $inner]["headers"]["content-type"] == $contenttype))
			{
				$body = $incomingmail["part" . $outer]["part" . $inner]["body"];
				$charset = $incomingmail["part" . $outer]["part" . $inner]["headers"]["content-type|charset"];
				if ($contenttype == "text/html")
				{
					$is_html = true;
				}
			}
			//heel lomp; alleen in eerste lus
			if ($contenttype == "text/plain")
			{
				//content-disposition zowel inline als ook attachment
				if (($incomingmail["part" . $outer]["part" . $inner]["body"] != "") && ($incomingmail["part" . $outer]["part" . $inner]["headers"]["content-disposition"] != ""))
				{
					$GLOBALS['Attachments'][$attachmentcounter]["data"] = $incomingmail["part" . $outer]["part" . $inner]["body"];
					$GLOBALS['Attachments'][$attachmentcounter]["filename"] = $incomingmail["part" . $outer]["part" . $inner]["headers"]["content-disposition|filename"];
					$GLOBALS['Attachments'][$attachmentcounter]["type"] = $incomingmail["part" . $outer]["part" . $inner]["headers"]["content-type"];
					$attachmentcounter++;
				}
			}
			$inner++;
		}
		$outer++;
	}
	//...als dat niks oplevert zoeken we 1 laag diep
	$outer = 1;
	while (is_array($incomingmail["part" . $outer]))
	{
		if (($body == "") && ($incomingmail["part" . $outer]["body"] != "") && ($incomingmail["part" . $outer]["headers"]["content-disposition"] == "") && ($incomingmail["part" . $outer]["headers"]["content-type"] == $contenttype))
		{
			$body = $incomingmail["part" . $outer]["body"];
			$charset = $incomingmail["part" . $outer]["headers"]["content-type|charset"];
			if ($contenttype == "text/html")
			{
				$is_html = true;
			}
		}
		//heel lomp; alleen in eerste lus
		if ($contenttype == "text/plain")
		{
			//content-disposition zowel inline als ook attachment
			if (($incomingmail["part" . $outer]["body"] != "") && ($incomingmail["part" . $outer]["headers"]["content-disposition"] != ""))
			{
				$GLOBALS['Attachments'][$attachmentcounter]["data"] = $incomingmail["part" . $outer]["body"];
				$GLOBALS['Attachments'][$attachmentcounter]["filename"] = $incomingmail["part" . $outer]["headers"]["content-disposition|filename"];
				$GLOBALS['Attachments'][$attachmentcounter]["type"] = $incomingmail["part" . $outer]["headers"]["content-type"];
				$attachmentcounter++;
			}
		}

		$outer++;
	}
	//...en als dat niks oplevert zoeken we 3 lagen diep (2018-01-29)
	$outer = 1;
	while (is_array($incomingmail["part" . $outer]))
	{
		$inner = 1;
		while (is_array($incomingmail["part" . $outer]["part" . $inner]))
		{
			$inner2 = 1;
			while (is_array($incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]))
			{
				if (($body == "") && ($incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["body"] != "") && ($incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["headers"]["content-disposition"] == "") && ($incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["headers"]["content-type"] == $contenttype))
				{
					$body = $incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["body"];
					$charset = $incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["headers"]["content-type|charset"];
					if ($contenttype == "text/html")
					{
						$is_html = true;
					}
				}
				//heel lomp; alleen in eerste lus
				if ($contenttype == "text/plain")
				{
					//content-disposition zowel inline als ook attachment
					if (($incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["body"] != "") && ($incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["headers"]["content-disposition"] != ""))
					{
						$GLOBALS['Attachments'][$attachmentcounter]["data"] = $incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["body"];
						$GLOBALS['Attachments'][$attachmentcounter]["filename"] = $incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["headers"]["content-disposition|filename"];
						$GLOBALS['Attachments'][$attachmentcounter]["type"] = $incomingmail["part" . $outer]["part" . $inner]["part" . $inner2]["headers"]["content-type"];
						$attachmentcounter++;
					}
				}
				$inner2++;
			}
			$inner++;
		}
		$outer++;
	}
}

//het is geen multipart message, dus nemen we de reguliere mail body
if ($body == "")
{
	$body = $incomingmail["body"];
	$charset = $incomingmail["headers"]["content-type|charset"];
	if ($incomingmail["headers"]["content-type"] == "text/html")
	{
		$is_html = true;
	}
}

if ($is_html)
{
	$body = html2plaintext($body);
}

$body = return_valid_utf8($body, $charset);


$GLOBALS['EMAIL_BODY'] = $body;
$GLOBALS['EMAIL_SUBJECT'] = $incomingmail["headers"]["subject"];

$GLOBALS['EMAIL_TO_ADDRESSES'] = array();
$GLOBALS['EMAIL_CC_ADDRESSES'] = array();

// In case there are more than one recipients
// $tos = preg_split("/,\s*/", $incomingmail["headers"]["to"]);
$tos = split_with_quotes($incomingmail["headers"]["to"], ",", "\"", "\\");
$ccs = split_with_quotes($incomingmail["headers"]["cc"], ",", "\"", "\\");

foreach ($tos AS $a1) {
	$a2 = ParseFormattedEmailAddress($a1);
	$GLOBALS['EMAIL_TO_ADDRESSES'][$a2['fromemail']] = $a2['fromname'];
}
foreach ($ccs AS $b1) {
	$b2 = ParseFormattedEmailAddress($b1);
	$GLOBALS['EMAIL_CC_ADDRESSES'][$b2['fromemail']] = $b2['fromname'];
}

$to = ParseFormattedEmailAddress($tos[0]);

$GLOBALS['EMAIL_TO_ADDRESS'] = $to['fromemail'];
$GLOBALS['EMAIL_TO_NAME'] = $to['fromname'];

$from = ParseFormattedEmailAddress($incomingmail["headers"]["from"]);
$GLOBALS['EMAIL_SENDER_ADDRESS'] = $from["fromemail"];
$GLOBALS['EMAIL_SENDER_NAME'] = $from["fromname"];

//DA($incomingmail["headers"]);

if ($runmodule > 0)
{
	//print "Run Module";
	RunModule($runmodule);
}
else
{
	//print "Process rules";
	ProcessRulesForAllTablesHavingRulesWithCondition("an e-mail is received");
}

EndHTML(false);

function InterleaveMimeParse($mime)
{
        $mail = array();
        $mail["headers"] = array(); //all headers are converted and returned as valid UTF-8
        $mail["body"] = array(); //bodies are not converted into another charset

        list($rawheaders, $mail["body"]) = preg_split("/\r?\n\r?\n/", $mime, 2);

        $header = "";
        foreach (preg_split("/\r?\n/", $rawheaders) as $rawheader)
        {
                //multiline header
                /*
                X-Spam-Status: No, score=-2.2 required=4.3 tests=ALL_TRUSTED,BAYES_00,
                        DKIM_SIGNED,DKIM_VALID,DKIM_VALID_AU,HTML_MESSAGE,MPART_ALT_DIFF,
                        TVD_SPACE_RATIO autolearn=no autolearn_force=no version=3.4.0
                */
                if (preg_match("/^\s+(.*)/", $rawheader, $match))
                {
                        $value = $match[1];
                        if ($header != "")
                        {
                                //invalid chars are removed (unlikely)
                                $mail["headers"][$header] .= " " . return_valid_utf8($value, "ASCII");
                        }
                        //else exception malformed
                }
                //Subject: test
                //TODO: support for multiple headers with same name (like "Received:")
                else if (preg_match("/^(.*?)\:\s*(.*)$/", $rawheader, $match))
                {
                        $header = strtolower($match[1]);
                        $value = $match[2];

                        //this header already exists, this probably only happens with multiple Received: headers
                        if (!empty($mail["headers"][$header]))
                        {
                                $x = 2;
                                //endless loop
                                while (true)
                                {
                                        //this is not very neat; creates headers like "received2" and "received3", better would be to modify this header to an array
                                        if (empty($mail["headers"][$header . $x]))
                                        {
                                                $header .= $x;
                                                break;
                                        }
                                        $x++;
                                }
                        }
                        //invalid chars are removed (unlikely)
                        $mail["headers"][$header] = return_valid_utf8($value, "ASCII");
                }
                //else exception malformed
        }

        //Content-Type: text/plain; charset=UTF-8; format=flowed
        //Content-Type: multipart/mixed; boundary="------------040700010005070501030207"
        //Content-Disposition: attachment; filename="bla.txt"
        $rfc2231_encoded_keys = array();
        //could these key=val; pairs OR rfc2231 be used in other headers as well?
        foreach (array("content-type", "content-disposition") as $header)
        {
                $parts = preg_split("/;\s*/", $mail["headers"][$header]);
                if ($parts[0] != "")
                {
                        $mail["headers"][$header] = $parts[0];
                        for ($x = 1; $x < count($parts); $x++)
                        {
                                //to remove double and single quotes
                                if (preg_match("/^(.*?)\=(\"|\')?(.*?)\\2?$/", $parts[$x], $match))
                                {
                                        $key = strtolower($match[1]);
                                        $val = $match[3];

                                        $rfc2231_encoded = false;
                                        $key = preg_replace("/\*$/", "", $key, -1, $count);
                                        if ($count == 1)
                                        {
                                                $rfc2231_encoded = true;
                                                //language and character set encoding
/*
Content-Disposition: attachment;
 filename*=UTF-8''%62%6C%C3%A0%2E%74%78%74
*/
                                        }

                                        $key = preg_replace("/\*\d$/", "", $key);
                                        //long string encoding, here combined with language and character set encoding
/*
Content-Disposition: attachment;
 filename*0*=UTF-8''%62%6C%61%20%6D%65%74%20%65%65%6E%20%62%6C%61%C3%A9%20;
 filename*1*=%62%69%6A%7A%6F%6E%64%65%72%20%6B%61%72%61%6B%74%65%72%20%77;
 filename*2*=%61%74%20%65%65%6E%20%72%61%72%65%20%66%69%6C%65%6E%61%6D%65;
 filename*3*=%20%7A%65%67%21%2E%74%78%74
*/

                                        $fullkey = $header . "|" . $key;

                                        if ($rfc2231_encoded)
                                        {
                                                $rfc2231_encoded_keys[$fullkey] = true;
                                        }

                                        if (empty($mail["headers"][$fullkey]))
                                        {
                                                $mail["headers"][$fullkey] = "";
                                        }
                                        $mail["headers"][$fullkey] .= $val;
                                }
                        }
                }
        }
        foreach (array_keys($rfc2231_encoded_keys) as $fullkey)
        {
                if (preg_match("/^(.*?)\'(.*?)\'(.*?)$/", $mail["headers"][$fullkey], $match))
                {
                        $charset = $match[1];
                        //$lang = $match[2];
                        $encoded = $match[3];
                        $mail["headers"][$fullkey] = return_valid_utf8(rawurldecode($encoded), $charset); //rawurldecode to not decode + signs to spaces
                }
                //else exception malformed
        }

        //these are the only fields containing encoded chars, right?
        //Subject: =?UTF-8?B?YcOg?=
        foreach (array("from", "to", "cc", "subject", "content-type|name") as $header)
        {
                if ($mail["headers"][$header] != "")
                {
                        //php's variable default_charset must be UTF-8 so iconv_mime_decode returns the string in UTF-8
                        $mail["headers"][$header] = return_valid_utf8(iconv_mime_decode($mail["headers"][$header]), "UTF-8");
                }
        }

        if ($mail["headers"]["content-transfer-encoding"] == "quoted-printable")
        {
                $mail["body"] = quoted_printable_decode($mail["body"]);
                //unset omdat de body niet langer gecodeerd is
                unset($mail["headers"]["content-transfer-encoding"]);
        }
        else if ($mail["headers"]["content-transfer-encoding"] == "base64")
        {
                $mail["body"] = base64_decode($mail["body"]);
                //unset omdat de body niet langer gecodeerd is
                unset($mail["headers"]["content-transfer-encoding"]);
        }
        //else exception 7bit, 8bit, what else?

        if (preg_match("/^multipart\//", $mail["headers"]["content-type"]))
        {
                //parts start with --$boundary, the last part ends with --$boundary--
                $parts = preg_split("/^--" . preg_quote($mail["headers"]["content-type|boundary"]) . "(\-\-)?$/m", $mail["body"]);

                //to save memory
                unset($mail["body"]);

                //the first part contains "This is a multi-part message in MIME format." -> which we ignore
                //the last part is empty -> which we ignore
                for ($x = 1; $x < count($parts) - 1; $x++)
                {
                        //recursive call for next part
                        $mail["part" . $x] = InterleaveMimeParse($parts[$x]);
                }
        }

        return $mail;
}

?>
