<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This script generates RTF entity reports (NOT Reports!)
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */

require_once "initiate.php";

$start_time = date('U');

if ($_REQUEST['template'] && isset($_REQUEST['attach_to_dossier']) && isset($_REQUEST['attach_to_entity']) && $_REQUEST['FlexTableRecord']) {

	if ($_REQUEST['FlexTable'] && $_REQUEST['FlexTableRecord']) {
		if (CheckTableRecordAccess("t" . $_REQUEST['FlexTable'], $_REQUEST['FlexTableRecord']) == "nok") {
			PrintAD("You don't have access to this flextable record");
			EndHTML();
			exit;
		}
	}



		$template_id = $_REQUEST['template'];
		$templatetype = GetTemplateType($_REQUEST['template']);
		$template = GetTemplate($_REQUEST['template']);


		$fn = GetTemplateName($_REQUEST['template']);
		$tmp_fn = explode(".", $fn);
		$ext = "." . strtolower($tmp_fn[(count($tmp_fn) -1)]);
		$ct = "";
		$filename = "";

		if ($ext == ".rtf") {

			$filename = str_replace(" ", "_", str_replace(".rtf","",GetTemplateName($_REQUEST['template'])) . "-" . date("Fj-Y-Hi") . "h.rtf");
			$ct = "Application/RTF";
			$rtf = true;
			$template = ParseTemplateGeneric   ($template);

			if ($_REQUEST['FlexTable'] && $_REQUEST['FlexTableRecord']) {
				$template = ParseTemplateRecordData($template, "t" . $_REQUEST['FlexTable'], $_REQUEST['FlexTableRecord']);
				qlog(INFO, "HH Parsed it");
			}
			$template = unescape_interleave_characters($template);

		} elseif ($ext != ".xlsm" && $ext != ".xlsx" && $ext != ".docx" && $ext != ".odt" && $ext != ".ods") {

			$raw = "";
			if ($templatetype == "TEMPLATE_REPORT_PDF" || $templatetype == "TEMPLATE_PLAIN") {
				$fn = GetAttribute("template", "FormatNumbers", $template_id);
				if ($fn == "Yes") {
				} else {
					$raw = "dontformatnumbers";
				}
			}

			$template = ReturnTemplateStyleSheet($_REQUEST['template']) . $template;
			$filename = str_replace(" ", "_", GetTemplateName($_REQUEST['template']));

			$template = ParseTemplateGeneric($template);

			if ($_REQUEST['FlexTable'] && $_REQUEST['FlexTableRecord']) {
				$template = ParseTemplateRecordData($template, "t" . $_REQUEST['FlexTable'], $_REQUEST['FlexTableRecord']);
				qlog(INFO, "HH Parsed it");
			}

			if (substr($filename, strlen($filename) - 4, 4) == ".xml" || $raw == "dontformatnumbers") {

				$ct = "Application/XML";
				$GLOBALS['DONTFORMATNUMBERS'] = true;

			} else {

				$ct = "Application/Unknown";

			}
			$template = unescape_interleave_characters($template);

		} else {
			$template = ParseZippedContent($_REQUEST['template'], 0, 0, $_REQUEST['FlexTable'], $_REQUEST['FlexTableRecord']);
			$filename = $fn;
		}

		header("Content-Type: " . $ct);
		header("Content-Disposition: attachment; filename=" . str_replace(" ", "_", $filename));
		header("Content-Description: Interleave Generated Data");
		header("Window-target: _top");
		print $template;


} else {

	ShowHeaders();

	print "<form id='SingleReport' method='post' action=''>";

	print "<input type='hidden' name='attach_to_dossier' value='n'>";
	print "<input type='hidden' name='attach_to_entity' value='n'>";
	print "<input type='hidden' name='FlexTableRecord' value='" . htme($_REQUEST['FlexTableRecord']) . "'>";
	print "<input type='hidden' name='FlexTable' value='" . htme($_REQUEST['FlexTable']) . "'>";
	print "<select name='template'>";
	$sql = "SELECT templateid,templatename FROM CRMtemplates WHERE (templatetype='TEMPLATE_REPORT' OR templatetype='TEMPLATE_PLAIN') ORDER BY templatename";
	foreach (db_GetArray($sql) as $row) {
		if (CheckTemplateAccess($row['templateid']) == "ok") {
			$ins = "";
			if ($_REQUEST['template']==$row['templateid']) {
				$ins = "selected";
			}
			print "<option " . $ins . " value='" . $row['templateid'] ."'>" . htme($row['templatename']) . "</option>";
		}
	}
	print "</select> ";
	print "<input type='button' value='" . $lang['go'] . "' onclick='doso();'></form>";
		?>
		<script type="text/javascript">
		<!--
		function doso() {
			WhosMyDaddy().window.location.href="entityreport.php?template=" + document.forms['SingleReport'].elements['template'].value + "&attach_to_dossier=" + document.forms['SingleReport'].elements['attach_to_dossier'].value + "&attach_to_entity=" + document.forms['SingleReport'].elements['attach_to_entity'].value + "&FlexTable=" + document.forms['SingleReport'].elements['FlexTable'].value + "&FlexTableRecord=" + document.forms['SingleReport'].elements['FlexTableRecord'].value ;
			CloseMe();
			window.close();

		}
		//-->
		</script>
		<?php
	EndHTML();
}
?>
