<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file does several things :)
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */
require_once "initiate.php";

// This script handles editing of fields

MustBeAdmin();
$GLOBALS["InAdminSection"] = true;
ShowHeaders();


if (!is_administrator()) {

	PrintAD("Access to this page/function denied.");
}
else
{
	if ($_REQUEST['editextrafield'] > 0) {
		$_REQUEST['tabletype'] = GetExtraFieldTableType($_REQUEST['editextrafield']);
	}

	$tabletype = $_REQUEST['tabletype'];

	$availtables = array();
	$availtables["All"] = "extrafields.php?tabletype=all";

	foreach (db_GetFlatArray("SELECT recordid FROM CRMflextabledefs ORDER BY recordid") as $ft)
	{
			$availtables["t" . $ft] = "extrafields.php?tabletype=" . $ft;
	}
	$availtables["users"] = "extrafields.php?tabletype=user";
	$availtables["groups"] = "extrafields.php?tabletype=group";
	$availtables["files"] = "extrafields.php?tabletype=files";

	print "<table class='split'><tr><td class='nwrp'>";
	print "<form method='get' action=''><span class=\"fa fa-search search_img\"></span><input class='search_input' type='search' onchange=\"this.form.submit();\" name='fssearch' value='" . htme($_REQUEST['fssearch']) . "' placeholder=\"Search\"></form>";

	$sres = array();
	if ($_REQUEST['fssearch'] != "" || $_REQUEST['fssearchtype'] != "")
	{

		$sres = db_GetArray("SELECT id, name, tabletype, tablename, fieldtype FROM CRMextrafields LEFT JOIN CRMflextabledefs ON (tabletype=recordid) WHERE (fieldtype LIKE '%" . mres($_REQUEST['fssearch']) . "%' OR options LIKE '%" . mres($_REQUEST['fssearch']) . "%' OR name LIKE '%" . mres($_REQUEST['fssearch']) . "%' OR remarks LIKE '%" . mres($_REQUEST['fssearch']) . "%' OR calculation LIKE '%" . mres($_REQUEST['fssearch']) . "%' OR id='" . mres($_REQUEST['fssearch']) . "') AND deleted='n' ORDER BY CRMextrafields.ordering");

		if (count($sres) == 1 && !$_REQUEST['editextrafield'])
		{
			$_REQUEST['editextrafield'] = $sres[0]['id'];
			$_REQUEST['tabletype'] = $sres[0]['tabletype'];
		}
		elseif (count($sres) == 0)
		{
			print "<div>No fields found matching criteria</div>";
		}
	}


	$sresdiv = db_GetArray("SELECT id, name, tabletype, tablename, fieldtype, CRMextrafields.ordering FROM CRMextrafields LEFT JOIN CRMflextabledefs ON (tabletype=recordid OR recordid IS NULL) WHERE deleted='n' ORDER BY `CRMextrafields`.`ordering`");

	print "<ul class='normal'>";
	foreach ($availtables AS $dstablename => $link)
	{
		print "<li>";
		$name = $GLOBALS['UC']['PersonalDataStructure'][$dstablename]["plural"];
		if ($dstablename == "All")
		{
			$name = "All";
			$dstablename = "";
		}

		$type_in_efid_table = $dstablename;
		if (preg_match("/^t(\d+)$/", $dstablename, $match))
		{
			$type_in_efid_table = $match[1];
		}
		else if ($dstablename == "users")
		{
			$type_in_efid_table = "user";
		}
		else if ($dstablename == "groups")
		{
			$type_in_efid_table = "group";
		}

		if ($name != "All") {
			print '<a onclick="plusminusexpand(\'fields' . $dstablename . '\', this)"><span class="fa fa-plus-square-o"></span></a>&nbsp;&nbsp;';

			print $dstablename . " ";
		}
		print "<a href='" . $link . "'>" . htme($name) . "</a>";
		if ($name != "All") {
			print " [<a href='" . $link . "&amp;editextrafield=new'>new</a>] [<a href=\"list.php?table=" . $dstablename . "&amp;listid=" . $dstablename . "efidpage&amp;listlayoutcolumns=allfieldsthistable\">show</a>]";
		}

		$nf = false;
		foreach ($sres AS $res)
		{
			if ($res['tabletype'] == $type_in_efid_table)
			{
				if (!$nf)
				{
					print "<ul>";
				}
				$nf = true;
				if ($res['id'] == $_REQUEST['editextrafield'])
				{
						print "<li>f" . $res['id'] . " " . htme($res['name']) . " (" . $res['ordering'] .")</li>";
				}
				else
				{
					$link = "extrafields.php?editextrafield=" . $res['id'] . "&amp;tabletype=" . $res['tabletype'] . "&amp;fssearch=" . htme($_REQUEST['fssearch']) . "&amp;fssearchtype=" . htme($_REQUEST['fssearchtype']);
					print "<li>f" . $res['id'] . " <a href='" . $link . "'>" . htme($res['name']) . " (" . $res['ordering'] .")</a></li>";
				}
			}
		}
		if ($nf)
		{
			print "</ul>";
		}

		$nf = false;
		foreach ($sresdiv AS $res)
		{
			if ($res['tabletype'] == $type_in_efid_table)
			{
				$disp = "none";
				if (($_REQUEST['tabletype'] == $res['tabletype'] && (!$_REQUEST['fssearch'] && !$_REQUEST['fssearchtype'])))
				{
					$disp = "block";
				}
				if (!$nf)
				{
//					print "<div id='f". $dstablename . "div' style='display: " . $disp . ";'><ul>";
					print '<ul id="fields' . $dstablename . '" style="display: ' . $disp . ';">';
				}
				$nf = true;
				$link = "extrafields.php?editextrafield=" . $res['id'] . "&amp;tabletype=" . $res['tabletype'] . "&amp;fssearch=" . htme($_REQUEST['fssearch']) . "&amp;fssearchtype=" . htme($_REQUEST['fssearchtype']);
				print "<li>f" . $res['id'] . " <a href='" . $link . "'>" . $res['name'] . " (" . $res['ordering'] .")</a></li>";
			}
		}
		if ($nf)
		{
			print "</ul>";
		}

		print "</li>";
	}
	print "</ul></td><td>";

	$fieldtypes = GetFieldTypes();

	natcasesort($fieldtypes);

	$profs = GetUserProfiles();
	foreach ($profs AS $profilearray)
	{
		array_push($fieldtypes, array("User-list of all users in group " . $profilearray[1], "Users of profile " . $profilearray[0]));
	}

	if ($_REQUEST['tabletype'])
	{
		$tname = "";
		if (is_numeric($_REQUEST['tabletype']))
		{
			$tname = GetFlexTableNames($_REQUEST['tabletype']);
			$tname = $tname[0];
		}
		else
		{
			$tname = $_REQUEST['tabletype'];
		}


	if ($_REQUEST['submitted'] && $_REQUEST['tabletype'])
	{
		$arr1 = explode("\n", trim($_REQUEST['newoption']));
		$arr = array();

		foreach ($arr1 AS $arrfield)
		{
			if ($arrfield <> "")
			{
				array_push($arr, trim($arrfield));
			}
		}

		if ($arr[0] != "" && $arr[1] == "")
		{
			$arr = explode(";", $arr[0]);
		}
		$options = serialize($arr);

		$dontgo = false;
		if ($_REQUEST['newtype'] == "drop-down" || $_REQUEST['newtype'] == "VAT drop-down" || $_REQUEST['newtype'] == "drop-down (multiselect)")
		{
			if (sizeof($arr)==0)
			{
				$dontgo = true;
			}
		}

		if ($_REQUEST['newtype'] == "text area")
		{
			$_REQUEST['options'] = $_REQUEST['boxsize1'] . ":" . $_REQUEST['boxsize2'] . ":" . $_REQUEST['ShowTimeDateInputClockThingy'];
			$options = $_REQUEST['options'];
		}


		if ($_REQUEST['newtype'] == "text area (rich text)")
		{
			$_REQUEST['options'] = $_REQUEST['boxsize3'] . ":" . $_REQUEST['boxsize4'] . ":" . $_REQUEST['ShowTimeDateInputClockThingy'];
			$options = $_REQUEST['options'];
		}



		if ($_REQUEST['newtype'] == "drop-down (populate by code)")
		{
			$_REQUEST['newtype'] = "drop-down";
			$options = "%POPULATE_BY_CODE%" . $_REQUEST['computation'];
		}

		if ($_REQUEST['newtype'] == "drop-down (populate by code multiselect)")
		{
			$_REQUEST['newtype'] = "drop-down (multiselect)";
			$options = "%POPULATE_BY_CODE%" . $_REQUEST['computation'];
		}

		if ($_REQUEST['newtype'] == "comment")
		{
			$options = $_REQUEST['newHTMLtemplate'];

		}


		if ($_REQUEST['newtype'] == "checkbox")
		{
			$_REQUEST['defaultval'] = $_REQUEST['cb_unchecked'];
			$options = $_REQUEST['cb_checked'];

		}

		if ($_REQUEST['SQLQUERY'] && ($_REQUEST['newtype'] == "SQL Query" || $_REQUEST['newtype'] == "SQL Query (multiselect)"))
		{
			$options = serialize(array($_REQUEST['SQLQUERYDB'],$_REQUEST['SQLQUERY']));
		}


		$israw = "n";
		if ($_REQUEST['IsRawHTML'] == "IsRawHTML")
		{
			$israw = "y";
		}

		if ($_REQUEST['defaultval'] && $_REQUEST['newtype'] == "drop-down (multiselect)")
		{
			$tmp = $_REQUEST['defaultval'];
			$_REQUEST['defaultval'] = array();
			array_push($_REQUEST['defaultval'], base64_encode($tmp));
			$_REQUEST['defaultval'] = serialize($_REQUEST['defaultval']);
		}

		if ($_REQUEST['showasradio'] != "y") $_REQUEST['showasradio'] = "n";

		if ($_REQUEST['newtype'] == "Reference to FlexTable" || $_REQUEST['newtype'] == "Reference to FlexTable (multiselect)")
		{
			if ($_REQUEST['dontshowFTpopup'] != "y") $_REQUEST['dontshowFTpopup'] = "n";
			$_REQUEST['sortwhendisplayed'] = $_REQUEST['dontshowFTpopup'];
			$options = $_REQUEST['FlexTableReference'];
		}

		if ($_REQUEST['excludefromfilters'] != "y") { $_REQUEST['excludefromfilters'] = "n"; }
		if ($_REQUEST['underwaterfield'] != "y") { $_REQUEST['underwaterfield'] = "n"; }
		if ($_REQUEST['sum_column'] != "yes") { $_REQUEST['sum_column'] = "no"; }
		if ($_REQUEST['log_stats'] != "y") { $_REQUEST['log_stats'] = "n"; }




		if ($dontgo <> true) {
			if ($_REQUEST['editextrafield'] == "new") {

				if ($_REQUEST['newtype'] != "") {

					$ordering = db_GetValue("SELECT MAX(ordering) FROM CRMextrafields WHERE tabletype='" . mres($_REQUEST['tabletype']) . "'") + 100;


					$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,excludefromfilters,defaultval,sort,size,showsearchbox,remarks,timestamp_last_change,showasradio,displaylistname,underwaterfield,sum_column,number_format,log_stats,calculation,calculation_type) VALUES ('" . mres($options) . "','" . mres($_REQUEST['newname']) . "','" . $ordering . "','" . mres($_REQUEST['newtype']) . "','" . mres($_REQUEST['tabletype']) . "','" . mres($_REQUEST['forcing']) . "','" . mres($_REQUEST['excludefromfilters']) . "','" . mres($_REQUEST['defaultval']) . "','" . mres($_REQUEST['sortwhendisplayed']) . "','" . mres($_REQUEST['boxsize']) . "','" . mres($_REQUEST['showsearchbox']) . "','" . mres($_REQUEST['fieldremarks']) . "', NOW(), '" . mres($_REQUEST['showasradio']) . "','" . mres($_REQUEST['newdisplaylistname']) . "','" . mres($_REQUEST['underwaterfield']) . "','" . mres($_REQUEST['sum_column']) . "','" . mres($_REQUEST['number_format']) . "','" . mres($_REQUEST['log_stats']) . "','" . mres(trim($_REQUEST['calculation'])) . "','" . mres($_REQUEST['calculation_type']) . "')";
					mcq($sql);

					$new_field_name = db_GetInsertId();
					$_REQUEST['editextrafield'] = $new_field_name;
					CheckAndSetAttributes($new_field_name, $_REQUEST['newtype'], true);

					print "<div class=\"okmsg\">Field <a href=\"extrafields.php?editextrafield=" . $new_field_name . "\">" . $new_field_name . ": " . htme($_REQUEST['newname'])  . "</a> created.</div>";

					$number_of_access_restrictions_for_fields_in_this_table = db_GetValue("SELECT COUNT(*) FROM CRMextrafields, CRMfieldaccessrules WHERE CRMextrafields.tabletype='" . mres($_REQUEST['tabletype']) . "' AND CRMextrafields.id=CRMfieldaccessrules.field");
					if ($number_of_access_restrictions_for_fields_in_this_table > 0)
					{
						print '<div class="warnmsg">Other fields in this table have access restrictions. For this reason, this newly created field is accessible only for administrators. <a onclick="PopRightsChooser(' . $new_field_name . ');">Change this here</a>.</div>';
						mcq("INSERT INTO CRMfieldaccessrules (field) VALUES(" . $new_field_name . ")");
					}

					AdminChangesDropCache();

					$ds_tablename = GetExtraFieldTableType($new_field_name);
					$tabletype = $ds_tablename;
					if (is_numeric($ds_tablename)) $ds_tablename = "t" . $ds_tablename;


					print "<h1>" . GetAlterQueryBasedOnFieldType("f" . $new_field_name, $ds_tablename, $_REQUEST['newtype'], "auto", "mysql", $_REQUEST['newname']) . "</h1>";
					mcq(GetAlterQueryBasedOnFieldType("f" . $new_field_name, $ds_tablename, $_REQUEST['newtype'], "auto", "mysql", $_REQUEST['newname']));

					if (is_numeric($tabletype)) {
						$table = "CRMflextable" . $tabletype;
						if ($_REQUEST['defaultval'])
						{
							mcq("UPDATE " . $table . " SET timestamp_last_change=timestamp_last_change, EFID" . $new_field_name . "='" . mres($_REQUEST['defaultval']) . "'");
						}
					//jeroen 2014-12-15: waarom?
					} elseif (($tabletype == "user") || ($tabletype == "loginusers")) {

						$table = "CRMloginusers";
						if ($_REQUEST['defaultval'])
						{
							mcq("UPDATE " . $table . " SET timestamp_last_change=timestamp_last_change, EFID" . $new_field_name . "='" . mres($_REQUEST['defaultval']) . "'");
						}
					} elseif (($tabletype == "group") || ($tabletype == "userprofiles")) {
						$table = "CRMuserprofiles";
						if ($_REQUEST['defaultval'])
						{
							mcq("UPDATE " . $table . " SET timestamp_last_change=timestamp_last_change, EFID" . $new_field_name . "='" . mres($_REQUEST['defaultval']) . "'");
						}
					} elseif ($tabletype == "files") {

						$table = "CRMbinfiles";
						if ($_REQUEST['defaultval'])
						{
							mcq("UPDATE " . $table . " SET timestamp_last_change=timestamp_last_change, EFID" . $new_field_name . "='" . mres($_REQUEST['defaultval']) . "'");
						}

					} else {
						PrintAD("Wrong table type (". $tabletype . "). Quitting.");
						EndHTML();
						exit;
					}

					if (GetSetting("DevelopmentOrProduction") == "Development") {
						SetAttribute("system", "TriggerQueriesForDeploy", return_mysql_trigger_queries(true, true, true), 1, false);
					}
					$triggers = return_mysql_trigger_queries();
					foreach ($triggers AS $sql) {

						mcq($sql);
					}

					if ($_REQUEST['calculation'] != '') {
						print '<pre>';
						recalc_calculations("f" . $_REQUEST['editextrafield'], true, false);
						print '</pre>';
					}
				} else {
					print '<div class="errmsg">You didn\'t select a field type. Field not saved.</div>';
				}
			} else {

				$ef = db_GetRow("SELECT * FROM CRMextrafields WHERE id='" . mres($_REQUEST['editextrafield']) . "'");

				$sql = "UPDATE CRMextrafields SET options='" . mres($options) . "', name='" . mres($_REQUEST['newname']) . "', ordering='" . mres($_REQUEST['neworder']) . "', fieldtype='" . mres($_REQUEST['newtype']) . "', forcing='" . mres($_REQUEST['forcing']) . "',excludefromfilters='" . mres($_REQUEST['excludefromfilters']) . "', defaultval='" . mres($_REQUEST['defaultval']) . "', sort='" . mres($_REQUEST['sortwhendisplayed']) . "', size='" . mres($_REQUEST['boxsize']) . "', showsearchbox='" . mres($_REQUEST['showsearchbox']) . "',showasradio='" . mres($_REQUEST['showasradio']) . "',israwhtml='" . $israw . "', remarks='" . mres($_REQUEST['fieldremarks']) . "',displaylistname='" . mres($_REQUEST['newdisplaylistname']) . "',underwaterfield='" . mres($_REQUEST['underwaterfield']) . "', timestamp_last_change=NOW(), sum_column='" . mres($_REQUEST['sum_column']) . "',number_format='" . mres($_REQUEST['number_format']) . "',log_stats='" . mres($_REQUEST['log_stats']) . "', calculation='" . mres(trim($_REQUEST['calculation'])) . "', calculation_type='" . mres($_REQUEST['calculation_type']) . "' WHERE id='" . mres($_REQUEST['editextrafield']) . "'";
				mcq($sql);
				print '<div>' . htme($sql) . '</div>';
				CheckAndSetAttributes($_REQUEST['editextrafield'], $_REQUEST['newtype'], false);
				AdminChangesDropCache();

				$change_query = GetAlterQueryBasedOnFieldType("f" . $_REQUEST['editextrafield'], get_ds_tablename_for_field($_REQUEST['editextrafield']), $_REQUEST['newtype'], "auto", "mysql", $_REQUEST['newname']);

				if ($change_query != "SELECT 1+1") print '<pre>' . date('r') . ": " . htme($change_query) . '</pre>';

				mcq($change_query);

				if (GetSetting("DevelopmentOrProduction") == "Development") {
					SetAttribute("system", "TriggerQueriesForDeploy", return_mysql_trigger_queries(true, true, true), 1, false);
				}
				$triggers = return_mysql_trigger_queries();
				foreach ($triggers AS $sql) {
					mcq($sql);
				//	print $sql;
				}

//				if ($_REQUEST['calculation'] != $ef['calculation']) {
				if ($ef['calculation'] != "") {
					print '<pre>';
					recalc_calculations("f" . $_REQUEST['editextrafield'], true, false);
					print '</pre>';
				}

				if ($_REQUEST['defaultval'] && !strstr($_REQUEST['defaultval'], "<?")  && count(get_tags($_REQUEST['defaultval'])) == 0)
				{
					// A default value was added, so we have to create this field for all records. If we don't, stats will suffer.

					if (is_numeric($tabletype))
					{
						$table = "CRMflextable" . $tabletype;
						mcq("UPDATE " . $table . " SET EFID" . mres($_REQUEST['editextrafield']) . "='" . mres($_REQUEST['defaultval']) . "',timestamp_last_change=timestamp_last_change WHERE EFID" . $_REQUEST['editextrafield'] . "=''");
						print "Default values created<br>";
					}
					//jeroen 2014-12-15: waarom?
					elseif (($tabletype == "user") || ($tabletype == "loginusers"))
					{
						$table = "CRMloginusers";
						mcq("UPDATE " . $table . " SET EFID" . $_REQUEST['editextrafield']. "='" . mres($_REQUEST['defaultval']) . "',timestamp_last_change=timestamp_last_change  WHERE EFID" . $_REQUEST['editextrafield'] . "=''");
						print "Default values created<br>";
					}
					elseif (($tabletype == "group") || ($tabletype == "userprofiles"))
					{
						$table = "CRMuserprofiles";
						mcq("UPDATE " . $table . " SET EFID" . $_REQUEST['editextrafield']. "='" . mres($_REQUEST['defaultval']) . "',timestamp_last_change=timestamp_last_change  WHERE EFID" . $_REQUEST['editextrafield'] . "=''");
						print "Default values created<br>";
					}
					elseif ($tabletype == "files")
					{
						$table = "CRMbinfiles";
						mcq("UPDATE " . $table . " SET EFID" . $_REQUEST['editextrafield']. "='" . mres($_REQUEST['defaultval']) . "',timestamp_last_change=timestamp_last_change  WHERE EFID" . $_REQUEST['editextrafield'] . "=''");
						print "Default values created<br>";
					}

					else
					{
						PrintAD("Wrong table type (" . $tabletype . "). Quitting.");
						exit;
					}

				} else {
					print "<div class=\"warnmsg\">Default values NOT created because the value contains PHP or tags.</div>";
				}
			}
		}
		else
		{
			?>
				<script type="text/javascript">
				<!--
					alert('A drop-down box must have options! Field is not saved.');
				//-->
				</script>
			<?php
		}

		if (ipi($_REQUEST['copyfrom'])) {

				$sql = "DELETE FROM CRMfieldaccessrules WHERE `field` = '" . mres($_REQUEST['editextrafield']) . "'";
				mcq($sql);

				/* copy access rights from another field */
				$sql = "INSERT INTO CRMfieldaccessrules(`field`, `group`, `read`, `write`) SELECT '" . mres($_REQUEST['editextrafield']) . "', `group`, `read`, `write` FROM CRMfieldaccessrules WHERE `field`='" . mres($_REQUEST['copyfrom']) . "'";
				mcq($sql);

				$sql = "DELETE FROM CRMextendedprivsgroup WHERE `field` = '" . mres($_REQUEST['editextrafield']) . "'";
				mcq($sql);

				$sql = "INSERT INTO CRMextendedprivsgroup(`groupid`, `field`, `value`, `rule`, `operand`, `visual_only`) SELECT `groupid`, '" . mres($_REQUEST['editextrafield']) . "', `value`, `rule`, `operand`, `visual_only` FROM CRMextendedprivsgroup WHERE `field`='" . mres($_REQUEST['copyfrom']) . "'";
				mcq($sql);

                $sql = "DELETE FROM CRMextendedprivsgroup WHERE `only_apply_for_field` = '" . mres($_REQUEST['editextrafield']) . "'";
				mcq($sql);

				$sql = "INSERT INTO CRMextendedprivsgroup(`groupid`, `only_apply_for_field`, `value`, `rule`, `operand`, `field`, `visual_only`) SELECT `groupid`, '" . mres($_REQUEST['editextrafield']) . "', `value`, `rule`, `operand`, `field`, `visual_only` FROM CRMextendedprivsgroup WHERE `only_apply_for_field`='" . mres($_REQUEST['copyfrom']) . "'";
				mcq($sql);

				$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "alert('Access rules, group rules and required conditions were copied when creating this field.');";
			}


			if ($_REQUEST['fromlist'] != "") {
				print '<script type="text/javascript">window.location.href=\'' . jsencode(base64_decode($_REQUEST['fromlist'])) . '\';</script>';
			}
	}


	if ($_REQUEST['editextrafield'])
	{
		$sql = "SELECT * FROM CRMextrafields WHERE id='" . mres($_REQUEST['editextrafield']) . "'";
		$row = db_GetRow($sql);

		$ds_tablename = GetExtraFieldTableType($row['id']);
		$tabletype = $ds_tablename;
		$db_tablename  = $ds_tablename;
		if (is_numeric($db_tablename)) $db_tablename = "flextable" . $db_tablename;
		if (is_numeric($ds_tablename)) $ds_tablename = "t" . $ds_tablename;

		if ($_GET['converdatetoiso'] == 1 && $row['fieldtype'] == "date") {
			print '<h1>Convert to ISO</h1>';

			//if a trigger exists for this field it will crash during this update
			disable_mysql_triggers();
			mcq("UPDATE CRM" . $db_tablename . " SET timestamp_last_change = timestamp_last_change, EFID" . $row['id'] . "=IF(EFID" . $row['id'] . "='','0000-00-00',STR_TO_DATE(EFID" . $row['id'] . ", '%d-%m-%Y'))");
			mcq(GetAlterQueryBasedOnFieldType("f" . $row['id'], $ds_tablename, "date (iso)", "auto", "mysql", $row['name']));
			mcq("UPDATE CRMextrafields SET fieldtype='date (iso)' WHERE id='" . $row['id'] . "'");
			AdminChangesDropCache();
			enable_mysql_triggers();
			print Alert("Warning: check you modules and triggers; the default value of this field is now 0000-00-00 instead of empty!");
			print JS("window.location.href='extrafields.php?editextrafield=" . $row['id'] . "';");

		} elseif ($_GET['convert_diary_to_flextable'] == 1) {
			convert_diary_to_flextable($row['id']);

			//print JS("window.location.href='extrafields.php?editextrafield=" . htme($row['id']) . "';");
		}


		if (strstr($row['options'], "%POPULATE_BY_CODE%") && $row['fieldtype'] == "drop-down")
		{
			$row['fieldtype'] = "drop-down (populate by code)";
			$row['options'] = str_replace("%POPULATE_BY_CODE%", "", $row['options']);
		}
		elseif (strstr($row['options'], "%POPULATE_BY_CODE%") && $row['fieldtype'] == "drop-down (multiselect)")
		{
			$row['fieldtype'] = "drop-down (populate by code multiselect)";
			$row['options'] = str_replace("%POPULATE_BY_CODE%", "", $row['options']);
		}



		print familytree("fields", $row['id'], $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
		if ($_REQUEST['editextrafield'] != "new") {
			print "<h1>Field " . $tname . " f" . $row['id'] . ": " . htme($row['name']) . "</h1>";
			if (ipi($_REQUEST['tabletype'])) {
				print '<input type="text" name="dummy" value="t' . htme($_REQUEST['tabletype']) . '-f' . $row['id'] . '">';
			}
//			print "<h2>Last update: " . $row['timestamp_last_change'] . "</h2>";
		} else {
			print "<h1>New field for table " . $tname . "</h1>";
		}

		print "<form id='EditField' method='post' action=''>";

		print "<div>";
		print "<input name='submitted' type='submit' value='Save'> ";
		if ($_REQUEST['editextrafield'] != "new") {
			print AttributeLink("extrafield", $row['id'], "Attributes", "", true) . " ";
			if ($row['fieldtype'] == "drop-down" || $row['fieldtype'] == 'textbox') {
				print "<input type=\"button\" value=\"Group comparison\" onclick=\"PopFancyBoxExtraLarge('Group comparison', 'listadmin.php?groupcomparison=1&amp;nonavbar=1&amp;field=f" . $row['id'] . "');\"> <input type=\"button\" value=\"Normalize to table\" onclick=\"PopFancyBox('Normalize', 'admin.php?nonavbar=1&amp;normalize=" . $row['id'] . "');\"> ";
			} elseif ($row['fieldtype'] == "date") {
				print "<input type=\"button\" value=\"Convert to ISO date\" onclick=\"if (confirm('Sure?')) { window.location.href='extrafields.php?editextrafield=" . $row['id'] . "&amp;converdatetoiso=1'; } else { return(false); }\"> ";
			} elseif ($row['fieldtype'] == "diary") {
				print "<input type=\"button\" value=\"Convert to table\" onclick=\"if (confirm('Sure?')) { window.location.href='extrafields.php?editextrafield=" . $row['id'] . "&amp;convert_diary_to_flextable=1'; } else { return(false); }\"> ";

			}

			print ' <a class="likebutton addbutton" onclick=\'PopFancyBoxLarge("", "flextable.php?createrules&amp;table=' . $ds_tablename . '&nonavbar=1");\'>Create rules</a>';
		}
		print "<input type='hidden' name='fromlist' value='" . htme($_REQUEST['fromlist']) . "'>";
		print "<table class='form-table'>";


		print "<tr><td>Field name</td><td>";
		print "<input type='text' name='newname' size='60' value=\"" . htme($row['name']) . "\">";
		if ($_REQUEST['editextrafield'] != "new") {
			if (db_GetValue("SELECT COUNT(DISTINCT(LANGID)) FROM CRMlanguages") > 1)
			{
				print '<br>';
				/* HF20160823 uitleg toegevoegd, er stond alleen "DLN", da's niet echt duidelijk */
				foreach (array("" => "", "DLN" => "list-name") as $tag => $exp)
				{
					print '<input onclick="ilor(\'record.php?table=languages&amp;record=&amp;languages-TEXTID=EFID' . $_REQUEST['editextrafield'] . $tag . '\',2,\'languagefield\',0)" value="New ' . $exp . ' language tag" type="button"> ';
				}
				$listoptions = array();
				$listoptions["table"] = "languages";
				$listoptions["listid"] = "languagefield";
				$listoptions["type_of_list"] = "sublist";
				$listoptions["hide_search"] = true;
				$listoptions["hide_filters"] = true;
				$listoptions["hide_header"] = true;
				$listoptions["hide_pagination_if_only_1_page"] = true;
				$listoptions["hide_recordcounter"] = true;
				$listoptions["hide_outputtype_excel"] = true;
				$listoptions["hide_perpage"] = true;
				$listoptions["hide_addlink"] = true;
				$listoptions["hide_tablewhennoresults"] = true;
				$listoptions["listlayoutcolumns"] = "languages-LANGID,languages-TEXTID,languages-TEXT";
				$listoptions["hiddenfilter"]["languages-TEXTID"][] = "EFID" . $_REQUEST['editextrafield'];
				$listoptions["hiddenfilter"]["languages-TEXTID"][] = "EFID" . $_REQUEST['editextrafield'] . "DLN";
				list($number_of_records, $output) = make_list($listoptions);
				print $output;
			}
		}
		print "</td></tr>";
		if ($_REQUEST['editextrafield'] != "anew") {
			print '<tr><td>Copy access rules from</td><td>';
			print '<select name="copyfrom" id="JS_copyfrom">';
			print '<option value="">Don\'t copy rules</option>';

			$currentfields = db_GetArray("SELECT id, name FROM CRMextrafields WHERE tabletype='" . mres($_REQUEST['tabletype']) . "' AND deleted='n'");
			foreach ($currentfields AS $field) {
				print '<option value="' . $field['id'] . '">' . $field['name'] . '</option>';
			}
			print '</select>';
			print '</td></tr>';

		}
		print "<tr><td>Field name in lists</td><td>";

		print "<input type='text' name='newdisplaylistname' size='60' value=\"" . htme($row['displaylistname']) . "\">";
		print "</td></tr>";

		print "<tr><td>Type</td><td>";
			print "<select name='newtype' id='JS_newtype' onchange=\"SetDivOpen();";

			print "\">";
			foreach ($fieldtypes AS $type) {
				$value = "";
				if (is_array($type)) {
					$value = $type[1];
					$tmp = $type[0];
					unset($type);
					$type = $tmp;
				} else {
					$value = $type;
				}
				$ins = "";
				if ($row['fieldtype'] == $type || $row['fieldtype'] == $value) {
					$ins = "selected";
				}
				if ($_REQUEST['editextrafield'] == "new" && $value =='date') {
				} else {
					print "<option " . $ins . " value='" . htme($value) . "'>" . $type . "</option>";
				}
			}
			print "</select>";
		//print ReturnDropDownSearchField("JS_newtype");
		print "</td></tr>";
		print "<tr><td>&nbsp;</td><td>&nbsp;";

		// Button DIV
		print "<div id='dd_button' class='HideElement'><table style='width: 100%;'>";
		print "<tr><td>After creating a button, use <a href='rules.php'>a button rule</a> to set actions to this button!<br><br>With buttons you can combine the advanced access rights possibilities of an<br>field with a form element. Other triggers will also go off when appropriate,<br>but the button trigger will always go last.<br><br>A button will <strong>always</strong> save the record!</td></tr>";
		print "</table></div>";

		print "<div id='flextableoptions' class='HideElement'><table style='width: 100%;'>";
		print "<tr><td>Refer to table</td><td><select name='FlexTableReference' id='JS_FlexTableReference'>";
		print "<option></option>"; //Jeroen 2010-04-19 minimaal 1 option required by xhtml
		$possible_tables = array();
		foreach (GetFlexTableDefinitions() as $ft)
		{
			$possible_tables[$ft["recordid"]] = $ft["tablename"];
		}
		foreach ($possible_tables as $key => $val)
		{
			$ins = "";
			if ($row['options'] == $key)
			{
				$ins = "selected";
			}
			print "<option " . $ins . " value='" . $key . "'>" . $key . ": " . htme($val) . "</option>";
		}
		print "</select> " . ReturnDropDownSearchField("JS_FlexTableReference") . " </td></tr>";

		$t = "";
		if ($row['sort'] == "y")
		{
			$t = "checked";
		}
		print "<tr><td>Select from table popup instead of drop-down <input " . $t . " type='checkbox' name='dontshowFTpopup' value='y'></td></tr>";
		print "</table>";
		print "</div>";

		print "<div id='ddoptions_CHECKBOX' class='HideElement'><table style='width: 100%;'>";

		if ($row['options'] == "") $row['options'] = "Yes";
		if ($_REQUEST['editextrafield'] != "new") {
			print "<tr><td><a onclick=\"PopEFDDColorChooser(" . $row['id'] . ",'" . $tabletype . "');\">Assign background colors/css classes to values</a></td></tr>";

		}
		if (GetAttribute("extrafield", "CheckBoxCheckedByDefault", $_REQUEST['editextrafield']) == "Yes") {
			print "<tr><td>Value when unchecked</td><td><input type='text' name='cb_checked' value='" . htme($row['options']) . "'></td></tr>";
			print "<tr><td>Value when checked</td><td><input type='text' name='cb_unchecked' value='" . htme($row['defaultval']) . "'></td></tr>";
		} else {
			print "<tr><td>Value when checked</td><td><input type='text' name='cb_checked' value='" . htme($row['options']) . "'></td></tr>";
			print "<tr><td>Value when unchecked</td><td><input type='text' name='cb_unchecked' value='" . htme($row['defaultval']) . "'></td></tr>";

		}

		print "</table></div>";

		if ($row['size'] == "")
		{
			if ($row['fieldtype'] == "numeric")
			{
				$row['size'] = 8;
			}
			else
			{
				$row['size'] = 50;
			}
		}

		print "<div id='sizeoptions' class='HideElement'><table style='width: 50%;'>";
		print "<tr><td>Size (in characters):&nbsp;&nbsp; <input size='2' type='text' name='boxsize' value='" . htme($row['size']) . "'></td></tr>";
		print "</table></div>";
		print "<div id='numericsumcolumnoptions' class='HideElement'></div><table style='width: 50%;'>";
		$checked = "";
		if ($row['sum_column'] == "yes") {
			$checked = "checked";
		}
		print "<tr><td><input size='2' " . $checked . " type='checkbox' name='sum_column' value='yes'>&nbsp;Add up this column below the list</td></tr>";
		print "<tr><td>Number format <select name='number_format'>";

		$options = array(

							"don't format"	=> "Don't format",
							"normal"		=> "2 decimals (default)",
							"currency"		=> "Currency (without sign)",
							"currency EUR"	=> "Currency &euro;",
							"currency DOL"	=> "Currency $",
							"currency BRP"	=> "Currency &pound;",
							"currency YEN"	=> "Currency &yen;",
							"no decimals"	=> "No decimals",
							"1 decimal"		=> "1 decimal",
							"3 decimals"		=> "3 decimals",
							"4 decimals"		=> "4 decimals",
							"5 decimals"		=> "5 decimals"

						);

		foreach ($options AS $value => $disp) {
			$checked = "";
			if ($row['number_format'] == $value) {
				$checked = " selected";
			}
			print "<option value='" . htme($value) . "' " . $checked . ">" . htme($disp) . "</option>";
		}

		print "</select></td></tr>";

		print "</table>";
		print "<div id='planning-options' class='HideElement'><table style='width: 50%;'>";
		print "<tr><td>Display method</td><td><select name='planoptions'>";
		print "<option value='icon/popup'>Icon/popup</option>";
		if ($row['options'] == "inline")
		{
			print "<option value='inline' selected>In-line</option>";
		}
		else
		{
			print "<option value='inline'>In-line</option>";
		}
		print "</select></td></tr>";

		print "</table></div>";
		print "<div id='sqlquery' class='HideElement'><table style='width: 50%;'>";
		$t = unserialize($row['options']);
		print "<tr><td>Database name:<br><input type='text' name='SQLQUERYDB' size='50' value='" . htme($t[0]) . "'><br>SQL Query: <textarea name='SQLQUERY' cols='100' rows='10'>" . htme($t[1]) . "</textarea><br><br>If the database is not on the same server, use DBNAME@HOSTNAME. The user specified in your config/config.inc.php must also have the rights to use the database you provide here. ";
		print "If your query returns 1 column, that column will be used for both value and text. When it returns two columns, the 1st column will be used as value, the second as text.</td></tr>";
		print "</table></div>";
		print "<div id='computation' class='HideElement'><table style='width: 50%;'>";
		$t = unserialize($row['options']);
		if ($row['options'] == "" || $row['options'] == "Yes")
		{
			$row['options'] = "\$result = ;";
		}


		print "<tr><td>Compute: (standard PHP syntax)<br><textarea name='computation' id='computationTA' cols='150' rows='25'>" . htme($row['options']) . "</textarea></td></tr>";

		print "</table></div>";

		print "<div id='sizeoptionstextarea' class='HideElement'><table style='width: 50%;'>";
		$sa = explode(":", $row['options']);

		if ($sa[0] == "Yes" || $sa[0] == "\$result = ;")
		{
			$sa[0] = "";
		}

		print "<tr><td>Number of columns (in characters)</td><td><input size='2' type='text' name='boxsize1' value='" . htme($sa[0]) . "'></td></tr>";
		print "<tr><td>Number of rows (in characters)</td><td><input size='2' type='text' name='boxsize2' value='" . htme($sa[1]) . "'></td></tr>";
		$ins1 = "";
		$ins2 = "";
		if ($sa[2] == "y")
		{
			$ins2 = "selected";
		}
		else
		{
			$ins1 = "selected";
		}
		print "<tr><td>Show insert date/time clock <span class=\"fa fa-clock-o\"></span></td><td><select name='ShowTimeDateInputClockThingy'><option value='y' " . $ins2 . ">Yes</option><option value='n' " . $ins1 . ">No</option></select></td></tr>";

		print "</table></div>";
		print "<div id='sizeoptionstextarea_rt' class='HideElement'><table style='width: 50%;'>";
		$sa = explode(":", $row['options']);
		$width = $sa[0];
		$height = $sa[1];
		if (!ipi($width))
		{
			$width = "";
		}
		if (!ipi($height))
		{
			$height = "";
		}

		print "<tr><td>Width </td><td><input size='4' type='text' name='boxsize3' value='" . htme($width) . "'> pixels / %</td></tr>";
		print "<tr><td>Height </td><td><input size='4' type='text' name='boxsize4' value='" . htme($height) . "'> pixels / %</td></tr>";

		print "</table></div>";
		print "<div id='ddoptions' class='HideElement'><table style='width: 100%;'>";

		print "<tr><td>Enter your options here (put every option on a new line): ";

		$tablename = "";
		if (is_numeric($tabletype))
		{
			$tablename = "flextable" . $tabletype;
		}
		else
		{
			if ($tabletype == "user") {
				$tablename = "loginusers";
			} elseif ($tabletype == "group") {
				$tablename = "userprofiles";
			} elseif ($tabletype == "files") {
				$tablename = "binfiles";
			}
		}
		$htmlisn = "";
		$vals = array();
		if ($tablename && $row['id'])
		{
			$count = db_GetValue("SELECT COUNT(*) FROM CRM" . $tablename);

			if ($count < 50000) {
				$vals = db_GetFlatArray("SELECT DISTINCT(EFID" . $row['id'] . ") FROM CRM" . $tablename . " ORDER BY EFID" . $row['id']. "");
			} else {
				$htmlisn = "[table too large - " . $count . " rows]";
			}
		}

		print "<input type='hidden' name='curvals' value='";
		$t = 0;
		$tmp = "";
		foreach ($vals AS $val)
		{
			$tmp .= htme($val) . "\n";
			$t++;
		}
		if ($htmlisn) {
			print $htmlisn;
		} elseif ($t>250)
		{
			print "[too many values: " . $t . " - max is 250]";
		}
		else
		{
			print $tmp;
		}

		print "'>";

		print "</td></tr>";
		print "<tr><td><textarea rows='10' cols='40' name='newoption'>";
		$arr = unserialize($row['options']);
		if (is_array($arr))
		{
			foreach ($arr AS $option)
			{
				print $option . "\n";
			}
		}

		print "</textarea><br><a onclick=\"document.forms['EditField'].elements['newoption'].value=document.forms['EditField'].elements['curvals'].value;\">Populate this based on the current values</a>";

		if ($row['fieldtype'] != "drop-down (multiselect)")
		{
			$t1 = "";

			if ($row['showasradio'] == 'y')
			{
				$t1 = "checked";
			}

			print "<tr title=\"When this option is enabled, a list of radio buttons will be shown instead of a drop-down field.\"><td><input " . $t1 . " type='checkbox' name='showasradio' value='y'>&nbsp;Display as set of radio buttons</td></tr>";

		}
		$t = "";
		if ($row['sort'] == 'y')
		{
			$t = "checked";
		}
		if ($row['fieldtype'] != "drop-down (multiselect)")
		{
		//jh 2015-06-27 deze doet niks meer, daarom verborgen
			print "<tr style=\"display: none;\"><td> <input " . $t . " type='checkbox' name='sortwhendisplayed' value='y'>&nbsp;Sort list alphabetically in forms</td></tr>";
		}
		print "</table></div>";
		// Show search box DIV

		print "<div id='dd_searchboxdiv' class='HideElement'><table style='width: 100%;'>";
		$tt = "";
		if ($row['showsearchbox'] == 'y')
		{
			$tt = "checked";
		}
		if ($row['fieldtype'] != "drop-down (multiselect)" && $row['fieldtype'] != "drop-down (populate by code multiselect)" && $row['fieldtype'] != "Reference to FlexTable (multiselect)" && $row['fieldtype'] != "SQL Query (multiselect)")
		{
			print "<tr><td><input " . $tt . " type='checkbox' name='showsearchbox' value='y'>&nbsp;Show a search box next to this drop-down field</td></tr>";
		}
		else
		{
			print "<tr><td><input " . $tt . " type='checkbox' name='showsearchbox' value='y'>&nbsp;Display as set of checkboxes</td></tr>";
		}
		print "</table>";
		print "</div>";
		if ($_REQUEST['editextrafield'] != "new") {
			print "<table><tr><td><a onclick=\"PopEFDDColorChooser(" . $row['id'] . ",'" . $tabletype . "');\">Assign background colors/css classes to values</a></td></tr></table>";
		}
		print "<div id='commentoptions' class='HideElement'><table style='width: 50%;'>";
		print "<tr><td>Select a template to display on this field location: <br><br><select name='newHTMLtemplate'>";
		$sql = "SELECT templateid, templatename, template_subject FROM CRMtemplates WHERE templatetype='TEMPLATE_HTML' AND version_belonging_to='0'";
		foreach (db_GetArray($sql) as $row2) {
			$tins = "";
			if ($row['options'] == $row2['templateid'])
			{
				$tins = "selected";
			}

			print "<option " . $tins . " value='" . $row2['templateid'] . "'>" . $row2['templatename'];
			if ($row2['template_subject'] <> "")
			{
				print " (" . $row2['template_subject'] . ")";
			}
			print "</option>";
		}
		print "</select></td></tr>";
		print "<tr><td><a onclick=\"window.open(this.href); return false;\" href='admin.php?templates=1'>Edit RTF and HTML templates in new window</a></td></tr>";
		print "</table></div>";
		print "</td></tr>";
		if ($_REQUEST['editextrafield']<>"new")
		{
			print "<tr><td>Order</td><td><input type='text' name='neworder' size='10' value='" . htme($row['ordering']) . "'>";
			print "</td></tr>";

			print "<tr><td>Configure access</td><td><a href='javascript:PopRightsChooser(" . $_REQUEST['editextrafield'] . ");'>select</a>&nbsp;&nbsp;";
			$num = db_GetValue("SELECT COUNT(*) FROM CRMfieldaccessrules WHERE field='" . mres($_REQUEST['editextrafield']) . "'");
			if ($num > 0)
			{
				print "<span class='warnmsg'>[" . $num . " set]</span>";
			}
			else
			{
				print "[none set]";
			}
			print "</td></tr>";
		}
		if ($_REQUEST['editextrafield'] != "new") {
			print "<tr><td>Custom validation</td><td>";
			print AttributeLink("extrafield", $_REQUEST['editextrafield'], "select", "CustomValidationFunctionPHP") . "&nbsp;&nbsp;";

			if ($_REQUEST['editextrafield']  == "new") {
				print "[none set, save first]";
			} else {
				$code = GetAttribute("extrafield", "CustomValidationFunctionPHP", $_REQUEST['editextrafield']);
				if ($code == "") {
					print "[none set]";
				} else {
					print "<span class='warnmsg'>[set]</span>";
				}

			}

			/* users with edit-fields rights don't have these tables in their DS */
			if (is_administrator()) {
				$listoptions = array();
				$listoptions["table"] = "extendedprivsgroup";
				$listoptions["type_of_list"] = "sublist";
				$listoptions["hide_header"] = true;
				$listoptions["listname"] = "extendedprivsgroup-based-sublist"; //de default mainlist layout
				$listoptions["hiddenfilter"]["extendedprivsgroup-field"][] = $_REQUEST['editextrafield'];
				$listoptions["hide_addrow"] = false;
				$listoptions["hide_addlink"] = true;
				$listoptions["listid"] = "extendedprivsgroup1";
				list($number_of_records, $output) = make_list($listoptions);
	//			print '<tr><td>Conditional record/field access <em>based on</em> this field</td><td><a onclick="PopFancyBoxExtraLarge(\'Conditional record/field access based on this field\',\'#rar1\')">';
				print '<tr><td>Conditional record/field access <em>based on</em> this field</td><td><a onclick="PopFancyBoxExtraLarge(\'Conditional record/field access based on this field\',\'list.php?table=extendedprivsgroup&amp;listname=extendedprivsgroup-based-sublist&amp;hiddenfilter[extendedprivsgroup-field][]=' . $_REQUEST['editextrafield'] . '&amp;nonavbar=1&amp;hide_addrow=0&amp;type_of_list=sublist\')">';
				if ($number_of_records == 0)
				{
					print '[none set]';
				}
				else
				{
					print '<span class="warnmsg">[' . $number_of_records . ' set]</span>';
				}
				print '</a><div id="rar1" class="hide_content"><h1>Conditional record/field access <em>based on</em> this field</h1>' . $output . '</div></td></tr>';

				$listoptions = array();
				$listoptions["table"] = "extendedprivsgroup";
				$listoptions["type_of_list"] = "sublist";
				$listoptions["hide_header"] = true;
				$listoptions["listname"] = "extendedprivsgroup-for-sublist"; //de default mainlist layout
				$listoptions["hiddenfilter"]["extendedprivsgroup-only_apply_for_field"][] = $_REQUEST['editextrafield'];
				$listoptions["hide_addrow"] = false;
				$listoptions["hide_addlink"] = true;
				$listoptions["listid"] = "extendedprivsgroup2";
				list($number_of_records, $output) = make_list($listoptions);
				//print '<tr><td>Conditional field access <em>for</em> this field</td><td><a onclick="PopFancyBoxExtraLarge(\'Conditional field access for this field\',\'#rar2\')">';
				print '<tr><td>Conditional record/field access <em>for</em> this field</td><td><a onclick="PopFancyBoxExtraLarge(\'Conditional record/field access for this field\',\'list.php?table=extendedprivsgroup&amp;listname=extendedprivsgroup-for-sublist&amp;hiddenfilter[extendedprivsgroup-only_apply_for_field][]=' . $_REQUEST['editextrafield'] . '&amp;nonavbar=1&amp;hide_addrow=0&amp;type_of_list=sublist\')">';

				if ($number_of_records == 0)
				{
					print '[none set]';
				}
				else
				{
					print '<span class="warnmsg">[' . $number_of_records . ' set]</span>';
				}
				print '</a><div id="rar2" class="hide_content"><h1>Conditional field access <em>for</em> this field</h1>' . $output . '</div> </td></tr>';
			}
		}

		if (is_array(unserialize($row['defaultval'])))
		{
			$row['defaultval'] = unserialize($row['defaultval']);
			$row['defaultval'] = base64_decode($row['defaultval'][0]);
		}
		$ins = "";
		if ($row['israwhtml'] == "y")
		{
			$ins = "checked";
		}
		print "<tr><td>Contains raw HTML</td><td><input type='checkbox' name='IsRawHTML' value='IsRawHTML' " . $ins . "></td></tr>";

		print "<tr><td>Default value</td><td><textarea rows=\"4\" cols=\"70\" name='defaultval'>" . htme($row['defaultval']) . "</textarea></td></tr>";
		print "<tr><td>Calculation type</td><td><select name='calculation_type' id='JS_calculation_type'";

		print ">";
		print "<option>database trigger</option>";
		print "<option";
		$syntax = "sql";
		if ($row['calculation_type'] == 'calculated on display') {
			print " selected='selected'";
			$syntax = "php";
		}
		print ">calculated on display</option>";
		print "</select>";
		print "<tr><td>Calculation</td><td>";

		print '<ol>';
		print '<li>MySQL triggers will be automatically created based on this field for &quot;database trigger&quot; calculations.</li>';
		print '<li>Your query will be placed in a query like &quot;UPDATE CRMflextableX SET EFIDX = (&lt;&lt;your query here&gt;&gt;)&quot;.</li>';
		print '<li>Use @table_alias@ for the own table instead of CRMflextableX. Do <strong>not</strong> use `tildes` around @table_alias@, these will be added by Interleave.</li>';
		print '<li>Valid examples: &quot;SELECT COUNT(*) FROM CRMflextable3 WHERE CRMflextable3.deleted=\'n\' AND CRMflextable3.EFID15=@table_alias@.recordid&quot; (only add deleted=\'n\' when UsePhysicalDelete is No for this table) or &quot;@table_alias@.EFID2 * @table_alias@.EFID7&quot;.</li>';
		print '<li>You <strong>have</strong> to use fully qualified field names, e.g. @table_alias@.EFID2 instead of just EFID2.</li>';
		print '<li><strong>Don\'t forget to add CRMflextableX.deleted=\'n\'</strong> in subqueries (only when UsePhysicalDelete is No for this table).</li>';
		print '<li>PHP is evaluated only for &quot;calculated on display&quot; calculations.</li>';
		print '<li>You can use the results of a &quot;database trigger&quot; calculation within another calculation. This is <strong>not</strong> possible with &quot;calculated on display&quot; calculations.</li>';
		if ($row['calculation'] != "")
		{
			$dependent_calculations = 0;
			$using_other_calculations = 0;
			$name = "EFID" . $row['id'];
			foreach (db_GetArray("SELECT id, name FROM CRMextrafields WHERE deleted='n' AND calculation REGEXP '[[:<:]]" . $name . "[[:>:]]' AND id!='" . $row['id'] . "'") as $other)
			{
				$dependent_calculations++;
				print '<li><div class="warnmsg">This calculation is used in another calculation <a href="extrafields.php?editextrafield=' . $other['id'] . '">' . $other['id'] . ' ' . htme($other['name']) . '</a></div></li>';
			}
			preg_match_all("/\bEFID(\d+)\b/", $row['calculation'], $matches);
			foreach (array_unique($matches[1]) as $match)
			{
				$other = db_GetRow("SELECT id, name FROM CRMextrafields WHERE deleted='n' AND id=" . $match . " AND calculation!=''");
				if (($other['id'] > 0) && ($other['id'] != $row['id']))
				{
					$using_other_calculations++;
					print '<li><div class="warnmsg">This calculation uses another calculation <a href="extrafields.php?editextrafield=' . $other['id'] . '">' . $other['id'] . ' ' . htme($other['name']) . '</a></div></li>';
				}
			}
			if ($dependent_calculations > 0 || $using_other_calculations > 0)
			{
				print '<li><div class="warnmsg">Be extremely careful when altering the order, because MySQL runs the calculations in this order</div></li>';
			}
		}
		print '</ol>';

		print "<textarea rows=\"14\" cols=\"120\" name=\"calculation\" id=\"JS_calculation\">" . htme($row['calculation']) . "</textarea></td></tr>";
		print make_code_editor('JS_calculation', 'text/x-mysql');


		$ins = "";
		if ($row['forcing'] == "y")
		{
			$ins = "checked";
		}

		print "<tr><td>Required (user will be forced to enter or select a value)</td><td><input type='checkbox' name='forcing' value='y' " . $ins . ">";
		print "</td></tr>";

		$ins = "";
		if ($row['excludefromfilters'] != "n")
		{
			$ins = "checked";
		}
		print "<tr><td>Do not show list filters for this field</td><td><input type='checkbox' name='excludefromfilters' value='y' " . $ins . "></td></tr>";
		$ins = "";
		if ($row['underwaterfield'] == "y")
		{
			$ins = "checked";
		}

		print "<tr><td>Hide this field from @AUTO@ forms and lists (except for administrators)</td><td><input type='checkbox' name='underwaterfield' value='y' " . $ins . "></td></tr>";

		$ins = "";
		if ($row['log_stats'] == "y")
		{
			$ins = "checked";
		}
		print "<tr><td>Log daily statistics</td><td><input type='checkbox' name='log_stats' value='y'" . $ins . "></td></tr>";

		print "<tr><td>Remarks</td><td><textarea cols='70' rows='4' name='fieldremarks'>" . htme($row['remarks']) . "</textarea></td></tr>";

		print "</table>";

		print "<input type='hidden' name='editextrafield' value='" . htme($_REQUEST['editextrafield']) . "'><input type='hidden' name='tabletype' value='" . htme($_REQUEST['tabletype']) . "'><input name='submitted' type='submit' value='Save'>";

		print "</form>";

		if (is_numeric($row['id']))
		{
			print showchilds("fields", $_REQUEST['editextrafield']);
		}


		print '<script type="text/javascript">SetDivOpen();</script>';
	}
	else
	{
		$lo = array();
		$lo["table"] = "fields";
		$lo["listid"] = "ef" . $tabletype;
		$lo["type_of_list"] = "sublist";
		$lo["hiddenfilter"]["fields-deleted"][] = "n";
		if ($tabletype != "all") {
			$lo["hiddenfilter"]["fields-tabletype"][] = $tabletype;
		}
		list($count, $result) = make_list($lo);
		print $result;
	}
	}
} // end if access

EndHTML();

?>
