<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 *  Displays file revision history
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */
require_once "initiate.php";
ShowHeaders();

$fid = $_GET['fileid'];
$dif = $_GET['deletefileid'];
$revert = $_GET['revert_to'];
$dacfpf = $_POST['delete_all_childs_from_parent_fileid'];
$alldelconfirmed = $_POST['all_del_confirmed'];

$no_list = false; // to prevent the list from showing when asking for confirmation

if (ipi($revert) && CheckTableRecordAccess("files", $revert) == "ok") {
	$fid = RevertToFile($revert);
}

if (ipi($fid) && CheckTableRecordAccess("files", $fid) == "ok") {

	if (ipi($dif) && CheckTableRecordAccess("files", $dif) == "ok") {
		// Deletefile journaled zelf
		DeleteFile($dif, false, true);

	} elseif (ipi($dacfpf)) { //delete_all_childs_from_parent_fileid
		if ($alldelconfirmed != "y") {
			print '<h1>Are you sure you want to delete these files?</h1>';
			print '<ul>';
			$no_list = true;
		}
		$list = db_GetFlatArray("SELECT fileid FROM CRMbinfiles WHERE version_belonging_to='" . mres($dacfpf) . "'");
		foreach ($list AS $fileid) {
			if (ipi($fileid) && CheckTableRecordAccess("files", $fileid) == "ok") {
				// Deletefile journaled zelf
				if ($alldelconfirmed == "y") {
					DeleteFile($fileid, false, true);
				} else {
					print '<li>' . htme($fileid) . " : " . htme(GetFileName($fileid)) . '</li>';
				}
			}
		}
		if ($alldelconfirmed != "y") {
			print '</ul>';
			print '<form name="delall" method="post"><input type="hidden" name="delete_all_childs_from_parent_fileid" id="JS_delete_all_childs_from_parent_fileid" value="' . htme($dacfpf) . '"><input type="hidden" name="all_del_confirmed" value="y" id="JS_all_del_confirmed"><input type="submit" id="JS_submit" name="subm" value="Yes, delete these files"></form>';
		}
	}
	
	
	// Hier zouden we LIST voor moeten gebruiken maar daarmee is acties in kolommen stoppen niet mogelijk
	$fat = db_GetArray("SELECT fileid, timestamp_last_change, username, filesize, koppelid, type, folder FROM CRMbinfiles WHERE version_belonging_to='" . mres($fid) . "' ORDER BY timestamp_last_change DESC");

	if (count($fat) == 0) {
		print '<h1>This file has no sub versions.</h1>';
	} else {

		$ds_tablename = str_replace("flextable", "", $fat[0]['type']);
		$parent = $fat[0]['koppelid'];
		

		if (ipi($ds_tablename)) {
			$ds_tablename = "t" . $ds_tablename;
		} else {
			PrintAD("Couldn't reliably determine table type");
			$ds_tablename = "";
		}
		if ($ds_tablename != "") {
			if (ipi($revert) || ipi($dif)) { // when a file was deleted or reverted, reload file list in parent window
				$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "WhosMyDaddy().ListReload('" . $ds_tablename . "files', true, false);";
			}	
			
			if (!$no_list) {
				print '<h1>File revisions</h1><h2>' . $fid . ' : <a href="csv.php?fileid=' . htme($fid) . '">' . htme(GetFilename($fid)) . '</a>';
				print '&nbsp;<form name="delall" method="post"><input type="hidden" name="delete_all_childs_from_parent_fileid" id="JS_delete_all_childs_from_parent_fileid" value="' . htme($fid) . '"><input type="submit" id="JS_submit" name="subm" value="Delete all"></form>';
				print '</h2>';
				print list_filebox($ds_tablename, $parent, $fat[0]['folder'], $fid);
			}
		} 
	}

	
} else {
	PrintAD("Access denied");
}
EndHTML();
?>