<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file handles tables
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */


require_once "initiate.php";

$GLOBALS["InAdminSection"] = true;

if (isset($_GET['showtags'])) {
	/* this option is also usable by non-admins!! */
	ShowTableTags($_GET['showtags'], $_GET['CKEditorInstance'], $_GET['type'], $_GET['fqn'], $_GET['record']);
} else {
	MustBeAdmin();

    ShowHeaders();

    if (isset($_GET['createrules']) && isset($_GET['table'])) {
    	require_once "adminfunctions.php";
    	create_access_rules_for_fields_in_table($_GET['table'], $_POST);

    }

    if (ipi($_REQUEST['EditFlexTable'])) {
    	$table = "tables";
    	$recordid = $_REQUEST['EditFlexTable'];

    	print familytree($table, $recordid, $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
    	print "<h1>" . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["singular"] . " " . get_refer_layout_for_record($table, $recordid)) . "</h1>";
    }

    if ($_REQUEST['AtOnce']) {
    	print "<table class=\"form-table\"><tr><td>";
    	if ($_REQUEST['ImportStash']) {
    		AdminChangesDropCache();
    		$arr = PopStashValue($_REQUEST['ImportStash']);
    		$tname = $_REQUEST['TableName'];
    		$fields = explode("\t",$arr[0]);
    		unset($arr[0]);

    		$sql = "INSERT INTO CRMflextabledefs(tablename, formid, refer_field_layout, maxrowsperpage, headerhtml, tableheaderrepeat, addlinktext) VALUES('" . mres(trim($_REQUEST['TableName'])) . "','','','100','','0', '" . mres($lang['pbaddrec']) . "')";
    		mcq($sql);
    		$table_id = db_GetInsertId();

			mcq("UPDATE CRMflextabledefs SET refer_field_layout='@t" . $table_id . "-recordid@' WHERE recordid=" . $table_id);

    		/* create a first rule denying access to everybody but admins. new tables are not accessible for anyone, this rule for admins (0) automatically denies access for everybody else */
    		$sql = "INSERT INTO CRMtableaccessrules(`table`, `group`, `read`, `write`, `add`, `delete`) VALUES (" . $table_id . ", 0, 1, 1, 1, 1)";
    		mcq($sql);

    		/* create the physical table */
    		mcq("CREATE TABLE CRMflextable" . $table_id . " (recordid INT(11) NOT NULL auto_increment, deleted ENUM('n','y') NOT NULL DEFAULT 'n', timestamp_last_change TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (recordid)) ENGINE=InnoDB DEFAULT CHARSET=UTF8 COMMENT='Interleave data table'");


    		$temp_names = array();
    		$order = 10;
    		foreach ($fields AS $field) {
    				$order++;
    				$sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,defaultval,sort,size,showsearchbox,excludefromfilters,number_format,sum_column) VALUES ('','" . mres(trim($field)) . "'," . $order . ",'textbox'," . $table_id . ",'n','','n','','n','y','don\'t format','no')";
    				mcq($sql);
    				$new_field_name = db_GetInsertId();
    				array_push($temp_names, array($field, "#EFID" . $new_field_name . "#", "[[EFID" . $new_field_name . "]]"));
    				mcq("ALTER TABLE CRMflextable" . $table_id . " ADD `EFID" . $new_field_name . "` LONGTEXT NOT NULL");
    				$sql = "UPDATE CRMextrafields SET ordering='" . mres($new_field_name*100) . "' WHERE id=" . $new_field_name;
    				mcq($sql);
    //				print "Push : " . "#" . str_replace(" ", "_", strtoupper($field)) . "#<br>";
    		}
    		print "Done creating table.";

		$importbody = "";
		$t = 0;
    		foreach ($arr AS $row) {
    			$importbody .= str_replace("\n","", $row) . "\n";
    			$t++;
    		}

    		AdminChangesDropCache();

    		$t = PushStashValue($importbody);
    		?>
    			<script type="text/javascript">
    				$(document).ready(function() {
    					window.location.href='flextable.php?Msg=1&DataInStash=<?php echo $t;?>&ImportIntoTable=<?php echo $table_id;?>';
    				});
    			</script>
    		<?php

    	} elseif ($_POST['importBody']) {
    		$farr = explode("\n", trim($_POST['importBody']));
    		$st1 = explode("\t",$farr[0]);
    		$stash = PushStashValue($farr);

    		print "<form id='automated' method='post' action=''><table class='form-table'><tr><td>Table name</td><td><input type='text' name='TableName' value=''><input type='hidden' name='ImportStash' value='" . $stash . "'><input type='hidden' name='AtOnce' value='true'></td></tr>";

    		print "<tr><td>Fields to add</td><td>";
    		foreach($st1 AS $field) {
    			print $field . "<br>";
    		}
    		print "</td></tr>";
    		print "<tr><td>Number of records to import</td><td>" . (sizeof($farr)-1) . "</td></tr>";
    		print "<tr><td colspan='2'><input type='submit' name='Go' value='go'></td></tr>";
		print "</table>";
    		print "</form>";
    	} elseif ($_REQUEST['import_sql_host'] && $_REQUEST['import_sql_user']) {
		$cancel = false;
    		if (!$db = db_only_connect($_REQUEST['import_sql_user'], $_REQUEST['import_sql_pass'], $_REQUEST['import_sql_host'])) {
    			print "<span class=\"errmsg\">Database connection failed (probably wrong user/pass combination)</span><br>";
    			$cancel = true;
    		} elseif (!db_only_select($_REQUEST['import_sql_name'])) {
    			print "<span class=\"errmsg\">Connection is OK but database could not be selected</span><br>";
    			$cancel = true;
    		}
    		if (!$cancel) {
    			$st1 = array();
    			$farr = array();
    			print "<pre>";
    			$thisrow = "";
    			$sql = $_REQUEST['import_sql_query'];
			$s = false;
			$done = false;
    			foreach (db_GetArray($sql) AS $row) {
    				$y = false;
				$headrow = "";
				$thisrow = "";
    				foreach ($row AS $head => $data) {
    					if ($y && !is_numeric($head)) $thisrow .= "\t";
    					if (!is_numeric($head))	{
    						$thisrow .= str_replace("\t","###TAB###", $data);
    						$y = true;
    					}
    					if (!is_numeric($head)) {
    						if ($s) $headrow .= "\t";
    						$headrow .= $head;
    						$s = true;
    					}
    				}
    				if (!$done) {
    					array_push($farr, $headrow);
    				}
    				//array_push($farr, $thisrow);
    				unset($thisrow);
    				unset($headrow);
    				$done = true;
    			}



    			unset($GLOBALS['LAST_DB_CONN']);
    			DB_Connect($GLOBALS['repository']);
    			if (SwitchToRepos($GLOBALS['repository']) == false) {
    				print "ERROR!";
    				exit;

    			}


    			$st1 = explode("\t",$farr[0]);
    			$stash = PushStashValue($farr);
    			print "<form id='automated' method='post' action=''><table class='form-table'><tr><td>Table name</td><td><input type='text' name='TableName' value=''><input type='hidden' name='ImportStash' value='" . $stash . "'><input type='hidden' name='AtOnce' value='true'></td></tr>";

    			print "<tr><td>Fields to add</td><td>";
    			foreach($st1 AS $field) {
    				print $field . "<br>";
    			}
    			print "</td></tr>";
    			print "<tr><td>Number of records to import</td><td>" . (sizeof($farr)-1) . "</td></tr>";
    			print "<tr><td colspan='2'><input type='submit' name='Go' value='go'></td></tr>";
			print "</table>";
    			print "</form>";
    		}

    	} else {

    		print "Paste tab-delimited values (from Excel or OO/LO Calc)<br>";
    		print "<form id='uploadFlextable' method='post' enctype='multipart/form-data' action=''>";
    		print "<textarea name=\"importBody\" id=\"JS_importBody\" cols=\"100\" rows=\"4\"></textarea><br>";
    		print "<input type='submit' value='Go'></div></form><br>";
    		print "&nbsp;&nbsp; File layout:<br>";
    		print "<ul><li>CSV Layout with tab as separator</li>";
    		print "<li>First row must contain field names</li></ul>";
    		//print "<hr>";
    		print "</td></tr><tr><td>";
    		print "Or create table by SQL Query:&nbsp;&nbsp;&nbsp;";
    		print "<form id='SQLquery' method='post' action=''><table class='form-table'>";
    		print "<tr><td>Database host</td><td><input type='text' name='import_sql_host'></td></tr>";
    		print "<tr><td>Database user</td><td><input type='text' name='import_sql_user'></td></tr>";
    		print "<tr><td>Database password</td><td><input type='password' name='import_sql_pass'></td></tr>";
    		print "<tr><td>Database name</td><td><input type='text' name='import_sql_name'></td></tr>";
    		print "<tr><td>SQL query</td><td><textarea rows='5' cols='40' name='import_sql_query'></textarea></td></tr>";
    		print "<tr><td><input type='submit' name='submit' value='Go'></td><td></td></tr></table></form>";
    	}
    	print "</td></tr></table>";
    	print "</div>";
    }

    if ($_REQUEST['TableAdmin'] || $_REQUEST['EditFlexTable'] || $_REQUEST['DeleteFlexTable'] || $_REQUEST['EditFlexTableFormID'] || $_REQUEST['TruncateFlexTable'] || $_REQUEST['PurgeFlexTable']) {

    	if ($_REQUEST['TruncateFlexTable']) {
    		if (!$_REQUEST['Sure']) {
    			print "<h2>Truncate table " . htme($_REQUEST['TruncateFlexTable']) . " " . htme(GetFlextableName($_REQUEST['TruncateFlexTable'])) . "</h2>";
    			print "<h2>All data in this table will be lost, including journal information and attachments.</h2>";
    			print "<p><br>Are you sure? <input type='button' onclick='window.location.href=\"flextable.php?TruncateFlexTable=" . htme($_REQUEST['TruncateFlexTable']) . "&amp;Sure=yes\";' value='Yes, truncate this table'></button></p>";
    			print '<h2>Summary</h2><ul>';
    			print '<li>Records: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMflextable" . mres($_REQUEST['TruncateFlexTable']) . ""),0) . '</li>';
    			print '<li>Datajournal records: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMdatajournal WHERE `table`='" . mres($_REQUEST['TruncateFlexTable']) . "' AND record IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['TruncateFlexTable']) . ")"),0) . '</li>';
    			print '<li>Journal records: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMjournal WHERE type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "' AND eid IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['TruncateFlexTable']) . ")"),0) . '</li>';

    			print '<li>Files: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "' AND koppelid IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['TruncateFlexTable']) . ")"),0) .  ' (total size ' . FormatNumber((db_GetValue("SELECT SUM(filesize) FROM CRMbinfiles WHERE type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "' AND koppelid IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['TruncateFlexTable']) . ")")/1024/1024),2,false,true) . 'M)</li>';
    			print '</ul>';
    			EndHTML();
    			exit;
    		} else {
    			print "<strong>Table " . htme($_REQUEST['TruncateFlexTable']) . " was truncated.</strong><br><br>";
    			$sql = "TRUNCATE TABLE CRMflextable" . $_REQUEST['TruncateFlexTable'] . "";
    			mcq($sql);
    			$sql = "DELETE CRMbinfiles, CRMblobs FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND CRMbinfiles.type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "'";
    			mcq($sql);
    			$sql = "DELETE FROM CRMbinfiles WHERE CRMbinfiles.type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "' AND CRMbinfiles.type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "'";
    			mcq($sql);
    			$sql = "DELETE FROM CRMjournal WHERE type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "'";
    			mcq($sql);
    			$sql = "DELETE FROM CRMdatajournal WHERE `table`='" . mres($_REQUEST['TruncateFlexTable']) . "'";
    			mcq($sql);
    		}

    	} elseif ($_REQUEST['PurgeFlexTable']) {
			/* this option is only available when the table uses logical delete */
    		if (!$_REQUEST['Sure']) {
    			print "<h2>Purge table " . htme($_REQUEST['PurgeFlexTable']) . "</h2><h2>All prior deleted records in table will be physically deleted!</h2><p>Are you absolutely sure? <input type='button' onclick='window.location.href=\"flextable.php?PurgeFlexTable=" . $_REQUEST['PurgeFlexTable'] . "&amp;Sure=yes\";' value='Yes, purge deleted records in this table'></button></p>";

    			print '<h2>Summary</h2><ul>';
    			print '<li>Records: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMflextable" . mres($_REQUEST['PurgeFlexTable']) . " WHERE deleted='y'"),0) . '</li>';
    			print '<li>Datajournal records: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMdatajournal WHERE `table`='" . mres($_REQUEST['PurgeFlexTable']) . "' AND record IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['PurgeFlexTable']) . " WHERE deleted='y')"),0) . '</li>';
    			print '<li>Journal records: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMjournal WHERE type='flextable" . mres($_REQUEST['PurgeFlexTable']) . "' AND eid IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['PurgeFlexTable']) . " WHERE deleted='y')"),0) . '</li>';
    			print '<li>Files: ' . FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE type='flextable" . mres($_REQUEST['PurgeFlexTable']) . "' AND koppelid IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['PurgeFlexTable']) . " WHERE deleted='y')"),0) .  ' (total size ' . FormatNumber((db_GetValue("SELECT SUM(filesize) FROM CRMbinfiles WHERE type='flextable" . mres($_REQUEST['PurgeFlexTable']) . "' AND koppelid IN (SELECT recordid FROM CRMflextable" . mres($_REQUEST['PurgeFlexTable']) . " WHERE deleted='y')")/1024/1024),2) . 'M)</li>';
    			print '</ul>';

    			EndHTML();
    			exit;
    		} else {
    			print "<strong>Table " . $_REQUEST['PurgeFlexTable'] . " was purged.</strong><br><br>";
    			$listofids = db_GetFlatArray("SELECT recordid FROM CRMflextable" . $_REQUEST['PurgeFlexTable'] . " WHERE deleted='y'");

    			foreach ($listofids AS $id) {
    				$sql = "DELETE CRMbinfiles, CRMblobs FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND CRMbinfiles.type='flextable" . mres($_REQUEST['PurgeFlexTable']) . "' AND CRMbinfiles.koppelid='" . mres($id) . "'";
    				mcq($sql);

    				$sql = "DELETE FROM CRMbinfiles WHERE CRMbinfiles.type='flextable" . mres($_REQUEST['PurgeFlexTable']) . "' AND CRMbinfiles.koppelid='" . mres($id) . "'";
    				mcq($sql);

    				$sql = "DELETE FROM CRMjournal WHERE type='flextable" . mres($_REQUEST['TruncateFlexTable']) . "' AND eid='" . mres($id) . "'";
    				mcq($sql);
    			}
    			$sql = "DELETE FROM CRMflextable" . $_REQUEST['PurgeFlexTable'] . " WHERE deleted='y'";
    			mcq($sql);
    		}
    	} elseif ($_GET['DeleteFlexTable']) {
    		if (!$_REQUEST['Sure']) {
    			print "<strong>Delete table " . $_REQUEST['DeleteFlexTable'] . " - All data in this table will be lost!</strong><br><br>Are you absolutely sure? <a href='flextable.php?DeleteFlexTable=" . $_REQUEST['DeleteFlexTable'] . "&amp;Sure=yes'>Yes, delete this table.</a> (no way back)";
    			EndHTML();
    			exit;
    		} else {
    			print "<strong>Table " . $_REQUEST['DeleteFlexTable'] . " was deleted, including attachments, the field definitions and the field values. Forms were preserved.</strong><br><br>";
    			$sql = "DELETE FROM CRMflextabledefs WHERE recordid='" . mres($_GET['DeleteFlexTable']) ."'";
    			mcq($sql);
    			$sql = "DELETE FROM CRMextrafields WHERE tabletype='" . mres($_GET['DeleteFlexTable']) ."'";
    			mcq($sql);
    			$sql = "DELETE FROM CRMattributes WHERE entity='" . mres($_GET['DeleteFlexTable']) ."' AND identifier='flextable'";
    			mcq($sql);
    			$sql = "DROP TABLE CRMflextable" . mres($_GET['DeleteFlexTable']) ."";
    			mcq($sql);

    			$sql = "DELETE CRMbinfiles, CRMblobs FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND CRMbinfiles.type='flextable" . mres($_REQUEST['DeleteFlexTable']) . "'";
    			mcq($sql);
    		}

    	} elseif ($_POST['EditFlexTableFormID']) {

    		if ($_REQUEST['add_in_popup'] != "y") {
    			$_REQUEST['add_in_popup'] = "n";
    		}

    		if (is_numeric($_POST['EditFlexTableFormID'])) {

    			$sql = "UPDATE CRMflextabledefs SET sort_on='" . mres($_REQUEST['sort_on']) . "',sort_direction='" . mres($_REQUEST['sort_direction']) . "', tablename='" . mres($_POST['tablename']) . "',formid='" . mres($_POST['formid']) . "', refer_field_layout='" . mres($_POST['refer_field_layout']) . "',ordering='" . mres($_REQUEST['ordering']) . "', maxrowsperpage='" . mres($_REQUEST['maxrowsperpage']) . "', headerhtml='" . mres($_REQUEST['headerhtml']) . "', addlinktext='" . mres($_REQUEST['addlinktext']) . "', add_in_popup='" . mres($_REQUEST['add_in_popup']) . "',tableheaderrepeat='" . mres($_REQUEST['tableheaderrepeat']) . "', stayinformaftersave='" . mres($_REQUEST['stayinformaftersave']) . "', comment='" . mres($_REQUEST['tableremarks']) . "' WHERE recordid='" . mres($_POST['EditFlexTableFormID']) . "'";
    			mcq($sql);

    			AdminChangesDropCache();

    		} elseif ($_POST['EditFlexTableFormID'] == "new") {

    			$sql = "INSERT INTO CRMflextabledefs(tablename,formid,refer_field_layout,maxrowsperpage, headerhtml,addlinktext,stayinformaftersave) VALUES('" . mres($_POST['tablename']) . "','" . mres($_POST['formid']) . "','" . mres($_POST['refer_field_layout']) . "','" . mres($_REQUEST['maxrowsperpage']) . "','" . mres($_REQUEST['headerhtml']) . "','" . mres($_REQUEST['addlinktext']) . "','" . mres($_REQUEST['stayinformaftersave']) . "')";
    			mcq($sql);
    			$newtable = db_GetInsertId();

    			/* create a first rule denying access to everybody but admins. new tables are not accessible for anyone, this rule for admins (0) automatically denies access for everybody else */
    			$sql = "INSERT INTO CRMtableaccessrules(`table`, `group`, `read`, `write`, `add`, `delete`) VALUES (" . $newtable . ", 0, 1, 1, 1, 1)";
    			mcq($sql);

    			mcq("CREATE TABLE CRMflextable" . $newtable . " (recordid INT(11) NOT NULL auto_increment, deleted ENUM('n','y') NOT NULL DEFAULT 'n', timestamp_last_change TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (recordid)) ENGINE=InnoDB DEFAULT CHARSET=UTF8");

    			$_GET['EditFlexTable'] = $newtable;
    			AdminChangesDropCache();

    		}

    		if ($_REQUEST['fromlist'] != "") {
    			print '<script type="text/javascript">window.location.href=\'' . jsencode(base64_decode($_REQUEST['fromlist'])) . '\';</script>';
    		}


    	}

    	$arr = GetFlexTableDefinitions();

    	if ($_GET['EditFlexTable'] == "new") {
    		$arr = array();
    		$arr[0]['recordid'] = "new";
    	}
    	if ($_GET['EditFlexTable']) {


    		if (!is_numeric($_GET['EditFlexTable']) && $_GET['EditFlexTable'] != 'new') { // dirty security check
    			PrintAD("Access denied or non-existent table or record.");
    			EndHTML();
    			exit;
    		}
    		$AddRowLocation = GetAttribute("flextable", "AddRowLocation", $_GET['EditFlexTable']);
    		if ($AddRowLocation == "") {
    			SetAttribute("flextable", "AddRowLocation", "top", $_GET['EditFlexTable'], array("top", "bottom"));
    		}
    		$MainTable = GetAttribute("flextable", "MainTable", $_GET['EditFlexTable']);
    		if ($MainTable == "") {
    			SetAttribute("flextable", "MainTable", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$WebDAVDirectoryName = GetAttribute("flextable", "WebDAVDirectoryName", $_GET['EditFlexTable']);
    		if ($WebDAVDirectoryName == "") {
    			SetAttribute("flextable", "WebDAVDirectoryName", "{{none}}", $_GET['EditFlexTable']);
    		}
    		$ShowOnUserEditPage = GetAttribute("flextable", "ShowOnUserEditPage", $_GET['EditFlexTable']);
    		if ($ShowOnUserEditPage == "") {
    			SetAttribute("flextable", "ShowOnUserEditPage", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$DQSMethod = GetAttribute("flextable", "DQSMethod", $_GET['EditFlexTable']);
    		if ($DQSMethod == "") {
    			SetAttribute("flextable", "DQSMethod", "Re-run query", $_GET['EditFlexTable'], array("Re-run query", "Fixed set", "Disabled"));
    		}
			$AddRowEnabledOnSublistsOnAutoForms = GetAttribute("flextable", "AddRowEnabledOnSublistsOnAutoForms", $_GET['EditFlexTable']);
    		if ($AddRowEnabledOnSublistsOnAutoForms == "") {
    			SetAttribute("flextable", "AddRowEnabledOnSublistsOnAutoForms", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
			$FilenameForDownloadsTemplate = GetAttribute("flextable", "FilenameForDownloadsTemplate", $_GET['EditFlexTable']);
    		if ($FilenameForDownloadsTemplate == "") {
    			SetAttribute("flextable", "FilenameForDownloadsTemplate", "{{none}}", $_GET['EditFlexTable']);
    		}
            $ImportHeaderHTMLText = GetAttribute("flextable", "ImportHeaderHTMLText", $_GET['EditFlexTable']);
    		if ($ImportHeaderHTMLText == "") {
    			SetAttribute("flextable", "ImportHeaderHTMLText", "{{none}}", $_GET['EditFlexTable']);
    		}
    		$HasFileAttachments = GetAttribute("flextable", "HasFileAttachments", $_GET['EditFlexTable']);
    		if ($HasFileAttachments == "") {
    			SetAttribute("flextable", "HasFileAttachments", "No", $_GET['EditFlexTable'], array("Yes", "No"));
    		}
    		$WhenSearchingAlsoSearchThroughBinaryAttachments = GetAttribute("flextable", "WhenSearchingAlsoSearchThroughBinaryAttachments", $_GET['EditFlexTable']);
    		if ($WhenSearchingAlsoSearchThroughBinaryAttachments == "") {
    			SetAttribute("flextable", "WhenSearchingAlsoSearchThroughBinaryAttachments", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$IncludeInSystemWideSearches = GetAttribute("flextable", "IncludeInSystemWideSearches", $_GET['EditFlexTable']);
    		if ($IncludeInSystemWideSearches == "") {
    			SetAttribute("flextable", "IncludeInSystemWideSearches", "No", $_GET['EditFlexTable'], array("Yes", "No"));
    		}
    		$DeleteConfirmationMessage = GetAttribute("flextable", "DeleteConfirmationMessage", $_GET['EditFlexTable']);
    		if ($DeleteConfirmationMessage == "") {
    			SetAttribute("flextable", "DeleteConfirmationMessage", "{{none}}", $_GET['EditFlexTable']);
    		}
    		$ShowSelectionsWhenInline = GetAttribute("flextable", "ShowSelectionsWhenInline", $_GET['EditFlexTable']);
    		if ($ShowSelectionsWhenInline == "") {
    			SetAttribute("flextable", "ShowSelectionsWhenInline", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$ShowSelectionsWhenNotInline = GetAttribute("flextable", "ShowSelectionsWhenNotInline", $_GET['EditFlexTable']);
    		if ($ShowSelectionsWhenNotInline == "") {
    			SetAttribute("flextable", "ShowSelectionsWhenNotInline", "Yes", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$UsePopupAlsoWhenViewingPlainList = GetAttribute("flextable", "UsePopupAlsoWhenViewingPlainList", $_GET['EditFlexTable']);
    		if ($UsePopupAlsoWhenViewingPlainList == "") {
    			SetAttribute("flextable", "UsePopupAlsoWhenViewingPlainList", "No", $_GET['EditFlexTable'], array("Yes", "No"));
    		}
    		$ShowInlineDeleteLink = GetAttribute("flextable", "ShowInlineDeleteLink", $_GET['EditFlexTable']);
    		if ($ShowInlineDeleteLink == "") {
    			SetAttribute("flextable", "ShowInlineDeleteLink", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$ExtraSelectCondition = GetAttribute("flextable", "ExtraSelectCondition", $_GET['EditFlexTable']);
    		if ($ExtraSelectCondition == "") {
    			SetAttribute("flextable", "ExtraSelectCondition", "{{none}}", $_GET['EditFlexTable']);
    		}
    		$RemoveExtraSelectCondionFromQueryLinkText = GetAttribute("flextable", "RemoveExtraSelectCondionFromQueryLinkText", $_GET['EditFlexTable']);
    		if ($RemoveExtraSelectCondionFromQueryLinkText == "") {
    			SetAttribute("flextable", "RemoveExtraSelectCondionFromQueryLinkText", "{{none}}", $_GET['EditFlexTable']);
    		}
    		$AddExtraSelectCondionToQueryLinkText = GetAttribute("flextable", "AddExtraSelectCondionToQueryLinkText", $_GET['EditFlexTable']);
    		if ($AddExtraSelectCondionToQueryLinkText == "") {
    			SetAttribute("flextable", "AddExtraSelectCondionToQueryLinkText", "{{none}}", $_GET['EditFlexTable']);
    		}
    		$ShowInlineDuplicateLink = GetAttribute("flextable", "ShowInlineDuplicateLink", $_GET['EditFlexTable']);
    		if ($ShowInlineDuplicateLink == "") {
    			SetAttribute("flextable", "ShowInlineDuplicateLink", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
			$UsePhysicalDelete = GetAttribute("flextable", "UsePhysicalDelete", $_GET['EditFlexTable']);
    		if ($UsePhysicalDelete == "") {
    			SetAttribute("flextable", "UsePhysicalDelete", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$DenyDownloads = GetAttribute("flextable", "DenyDownloads", $_GET['EditFlexTable']);
    		if ($DenyDownloads == "") {
    			SetAttribute("flextable", "DenyDownloads", "No", $_GET['EditFlexTable'], array("Yes", "No"));
    		}
    		$IncludeThisTableInSearchesFromParentTable = GetAttribute("flextable", "IncludeThisTableInSearchesFromParentTable", $_GET['EditFlexTable']);
    		if ($IncludeThisTableInSearchesFromParentTable == "") {
    			SetAttribute("flextable", "IncludeThisTableInSearchesFromParentTable", "Yes", $_GET['EditFlexTable'], array("Yes", "No"));
    		}
    		$IncludeChildTablesInSearches = GetAttribute("flextable", "IncludeChildTablesInSearches", $_GET['EditFlexTable']);
    		if ($IncludeChildTablesInSearches == "") {
    			SetAttribute("flextable", "IncludeChildTablesInSearches", "Yes", $_GET['EditFlexTable'], array("Yes", "No"));
    		}
    		$IncludeParentTableInSearches = GetAttribute("flextable", "IncludeParentTableInSearches", $_GET['EditFlexTable']);
    		if ($IncludeParentTableInSearches == "") {
    			SetAttribute("flextable", "IncludeParentTableInSearches", "Yes", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$NoResultsMessage = GetAttribute("flextable", "NoResultsMessage", $_GET['EditFlexTable']); // {{language default}}
    		if ($NoResultsMessage == "") {
    			SetAttribute("flextable", "NoResultsMessage", "{{language default}}", $_GET['EditFlexTable']);
    		}
    		$PopUpSize = GetAttribute("flextable", "PopUpSize", $_GET['EditFlexTable']);
    		if ($PopUpSize == "") {
    			SetAttribute("flextable", "PopUpSize", "Large", $_GET['EditFlexTable'], array("Small", "Medium", "Large", "Extra large"));
    		}


			$ResizeImagesToMaxPx = GetAttribute("flextable", "ResizeImagesToMaxPx", $_GET['EditFlexTable']);
    		if ($ResizeImagesToMaxPx == "") {
    			SetAttribute("flextable", "ResizeImagesToMaxPx", "{{none}}", $_GET['EditFlexTable']);
    		}
			$PutCellDataInOwnDivInLists = GetAttribute("flextable", "PutCellDataInOwnDivInLists", $_GET['EditFlexTable']);

    		if ($PutCellDataInOwnDivInLists == "") {
    			SetAttribute("flextable", "PutCellDataInOwnDivInLists", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
    		$CreateEmptyRecordOnAdd = GetAttribute("flextable", "CreateEmptyRecordOnAdd", $_GET['EditFlexTable']);
    		if ($CreateEmptyRecordOnAdd == "") {
    			SetAttribute("flextable", "CreateEmptyRecordOnAdd", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
			$TableIsPartOfConfiguration = GetAttribute("flextable", "TableIsPartOfConfiguration", $_GET['EditFlexTable']);
    		if ($TableIsPartOfConfiguration == "") {
    			SetAttribute("flextable", "TableIsPartOfConfiguration", "No", $_GET['EditFlexTable'], array("No", "Yes"));
    		}
			$TemplateForNewEmptyInterleaveDocuments = GetAttribute("flextable", "TemplateForNewEmptyInterleaveDocuments", $_GET['EditFlexTable']);
	    	if ($TemplateForNewEmptyInterleaveDocuments == "") {
	    		SetAttribute("flextable", "TemplateForNewEmptyInterleaveDocuments", "0", $_GET['EditFlexTable']);
	    	}
			$DoNotLock = GetAttribute("flextable", "DoNotLock", $_GET['EditFlexTable']);
			if ($DoNotLock == "") {
				SetAttribute("flextable", "DoNotLock", "No", $_GET['EditFlexTable'], array("No", "Yes"));
			}


    		print "<form id='EditFlexTableForm' method='post' action=''>";
    		print "<input type='hidden' name='EditFlexTableFormID' value='" . $_GET['EditFlexTable'] . "'>";

    			foreach ($arr AS $ar) {
    				if ($ar['recordid'] == $_GET['EditFlexTable']) {

    					print "<input type='submit' value='Save'>";
    					if ($_GET['EditFlexTable'] <> "new") {
    						print " " . AttributeLink("flextable", $ar['recordid'], "Attributes", "", true);
    						print " <a href=\"list.php?table=t" . $ar['recordid'] . "&amp;listid=t" . $ar['recordid'] . "efidpage\" class=\"likebutton\">Show</a>";


    						print " <a href='flextable.php?TruncateFlexTable=" . $_GET['EditFlexTable'] . "' class=\"likebutton\">Empty (truncate)</a>";

							if ($GLOBALS['UC']['PersonalDataStructure']["t" .  $_GET['EditFlexTable']]['logical_delete']) {
	    						$tmp = db_GetRow("SELECT COUNT(*) FROM CRMflextable" . $_GET['EditFlexTable'] . " WHERE deleted='y'");

	    						if ($tmp[0] > 0) {
	    							print " <a href='flextable.php?PurgeFlexTable=" . $_GET['EditFlexTable'] . "' class=\"likebutton\">Purge (" . $tmp[0] . ")</a>";
	    						}
							}
    						print " <a href='flextable.php?DeleteFlexTable=" . $_GET['EditFlexTable'] . "' class=\"likebutton deletebutton\">Delete</a>";
    						$worker = PushStashValue(array("table" => "unknown"));
    						print " <a href='import.php?tableId=" . $ar['recordid'] . "&amp;Worker=" . $worker . "' class=\"likebutton\">Import</a>";
    						print " <a href='dedup.php?tableId=" . $ar['recordid'] . "&amp;Worker=" . $worker . "' class=\"likebutton\">Deduplicate</a>";


    						print " <a href='extrafields.php?tabletype=ft_" . htme($_GET['EditFlexTable']) . "&ti=" . htme(GetFlexTableName($_GET['EditFlexTable'])) . "' class=\"likebutton\">Fields</a>";

    						print " <a onclick=\"PopFancyBoxExtraLarge('Group comparison', 'listadmin.php?groupcomparison=1&amp;nonavbar=1&amp;table=t" . $_GET['EditFlexTable'] . "');\" class=\"likebutton\">Group comparison</a>";
    						print " <a onclick=\"PopFancyBoxExtraLarge('Table property comparison', 'listadmin.php?tablecomparison=1&amp;nonavbar=1&amp;table=t" . $_GET['EditFlexTable'] . "');\" class=\"likebutton\">Table property compare</a>";

    						print " <a onclick=\"PopFancyBoxExtraLarge('Generate form', 'admin.php?get_default_form_for_table=" . $_GET['EditFlexTable'] . "&amp;nonavbar=1');\" class=\"likebutton\">Generate form</a>";

    						print ' <a class="likebutton addbutton" onclick=\'PopFancyBoxLarge("", "flextable.php?createrules&amp;table=t' . $_GET['EditFlexTable'] . '&nonavbar=1");\'>Create rules</a>';
    					} else {
    						print ' <a class="likebutton" href="flextable.php?AtOnce=1">Add by uploading a row</a>';
    					}
    					print "<br><br>";

    					print "<table class=\"form-table\">";
    					print "<tr><td>Table name</td><td><input type='text' name='tablename' value='" . htme($ar['tablename']) . "'>";

    					print '<br><br>';
    					foreach (array("plural", "singular", "add") as $tag)
    					{
    						print '<input onclick="ilor(\'record.php?table=languages&amp;record=&amp;languages-TEXTID=flextable' . $_GET['EditFlexTable'] . $tag . '\',2,\'languagetable\',0)" value="New ' . $tag . ' language tag" type="button" class="addbutton"> ';
    					}
    						$listoptions = array();
    						$listoptions["table"] = "languages";
    						$listoptions["listid"] = "languagetable";
    						$listoptions["type_of_list"] = "sublist";
    						$listoptions["hide_search"] = true;
    						$listoptions["hide_filters"] = true;
    						$listoptions["hide_header"] = true;
    						$listoptions["hide_pagination_if_only_1_page"] = true;
    						$listoptions["hide_recordcounter"] = true;
    						$listoptions["hide_outputtype_excel"] = true;
    						$listoptions["hide_perpage"] = true;
    						$listoptions["hide_addlink"] = true;
    						$listoptions["hide_tablewhennoresults"] = true;
    						$listoptions["listlayoutcolumns"] = "languages-LANGID,languages-TEXTID,languages-TEXT";
    						$listoptions["hiddenfilter"]["languages-TEXTID"][] = "flextable" . $_GET['EditFlexTable'] . "plural";
    						$listoptions["hiddenfilter"]["languages-TEXTID"][] = "flextable" . $_GET['EditFlexTable'] . "singular";
    						$listoptions["hiddenfilter"]["languages-TEXTID"][] = "flextable" . $_GET['EditFlexTable'] . "add";
    						list($number_of_records, $output) = make_list($listoptions);
    						print $output;

    					print "</td></tr>";
    					print "<tr><td>Remarks</td><td><textarea cols='70' rows='4' name='tableremarks'>" . htme($ar['comment']) . "</textarea></td></tr>";
    					print "<tr><td>Order</td><td><input type='text' name='ordering' value='" . htme($ar['ordering']) . "' size='5'></td></tr>";

    							$ins = "";
    							if ($ar['stayinformaftersave'] == "y") {
    								$ins = "checked";
    							}
    							print "<tr><td>Stay in form after save</td><td><input type='checkbox' name='stayinformaftersave' value='y' " . $ins . "></td></tr>";
    							$ins = "";
    							if ($ar['add_in_popup'] == "y") {
    								$ins = "checked";
    							}
    							print "<tr><td>Show forms in popup for sublists</td><td><input type='checkbox' name='add_in_popup' value='y' " . $ins . "></td></tr>";

    							if ($_GET['EditFlexTable'] <> "new") {

    								if (db_GetValue("SELECT COUNT(*) FROM CRMtableaccessrules WHERE `table`='" . mres($_REQUEST['EditFlexTable']) . "'") > 0) {
    									print "<tr><td>Access rules (for whole table)</td><td colspan='2'>";
    									print "<span class='warnmsg'>[apply]</span>";
    								} else {
    									print "<tr><td>Access rules (for whole table)</td><td colspan='2'>";
    									print "[none set]";
    								}
    								print "&nbsp;&nbsp;<a href='javascript:PopRightsChooserFlexTable(" . $_REQUEST['EditFlexTable'] . ");'>select</a></td></tr>";

    								if (db_GetValue("SELECT COUNT(*) FROM CRMdownloadrules WHERE `table`='" . mres($_REQUEST['EditFlexTable']) . "'") > 0) {
    									print "<tr><td>Download rules</td><td colspan='2'>";
    									print "<span class='warnmsg'>[apply]</span>";
    								} else {
    									print "<tr><td>Download rules</td><td colspan='2'>";
    									print "[none set]";
    								}
    								print "&nbsp;&nbsp;<a href='javascript:PopDownloadRulesChooserFlexTable(" . $_REQUEST['EditFlexTable'] . ");'>select</a></td></tr>";
    							}



    					print "<tr><td>Reference field layout</td><td><input type='text' sisze='50' name='refer_field_layout' value='" . htme($ar['refer_field_layout']) . "'></td></tr>";

    					print "<tr><td>Sort by</td>";
    					print "<td><select name='sort_on'>";
    					print "<option value='-'>No sort / default</option>";
    					$list = GetExtraFlexTableFields($ar['recordid']);
    					foreach ($list AS $extrafield) {
    							$ins = "";
    							if ($ar['sort_on'] == $extrafield['id']) {
    								$ins = "selected";
    							}
    							print "<option value='" . $extrafield['id'] . "' " . $ins . ">" . htme($extrafield['name']) . "</option>";
    							$acf = true;
    					}
    					print "</select>";
    					$ins = "";
    					if ($ar['sort_direction'] == "Descending") {
    						$ins = "selected";
    					}
    					print "&nbsp;&nbsp;<select name='sort_direction'><option value='Ascending'>Ascending</option><option " . $ins . " value='Descending'>Descending</option></select>";
    					print "</td></tr>";

    					print "<tr><td>Maximum rows per page</td><td><input type='text' size='3' name='maxrowsperpage' value='" . $ar['maxrowsperpage'] . "'> Use 0 for all rows</td></tr>";
    					print "<tr><td>Table header repeat every</td><td><input type='text' size='3' name='tableheaderrepeat' value='" . $ar['tableheaderrepeat'] . "'> Use 0 for no repeating table header</td></tr>";

    					print "<tr><td>Text for add link</td><td><input type='text' size='50' name='addlinktext' value='" . htme($ar['addlinktext']) . "'></td></tr>";

    					print "<tr><td>Form to use</td><td><select name='formid'>";
    					print "<option value='0'>Autoform</option>";
    							$sql = "SELECT templateid, templatename, template_subject FROM CRMtemplates WHERE version_belonging_to='0' AND templatetype='TEMPLATE_HTML_FORM'";
    							$printlink = false;
    							foreach (db_GetArray($sql) as $row) {
    								$ins = "";
    								if ($row['templateid'] == $ar['formid']) {
    									$ins = "selected";
    									$printlink = true;
    								}
    								print "<option " . $ins . " value='" . $row['templateid'] . "'>" . $row['templatename'] . " (" . $row['template_subject'] . ")</option>";
    							}
    							print "</select>";
    							if ($printlink) {
    								print "&nbsp;&nbsp;<a href='admin.php?templates=1&amp;editHTMLtemplate=" . $ar['formid'] . "&amp;fromlist=" . base64_encode("flextable.php?EditFlexTable=" . $ar['recordid']) . "'>edit form</a>";
    							}
    							print "</td></tr>";


    					print "<tr><td>List layouts</td><td>";

    					// vergelijkbare code staat in listadmin.php?lists=1
    					foreach (array("system", "user") as $listname_type)
    					{
    					//print '<ul>';
    					foreach (db_Getarray("SELECT entity, attribute FROM CRMattributes WHERE identifier='" . $listname_type . "' AND attribute LIKE 'List-layout-t" . $ar['recordid'] . "-%' ORDER BY entity") as $row)
    					{
    					list($prefix1, $prefix2, $table, $listname) = explode("-", $row['attribute']);
    					$listname_full = $listname_type . "-" . $listname;
    					$listname_this_display = $lang["listlayout-" . $listname_type] . " ";
    					if ($listname != "")
    					{
    					$listname_this_display .= $listname;
    					}
    					else
    					{
    					$listname_this_display .= $lang["listlayout-default"];
    					}
    					//print '<li>';
    					print '<div>';
    					print '<a onclick="PopFancyBoxLarge(\'\',\'listlayout.php?table=' . inline_jsencode(urlencode($table)) . '&amp;listname=' . inline_jsencode(urlencode($listname_full)) . '&amp;nonavbar=1';
    					if ($listname_type == "user")
    					{
    					print '&amp;userid=' . $row['entity'];
    					}
    					print '\')"><span class="fa fa-cog" title="' . htme($lang["selectcolumns"]) . '"></span></a> ';
    					print '<a href="list.php?table=' . $table . '&amp;listname=' . rawurlencode($listname_full);
    					if ($listname_type == "user")
    					{
    					print '&amp;userid=' . $row['entity'];
    					}
    					print '">';
    					if ($listname_type == "user")
    					{
    					print htme(db_GetValue("SELECT FULLNAME FROM CRMloginusers WHERE id='" . mres($row['entity']) . "'")) . ' ';
    					}
    					print htme($listname_this_display) . '</a>';
    					//print '</li>';
    					print '</div>';
    					}
    					//print '</ul>';
    					print '<div>&nbsp;</div>';
    					}





    					print "</td></tr>";

    				//if ($ar['headerhtml'] != "") {
    					print "<tr><td>Table header text (HTML/PHP and tags)<br>leave empty for automatic header</td><td><textarea id='JS_headerhtml' name='headerhtml' cols='100' rows='10'>" . htme($ar['headerhtml']) . "</textarea>";
    					print make_html_editor("JS_headerhtml", "", "", true, "300", "600");
    					print "</td></tr>";
    			//	}
    					print "</table></div>";

						print showchilds("tables", $_REQUEST['EditFlexTable']);

    					$listoptions = array();
    					$listoptions["table"] = "fields";
    					$listoptions["type_of_list"] = "sublist";
    					$listoptions["listname"] = "system-"; //de default mainlist layout
    					$listoptions["hiddenfilter"]["fields-tabletype"][] = $_REQUEST['EditFlexTable'];
    					$listoptions["hiddenfilter"]["fields-deleted"][] = "n";
    					list($number_of_records, $output) = make_list($listoptions);
    					print $output;


    					$listoptions = array();
    					$listoptions["table"] = "extendedprivsgroup";
    					$listoptions["type_of_list"] = "sublist";
    					$listoptions["listname"] = "system-"; //de default mainlist layout
    					$listoptions["hiddenfilter"]["extendedprivsgroup-field-fields-tabletype"][] = $_REQUEST['EditFlexTable'];
    					list($number_of_records, $output) = make_list($listoptions);
    					print $output;


    					print "</form>";
    				}
    			}
    	} else {
    		$listoptions = array();
    		$listoptions["table"] = "tables";
    		list($number_of_records, $output) = make_list($listoptions);
    		print $output;
    	}
    }
}
EndHTML();
?>
