<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * THIS FILE MUST BE CALLED EVERY MINUTE!
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */
//$GLOBALS['logtext'] = true;

$cl = false;



$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
if (!is_array($argv)) $argv = array();
foreach ($argv AS $cmdlineargument) {
	if (substr($cmdlineargument,0,4) == "cfg=") {
			$cmdlineargument = str_replace("cfg=", "" , $cmdlineargument);
			if (is_file($cmdlineargument)) {
				$GLOBALS['CONFIGFILE'] = $cmdlineargument;
				print date('r') . ": Using config file " . $GLOBALS['CONFIGFILE'] . "\n";
				continue;
			} else {
				print "Config file declaration is not correct. Fatal.";
			}
	}
}

$GLOBALS['CMDLINE'] = true;
$GLOBALS['CRON_ADMIN_LOGIN'] = true;
$GLOBALS['overriderepository'] = 0;


if ($_REQUEST['password']) {


} else {
		$cl = true;

		if ($argv[1]=="-help" || $argv[1]=="--help" || $argv[1]=="help" || $argv[1]=="-h") {
			print "\nUsage:\n";
			print "\t[reposnr] [cronpassword]\n";
			print "\nExample: php housekeeping.php 1 cron_password cfg=/path/to/config.inc.php\n\n";
			exit;
		}
		if ($argv[1] > 0) {
			$GLOBALS['overriderepository'] = $argv[1];
		}

		if ($argv[2]) {
			$_REQUEST['password'] = $argv[2];
		} else {
			print date('r') . ": \nUsage:\n";
			print date('r') . ": \t[reposnr] [cronpassword]\n";
			print date('r') . ": \nExample: php housekeeping.php 1 cron_password\n\n";
			exit;
		}
}

require "initiate.php";

require_once $GLOBALS['PATHTOINTERLEAVE'] . "adminfunctions.php";
//require_once $GLOBALS['PATHTOINTERLEAVE'] . "lib/class.phpmailer.php";
require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/phpmailer/PHPMailerAutoload.php';

/* this function redirects the user to index.php if a _SERVER['REQUEST_URI'] is found */
CheckIfShell();

if ($_REQUEST['password']<>GetSetting("cronpassword")) {
	log_msg("ERROR: Housekeeping was called with incorrect password. No notifications were submitted.");
	print("ERROR: Housekeeping was called with incorrect password. No notifications were submitted.");
	if (!$cl) print date('r') . ": ";
	exit;
}


print date('r') . ": Housekeeping running ... \n";
print date('r') . ": Working on " . GetSetting("title") . " - " . $GLOBALS['CRM_VERSION'] . "\n";
print date('r') . ": Running with admin account " . $GLOBALS['USERID'] . " (" . GetUserName($GLOBALS['USERID']) . ")\n";


// Some temporary files don't get processed and they stay behind, there's nothing to do about that.
print date('r') . ": Deleting expired temporary files...\n";
DeleteExpiredTempFiles();

print date('r') . ": Deleting expired locks ...\n";
RemoveExpiredLocks();

print date('r') . ": Deleting expired cache records ...\n";
DeleteExpiredCacheRecords();

print date('r') . ": Running minute-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("run every minute");

if (date('i') == "01") {
	print date('r') . ": Running hour-rules....\n";
	ProcessRulesForAllTablesHavingRulesWithCondition("run every hour");
}
print date('r') . ": Running exact-day-and-time-rules....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("at the exact date and time in [field]");

print date('r') . ": Running one-a-day at time specified in [matchvalue] rules ....\n";
ProcessRulesForAllTablesHavingRulesWithCondition("run once a day at time in [matchvalue]");

print date('r') . ": Processing to-do list ...\n";
ProcessOldTodos();

if (GetSetting("UseMailQueue") == "Yes") {
	print date('r') . ": Moving messages to error queue if they are older than 2 hours...\n";

	mcq("UPDATE CRMmailqueue SET status='error', worker_hash ='stalled in queue', timestamp_last_change = timestamp_last_change WHERE date_queued < DATE_SUB(NOW(), INTERVAL 2 HOUR) AND status='unsent'");

	print date('r') . ": Processing mail queue...\n";
	ProcessMailQueue();
}

UpdateSetting("TimestampLastHousekeeping", date('U'));

print date('r') . ": Done\n";
if (strstr($GLOBALS['tracelog'], "MEM_WARN")) {

	log_msg("ERROR: Housekeeping is consuming more memory than it should! " . $GLOBALS['tracelog']);
}
EndHTML(false);
?>
