<?php
/* ********************************************************************
* Interleave
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* This file handles iCal conversion / requests
*
* Check http://www.interleave.nl/ for more information
*
* BUILD / RELEASE :: 7.2.0.20180308
*
**********************************************************************
*/

/*
 *
 * TODO: check what the change time was and give corresponding status code if not changed. Also, check if somebody isn't requesting too often.
 * TODO: add headers for changed / not changed
 *
 */

$GLOBALS['REALMAUTH'] = true;
require_once "initiate.php";

$debug = false;
if (isset($_REQUEST['debug'])) {
	print "Debug on<br>";
	$debug = true;
}

require_once "lib/icalcreator/iCalcreator.class.php";

$CalObjects = explode(",", $_REQUEST['calObj']);
$t = GetAccessibleCalendars();

$description = array();
foreach ($CalObjects AS $obj) {
	$description[] = $t[$obj]['description'];
}

$config = array( 'unique_id' => GetSetting("title") );

$v = new vcalendar( $config );

$v->setProperty( 'method', 'PUBLISH' );
$v->setProperty( "X-WR-CALDESC", "Interleave iCal Calendar " . GetSetting("title"));

$v->setProperty( "x-wr-calname", implode(", ", $description) );
$v->setProperty( "X-WR-TIMEZONE", "Europe/Amsterdam" );

foreach ($CalObjects AS $CalObj) {

	foreach (GetCalendarEvents($CalObj, "ical") AS $event) {

		list($start_date, $start_time) = explode(" ", $event['iso_start']);
		list($start_year, $start_month, $start_day) = explode("-", $start_date);
		list($start_hour, $start_minute, $start_second) = explode(":", $start_time);

		list($end_date, $end_time) = explode(" ", $event['iso_end']);
		list($end_year, $end_month, $end_day) = explode("-", $end_date);
		list($end_hour, $end_minute, $end_second) = explode(":", $end_time);

		$vevent = & $v->newComponent( 'vevent' );

		$vevent->setProperty( 'dtstart', array( 'year'=>$start_year, 'month'=>$start_month, 'day'=>$start_day, 'hour'=>$start_hour, 'min'=>$start_minute,  'sec'=>$start_second ));
		$vevent->setProperty( 'dtend', array( 'year'=>$end_year, 'month'=>$end_month, 'day'=>$end_day, 'hour'=>$end_hour, 'min'=>$end_minute,  'sec'=>$end_second ));

		$vevent->setProperty( 'organizer' , GetUserEmail($event['user']) );
		$vevent->setProperty( 'summary', html2plaintext($event['summary']));
		$vevent->setProperty( 'description', html2plaintext($event['comment']));
		$vevent->setProperty( 'resources', html2plaintext($event['resource']));

		$vevent->parse( 'LOCATION:'. html2plaintext($event['location']));
		if ($debug) {
			print 'DATE year: ' . $start_year. ' month: ' . $start_month .  ' day: ' . $start_day . " TIME: Start: " . $start_hour . ":" . $start_minute . " End: " . $end_hour . ":" . $end_minute . " Desc: " . $event['summary'] . "<br>";
		}

	}
	log_msg("iCal calendar requested using ical.php. Object " . $_REQUEST['calObj']);

}

if (!$debug) {
	$v->returnCalendar();
}

EndHTML(false);
?>
