<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file enables users to import into tables
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 5.5.1.20120916
 *
 **********************************************************************
 */

require "initiate.php";

if (is_administrator()) {
	require_once "adminfunctions.php";
	$GLOBALS["InAdminSection"] = true;
}
$worker = '';
$mem = '';
$error = false;

ShowHeaders();

print "<form id=\"importForm\" method=\"post\" action=\"\">";
$js_add = "";

if (!$_REQUEST['Worker'] && !$_REQUEST['tableId']) { // No session exists, create one and ask some questions

	$worker = PushStashValue(array("table" => "unknown"));

	$tables = array();
	$set = false;
	if (is_administrator()) {
		$ft = GetFlextableDefinitions();

		foreach ($ft AS $f) {
			$tables[$f['recordid']] = $f['tablename'];
		}
		$tables['users'] = "Users";
		$set = true;
	} else {
		foreach (GetFlextableDefinitions() AS $ft) {
			$configname = "AllowedToImportFT" . $ft['recordid'];
			if (CheckFunctionAccess($configname) == "ok") {
				$tables[$ft['recordid']] = $ft['tablename'];
				$set = true;
			}
		}
		if (CheckFunctionAccess("AllowedToImportUsers") == "ok") {
			$tables['users'] = "Users";
			$set = true;
		}

	}

	if ($set) {
		if (count($tables) > 0) {
			print "Choose table to update or to import into: ";
			print "<select name=\"tableId\" id=\"JS_table\">";
			foreach ($tables AS $table => $name) {
				print "<option value=\"" . htme($table) . "\">" . htme($name) . "</option>";
			}
			print "</select>";
		} else {

		}
	} else {
		PrintAD("You're not allowed to use this functionality");
		$error = true;
	}
} else {
	$worker = "";
	if ($_REQUEST['tableId'] && !$_REQUEST['Worker']) {
		$worker = PushStashValue(array("table" => $_REQUEST['Table']));
		// print "Created worker $worker";
	} else {
		$worker = $_REQUEST['Worker'];
	}

	$mem = PopStashValue($worker);

	if ($mem['table'] && $mem['table'] != "unknown" && !CheckIfUserIsAllowedToImportInTable($mem['table'])) {

		PrintAD("You're not allowed to use this functionality");
		$error = true;

	} else {
		$update_row = false;

		if ($_REQUEST['tableId'] && !$_POST['importBody'] && !isset($_POST['Matched'])) {
			$mem['table'] = $_REQUEST['tableId'];
			if ($mem['table'] && !CheckIfUserIsAllowedToImportInTable($mem['table'])) {
				PrintAD("You're not allowed to use this functionality");
				$error = true;
			} else {
				$ImportHeaderHTMLText = GetAttribute("flextable", "ImportHeaderHTMLText", $_REQUEST['tableId']);

				if ($mem['table'] == "users" && GetSetting("UserImportTableHTML") != "") {
					print GetSetting("UserImportTableHTML");
				} elseif ($ImportHeaderHTMLText != '') {
					print $ImportHeaderHTMLText;
				} else {
					print "Paste values from excel or writer: (tab-delimited):<br>";
					print "<p>A few rules:</p>";
					print "<ul><li>Cell data should not contain a TAB-character</li>";
					print "<li>When cell data contains newline characters (enter), you should quote it's value</li>";
					print "</ul>";
				}
				print "<textarea name=\"importBody\" id=\"JS_importBody\" cols=\"100\" rows=\"4\"></textarea><br>";
			}
		} elseif ($_POST['importBody']) {

			$mem['rawData'] = $_POST['importBody'];
			$mem['arrayData'] = array();
			/*if (strstr($mem['rawData'], "[[LASTCELL]]")) {
				$delim = "\t[[LASTCELL]]";
			} else {
				$delim = "\n";
			}
			//foreach (explode($delim, $mem['rawData']) AS $row) {
			foreach (split_with_quotes($mem['rawData'], "\n", "\"", "\\") as $line)
				$result = explode("\t", $row);
				array_walk($result, 'trim');
				$mem['arrayData'][] = $result;
			}
			*/
			$mem['arrayData'] = ExcelSplit($mem['rawData']);
			//print_r($mem['arrayData']);
			//exit;
			$mem['rawData'] = "";
			$mem['headerData'] = $mem['arrayData'][0];



			$fields = array();
			if (is_numeric($mem['table'])) {
				$fields = array("none" => "none/ignore");
				$tab = GetFlextableDefinitions($mem['table']);
				$tab = $tab[0];
				$fields = array("none" => "none/ignore", "updateFlexRecord" => "Map to current record-id, update instead of import (non-matching rows will not be imported)");

				$extrafields = db_GetArray("SELECT CONCAT('EFID', id) AS id, name FROM CRMextrafields WHERE (fieldtype IN ('textbox', 'drop-down', 'numeric', 'mail', 'text area', 'text area (rich text)', 'hyperlink', 'date', 'date (iso)', 'checkbox', 'diary', 'date/time', 'Reference to FlexTable',  'Reference to FlexTable (multiselect)', 'phone number') OR fieldtype LIKE 'User-%' OR fieldtype LIKE 'List of all active%') AND deleted='n' AND tabletype='" . $mem['table'] . "'  ORDER BY ordering");
				//AND SUBSTR(options, 1, 18) != '%POPULATE_BY_CODE%'

				//DA($extrafields);
				foreach ($extrafields AS $row) {
					$fields[$row['id']] = $row['name'];
				}
				foreach ($extrafields AS $row) {
					$fields["updateFlexRecord-" . $row['id']] = "Map to " . $row['name'] . ", update instead of import  (non-matching rows will be imported)";
				}
				$mem['SQLtable'] = "CRMflextable" . $mem['table'];
				//DA($fields);

			} elseif ($mem['table'] == "users") {
				$fields = array("none" => "none/ignore", "name" => "Account name", "FULLNAME" => "Full name", "PASSWORD" => "Password", "PROFILE" => "Group ID", "EMAIL" => "E-mail address");

				$mem['SQLtable'] = "CRMloginusers";
			}

			if (count($mem['arrayData']) > 1) {
				print "Received a sheet with " . (count($mem['arrayData']) - 1) . " rows. The first line will be interpreted as header line and thus be ignored while importing!<br><br>";

				$_POST['importBody'] = "";

				print "<table class=\"crm\"><thead><tr><th>Column from import</th><th>Matches field</th><th>Search</th><th>Sheet validates?</th></tr></thead>";
				$headerId = 0;
				foreach ($mem['headerData'] AS $headerCell) {
					$id = 'JS_' . randomstring(16);
					$matchArray = "<select name=\"matchArray" . $headerId . "\" id=\"JS_matchArray" . $headerId . "\" onchange=\"";
					$matchArray .= "refresh_contents_of_div('" . $id . "', 'assist.php', 'Function=ValidateInput&Run=1&Worker=" . $worker . "&Header=" . ($headerId) . "&Table=" . $mem['table'] . "&SelectedField=' + document.getElementById('JS_matchArray" . $headerId . "').options[document.getElementById('JS_matchArray" . $headerId . "').selectedIndex].value, true, 'POST', '', false);\" >";

					foreach ($fields AS $fieldname => $desc) {

						$ins = "";
						if (trim(strtolower($headerCell)) == trim(strtolower($desc))) {
							$ins = " selected";

							$js_add .= "refresh_contents_of_div('" . $id . "', 'assist.php', 'Function=ValidateInput&Run=1&Worker=" . $worker . "&Header=" . ($headerId) . "&Table=" . $mem['table'] . "&SelectedField=' + document.getElementById('JS_matchArray" . $headerId . "').options[document.getElementById('JS_matchArray" . $headerId . "').selectedIndex].value, true, 'POST', '', false);";
						}
						$matchArray .= "<option " . $ins . " value=\"" . $fieldname . "\">" . htme($desc) . "</option>";

					}
					$matchArray .= "</select></td><td>" . ReturnDropDownSearchField("JS_matchArray" . $headerId . "");

					print "<tr><td>" . htme($headerCell) . "</td><td>" . ($matchArray);

					print "</td><td>";


					print '<div id="' . $id . '"></div>';
						print "</td></tr>";
					$headerId++;
				}
				print "</table><p>";
				if (is_administrator()) {
					print "<p id=\"kick_recalc\"><input type=\"checkbox\" name=\"dis_trigger\" value=\"true\" checked>Disable MySQL triggers</p>";
					print "<p id=\"kick_update\"><input type=\"checkbox\" name=\"dis_def\" value=\"true\" checked>Disable adding of default values</p>";
					print "<p id=\"no_newer_than\">Don't update records changed after <input type=\"text\" class=\"datetimepicker\" name=\"update_only_older\" id=\"JS_update_only_older\"></p>";
				}
				print "<br><br>When you click \"go\" you will actually import or update. Use with care!<br><br>";
				print "<input type=\"hidden\" name=\"Matched\" value=\"true\"></p>";
			} else {
				print "<p>Only one row found. Since the first row must be the header row, this sheet effectively contains zero rows. Quitting.</p>";
				$error = true;
			}

		} elseif ($_POST['Matched'] == "true") {
			$counter =0;
			$upd = false;
			foreach ($mem['headerData'] AS $headerCell) {
				//print "Match: " . $headerCell . " to " . $_POST['matchArray' . $counter] . "<br>";
				$mem['headerMatchArray'][trim($headerCell)] = trim($_POST['matchArray' . $counter]);

				$counter++;
				$name = trim($headerCell);
				if (substr($mem['headerMatchArray'][$name],0,16) == "updateFlexRecord") {
					$upd=true;
				}
			}

			$error = false;
			$errors = "";

			if (is_numeric($mem['table'])) {
				 if (!$upd) {
					$tab = GetFlextableDefinitions($mem['table']);
					$tab = $tab[0];

				}
			}


			// Double-field check
			$done = array();
			foreach ($mem['headerMatchArray'] AS $header => $destination) {
				if (in_array($destination, $done) && $destination != "none") {
					$error = true;
					$errors .= "<span class=\"errmsg\">Field \"" . htme($header) . "\" was mapped to field \"" . htme(GetExtraFieldName(str_replace("EFID", "", $destination))) . "\" but another field was already mapped to this destination.</span><br><br>";
				}
				$done[] = $destination;
			}

			$mem['sql'] = array();


			if (!$error) {
				$errors = "<table class=\"crm\"><thead><tr><th>Field</th><th>Destination</th><th>Type</th><th>Input value</th><th>Row</th><th>Cell</th><th>Remarks</th></tr></thead>";

				$rowcounter = 1;
				print 'iterate, rows: ' . count($mem['arrayData']) . ', header width ' . count($mem['headerData']) . ', matchheader width ' . count($mem['headerMatchArray']) . '<br>';
			//	DA($mem['headerData']);
			//	DA($mem['headerMatchArray']);
				$tmpsql_update_back = '';

				foreach ($mem['arrayData'] AS $row) {
//					DA($row);

					if ($row != $mem['headerData']) {

						$tmpsql = "INSERT INTO " . $mem['SQLtable'] . "(";
						$tmpsql_update_front = "UPDATE " . $mem['SQLtable'] . " SET ";
						$tmpsql_update_args = array();

						$nf = false;
						$bla=0;
						foreach ($mem['headerMatchArray'] AS $header => $destination) {
							if ($destination != "none") {
								if ($nf) {
									$tmpsql .= ",";
								}
								$bla++;
								$tmpsql .= str_replace('updateFlexRecord-', '', $destination);
								$nf = true;
								if (substr($destination,0,16) == "updateFlexRecord") {
									$update_row = true;
								}
							}
						}
						//DA($mem['headerData']);

						$tmpsql .= ") VALUES(";
						$nf = false;
						$cnt = 0;
						//DA($row);
						foreach ($row AS $origdata) {



							$name = trim($mem['headerData'][$cnt]);

							$field = str_replace("EFID", "", $mem['headerMatchArray'][$name]);
							$cnt++;
							if ($mem['headerMatchArray'][$name] != "none") {

								$res = "";
								$ret = "";

								/* don't check numeric record id's when importing a ref-to-flex field. WE SHOULD  */
								if (GetExtraFieldType($field) == "Reference to FlexTable" && ipi($origdata)) {

									$res = "ok";
									$ret = $origdata;

								} else {
									list ($res, $msg, $ret) = ValidateFieldInput($field, trim($origdata), $mem['table']);
								}

								$data = "";
								if ($res == "ok") {
									// all ok
									$data = trim($ret);
								}


								if (GetExtraFieldType($field) == "diary") {

									$tmp = explode("\n", $data);
									$data = array();
									foreach ($tmp AS $el) {
										if (trim($el) != "") {
											$data[] = array(date('U'), $GLOBALS['USERID'], $el);
										}
									}
									$data = serialize($data);

								} elseif (GetExtraFieldType($field) == "date/time") {
									// niks
								} elseif (GetExtraFieldType($field) == "date (iso)") {
									$data = NLDate2INTLDate(FormattedDateToNLDate($data));
								} elseif (strstr(GetExtraFieldType($field), "multiselect")) {
									// Explode on comma and serialize it
									$data = serialize(explode(",", $data));
								}
								/* if (substr($data,0,10) != "{{{nok}}}}") { */

								if ($res == "ok") {
									if ($nf) $tmpsql .= ",";
									$tmpsql .= "'" . mres($data) . "'";

									if ($update_row) {
										if (substr($mem['headerMatchArray'][$name],0,16) == "updateFlexRecord") {


											if ($mem['headerMatchArray'][$name] == "updateFlexRecord") {

												$tmpsql_update_back = " WHERE CRMflextable" . $mem['table'] . ".recordid = '" . mres($data) . "'";

											} else {
												$to_field = str_replace("updateFlexRecord-", "", $mem['headerMatchArray'][$name]);

												/* we materialize here in order to avoid matching imported records later on */

												$material = "SELECT recordid FROM CRMflextable" . $mem['table'] . " WHERE CRMflextable" . $mem['table'] . "." . $to_field . " = '" . mres($data) . "'";
												$materialized = db_GetFlatArray($material);

												$tmpsql_update_back = " WHERE CRMflextable" . $mem['table'] . ".recordid IN (" . implode(",", $materialized) . ")";

												if ($_REQUEST['update_only_older'] != '') {
													$tmpsql_update_back .= " AND timestamp_last_change < '" . mres(StrDateTime2IsoDateTime($_REQUEST['update_only_older'])) . "'";
												}

												/* if no match, we fall back to regular import */
												if (count($materialized) == 0) {
													$update_row = false;
												}
											}

										} else {
											if (trim($data) != "") {
												$tmpsql_update_args[] = $mem['headerMatchArray'][$name] . " = '" . mres($data) . "'";
											}
										}
									}
									$nf = true;
								} else {
									$error = true;
									$displayfield = $field;
									$type = GetExtraFieldType($field);
									$errors .= "<tr><td>" . $name . "</td><td>" . GetExtraFieldName($displayfield) . "</td><td>" . $type . "</td><td>\"" . htme(trim($origdata)) .  "\" </td><td>" . $rowcounter . "</td><td>" . $cnt . "</td><td>";
									if (GetExtraFieldType($field) == "drop-down") {
										$errors .= " Valid values for this field are: ";
										foreach (GetExtraFieldOptions($field) AS $option) {
											$errors .= htme($option) . " ";
										}
									} elseif (GetExtraFieldType($field) == "numeric") {
										$errors .= "Field must be numeric";
									} elseif (GetExtraFieldType($field) == "mail") {
										$errors .= "Field must contain a valid email address";
									} elseif (GetExtraFieldType($field) == "date") {
										$errors .= "Field must contain a valid date in format: " . $GLOBALS['UC']['DateFormat'];
									} else {
										$errors .= "unknown error.";
									}
									$errors .= "</td></tr>";
								}
							} else {
							//	 print "skip field";
							}

						} // end foreach row as origdata
						//print "Nu $cnt veldwaardes opgeslagenm<br>";
						$tmpsql .= ")";
						$nnf = false;
						if ($update_row) {
							$tmp = $tmpsql_update_front;
							foreach ($tmpsql_update_args AS $ar) {
								if ($nnf) $tmp .= ",";
								$tmp .= $ar;
								$nnf = true;
							}
							$tmp .= $tmpsql_update_back;
							if ($nnf) {
								$mem['sql'][] = $tmp;
							}
						} else {
							$mem['sql'][] = $tmpsql;
						}

					} else {
						/* if (count($row) == count($mem['headerMatchArray']) && $row != $mem['headerData'])  */
						/* this message will also be printed for the header which is useless */
 						//print 'Row count (' . count($row) . ') not equal to header count (' . count($mem['headerMatchArray']) . ') or data exactly the same as header.<br>';
					}

					$rowcounter++;
				}
				$errors .= "</table>";
			}

			if ($error) {

				print "This data cannot be imported because errors were encountered:<br><br>" . $errors;

			} else {

				$GLOBALS['CRON_RUNNING'] = true;
				if (is_administrator()) print "Number of generated queries: " . count($mem['sql']) . "<br>";

				/* disable triggers! */
				if ($_REQUEST['dis_trigger'] == 'true' && is_administrator()) {
					disable_mysql_triggers();
				}

				foreach ($mem['sql'] AS $sql) {

					//print htme($sql) . '<br>';


					mcq($sql);

					$new_id = db_GetInsertId();

					$dstable = $mem['table'];

					if (ipi($dstable)) {
						$dstable = "t" . $dstable;
					}

					if ($_REQUEST['dis_def'] != 'true') {
						add_default_values_for_fields($dstable, $new_id, array());
					}



					// Create default fields and kick triggers


				}
				if ($update_row) {
					print "Done; " . count($mem['sql']) . " records updated.";
				} else {
					print "Done; " . count($mem['sql']) .  " records imported.";
				}
				if ($_REQUEST['dis_trigger'] == 'true' && is_administrator()) {
					print '<br>Warning: mysql triggers were disabled while importing!';
				}
				$error = true;
			}
		}


	}
}
UpdateStashvalue($worker, $mem);
print "<input type=\"hidden\" name=\"Worker\" value=\"" . $worker . "\">";
if (!$error) {
	print "<input type=\"submit\" name=\"submitButton\" value=\"" . $lang['go'] . "\">";
}
print "</form>";
if ($js_add != "") {
	print "<script type=\"text/javascript\">\n";
	print "<!--\n";
	print "var t = setTimeout('StartInit()', 1500);\n";
	print "function StartInit() {\n";
	print "alert('This procedure will now try to validate each auto-matched field.');\n";
	print $js_add;
	print "}\n";
	print "//-->\n";
	print "</script>\n";
}
EndHTML();

function CheckIfUserIsAllowedToImportInTable($tableid) {
	if (is_administrator()) {
		return true;
	} elseif ($tableid == "users" && CheckFunctionAccess("AllowedToImportUsers") == "ok") {
		return true;
	} elseif (is_numeric($tableid) &&CheckFunctionAccess("AllowedToImportFT" . $tableid) == "ok") {
		return true;
	} else {
		return false;
	}
}
?>
