<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file does several things :)
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */

/* the file containing the shutdown function */
require "shutdownfunction.php";

/* register the function to call when something goes seriously wrong */
register_shutdown_function( "last_function_called_on_every_execution" );

/* set error reporting level */
ini_set("error_reporting", "E_ALL & ~E_NOTICE & ~E_DEPRECATED");

/* internal encoding */
mb_internal_encoding("UTF-8");

//CONFIGFILE is reeds gezet als we via CMDLINE binnen komen
if (!$GLOBALS['CMDLINE'])
{
	$t = $_SERVER['SCRIPT_FILENAME'];
	$t = str_replace("\\","/", $t);
	$u = explode("/", $t);
	$path = "";
	for ($p = 0; $p < sizeof($u)-1; $p++)
	{
		$path .= $u[$p] . "/";
	}
	$GLOBALS['PATHTOINTERLEAVE'] = $path;

	$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
}

require $GLOBALS['PATHTOINTERLEAVE'] . "functions.php";

if (!file_exists($GLOBALS['CONFIGFILE']) || filesize($GLOBALS['CONFIGFILE'])==0)
{
	header("Location: install.php");
	exit;
}
require $GLOBALS['CONFIGFILE'];
require $GLOBALS['PATHTOINTERLEAVE'] . "config/config-vars.php";

list($usec, $sec) = explode(" ", microtime());
$GLOBALS['starttime'] = ((float)$usec + (float)$sec);
$GLOBALS['tracelog'] = date('Ymd H:i:s') . " start\n";

//$GLOBALS['allowed_number_of_mysql_crashes'] = 1;

/* initialize globals */
$GLOBALS['url_to_redirect_to'] = '';


if ($GLOBALS['logrequests'])
{
	$GLOBALS['page_id'] = randomstring(32);
	@$fp = fopen("querylog.txt","a");
	@fputs($fp,$GLOBALS['USERNAME'] . ":" . $_SERVER['SCRIPT_NAME'] . " " . $_SERVER['QUERY_STRING'] . " id: " . $GLOBALS['page_id'] . "\n");
	@fclose($fp);
}


$GLOBALS['USERID'] = 0;

$repository = 0;
if (count($host) > 1)
{
	//voor dav en caldav
	if (is_positive_integer_or_zero($GLOBALS['overriderepository']))
	{
		$repository = $GLOBALS['overriderepository'];
	}
	else if (is_positive_integer_or_zero($_POST['repository']))
	{
		$repository = $_POST['repository'];
	}
	else if (is_positive_integer_or_zero($_GET['repository']))
	{
		$repository = $_GET['repository'];
	}
	else if (is_positive_integer_or_zero($_COOKIE['repository']))
	{
		$repository = $_COOKIE['repository'];
	}

	if ($host[$repository] == "")
	{
		$repository = 0;
	}
}

if (($GLOBALS['logqueries']) || ($GLOBALS['logtext']))
{
	$GLOBALS['mysql_query_counter'] = 0;
	$fp = @fopen("qlist.txt","a");
	@fputs($fp,"=============================================================================\n");
	@fputs($fp,$_SERVER['PHP_SELF'] . " " . date("d-m-Y H:i:s") . "s (" . fillout($_SERVER['QUERY_STRING'], 80,true) . ")\n");
	@fclose($fp);
}

/*
if ((count($_GET) > 400) || (count($_POST) > 400))
{
    mail("jeroen@atomos.nl", "GET: " . count($_GET) . " POST: " . count($_POST), $_SERVER["REQUEST_URI"]);
}
*/


if (!DB_Connect($repository))
{
	handle_error("error connecting repository: \"" . $repository . "\" host: \"" . $host[$repository] . "\"");
}

// Catch version having the wrong database version
if ($GLOBALS['VERSION'] != GetSetting('DBVERSION'))
{
	IntermediateDatabaseUpgrade();
}

$timeout = GetSetting("timeout");
if (!is_positive_integer($timeout))
{
	$timeout = 20;
}

$base = "";
if (GetSetting("UseURLBeautification") == "Yes")
{
	//2016-02-03 we zouden hem ook ALTIJD kunnen zetten ongeacht beautification (?)
	$base = GetSetting("BASEURL");
}
$GLOBALS['BASE'] = $base;

if (GetSetting('WebAppEnabled') != 'Yes')
{
	$GLOBALS['webapp'] = false;
}

$GLOBALS['BYAJAX'] = false;
if ($_GET['BYAJAX'] == 1)
{
	$GLOBALS['BYAJAX'] = true;
}

$self = "index.php";
if ($GLOBALS['webapp'])
{
	$self = "webapp.php";
}

if (!$GLOBALS['CMDLINE'])
{
	$allowedipadresses = GetSetting("ALLOWEDIPADRESSES");
	if ($allowedipadresses != "")
	{
		$ip_arr = explode(";", $allowedipadresses);
		if (!in_array($_SERVER['REMOTE_ADDR'], $ip_arr))
		{
			if ($GLOBALS['webapp'])
			{
				//slordig maar deze kan unauth gerunt worden voor de webapp
				ShowHeaders();
			}
			else
			{
				PrintHTMLHeader();
				print '<title>' . $GLOBALS['PRODUCT'] . '</title>';
				print '<link rel="shortcut icon" href="favicon.ico">';
				print '<meta name="viewport" content="width=device-width, initial-scale=1">';
				print '</head>';
				print '<body class="loginform">';
			}
			print 'Access to this application is not allowed from your source address';
			print '</body>';
			print '</html>';
			EndHTML(false);
			exit;
		}
	}
}

$resetpasswordcode_ok = false;
$resetpassword_userid = 0;
$newpassword_invalid = false;

$login_invalid = false;
$session_invalid = false;

$attempt_username = "";
$attempt_password = "";
$login_without_password = false; //nodig voor commandlinelogin
$create_session_on_successful_login = false;

$securecookie = false;
if ($_SERVER['HTTPS'] == "on")
{
	$securecookie = true;
}

$ALLOWLOGONPAGEPASSCHANGE = false;
$show_resetpassword = false;
if (GetSetting("ALLOWLOGONPAGEPASSCHANGE") == "Yes")
{
	$ALLOWLOGONPAGEPASSCHANGE = true;
	if (isset($_GET['resetpassword']))
	{
		$show_resetpassword = true;
	}
}

if ($ALLOWLOGONPAGEPASSCHANGE)
{
	if ($_GET['resetpasswordcode'] != "")
	{
		//BINARY om case sensitive te matchen
		$resetpassword_userid = db_GetValue("SELECT `entity` FROM `CRMattributes` WHERE `identifier`='user' AND `attribute`='resetpasswordcode' AND BINARY `value`='" . mres($_GET['resetpasswordcode']) . "'");

		if ($resetpassword_userid > 0)
		{
			$resetpassword_userid = db_GetValue("SELECT `id` FROM `CRMloginusers` WHERE `active`='yes' AND `id`=" . $resetpassword_userid); // AND `administrator`='no'
			if ($resetpassword_userid > 0)
			{
				$resetpasswordcode_validity = GetAttribute("user", "resetpasswordcode_validity", $resetpassword_userid);
				if ($resetpasswordcode_validity > date("U"))
				{
					$resetpasswordcode_ok = true;
					if (($_POST['pw1'] != "") || ($_POST['pw2'] != ""))
					{
						if ((strlen($_POST['pw1']) > 4) && ($_POST['pw1'] == $_POST['pw2']))
						{
							//we loggen direct in na het aanpassen van het wachtwoord
							$attempt_username = db_GetValue("SELECT `name` FROM `CRMloginusers` WHERE `id`=" . $resetpassword_userid);
							$attempt_password = $_POST['pw1'];
							$create_session_on_successful_login = true;

							mcq("UPDATE `CRMloginusers` SET `password`=PASSWORD('" . mres($_POST['pw1']) . "'), `LASTPASSCHANGE`=NOW(), `FORCEPASSCHANGE`='n' WHERE `id`=" . $resetpassword_userid);
							//delete all current sessions of this user
							mcq("DELETE FROM `CRMsessions` WHERE `userid`='" . mres($resetpassword_userid) . "'");

							log_msg("User [" . $attempt_username . "] id [" . $resetpassword_userid . "] set a new password via the password reset link");
						}
						else
						{
							$newpassword_invalid = true;
						}
					}
				}
			}
		}
	}
}

//TODO al deze compares vooraf laten gaan aan een check op cookie['session'] ?
if (($_POST['username'] != "") || ($_POST['password'] != ""))
{
	$attempt_username = $_POST['username'];
	$attempt_password = $_POST['password'];
	$create_session_on_successful_login = true;
}
//TODO inlog via GET zouden we eigenlijk niet toe moeten staan
else if (($_GET['username'] != "") || ($_GET['password'] != ""))
{
	$attempt_username = $_GET['username'];
	$attempt_password = $_GET['password'];
	$create_session_on_successful_login = true;
}
else if (($_SERVER['PHP_AUTH_USER'] != "") || ($_SERVER['PHP_AUTH_PW'] != ""))
{
	$attempt_username = $_SERVER['PHP_AUTH_USER'];
	$attempt_password = $_SERVER['PHP_AUTH_PW'];
}
else if ($GLOBALS['CMDLINE'])
{
	if ($GLOBALS['CRON_ADMIN_LOGIN'])
	{
		$attempt_username = db_GetValue("SELECT `name` FROM `CRMloginusers` WHERE `administrator`='yes' AND `active`='yes'");
		$login_without_password = true;
	}
	else
	{
		$attempt_username = $GLOBALS['cmdline_username'];
		//TODO slordig
		if ($GLOBALS['cmdline_password'] == "NOPASS")
		{
			$login_without_password = true;
		}
		else
		{
			$attempt_password = $GLOBALS['cmdline_password'];
		}
	}
}
else if ($GLOBALS["run_unauthenticated_module"])
{
	$module_id = db_GetValue("SELECT mid FROM CRMmodules WHERE mid='" . mres($GLOBALS["module_id"]) . "' AND version_belonging_to=0");
	if ($module_id > 0)
	{
		if (GetAttribute("module", "UnauthenticatedAccess", $module_id) == "Yes")
		{
			$RunAsUser = GetAttribute("module", "RunAsUser", $module_id);
			if (is_positive_integer($RunAsUser))
			{
				$attempt_username = db_GetValue("SELECT `name` FROM `CRMloginusers` WHERE `id`=" . $RunAsUser);
				$login_without_password = true;
			}
			else
			{
				print "err3";
				exit;
			}
		}
		else
		{
			print "err2";
			exit;
		}
	}
	else
	{
		print "err1";
		exit;
	}
}

$name = "";

//resetpassword gaat ook door deze anti-hack code
if (($attempt_username != "") || ($attempt_password != "") || ($_POST['usernameresetpassword'] != ""))
{
	//JH 2015-11-18 dit was voorheen de functie LogAndCheckLogin()
	if (file_exists("logins.txt"))
	{
		$then = date('U') - 600;
		$hacklist = "";
		$hackcounter = 0;

		$name = $attempt_username;
		if ($name == "")
		{
			$name = $_POST['usernameresetpassword'];
		}
		if ($name == "")
		{
			$name = "{{{empty}}}";
		}

		$t = tail_file("logins.txt", 500);
		foreach ($t AS $line)
		{
			$logline = explode("::", $line);
			if ($logline[0] == $_SERVER['REMOTE_ADDR'] && ($logline[1] > $then) && trim($logline[3]) == "false")
			{
				$hackcounter++;
				$hacklist .= $line;
			}
			elseif ($logline[0] == $_SERVER['REMOTE_ADDR'] && ($logline[1] > $then) && trim($logline[3]) == "true")
			{
				$hackcounter = 0;
			}
		}

		if ($hackcounter > 10)
		{
			if (ValidateEmail($GLOBALS['LoginTryCountNotifyTo']))
			{
				$fp = "Warning; safety block in effect for IP " . $_SERVER['REMOTE_ADDR'] . ", current user " . $name .". Repository: " . GetSetting("title") . ". Host: " . $_SERVER['HTTP_HOST'] . "\n\nList of login attempts:\n\n" . $hacklist;
				mail($GLOBALS['LoginTryCountNotifyTo'], GetSetting("title") . ': Safety block in effect', $fp, "From: " . $GLOBALS['PRODUCT'] . " Notification Manager <info@interleave.nl>");
			}
			print '<!DOCTYPE html>';
			print '<html>';
			print '<head><meta charset="UTF-8">';
			print '<title>Safety restriction in effect</title>';
			print '<link rel="shortcut icon" href="favicon.ico">';
			print '<meta name="viewport" content="width=device-width, initial-scale=1">';

			PrintUnauthenticatedHeaderJavascript();

			print '</head><body class="loginform"><div id="page"><h1 id="title">' . htme($GLOBALS['PRODUCT']) . '</h1><h2>Safety restriction in effect</h2>';
			print '<p>You tried to log in many times but failed every time. For security reasons, this incident has been reported along with your computer\'s IP-address.</p>';
			print '<p>If you forgot your password, you can <a href="?resetpassword">request a new one</a>.</p>';
			print '<p>If you would like an account please contact this site\'s administrator (name/e-mail not mentioned intentionally).</p>';
			print '<br><br><div class="centered">';
			print '<img src="images/interleave.gif" alt="">';
			print '</div></div></body></html>';
			EndHTML(false);
			exit;
		}
	}
}

$attempt_sessionid = "";
if ($_COOKIE['sessionid'] != "")
{
    $attempt_sessionid = $_COOKIE['sessionid'];
}
else if ($_POST['sessionid'] != "")
{
    $attempt_sessionid = $_POST['sessionid'];
}
else if ($_GET['sessionid'] != "")
{
    $attempt_sessionid = $_GET['sessionid'];
}


$logonmsg = "";
if (($attempt_username != "") || ($attempt_password != ""))
{
	//TODO session cookie overschrijven naar niks zodat je eventuele bestaande sessie kwijtraakt?
	if ($attempt_username == "")
	{
		$login_invalid = true;
	}
	else if (($attempt_password == "") && (!$login_without_password))
	{
		$login_invalid = true;
	}
	else
	{
		//TODO als de ref uit sessions op id gaat kunnen we hier db_GetValue gebruiken
		$sql = "SELECT `id`, `name` FROM `CRMloginusers` WHERE (`name`='" . mres($attempt_username) . "' OR `EMAIL`='" . mres($attempt_username) . "') AND `active`='yes'";

		if (!$login_without_password)
		{
			$sql .= " AND `password`=PASSWORD('" . mres($attempt_password) . "')";
		}
		$user = db_GetRow($sql);
		if ($user['id'] == 0)
		{
			$login_invalid = true;
			log_msg("WARNING: Invalid user/pass combination: user \"" . $attempt_username . "\"");
		}
		else
		{
			$GLOBALS['USERID'] = $user['id'];
			if ($create_session_on_successful_login)
			{
				mcq("UPDATE CRMloginusers SET TRACE='Off' WHERE id=" . $GLOBALS['USERID']);
				$noexp = 'n';
				$expire = 0; //geldig totdat de browser wordt afgesloten
				if ($GLOBALS['webapp'])
				{
					$noexp = 'y';
					$expire = time() + 60 * 60 * 24 * 365 * 15; //sessie wordt 15 jaar bewaard door de browser; aangezien het sessie cookie nooit overschreven wordt moet er na 15 jaar opnieuw worden ingelogd; ook al heb je die 15 jaar iedere dag de applicatie gebruikt
				}

				$sessionid = randomstring(32);
				//TODO exptime zou een datetime column moeten zijn
				mcq("INSERT INTO `CRMsessions` (`temp`, `exptime`, `userid`, `noexp`, `ip`) VALUES('" . mres($sessionid) . "', UNIX_TIMESTAMP(), '" . mres($user['id']) . "', '" . $noexp . "','" . mres($_SERVER['REMOTE_ADDR']) . "')");

				log_msg("Login " . $user['name']);

				//TODO liever vaste database velden
				//op een normale login wordt de resetpasswordcode overschreven
				SetAttribute("user", "resetpasswordcode", "", $user['id']);
				SetAttribute("user", "resetpasswordcode_validity", 0, $user['id']);

				if (count($host) > 1)
				{
					//wordt 30 dagen bewaard
					setcookie("repository", $repository, time()+30*24*60*60, get_uri_from_base($GLOBALS['BASE']), "", $securecookie, true);
				}
				setcookie("sessionid", $sessionid, $expire, get_uri_from_base($GLOBALS['BASE']), "", $securecookie, true);

				// needed for EndSession
				$GLOBALS["sessionid"] = $sessionid;

				$logonmsg = GetSetting("Logon message");

				// HF20160506 TODO: Rule "a user logs in" wordt nog niet gekicked hier
			}
		}
	}

	if (file_exists("logins.txt"))
	{
		$result = "true";
		if ($login_invalid)
		{
			$result = "false";
		}
		$extra = "";
		if ($fp = @fopen("logins.txt","a"))
		{
			fputs($fp, $_SERVER['REMOTE_ADDR'] . "::" . date('U') . "::" . $name . "::" . $result . "::" . $extra . "::" . GetSetting("title") . "::" . $_SERVER['HTTP_HOST'] . "::" . $_SERVER['PHP_SELF'] . "\n");
			fclose($fp);
		}
	}
}
else if ($attempt_sessionid != "") {

	$session_invalid = false;

	//noexp/webapp sessies zijn twee weken geldig
	mcq("DELETE FROM `CRMsessions` WHERE (`exptime`<UNIX_TIMESTAMP()-" . $timeout . "*60 AND noexp='n') OR (`exptime`<UNIX_TIMESTAMP()-1209600 AND noexp='y')");

	$sql = "SELECT `CRMloginusers`.`id`, `CRMsessions`.`noexp`, `CRMsessions`.`temp` FROM `CRMsessions`, `CRMloginusers` WHERE `CRMsessions`.`temp`='" . mres($attempt_sessionid) . "' AND `CRMsessions`.`userid`=`CRMloginusers`.`id` AND `CRMloginusers`.`active`='yes'";
	if (GetSetting('BindSessionToIP') != "No")
	{
		//ip check is skipped for webapp (noexp=y) sessions
		$sql .= " AND (`CRMsessions`.`noexp`='y' OR `CRMsessions`.`ip`='" . mres($_SERVER['REMOTE_ADDR']) . "')";
	}

	$session = db_GetRow($sql);

	$userid = $session["id"];
	//we use the "noexp" column to check if this is a webapp session -> this is a bit nasty
	//the webapp must (at this moment) still be enabled; otherwise this user will get a regular session
	if (($session["noexp"] == "y") && (GetSetting('WebAppEnabled') == 'Yes'))
	{
		$GLOBALS['webapp'] = true;
	}
	if (($userid == 0) || ((isset($_GET['logout'])) || (isset($_POST['logout']))))
	{
		if ($userid == 0)
		{
			$session_invalid = true;
		}
		else //er is dus op de logout link geklikt
		{
			//dit is wat lomp om een db_GetValue te moeten doen
			log_msg("Logoff " . db_GetValue("SELECT `name` FROM `CRMloginusers` WHERE `id`=" . $userid));
			SetAttribute("user", "LastLogout", date('U'), $GLOBALS['USERID']);
		}
		if ($session["temp"] != "")
		{
			mcq("DELETE FROM `CRMsessions` WHERE `temp`='" . mres($session["temp"]) . "'");
		}
		//expiry 1 dag geleden zodat hij wordt weggegooid door de browser
		setcookie("sessionid", "", time()-24*60*60, get_uri_from_base($GLOBALS['BASE']), "", $securecookie, true);
		//Engels zou "of to" moeten zijn ipv "off to"
		if ($_GET['offto'] != "" && GetSetting('DevelopmentOrProduction') != 'Development')
		{
			header("Location: " . base64_decode($_GET['offto']));
			exit;
		}
	}
	else
	{
		//repository switcher is alleen in gebruik bij FS
		//geen fraaie code dit, maar het werkt
		//geen webapp support
		if ((is_positive_integer_or_zero($_GET['switchtorepos'])) && ($_GET['switchtorepos'] != $repository))
		{
			//TODO sessie uit huidige repository verwijderen
			$user = db_GetRow("SELECT `name`, `password` FROM `CRMloginusers` WHERE `id`=" . $userid);
			if (($host[$_GET['switchtorepos']] != "") && (DB_Connect($_GET['switchtorepos'])))
			{
				$user_in_other_repos = db_GetValue("SELECT `id` FROM `CRMloginusers` WHERE `name`='" . mres($user['name']) . "' AND `password`='" . mres($user['password']) . "'");
				if ($user_in_other_repos > 0)
				{
					//code duplicatie
					//BASE van andere repository zou anders kunnen zijn
					//er zou ip restrictie op andere repository kunnen zitten. daar loop je dan tegenop na de redirect

					$sessionid = randomstring(32);
					//TODO ref op basis van user id ipv user name
					//TODO exptime zou een datetime column moeten zijn
					mcq("INSERT INTO `CRMsessions` (`temp`, `exptime`, `userid`, `ip`) VALUES('" . mres($sessionid) . "', UNIX_TIMESTAMP(), '" . mres($user_in_other_repos) . "','" . mres($_SERVER['REMOTE_ADDR']) . "')");
					log_msg("Login " . $user['name']);

					//TODO liever vaste database velden
					//op een normale login wordt de resetpasswordcode overschreven
					SetAttribute("user", "resetpasswordcode", "", $user_in_other_repos);
					SetAttribute("user", "resetpasswordcode_validity", 0, $user_in_other_repos);

					if (count($host) > 1)
					{
						//wordt 30 dagen bewaard
						setcookie("repository", $_GET['switchtorepos'], time()+30*24*60*60, get_uri_from_base($GLOBALS['BASE']), "", $securecookie, true);
					}
					setcookie("sessionid", $sessionid, 0, get_uri_from_base($GLOBALS['BASE']), "", $securecookie, true);

					header("Location: " . $self);
				}
				exit;
			}
		}

		//we do not wish to set a new session time for non-user-initiated calls (like the watch list or checkmessages)
		if (!$GLOBALS['dontsetnewsessiontime'])
		{
			//TODO exptime is een misnomer; het is de last activity time
			mcq("UPDATE `CRMsessions` SET `exptime`=UNIX_TIMESTAMP() WHERE `temp`='" . mres($session["temp"]) . "'");
//JH 2017-08-29 not in use; so commented to save 6ms on cluster update
//			SetAttribute("user", "LastActivity", date('U'), $GLOBALS['USERID']);
			//bij record en list calls (die gebruik maken van locks) is dontsetnewsessiontime niet gezet
			if (GetSetting('EnableEntityLocking') == 'Yes')
			{
				RemoveExpiredLocks();
			}
		}
		$GLOBALS["USERID"] = $userid;

		// needed for EndSession
		$GLOBALS["sessionid"] = $session["temp"];
	}
}


/*
//we are in the webapp
//but this load is not by ajax
//the only page that should be loaded is webapp.php
//if it is not; we redirect to it
//UNLESS dl=1 OR the opened page is csv.php (which both are downloads)

//Sadly; this doesn't work because not all ajax calls use BYAJAX=1; for instance assist.php?checkUserEvents. this could be rewritten to assist.php?checkUserEvents&BYAJAX=1
//or assist.php and record-ajax.php could be excluded as well

//But instead of this extra complexity I have placed the redirect code in index.php. So it is still possible to open record.php in the webapp WITHOUT ajax, but that is not very likely
//index.php (and also "/") is much more likely and that url is now redirected to webapp.php
if (($GLOBALS['webapp']) && (!$GLOBALS['BYAJAX']) && (!strstr($_SERVER['REQUEST_URI'], "webapp.php")) && ($_GET['dl'] != 1) && (!strstr($_SERVER['REQUEST_URI'], "csv.php")))
{
	header("Location: webapp.php");
	exit;
}
*/


//we need the language pack for the login page
$lang = do_language();
if ($logonmsg != "")
{
	$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "alert('" . $lang['sysmsg'] . ":\\n\\n" . $logonmsg . "');";
}

if ($GLOBALS['USERID'] == 0)
{
	if ($GLOBALS['CMDLINE'])
	{
		if ($login_invalid)
		{
			print "login error repository: \"" . $repository . "\" host: \"" . $host[$repository] . "\"\n";
		}
		else
		{
			print "please login\n";
		}
		//exit onderaan buitenste lus
	}
	else if (($GLOBALS['REALMAUTH']) || ($_GET['REALMAUTH'] == 1))
	{
		header('WWW-Authenticate: Basic realm="' . $GLOBALS['PRODUCT'] . ' ' . GetSetting("title") . ' - login"');
		header('HTTP/1.0 401 Unauthorized');
		//exit onderaan buitenste lus
	}
	else
	{
		if ($GLOBALS['webapp'])
		{
			//slordig maar deze kan unauth gerunt worden voor de webapp
			ShowHeaders();
		}
		else
		{

			if ((GetSetting('WebAppEnabled') == 'Yes') && (GetSetting('WebAppRedirectMobileClients') == 'Yes') && ($_GET["forcedesktop"] != 1))
			{
				if (preg_match('/iphone|ipad|android|windows phone/i', $_SERVER['HTTP_USER_AGENT']))
				{
					header("Location: webapp.php");
					exit;
				}
			}

			PrintHTMLHeader();
			print '<title>' . $GLOBALS['PRODUCT'] . '</title>';
			print '<link rel="shortcut icon" href="favicon.ico">';
			print '<meta name="viewport" content="width=device-width, initial-scale=1">';
			PrintUnauthenticatedHeaderJavascript();
			print '</head>';
			print '<body class="loginform">';
		}

		print '<div id="page">';

		print '<h1 id="title">' . htme(GetSetting("title")) . '</h1>';
		$subtitle = GetSetting("SUBTITLE");
		if ($subtitle != "")
		{
			print '<h2 id="subtitle">' . htme($subtitle) . '</h2>';
		}

		if (($ALLOWLOGONPAGEPASSCHANGE) && ($_GET['resetpasswordcode'] != ""))
		{
			if ($resetpasswordcode_ok)
			{
				if ($newpassword_invalid)
				{
					//hier zou je nooit terecht moeten komen want CheckPWD vangt (als het goed is) alle mogelijke fouten af. we zouden hier een lang tag van kunnen maken die we ook op de profile page kunnen gebruiken maar dit is niet zo belangrijk
					print '<div class="errmsg">New password not strong enough, or not twice the same.</div>';
				}

				print '<form method="post" action="' . $self . '?resetpasswordcode=' . htme($_GET['resetpasswordcode']) . '" onsubmit="return CheckPWD(\'' . inline_jsencode(GetSetting("MINIMUMPASSWORDSTRENGTH")) . '\',\'' . inline_jsencode($lang['passwarning']) . '\',\'Your new password did not match.\',1,1)">';

				print '<div id="div_password">';
				print '<div><label for="pw1">' . htme($lang['newpassword']) . '</label></div>';
				print '<div><input type="password" name="pw1" id="pw1" placeholder="' . htme($lang['newpassword']) . '" onkeyup="CheckPWD(\'' . inline_jsencode(GetSetting("MINIMUMPASSWORDSTRENGTH")) . '\',\'' . inline_jsencode($lang['passwarning']) . '\',\'Your new password did not match.\',0,1)"></div>';
				print '</div>';

				print '<div id="div_password2">';
				print '<div><label for="pw2">' . htme($lang['newpasswordconfirm']) . '</label></div>';
				print '<div><input type="password" name="pw2" id="pw2" placeholder="' . htme($lang['newpasswordconfirm']) . '" onkeyup="CheckPWD(\'' . inline_jsencode(GetSetting("MINIMUMPASSWORDSTRENGTH")) . '\',\'' . inline_jsencode($lang['passwarning']) . '\',\'Your new password did not match.\',0,1)"></div>';
				print '</div>';

				if (count($host) > 1)
				{
					print '<input type="hidden" name="repository" value="' . $repository . '">';
				}

				print '<div id="div_loginbutton"><input type="submit" value="' . htme($lang['changepassword']) . '"></div>';

				print '</form>';
			}
			else
			{
				print '<div class="errmsg">' . htme($lang["resetpassword_errorcode"]) . '</div>';
			}
			print '<div id="forgotpasswordbacktologinpagelink"><a href="' . $self . '">' . htme($lang['passwdreset_backlink']) . '</a></div>';
		}
		else
		{
			$displayform = true;

			if ($ALLOWLOGONPAGEPASSCHANGE)
			{
				if ($_POST['usernameresetpassword'] != "")
				{
					$user = db_GetRow("SELECT `id`, `name`, `EMAIL` FROM `CRMloginusers` WHERE (`name`='" . mres($_POST['usernameresetpassword']) . "' OR `EMAIL`='" . mres($_POST['usernameresetpassword']) . "') AND `active`='yes'");
					if ($user['id'] == 0)
					{
						log_msg("WARNING: User [" . $_POST['usernameresetpassword'] . "] requested a password reset link (UNsuccessful)");
//						print '<div class="errmsg">' . htme($lang["passwdreset_errormsg"]) . '</div>';
					}
					else
					{
						$resetpasswordcode = randomstring(16);
						$resetpasswordcode_validity = 10; //minutes

						$mail_subject = $lang["resetpassword_mail_subject"];
						$mail_body = $lang["resetpassword_mail_body"];
						$resetpasswordlink = GetSetting("BASEURL") . $self . '?resetpasswordcode=' . $resetpasswordcode;
						if (count($host) > 1)
						{
							$resetpasswordlink .= '&repository=' . $repository;
						}

						$mail_body = str_replace("@resetpasswordlink@", '<a href="' . htme($resetpasswordlink) . '">' . htme($resetpasswordlink) . '</a>', $mail_body);
						$mail_body = str_replace("@resetpasswordvalidity@", $resetpasswordcode_validity, $mail_body);

						//TODO liever vaste database velden
						SetAttribute("user", "resetpasswordcode", $resetpasswordcode, $user['id']);
						SetAttribute("user", "resetpasswordcode_validity", date('U') + $resetpasswordcode_validity * 60, $user['id']);

						//SimpleMail overschrijft dit met UNIFIED_FROMADDRESS, indien gezet
						SimpleMail(GetSetting("admemail"), $user['EMAIL'], $mail_subject, $mail_body, false);
						log_msg("WARNING: User [" . $user['name'] . "] id [" . $user['id'] . "] email [" . $user['EMAIL'] . "] requested a password reset link");
//						print '<div class="okmsg">' . htme($lang["resetpassword_confirmmessage"]) . '</div>';
//						$displayform = false;
						//voor de juiste back to login link
//						$show_resetpassword = true;
					}

					//2017-02-27 SECURITY: we won't give any feedback wether the user exists in our database
					usleep(rand(100000, 300000)); //sleep between 0.1 and 0.3 to prevent hackers from measuring response time to figure out if this user exists or not
					$displayform = false;
					$show_resetpassword = true;
					print '<div class="okmsg"><div>' . htme($lang["resetpassword_confirmmessage"]) . '</div><div>' . htme($lang["passwdreset_errormsg"]) . '</div></div>';
				}
			}

			if ($login_invalid) {

				print '<div class="errmsg">' . htme($lang["logininvalid"]) . '</div>';

			} elseif ($session_invalid || isset($_GET['expired'])) {

				print '<div class="warnmsg">' . htme($lang["sessionexpired"]) . '</div>';
			}

			if ($displayform)
			{
				//ProcessMessageReply checkt hier op
				print '<!-- thisistheloginform -->';
				//removes "logout" from uri, to prevent a auto logout when logging in
				$action = preg_replace("/\blogout\b/", "", $_SERVER['REQUEST_URI']);
				$action = preg_replace("/\?$/", "", $action);
				print '<form method="post" action="' . htme($action) . '">';

				print '<div id="div_username">';
				print '<div><label for="JS_username">' . htme($lang['usernameoremail']) . '</label></div>';
				print '<div><input type="text" name="username';
				if ($show_resetpassword)
				{
						print 'resetpassword';
				}
				print '" id="JS_username" placeholder="' . htme($lang['usernameoremail']) . '" value="' . htme($_POST['username']) . '"></div>';
				print '</div>';

				print '<script type="text/javascript">';
				print 'document.getElementById("JS_username").focus();';
				print '</script>';

				if (!$show_resetpassword)
				{
					print '<div id="div_password">';
					print '<div><label for="JS_password">' . htme($lang['password']) . '</label></div>';
					print '<div><input type="password" name="password" id="JS_password" placeholder="' . htme($lang['password']) . '"></div>';
					print '</div>';
				}

				//anders defaulteren we naar repository 0
				if (count($host) > 1)
				{
					print '<div id="repositoryselector">';
					print '<div><label for="JS_repository">Repository</label></div>';
					print '<div><select name="repository">';
					for ($x = 0; $x < count($host); $x++)
					{
						if (DB_Connect($x))
						{
							print '<option value="' . $x . '"';
							if ($repository == $x)
							{
								print ' selected';
							}
							print '>' . htme(GetSetting('title')) . '</option>';
							db_CloseConnection();
						}
						else
						{
							print '<option value="0">Error connecting to repository ' . $x . '</option>';
						}
					}
					print '</select></div>';
					print '</div>';
					DB_Connect($repository);
				}

				$text = $lang["login"];
				if ($show_resetpassword)
				{
					$text = $lang["resetpassword_button"];
				}
				print '<div id="div_loginbutton"><input type="submit" value="' . htme($text) . '"></div>';

				print '</form>';
			}

			if ($ALLOWLOGONPAGEPASSCHANGE)
			{
				if ($show_resetpassword)
				{
					print '<div id="forgotpasswordbacktologinpagelink"><a href="' . $self . '">' . htme($lang['passwdreset_backlink']) . '</a></div>';
				}
				else
				{
					print '<div id="forgotpassword"><a href="' . $self . '?resetpassword">' . htme($lang['resetpassword_button']) . '</a></div>';
				}
			}

			if ($displayform)
			{
				$LoginPageMessage = GetSetting("LoginPageMessage");
				if ($LoginPageMessage != "")
				{
					print '<div id="LogonPageMessage">' . $LoginPageMessage . '</div>';
				}
			}

			print '<div id="loginpagemessages">Interleave is an online business process management &amp; workflow framework developed by <a href="http://atomos.nl/">Atomos Applications</a> which enables you to make any business process available as an online application. Visit the <a href="http://www.interleave.nl/">product website</a> for more information.</div>';

			print '<div id="copythingy">';
			print '<div><img src="images/interleave_solo_bg_small.gif" height="25" width="25" alt="Interleave"></div><div>&copy; <a href="http://atomos.nl/">Atomos Applications</a> 2001-' . date("Y") . '</div>';
			print '</div>';
		}

		print '</div></body></html>';
		EndHTML(false);
	}

	exit;
}

$GLOBALS['repository'] = $repository;


InitUser();
// deze code runt ook voor housekeeping/duedate notify
// Load any PHP modules if required
$mod_inc = GetSetting("NumberOfModuleToIncludeInAllPageloads");
if ((is_positive_integer($mod_inc)) && (CheckModuleAccess($mod_inc) == "ok"))
{
	//qlog(INFO, "Running module " . $mod_inc);
	eval("?>" . db_GetValue("SELECT module_code FROM CRMmodules WHERE mid=" . $mod_inc));
}

// Check two-phase authentication settings

if (GetSetting('MAINTENANCE_MODE') == "Yes")
{
	if (is_administrator())
	{
		//TODO dit is niet de goede plek; headers zijn nog niet geprint
		print '<div class="warnmsg">Maintenance mode is enabled. Only administrators can log in!</div>';
	}
	else
	{
		if ($GLOBALS['webapp'])
		{
			//slordig maar deze kan unauth gerunt worden voor de webapp
			ShowHeaders();
		}
		else
		{
			PrintHTMLHeader();
			print '<title>' . $GLOBALS['PRODUCT'] . '</title>';
			print '<link rel="shortcut icon" href="favicon.ico">';
			print '<meta name="viewport" content="width=device-width, initial-scale=1">';
			print '</head>';
			print '<body class="loginform">';
		}
		print htme($lang['maintenancemodeison']);
		print '</body>';
		print '</html>';
		EndHTML(false);
		exit;
	}
}

if (!$GLOBALS['CMDLINE'])
{
	if (!$GLOBALS['SesMem']['TPADone'])
	{
		if (CheckFunctionAccess("requiretpa") == "ok" || GetSetting("RequireTwoPhaseAuthenticationForEveryOne") == "Yes" || (is_administrator() && GetSetting("RequireTwoPhaseAuthenticationPerIPForAdmins")=="Yes"))
		{
			$tpa_module = GetSetting("TwoPhaseAuthenticationModuleNum");

			if (!in_array($_SERVER['REMOTE_ADDR'], explode(",", GetAttribute("group", "DontRequireTPAWhenFromIPCSV", $GLOBALS['GROUPID']))))
			{
                /* public/private IP test */
                if (GetSetting("TwoPhaseAuthenticationTrustAllLocalIPRanges") != "Yes" || (GetSetting("TwoPhaseAuthenticationTrustAllLocalIPRanges") == "Yes" && !preg_match('/(^127\.)|(^192\.168\.)|(^10\.)|(^172\.1[6-9]\.)|(^172\.2[0-9]\.)|(^172\.3[0-1]\.)|(^::1$)|(^[fF][cCdD])/', $_SERVER['REMOTE_ADDR']))) {

                    /* exception for Atomos infrastructure */
                    if (is_positive_integer($tpa_module) || ((is_administrator() && GetSetting("RequireTwoPhaseAuthenticationPerIPForAdmins")=="Yes" && file_exists("/disk/scripts/interleave_admin_tpa.php"))))
                    {
                        // Default, no TPA
                        $tpa = false;

                        // Fetch TPA requirement
                        $type = GetSetting("TwoPhaseAuthenticationRequired");

                        /* exception for admins */
                        if (is_administrator() && GetSetting("RequireTwoPhaseAuthenticationPerIPForAdmins")=="Yes") {
                            $type = "Unknown IP";
                        }

                        // Get TPA Log (assoc array: ['IP-address']['epoch'] )
                        $log = GetAttribute("user", "TPALog", $GLOBALS['USERID']);

                        // Options: Every time|Unknown IP|First login
                        switch ($type) {
                                default:
                                        $tpa = false;
                                break;
                                case "Every time":
                                        $tpa = true;
                                break;
                                case "Unknown IP":
                                        if (!array_key_exists($_SERVER['REMOTE_ADDR'], $log)) {
                                                // new/unknow IP, tpa is required
                                                $tpa = true;
                                        }
                                break;
                                case "First login":
                                        if (count($log) == 0) {
                                                // Not a single log
                                                $tpa = true;
                                        }
                                break;
                        }

                        if ($tpa)
                        {
                            if (($GLOBALS['SesMem']['TPACode'] != "") && ($_POST['tpacode'] == $GLOBALS['SesMem']['TPACode']))
                            {

                                // Mark TPA as completed. This will prevent TPA from interfering later.
                                $GLOBALS['SesMem']['TPADone'] = true;

                                // Get TPA Log (assoc array: ['IP-address']['epoch'] )
                                $log = GetAttribute("user", "TPALog", $GLOBALS['USERID']);

                                // Client IP
                                $ip = $_SERVER['REMOTE_ADDR'];

                                // Set log
                                $log[$ip] = date('U');

                                // Commit it
                                SetAttribute("user", "TPALog", $log, $GLOBALS['USERID']);

                                //all ok; now continue loading the requested page
                            }
                            else
                            {
                                if ($GLOBALS['webapp'])
                                {
                                    //slordig maar deze kan unauth gerunt worden voor de webapp
                                    ShowHeaders();
                                }
                                else
                                {
                                    PrintHTMLHeader();
                                    print '<title>' . $GLOBALS['PRODUCT'] . '</title>';
                                    print '<link rel="shortcut icon" href="favicon.ico">';
                                    print '<meta name="viewport" content="width=device-width, initial-scale=1">';
                                    print '</head>';
                                    print '<body>';
                                }
                                print '<div id="tpadiv">';

                                $GLOBALS['TPACodeToSend'] = rand(10000, 99999);
                                $GLOBALS['SesMem']['TPACode'] = $GLOBALS['TPACodeToSend'];
                                EndSession();

                                /* exception for admins, only on Atomos infrastructure */
                                if (is_administrator() && GetSetting("RequireTwoPhaseAuthenticationPerIPForAdmins")=="Yes" && file_exists("/disk/scripts/interleave_admin_tpa.php")) {
                                    require "/disk/scripts/interleave_admin_tpa.php";
                                } else {

                                    RunModule($tpa_module);
                                }
                                print '<h1>Two-phase authentication: this application requires you to identify once more</h1>';

                                if (isset($_POST['tpacode']))
                                {
                                    log_msg("invalid tpa code \"" . $_POST['tpacode'] . "\"");
                                    print '<div class="errmsg">Wrong code, a new code is sent to you, please try again.</div>';
                                }

                                print '<form id="tpa_form" method="post">';
                                print '<div class="formfieldlabel">Received code</div><div class="formfield"><input type="text" name="tpacode" id="JS_tpacode" size="5"></div>';
                                print '<div><input type="submit" id="tpa_submit" value="Submit code"></div>';
                                print '</form>';

                                print '</div>';
                                print '</body></html>';
                                EndHTML(false);
                                exit;
                            }
                        }
                    }
                    else
                    {
                        if ($GLOBALS['webapp'])
                        {
                            //slordig maar deze kan unauth gerunt worden voor de webapp
                            ShowHeaders();
                        }
                        else
                        {
                            PrintHTMLHeader();
                            print '<title>' . $GLOBALS['PRODUCT'] . '</title>';
                            print '<link rel="shortcut icon" href="favicon.ico">';
                            print '<meta name="viewport" content="width=device-width, initial-scale=1">';
                            print '</head>';
                            print '<body>';
                        }
                        PrintAD("Due to a configuration error, the 2nd stage of authentication is not possible. Access to this application is denied.");
                        EndHTML(false);
                        exit;
                    }
                }
			}
		}
	}

	//TODO hier zit een "lek"; door "&passonly=1" (of &reset) achter de url te typen kunnen users verhinderen dat ze hun wachtwoord aan moeten passen
	if (!$GLOBALS['webapp'] && !isset($_GET['GetCSS']) && !isset($_GET['GetJS']) && CheckIfPasswordMustBeChanged() && !$_REQUEST['passonly'])
	{
		header("Location: profile.php?passonly=true");
		exit;
	}
}

//TODO dit mag na verloop van tijd weg
//we zouden dit eigenlijk alleen moeten checken op een LOGIN
$url_to_go_to = $_GET['url_to_go'];
if ($_GET['url_to_go_to'] != "")
{
	$url_to_go_to = $_GET['url_to_go_to'];
}
if ($url_to_go_to != "")
{
	$url_to_go_to = str_replace("|", "&", $url_to_go_to);
	header("Location: " . $url_to_go_to);
}

if (GetSetting("HighlightSearchesInForms") == "Yes" && (is_positive_integer($_REQUEST['record'])) && $_REQUEST['listid'] != "")
{
	// dit is smerig. LET OP staat ook in list_filebox() in listfunctions.php
	$attribsql = "SELECT value FROM CRMattributes WHERE entity='" . mres($GLOBALS['USERID']) . "' AND identifier='user' AND attribute LIKE 'List-lastview-%-" . mres($_REQUEST['listid']) . "'";

	//onhandig in de lastview attrib zit ook de tabel naam opgeslagen. dat is niet nodig want listid moet al uniek zijn. om die reden deze lompe query
	//$lastview_attribute = "List-lastview-" . $table . "-" . $listid;
	//$lastview = GetAttribute("user", $lastview_attribute, $GLOBALS['USERID']);
	$lastview = unserialize(db_GetValue($attribsql));

	if ($lastview['search'] != "")
	{
		list($searchtype, $searchparts) = searchstring_to_searchparts($lastview['search']);
		for ($searchpart_counter = 0; $searchpart_counter < count($searchparts); $searchpart_counter++)
		{
			//als deze false is dan is het een NOT search; die kan dan sowieso niet meer in value staan, maar we willen de preg_replace niet onnodig draaien
			if ($searchparts[$searchpart_counter]["is_positive"])
			{
				$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = "highlight('" . $searchparts[$searchpart_counter]["str"] . "');\n";
			}
		}
	}
}
function get_uri_from_base($base)
{
	return parse_url($base, PHP_URL_PATH);
}

?>
