<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This is the Interleave installer - it should be run from your browser,
 * not from the command line.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */
$GLOBALS['Installer'] = true;

ini_set("error_reporting", "E_ALL & ~E_NOTICE & ~E_DEPRECATED");

// The main version number to install with (5.5.0.4 is the last hardcoded version)
$version = "5.5.0.4";

if ($_REQUEST['AddRepository']=="1") {
	require "initiate.php";
} else {
	require $GLOBALS['PATHTOINTERLEAVE'] . "functions.php";
}

if (filesize('config/config.inc.php') > 0 && $_REQUEST['AddRepository'] !=1) {
	print 'Already configured';
	exit;
}


//ShowHeaders();

require $GLOBALS['PATHTOINTERLEAVE'] . "adminfunctions.php";

$tmpfileerror = 0;

if ($_REQUEST['AddRepository']=="1") {
	MustBeAdmin();
	ShowHeaders();
	$tabbs = array();
	$tabbs[] = array("admin.php?reposman=1&amp;resman=1&amp;manageres=1", "Current repositories");
	$tabbs[] = array("install.php?AddRepository=1&amp;step=1","New repository");
	PlainNav($tabbs);
	print "<hr><div>";
} elseif ($_REQUEST['step'] != 'dl') {

	require "config/config-vars.php";
	print '<!DOCTYPE html><html>';
	?>
	<head>
	<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
	<?php
	print "<title>Interleave installation procedure</title>";
	PrintUnauthenticatedHeaderJavascript();
	//print GetCustomCSS(true);
	?>
	</head>

	<body>
	<div>

	<div id="installpage">
		<h1 id='title'>
		Interleave installation procedure
	</h1>
<?php
}

$write = "";
if ($_REQUEST['step']=='dl') {
	header("Content-Type: text/php	");
	header("Content-Disposition: attachment; filename=config.inc.php");
	header("Window-target: _top");
	// Push attachment from variable
	print $_REQUEST['cfgfile'];
	exit;
} elseif ($_REQUEST['step']=='write') {
	$_REQUEST['trywrite'] = 1;
    if ($fp = @fopen("config/config.inc.php","w")) {
		fputs($fp,$_REQUEST['cfgfile']);
		fclose($fp);
        $write = "gelukt";
    } else {
        $write = "niet gelukt";
    }
	$_REQUEST['step'] = 4;
}




if (!$_REQUEST['step']) {
		$ver = phpversion();
		$phpver = "";

		$ver_a = explode(".", $ver);

		$k = "<span class='errmsg'>Error</span>";

		$fatal = 0;
		if ($ver_a[0] < 5) {
			$fatal = 1;
			$phpver = "Too old: " . $ver;
		} elseif ($ver_a[0] == 5 && $ver_a[1] < 2) {
			$fatal = 1;
			$phpver = "Too old: " . $ver;
		} elseif ($ver_a[0] == 5 && $ver_a[1] == 2 && $ver_a[2] < 3) {
			$fatal = 1;
			$phpver = "Too old: " . $ver;
		} else {
			$phpver = $ver;
			$k = "<span class='okmsg'><strong>OK</strong></span>";
		}

		$sv = $k . "</td><td>" . $phpver;
		$path = realpath(".");
		$webpath = $_SERVER['PHP_SELF'];
		$webhost = $_SERVER['SERVER_NAME'];
		$a = get_loaded_extensions();
		$mysqlsupport = '';
		if (!in_array("mysqli",$a)) {
				$mysqlsupport = "<span class='errmsg'>Error</span></td><td>MySQL support in PHP not found";
				$fatal = 1;
		} else {
				$mysqlsupport = "<span class='okmsg'>OK</span></td><td>Available";
		}
		$gd = '';
		if (in_array("gd",$a)) {
				$gd = "<span class='okmsg'>OK</span></td><td>Installed";
			} else {
				$gd = "<span class='errmsg'>Error</span></td><td>Not installed";
                $fatal = 1;
			}
		$rg = '';
		if (ini_get('register_globals')=="1" || strtolower(ini_get('register_globals'))=="on" || strtolower(ini_get('register_globals'))=="yes") {
				$rg = "<span class='warnmsg'>Warning</span></td><td>The PHP variable \"REGISTER_GLOBALS\" is enabled. This is dangerous.</span>";

		} else {
				$rg = "<span class='okmsg'>OK</span></td><td>Off";
				//$fatal = 1;
		}


		$t = ini_get('memory_limit');
		$t = str_replace("M","", $t);
		$mem = '';
		if (is_numeric($t) && $t > 15) {
				$mem = "<span class='okmsg'>OK</span></td><td>" . $t . "MB";
		} elseif (is_numeric($t)) {
				$mem = "<span class='errmsg'>Error</span></td><td>" . $t . "MB is not enough, set it to at least 16MB.";
				$fatal = 1;
		} else {
				$mem = "Unable to determine";
		}
		$dir = ini_get("session.save_path");
		$fa = '';
		if ($f = tempnam($dir,"INTLV-")) {
				$fa = "<span class='okmsg'>OK</span></td><td>$f";
				unlink($f);
		} else {
				$fa = "<span class='errmsg'>Warning</span></td><td>The PHP variable \"session.save_path\" is pointing to directory " . $dir .". Interleave was not able to write a file in this directory.<br>This is essential. This installation procedure will ask you for a new file location in the next step. Without a temporary file location, you cannot continue.</span>";
				$tmpfileerror=1;
		}


		print "<h2>This 4-step procedure will install Interleave.</h2>";
		print "<strong>Things you must know before starting:</strong><ol>";
		print "<li>Your MySQL server hostname, database name, username and password</li>";
		print "<li>The administrator's email address</li>";
		print "<li>A name and password for the initial administrative login account</li>";
		print "<li>Your company name (Interleave repository main title)</li></ol>";



		print "<strong>System sanity checks</strong>";
		print "<table class='crm'><thead><tr><th colspan='3'>";
		print "Required server properties &amp; settings</th></tr></thead>";
		print "<tr><td>PHP version </td><td>" . $sv . "</td></tr>";
		print "<tr><td>";
		print "MySQL support</td><td>" . $mysqlsupport . "</td></tr>";
		print "<tr><td>";
		print "Global registry of variables</td><td>" . $rg . "</td></tr>";
		if (ini_get('magic_quotes_gpc') == "Yes" || ini_get('magic_quotes_gpc') == "On" || ini_get('magic_quotes_gpc') == "1") {
			print "<tr><td>";
			print "Magic quotes</td><td><span class='errmsg'>Error</span></td><td>MQ is on. Interleave will try to set it off, but this can cause problems.</td></tr>";
		} else {
			print "<tr><td>";
			print "Magic quotes</td><td><span class='okmsg'>OK</span></td><td>Off</td></tr>";
		}
		print "<tr><td>";
		print "Temp file space</td><td>" . $fa . "</td></tr>";
		print "<tr><td>";
		print "Maximum memory for PHP scripts</td><td>" . $mem . "</td></tr>";

		print "<tr><td>";
		$zip = '';
		if (function_exists("zip_open")) {
			$zip = "<span class='okmsg'>OK</span></td><td>Available";
		} else {
			$zip = "<span class='errmsg'>Error</span></td><td>Not installed";
			$fatal = 1;
		}
		print "PHP Zip compiled</td><td>" . $zip . "</td></tr>";



		$ro = ini_get('request_order');
		$name = "request order";
		if ($ro == "") {
			$ro = ini_get('variables_order');
			$name = "variables order";
		}
		print "<tr><td>PHP " . $name . "</td><td>";
		if (substr(strtolower($ro),0,3)!="gpc" && strtolower($ro)!="egpcs" && strtolower($ro)!="gp") {
				print "<span class='errmsg'>Error</span></td><td>The " . $name . " of PHP is not set correctly (should be GPC but is " . $ro . ")</span>";
				$fatal = 1;
		} else {
				print "<span class='okmsg'>OK</span></td><td>" . $ro;

				//$fatal = 1;
		}
		print "</td></tr><tr><td>";
		if (function_exists("iconv")) {
			$zip = "<span class='okmsg'>OK</span></td><td>Available";
		} else {
			$zip = "<span class='errmsg'>Error</span></td><td> (not found)";
			$fatal = 1;
		}
		print "iConv support</td><td>" . $zip . "</td></tr>";
        print "<tr><td>";
		if (function_exists("mb_internal_encoding")) {
			$zip = "<span class='okmsg'>OK</span></td><td>Available";
		} else {
			$zip = "<span class='errmsg'>Error</span></td><td> (not found)";
			$fatal = 1;
		}
		print "mbstring support</td><td>" . $zip . "</td></tr>";

            print "<tr><td>";
		if (ini_get("short_open_tag")) {
			$zip = "<span class='okmsg'>OK</span></td><td>Enabled";
		} else {
			$zip = "<span class='errmsg'>Error</span></td><td>Disabled";
			$fatal = 1;
		}
		print "short_open_tag</td><td>" . $zip . "</td></tr>";



		print "<tr><td>";
		print "GD Library</td><td>" . $gd . "</td></tr>";
		print "<thead><tr><th colspan='3'>Optional libraries and file properties</th></tr></thead>";
		print "<tr><td>";
		print "Advanced PHP Caching support (APC)</td>";

		if (function_exists("apc_fetch")) {
			print "<td><span class='okmsg'>OK</span></td><td>Available</td>";
		} else {
			print "<td><span class='errmsg'>x</span></td><td>Not available</td>";
        }
		print "<tr><td>";
		$pear = '';
		if (require_once $GLOBALS['PATHTOINTERLEAVE'] . "lib/excel2003/PEAR.php") {
			$pear = "<span class='okmsg'>OK</span></td><td>Installed";
		} else {
			$pear = "<span class='errmsg'>Error</span></td><td>You will not be able to use Microsoft&reg; Excel&reg; formatted exports";
		}
		print "PEAR Classes</td><td>" . $pear . "</td></tr>";

		$b = get_perms("config/config.inc.php");
		$configfile = '';
		if ($fp = @fopen("config/config.inc.php","w")) {
			$configfile = "<span class='okmsg'>OK</span></td><td>$b";
		} else {
			$configfile = "<span class='errmsg'>x</span></td><td>Not writeable";
		}
		print "<tr><td>Write access to config file</td><td>" . $configfile . "</td></tr>";
		print "</table>";
		print "<form id='inst' action='install.php' method='post'>";
		print "<br>";
		print "<input type='hidden' name='step' value='GPL'>";
		print "<input type='hidden' name='tmpfileerror' value='" . $tmpfileerror . "'>";
		print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";
		print "<input type='hidden' name='ovrw' value='" . $_REQUEST['ovrw'] . "'>";
		if (!$fatal) {
			print "<input type='submit' value='Next page'>";
		} else {
			print "<input type='submit' value='Fatal error found - unable to continue' disabled>";
		}

		print "</form>";
		print "<p>If you need any help go to our <a href='http://www.interleave.nl/'>website</a> or directly to our <a href=\"http://support.interleave.nl/\">support application</a>.</p>";
		print "</div></body></html>";


} elseif ($_REQUEST['step']=="GPL") {
		print "<h2>Please accept the GPL license</h2>";
		print "<form id='inst' action='install.php' method='post'>";
		print "<input type='hidden' name='step' value='1'>";
		print "<input type='hidden' name='tmpfileerror' value='" . $tmpfileerror . "'>";
		print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";
		print "<div style='max-height: 600px;overflow: auto;'><pre>";
		require "COPYING";
		print "</pre></div>";
		print "<input type='submit' value='I agree, start installation'> &nbsp;";
		print "<input type='hidden' name='ovrw' value='" . $_REQUEST['ovrw'] . "'>";
		print "<input type='button' onclick=\"window.location.href='http://www.google.com/';\" value=\"I don't agree\" >";
		print "</form>";

} elseif ($_REQUEST['step']==1) {

		print "<h2>MySQL database name &amp; credentials</h2>";

		print "<form id='sql' action='install.php' method='post'><table class='crm'>";
		print "<tr><td>MySQL host</td><td><input type='text' name='sqlhost' size='30'></td></tr>";
		print "<tr><td>MySQL username</td><td><input type='text' name='sqluser' size='30'></td></tr>";
		print "<tr><td>MySQL password</td><td><input type='password' name='sqlpwd' size='30'></td></tr>";

		print "<tr><td>MySQL database <sup>1</sup></td><td><input type='text' name='sqldb' size='30'></td></tr>";
		print "<tr><td>Delete database prior to create&nbsp;<sup>2</sup></td><td><input type='checkbox' name='dropdb' value='yes'></td></tr>";
		if ($tmpfileerror) {
			print "<tr><td>Temp file path (e.g. /tmp)</td><td><input type='text' name='tmp_file_path' size='30'></td></tr>";
		}
		print "</table>";

		print "<p><input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'></p>";
		print "<p><br><input type='hidden' name='step' value='2'><input type='submit' value='Go to step 2'></p></form>";

		print '<br>';
		print "<sup>1</sup> The install procedure will try to create this database but will continue if it already exists<br>";
		print "<sup>2</sup> When selected the install procedure will first issue a DROP DATABASE before trying to create it. This will effectively delete the database if it currently exists. Use with care.<br>";


		print "</div></body></html>";

} elseif ($_REQUEST['step']==2) {

	if ((!$_REQUEST['sqlhost']) || (!$_REQUEST['sqluser']) || (!$_REQUEST['sqldb'])) {
		printerror("not enough information");
		exit;
	}
	$tp = "<ul>";
	if (!$db = db_only_connect($_REQUEST['sqluser'],$_REQUEST['sqlpwd'], $_REQUEST['sqlhost'])) {
		printerror("error connecting to database");
		exit;
	} else {
		$tp .= "<li>Database information was OK, the connection has been tested</li>";
	}

	if ($_REQUEST['dropdb'] == "yes") {
		mcq("DROP DATABASE IF EXISTS `" . $_REQUEST['sqldb'] . "`");
		$tp .= "<li>Old database dropped (if it existed)</li>";
	}


	$sql = "CREATE DATABASE IF NOT EXISTS `" . $_REQUEST['sqldb'] . "` CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci";
	mcq($sql);
	$db = @db_only_connect($_REQUEST['sqluser'], $_REQUEST['sqlpwd'], $_REQUEST['sqlhost']);
	if (@db_only_select($_REQUEST['sqldb'])) {
		$tp .= "<li>Database " . $_REQUEST['sqldb'] . " was created and selected successfully</li>";
	} else {
		$tp .= "<span class=\"errmsg\">Database " . $_REQUEST['sqldb'] . " was NOT created succesfully.</span><br><br>This could not be fatal. Trying to use it anyway.<br><br>";
	}


	// LANGUAGE IMPORT ROUTINE
	// The main pack file MUST BE NAMED "ENG.CRM"
	$sqla = array();
	$sqla = fillarray();



	for ($x=0;$x<sizeof($sqla);$x++) {
		$result= mcq($sqla[$x]);
	}

	$tp .= "<li>Database structure was successfully imported.</li>";

	$fc = file("ENG.CRM");

	$fc1 = array();
	$fc2 = array();
	$fc3 = array();

	$fc[0] = ""; // Interleave LANGUAGE PACK EXPORT FILE - Pack ENGLISH. This is the original, distributed pack.
	$fc[1] = ""; // Generated May 9, 2006, 21:05 on Interleave version Interleave 3.4.2 (c) 2001-2013 - LOGTEXT ENABLED.
	$fc[2] = ""; // PACK|||ENGLISH|||318
	for ($x=3;$x<sizeof($fc);$x++) {
			$tmp=explode("|||",$fc[$x]);
			$fc1[$x] = mres(trim($tmp[0]));
			$fc2[$x] = mres(trim($tmp[1]));
			$fc3[$x] = mres(trim($tmp[2]));
	}
//		fclose($fp);
//			print "FILE RECEIVED! - $_FILES['userfile']['tmp_name']  ($_FILES['userfile']['name'])";
	$tp2 = $fc[2];
	$header=explode("|||",$tp2);
	$pack = $header[1];
	$outp = "";

		for ($p=3;$p<sizeof($fc2);$p++) {
					$sql = "INSERT INTO CRMlanguages(LANGID,TEXTID,TEXT) VALUES('" . mres($fc1[$p]) . "', '" . mres($fc2[$p]) . "', '" . mres($fc3[$p]) . "')";
					 mcq($sql);
				}
				$outp .= "<li>" . $p . " Language entries were imported (English)</li>";

	print "<h2>Database created</h2>";
	print $tp;
	print $outp;
	print "</ul>";

?>
		<br>
	<form id='inst' action='install.php' method='post'>
	<input type='hidden' name='step' value='3'>
	<input type='hidden' name='upgrade' value='<?php echo $_REQUEST['upgrade'];?>'>
		<?php print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";?>
	<input type='submit' value='Go to step 3'>
	<?php
	print "<input type='hidden' name='sqldb' value='" . $_REQUEST['sqldb'] . "'>";
	print "<input type='hidden' name='sqluser' value='" . $_REQUEST['sqluser'] . "'>";
	print "<input type='hidden' name='sqlpwd' value='" . $_REQUEST['sqlpwd'] . "'>";
	print "<input type='hidden' name='sqlhost' value='" . $_REQUEST['sqlhost'] . "'>";

	?>
	</form>

	</div>
	</body>
	</html>
	<?php
} elseif ($_REQUEST['step']==3) {


		print "<h2>Repository details and admin user account</h2>";

		print "<table class='crm'><tr><td><form id='addinfo' action='install.php' method='post'>";
		print "Repository name: </td><td><input type='text' name='cname' size='30' value='My Demo Company'></td></tr>";
		print "<tr><td>";
		print "Administrator's email: </td><td><input type='text' name='admemail' size='30' value=''></td></tr>";
		print "<tr><td>";
		print "Initial login account name: </td><td><input type='text' name='fstaccount' size='30' value=''></td></tr>";
		print "<tr><td>";
		print "Initial login account password: </td><td><input type='password' name='fstpwd1' size='30' value=''></td></tr>";
		print "<tr><td>";
		print "Again: </td><td><input type='password' name='fstpwd2' size='30' value=''></td></tr>";
		print "</td></tr></table>";


		print "<br>";
		print "<input type='hidden' name='step' value='4'>";

		print "<input type='hidden' name='sqldb' value='" . $_REQUEST['sqldb'] . "'>";
		print "<input type='hidden' name='upgrade' value='" . $_REQUEST['upgrade'] . "'>";
		print "<input type='hidden' name='sqluser' value='" . $_REQUEST['sqluser'] . "'>";
		print "<input type='hidden' name='sqlpwd' value='" . $_REQUEST['sqlpwd'] . "'>";
		print "<input type='hidden' name='sqlhost' value='" . $_REQUEST['sqlhost'] . "'>";
		print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";

		?>
		<input type='submit' value='Go to step 4'>
		</form>

		</div>
		</body>
		</html>
	<?php
} elseif ($_REQUEST['step']==4) {

		if ((!$_REQUEST['trywrite']) && (!$_REQUEST['upgrade'])) {

			if ((!$_REQUEST['cname']) || (!$_REQUEST['admemail']) || (!$_REQUEST['fstaccount']) || (!$_REQUEST['fstpwd1']) || (!$_REQUEST['fstpwd2'])) {
					printerror("");
			}
			if ($_REQUEST['fstpwd1']<>$_REQUEST['fstpwd2']) {
					printerror("Passwords do not match. Press 'back' in your browser and try again.");
			}
			if ($_REQUEST['fstpwd1']=="") {
					printerror("Sorry, password cannot be empty. Press 'back' in your browser and try again.");
			}
			if ((strlen($_REQUEST['fstpwd1']))<3) {
					printerror("Your password is too short (". strlen($_REQUEST['fstpwd1']) . ").  Press 'back' in your browser and enter one longer than 3 characters!");
			}
			if (strlen($_REQUEST['fstaccount'])<3) {
					printerror("Your accountname is too short.  Press 'back' in your browser and enter one longer than 3 characters!");
			}

			$logo="*NONE*";

			$db = db_base_connect($_REQUEST['sqluser'], $_REQUEST['sqlpwd'], $_REQUEST['sqlhost'], $_REQUEST['sqldb']);

			$sqla = array();
			$sqla = datafill($_REQUEST['fstaccount'],$_REQUEST['fstpwd1'],$_REQUEST['admemail'],$_REQUEST['cname'],$logo);

			$last___ins = 0;
			for ($x=0;$x<sizeof($sqla);$x++) {
				$sqla[$x] = str_replace("@@@@LAST_ID@@@@",$last___ins,$sqla[$x]);

				$result= mcq($sqla[$x]);
				$last___ins = db_GetInsertId();
				if (!is_numeric($last___ins)) {
					unset($last___ins);
				}

			}
			// POST-INSTALL BUSINESS
			PostInstall();

		} // end if !trywrite
		$cfgfile = '<?php';
		$cfgfile .= "\n";
		$cfgfile .= '$host[0] = \'' . $_REQUEST['sqlhost'] . '\';';
		$cfgfile .= "\n";
		$cfgfile .= '$user[0] = \'' . $_REQUEST['sqluser'] . '\';';                                        // SQL-user
		$cfgfile .= "\n";
		$cfgfile .= '$pass[0] = \'' . $_REQUEST['sqlpwd'] . '\';';                                          // SQL-pass
		$cfgfile .= "\n";
		$cfgfile .= '$database[0] = \'' . $_REQUEST['sqldb'] .'\';';                                // CRM-database
		$cfgfile .= "\n";
		$cfgfile .= '?>';

		if ($_REQUEST['upgrade']) {
				$cfgfile = '<?php';
				$cfgfile .= "\n";
				$cfgfile .= '$host[0] = \'' . $_REQUEST['sqlhost'] . '\';';
				$cfgfile .= "\n";
				$cfgfile .= '$user[0] = \'' . $_REQUEST['sqluser'] . '\';';                                        // SQL-user
				$cfgfile .= "\n";
				$cfgfile .= '$pass[0] = \'' . $_REQUEST['sqlpwd'] . '\';';                                          // SQL-pass
				$cfgfile .= "\n";
				$cfgfile .= '$database[0] = \'' . $_REQUEST['sqldb'] .'\';';                                // CRM-database
				$cfgfile .= "\n";
				$cfgfile .= '?>';
		}
		if ($write=="niet gelukt") {
				$b = get_perms("config/config.inc.php");
				?>
					<script type="text/javascript">
					<!--
					alert("Writing failed. The permissions are <?php echo $b;?> which is not enough!");
					//-->
					</script>
				<?php
		} elseif ($write=="gelukt") {
				$b = get_perms("config/config.inc.php");
   				?>
					<script type="text/javascript">
					<!--
					alert("Writing succesfull! The permissions now are <?php echo $b;?>. Make sure the webserver cannot write to this file anymore!");
					//-->
					</script>
				<?php
		}
//$cfgfile = '';

		if ($_REQUEST['AddRepository']==1) {
			$a = 0;
			for ($i=0;$i<64;$i++) {
				if (!$pass[$i] && !$a) {
					$a = $i;
					continue;
				}
			}
			?>
			<h2>Installation complete</h2>
			<table>
			<tr><td colspan='2'><strong>All is set. The only thing left is to edit your config file.</strong>
			<br><br>
			You need to add the following text. This procedure cannot do that for you.
			<br><br>
						<?php

	//				$cfgfile .= "\n";
					$cfgfile .= '$host[' . $a . '] = "' . $_REQUEST['sqlhost'] . '";';
					$cfgfile .= "\n";
					$cfgfile .= '$user[' . $a . '] = "' . $_REQUEST['sqluser'] . '";';                                        // SQL-user
					$cfgfile .= "\n";
					$cfgfile .= '$pass[' . $a . '] = "' . $_REQUEST['sqlpwd'] . '";';                                          // SQL-pass
					$cfgfile .= "\n";
					$cfgfile .= '$database[' . $a . '] = "' . $_REQUEST['sqldb'] .'";';                          // CRM-database
					$cfgfile .= "\n";

				print "<pre>";
				print htme($cfgfile);
				print "</pre>";
				?>
				<br></td></tr>
				<tr><td>When done, point your browser <a href='index.php'>here</a>.</td></tr></table>


			<?php
		} else {
		?>




		<?php
			if (file_exists("config/config.inc.php")) {
				require "config/config.inc.php";
			}
			if ($_REQUEST['cfgfile'] != "") {
				$cfgfile = $_REQUEST['cfgfile'];
			}
			if ($host[0] && $user[0] && $pass[0]) {
				?>
					<h2>That's all. Start working with Interleave!</h2>
					Go <a href="index.php">to the login page</a>.
				<?php
			} else {
				?>
				<h2>Save configuration file</h2>
		All is set. The only thing left is to create the config file. Please choose one of these options:
		<ul>
			<li>Let the install procedure try to write the file itself
			<p>

			<form id='dlcfg' action='install.php' method='post'>
			<input type='hidden' name='step' value='write'>
			<input type='hidden' name='cfgfile' value='<?php echo htme($cfgfile); ?>'>
			<?php print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";?>
			<input type='submit' value='Try to write the configuration file automatically'>
			</form>
		</p>
		</li>

			<li>Download the file to you computer and place it in the installation directory yourself (/config/)
			<p>
			<form id='dlcfg' action='install.php' method='post'>
			<input type='hidden' name='step' value='dl'>
			<input type='hidden' name='cfgfile' value='<?php echo htme($cfgfile); ?>'>
			<?php print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";?>
			<input type='submit' value='Download the config/config.inc.php file'>
			</form>
		</p>
		</li>
			<li>Place the below printed text into the config/config.inc.php file yourself:
			<p>
			<?php


			print "<pre>";
			print htme($cfgfile);
			print "</pre>";
			?>
			</p>
		</li>

		</ul>
					<h2>You cannot continue until the configuration file is placed correctly.</h2>
					<form id='dlcfg' action='install.php' method='post'>
					<input type='hidden' name='trywrite' value='1'>
					<input type='hidden' name='step' value='4'>
					<input type='hidden' name='cfgfile' value='<?php echo htme($cfgfile); ?>'>
					<?php print "<input type='hidden' name='AddRepository' value='" . $_REQUEST['AddRepository'] . "'>";?>
					<input type='submit' value='Refresh / check config file'>
					</form>
				<?php
			}





		} // end if repository
?>
</div>
			</body>
			</html>
	<?php

}
function printerror($a)
{

		if (!$a) {
		    $a="You didn't provide all required information. Press 'back' in your browser and try again.";
		}
		?>
		<table><tr><td>Error<table>
		<tr><td colspan='2'><span class=\"errmsg\"><?php echo $a;?></span>
		</td></tr></table></td></tr></table></div></body></html>
		<?php
			exit;
} // end func
function fillarray()
{
	// This function fills the sqla array with queries to create Interleave database table structure
	// Last update; 5.5.0.2, february 10 2011
	// Last update: 0213-06-06
	$sqla = array();

$sqla[]= "CREATE TABLE `CRMuserprofiles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `active` enum('yes','no') NOT NULL DEFAULT 'yes',
  `CLLEVEL` mediumtext NOT NULL,
  `DASHBOARDFILEID` int(11) NOT NULL DEFAULT '0',
  `MENUTOUSE` int(11) NOT NULL,
  `webappmenu` int(11) NOT NULL,
  `INTERACTIVEFIELDS` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  `HIDEFROMASSIGNEEANDOWNERLISTS` enum('n','y') NOT NULL DEFAULT 'n',
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave User profile definition table'";
$sqla[]= "CREATE TABLE `CRMloginusers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `password` varchar(50) DEFAULT NULL,
  `PROFILE` varchar(10) NOT NULL DEFAULT '',
  `active` enum('yes','no') NOT NULL DEFAULT 'yes',
  `FULLNAME` varchar(150) NOT NULL DEFAULT '',
  `EMAIL` varchar(255) NOT NULL,
  `CLLEVEL` mediumtext NOT NULL,
  `administrator` enum('yes','no') NOT NULL DEFAULT 'no',
  `HIDEFROMASSIGNEEANDOWNERLISTS` enum('n','y') NOT NULL DEFAULT 'n',
  `TRACE` enum('Off','On') NOT NULL DEFAULT 'Off',
  `FORCEPASSCHANGE` enum('n','y') NOT NULL DEFAULT 'n',
  `LASTPASSCHANGE` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `INTERACTIVEFIELDS` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Files table'";
$sqla[]= "CREATE TABLE `CRMbinfiles` (
  `fileid` int(11) NOT NULL AUTO_INCREMENT,
  `koppelid` int(11) NOT NULL DEFAULT '0',
  `filename` varchar(200) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `filesize` int(11) NOT NULL DEFAULT '0',
  `filetype` varchar(150) NOT NULL DEFAULT '',
  `username` int(11) NOT NULL DEFAULT '0',
  `checked` enum('in','out') NOT NULL DEFAULT 'in',
  `checked_out_by` int(11) NOT NULL DEFAULT '0',
  `type` varchar(20) NOT NULL DEFAULT '',
  `version_belonging_to` int(11) NOT NULL DEFAULT '0',
  `version_no` int(11) NOT NULL DEFAULT '1',
  `extractedascii` longtext NOT NULL,
  `folder` int(11) NOT NULL,
  `offloaded` enum('n','y') NOT NULL,
  `coordinates` varchar(40) NOT NULL,
  PRIMARY KEY (`fileid`),
  KEY `koppelid` (`koppelid`),
  KEY `checked` (`checked`),
  KEY `filetype` (`filetype`),
  KEY `type` (`type`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Binary files'";
$sqla[]= "CREATE TABLE `CRMblobs` (
  `fileid` int(11) NOT NULL DEFAULT '0',
  `content` longblob NOT NULL,
  `thumbnail` blob NOT NULL,
  `gz` enum('n','y') NOT NULL DEFAULT 'n',
  `minithumbnail` blob NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`fileid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Blob stand-alone table'";
$sqla[]= "CREATE TABLE `CRMtemplates` (
  `templateid` int(11) NOT NULL AUTO_INCREMENT,
  `templatename` varchar(200) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `templatetype` varchar(150) NOT NULL DEFAULT '',
  `template_subject` varchar(2048) NOT NULL,
  `stylesheet` int(11) NOT NULL,
  `orientation` enum('P','L') DEFAULT NULL,
  `content` mediumtext NOT NULL,
  `binary_content` mediumblob NOT NULL,
  `page_id` varchar(100) NOT NULL,
  `version_belonging_to` int(11) NOT NULL,
  PRIMARY KEY (`templateid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave templates'";
$sqla[]= "CREATE TABLE `CRMtemplateaccessrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `template` int(11) NOT NULL DEFAULT 0,
  `group` int(11) NOT NULL DEFAULT 0,
  `read` enum('0','1') NOT NULL DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave template access rules'";
$sqla[]= "CREATE TABLE `CRMinternalmessages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `to` int(11) NOT NULL DEFAULT '0',
  `from` int(11) NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `read` enum('n','y') NOT NULL DEFAULT 'n',
  `dub_count` int(11) NOT NULL DEFAULT '1',
  `body` longtext NOT NULL,
  `shown_in_popup` enum('n','y') NOT NULL DEFAULT 'n',
  PRIMARY KEY (`id`),
  KEY `to` (`to`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Internal messages (user-to-user)'";
$sqla[]= "CREATE TABLE `CRMmodules` (
  `mid` int(11) NOT NULL AUTO_INCREMENT,
  `module_name` varchar(255) NOT NULL DEFAULT '',
  `module_description` mediumtext NOT NULL,
  `module_add_date` varchar(50) NOT NULL DEFAULT '',
  `module_last_run_result` mediumtext NOT NULL,
  `module_last_run_date` varchar(50) NOT NULL DEFAULT '',
  `module_code` mediumtext NOT NULL,
  `module_list_html` varchar(255) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  `for_table` varchar(20) NOT NULL,
  `version_belonging_to` int(11) NOT NULL,
  PRIMARY KEY (`mid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Module code table'";
$sqla[]= "CREATE TABLE `CRMmoduleaccessrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `module` int(11) DEFAULT NULL,
  `group` int(11) DEFAULT NULL,
  `execute` enum('0','1') DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave module access rules'";
$sqla[]= "CREATE TABLE `CRMsettings` (
  `settingid` int(11) NOT NULL AUTO_INCREMENT,
  `setting` varchar(150) NOT NULL DEFAULT '',
  `value` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `discription` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`settingid`),
  KEY `setting` (`setting`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Main settings table'";
$sqla[]= "CREATE TABLE `CRMjournal` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `eid` int(11) NOT NULL DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `user` int(11) NOT NULL DEFAULT '0',
  `message` longtext NOT NULL,
  `type` varchar(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `type_eid` (`type`,`eid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave record modification journal'";
$sqla[]= "CREATE TABLE `CRMdatajournal` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `record` int(11) NOT NULL,
  `from_val` longtext NOT NULL,
  `to_val` longtext NOT NULL,
  `by_user` int(11) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  `field` varchar(20) NOT NULL,
  `table` varchar(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `table_record_field` (`table`,`record`,`field`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave field change journal'";
$sqla[]= "CREATE TABLE `CRMentitylocks` (
  `lockon` int(11) NOT NULL DEFAULT '0',
  `lockby` int(11) NOT NULL DEFAULT '0',
  `locktable` varchar(20) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`lockon`,`lockby`,`locktable`),
  KEY `timestamp_last_change` (`timestamp_last_change`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Interleave record locks'";
$sqla[]= "CREATE TABLE `CRMflextabledefs` (
  `recordid` int(11) NOT NULL AUTO_INCREMENT,
  `tablename` varchar(128) NOT NULL DEFAULT '',
  `formid` int(11) NOT NULL DEFAULT '0',
  `refer_field_layout` text NOT NULL,
  `comment` longtext NOT NULL,
  `maxrowsperpage` int(4) NOT NULL,
  `headerhtml` mediumtext NOT NULL,
  `addlinktext` varchar(255) NOT NULL,
  `add_in_popup` enum('y','n') NOT NULL,
  `sort_on` int(11) NOT NULL,
  `sort_direction` enum('Ascending','Descending') NOT NULL,
  `tableheaderrepeat` int(11) NOT NULL,
  `stayinformaftersave` enum('n','y') NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`recordid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave flextable definition table'";
$sqla[]= "CREATE TABLE `CRMdownloadrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `table` int(11) NOT NULL,
  `group` int(11) NOT NULL,
  `max_rows` int(11) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Interleave download rules'";
$sqla[]= "CREATE TABLE `CRMtableaccessrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `table` int(11) DEFAULT NULL,
  `group` int(11) DEFAULT NULL,
  `read` enum('0','1') DEFAULT '0',
  `write` enum('0','1') DEFAULT '0',
  `add` enum('0','1') DEFAULT '0',
  `delete` enum('0','1') DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave table access rules'";
$sqla[]= "CREATE TABLE `CRMextrafields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `tabletype` varchar(20) NOT NULL,
  `deleted` enum('n','y') NOT NULL DEFAULT 'n',
  `fieldtype` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(250) NOT NULL DEFAULT '',
  `displaylistname` varchar(250) NOT NULL,
  `options` longtext NOT NULL,
  `optioncolors` longtext NOT NULL,
  `forcing` enum('n','y') NOT NULL DEFAULT 'n',
  `defaultval` longtext,
  `sort` enum('n','y') NOT NULL DEFAULT 'n',
  `size` int(11) NOT NULL DEFAULT '0',
  `showsearchbox` enum('n','y') NOT NULL DEFAULT 'n',
  `israwhtml` enum('n','y') NOT NULL,
  `remarks` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `showasradio` enum('n','y') NOT NULL,
  `excludefromfilters` enum('n','y') NOT NULL,
  `underwaterfield` enum('n','y') NOT NULL,
  `sum_column` enum('yes','no') NOT NULL,
  `number_format` varchar(50) NOT NULL DEFAULT 'normal',
  `log_stats` enum('n','y') NOT NULL DEFAULT 'n',
  `calculation` longtext NOT NULL,
  `calculation_type` enum('database trigger','calculated on display') NOT NULL DEFAULT 'database trigger',
  PRIMARY KEY (`id`),
  KEY `tabletype` (`tabletype`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Extra field definitions'";
$sqla[]= "CREATE TABLE `CRMfieldaccessrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `field` int(11) DEFAULT NULL,
  `group` int(11) DEFAULT NULL,
  `read` enum('0','1') DEFAULT '0',
  `write` enum('0','1') DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave field access rules'";
$sqla[]= "CREATE TABLE `CRMlanguages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `LANGID` varchar(15) NOT NULL DEFAULT '',
  `TEXTID` varchar(60) NOT NULL,
  `TEXT` varchar(255) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `LANGID` (`LANGID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave language table'";
$sqla[]= "CREATE TABLE `CRMsessions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL,
  `temp` varchar(32) BINARY NOT NULL DEFAULT '',
  `exptime` varchar(40) NOT NULL DEFAULT '',
  `noexp` enum('n','y') NOT NULL DEFAULT 'n',
  `sessioncache` longtext NOT NULL,
  `ip` varchar(45) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `temp` (`temp`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Session table'";
$sqla[]= "CREATE TABLE `CRMrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `enabled` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `table` varchar(20) DEFAULT NULL,
  `name` varchar(1024) NOT NULL,
  `remarks` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `operator` enum('AND','OR') NOT NULL DEFAULT 'AND',
  `log_passed` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `log_failed` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave rules'";
$sqla[]= "CREATE TABLE `CRMruleconditions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rule` int(11) NOT NULL,
  `enabled` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `condition` varchar(50) NOT NULL,
  `field` varchar(1024) NOT NULL,
  `matchvalue` varchar(1024) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave rule conditions'";
$sqla[]= "CREATE TABLE `CRMruleactions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rule` int(11) NOT NULL,
  `enabled` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `action` varchar(50) NOT NULL,
  `field` varchar(1024) NOT NULL,
  `template` int(11) NOT NULL,
  `attach` varchar(15) NOT NULL,
  `attach_matchvalue` varchar(1024) NOT NULL,
  `value` varchar(8196) DEFAULT NULL,
  `module_to_run` int(11) NOT NULL,
  `message_to_display` varchar(1024) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `operator` enum('AND','OR') NOT NULL DEFAULT 'AND',
  `alternate_from_address` varchar(512) NOT NULL,
  `order` int(11) NOT NULL,
  `remarks` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave rule actions'";
$sqla[]= "CREATE TABLE `CRMruleactionconditions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ruleaction` int(11) NOT NULL,
  `enabled` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `condition` varchar(50) NOT NULL,
  `field` varchar(1024) NOT NULL,
  `matchvalue` varchar(1024) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave rule action conditions'";
$sqla[]= "CREATE TABLE `CRMcalendars` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `deleted` enum('n','y') NOT NULL DEFAULT 'n',
  `description` varchar(255) NOT NULL,
  `ref_start_date_time` varchar(20) NOT NULL,
  `ref_end_date_time` varchar(20) NOT NULL,
  `appointment_click_action` enum('None','Open record in popup','Open record in current window') NOT NULL,
  `show_calendar_in_legend` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `summary` varchar(512) NOT NULL DEFAULT '',
  `ref_organiser` int(11) NOT NULL,
  `resource` varchar(1024) NOT NULL,
  `comment` varchar(1024) NOT NULL,
  `location` varchar(1024) NOT NULL,
  `display_popup` enum('Yes','No') NOT NULL DEFAULT 'Yes',
  `minutes_before_csv` varchar(50) NOT NULL DEFAULT '30,15,0',
  `color_in_legend` varchar(7) NOT NULL,
  `calendar_object` varchar(15) NOT NULL,
  `listoptions` varchar(2048) NOT NULL,
  `sortorder` int(11) NOT NULL,
  `show_add_option` enum('No','Yes') NOT NULL,
  `add_option_url_extras` varchar(1024) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave calendar definitions'";
$sqla[]= "CREATE TABLE `CRMcalendaraccessrules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calendar` int(11) DEFAULT NULL,
  `group` int(11) DEFAULT NULL,
  `read` enum('0','1') DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave calendar access rules'";
$sqla[]= "CREATE TABLE `CRMattributes` (
  `entity` int(11) NOT NULL,
  `identifier` varchar(20) NOT NULL,
  `attribute` varchar(250) NOT NULL,
  `value` longtext NOT NULL,
  `allowed_values` varchar(2048) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  UNIQUE KEY `DB_PRIM` (`entity`,`identifier`,`attribute`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4";
$sqla[]= "CREATE TABLE `CRMuselog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip` varchar(45) NOT NULL DEFAULT '',
  `url` varchar(50) NOT NULL DEFAULT '',
  `useragent` varchar(255) NOT NULL DEFAULT '',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `qs` longtext NOT NULL,
  `user` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `tijd` (`timestamp_last_change`),
  KEY `url` (`url`),
  KEY `ip` (`ip`),
  KEY `user` (`user`),
  KEY `qs` (`qs`(30))
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Main activity log table'";
$sqla[]= "CREATE TABLE `CRMmailqueue` (
  `queueid` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `template` longtext NOT NULL,
  `entity` int(11) NOT NULL,
  `customer` int(11) NOT NULL,
  `from` varchar(512) NOT NULL DEFAULT '',
  `fromname` varchar(512) NOT NULL DEFAULT '',
  `to` varchar(1024) NOT NULL DEFAULT '',
  `PDF` enum('not','used') NOT NULL,
  `subject` varchar(1024) NOT NULL DEFAULT '',
  `attach_to_dossier` enum('','both','entity','customer') NOT NULL,
  `attach_as_filename` varchar(250) NOT NULL,
  `report_attach` varchar(20) NOT NULL,
  `flextableid` int(11) NOT NULL,
  `flextablerecord` int(11) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `date_sent` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` enum('unsent','sent','error') DEFAULT NULL,
  `worker_hash` varchar(64) NOT NULL DEFAULT '',
  `date_queued` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `parse` enum('y','n') NOT NULL DEFAULT 'y',
  `files_to_attach` longtext NOT NULL,
  `table` varchar(20) NOT NULL,
  PRIMARY KEY (`queueid`),
  KEY `status` (`status`),
  KEY `flextableid` (`flextableid`),
  KEY `flextablerecord` (`flextablerecord`),
  KEY `entity` (`entity`),
  KEY `worker_hash` (`worker_hash`),
  KEY `customer` (`customer`),
  KEY `user` (`user`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave mail queue'";
$sqla[]= "CREATE TABLE `CRMtodo` (
  `todoid` int(11) NOT NULL AUTO_INCREMENT,
  `onchange` varchar(255) NOT NULL DEFAULT '',
  `from_value` mediumtext NOT NULL,
  `to_value` mediumtext NOT NULL,
  `eid` int(11) NOT NULL DEFAULT '0',
  `user` int(11) NOT NULL DEFAULT '0',
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `worker_hash` varchar(64) NOT NULL,
  PRIMARY KEY (`todoid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4";
$sqla[]= "CREATE TABLE `CRMcache` (
  `stashid` int(11) NOT NULL AUTO_INCREMENT,
  `epoch` varchar(20) DEFAULT NULL,
  `session` varchar(32) BINARY NOT NULL DEFAULT '',
  `value` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`stashid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave Query cache table'";
$sqla[]= "CREATE TABLE `CRMstats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item` varchar(20) NOT NULL,
  `value` varchar(1024) NOT NULL,
  `count` int(11) NOT NULL,
  `sum` int(11) NOT NULL,
  `avg` int(11) NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave statistics table'";
$sqla[]= "CREATE TABLE `CRMdatastructures` (
  `userid` int(11) NOT NULL,
  `datastructure` longtext NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Interleave data structure table'";
$sqla[]= "CREATE TABLE `CRMextendedprivsgroup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `groupid` int(11) NOT NULL,
  `field` int(11) NOT NULL,
  `value` varchar(300) NOT NULL,
  `rule` enum('readonly','invisible') NOT NULL,
  `timestamp_last_change` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `operand` enum('IS','IS NOT') NOT NULL,
  `only_apply_for_field` int(11) NOT NULL DEFAULT '0',
  `visual_only` enum('n','y') NOT NULL DEFAULT 'n',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8mb4 COMMENT='Interleave extended privileges table for groups'";



	return $sqla;
} // end func
function datafill($fstaccount,$fstpwd1,$admemail,$cname,$logo)
{
	global $version;
	$sqla = array();
	// 1st Admin user
	$sqla[] = "INSERT INTO CRMloginusers (name,password,administrator,FULLNAME,LASTPASSCHANGE) VALUES('" . mres($fstaccount) . "',PASSWORD('" . mres($fstpwd1) . "'),'Yes','Administrator " . mres($fstaccount) . "',NOW())";

	$sqla[] = 'INSERT INTO CRMattributes(entity,identifier,attribute,value) VALUES (\'1\',\'system\',\'List-layout-fields-\',\'a:6:{i:0;s:9:"fields-id";i:1;s:15:"fields-ordering";i:2;s:16:"fields-fieldtype";i:3;s:11:"fields-name";i:4;s:14:"fields-remarks";i:5;s:28:"fields-timestamp_last_change";}\'),(\'1\',\'system\',\'List-layout-files-\',\'a:4:{i:0;s:12:"files-fileid";i:1;s:14:"files-filename";i:2;s:14:"files-filetype";i:3;s:14:"files-filesize";} \'),(\'1\',\'system\',\'List-layout-groups-\',\'a:1:{i:0;s:11:"groups-name";}\'),(\'1\',\'system\',\'List-layout-modules-\',\'a:5:{i:0;s:11:"modules-mid";i:1;s:19:"modules-module_name";i:2;s:26:"modules-module_description";i:3;s:23:"modules-module_add_date";i:4;s:29:"modules-timestamp_last_change";}\'),(\'1\',\'system\',\'List-layout-sessions-\',\'a:4:{i:0;s:11:"sessions-id";i:1;s:15:"sessions-userid";i:2;s:13:"sessions-temp";i:3;s:16:"sessions-exptime";}\'),(\'1\',\'system\',\'List-layout-tables-\',\'a:1:{i:0;s:16:"tables-tablename";}\'),(\'1\',\'system\',\'List-layout-templates-\',\'a:5:{i:0;s:20:"templates-templateid";i:1;s:22:"templates-templatename";i:2;s:22:"templates-templatetype";i:3;s:17:"templates-page_id";i:4;s:31:"templates-timestamp_last_change";}\'),(\'1\',\'system\',\'List-layout-triggers-\',\'a:6:{i:0;s:12:"triggers-tid";i:1;s:17:"triggers-onchange";i:2;s:15:"triggers-action";i:3;s:17:"triggers-to_value";i:4;s:16:"triggers-comment";i:5;s:16:"triggers-enabled";}\'),(\'1\',\'system\',\'List-layout-users-\',\'a:6:{i:0;s:14:"users-FULLNAME";i:1;s:13:"users-PROFILE";i:2;s:10:"users-name";i:3;s:11:"users-EMAIL";i:4;s:19:"users-administrator";i:5;s:27:"users-timestamp_last_change";}\')';

	foreach (GetDefaultSettings() as $setting)
	{
		$sqla[] = "INSERT INTO CRMsettings (setting, value, discription) VALUES ('" . mres($setting[0]) . "', '" . mres($setting[1]) . "', '" . mres($setting[2]) . "')";
	}

	$TMP_FILE_PATH = ini_get("session.save_path");
	$sqla[] = "UPDATE CRMsettings SET value='" . mres($TMP_FILE_PATH) . "' WHERE setting='TMP_FILE_PATH'";
	$sqla[] = "UPDATE CRMsettings SET value='" . mres($cname) . "' WHERE setting='title'";
	$sqla[] = "UPDATE CRMsettings SET value='" . mres($admemail) . "' WHERE setting='admemail'";
	$sqla[] = "UPDATE CRMsettings SET value='" . mres($version) . "' WHERE setting='DBVERSION'";

	return $sqla;
}

function PostInstall() {

	require_once $GLOBALS['PATHTOINTERLEAVE'] . "functions.php";

	$dashboard = AttachFileS("Default Dashboard Template", "
	<h1>@TITLE@</h1>
	<div><a href=\"admin.php?templates=1&amp;nav=dashtemplates&amp;t1=dash\">Edit this dashboard template</a></div>", "TEMPLATE_DASHBOARD", "Default Dashboard Template");
	mcq("UPDATE CRMsettings SET value='" . $dashboard . "' WHERE setting='DASHBOARDTEMPLATE'");

	$menu = AttachFileS("Default Menu Template", '<nav><ul><li><a href="index.php">[[dashboard]]</a></li><li><a href="list.php?table=t1">[[flextable1plural]]</a></li><li><a href="list.php?table=t2">[[flextable2plural]]</a></li></ul><ul><li><a href="profile.php" title="[[youraccount]]"><span class="fa fa-user fa-fw">&nbsp;</span></a></li><li><a href="index.php?logout" title="[[logout]]"><span class="fa fa-power-off fa-fw">&nbsp;</span></a></li></ul></nav>', "TEMPLATE_MENU", "Default Menu Template");
	mcq("UPDATE CRMsettings SET value='" . $menu . "' WHERE setting='MenuTemplateId'");
}

function get_perms($file) {
   $p_bin = substr(decbin(@fileperms($file)), -9) ;
   $p_arr = explode(".", substr(chunk_explode($p_bin, 1,"."), 0, 17)) ;
   $perms = ""; $i = 0;
   foreach ($p_arr as $that) {
      $p_char = ($i%3==0 ? "r" : ($i%3==1 ? "w" :"x"));
      $perms .= ($that=="1" ? $p_char : "-") . ($i%3==2 ? " " : "");
      $i++;
   }
   return $perms;
}
function chunk_explode($glue=' ',$pieces='',$size=2,$final=array()) {
    if(!is_string($pieces) && !is_array($pieces))
        return false;

    if(is_string($pieces))
        $pieces = explode($glue,$pieces);

    $num_pieces = sizeof($pieces);
    if($num_pieces <= 0)
       return $final;

    if($num_pieces >= $size) {
        $arr_chunk = array_chunk($pieces, $size);
        array_push($final,implode($glue,$arr_chunk[0]));
        for($i=0;$i<=$size;$i++) { array_shift($pieces); }
        return chunk_explode($glue,$pieces,$size,$final);
    }
    array_push($final,implode($glue,$pieces));
    return $final;
}

function AttachFileS($filename, $content, $filetype,$subject) {

	$sql = "INSERT INTO CRMtemplates(templatename,templatetype,template_subject,content,timestamp_last_change) VALUES ('" . mres($filename) . "','" . mres($filetype) . "','". mres($subject) . "','" . mres($content) . "',NOW())";
	mcq($sql);
	return db_GetInsertId();
}
?>
