<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file handles modules.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */


if (substr($argv[0], strlen($argv[0])-11, 11) == "modules.php") {

	$GLOBALS['PATHTOINTERLEAVE'] = dirname(realpath($argv[0])) . "/";

	$GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
	foreach ($argv AS $ar) {
		if (substr($ar, 0, 4) == "cfg=") {
			$cfg = str_replace("cfg=", "", $ar);
			$GLOBALS['CONFIGFILE'] = $cfg;
		}
	}
	require_once $GLOBALS['PATHTOINTERLEAVE'] . "adminfunctions.php";

	if ($argv[2] =="" || $argv[3] == "" || $argv[4] == "") {
		$argv[1] = "-help";
	}
	if ($argv[1]=="-help" || $argv[1]=="--help" || $argv[1]=="help" || $argv[1]=="-h") {
		print "usage: php ./modules.php [repository] [username] [password] (or \"NOPASS\") [module] [cfg=/path/to/config.inc.php]\n";
		exit;
	}
	$repository = 0;
	if (isset($argv[1])) {
		$repository = $argv[1];
		if (!is_numeric($repository)) {
			$repository = 0;
		}
	}
	$username = "";
	if ($argv[2] != "") {
		$username = $argv[2];
	}
	$password = "";
	if ($argv[3] != "") {
		$password = $argv[3];
	}
	$module = 0;
	if ($argv[4] != "") {
		$module = $argv[4];
	}
	if ($username == "" || $password == "" || $module == 0)
	{
		print "error: provide username, password and module\n";
		exit;
	}

	$GLOBALS['CMDLINE'] = true;
	$GLOBALS['overriderepository'] = $repository;
	$GLOBALS['cmdline_username'] = $username;
	$GLOBALS['cmdline_password'] = $password;
	require "initiate.php";

	RunModule($module);
	EndHTML(false);
//	print "\n\nDone running module " . $module . " (end).\n\n";
	exit;
}


require_once "initiate.php";

if ($_REQUEST['action'] <> "run") {
	MustBeAdmin();
	$GLOBALS["InAdminSection"] = true;
}

if (!$_REQUEST['ExecInsModule'] && $_REQUEST['action'] <> "run" && !$_REQUEST['dl']) {
	ShowHeaders();
	MustBeAdmin();
} elseif ($_REQUEST['ExecInsModule']) {
	RunModule($_REQUEST['ExecInsModule']);
	EndHTML(false);
	exit;
}

if ($_REQUEST['nm_name']) {
	MustBeAdmin();
	$code = "<?php\n// This is a default module file.\n// Edit it the way you like. The tab navigation will come free with all modules\n// and all global settings and database connections are at your disposal.\n\n// If run for a specific record, the recordid is in \$recordid.\n// If this module is ran by a trigger when an e-mail is received, the from address is\n// in \$GLOBALS['EMAIL_SENDER_ADDRESS'], the to-address is in \$GLOBALS['EMAIL_SENDER_TO']\n// and the body is in \$GLOBALS['EMAIL_BODY']. Attachements are stored in \$GLOBALS['Attachments'] (associative: filename => file contents).\n\n// If you're using a list to link to your module (see option below) than you can find the list of id's in \$GLOBALS['recordids'].\n\n// If you're this using module for two-phase authentication your code-to-send-to-the-user is in \$GLOBALS['TPACodeToSend'].\n\nprint \"This module works.\";\n\n// Don't use the EndHTML() function, it will be added while processing your module.\n?>\n";
	mcq("INSERT INTO CRMmodules (module_name,module_description,module_add_date,module_code) VALUES ('" . mres($_REQUEST['nm_name']) . "','" . mres($_REQUEST['nm_description']) . "','" . date('U') . "','" . mres($code) . "')");

	$mid = db_GetInsertId();
	mcq("INSERT INTO CRMmoduleaccessrules(module, `group`, execute) VALUES ('" . $mid . "','0','1')");
	print '<div class="okmsg">Module ' . htme($_REQUEST['nm_name']) . ' added.</div>';
	qlog(INFO, "Manually inserted module definition file");
}
if (!isset($_REQUEST['action'])) {
	$_REQUEST['action'] = "avail";
}
switch ($_REQUEST['action']) {
		case "avail":

			list($number_of_records, $output) = make_list(array("table" => "modules", "hiddenfilter" => array("modules-version_belonging_to" => array(0))));
			print $output;

		break;
		case "addonline":
				print "<h1>Add a new module</h1>";
				print "<form id='addform' method='post' action='modules.php'>";
				print "Module name <input size='50' name='nm_name' type='text'><br>";
				print "Module description <input size='50' name='nm_description' type='text'><br>";
				print "<input type='submit' value='Add module' class='addbutton'>";
				print "</form>";

				break;
		case "run" :

            /*
             *
             *  Be aware: arguments action and mid could be given through GET *and* POST. Use _REQUEST to read.
             *
             */

			$ajax = GetAttribute("module", "RunInAjax", $_REQUEST['mid']);
			$headers = GetAttribute("module", "ShowHeaders", $_REQUEST['mid']);
			$ContentsOfDivWhileLoadingViaAjax = GetAttribute("module", "ContentsOfDivWhileLoadingViaAjax", $_REQUEST['mid']);

			if ($headers != "No" && !isset($_REQUEST['noheaders']) && (!$GLOBALS['BYAJAX'])) {

				ShowHeaders();

				if ($GLOBALS['SesMem']['InlineEditMode_InlineLinks'] == "On") {
					print "<div class=\"InlineEditModeDivContainer\"><div class=\"InlineEditModeDiv\"><a href=\"modules.php?action=edit&amp;mid=" . $_REQUEST['mid'] . "&amp;fromlist=" . base64_encode($_SERVER['REQUEST_URI']) . "\"><span class=\"fa fa-cogs\"></span></a></div></div>";
				}

				if ($ajax == "No") {

					RunModule($_REQUEST['mid'], false, false, false, false, false, $_REQUEST['dqs']);

				} else {
					$id = 'JS_RunModule' . htme($_REQUEST['mid']);

					/* we pass on two stash values containing the original GET and POST */
					$get = PushStashValue($_GET);
					$post = PushStashValue($_POST);
					print '<div id="' . $id . '">' . htme($ContentsOfDivWhileLoadingViaAjax) . '</div>';
					$GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] ="
					refresh_contents_of_div('" . $id . "', 'assist.php', 'Function=RunModule&ExecInsModule=" . htme($_REQUEST['mid']) . "&dqs=" . $_REQUEST['dqs'] . "&massupdate=" . $_REQUEST['massupdate'] . "&get=" . $get . "&post=" . $post . "', true, 'POST', '', false);
					";

				}
				EndHTML();
			} else {

				RunModule($_REQUEST['mid'], false, false, $_REQUEST['recordid'], false, false, $_REQUEST['dqs'], $_REQUEST['table']);
				EndHTML(false);
			}
			exit;
		break;
		case "edit" :
			$table = "modules";
			$recordid = $_REQUEST['mid'];
			print showchilds($table, $recordid);
			print familytree($table, $recordid, $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
			print "<h1>" . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["singular"] . " " . get_refer_layout_for_record($table, $recordid)) . "</h1>";
			ShowModuleEditScreen();
		break;
}
EndHTML();
?>
