<?php

function RealExcel2007($excel,$CSVseparator="@@@@REALEXCEL@@@@", $format = "xlsx", $dateformat = "", $filename) {

    require_once 'lib/phpspreadsheet/src/Bootstrap.php';


    // Create new Spreadsheet object
    $spreadsheet = new \PhpOffice\PhpSpreadsheet\Spreadsheet();
    $cacheMethod = \PhpOffice\PhpSpreadsheet\CachedObjectStorageFactory::CACHE_TO_PHPTEMP;
    if (\PhpOffice\PhpSpreadsheet\Settings::setCacheStorageMethod($cacheMethod)) {

    } else {
        log_msg(INFO, "Couldn't select cache method CACHE_TO_PHPTEMP");
    }
    // Set document properties
    $spreadsheet->getProperties()->setCreator("" . $GLOBALS['PRODUCT'] . " user " . $GLOBALS['USERNAME'])
                ->setLastModifiedBy($GLOBALS['USERNAME'])
                ->setTitle("Office 2007 XLSX Document")
                ->setSubject("" . $GLOBALS['PRODUCT'] . " Excel2007 Export")
                ->setDescription("Interleave Open Source Business Process Management - http://www.interleave.nl")
                ->setKeywords("" . $GLOBALS['PRODUCT'] . "-export-" . date("m-j-Y-Hi") . "h")
                ->setCategory("" . $GLOBALS['PRODUCT'] . " Export " . date("m-j-Y-Hi") . "h");

    qlog(INFO, "Writing Excel 2007 file");

    if (strstr($excel[1], "@@@@REALEXCEL@@@@")) $CSVseparator = "@@@@REALEXCEL@@@@";

    $rows = ExcelRows(); // Array with rows (A .. AA .. ZZ)
    $sheet = 0;
    if ($filename == "") {
        if ($_REQUEST['fntu'] != "") {
            $filename = base64_decode($_REQUEST['fntu']);
        } else {
            $filename = str_replace(" ", "_", GetSetting("title")) . "-" . $GLOBALS['PRODUCT'] . "-export-" . date("m-j-Y-Hi") . "h";
        }
    }
    if ($_REQUEST['fmtu'] != "") {
        $format_t = base64_decode($_REQUEST['fmtu']);
        if ($format_t == "xlsx" || $format_t == "xls" || $format_t == "pdf") {
            $format = $format_t;
        }
    }


    $default_size = GetSetting("DefaultExcel2007FontSize");
    $default_font = GetSetting("DefaultExcel2007Font");
    if ($default_font == "") $font = "Tahoma";

    $spreadsheet->getActiveSheet()->getDefaultStyle()->getFont()->setName($default_font);
    $spreadsheet->getActiveSheet()->getDefaultStyle()->getFont()->setSize($default_size);

    $spreadsheet->getActiveSheet()->getPageSetup()->setFitToPage(false);
    $spreadsheet->getActiveSheet()->getPageSetup()->setFitToWidth(0);
    $spreadsheet->getActiveSheet()->getPageSetup()->setFitToHeight(0);

    // $spreadsheet->getActiveSheet()->setAutoFilter('A1:C9');

    // Add some data
    $spreadsheet->setActiveSheetIndex(0);


    // Create header in format_bold
    $header = "";
    if ($CSVseparator != "array") {
        $header = explode($CSVseparator,$excel[0]);
    } else {
        $header = $excel[0];
    }
    for ($i=0;$i<sizeof($header);$i++) {
        if (trim($header[$i]) == "") {
            unset($header[$i]);
        } else {
            qlog(INFO, "VALID HEADER: " . $header[$i]);
        }
    }

    qlog(INFO, "Set auto-resize....");
    // Set all columns to auto-resize by default
    $scol = 'A';
    foreach ($header AS $dummy) {
        $scol++;
    }
    $scol++;
    for ($col = 'A'; $col != $scol; $col++) {
        $spreadsheet->getActiveSheet()->getColumnDimension($col)->setAutoSize(true);
    }
    $sheetCorrection = 0;

    qlog(INFO, "Array contains " . sizeof($excel) . " rows including header");

    for ($i=0;$i<sizeof($excel);$i++) {

        qlog(INFO, "Processing row " . $i . " (mem: " . memory_get_usage() . ")");
        $line = array();
        if ($CSVseparator != "array") {
            $line = explode($CSVseparator,$excel[$i]);	// get current line and array' it
        } else {
            $line = $excel[$i];
            $line[] = "";
        }

        for ($u=0;$u<sizeof($line) -1;$u++) {
            //if ($line[$u]) {

            $styleArray = array();
            $styleArray['font'] = array();

            $cell = ($rows[$u]) . (($i+1) - $sheetCorrection);

            $style_set = false;

            preg_match_all('/\[\[[A-Za-z0-9_#-]+\]\]/', $line[$u], $matches);
            $list_of_tags = $matches[0];
            $new_sheet = false;
            foreach ($list_of_tags AS $tag) {
                // Strip operators
                $tag_content = str_replace("[[", "", str_replace("]]", "", $tag));

                // Strip tag from value
                $line[$u] = str_replace($tag, "", $line[$u]);

                // Check per possible tag
                if (substr($tag_content, 0, 8) == "fontsize") {

                    $fontsize = str_replace("fontsize", "", $tag_content);
                    $styleArray['font']['size'] = $fontsize;
                    $style_set = true;

                } elseif (substr($tag_content, 0, 4) == "font") {

                    $font = str_replace("font", "", $tag_content);
                    $styleArray['font']['name'] = $font;
                    $style_set = true;

                } elseif (substr($tag_content, 0, 7) == "bgcolor") {

                    $bgcolor= strtoupper(str_replace("bgcolor#", "", $tag_content));
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID);
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getFill()->getStartColor()->setARGB('FF' . $bgcolor);

                } elseif (substr($tag_content, 0, 7) == "fgcolor") {

                    $fgcolor= str_replace("fgcolor#", "", $tag_content);
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getFont()->getColor()->setARGB('FF' . $fgcolor);

                } elseif ($tag_content == "wrapped" || $tag_content== "wrap") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setWrapText(true);

                } elseif ($tag_content == "borders") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getTop()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getBottom()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getLeft()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getRight()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);

                } elseif ($tag_content == "border-top") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getTop()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);

                } elseif ($tag_content == "border-bottom") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getBottom()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);

                } elseif ($tag_content == "border-left") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getLeft()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);

                } elseif ($tag_content == "border-right") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getRight()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);

                } elseif ($tag_content == "standing") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setTextRotation(90);

                } elseif ($tag_content == "bold") {

                    $styleArray['font']['bold'] = true;
                    $style_set = true;

                } elseif ($tag_content == "italic") {

                    $styleArray['font']['italic'] = true;
                    $style_set = true;

                } elseif (substr($tag_content, 0, 6) == "vmerge") {

                    $num_merge = str_replace("vmerge", "", $tag_content);
                    $spreadsheet->getActiveSheet()->mergeCells($cell . ":" . $rows[$u] . ($i + $num_merge));

                } elseif (substr($tag_content, 0, 5) == "merge") {

                    $num_merge = str_replace("merge", "", $tag_content);
                    $num_merge--;
                    $spreadsheet->getActiveSheet()->mergeCells($cell . ":" . $rows[($u + $num_merge)] . ($i+1));

                } elseif (substr($tag_content, 0, 5) == "width") {

                    $width = str_replace("width", "", $tag_content);
                    // Disable AutoSize
                    $spreadsheet->getActiveSheet()->getColumnDimension($rows[$u])->setAutoSize(false);
                    // Set width
                    $spreadsheet->getActiveSheet()->getColumnDimension($rows[$u])->setWidth($width);

                } elseif ($tag_content == "right-align") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

                } elseif ($tag_content == "left-align") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

                } elseif ($tag_content == "center") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

                } elseif ($tag_content == "autofilter") {
                    // Set autofilter on first row
                    $spreadsheet->getActiveSheet()->setAutoFilter('A1:' . $rows[$i] . (sizeof($header) - 1));

                } elseif ($tag_content == "nextsheet") {

                    $new_sheet = true;

                } elseif ($tag_content == "autosize") {

                    $spreadsheet->getActiveSheet()->getColumnDimension($rows[$u])->setAutoSize(true);

                } elseif (substr($tag_content, 0, 9) == "sheetname") {

                    $sheetname = str_replace("sheetname", "", $tag_content);
                    $spreadsheet->getActiveSheet()->setTitle($sheetname);

                } elseif ($tag_content == "landscape") {

                    $spreadsheet->getActiveSheet()->getPageSetup()->setOrientation(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::ORIENTATION_LANDSCAPE);

                } elseif ($tag_content == "a4") {

                    $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A4);

                } elseif ($tag_content == "a3") {

                    $spreadsheet->getActiveSheet()->getPageSetup()->setPaperSize(\PhpOffice\PhpSpreadsheet\Worksheet\PageSetup::PAPERSIZE_A3);

                } elseif ($tag_content == "fittopage") {

                    $spreadsheet->getActiveSheet()->getPageSetup()->setFitToPage(true);

                } elseif ($tag_content == "fittowidth") {

                    $spreadsheet->getActiveSheet()->getPageSetup()->setFitToWidth(1);

                } elseif ($tag_content == "fittoheight") {

                    $spreadsheet->getActiveSheet()->getPageSetup()->setFitToHeight(1);

                } elseif ($tag_content == "currency-eur") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->setFormatCode(\PhpOffice\PhpSpreadsheet\Style\NumberFormat::FORMAT_CURRENCY_EUR_SIMPLE);

                } elseif ($tag_content == "currency-usd") {

                    $spreadsheet->getActiveSheet()->getStyle($cell)->setFormatCode(\PhpOffice\PhpSpreadsheet\Style\NumberFormat::FORMAT_CURRENCY_USD_SIMPLE);

                }
            }

            if ($style_set) {
                $spreadsheet->getActiveSheet()->getStyle($cell)->applyFromArray($styleArray);
            }

            // backwards compatibility

            if (strstr($line[$u], "@@@@HEXCOLOR")) {
                // Cell value contains color code
                $tmp = explode("@@@@HEXCOLOR", $line[$u]);
                $color = trim(str_replace("#", "", $tmp[1]));
                $value = $tmp[2];
                $line[$u] = $value;

                $spreadsheet->getActiveSheet()->getStyle($cell)->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getFill()->getStartColor()->setARGB('FF' . $color);
            }



            if (strstr($line[$u], "@@@@WRAPPED@@@@")) {

                $line[$u] = str_replace("@@@@WRAPPED@@@@", "", $line[$u]);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setWrapText(true);

            }
            if (strstr($line[$u], "@@@@BORDERS@@@@")) {

                $line[$u] = str_replace("@@@@BORDERS@@@@", "", $line[$u]);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getTop()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getBottom()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getLeft()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getBorders()->getRight()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN);
            }

            if (strstr($line[$u], "@@@@STANDING@@@@")) {

                $line[$u] = str_replace("@@@@STANDING@@@@", "", $line[$u]);
                $spreadsheet->getActiveSheet()->getStyle($cell)->getAlignment()->setTextRotation(90);

            }

            if (is_numeric($line[$u])) {

    //            $spreadsheet->getActiveSheet()->getCell($cell)->setValueExplicit($line[$u], PHPExcel_Cell_DataType::TYPE_NUMERIC);
                $spreadsheet->getActiveSheet()->setCellValue($cell, $line[$u]);

            } elseif (IsFormattedDate($line[$u])) {

                $date = date('U', NLDate2Epoch(FormattedDateToNLDate($line[$u]))) + 86300;

                $spreadsheet->getActiveSheet()->setCellValue($cell, \PhpOffice\PhpSpreadsheet\Shared\Date::PHPToExcel($date));
                //$spreadsheet->getActiveSheet()->setCellValue($cell, PHPExcel_Shared_Date::PHPToExcel($date));

                if ($GLOBALS['UC']['DateFormat'] == "mm-dd-yyyy") {
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getNumberFormat()->setFormatCode(\PhpOffice\PhpSpreadsheet\Style\NumberFormat::FORMAT_DATE_DATETIME);
                } elseif ($GLOBALS['UC']['DateFormat'] == "dd-mm-yyyy") {
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getNumberFormat()->setFormatCode(\PhpOffice\PhpSpreadsheet\Style\NumberFormat::FORMAT_DATE_DATETIME);
                } elseif ($GLOBALS['UC']['DateFormat'] == "yyyy-mm-dd") {
                    $spreadsheet->getActiveSheet()->getStyle($cell)->getNumberFormat()->setFormatCode(\PhpOffice\PhpSpreadsheet\Style\NumberFormat::FORMAT_DATE_DATETIME);
                } else {
                    log_msg("ERROR::Dateformat not correct! (excel2007)");
                }
                unset($date);

            } else {
                $spreadsheet->getActiveSheet()->setCellValue($cell, $line[$u]);
            }

            $spreadsheet->getActiveSheet()->getRowDimension($u)->setRowHeight(-1);

            if ($new_sheet) {
                $sheet++;
                $spreadsheet->createSheet();  // Create a new sheet and set it as the active sheet
                unset($new_sheet);

                $spreadsheet->setActiveSheetIndex($sheet);
                $spreadsheet->getActiveSheet()->getDefaultStyle()->getFont()->setName($default_font);
                $spreadsheet->getActiveSheet()->getDefaultStyle()->getFont()->setSize($default_size);

                qlog(INFO, "Set auto-resize....");
                // Set all columns to auto-resize by default
                $scol = 'A';
                foreach ($header AS $dummy) {
                    $scol++;
                }
                $scol++;
                for ($col = 'A'; $col != $scol; $col++) {
                    $spreadsheet->getActiveSheet()->getColumnDimension($col)->setAutoSize(true);
                }
                // Correct the row-counter!
                $sheetCorrection = ($i+1);
            }

                //}
        }
    }

    // Set active sheet index to the first sheet, so Excel opens this as the first sheet
    $spreadsheet->setActiveSheetIndex(0);

    $filename = clean_filename($filename);
    // Redirect output to a client’s web browser (Xlsx)

    header('Cache-Control: max-age=0');
    // If you're serving to IE 9, then the following may be needed
    header('Cache-Control: max-age=1');

    // If you're serving to IE over SSL, then the following may be needed
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
    header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
    header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
    header('Pragma: public'); // HTTP/1.0

    $objWriter = new stdClass();
    switch ($format) {
        case "xlsx":
            header('Content-Disposition: attachment;filename="' . $filename . '.xlsx"');
            header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
            // Save Excel 2007 file
            $writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheet, 'Xlsx');
            $writer->save('php://output');
        break;
        case "pdf":
            $objWriter = new PHPExcel_Writer_PDF($spreadsheet);
            $objWriter->writeAllSheets();
            $filename .= ".pdf";
            header('Content-Disposition: attachment;filename="' . $filename . '"');
            header('Content-Type: application/pdf');

            break;
        case "xls":
            $objWriter = new PHPExcel_Writer_Excel5($spreadsheet);
            $filename .= ".xls";
            header('Content-Disposition: attachment;filename="' . $filename . '"');
            header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
            break;

    }




}
?>
