<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This script handles ajax calls for record.php
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
*/
require ("initiate.php");

// debug test slow networks / asynchoneously
// sleep('1');

/* supported methods. currently not in use */
$methods = array("general_form_submit", "general_element_change", "autosave_record_element", "load_ifield");

/* set everything from _POST here. its always a POST */
$fqn 				= $_POST['fqn']; 					// the fully qualified field name, e.g. t12-f34
$recordid 			= $_POST['recordid']; 				// the record id
$value 				= $_POST['value']; 					// the (new) value
$method 			= $_POST['method']; 				// the requested method
/*
 * exception for the app.
*/
if ($method == "" && $_GET['method'] == "reload_calendar") {

	$method = "reload_calendar";

} elseif ($method == "" && $_GET['method'] == "get_images") {

	/* ... and the ckeditor simple-image-browser plugin, which also works using a GET */
	$fqn = $_GET['fqn'];
	$recordid = $_GET['recordid'];
	$method = "get_images";

}
$listid 			= $_POST['listid']; 				// the parent list id in case of an in-list ifield (for reload)
$commenthash 		= $_POST['commenthash']; 			// the comment hash in case of editing a diary entry
$delentry 			= $_POST['delentry']; 				// the comment hash in case of deleting a diary entry
$type 				= $_POST['type']; 					// the type of update ('interactive')
$starttable 		= $_POST['starttable']; 			// the start table for the familytree
$startrecord		= $_POST['startrecord']; 			// the start record for the familytree
$fromlist 			= $_POST['fromlist']; 				// the fromlist var for the familytree
$save 				= $_POST['save_after_validation']; 	// if 1, treat this as a save next to a validate
$reload_list 		= $_POST['reload_list'];
$page_href 			= $_POST['pagedel_href'];
$page_title 		= trim($_POST['page_title']);
$ifield 			= $_POST['ifield'];
$template_to_use	= $_POST['template_to_use'];
$e_button			= $_POST['e_button'];

/*
    no digging in REQUEST vars beyond this point.
*/

/* the default */
$return_as_json = true;

/* the array to hold the output; will be put into JSON */
$result = array();
$result["update_elements"] = array();

/* $fqn can be an associative array when reloading multiple fields at once */
$table = '';
$field = '';
$fqn_without_record = '';

if (!is_array($fqn)) {

	/* create table and record vars/values */
	list($table, $field) = explode("-", $fqn);

	/* compose FQN field name: t12-f34 */
	$fqn_without_record = $table . "-" . $field;
}

/* declare */
$access = false;
$current_record = false;

if ($table == "files" && ipi($recordid)) {

	/* files are special. we check access for rotation */

	$t = db_GetRow("SELECT type, koppelid FROM CRMbinfiles WHERE fileid='" . mres($recordid) . "'");
	if (CheckIfAttachingIsAllowed($t['koppelid'], binfiles_table_to_ds_tablename($t['type']))) {
		$access = true;
	}

} elseif (ipi($recordid) && $fqn_without_record != "") {

    /* since we're handling forms, we want the field to be writeable. there are three exceptions in this file; general_form_submit, calculations and reload_element, they handle their own security */


    $current_record = getrecord($table, $recordid, false, false, array($fqn_without_record));

    if ($current_record['type_of_access'] == 'ok' && $current_record['record_locked_by'] == 0 && $current_record['*' . $fqn_without_record] == 1) {
        $access = true;
    } elseif ($method == "get_images" && $current_record['type_of_access'] == "ok" && $current_record['record_locked_by'] == 0) {
		$access = true;
	}

} else {
    /* check whether adding to this table is allowed. dirty exception for files */
    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["allowed_to_add"] || $table == "files") { /* VERY dirty hack */
        $access = true;
    }
}

/* the method called just before submitting a complete form. we receive the form in $value as an JSON stringified array */
if ($method == "general_form_submit") {

    /* as it's a form submit, we also check for submitted, but empty, required fields. fields not submitted at all are ignored, leading to possible data record integrity issues. we SHOULD check the form here to see what we were expecting expecting but for now, we don't have a clue on what to expect */
    $check_for_required_fields = true;

    /* the array to hold messages to pass back to the user, if any */
    $messages = array();

    /* the array to hold the result to be sent back to the client */
    $result["data"] = array();

	/* save after validate, for app use */
	$data = array();

    /* decode the form */
    $value = json_decode($value);

    if (json_last_error() == JSON_ERROR_NONE) {

        if (!ipi($recordid)) $recordid = "_new_";

        $to_parse = "";

        /* compose a normal URI string */
        foreach ($value AS $keyvaluepair) {

			/*
			   we expect url encoded input. if it's not, parse_str will crash on &'s

			   we do NOT validate the fqn here, this will be done later on and spawn an error message
			   when incorrect. it's preferred to see that error so no checking here

			*/

            $to_parse.= "&" . ($keyvaluepair[0]) . '=' . ($keyvaluepair[1]);
        }

        /* quite nasty, but this converts multiple elements like fieldname[] into arrays, which saves us the trouble */
        $to_process = array();
        parse_str($to_parse, $to_process);

        /* get current record */
        $fields_to_fetch = array();
        foreach ($to_process AS $key => $value) {

			//$key = urldecode($key);
			//$value = urldecode($value);

            list($localfqntable, $localfqnfield) = explode("-", $key);
            $fields_to_fetch[] = $localfqntable . "-" . $localfqnfield;

        }

        $current_record = getrecord($table, $recordid, false, false, $fields_to_fetch);


		/* ############################################# BEGIN hele vieze workaround */
		/* HELE VIEZE workaround. Dit MOET eruit. In eigen loop gezet want anders gaat dit niet goed in select_refer_field_options en dan kan ik niet verder met de deploy van NDI

		Alleen het EIGEN veld (dus het veld wat op dat moment gevalideerd wordt) zit vanwege backwards compatibility op die manier (tX-fY) in de REQUEST (en dan alleen relation_to velden). Dit was om de “oude” manier te ondersteunen, en het is legacy (dat weet je want we hebben het er destijds over gehad dat we deze hack zouden inbouwen omdat jij het niet eens was met de tX-fY-recordid notatie). Als je de boel dan in een lusje draait, en precies in de juiste volgorde, dan kan zijn zijn dat je *toevallig* ook andere waardes van eerder-verwerkte refer fields tegenkomt, die zijn achtergebleven omdat ze er in een eerdere iteratie bijgezet zijn. Dat is wat hier verkeerd gaat. Dit was nooit een probleem, maar bij hiddenfilters gebaseerd op een waarde die loopt via een referentie in een ANDER veld, wordt het dat wel. Logisch.

		Deze toevoeging van het veld-in-behandeling gebeurt trouwens *uniform* in beide varianten m.a.w. record en add-row zijn VOLKOMEN gelijk; het is niet de bedoeling dat iets er vanuit gaat dat deze waardes in de REQUEST zitten, behalve dus de de entry van de waarde van het veld dat op dat moment aan de beurt is zelf. In de request kan je zien dat in het geval van een add-row dit veld inderdaad achteraan staat, en dus nog niet in de REQUEST zit op het moment dat f552 aan de beurt is. Aan het einde van het liedje zit-ie dat wel.

		*/
		foreach ($to_process AS $key => $value) {
			/*
			$key = urldecode($key);
			$value = urldecode($value);
*/
			/* for compatibility reasons, set FQN request elements. this is mainly if not only in use for fields which are validated using/against a pre-set refer field value like multiselect reference fields: to validate them you NEED to know the reference. for that reason we only set fields referring to something else */
			list($localfqntable, $localfqnfield) = explode("-", $key);
			$localfqn = $localfqntable . "-" . $localfqnfield;
			if ($GLOBALS['UC']['PersonalDataStructure'][$localfqntable]["fields"][$localfqnfield]['relation_to'] != "") {

				$_REQUEST[$localfqn] = $value;
			}
		}
		/* ############################################# END hele vieze workaround */



        /* loop through each key-value pair */
        foreach ($to_process AS $key => $value) {
			/*
			$key = urldecode($key);
			$value = urldecode($value);
*/
            /* use ValidateFieldInputDataStructureOnly to validate and correct the submited value */
            $pair_result = array();

            list($localfqntable, $localfqnfield) = explode("-", $key);
            $localfqn = $localfqntable . "-" . $localfqnfield;

            /* check access by checking if the query has '*fqn' result set to 1. Or, when recordid is not a positive integer, all fields are allowed be cause the user is adding a record */
            if (($current_record['type_of_access'] == 'ok' && $current_record['record_locked_by'] == 0 && $current_record['*' . $localfqn] == 1) || !ipi($recordid)) {

                /* the validator wants DUTCH FORMATTED DATES NO MATTER WHAT THE DB TYPE IS. format formatted dates here */
                /* we always receive dates formatted */
                if ($GLOBALS['UC']['PersonalDataStructure'][$localfqntable]["fields"][$localfqnfield]['fieldtype_in_extrafields_table'] == "date" || $GLOBALS['UC']['PersonalDataStructure'][$localfqntable]["fields"][$localfqnfield]['fieldtype_in_extrafields_table'] == "date (iso)") {

					$hv = false;
					if ($value != '') $hv = true;
                    $value = INTLDate2NLDate(StrDate2IsoDate($value));
					if ($value == '' && $hv) {
						/* it HAD a value, but now it's gone, must have been wrong. trick old validator with bogus value to trigger error */
						$value = 'dl3b';
					}

                } elseif ($GLOBALS['UC']['PersonalDataStructure'][$localfqntable]["fields"][$localfqnfield]['fieldtype_in_extrafields_table'] == "date/time") {

                    /* date/time fields must always be iso formatted */

                    //$value = FormattedDateTimeToSQLDateTime($value);

                }

                list($pair_result["result"], $pair_result["message"], $pair_result["corrected_value"]) = ValidateFieldInputDataStructureOnly($localfqn, $value, $check_for_required_fields, $recordid);

                if (is_array($value)) {
                    /* we don't support correcting multiselect fields (which are arrays) */
                    $pair_result["corrected_value"] = "";
                }

                if ($pair_result["result"] != "ok") {
                    /* prevents save in case of app BYAJAX save */
                    $save = 0;
                }

                /* give this back to the browser if outcome is !ok or a message needs to be displayed */
                if ($pair_result["result"] != "ok" || $pair_result["corrected_value"] != $value) {

                    $result["data"][] = array($localfqn . "-" . $recordid, $pair_result);

                    /* no message given, but it's still not OK. use system default message */
                    if ($pair_result["result"] == "nok" && $pair_result["message"] == "") {
                        $pair_result["message"] = $lang["requiredfields"];
                    }

                    /* stack messages, there could be several */
                    if ($pair_result["message"] != "" && !in_array($pair_result["message"], $messages)) {
                        $messages[] = $pair_result["message"];
                    }

                } else {
					/* enble this for debug */
					// $result["OKdata"][] = array($localfqn . "-" . $recordid, $pair_result);

				}

                if ($save == 1 && $pair_result["result"] == "ok") {

                    /* store the values for saving them later. only when saving via ajax (app calls) */
                    $data[$localfqn . "-" . $recordid] = $value;

                }
            } else {
                log_msg("ERROR: Field [" . $localfqnfield . "] was submitted for validation, but the user doesn't have write access for this record.");
            }
        }


        /* set the stack of messages in the result array */
        $result["message"] = implode("\n", $messages);

    } else {

        /* decoding the JSON stringified value failed. return fail and message */
        $result["result"] = "nok";
        $result["message"] = "Form data undecodable";
    }

    if ($save == 1) {

        $access_for = "nok";
        if ($access) $access_for = "ok";

        /* use generic save */
        list($success, $recordid, $messages) = process_record_save($table, $recordid, $data, $current_record, $access_for);

		$result["saved"] = $success;

		/* process buttons if saving was successful and a button was pressed (webapp only) */
		if (ipi($e_button) && $success) {

			$x = GetAllButtons($e_button);

			if ($x[0]['fieldtype'] == "Button") {

				if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields']['f' . $e_button])) {

					// So, a button was pressed (and the user has the rights to press it)

					$messages[] = Processrules($table, $recordid, "f" . $e_button, "pressed", "");

				}
			}
		}

        /* this element will be picked up by the ajax caller to pass false to the form submit so it doesn't get posted */
        $result["directlysubmitted"] = 1;

        /* this will be used by app logic to redirect to the record using ilor */
        $result["openlink"] = $GLOBALS['UC']['PersonalDataStructure'][$table]['openlink'] . $recordid;
		if (ipi($template_to_use)) {
			if (GetSetting('UseURLBeautification') == 'Yes') {
				$result["openlink"] .= '?';
			} else {
				$result["openlink"] .= '&';
			}
			$result["openlink"] .= 'template_to_use=' . $template_to_use;
		}

        if (count($messages) > 0) {
    //        $result["message"] .= implode("\n", $messages);
		/* messages are in de JS array */
        }

		/* strange duck in the byte - as we're processing a button via ajax/JSON, we need to tell the client
		   if it needs to execute javascript. normally is this printed in EndHTML() but we'll never get that far */

		if (is_array($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'])) {
		   $result["javascript_to_evaluate_by_client"] = '$(document).ready(function() {';
		   foreach ($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'] as $ajaxBoxElement) {
		       $result["javascript_to_evaluate_by_client"] .= $ajaxBoxElement;
		   }
		   $result["javascript_to_evaluate_by_client"] .= '});';
		}

		if ($GLOBALS['url_to_redirect_to'] != '') {
			$result["url_to_redirect_to"] = $GLOBALS['url_to_redirect_to'];
		}
    }

} elseif ($method == "delete_record") {
	/*
		ajax call to delete a record. mostly in use by webapp

	*/

	$listonly = false;
	if ($value == "listonly") $listonly = true;
	list($descendingdeleteresult, $array_with_result) = descendingdelete($table, array($recordid), $listonly);
	if (GetAttribute("flextable", "DeleteConfirmationMessage", str_replace("t", "", $table)) != "") {
		$result['message'] = jsencode(GetAttribute("flextable", "DeleteConfirmationMessage", str_replace("t", "", $table)));
	} else {
		$result['message'] = jsencode($lang['areyousure']);
	}
	$result['message'] .= "\n\n";
	foreach ($array_with_result AS $name => $oknok) {
		$result["message"] .= htme($name) . ': ';
		$result["message"] .= $oknok['ok'];
		if (ipi($oknok['nok'])) {
			$result["message"] .= ' '.  htme($lang['allowed']) . ', ' . $oknok['nok'] . ' ' . htme($lang['notallowed']) . '';
		}
		$result['message'] .= "\n";
	}

	$result["result"] = "nok";
	if ($descendingdeleteresult) {
		$result["result"] = "ok";
	}

} elseif ($method == "validate_buttonclick" && $access) {


    /* we simply validate the button. value is always empty */
    list($result["result"], $result["message"], $result["corrected_value"]) = ValidateFieldInputDataStructureOnly($fqn, "", false, $recordid);

} elseif (($method == "general_element_change" || $method == "general_element_validate") && $access) {

    $some_changed = false;

    /* prepare */
    $result["autosaved"] = "0";
    $result["reload_list"] = $reload_list;
    $result["listid"] = $listid;
	$result["update_elements"] = array();

    $check_for_required_fields = true;

    if ($type != "interactive") {
        /* as it's NOT a form submit, we don't check for required, but empty, fields */
        //$check_for_required_fields = false;
    }

    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {
        /* decode json array */
        $value = json_decode($value);
    }



    /* the validator wants DUTCH FORMATTED DATES NO MATTER WHAT THE DB TYPE IS. format formatted dates here */
    /* we always receive dates formatted */
    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date (iso)") {

		$hv = false;
		if ($value != '') $hv = true;
		$value = INTLDate2NLDate(StrDate2IsoDate($value));
		if ($value == '' && $hv) {
			/* it HAD a value, but now it's gone, must have been wrong. trick old validator with bogus value to trigger error */
			$value = 'dl3b';
		}

    } elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date/time") {

    }

    /* use ValidateFieldInputDataStructureOnly to validate and correct the submitted value */
    list($result["result"], $result["message"], $result["corrected_value"]) = ValidateFieldInputDataStructureOnly($fqn, $value, $check_for_required_fields, $recordid);

	if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"] == '') {
		$result["textvalue"] = formatvalue($result["corrected_value"], $fqn);
	} else {
		$result["textvalue"] = get_refer_layout_for_record($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"], $result["corrected_value"]);
	}


    if ($method == "general_element_change")
    {
		//CODE DUPLICATION: general_element_change reloads calculations on the current form while reload_calculations reloads calculations on all the parent forms in fancybox popups. We should consolidate!

		//this code also runs when $result["result"] != "ok". this means calculations in the form will be emptied when they are dependent on form values that are not ok

		//formvalues is an array of data currently on the form. this data is not yet saved to the database (if USE_AUTOSAVE is No, or if this is a new form)
		//the data is this array is in the format AS IF it came from the database (in case of iso/nl dates)
		//EXCEPTION: diary fields and multiselect fields (both serialized) ARE not supported in this code. It seems unlikely though if these fields are ever used in a calculation
		$formvalues = array();
		foreach ($_POST as $key => $val)
		{
			if (preg_match("/^" . $table . "\-(f\d+)\-" . $recordid . "$/", $key, $match))
			{
				$thisfield = $match[1];

				//we need to validate every POST var on every general_element_change; because multiple fields on the form could simultaneously be filled incorrectly; and we do not want to pass incorrect values to mysql
				//TODO: validating all the fields could be fairly expensive (especially if refer-to-table fields are used - because the db needs to be queried to see wether the chosen value exists)
				//we could move this code to reload_calculations_after_field_change_with_form_data() and ONLY validate the fields which are actually needed in the calcs
				list($formvalue_result, $formvalue_message, $formvalue_corrected_value) = ValidateFieldInputDataStructureOnly($table . "-" . $thisfield, $val, $check_for_required_fields, $recordid);
				if ($formvalue_result != "ok")
				{
					continue;
				}
				$val = $formvalue_corrected_value;
				//TODO: ValidateFieldInputDataStructureOnly returns a date/time field in iso format, while dates are returned in the user preferred date format; THIS NEEDS TO BE CHANGED!
				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$thisfield]["dateformat_in_database"] == "yyyy-mm-dd hh:mm:ss")
				{
					$val = from_iso_datetime($val);
				}

				if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$thisfield]["fieldtype"] == "date")
				{
					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$thisfield]["dateformat_in_database"] == "yyyy-mm-dd hh:mm:ss")
					{
						$val = StrDateTime2IsoDateTime($val);
					}
					//it is a date or date iso field
					else
					{
						$val = StrDate2IsoDate($val);
						//we need the values AS IF they came from the database; so we convert to NL date format if this field is saved to the database in that manner
						if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$thisfield]["dateformat_in_database"] == "dd-mm-yyyy")
						{
							$val = INTLDate2NLDate($val);
						}
					}
				}
				$formvalues[$thisfield] = $val;
			}
		}

		//reload_calculations only contains calculation that may have a new value (because of the change in $field). Calculations that cannot have a new value are not returned
		//furthermore; the code in javascript only updates the client DOM if the new value actually is different from the one currently in the DOM
		//TODO (OR NOT?); if the client sends a list of the calculations that are currently on the form we can optimize this code further; however checking the DOM for calculations takes time as well...
		//...and since we use autoforms on many occassions ALL the calculations this user has access to are on the form anyhow
		$result["update_calculations"] = array();
		foreach (reload_calculations_after_field_change_with_form_data($table, $recordid, $field, $formvalues) as $calc_fqn => $calc_val)
		{
			$calc_formatted_val = $calc_val;

			list($calc_table, $calc_field) = explode("-", $calc_fqn);

			if ($GLOBALS["UC"]["PersonalDataStructure"][$calc_table]["fields"][$calc_field]["relation_to"] != "")
			{
				$calc_formatted_val = get_colorspan_and_htme($calc_table, $calc_field, get_refer_layout_for_record_field($calc_table, $calc_field, $calc_val), $calc_val);
			}
			else
			{
				//get the textual human readable value. it will be htme encoded when we get it back
				$calc_formatted_val = formatvalue($calc_val, $calc_fqn);
			}

			$result["update_calculations"][] = array($listid . "--" . $calc_fqn . "--" . $recordid, $calc_formatted_val, $calc_val);
		}

		//END CODE DUPLICATION: general_element_change reloads calculations on the current form while reload_calculations reloads calculations on all the parent forms in fancybox popups. We should consolidate!
    }


    if ($result["result"] == "ok") {

        if ($method == "general_element_change") {

            /* check if autosave is enabled for this specific field */
            if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["autosave"] || $type == 'interactive') {

                /* update the field here */
                if (ipi($recordid)) {
					/* the recordid could also be _new_, in that case, no autosave */

                    $to_save = "";

                    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {

						/* we don't support corrections on multiselect fields */
						$to_save = $value;

                    } else {

                        $to_save = $result['corrected_value'];

                    }

                    /* update_field_value wants exactly correct values. at this stage, everything is in dutch format. format it here if it's an iso date */
                    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date (iso)") {

                        $to_save = NLDate2INTLDate($to_save);
                    }
                    $bypass_security = false;
                    $dont_kick_rules = false;
                    $journal_addition = "(autosave)";

					/* TODO call process_record_save ??? */

                    $result["message"].= update_field_value($fqn_without_record, $recordid, $to_save, $bypass_security, $dont_kick_rules, $journal_addition);

                    $some_changed = true;

                    $result["autosaved"] = "1";
					/* we need to know client side if we have to treat the repsonse as html */
					$result["ishtml"] = "0";
					if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["ishtml"]) {
						$result["ishtml"] = "1";
					}

					if (!$GLOBALS['UC']['PersonalDataStructure'][$table]['datatable'] && $table != 'files') {
						require_once 'adminfunctions.php';
						AdminChangesDropCache();
					}

				}

            }

            if ($some_changed) {
                /* the updates could have left todo's behind. process them now */
                process_open_todos($table, $recordid);
            }

            /* odd exception: date/time fields. they will now be corrected to NL format, which is correct for the database, but not nescessarily for the user */
            if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date (iso)"
				|| $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date") {

                $result['corrected_value'] = from_iso_datetime(NLDate2INTLDate($result['corrected_value']));

            } elseif ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date/time") {

				$result['corrected_value'] = from_iso_datetime($result['corrected_value']);

			}

            /* now fetch all elements which, if available, should be refreshed because of this field change */
            $result["update_elements"] = get_elements_to_update_on_field_change($fqn_without_record);

            /* if the changed field is a field which refers to another table. if so, update all ifields using the same path */
            if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'] != "") {
			/* KAN DIT WEG? */
               // $result["update_elements"][] = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['relation_to'];

            }



        }
    } elseif ($result["message"] == "") {
        /* No messages on tabbing through forms unless the validator returns a specific message (probably from custom validator script) */

    }
    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['multiselect']) {
        /* we don't support corrections on multiselect fields */
        $result["corrected_value"] = "";
    }




} elseif ($method == "reload_element") {

    /* check access to the requested record */

	if (!is_array($fqn)) $fqn = array($fqn => array($value, $recordid));

	$result["result"] = array();

	foreach ($fqn AS $Mfqn => $el) {

		list($table, $field) = explode("-", $Mfqn);

		$value 		= $el[0];
		$recordid 	= $el[1];

		$access 	= CheckTableRecordAccess($table, $recordid);

		if ($access != "nok") {

			/* odd exception: date/time fields. they will now be corrected to ISO format, which is correct for the database, but not nescessarily for the user */
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date/time" || $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]['fieldtype_in_extrafields_table'] == "date") {
				$value = from_iso_datetime($value);
			}
			/* put complete new form element in result */

			if ($ifield == 1) {
				$result["result"][$Mfqn] = return_ifield($Mfqn, $recordid, $value, "", true, false);
			} else {
				$interactive_field_list_element = false;
				$result["result"][$Mfqn] = get_form_element($table . "-" . $field, $value, $recordid, false, false, $interactive_field_list_element);
			}

		}
	}

} elseif ($method == "reload_ifield") {

    /* this re-loads an entire ifield, even if the referring record has changed */

    $listid = "";
    $value = "";
    $is_reload = true;
	$result["result"] = array();

	/* $fqn is an array consisting of full-path ifield refereces, e.g. t18-f299-t2-f29-t1-f484-3 */
	foreach ($fqn AS $fqns => $recordid) {

		/* strip last element (contains recordid) and the first two elements*/
		$tmp = explode('-', $fqns);
		$ifield_div_name = implode('-', $tmp);

		array_shift($tmp);
		array_shift($tmp);

		/* the path without the first two, and the last element */
		$completepath = implode('-', $tmp);

		$field_in_target_table = $tmp[count($tmp)-2] . '-' . $tmp[count($tmp)-1];

		/* strip the field, add -recordid */
		array_pop($tmp);
		$record_in_target_table = implode('-', $tmp) . "-recordid";

		$target_table = $tmp[count($tmp)-1];


		/* first two elements are the ones we're looking for */
		list($sourcetable, $sourcefield) = explode("-", $fqns);

		$table = $GLOBALS['UC']['PersonalDataStructure'][$sourcetable]["fields"][$sourcefield]['relation_to'];

		/* get the concerning record */
		$tmp_current_record = getrecord($table, $recordid, false, false, array($record_in_target_table));
		$current_record = getrecord($target_table, $tmp_current_record[$record_in_target_table], false, false, array($field_in_target_table));

		$value = $current_record[$field_in_target_table];

		if ($current_record['*' . $field_in_target_table] == 1) {

			/* we now know all is ok */
			$skip_access_check = true;
			$result["result"][$ifield_div_name] = return_ifield($completepath, $tmp_current_record[$record_in_target_table], $value, $listid, $is_reload, $skip_access_check);

		} else {

			$result["result"][$ifield_div_name] = $value;
		}
	}



} elseif ($method == "load_ifield" && $access) {

    /* loads an ifield */

    /* check if field is writeable */
    if ($access) {

        /* make_ifield should cover security */
        $skip_access_check = false;
        $value_given = false;
        $value = "";

        $result["result"] = make_ifield($fqn_without_record, $recordid, $listid, $value, $value_given, $skip_access_check);

    } else {

        /* access was denied */
        $result["result"] = "a/d";

    }

} elseif ($method == "reload_calendar") {
    $listid_div_exists = false;
    if ($_GET['listid_div_exists'] == 1) {
        $listid_div_exists = true;
    }
    $result["result"] = ShowCalendar($_GET['listid'], $_GET['view'], $_GET['startdate'], $listid_div_exists, $_GET['cals_to_show']);

    $return_as_json = false;

} elseif ($method == "reload_calculations") {

    //CODE DUPLICATION: general_element_change reloads calculations on the current form while reload_calculations reloads calculations on all the parent forms in fancybox popups. We should consolidate!

    /*
    $value contains an array of field elements suffixed by "-calc". this function
    gets the new formatted value and puts it in an array which will be returned.
    */

    $tables = array();
    $rows = array();
    $return = array();

    /* compose structure of all table-record-field combo's we need */
    foreach ($value AS $calc) {

        $el = explode("--", $calc);

        list($loctable, $locfield) = explode("-", $el[1]);

        $locrecord = $el[2];

        if (!is_array($tables[$loctable])) $tables[$loctable] = array();
        if (!is_array($tables[$loctable][$locrecord])) $tables[$loctable][$locrecord] = array();
        if (!in_array($el[1], $tables[$locrecord])) $tables[$loctable][$locrecord][] = $el[1];

    }

    /* get all the records we now know we need */
    foreach ($tables AS $table => $records) {
        foreach ($records AS $record => $fields) {
            $rows[$table][$record] = getrecord($table, $record, false, false, $fields);
        }
    }

    /* now we need to format these values */

    /* cycle through array (again) */
    foreach ($value AS $calc) {

        $el = explode("--", $calc);
        $fqn = $el[1];

        list($loctable, $locfield) = explode("-", $fqn);
        $tmp = explode("-", $fqn);

        $targettable = $tmp[count($tmp) - 2];
        $targetfield = $tmp[count($tmp) - 1];

        $locrecord = $el[2];

		$textvalue = '';

        if ($GLOBALS['UC']['PersonalDataStructure'][$targettable]["fields"][$targetfield]['relation_to'] != "") {

            /* it's a refer field, fetch the representation layout */
	    $textvalue = get_colorspan_and_htme($targettable, $targetfield, get_refer_layout_for_record_field($targettable, $targetfield, $rows[$loctable][$locrecord][$fqn]), $rows[$loctable][$locrecord][$fqn]);

        } else {

            /* get the textual human readable value. it will be htme encoded when we get it back */
            $textvalue = formatvalue($rows[$loctable][$locrecord][$fqn], $fqn);

        }

		//$textvalue .= 'FQN:' . $fqn . '----' . $targettable . "-" . $targetfield;

		$unparsedvalue = $rows[$loctable][$locrecord][$fqn];

        $return[] = array($calc, $textvalue, $unparsedvalue);
    }

    $result["result"] = $return;

    //END CODE DUPLICATION: general_element_change reloads calculations on the current form while reload_calculations reloads calculations on all the parent forms in fancybox popups. We should consolidate!

} elseif ($method == "update_diary" && $access) {

    /* get current record, but only the field we need */
    if (!is_array($current_record)) {
        $current_record = getrecord($table, $recordid, false, false, array($fqn_without_record));
    }

    /* get current diary content. it's in the database as a serialized array (ouch). FlattenArray is important to make sure keys increment 1 when looping */
    $current_diary = FlattenArray(unserialize($current_record[$fqn_without_record]));

    /* the var to hold the action description for the journals */
    $whatj = "added";
    $whatdj = "{{add}}";

    /* update only if a value was given. else, it's refresh only. check for commenthash+delete option */
    if ($value != "" || ($commenthash != '' && $delentry == 1)) {

        /* check for comment hash. if so, it's an update of an existing entry */
        if ($commenthash != "") {

            /* check privilege to alter diary contents */
            if (CheckFunctionAccess("AllowedToAlterDiaryContents") == "ok" || is_administrator()) {

                /* loop through all entries and check if commenthas matches */
                for ($lus = 0; $lus < count($current_diary); $lus++) {

                    /* generate hash ... */
                    $commenthash_this_entry = md5($current_diary[$lus][0] . $current_diary[$lus][1] . $current_diary[$lus][2]);

                    /* and compare */
                    if ($commenthash == $commenthash_this_entry) {

                        /* for datajournal, it needs to contain the old value */
                        $whatdj = $current_diary[$lus][2];

                        /* set journal action description */
                        $whatj = "updated";

                        if ($delentry == 1) {

                            /* delete the entry entirely */
                            unset($current_diary[$lus]);
                            $whatj = "deleted";

                        } else {

                            /* update the element to the new value */
                            $current_diary[$lus][2] = $value;
                        }

                        /* stop the for loop, we found what we were looking for */
                        break;
                    }
                    //$whatj = "HASH MISMATCH";
                    //$result["message"] = "Hash mismatch, not updated.";

                }
            } else {
                $whatj = "NO ACCESS";
                $result["message"] = "Access denied";
            }

        } else {

            /* add array with new value */
            $current_diary[] = array(date('U'), $GLOBALS['USERID'], $value);
        }
	    /* compose stuff to put into the database */
        $ser = serialize($current_diary);

        /* update database */
        $sql = "UPDATE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "` SET `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name_in_database"] . "`='" . mres($ser) . "' WHERE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["primary"] . "` = '" . $recordid . "'";

        mcq($sql);

		/*
		$check = "SELECT `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name_in_database"] . "` FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "` WHERE `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"] . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$table]["primary"] . "` = '" . $recordid . "'";
		if ($ser != db_GetValue($check)) {
			mail("", "Diary update failed!", string_r($current_diary));
		}
		*/

        journal($recordid, "A record was " . $whatj . " to diary field " . $fqn_without_record . ". Text: " . $value, ds_tablename_to_journal_tabletype($table));
        DataJournal($recordid, $whatdj, $value, str_replace("f", "", $field));

        AddToDo($fqn_without_record, $value, $recordid, $current_record[$fqn_without_record]);
        AddToDo($table . "-changed", "", $recordid, '');

    }

    $result["result"] = get_formatted_diary_table($fqn_without_record, $recordid, $current_diary);
	$result["value"] = $value;
    //$result["result"] = "FQN: $fqn $sql";

} elseif ($method == "get_field_value") {

	$result["result"] = $current_record[$fqn_without_record];

} elseif ($method == "rotate_image") {

	$angle = '270';
	if ($value == 'left') {
		$angle = '90';
	}
	if (RotateImage($recordid, $angle)) {
		$result['result'] = "ok";
		$result['message'] = "";
	} else {
		$result['result'] = "nok";
		$result['message'] = "An error occured rotating this image.";
	}

} elseif ($method == "search_all_tables") {

	$result = array();

	if (is_administrator()) {

		$name_in_database_openlink = array();
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
		{
			if ($GLOBALS['UC']['PersonalDataStructure'][$table]["openlink"] != "")
			{
				$name_in_database_openlink[$GLOBALS['UC']['PersonalDataStructure'][$table]["name_in_database"]] = $GLOBALS['UC']['PersonalDataStructure'][$table]["openlink"];
			}
		}
		require_once 'adminfunctions.php';
		$hits = search_all_admin_tables($value, false);
		if (count($hits) > 0) $result['SPACER0'] = 'Configuration items';
		foreach ($hits as $hit)
		{
			if (preg_match("/^CRM(\w+) \w+\=(\w+)/", $hit, $match))
			{
				if ($name_in_database_openlink[$match[1]] != "")
				{
					$result[$name_in_database_openlink[$match[1]] . $match[2]] = htme(substr($hit, 0, 100));
				}
			}

		}

	}

	$spacercount = 99;
	foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $props) {

		if ($props['IncludeInSystemWideSearches']) {

			$listoptions = array();
			$listoptions["table"] = $table;
			$listoptions["outputtype"] = "array";
			$listoptions["internallistcall"] = true;
			$listoptions["listlayoutcolumns"] = $table . "-" . $props['primary'];
			$listoptions["perpage"] = 0;
			$listoptions["search"] = $value;
			$listoptions["search_parents"] = false;
			$listoptions["search_childs"] = false;
			$listoptions["RemoveExtraSelectCondition"] = true;
			$listoptions["1ignorelastview"] = true;

			$rows = make_list($listoptions);
			if (count($rows) > 0) {
				$result['SPACER' . $spacercount++] = htme($props['plural']);
				foreach($rows AS $row) {
					$result[$props['openlink'] . $row[$table . '-' . $props['primary']]] = htme(get_refer_layout_for_record($table, $row[$table . '-' . $props['primary']]));
				}
			}
		} else {
		//	$result[] = $table . ' may nog be included';
		}
	}
} elseif ((GetSetting("NotificationsEnabled") == "Yes") && ($method == "RegisterEndpoint")) {
	$endpoints = GetAttribute("user", "endpoints", $GLOBALS["USERID"]);
	if (!is_array($endpoints))
	{
		$endpoints = array();
	}

	//registerendpoint is called repeatedly, so we might already know this endpoint
	if (!in_array($_POST["endpoint"], $endpoints))
	{
		//TODO: do we need to validate this new endpoint? it must be valid json
		$endpoints[] = $_POST["endpoint"];

		SetAttribute("user", "endpoints", $endpoints, $GLOBALS["USERID"]);
		log_msg("RegisterEndpoint: " . $_POST["endpoint"]);
	}

	$result["result"] = "ok";

} elseif ((GetSetting("NotificationsEnabled") == "Yes") && ($method == "RemoveEndpoint")) {
	$endpoints = GetAttribute("user", "endpoints", $GLOBALS["USERID"]);
	if (!is_array($endpoints))
	{
		$endpoints = array();
	}
	$newendpoints = array();
	foreach ($endpoints as $endpoint)
	{
		if ($endpoint != $_POST["endpoint"])
		{
			$newendpoints[] = $endpoint;
		}
	}

	if ($newendpoints != $endpoints)
	{
		SetAttribute("user", "endpoints", $newendpoints, $GLOBALS["USERID"]);
		log_msg("RemoveEndpoint: " . $_POST["endpoint"]);
	}

	$result["result"] = "ok";

} elseif ((GetSetting("NotificationsEnabled") == "Yes") && ($method == "NotificationSoftFail")) {

    log_msg("NotificationSoftFail");
    SetAttribute("user", "NotificationSoftFail", db_GetValue("SELECT NOW()"), $GLOBALS["USERID"]);

} elseif ((GetSetting("NotificationsEnabled") == "Yes") && ($method == "NotificationHardFail")) {

    log_msg("NotificationHardFail: " . $_POST["error"]);
    SetAttribute("user", "NotificationHardFail", db_GetValue("SELECT NOW()"), $GLOBALS["USERID"]);

}



if ($return_as_json) {
    /* pass the complete result set back to the client, JSON encoded */

	/* WATCH OUT: when passing this content type, jquery auto-ParseJSON's the response. DONT ENABLE */
    //header("Content-type: application/json; charset=UTF-8");


    print json_encode(array($method, $fqn, $recordid, $result));
} else {
    //header("Content-Type: text/html; charset=UTF-8");
    /* refresh_contents_of_div doesn't expect json, just plain result */

    print $result["result"];
}

EndHTML(false);
?>
