<?php
/* ********************************************************************
* Interleave
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* This file does several things :)
*
* Check http://www.interleave.nl/ for more information
*
* BUILD / RELEASE :: 7.2.0.20180308
*
**********************************************************************
*/
require_once "initiate.php";
$recordid = $_REQUEST['concerningrecord'];

if (is_administrator())
{
	$GLOBALS["InAdminSection"] = true;
}

ShowHeaders();


if (CheckFunctionAccess("UserAdmin") <> "ok" && !is_administrator()) {

	PrintAD("Access to this page/function denied.");

} elseif ($_REQUEST['EditUser'] != "" && (!is_numeric($_REQUEST['EditUser']) || db_GetValue("SELECT COUNT(*) FROM CRMloginusers WHERE id='" . mres($_REQUEST['EditUser']) . "'") != 1)) {

	// General catch-all
	PrintAD("Access denied or non-existent");

} elseif ($_REQUEST['EditGroup'] != "" && (!is_numeric($_REQUEST['EditGroup']) || db_GetValue("SELECT COUNT(*) FROM CRMuserprofiles WHERE id='" . mres($_REQUEST['EditGroup']) . "'") != 1)) {

	// General catch-all
	PrintAD("Access denied or non-existent");

} elseif (ipi($_REQUEST['show_ds'])) {

	if (is_administrator()) {
		$tmpuser = $GLOBALS['USERID'];
		$tpa = $GLOBALS['SesMem']['TPADone'];
		InitUser($_REQUEST['show_ds']);

		$ds = get_data_structure();
		print "<pre>Data structure size: " . round(strlen(serialize($ds))/1024) . "KB\n</pre>";

		print "<pre>" . htme(string_r($ds)) .  "</pre>";

		InitUser($tmpuser);
		$GLOBALS['SesMem']['TPADone'] = $tpa;

	}

} elseif (ipi($_REQUEST['show_ds_reasons'])) {

	if (is_administrator()) {
		$tmpuser = $GLOBALS['USERID'];
		$tpa = $GLOBALS['SesMem']['TPADone'];
		InitUser($_REQUEST['show_ds_reasons']);

		print "<table class=\"crm noclick filtertable\">";
		foreach (GetAttribute("user", "DataStructureAccessReasons", $_REQUEST['show_ds_reasons']) AS $line) {
			print "<tr><td>" . htme($line) . "</td></tr>";
		}
		print "</table>";

		InitUser($tmpuser);
		$GLOBALS['SesMem']['TPADone'] = $tpa;
	}

} else {

	if (is_administrator()) {
		require_once "adminfunctions.php";
	}

	if (ipi($_REQUEST['EditGroup'])) {
		$table = "groups";
		$recordid = $_REQUEST['EditGroup'];
		print familytree($table, $recordid, $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
		print '<div>';
		if (is_administrator() || (CheckFunctionAccess("DenyJournalAccess") != "ok" && CheckFunctionAccess("UserAdmin") == "ok")) {
			print '<a title="Journal" href="journal.php?table=groups&amp;recordid=' . $_REQUEST['EditGroup'] . '&amp;nonavbar=1" onclick="PopFancyBoxLarge(\'\', this.href); return false;"><span class="fa fa-book"></span></a> ';
		}
		print "<h1 class=\"showinlineblock\">" . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["singular"] . " " . get_refer_layout_for_record($table, $recordid)) . "</h1>";
		print '</div>';
	} elseif (ipi($_REQUEST['EditUser'])) {
		$table = "users";
		$recordid = $_REQUEST['EditUser'];
		print familytree($table, $recordid, $_REQUEST['starttable'], $_REQUEST['startrecordid'], $_REQUEST['fromlist']);
		print '<div>';
		if (is_administrator() || (CheckFunctionAccess("DenyJournalAccess") != "ok" && CheckFunctionAccess("UserAdmin") == "ok")) {
			print '<a title="Journal" href="journal.php?table=users&amp;recordid=' . $_REQUEST['EditUser'] . '&amp;nonavbar=1" onclick="PopFancyBoxLarge(\'\', this.href); return false;"><span class="fa fa-book"></span></a> ';
			print '<a href="useradmin.php?nonavbar=1&amp;ActivityUserGraph=' . $_REQUEST['EditUser'] . '" onclick="PopFancyBoxLarge(\'\', this.href); return false;"><span class="fa fa-line-chart"></span></a> ';
		}
		print "<h1 class=\"showinlineblock\">" . htme($GLOBALS['UC']['PersonalDataStructure'][$table]["singular"] . " " . get_refer_layout_for_record($table, $recordid));
		$last_login = db_GetValue("SELECT timestamp_last_change FROM CRMuselog WHERE qs='Login " . mres(GetUserAccountName($_REQUEST['EditUser'])) . "' ORDER BY id DESC");
		print ", last login: " . SQLDateTimeToFormattedDateTime($last_login) . ", total logins: ";
		print FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE qs='Login " . mres(GetUserAccountName($_REQUEST['EditUser'])) . "'"), 0);
		print "</h1>";
		print '</div>';
	}

	if ($_REQUEST['delete'] == "Delete" && is_numeric($_REQUEST['EditUser'])) {

		if ((!is_administrator()) && (CheckTableRecordAccess("users", $_REQUEST['EditUser']) != "ok")) {
			PrintAD("You are not allowed to view/edit this user.");
		} else {
			log_msg("User " . GetUserName($GLOBALS['USERID']) . " deleted user " . $_REQUEST['EditUser'] . " (" . GetUserName($_REQUEST['EditUser']) . ")");
			journal($_REQUEST['EditUser'], "User " . GetUserName($GLOBALS['USERID']) . " deleted user " . $_REQUEST['EditUser'] . " (" . GetUserName($_REQUEST['EditUser']) . ")", "user");
			mcq("UPDATE CRMloginusers SET active='no',name='deleted_user__" . mres(GetUserAccountName($_REQUEST['EditUser'])) . "' WHERE id='" . mres($_REQUEST['EditUser']) . "'");

			DataJournal($_REQUEST['EditUser'], "n", "y", "user-deleted");
			DropAllUserCache($_REQUEST['EditUser']);
			Processrules("users", $_REQUEST['EditUser'], "", "deleted","");
			Processrules("users", $_REQUEST['EditUser'], "", "changed","");
			$_REQUEST['cur'] = true;
		}
		unset($_REQUEST['EditUser']);
		unset($_REQUEST['Saved']);

	} elseif ($_REQUEST['EditGroup'] && !is_administrator()) {
		//because group now is a link in the familytree 2016-03-11
		//PrintAD("You're not allowed to change group properties");
		print '<div class="errmsg">You\'re not allowed to change group properties</div>';
		unset($_REQUEST['EditGroup']);
		unset($_REQUEST['Saved']);

	} else {
		$conc_table = "";
		$EditingProfile = false;
		if ($_REQUEST['EditUser']) {
			$conc_table = "CRMloginusers";

			//DropAllUserCache($_REQUEST['EditUser']);
			$pwdreset = GetAttribute("user","PasswordNeverExpires", $_REQUEST['EditUser']);
			if ($pwdreset == "") {
				SetAttribute("user", "PasswordNeverExpires", "False", $_REQUEST['EditUser'], array("False", "True"));
			}
			$DontRequireTPAWhenFromIPCSV = GetAttribute("user","DontRequireTPAWhenFromIPCSV", $_REQUEST['EditUser']);
			if ($DontRequireTPAWhenFromIPCSV == "") {
				SetAttribute("user", "DontRequireTPAWhenFromIPCSV", "{{none}}", $_REQUEST['EditUser']);
			}
		} elseif ($_REQUEST['EditGroup']) {
			$DontRequireTPAWhenFromIPCSV = GetAttribute("group","DontRequireTPAWhenFromIPCSV", $_REQUEST['EditGroup']);
			if ($DontRequireTPAWhenFromIPCSV == "") {
				SetAttribute("group", "DontRequireTPAWhenFromIPCSV", "{{none}}", $_REQUEST['EditGroup']);
			}
			$OpenAllTablesWithFormId = GetAttribute("group","OpenAllTablesWithFormId", $_REQUEST['EditGroup']);
			if ($OpenAllTablesWithFormId == "") {
				SetAttribute("group", "OpenAllTablesWithFormId", "{{none}}", $_REQUEST['EditGroup']);
			}
			$_REQUEST['EditUser'] = $_REQUEST['EditGroup'];
			$conc_table = "CRMuserprofiles";
			$EditingProfile = true;
		}
		$journal_add = "";

		if ((!$EditingProfile) && (is_positive_integer($_REQUEST['EditUser'])) && (!is_administrator()) && (CheckTableRecordAccess("users", $_REQUEST['EditUser']) != "ok")) {
			PrintAD("You are not allowed to view/edit this user.");
		} else {
			if ($_REQUEST['Saved']) {
				if ($_REQUEST['HIDEFROMASSIGNEEANDOWNERLISTS'] == "") {
					$_REQUEST['HIDEFROMASSIGNEEANDOWNERLISTS'] = "n";
				} else {
					$_REQUEST['HIDEFROMASSIGNEEANDOWNERLISTS'] = "y";
				}
				if ($_REQUEST['FORCEPASSCHANGE'] == "") {
					$_REQUEST['FORCEPASSCHANGE'] = "n";
				} else {
					$_REQUEST['FORCEPASSCHANGE'] = "y";
				}

				if (!is_positive_integer($_REQUEST['dashboardtemplate'])) {
					$_REQUEST['dashboardtemplate'] = 0;
				}
				if (!is_positive_integer($_REQUEST['customtabmenu'])) {
					$_REQUEST['customtabmenu'] = 0;
				}

				$pwd = "";
				if ($_REQUEST['accpass1']<>"") {
					if ($_REQUEST['accpass1'] == $_REQUEST['accpass2']) {
						$pwd = "password=PASSWORD('" . mres($_REQUEST['accpass1']) . "'), LASTPASSCHANGE=NOW(),";
						$journal_add .= "\nPassword changed";
						DataJournal($_REQUEST['EditUser'], "*****", "****", "password-changed", "user");

					} else {
						$journal_add .= "\nMessage display: Password not saved; they are not the same.";
					}
				}

				$sql= "UPDATE " . $conc_table . " SET ";

				// Some important security (direct posting)
				if (!is_administrator()) {
					$adminfunctions = explode(",", "Administrator");
					foreach ($adminfunctions AS $func) {
						$oldcl = GetClearanceLevel($_REQUEST['EditUser']);
						if (in_array($func, $oldcl)) { // Check if admin rights exists in former profile
							if (!in_array($func, $_REQUEST['AccArr'])) {
								array_push($_REQUEST['AccArr'], $func);
								// Make sure rights are preserved
								$journal_add .= "\nOriginal administrative rights (" . $func . ") were preserved";
							} else {
								// This is illegal
								$journal_add .= "\nMessage display: This is not good - incident reported.";
								PrintAD("This is not good - incident reported.");
								EndHTML();
								exit;
							}
						}
					}

				}

				$admin = "no";
				$CLLEVEL = "";
				if (in_array("Administrator", $_REQUEST['AccArr'])) {
					$admin = "yes";
					$t = array();
					$t[] = "MaySelectColumns";
					$t[] = "Administrator";

					if (in_array("OnlyDevelopmentAdmin", $_REQUEST['AccArr'])) {
						$t[] = "OnlyDevelopmentAdmin";
					}
					if (in_array("requiretpa", $_REQUEST['AccArr'])) {
						$t[] = "requiretpa";
					}
					$CLLEVEL = serialize($t);
					$journal_add .= "\nUser edited is admin";
				} else {
					$journal_add .= "\nUser edited is not an admin";
					$CLLEVEL = serialize($_REQUEST['AccArr']);
				}

				$dont_update = false;
				if (!$EditingProfile) {

					if (ValidateEmail($_REQUEST['EMAIL'])) {

						$sql .= $pwd . " PROFILE='" . mres($_REQUEST['profile']) . "', administrator='" . mres($admin) . "', EMAIL='" . mres(trim($_REQUEST['EMAIL'])) . "',FULLNAME='" . mres($_REQUEST['FULLNAME']) . "', FORCEPASSCHANGE='" . mres($_REQUEST['FORCEPASSCHANGE']) . "'";

						$cur = db_GetRow("SELECT * FROM CRMloginusers WHERE id='" . mres($_REQUEST['EditUser']) . "'");
						// DateJournal won't journal if values are the same

						DataJournal($_REQUEST['EditUser'], $cur['FULLNAME'], $_REQUEST['FULLNAME'], "FULLNAME", "user");
						DataJournal($_REQUEST['EditUser'], $cur['EMAIL'], $_REQUEST['EMAIL'], "EMAIL", "user");
						DataJournal($_REQUEST['EditUser'], $cur['PROFILE'], $_REQUEST['profile'], "PROFILE", "user");
						journal($_REQUEST['EditUser'], "User " . GetUserName($GLOBALS['USERID']) . " saved properties of user " . $_REQUEST['EditUser'] . " (" . GetUserName($_REQUEST['EditUser']) . ")", "user");

						Processrules("users", $_REQUEST['EditUser'], "", "changed","");

						$for_rules = array("PROFILE" => "profile", "EMAIL" => "EMAIL", "FULLNAME" => "FULLNAME");
						foreach ($for_rules AS $fieldname => $postname) {
							if ($cur[$fieldname] != $_REQUEST[$postname]) {
								Processrules("users", $_REQUEST['EditUser'], "" . $fieldname, "changed","");
							}
						}


						DropPersonalDataStructure($_REQUEST['EditUser']);
					} else {
						$dont_update = true;
						PrintAD("Invalid e-mail address. Form not saved.");
					}

				} else {
					$webappmenu = 0;
					if ((GetSetting('WebAppEnabled') == 'Yes') && (is_positive_integer($_REQUEST['webappmenu'])))
					{
						$webappmenu = $_REQUEST['webappmenu'];
					}

					$sql .= " name='" . mres($_REQUEST['newgroupname']) . "', DASHBOARDFILEID='" . mres($_REQUEST['dashboardtemplate']) . "', MENUTOUSE='" . mres($_REQUEST['customtabmenu']) . "', webappmenu=" . $webappmenu;

					DropPersonalDataStructure($_REQUEST['EditUser']);

				}

				if (!$dont_update) {

					$sql .= ", HIDEFROMASSIGNEEANDOWNERLISTS='" . mres($_REQUEST['HIDEFROMASSIGNEEANDOWNERLISTS']) . "', CLLEVEL='" . mres($CLLEVEL) . "', active='yes' WHERE id='" . mres($_REQUEST['EditUser']) . "'";
					mcq($sql);
				//	print $sql;

					//password is updated
					if ($pwd != "")
					{
						//delete all current sessions of this user
						mcq("DELETE FROM `CRMsessions` WHERE `userid`='" . mres($_REQUEST['EditUser']) . "'");
					}
				}

				if ($EditingProfile) {
					journal($_REQUEST['EditUser'], "Group properties of group " . GetGroupName($_REQUEST['EditUser']) . " saved" . $journal_add, "group");
				} else {
					journal($_REQUEST['EditUser'], "User properties of user " . GetUserName($_REQUEST['EditUser']) . " saved" . $journal_add, "user");
				}

			} elseif ($_REQUEST['AddProfile']) {

				if ($_REQUEST['NewGroupName'] != "") {
					mcq("INSERT INTO CRMuserprofiles(name) VALUES('" . mres($_REQUEST['NewGroupName']) . "')");
					$recordid = db_GetInsertId();

					print JS("window.location.href='useradmin.php?EditGroup=" . $recordid . "&fromlist=" . base64_encode("useradmin.php?cur=true") . "'");
					$EditingProfile = true;
				} else {
					print "<div class=\"errmsg\">Please enter at least a group name.</div>";
				}
			}


			$table = "groups";
			if (!$EditingProfile) {
				$table = "users";
			}

			$something_changed = false;

			// Loop through posted fields
			foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"] AS $fieldname => $fieldproperties) {



				$fieldnum = str_replace("f", "", $fieldname);



				if (ipi($fieldnum)) {



					$fqn = $table . "-" . $fieldname;

					$posted_value = "";

					if ($_REQUEST[$table . '-' . $fieldname . '-' . $recordid] != "") {
						if (is_array($_REQUEST[$table . '-' . $fieldname . '-' . $recordid])) {
							$posted_value = $_REQUEST[$table . '-' . $fieldname . '-' . $recordid];
						} else {
							$posted_value = trim($_REQUEST[$table . '-' . $fieldname . '-' . $recordid]);
						}
					} elseif ($_REQUEST[$table . '-' . $fieldname . '-_new_'] != "") {

						if (is_array($_REQUEST[$table . '-' . $fieldname . '-_new_'])) {
							$posted_value = $_REQUEST[$table . '-' . $fieldname . '-_new_'];
						} else {
							$posted_value = trim($_REQUEST[$table . '-' . $fieldname . '-_new_']);
						}
					}


					if ($posted_value != "" || (is_array($posted_value) && count($posted_value) > 0)) {


						list ($result, $dummy, $value) = ValidateFieldInputDataStructureOnly($fqn, $posted_value, true, false);


						/* we don't support correcting multiselect fields */

						if (is_array($posted_value)) {
							$value = $posted_value;
						}
						if ($result == "ok") {
							$bypass_security = false;
							$dont_kick_rules = false;
							$journal_addition = "";

							update_field_value($fqn, $recordid, $value, $bypass_security, $dont_kick_rules, $journal_addition);
							$something_changed = true;

							//print 'process ' . $fieldname . ': ' . $fieldnum . ' val ' . print_r($posted_value) . '<br>';

						} else {

							log_msg("WARNING: Skipping pre-set value for field " . $fieldname . " : value didn't validate");
							print("WARNING: Skipping pre-set value for field " . $fieldname . " : value didn't validate");

						}
					}
				}
			}
			if ($something_changed) {
				DropPersonalDataStructure();
			}

			// Process any buttons (must be the last action)s

				if ($_REQUEST['e_button']) {
					$x = GetAllButtons($_REQUEST['e_button']);
					if ($x[0]['fieldtype'] == "Button") {
							// So, a button was pressed (and the user has the rights to press it)
							qlog(INFO, "An field button was pressed. Processing triggers.");
							journal($_REQUEST['EditUser'], "User pressed button " . $x['id'] . "::" . $x['name'], "user");
							Processrules("users", $_REQUEST['EditUser'], "f" . $_REQUEST['e_button'], "pressed", "");
						}

				}


			if ($_REQUEST['AddUser']) {

				if ($_REQUEST['AddUserSave']) {
					if ($_REQUEST['newuser'] != "") {
						if ($_REQUEST['accpass1'] == $_REQUEST['accpass2']) {
							if (!is_administrator() && (!is_positive_integer($_REQUEST['newuserprofile']))) {

								PrintAD("You're not allowed to add users without a group!");

							} else {

								if (ValidateEmail($_REQUEST['newemail'])) {

									if (db_GetValue("SELECT COUNT(*) FROM CRMloginusers WHERE EMAIL ='" . mres($_REQUEST['newuser']) . "' OR name='" . mres($_REQUEST['newuser']) . "' AND active='yes'") > 0) {

										PrintAD("Username or e-mail address not unique. User not added.");

									} else {

										mcq("INSERT INTO CRMloginusers(name,password,FULLNAME,EMAIL,FORCEPASSCHANGE,LASTPASSCHANGE,PROFILE) VALUES('" . mres($_REQUEST['newuser']) . "',PASSWORD('" . mres($_REQUEST['accpass1']) . "'),'" . mres($_REQUEST['newuserfullname']) . "','" . mres($_REQUEST['newemail']) . "','y',NOW(),'" . mres($_REQUEST['newuserprofile']) . "')");
										$t = db_GetInsertId();

										if ($_REQUEST['newuserprofile'] > 0) {
											Processrules("users", $t, "", "changed", "");
											Processrules("users", $t, "", "added","");

											$for_rules = array("PROFILE" => "newuserprofile", "EMAIL" => "newemail", "FULLNAME" => "newuserfullname");
											$cur = array(); /* alles is nieuw */
											foreach ($for_rules AS $fieldname => $postname) {
												if ($cur[$fieldname] != $_REQUEST[$postname]) {
													Processrules("users", $t, "" . $fieldname, "changed","");
												}
											}
										}
										$fields = GetExtraUserFields();
										foreach ($fields AS $field) {
											if (isset($_REQUEST['EFID' . $field['id']])) {
												if (is_array($_REQUEST['EFID' . $field['id']])) {
													$_REQUEST['EFID' . $field['id']] = serialize($_REQUEST['EFID' . $field['id']]);
												}
												$curval = GetExtraFieldValue($t, $field['id'], false, true, false);
												if ($curval != $_REQUEST['EFID' . $field['id']]) {

													$bypass_security = false;
													$dont_kick_rules = false;
													$journal_addition = "";

													update_field_value("users-f" . $field['id'], $t, $_REQUEST['EFID' . $field['id']], $bypass_security, $dont_kick_rules, $journal_addition);


													//print "SET " . $field['id'] ." name " . $field['name'] . " to " . $_REQUEST['EFID' . $field['id']];
													journal($t, "Field f" . $field['id'] . " updated from [" . $curval . "] to [" . $_REQUEST['EFID' . $field['id']] . "]", "user");
												}
											}
										}
										print "<h1>User added</h1>";

										print '<script type="text/javascript">window.location.href = "useradmin.php?EditUser=' . $t . '&fromlist=' . base64_encode("useradmin.php?cur=true") . '";</script>';
									}

								} else {
									PrintAD("The e-mail addres you entered is invalid. User not added");
								}
							}
						} else {
							print '<div class="errmsg">Passwords do not match; user not added.</div>';
						}
					} else {
						print '<div class="errmsg">Please enter at least a user name.</div>';
					}

				}
			} elseif ($_REQUEST['cur']) {

				print "<input type=\"button\" class=\"addbutton\" onclick=\"PopFancyBoxDimensioned('Add a user', '#add-user', 400, 750);\" value=\"Add a user\">";

				$lo = array("table" => "users", "hide_selections" => true, "search_files" => false, "search_childs" => false, "hiddenfilter" => array("users-active" => array('yes')));

				list($number_of_records, $output) = make_list($lo);
				print $output;

				print "<div id=\"add-user\" class=\"hide_content\">";
				print "<h1>New user</h1>";
				print '<form class="recordform" novalidate autocomplete="off" id="users-_new_" method="post" action="" onsubmit="return general_form_submit(this.id, \'_new_\');">';

				print "<table class=\"form-table\">";
				print '<tbody>';
				print "<tr><th>" . htme($lang["username"]) . "</th><td><input type='text' size='50' name='newuser' id='JS_newuser'></td></tr>";
				print "<tr><th>" . htme($lang["name"]) . "</th><td><input type='text' size='50' name='newuserfullname' id='JS_newuserfullname'></td></tr>";
				print "<tr><th>" . htme($lang["emailaddress"]) . "</th><td><input type='text' size='50' name='newemail' id='JS_newemail'></td></tr>";
				print "<tr><th>" . htme($lang['password']) . "</th><td><input type='password' size='50' name='accpass1' id='accpass1id' onkeyup=\"InlineCheckPasswordStrength('accpass1id');\"></td></tr>";
				print "<tr><th>" . htme($lang['password']) . " (confirm)</th><td><input type='password' size='50' name='accpass2' id='accpass2id' onkeyup=\"InlineCheckPasswordStrength('accpass2id');\"></td></tr>";

				/*
				 *foreach ($GLOBALS['UC']['PersonalDataStructure']["users"]["fields"] AS $name => $field) {
					if ($field["fieldtype_in_extrafields_table"] != "" && $field["allowed_to_write"]) {
						print "<tr><td>" . htme($field['name']) . "</td><td>";
						$tag = "users-" . $name;
						print '<div id="ffc-' . $tag . '">';
						print get_form_element($tag, "", "_new_", array(), false, false, "");
						print '</div>';
						print "</td></tr>";
					} elseif ($field["fieldtype_in_extrafields_table"] != "") {
						$html = "<tr><td>" . htme($field['name']) . "</td><td>";
						$html .= "@" . $name . "@";
						$html .= "</td></tr>";

						print ParseTemplateRecordData($html, "users", $_REQUEST['EditUser'], false);
					}
				}

			*/
				$la = GetUserProfiles();
				print "<tr><th>" . $lang['group'] . "</th><td><select name='newuserprofile'>";
				if (is_administrator()) {
					print "<option value=''>- no group -</option>";
				}
				foreach($la AS $profile) {
					print "<option value='" . $profile[0] . "'>" . htme($profile[1]) . "</option>";
				}
				print "</select></td></tr>";
				print '</tbody>';
				print "</table>";
				print "<input type='hidden' name='AddUser' value='true'><input type='hidden' name='AddUserSave' value='true'><input type='submit' value='Create user' class='addbutton'></form>";
				print "</div>";

				if (is_administrator()) {
					print "<br>";
					print "<input type=\"button\" class=\"addbutton\" onclick=\"PopFancyBoxDimensioned('Add a group', '#add-group', 50, 400);\" value=\"Add a group\">";

					list($number_of_records, $output) = make_list(array("table" => "groups", "hide_selections" => true, "search_files" => false, "search_childs" => false));
					print $output;
					print "<div id=\"add-group\" class=\"hide_content\">";
					print "<h1>Create a new group</h1>";
					print '<form class="recordform" novalidate autocomplete="off" id="groups-_new_" method="post" action="" onsubmit="return general_form_submit(this.id, \'_new_\');">';
					print "<table class=\"form-table\">";
					print '<tbody>';
					print "<tr><th>New group name</th><td><input type='text' name='NewGroupName' id='JS_NewGroupName'></td></tr>";
					foreach ($GLOBALS['UC']['PersonalDataStructure']["groups"]["fields"] AS $name => $field) {
						if ($field["fieldtype_in_extrafields_table"] != "" && $field["allowed_to_write"]) {
							print "<tr><th>" . htme($field['name']) . "</th><td>";
							$tag = "groups-" . $name;
							print '<div id="ffc-' . $tag . '">';
							print get_form_element($tag, "", "_new_", array(), false, false, "");
							print '</div>';
							print "</td></tr>";
						} elseif ($field["fieldtype_in_extrafields_table"] != "") {
							$html = "<tr><th>" . htme($field['name']) . "</th><td>";
							$html .= "@groups-" . $name . "@";
							$html .= "</td></tr>";

							print ParseTemplateRecordData($html, "groups", $_REQUEST['EditGroup'], false);
						}
					}
					print '</tbody>';
					print "</table>";
					print "<br><input type='submit' value='Create group' class='addbutton'><input type='hidden' name='AddProfile' value='true'>";
					print "</form>";
					print "</div>";
				}

			} elseif ($_REQUEST['profiles']) {

			} elseif ($_REQUEST['EditGroup'] || $_REQUEST['EditUser']) {

				$to_tabs = array();

				if (!$EditingProfile && is_numeric(GetGroup($_REQUEST['EditUser']))) {


				} elseif (!$EditingProfile && !is_administrator()) {

					$to_tabs = array("Personals");


				} elseif (!$EditingProfile && is_administrator($_REQUEST['EditUser'])) {
					$to_tabs = array("Personals", "Privileges");


				} elseif ($EditingProfile) {
					$to_tabs = array("Personals", "Members", "Privileges", "Record access rules", "Limits");

				} else {
					$to_tabs = array("Personals", "Privileges");

				}


				$sql= "SELECT * FROM " . $conc_table . " WHERE id='" . mres($_REQUEST['EditUser']) . "'";
				$result= db_GetRow($sql);
				$AccArr = unserialize($result['CLLEVEL']);
				$recordid = $_REQUEST['EditUser'];

				if ($EditingProfile) {
					$table = "groups";
				} else {
					$table = "users";
				}

				print '<form class="recordform showinline" novalidate autocomplete="off" id="' . $table . '-' . $recordid . '" method="post" action="" onsubmit="return general_form_submit(this.id, \'' . $recordid . '\');">';

				print "<input type='hidden' name='Saved' value='" . $_REQUEST['EditUser'] . "'>";
				print "<input type='hidden' name='concerningrecord' id='JS_concerningrecord' value='" . $_REQUEST['EditUser'] . "'>";
				print "<input type='hidden' name='e_button' id='JS_e_button' value=''>";
				if ($EditingProfile) {

					print "<input type='hidden' name='EditGroup' value='" . $_REQUEST['EditGroup'] . "'>";
				} else {
					print "<input type='hidden' name='EditUser' value='" . $_REQUEST['EditUser'] . "'>";
				}


				if (count($to_tabs) > 0)
				{
					print '<nav class="iltabs">';
					print '<ul>';
					foreach ($to_tabs as $tab)
					{
						print '<li><a id="' . str_replace(" ", "_", $tab) . '">' . $tab . '</a></li>';
					}
					print '</ul>';
					print '</nav>';
				}


				print "<div class=\"iltab\" id=\"Personals_content\">";

				print "<table class=\"form-table\">";
				print '<tbody>';
				$type = "";
				if (!$EditingProfile) {
					print "<tr><th>" . htme($GLOBALS['UC']['PersonalDataStructure']["users"]["fields"]["FULLNAME"]["name"]) . "</th><td><input size='50' type='text' name='FULLNAME' value='" . htme($result['FULLNAME']) . "'></td></tr>";

				} else {
					$type = $GLOBALS['UC']['PersonalDataStructure']["groups"]["fields"]["name"]["name"];
				}

				if (!$EditingProfile) {
					print "<tr><th>" . htme($GLOBALS['UC']['PersonalDataStructure']["users"]["fields"]["name"]["name"]) . "</th><td>" . $result['name'] . "</td></tr>";
					print "<tr><th>" . htme($lang['password']) . "</th><td><input type='password' name='accpass1' value='' id='accpass1id' onkeyup=\"CheckPasswordStrength('accpass1id', '" .GetSetting("MINIMUMPASSWORDSTRENGTH") . "');\"></td></tr>";
					print "<tr><th>" . htme($lang['password']) . " (confirm)</th><td><input type='password' name='accpass2' id='accpass2id' value='' onkeyup=\"CheckPasswordStrength('accpass2id','" . GetSetting("MINIMUMPASSWORDSTRENGTH") . "');\"></td></tr>";
				}
				$user_has_group = false;
				$user_group = array();
				if (!$EditingProfile) {
					print "<tr><th>E-mail</th><td><input type='text' size='50' name='EMAIL' value='" . $result['EMAIL'] . "'></td></tr>";
//					if (!in_array("Administrator",$AccArr)) {
						$la = GetUserProfiles();
						print "<tr><th>Group</th><td><select name='profile'>";
				    		if (is_administrator()) {
							print "<option value=''>- no group -</option>";
						}
						foreach($la AS $profile) {
							$ins = "";
							if ($result['PROFILE'] == $profile[0]) {
								$ins = "selected";
								$user_has_group = true;
								$user_group = GetProfileArray($profile[0]);
							}
							if ($profile[0] != 0) {
								print "<option " . $ins . " value='" . $profile[0] . "'>" . $profile[1] . "</option>";
							}
						}
						print "</select>";
						print "</td></tr>";
//					}
				}

				if (!$EditingProfile) {
					$ins = "";
					if ($result['FORCEPASSCHANGE'] == "y") {
						$ins = "checked";
					}
					print "<tr><th>Force change password</th><td><input type='checkbox' " . $ins . " name='FORCEPASSCHANGE' value='y'></td></tr>";

					foreach ($GLOBALS['UC']['PersonalDataStructure']["users"]["fields"] AS $name => $field) {
						if ($field["fieldtype_in_extrafields_table"] != "" && $field["allowed_to_write"]) {
							print "<tr><th>" . htme($field['name']) . "</th><td>";
							$tag = "users-" . $name;
							print '<div id="ffc-' . $tag . '">';
							print get_form_element($tag, $result['EFID' . str_replace("f", "", $name)], $_REQUEST['EditUser'], array(), false, false, "");
							print '</div>';
							print "</td></tr>";
						} elseif ($field["fieldtype_in_extrafields_table"] != "") {
							$html = "<tr><th>" . htme($field['name']) . "</th><td>";
							$html .= "@users-" . $name . "@";
							$html .= "</td></tr>";

							print ParseTemplateRecordData($html, "users", $_REQUEST['EditUser'], false);
						}

					}
					foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']["users"]["childs"]) as $child_table) {
						foreach ($GLOBALS['UC']['PersonalDataStructure']["users"]["childs"][$child_table] as $child_field)
						{
							if (GetAttribute("flextable", "ShowOnUserEditPage", str_replace("t", "", $child_table)) == "Yes") {

								print "<tr><th>";
								print htme($GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']);
								print "</th><td>";


								list($count, $result2) = make_list(array("table" => $child_table, "type_of_list" => "sublist", "hiddenfilter" => array($child_table . '-' . $child_field => array($_REQUEST['EditUser']))));
								print $result2;
								print "</td></tr>";
							}
						}
					}
				} else {
					print "<tr><th>" . htme($type . " " . $lang['name']) . "</th><td><input type='text' name='newgroupname' value='" . htme($result['name']) . "'></td></tr>";

					foreach ($GLOBALS['UC']['PersonalDataStructure']["groups"]["fields"] AS $name => $field) {
						if ($field["fieldtype_in_extrafields_table"] != "" && $field["allowed_to_write"]) {
							print "<tr><th>" . htme($field['name']) . "</th><td>";
							$tag = "groups-" . $name;
							print '<div id="ffc-' . $tag . '">';
							print get_form_element($tag, $result['EFID' . str_replace("f", "", $name)], $_REQUEST['EditGroup'], array(), false, false, "");
							print '</div>';
							print "</td></tr>";
						} elseif ($field["fieldtype_in_extrafields_table"] != "") {
							$html = "<tr><th>" . htme($field['name']) . "</yh><td>";
							$html .= "@" . $name . "@";
							$html .= "</td></tr>";

							print ParseTemplateRecordData($html, "groups", $_REQUEST['EditGroup'], false);
						}
					}
				}

				$ins = "";
				if ($result['HIDEFROMASSIGNEEANDOWNERLISTS'] == "y") {
					$ins = "checked";
				}
				print "<tr><th class='nwrp useradmin_hidefromlists'>";
				//	DA($result, false);
				if (!$EditingProfile) {
					print "Hide this user from user lists";
				} else {
					print "Hide users in this group from user lists";
				}
				print "</th><td class=\"useradmin_hidefromlists\"><input type='checkbox' " . $ins . " name='HIDEFROMASSIGNEEANDOWNERLISTS' value='y'></td></tr>";

				if ($EditingProfile) {

						print "<tr><th>Dashboard</th><td>";
						$sql = "SELECT templateid,templatename,templatetype FROM CRMtemplates WHERE templatetype='TEMPLATE_DASHBOARD' AND version_belonging_to='0'";
						print "<select name='dashboardtemplate'><option value='0'>Follow system default</option>";
						foreach (db_GetArray($sql) as $row) {
							$ins = "";
							if ($result['DASHBOARDFILEID'] == $row['templateid']) {
								$ins = "selected";
							}
							print "<option " . $ins . " value='" . $row['templateid'] . "'>" . $row['templatename'] . "</option>";
						}
						print "</select></td></tr>";

						print "<tr><th>Menu</th><td>";
						print "<select name='customtabmenu'><option value='0'>Follow system default</option>";
						$sql = "SELECT templateid, templatename FROM CRMtemplates WHERE version_belonging_to=0 AND templatetype='TEMPLATE_MENU' ORDER BY templatename";
						foreach (db_GetArray($sql) as $row) {
							$ins = "";
							if ($result['MENUTOUSE'] == $row['templateid']) {
								$ins = "selected";
							}
							print "<option " . $ins . " value='" . $row['templateid'] . "'>" . htme($row['templatename']) . "</option>";
						}
						print "</select></td></tr>";

						if (GetSetting('WebAppEnabled') == 'Yes')
						{
							print "<tr><th>Webapp menu</th><td>";
							print "<select name='webappmenu'><option value='0'>Use standard menu</option>";
							$sql = "SELECT templateid, templatename FROM CRMtemplates WHERE version_belonging_to=0 AND templatetype='TEMPLATE_MENU' ORDER BY templatename";
							foreach (db_GetArray($sql) as $row) {
								$ins = "";
								if ($result['webappmenu'] == $row['templateid']) {
									$ins = "selected";
								}
								print "<option " . $ins . " value='" . $row['templateid'] . "'>" . htme($row['templatename']) . "</option>";
							}
							print "</select></td></tr>";
						}

//						print "<tr><th>Date format</th><td>" . AttributeAjaxEditElement("user", "DateFormat", $result['id']) . "</td></tr>";

				}
				if (is_administrator() && !$EditingProfile) {

					print "<tr><td colspan='2'><h2>Data structure</h2></td></tr>";
					print "<tr><th>Personal Data Structure</th><td>";

					print "<a onclick=\"PopFancyBoxDimensioned('personal data structure', 'useradmin.php?nonavbar=1&amp;show_ds=" . htme($_REQUEST['EditUser']) . "');return(false);\">[view]</a></td></tr>";
					print "<tr><th>Personal Data Structure Access Reasons</th><td>";
					print "<a onclick=\"PopFancyBoxDimensioned('personal data structure reasons', 'useradmin.php?nonavbar=1&amp;show_ds_reasons=" . htme($_REQUEST['EditUser']) . "');return(false);\">[view]</a><td></tr>";
				}

				print '</tbody>';
				print "</table>";

				print "</div>"; // end Personals div
				if ($EditingProfile) {
					print "<div class=\"iltab\" id=\"Members_content\">";
					list($count, $result2) = make_list(array("table" => "users", "type_of_list" => "sublist", "customheader" => "Members", "hiddenfilter" => array("users-PROFILE" => array($_REQUEST['EditUser']), "users-active" => array('yes'))));
					print $result2;
					print "</div>";
				}


				//--------------------------------------------------------------------
				if (!$user_has_group || in_array("Administrator",$AccArr)) {
					print "<div class=\"iltab\" id=\"Privileges_content\">";
					print "<table class=\"form-table\">";
					if (!in_array("Administrator",$AccArr)) {

							print "<tr><td><strong>Lay-out</strong></td></tr>";
							$checked = "";
							if (in_array("MaySelectColumns",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to select columns in lists</td><td><input type='checkbox' value='MaySelectColumns' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("HideListExportIcons",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Deny <strong>all</strong> list exports</td><td><input type='checkbox' value='HideListExportIcons' name='AccArr[]' " . $checked . "></td></tr>";

							print "<tr><td>&nbsp;</td></tr>";
							print "<tr><td><strong>Selections</strong></td></tr>";
							$checked = "";
							if (in_array("HideSelectionsSelectBox",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Hide saved-selections drop box</td><td><input type='checkbox' value='HideSelectionsSelectBox' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("AddEditSelections",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to add/edit selections</td><td><input type='checkbox' value='AddEditSelections' name='AccArr[]' " . $checked . "></td></tr>";
							//JH 2015-10-21 niet langer supported in selectionnew
							/*
							$checked = "";
							if (in_array("MayShareSelections",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to share selections with other users</td><td><input type='checkbox' value='MayShareSelections' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("AllowedToEditSystemWideSelections",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to manage system-wide selections</td><td><input type='checkbox' value='AllowedToEditSystemWideSelections' name='AccArr[]' " . $checked . "></td></tr>";
							*/


					}
					print "<tr><td>&nbsp;</td></tr>";
					print "<tr><td><strong>Security</strong></td></tr>";
					$checked = "";
					if (in_array("requiretpa",$AccArr)) { $checked = "checked"; }
					if (GetSetting("RequireTwoPhaseAuthenticationForEveryOne") == "Yes") {
						$checked = "checked disabled";
					}
					print "<tr><td>Require two-phase authentication</td><td><input type='checkbox' value='requiretpa' name='AccArr[]' " . $checked . "></td></tr>";

					if (!$EditingProfile && is_administrator()) {
						print "<tr><td>&nbsp;</td></tr>";
						print "<tr><td><strong>Administrator</strong></td></tr>";
						$ins2 = "";
						if ($_REQUEST['EditUser'] == $GLOBALS['USERID'] && is_administrator()) {

							$ins2 = "<tr><td colspan='2'><em>To withdraw your own administrative rights, login with another administrator account.</em></td></tr>";

							print "<tr><td>Is an administrator (overrules all)</td><td><input type='checkbox' value='Administrator' name='UnImp' disabled checked><input type='hidden' name='AccArr[]' value='Administrator'></td></tr>";

						} else {

							if (db_GetValue("SELECT administrator FROM CRMloginusers WHERE id='" . mres($_REQUEST['EditUser']) . "'") == "yes") { $checked = "checked"; }
							print "<tr><td>Is an administrator (overrules all)</td><td><input type='checkbox' value='Administrator' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("OnlyDevelopmentAdmin",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Only administrator in development</td><td><input type='checkbox' value='OnlyDevelopmentAdmin' name='AccArr[]' " . $checked . "></td></tr>";
						}
						print $ins2;
					}

					print "<tr><td>&nbsp;</td></tr>";

						print "<tr><td colspan='2'><strong>Interactive fields</strong></td></tr>";
						print "<tr><td colspan='2'>Interactive fields are fields which can be changed in the list, without opening a record.</td></tr>";
						if ($EditingProfile) {
							print "<tr><td>Select fields</td><td><a href=\"javascript:PopRightsChooserInteractiveFields(" . $result['id'] . ", 'profile');\">[select]</a></td></tr>";
						} else {
							print "<tr><td>Select fields</td><td><a href=\"javascript:PopRightsChooserInteractiveFields(" . $result['id'] . ", 'user');\">[select]</a></td></tr>";
						}

						print "<tr><td>Currently selected fields:<br><em>";
						$ins = "";
						foreach (unserialize($result['INTERACTIVEFIELDS']) AS $field) {

							if (is_numeric($field)) {
								print $ins . GetExtraFieldName($field);
							} else {
								print $ins . $lang[$field];
							}
							$ins = ", ";
						}
						if ($ins == "") print "None";
						print "</em></td></tr>";



					if (!in_array("Administrator",$AccArr)) {


						print "<tr><td>&nbsp;</td></tr>";
						print "<tr><td><strong>Privacy</strong></td></tr>";
						print "<tr><td>Hide all usernames</td><td>";
						$checked = "";
						if (in_array("HideUserNames",$AccArr)) { $checked = "checked"; }
						print "<input type='checkbox' value='HideUserNames' name='AccArr[]' " . $checked . "></td></tr>";
						print "<tr><td>Deny access to all journals</td><td>";
						$checked = "";
						if (in_array("DenyJournalAccess",$AccArr)) { $checked = "checked"; }
						print "<input type='checkbox' value='DenyJournalAccess' name='AccArr[]' " . $checked . "></td></tr>";
						print "<tr><td>When showing journals, show only own updates</td><td>";
						$checked = "";
						if (in_array("ShowOnlyOwnJournalRecords",$AccArr)) { $checked = "checked"; }
						print "<input type='checkbox' value='ShowOnlyOwnJournalRecords' name='AccArr[]' " . $checked . "></td></tr>";

						if (is_administrator()) {
							print "<tr><td>&nbsp;</td></tr>";
							print "<tr><td><strong>Administrative tasks</strong></td></tr>";
							$checked = "";
							if (in_array("AllowedToUseDescendingDeletes",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to issue descending deletes</td><td><input type='checkbox' value='AllowedToUseDescendingDeletes' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("DontEditOwnProfile",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Not allowed to edit his/her own profile</td><td><input type='checkbox' value='DontEditOwnProfile' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("UserAdmin",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Can add/edit users</td><td><input type='checkbox' value='UserAdmin' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("UserAdminSudo",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to login as other users from user-admin page</td><td><input type='checkbox' value='UserAdminSudo' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("SendMessagesToAllUsers",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to send messages to all users at once</td><td><input type='checkbox' value='SendMessagesToAllUsers' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("AllowedToAlterDiaryContents",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to change and delete previously added diary remarks</td><td><input type='checkbox' value='AllowedToAlterDiaryContents' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("AllowedToAlterOwnDiaryContents",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to change and delete previously added own diary remarks</td><td><input type='checkbox' value='AllowedToAlterOwnDiaryContents' name='AccArr[]' " . $checked . "></td></tr>";
							$checked = "";
							if (in_array("AllowedToExportXML",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to export XML</td><td><input type='checkbox' value='AllowedToExportXML' name='AccArr[]' " . $checked . "></td></tr>";

							foreach (GetFlextableDefinitions() AS $ft) {
									$configname = "AllowedToImportFT" . $ft['recordid'];
									$checked = "";
									if (in_array($configname,$AccArr)) { $checked = "checked"; }
									print "<tr><td>Allowed to import records into table " . htme($ft['tablename']) . "</td><td><input type='checkbox' value='" . $configname . "' name='AccArr[]' " . $checked . "></td></tr>";
							}
							$checked = "";
							if (in_array("AllowedToImportUsers",$AccArr)) { $checked = "checked"; }
							print "<tr><td>Allowed to import users</td><td><input type='checkbox' value='AllowedToImportUsers' name='AccArr[]' " . $checked . "></td></tr>";



							foreach (GetFlextableDefinitions() AS $ft) {
									$configname = "AllowedTodedupFT" . $ft['recordid'];
									$checked = "";
									if (in_array($configname,$AccArr)) { $checked = "checked"; }
									print "<tr><td>Allowed to deduplicate table " . htme($ft['tablename']) . "</td><td><input type='checkbox' value='" . $configname . "' name='AccArr[]' " . $checked . "></td></tr>";
							}
						}
					}
					print "</table></div>";

					print "<div class=\"iltab\" id=\"Record_access_rules_content\">";
					if (!in_array("Administrator", $AccArr)) {

							if ($EditingProfile) {
								list($count, $result) = make_list(array("table" => "extendedprivsgroup", "hide_selections" => true, "hide_addrow" => false, "type_of_list" => "sublist", "hiddenfilter" => array("extendedprivsgroup-groupid" => array($_REQUEST['EditGroup']))));
								print $result;
							}
					}
					print "</div>";

				}

				print "<div class=\"iltab\" id=\"Limits_content\"><table>";
					if (!$EditingProfile) {

					} else {
						foreach (GetFlextableDefinitions() AS $ft) {
							print "<tr><td>t" . $ft['recordid'] . " " . htme($ft['tablename']) . " read-access SQL</td><td>" . AttributeAjaxEditElement("group", "SecuritySubselectForRecordAccessReadForFlextable" . $ft['recordid'], $_REQUEST['EditUser']) . "</td></tr>";
							print "<tr><td>t" . $ft['recordid'] . " " . htme($ft['tablename']) . " write-access SQL</td><td>" . AttributeAjaxEditElement("group", "SecuritySubselectForRecordAccessWriteForFlextable" . $ft['recordid'], $_REQUEST['EditUser']) . "</td></tr>";
						}

					}
			print "</table></div>";



				print "<br>";
				if ($EditingProfile) {
					print "<input type='submit' name='SubmitButton' value='" . htme($lang['save']) . "'> ";

					if (is_administrator()) {

						print "<input type=\"button\" class=\"deletebutton\" onclick=\"PopFancyBoxDimensioned('','record.php?table=groups&amp;record=" . htme($_REQUEST['EditGroup']) . "&amp;delete=1&amp;nonavbar=1&amp;ParentAjaxHandler=groups',300,500)\" value=\"" . htme($lang['delete']) . "\"> ";
						print AttributeLink("group", $_REQUEST['EditGroup'], "Attributes", "", true) . " ";
						print "<a onclick=\"PopFancyBoxExtraLarge('Group comparison', 'listadmin.php?groupcomparison=1&amp;nonavbar=1');\" class=\"likebutton\">Group comparison</a> ";
					}

				} else {
					print "<input type='submit' name='SubmitButton' value='" . htme($lang['save']) . "'> ";
					print "<input type='button' class='deletebutton' onclick=\"if (confirm('Are you sure?')) { window.location.href='useradmin.php?delete=Delete&amp;EditUser=" . $_REQUEST['EditUser'] . "'; return(false); }\" value='" . htme($lang['delete']) . "'> ";

					if (is_administrator() && $_REQUEST['EditUser'] != $GLOBALS['USERID'] && !is_administrator($_REQUEST['EditUser']) || CheckFunctionAccess("UserAdminSudo") == "ok") {
						print "<input type='button' onclick=\"window.location.href='admin.php?BeThisUser=". $_REQUEST['EditUser'] . "'; return(false);\" value='Login as " . htme(GetUserName($_REQUEST['EditUser'])) . "'> ";
					}

					if (is_administrator()) {
						print AttributeLink("user",  $_REQUEST['EditUser'], "Attributes", "", true) . " ";
					}

					if (is_administrator()) {
						print "<a onclick=\"PopFancyBoxExtraLarge('Group comparison', 'listadmin.php?groupcomparison=1&amp;nonavbar=1');\" class=\"likebutton\">Group comparison</a> ";
					}

				}

				print "</form>";
				if (is_administrator() && $EditingProfile) {
					print ' <form method="post" class="showinline" action="listadmin.php?duplicategroup=1" onsubmit="return confirm(\'Are you sure?\')">';
					print '<input type="hidden" name="oldgroup_id" value="' . htme($_REQUEST['EditUser']) . '">';
					print '<input type="text" name="newgroup_name" placeholder="new group name" size="13"> ';
					print '<input type="submit" value="Duplicate group">';
					print '</form>';

				}
			} elseif ($_REQUEST['UserStatistics']) {
				MustBeAdmin();
				log_msg("DisplayUserActivityGraph Journal");

				print "<table>";
				print "<tr><td><h1>All users activity graphs</h1><br>";


				if (!$_REQUEST['Journal'] && !$_REQUEST['Uselog']) {
						print "<br>Interleave logs in two ways:<br>";
						print "<ul><li>&nbsp;<a href='useradmin.php?UserStatistics=true&amp;Uselog=1'>The use-log</a><br>All actions of user are logged. These actions include every page reload, logins, errors etcetera. This log may contain very much records if you have a heavily used repository; the statistics may take a while to load.</li>";
						print "<li>&nbsp;<a href='useradmin.php?UserStatistics=true&amp;Journal=1'>Journal entries</a><br>The journal entries log more specific activity rather than browse-thru statistics. In the journal things like adding a file, saving an enity, and sending an e-mail are logged. The journal is the best to use for statistics to get an overview of <em>real</em> activity of your users.</li></ul>";

				} else {

						if (!$_REQUEST['Journal']) {
								print "These images are generated using the 'uselog' - e.g. they represent any action; may me <br>just viewing. To see the charts based on the entity journals, <a href='useradmin.php?UserStatistics=true&amp;Journal=1'>click here</a>.<br><br>";
						} else {
								print "User activity charts based on record journals<br><br>";
						}


						$sql = "SELECT id,FULLNAME,name FROM CRMloginusers WHERE active<>'no' ORDER BY FULLNAME";
						foreach (db_GetArray($sql) as $row) {
							if (trim($row['FULLNAME']=="")) { $row['FULLNAME'] = $row['name'];}
							print "<br><strong>" . htme(GetUserName($row['id'])) . "</strong><br>";
							if ($_REQUEST['Journal']==1) {

								print CreateHighChartFromSQLNEW(GetUserName($row['id']), "Table logs", "SELECT DATE_FORMAT(timestamp_last_change,'%Y-%m') AS `Month`, COUNT(*) AS `Journal entries` FROM CRMjournal WHERE user='" . mres($row['id']) . "' GROUP BY YEAR(timestamp_last_change), MONTH(timestamp_last_change)", "line", "200px", "", "month");
							} else {
								print CreateHighChartFromSQLNEW(GetUserName($row['id']), "Uselog only", "SELECT DATE_FORMAT(timestamp_last_change,'%Y-%m') AS `Month`, COUNT(*) AS `Log entries` FROM CRMuselog WHERE user='" . mres($row['id']) . "' GROUP BY YEAR(timestamp_last_change), MONTH(timestamp_last_change)", "line", "200px", "", "month");
							}
						}
				}
				print "</td></tr></table>";
			} elseif ($_REQUEST['ActivityUserGraph']) {
				if (is_administrator() || (CheckFunctionAccess("DenyJournalAccess") != "ok" && CheckFunctionAccess("UserAdmin") == "ok")) {
					$sql = "SELECT DATE_FORMAT(timestamp_last_change, '%Y-%m') AS `Month`, COUNT(*) AS `Log entries` FROM CRMuselog WHERE LEFT(user, " . (strlen($_REQUEST['ActivityUserGraph'])+1) . ") = '" . mres($_REQUEST['ActivityUserGraph']) . " ' GROUP BY YEAR(timestamp_last_change), MONTH(timestamp_last_change)";
					print CreateHighChartFromSQLNEW(GetUserName($_REQUEST['ActivityUserGraph']) . " all time", "Usage log (clicks)", $sql, "line", "200px", "", "month");

					$sql = "SELECT CONCAT(LEFT(YEARWEEK(timestamp_last_change, 3),4),'W',RIGHT(YEARWEEK(timestamp_last_change, 3),2)) AS `Week`, COUNT(*) AS `Log entries` FROM CRMuselog WHERE LEFT(user, " . (strlen($_REQUEST['ActivityUserGraph'])+1) . ") = '" . mres($_REQUEST['ActivityUserGraph']) . " ' AND YEAR(timestamp_last_change)=YEAR(CURDATE()) GROUP BY YEARWEEK(timestamp_last_change, 3)";
					print CreateHighChartFromSQLNEW(GetUserName($_REQUEST['ActivityUserGraph']) . " this year", "Usage log (clicks)", $sql, "line", "200px", "", "week");

					$sql = "SELECT DATE_FORMAT(timestamp_last_change, '%Y-%m') AS `Month`, COUNT(*) AS `Log entries` FROM CRMdatajournal WHERE by_user='" . mres($_REQUEST['ActivityUserGraph']) . "' GROUP BY YEAR(timestamp_last_change), MONTH(timestamp_last_change)";
					print CreateHighChartFromSQLNEW(GetUserName($_REQUEST['ActivityUserGraph']) . " all time", "Data journal (mutations)", $sql, "line", "200px", "", "month");

					$sql = "SELECT CONCAT(LEFT(YEARWEEK(timestamp_last_change, 3),4),'W',RIGHT(YEARWEEK(timestamp_last_change, 3),2)) AS `Week`, COUNT(*) AS `Log entries` FROM CRMdatajournal WHERE by_user='" . mres($_REQUEST['ActivityUserGraph']) . "' AND YEAR(timestamp_last_change)=YEAR(CURDATE()) GROUP BY YEARWEEK(timestamp_last_change,3)";
					print CreateHighChartFromSQLNEW(GetUserName($_REQUEST['ActivityUserGraph']) . " this year", "Data journal (mutations)", $sql, "line", "200px", "", "week");
				}
			}
		}
	}
}
print '<script>' . PrintExtraFieldForceJavascript() . '</script>';
EndHTML(true);

?>
