<?php
/* ********************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/
 *
 * This file contains all administrative functions
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
 */


function create_charset_queries_for_deploy($print=false) {
//    $print=true;
    MustBeAdmin();
    print '<textarea rows="10" cols="60">';
    if ($print) print "# NORMAL\n";
    $qb4nd = GetAttribute("system", "QueriesBeforeNextDeploy", 1);

    $qb4nd[] = "ALTER DATABASE `" . db_GetValue("SELECT DATABASE()") . "` CHARACTER SET = utf8mb4 COLLATE = utf8mb4_unicode_ci;";
    $sql = "ALTER DATABASE `" . db_GetValue("SELECT DATABASE()") . "` CHARACTER SET = utf8mb4 COLLATE = utf8mb4_unicode_ci";

    if ($print) {
        print $sql . ";\n";
    } else {
        mcq($sql);
    }
    $tp = "";

    $table = 'CRMattributes';
    $qb4nd[] = 'PTONLINESCHEMACHANGE '. base64_encode('CHANGE attribute attribute VARCHAR(125) --execute D=QQQTARGET_DBQQQQ,t='.$table);
    mcq("ALTER TABLE CRMattributes CHANGE attribute attribute VARCHAR(125)");
    $qb4nd[] = '# PTSC table ' . $table . ': CHANGE attribute attribute VARCHAR(125)';

    foreach(db_GetFlatArray("SHOW TABLES") AS $table) {
        $qb4nd[] = 'PTONLINESCHEMACHANGE '.base64_encode('CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci --execute D=QQQTARGET_DBQQQQ,t='.$table);
        $qb4nd[] = '# PTSC table ' . $table . ': CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci';

        $sql = "ALTER TABLE " . $table . " CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci";
        if ($print) {
            print $sql . ";\n";
            $tp .= "/usr/bin/pt-online-schema-change -uroot -p***PASSWORD*** --alter='CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci --execute D=" . db_GetValue("SELECT DATABASE()") . "',t=" . $table . "\n";
        } else {
            mcq($sql);
        }
    }

    print "#PTSC\n";
    print "ALTER DATABASE `" . db_GetValue("SELECT DATABASE()") . "` CHARACTER SET = utf8mb4 COLLATE = utf8mb4_unicode_ci\n";
    print $tp;
    print '</textarea>';

    if (!$print) {
        SetAttribute('system', 'QueriesBeforeNextDeploy', $qb4nd, 1);
        SetAttribute("system", "TriggerQueriesForDeploy", return_mysql_trigger_queries(true, true, true), 1, false);
    }
}
function update_tslc_for_all_related_templates($template_id, $done = array()) {

    /*
       this function finds all related templates (by inclusion using a @TEMPLATExx@ tag) and updates their timestamp_last_change. we
       do this to make sure the timestamp_last_change field is also updated in the "parent" template when an included template is
       altered. because we support endless inclusions, we need to do this recursively.
     */


    /* touch all templates including the given template */
    $sql = "UPDATE CRMtemplates SET timestamp_last_change = NOW() WHERE content LIKE '%\@TEMPLATE" . mres($template_id) . "\@%'";
    mcq($sql);

    $done[] = $template_id;

    /* cycle through all touched templates and start over */
    foreach (db_GetFlatArray("SELECT templateid FROM CRMtemplates WHERE content LIKE '%\@TEMPLATE" . mres($template_id) . "\@%'") AS $next) {

         /* prevent endless recursion */
        if (!in_array($next, $done)) {

            /* call myself, start over */
            update_tslc_for_all_related_templates($next, $done);

        }
    }
}
function check_database_fields()
{
    echo '<a href="dbupgrade.php?CorrectTablesAndFields">Go here to fix the field types</a><br>';
    echo '<textarea cols="120" rows="40">';
    echo "Result\tTable\tField\tCorrect type\tCurrent type\n";
    $method = 'mysql';
    $in_query = '';

    $ds_tablename = '';
    $il_tablename = '';
    $sql = array();
    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE deleted='n' ".$in_query) as $ef) {
        if (ipi($ef['tabletype'])) {
            $ds_tablename = 't'.$ef['tabletype'];
            $il_tablename = 'CRMflextable'.$ef['tabletype'];
        } else {
            $ds_tablename = $ef['tabletype'];
            if ($ef['tabletype'] == 'user') {
                $il_tablename = 'CRMloginusers';
            } elseif ($ef['tabletype'] == 'group') {
                $il_tablename = 'CRMuserprofiles';
            } elseif ($ef['tabletype'] == 'files') {
                $il_tablename = 'CRMbinfiles';
            } else {
                $il_tablename = 'CRM'.$ef['tabletype'];
            }
        }
        if (GetAlterQueryBasedOnFieldType('f'.$ef['id'], $ds_tablename, $ef['fieldtype'], 'change', $method, $ef['name']) != '') {
            $sql[$il_tablename][] = str_replace('ALTER TABLE '.$il_tablename, '', GetAlterQueryBasedOnFieldType('f'.$ef['id'], $ds_tablename, $ef['fieldtype'], 'change', $method, $ef['name']));
        }
    }

    foreach ($sql as $table => $list_of_changes) {
        foreach ($list_of_changes as $change) {

            // ok nu wordt het vies
            /*
                 CHANGE `EFID688` `EFID688` LONGTEXT NOT NULL DEFAULT '' COMMENT 'Opmerkingen sprint'
            */
            $x = explode('`', $change);
            $field = $x[1];
            $y = explode(' COMMENT', trim($x[4]));
            $type = $y[0];

            list($result, $curtype) = TableHasField2($table, $field, $type, db_GetValue("SELECT defaultval FROM CRMextrafields WHERE id='".str_replace('f', '', $field)."'"));

            if ($result == 'no' || $result == 'wrongtype') {
                echo $result."\t".$table."\t".$field."\t".$type."\t".$curtype."\n";
            }
        }
    }
    echo '</textarea>';
}
function TableHasField2($table, $field, $type, $defaultvalue = '')
{
    // Smerige hack, niet schadelijk

    $type = trim(str_replace('PRIMARY KEY', '', $type));
    $type = trim(str_replace('FIRST', '', $type));

    if (substr($table, 0, 3) != 'CRM') {
        $table = 'CRM'.$table;
    }
    $ar = db_GetArray('SHOW CREATE TABLE '.$table);
    $key = '`'.$field.'`';
    $ar = explode("\n", $ar[0][1]);
    $found = 'no';
    foreach ($ar as $cr) {
        $cr = trim($cr);
        if (substr($cr, 0, strlen($key)) == $key) {
            $tmp = explode(' COMMENT', $cr);
            $cr = $tmp[0];
        //	print 'CMP "' . $cr . '" to "' . $type . '"<br>' . "\n";
            if ($type == false || stristr($cr, $type) && (stristr($cr, "'".$defaultvalue."'") || !strstr($cr, 'DEFAULT'))) {
                return array('yes', $cr);
            } else {

                return array('wrongtype', $cr);
            }
        }
    }

    return array($found, 'NONEXISTENT');
}

/*
    This function should run daily (it's called from duedate-notify-cron)
*/
function create_indices()
{
    //return true;
    // Indices in this array will be created only if they don't exist already.

    $indices = array(
            array('journal', array('type', 'eid')),
            array('entitylocks', array('lockon', 'lockby', 'locktable'), 'PRIMARY'),
            array('entitylocks', array('timestamp_last_change')),
            array('datajournal', array('table', 'record', 'field')),
    );

    foreach (db_GetArray("SELECT tabletype, fieldtype, id FROM CRMextrafields WHERE deleted='n' AND (fieldtype IN ('Reference to FlexTable','User-list of all CRM-CTT users','User-list of administrative CRM-CTT users', 'List of all groups', 'date/time', 'date (iso)') OR fieldtype LIKE 'Users of profile %')") as $field) {
        $flextable = 0;
        if (ipi($field['tabletype'])) {
            $flextable = $field['tabletype'];
            $field['tabletype'] = 'flextable'.$field['tabletype'];
        }
        if ($field['tabletype'] == 'user') {
            $field['tabletype'] = 'loginusers';
        }
        if ($field['tabletype'] == 'group') {
            $field['tabletype'] = 'userprofiles';
        }
        if ($field['tabletype'] == 'files') {
            $field['tabletype'] = 'binfiles';
        }
        //print 'process flextable ' . $flextable . ' LD: ' .  $GLOBALS['UC']['PersonalDataStructure']['t' . $flextable]['logical_delete'] . '<br>';

        if (ipi($flextable) && $GLOBALS['UC']['PersonalDataStructure']['t' . $flextable]['logical_delete'] == true) { // flextable
            $indices[] = array($field['tabletype'], array('deleted', 'EFID'.$field['id']));

            /* table doesn't use physical delete, so delete indices on EFIDx */
            if (TableHasIndexByName('flextable' . $flextable, 'EFID' . $field['id'])) {
                print date('r') . ': Drop index EFID' . $field['id'] . ' - this table doesn\'t use physical delete (anymore)' . "<br>\n";
                mcq("ALTER TABLE CRMflextable" . $flextable . " DROP INDEX `EFID" . $field['id'] . "`");
            }

        } else {
            $indices[] = array($field['tabletype'], array('EFID'.$field['id']));

            if (ipi($flextable)) {

                /* table doesn't use logical delete, so delete indices on deleted_EFIDx */
                if (TableHasIndexByName('flextable' . $flextable, 'deleted_EFID' . $field['id'])) {
                    print date('r') . ': Drop index deleted_EFID' . $field['id'] . ' - this table doesn\'t use logical delete (anymore)' . "<br>\n";
                    mcq("ALTER TABLE CRMflextable" . $flextable . " DROP INDEX `deleted_EFID" . $field['id'] . "`");
                }
            }
        }
    }

    foreach ($indices as $index) {
        if (!TableHasIndex($index[0], $index[1])) {
            $sql = '';
            if ($index[2] == 'PRIMARY') {
                $sql = 'ALTER TABLE CRM'.$index[0].' ADD '.$index[2].' KEY (`'.implode($index[1], '`,`').'`)';
            } else {
                $sql = 'ALTER TABLE CRM'.$index[0].' ADD '.$index[2].' INDEX '.implode($index[1], '_').'(`'.implode($index[1], '`,`').'`)';
            }
            print date('r') . ': ' . $sql . "<br>\n";
            mcq($sql);
            if (is_administrator()) {
                echo date('r').': '.$sql."<br>\n";
            }
        } else {
            if (is_administrator()) {
                echo date('r').': Table/index '.$index[0].'/'.implode('_', $index[1])." already exists.<br>\n";
            }
        }
    }
    /* currently disabled! HF20171116 */
    //create_indices_based_on_user_sorts();
}
function create_indices_based_on_user_sorts() {
    /* this will probably not be useful because interleave could create thousands of combinations of order-by's. mayby worth
    try to adjust the indices to FIELD_DELETED (instead of deleted_field) and check if the query optimizer will use the index
    because it starts with the name of the field */

    $indices_create = array();
    $indices_drop   = array();
    $used_sorts     = array();
    $keys           = array();

    foreach (db_GetArray("SELECT * FROM CRMattributes WHERE identifier='user' AND attribute LIKE 'List-lastview-%'") AS $row) {

        $tmp = unserialize($row['value']);
        $used_sorts[] = $tmp['sortby'];

    }

    foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $table => $dummy) {

        if ($GLOBALS['UC']['PersonalDataStructure'][$table]['datatable']) {

            foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"] AS $field => $dummy) {

                /* we skip reference fields, they already have indexes */
                if ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['relation_to'] == '') {

                    /* we skip numbers */
                    if ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["fieldtype"] != "number") {

                        /* we skip primaries */
                        if ($GLOBALS['UC']['PersonalDataStructure'][$table]['primary'] != $field) {

                            /* we skip date/time fields and multiline fields */
                            if ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['fieldtype'] != 'date'
                            &&
                            $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['multiline'] != true) {

                                $exists = TableHasIndexByName($GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database'], "deleted_" . $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database']);

                                if ($exists && !in_array($table . '-' . $field, $used_sorts)) {

                                    /* this means the index exists, but it is currently not in use */
                                    $keys[] = 'ALTER TABLE CRM' . $GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database'] . ' DROP INDEX deleted_' . $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database'] . '';

                                } elseif (!$exists && in_array($table . '-' . $field, $used_sorts)) {

                                    print date('r') . ': Add key by: ' . $table . '-' . $field . " name: " . $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name'] . '<br>' . "\n";

                                    $keys[] = 'ALTER TABLE CRM' . $GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database'] . ' ADD INDEX deleted_' . $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database'] . '(`deleted`,`' . $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database'] . '`)';
                                }

                            }
                        }
                    }
                }
            }
        }
    }
    foreach ($keys AS $key) {
        print date('r') . ': ' . $key .  "<br>\n";
        mcq($key);
    }
}
function CalendarAdmin()
{
    echo '<p>With iCal you can publish calendar information to any iCal compatible calendar application. iCal calendars can be used from any application or device compatible with the iCal standard. In this section you can create iCal views on your Interleave database.</p>';

    print '<div><a href="admin.php?editsetting=CalendarAvailableViews&amp;fromlist=' . base64_encode($_SERVER["REQUEST_URI"]) . '">Available views: ' . htme(GetSetting("CalendarAvailableViews")) . '</a></div>';

    list($number_of_records, $output) = make_list(array('table' => 'calendars'));
    echo $output;

    echo '<h1>Calendar statistics</h1>';
    echo '<table class="crm"><thead><tr><th>Calendar object</th><th class="num">#Requests using ical.php</td></tr></thead><tbody>';
    foreach (db_GetFlatArray("SELECT calendar_object FROM CRMcalendars WHERE deleted='n'") as $calObj) {
        echo '<tr><td>'.$calObj.'</td><td class="num">'.FormatNumberNew(db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE qs='iCal calendar requested using ical.php. Object ".mres($calObj)."'")).'</td></tr>';
    }
    echo '</tbody></table>';
}
function checkundeclaredvariables($code, $additional_globals = array(), $debug = false, $show_warnings = true, $show_summary = true)
{
    //show_warnings => unused and inside string vars

    $return = '';
/*

ISSUES
    vars declared to high in a level

    vars later overwritten

    foreach ($row AS $fieldname => $value) {
        print $value
        vlaue unused??

    unset ook behandelen

    geen heredoc support in code analyser

    item1/2 unused?
        usort($items, function($item1, $item2) {
        $measure1 = $item1['iso_start'];
        $measure2 = $item2['iso_start'];
        if ($measure1 == '') {
        $measure1 = $item1['iso_end'];
        $measure2 = $item2['iso_end'];
        }
        if (strtotime($measure1) == strtotime($measure2)) return 0;
        return strtotime($measure1) < strtotime($measure2) ? -1 : 1;
        });

    The "one-line" comment styles only comment to the end of the line or the current block of PHP code, whichever comes first. This means that HTML code after // ... ?> or # ... ?> WILL be printed: ?> breaks out of PHP mode and returns to HTML mode, and // or # cannot influence that. If the asp_tags configuration directive is enabled, it behaves the same with // %> and # %>. However, the </script> tag doesn't break out of PHP mode in a one-line comment.
        <h1>This is an <?php # echo 'simple';?> example</h1>


//UNUSED
{
    $a = 1;
    $a = 2;
}

DIT IS OOK EEN BLOCK
if (true) $a = 2;



{
    $a = 1;
    {
        $a = 2;
    }
    {
        print $a;
        $a = 2;
    }
    {
        $a = 2;
        {
            $a = 3;
        }
    }
}






//FOUT
{
    print $a;
}

//FOUT
{
    print $a;
    $a = 1;
}

//FOUT
{
    {
        $a = 1;
    }
    print $a;
}

//GOED
{
    $a = 1;
    print $a;
}

//GOED
{
    $a = 1;
    {
        print $a;
    }
}

//OK
{
    $a = 1;
    print $a;
}

//UNUSED
{
    $a = 1;
}

//UNUSED
{
    $a = 1;
    $a = 2;
}



ISSUES
{ en } tussen quotes

VAR DECLARATIES

$a = 1;

$a => 12;

foreach ($b as $a)

list($a,$b) = func();

preg_match("//", $b, $a);

function jeroen($a)

global $a;

*/

    if ($debug) {
        $return .= "ORIGINAL CODE\n";
        $return .= "------------------------------------------------------------\n";
        $return .= $code;
        $return .= "------------------------------------------------------------\n";
        $return .= "\n";
    }

    //tabs naar spaties
    $code = str_replace("\t", ' ', $code);
    //meerdere spaties collapsen naar 1 spatie
    $code = preg_replace('/ +/', ' ', $code);

    //global $a, $b;
    //global($a, $b); -> maakt volgende replaces makkelijker
    $code = preg_replace("/(global|static|private|public) (.*)\;/i", '\\1(\\2);', $code);

    //whitespace voorafgaand aan = teken eruit
    //$code = preg_replace("/\s+\=/", "=", $code);
    $code = preg_replace("/ \=/", '=', $code);

    //foreach ($b as $a => $c)
    //foreach ($b as $a=1 => $c=1)
    //$code = preg_replace("/\s+as\s+\\$(\w+)\s*\=\>\s*\\$(\w+)/i", " as \$\\1=1 => \$\\2=1", $code);
    //$code = preg_replace("/ as \\$(\w+) ?\=\> ?\\$(\w+)/i", " as \$\\1=1 => \$\\2=1", $code);
        //omdat $a en $c in de lus eronder hoort en niet er buiten
        //foreach ($b as $a => $c) {    -->  foreach ($b as){$a=1 => $c)
        $code = preg_replace("/ as \\$(\w+) ?\=\> ?\\$(\w+)\s*\)(\s*)\{/i", ' as){$\\1=1 => $\\2=1\\3', $code);

    //foreach ($b as $a)
    //foreach ($b as $a=1)
    //$code = preg_replace("/\s+as\s+\\$(\w+)/i", " as \$\\1=1", $code);
    //$code = preg_replace("/ as \\$(\w+)/i", " as \$\\1=1", $code);
        //omdat $a in de lus eronder hoort en niet er buiten
        //foreach ($b as $a) {    -->  foreach ($b as){$a=1)
        $code = preg_replace("/ as \\$(\w+)\s*\)(\s*)\{/i", ' as){$\\1=1\\2', $code);

        //) -> ,) makkelijker matchen voor functies en list replaces later
        $code = preg_replace("/\)/", ',)', $code);

        //whitespace voorafgaand aan komma eruit
        //$code = preg_replace("/\s+\,/", ",", $code);
        $code = preg_replace("/ \,/", ',', $code);

    //==
    //||
    $code = str_replace('==', '||', $code);

    //global($a);
    //global($a=1);
    //$code = preg_replace("/(global\s+\\$)(\w+)/i", "\\1\\2=1", $code);
    $code = preg_replace("/((global|static|private|public) \\$)(\w+)/i", '\\1\\3=1', $code);
    $count = 1;
    while ($count > 0) {
        //global($a, $b);
        //global($a=1, $b=1);
        $code = preg_replace("/((global|static|private|public)\(.*?)\\$(\w+),(.*?\))/i", '\\1\$\\3=1,\\4', $code, -1, $count);
    }

    //preg_match("//", $b, $a)
    //preg_match("//", $b, $a=1)
    //$code = preg_replace("/(preg_match(_all)?\s*\(\"\/.*?\/\"\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\3=1)", $code);
    //$code = preg_replace("/(preg_match(_all)?\s*\(\'\/.*?\/\'\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\3=1)", $code);
    $code = preg_replace("/(preg_match(_all)? ?\(\"\/.*?\/\" ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", '\\1\\3=1)', $code);
    $code = preg_replace("/(preg_match(_all)? ?\(\'\/.*?\/\' ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", '\\1\\3=1)', $code);

    //preg_replace("//", $b, $a, $count)
    //preg_replace("//", $b, $a, $count=1)
    //$code = preg_replace("/(preg_replace?\s*\(\"\/.*?\/\"\s*\,\s*.*?\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\2=1)", $code);
    //$code = preg_replace("/(preg_replace?\s*\(\'\/.*?\/\'\s*\,\s*.*?\s*\,\s*.*?\s*\,\s*\\$)(\w+)\,\)/i", "\\1\\2=1)", $code);
    $code = preg_replace("/(preg_replace? ?\(\"\/.*?\/\" ?\, ?.*? ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", '\\1\\2=1)', $code);
    $code = preg_replace("/(preg_replace? ?\(\'\/.*?\/\' ?\, ?.*? ?\, ?.*? ?\, ?\\$)(\w+)\,\)/i", '\\1\\2=1)', $code);

    //parse_str($a, $b,) -> parse_str($a,$b=1,) EN OOK: getimagesize
    $code = preg_replace("/(parse_str|getimagesize)\(\\$(\w+)\s?,\s?\\$(\w+),\)/i", '\\1(\$\\2,\$\\3=1,)', $code);

    $code = preg_replace("/\(exception \\$(\w+),\)/i", '(exception $\\1=1,)', $code);



    //preg_match waarbij de regular expression als var wordt aangeleverd; preg_match($a,$b,$match,) -> preg_match($a,$b,$match=1,)
    $code = preg_replace("/preg_match\(\\$(\w+)\s?,\s?\\$(\w+)\s?,\s?\\$(\w+),\)/i", 'preg_match(\$\\1,$\\2,\$\\3=1,)', $code);

    //function jeroen($a,$b,)
    //function jeroen($a=1,$b=1,)
    //EN OOK
    //function ($matches,)
    $count = 1;
    while ($count > 0) {
        //	$code = preg_replace("/(function\s+\w+\s*\(.*?)\\$(\w+),(.*?\))/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
//        $code = preg_replace("/(function \w+ ?\(.*?)\\$(\w+),(.*?\))/i", '\\1\$\\2=1,\\3', $code, -1, $count);
        $code = preg_replace("/(function ?(\w+)? ?\(.*?)\\$(\w+),(.*?\))/i", '\\1\$\\3=1,\\4', $code, -1, $count);
    }


    //want $a is intern
    //function jeroen($a) {    -->   function jeroen { ($a)
    $code = preg_replace("/function (\w+) ?\((.*)\)(\s*)\{/i", 'function \\1 { \\2 \\3', $code);

    //list($a,$b,)
    //list($a=1,$b=1,)
    $count = 1;
    while ($count > 0) {
        //	$code = preg_replace("/(list\s*\(.*?)\\$(\w+),(.*?\)\s*=)/i", "\\1\\$\\2=1,\\3", $code, -1, $count);
        $code = preg_replace("/(list ?\(.*?)\\$(\w+),(.*?\) ?=)/i", '\\1\$\\2=1,\\3', $code, -1, $count);
    }

    if ($debug) {
        $return .= "CORRECTED CODE\n";
        $return .= "------------------------------------------------------------\n";
        $return .= $code;
        $return .= "------------------------------------------------------------\n";
        $return .= "\n";
    }

    $declared_vars = 0;
    $undeclared_vars = 0;
    $unused_vars = 0;
    $vars_inside_strings = 0;
    $level = 0;
    $maxlevel = 0;
    $lines_of_code = 1;
    $deepest_code = '';
    $vars_per_level_declared = array();
    $vars_per_level_used = array();

    $inside_variable = false;
    $inside_string = false;
    $close_tag = '';
    $next_char_is_escaped = false;

    $current_variable = '';
    $inside_code = false;
    $inside_comment = false;

//'lang', 'host', 'user', 'pass', 'database' in additional globals ??
    $globals = array('GLOBALS', '_SERVER', '_REQUEST', '_GET', '_POST', '_COOKIE', '_FILES', '_SESSION', '_ENV', 'php_errormsg', 'HTTP_RAW_POST_DATA', 'http_response_header', 'argc', 'argv', 'this', 'lang', 'host', 'user', 'pass', 'database');
    foreach ($additional_globals as $additional_global) {
        $globals[] = $additional_global;
    }

    if ($debug) {
        $return .= "linenumber\tcharnumber\tlevel\tcharorig\tcharcorrected\tinside_code\tinside_string\tinside_comment\tclose_tag\tnext_char_is_escaped\tinside_variable\tcurrent_variable\n";
    }

    $x = 0;
    while ($x < strlen($code)) {
        $char = substr($code, $x, 1);

        // voor // en /* en */ en \<\? en \?\>
        $next2char = substr($code, $x, 2);

        if ($level == $maxlevel) {
            $deepest_code .= $char;
        }

        if ($char == "\n") {
            ++$lines_of_code;
        }

        $charorig = $char;

        //\<\?php doet het dus ook
        if ($next2char == '<?') {
            $inside_code = true;
            ++$x;
        }

        if ($inside_code) {
            if ($inside_comment) {
                //einde van // is een enter; dat is 1 char
                if ($char == $close_tag) {
                    $inside_comment = false;
                    $close_tag = '';
                }
                //comments bestaan meestal uit 2 karakters; de stukken buiten de php code tags behadelen we ook als comments
                elseif ($next2char == $close_tag) {
                    $inside_comment = false;
                    $close_tag = '';
                    ++$x;
                }
            } else {
                //dit is lomp omdat ander "$a" niet als inside string wordt gevonden, "$a " wel
                $outside_string_at_end_of_loop = false;
                if ($inside_string) {
                    if ($next_char_is_escaped) {
                        $next_char_is_escaped = false;
                        //dit is een " ' of bv $ we behandelen die niet als een bijzonder char
                        $char = ' ';
                    } elseif ($char == '\\') {
                        $next_char_is_escaped = true;
                    } elseif (($char == '{') || ($char == '}')) {
                        //anders gaan we levels hiervan maken
                        $char = ' ';
                    } elseif ($char == $close_tag) {
                        //$inside_string = false;
                        $outside_string_at_end_of_loop = true;
                        $close_tag = '';
                    }
                } else {
                    if (($char == '"') || ($char == "'")) {
                        $inside_string = true;
                        $close_tag = $char;
                    }

                    // The "one-line" comment styles only comment to the end of the line or the current block of PHP code, whichever comes first. -> NOG GEEN SUPPORT
                    elseif ($next2char == '//') {
                        $inside_comment = true;
                        $close_tag = "\n";
                        ++$x;
                    } elseif ($char == '#') {
                        $inside_comment = true;
                        $close_tag = "\n";
                    } elseif ($next2char == '/*') {
                        $inside_comment = true;
                        $close_tag = '*/';
                        ++$x;
                    } elseif ($next2char == '?>') {
                        $inside_code = false;
                        ++$x;
                    }
                }

                //ook al zitten we in een string dan zoeken we nog steeds naar variabelen want dat kan in php
                if ($char == '$') {
                    $inside_variable = true;
                } else {
                    if ($inside_variable) {
                        if (preg_match("/^\w$/", $char)) {
                            $current_variable .= $char;
                        } else {
                            //numerieke waardes zoals in regular expression backreferences $1 -> deze staan altijd in strings, dus negeren we
                            if (($current_variable != '') && (!is_numeric($current_variable))) {
                                if ($inside_string) {
                                    ++$vars_inside_strings;
				    if ($show_warnings)
				    {
                                	    $return .= sprintf("% 8d   %s   $%s\n", $lines_of_code, 'inside string', $current_variable);
				    }
                                }

                                if (!in_array($current_variable, $globals)) {
                                    //variabelen kunnen niet in een string gedeclareerd worden, ze worden dus ALTIJD gebruikt in string context;
                                    //$y = "jero";
                                    //print "$y=16\n";
                                    //output -> jero=16
                                    if (($char == '=') && (!$inside_string)) {
                                        $var_already_declared = false;
                                        for ($y = 0; $y <= $level; ++$y) {
                                            if ($vars_per_level_declared[$y][$current_variable]) {
                                                $var_already_declared = true;
                                                break;
                                            }
                                        }

                                        if (!$var_already_declared) {
                                            ++$declared_vars;
                                            $vars_per_level_declared[$level][$current_variable] = $lines_of_code;
                                        }
                                    } else {
                                        $was_this_var_declared = false;
                                        for ($y = 0; $y <= $level; ++$y) {
                                            if ($vars_per_level_declared[$y][$current_variable]) {
                                                $vars_per_level_used[$y][$current_variable] = $lines_of_code;
                                                $was_this_var_declared = true;
                                                break;
                                            }
                                        }
                                        if (!$was_this_var_declared) {
                                            ++$undeclared_vars;
                                            $return .= sprintf("% 8d   %s   $%s\n", $lines_of_code, 'undeclared   ', $current_variable);
                                        }
                                    }
                                }
                            }
                            $current_variable = '';
                            $inside_variable = false;
                        }
                    }

                    if ($char == '{') {
                        ++$level;
                        if ($level > $maxlevel) {
                            $maxlevel = $level;
                            $deepest_code = '';
                        }
                    } elseif ($char == '}') {
                        //sluiten van een blok
                        if (count($vars_per_level_declared[$level]) > 0) {
                            foreach (array_keys($vars_per_level_declared[$level]) as $var) {
                                if ($vars_per_level_used[$level][$var] == 0) {
                                    ++$unused_vars;
				    if ($show_warnings)
				    {
                                	    $return .= sprintf("% 8d   %s   $%s\n", $vars_per_level_declared[$level][$var], 'unused       ', $var);
				    }
                                }
                            }
                        }
                        $vars_per_level_declared[$level] = array();
                        $vars_per_level_used[$level] = array();
                        --$level;
                    }
                }

                if ($outside_string_at_end_of_loop) {
                    $inside_string = false;
                }
            }
        }

        if ($debug) {
            $charorigprint = $charorig;
            if ($charorigprint == "\n") {
                $charorigprint = '\\n';
            }
            $charprint = $char;
            if ($charprint == "\n") {
                $charprint = '\\n';
            }
            $close_tagprint = $close_tag;
            if ($close_tagprint == "\n") {
                $close_tagprint = '\\n';
            }
            $return .= $lines_of_code."\t".$x."\t".$level."\t".$charorigprint."\t".$charprint."\t".$inside_code."\t".$inside_string."\t".$inside_comment."\t".$close_tagprint."\t".$next_char_is_escaped."\t".$inside_variable."\t".$current_variable."\n";
        }

        ++$x;
    }

    if ($level != 0) {
        $return .= "\n\nERROR MISSING { OR } IN CODE OR ERROR IN THIS SCRIPT!! level: ".$level."\n";
    }

    if ($show_summary) {
        if (($undeclared_vars > 0) || ($unused_vars > 0) || ($vars_inside_strings > 0)) {
	    $return .= "\n\n";

            $return .= 'lines_of_code: '.$lines_of_code."\n";

	    $return .= 'declared_vars: '.$declared_vars."\n";
	    $return .= 'undeclared_vars: '.$undeclared_vars."\n";
            $return .= 'unused_vars: '.$unused_vars."\n";
            $return .= 'vars_inside_strings: '.$vars_inside_strings."\n";
            $return .= 'max_code_depth: '.$maxlevel."\n";
            if ($debug) {
                $return .= 'deepest_code: '.$deepest_code."\n";
            }
	}
    }

    return $return;
}

function ShowModuleEditScreen()
{
    if ($_REQUEST['Save']) {
        SetAttribute('module', 'SaveComments '.date('Y-m-d H:i:s').' '.GetUserName($GLOBALS['USERID']), $_REQUEST['saveComments'], $_REQUEST['mid']);

//		mcq("INSERT INTO CRMmodules (for_table, module_add_date, module_code, module_description, module_last_run_date, module_last_run_result, module_list_html, module_name, version_belonging_to) SELECT for_table, module_add_date, module_code, module_description, module_last_run_date, module_last_run_result, module_list_html, module_name, version_belonging_to FROM CRMmodules WHERE mid='" . $_REQUEST['mid'] . "'");
//		$new = db_GetInsertId();
//		mcq("UPDATE CRMmodules SET version_belonging_to = '" . $_REQUEST['mid'] . "' WHERE mid='" . $new . "'");

        mcq("UPDATE CRMmodules SET module_code='".mres($_REQUEST['code'])."', module_name='".mres($_REQUEST['module_name'])."', module_description='".mres($_REQUEST['module_description'])."', module_list_html='".mres($_REQUEST['module_list_html'])."' , for_table='".mres($_REQUEST['for_table'])."' WHERE mid='".mres($_REQUEST['mid'])."'");
    }

    $ls = new SaferScript('<?php ?>'.db_GetValue("SELECT module_code FROM CRMmodules WHERE mid='".mres($_REQUEST['mid'])."'").'<?php ?>');

    $ls->allowHarmlessCalls();

    $ar = FlattenArray($ls->parse());

    if (count($ar) > 0) {
        echo '<h2>Illegal function calls</h2>';
        echo implode(', ', $ar);
    }
    $additional_globals = array('recordid', 'lang', 'flextablerecord', 'flextableid');
    $debug = false;

    $codecheck = checkundeclaredvariables(db_GetValue("SELECT module_code FROM CRMmodules WHERE mid='".mres($_REQUEST['mid'])."'"), $additional_globals, $debug);
    if ($codecheck != '') {
        echo '<h2>Code check</h2>';
        echo '<div class="errmsg">'.nl2br(htme($codecheck)).'</div>';
    }

    echo "<form id='edit_module_code' method='post' action=''>";
    echo '<input type="hidden" name="starttable" value="'.htme($_REQUEST['starttable']).'">';
    echo '<input type="hidden" name="startrecordid" value="'.htme($_REQUEST['startrecordid']).'">';
    echo "<input type='hidden' name='fromlist' value='".htme($_REQUEST['fromlist'])."'>";

    echo "<input type='hidden' name='plain' value='".htme($_REQUEST['plain'])."'>";
    echo "<table class='form-table'><tr><td colspan='4'>";

    $RunAsUser = GetAttribute('module', 'RunAsUser', $_REQUEST['mid']);
    if ($RunAsUser == '') {
        SetAttribute('module', 'RunAsUser', '{{current user}}', $_REQUEST['mid']);
    } elseif (is_numeric($RunAsUser)) {
        echo '<div class="warnmsg">This module will always be ran as user '.GetUserName($RunAsUser).', regardless the context!</div>';
    }
    $ajax = GetAttribute('module', 'RunInAjax', $_REQUEST['mid']);
    if ($ajax == '') {
        SetAttribute('module', 'RunInAjax', 'No', $_REQUEST['mid'], array('Yes', 'No'));
    }
    $ShowHeaders = GetAttribute('module', 'ShowHeaders', $_REQUEST['mid']);
    if ($ShowHeaders == '') {
        SetAttribute('module', 'ShowHeaders', 'Yes', $_REQUEST['mid'], array('Yes', 'No'));
    }

    $DontFetchDQS = GetAttribute('module', 'DontFetchDQS', $_REQUEST['mid']);
    if ($DontFetchDQS == '') {
        SetAttribute('module', 'DontFetchDQS', 'No', $_REQUEST['mid'], array('No', 'Yes'));
    }
    $MassUpdatePopup = GetAttribute('module', 'MassUpdatePopup', $_REQUEST['mid']);
    if ($MassUpdatePopup == '') {
        SetAttribute('module', 'MassUpdatePopup', 'Full screen (no popup)', $_REQUEST['mid'], array('Small', 'Medium', 'Large', 'Extra large', 'Full screen (no popup)'));
    }

    $UnauthenticatedAccess = GetAttribute('module', 'UnauthenticatedAccess', $_REQUEST['mid']);
    if ($UnauthenticatedAccess == '') {
        SetAttribute('module', 'UnauthenticatedAccess', 'No', $_REQUEST['mid'], array('No', 'Yes'));
    }

    $DontBufferOutput = GetAttribute('module', 'DontBufferOutput', $_REQUEST['mid']);
    if ($DontBufferOutput == '') {
        SetAttribute('module', 'DontBufferOutput', 'No', $_REQUEST['mid'], array('No', 'Yes'));
    }
    $ContentsOfDivWhileLoadingViaAjax = GetAttribute('module', 'ContentsOfDivWhileLoadingViaAjax', $_REQUEST['mid']);
    if ($ContentsOfDivWhileLoadingViaAjax == '') {
        SetAttribute('module', 'ContentsOfDivWhileLoadingViaAjax', 'Please wait...', $_REQUEST['mid']);
    }

    $module = db_GetRow("SELECT mid, module_code, module_name, module_description,module_list_html,for_table FROM CRMmodules WHERE mid='".mres($_REQUEST['mid'])."'");

    echo "<input type='submit' name='Save' value='Save'> <a href='modules.php?action=run&amp;mid=".$_REQUEST['mid']."' class=\"likebutton\">Run in this window</a> <a onclick=\"window.open('modules.php?action=run&amp;mid=".$_REQUEST['mid']."', 'ModuleRunWindow');\" class=\"likebutton\">Run in new window</a> ".AttributeLink('module', $_REQUEST['mid'], 'Attributes', '', true)." <a href='javascript:PopRightsChooserModules(".$module['mid'].");' class=\"likebutton\">Access restrictions</a>";

    echo '</td></tr>';

    echo "<tr><td>Name</td><td><input type='text' name='module_name' size='50' value='".htme($module['module_name'])."'></td>";
    echo "<td>List HTML</td><td><input type='text' name='module_list_html' size='50' value='".htme($module['module_list_html'])."'></td></tr>";

    echo "<tr><td>Description</td><td><input type='text' name='module_description' size='50' value='".htme($module['module_description'])."'></td>";
    echo '<td>For table</td><td>';
    echo "<select name='for_table'>";
    echo "<option value='none'>None/don't</option>";
    $ins = '';

    $ins = '';
    if ($module['for_table'] == 'MU-users') {
        $ins = 'selected';
    }
    echo "<option value='MU-users' ".$ins.'>Mass-update: users</option>';

    $ins = '';
    if ($module['for_table'] == 'MU-groups') {
        $ins = 'selected';
    }
    echo "<option value='MU-groups' ".$ins.'>Mass-update: groups</option>';

    foreach (GetFlextableDefinitions() as $ft) {
        $ins = '';
        if ($module['for_table'] == 'flextable'.$ft['recordid']) {
            $ins = 'selected';
        }
        echo "<option value='flextable".$ft['recordid']."' ".$ins.'>'.htme('Top-right icon: '.$ft['tablename']).'</option>';

        $ins = '';
        if ($module['for_table'] == 'MU-t'.$ft['recordid']) {
            $ins = 'selected';
        }
        echo "<option value='MU-t".$ft['recordid']."' ".$ins.'>'.htme('Mass-update: '.$ft['tablename']).'</option>';
    }
    echo '</td></tr>';
    echo '<tr><td>Comments/changes</td><td colspan="1"><input type="text" name="saveComments" id="JS_saveComments" size="50"><td>Sanity check</td><td>'.ValidatePHPSyntax($module['module_code']);
    echo '</td></tr>';
    echo '</table>';


    echo "<textarea id='code-editor' rows='30' cols='120' name='code'>".htme($module['module_code']).'</textarea>';
    echo "<input type='hidden' name='mid' value='".$_REQUEST['mid']."'>";
    echo "<br><input type='submit' name='Save' value='Save'>";
    foreach (db_GetArray("SELECT * FROM CRMattributes WHERE identifier='module' AND entity='".mres($_REQUEST['mid'])."' AND attribute LIKE 'SaveComments%' ORDER BY STR_TO_DATE(SUBSTRING(attribute,14,19), '%Y-%m-%d %H:%i:%s') DESC") as $row) {
        echo "<div>" . str_replace('SaveComments ', '', $row['attribute']).' :: '.htme($row['value'])."</div>";
    }
    echo '</form>';
    if (!$_REQUEST['plain']) {
        print make_code_editor('code-editor', 'application/x-httpd-php');
    }
    echo 'make_list example:<br><textarea rows="16" cols="45">
&#36;listoptions = array();
&#36;listoptions["table"] = "t3";
&#36;listoptions["hide_selections"] = 1;
&#36;listoptions["hide_filters"] = 1;
&#36;listoptions["hide_header"] = 1;
&#36;listoptions["hiddenfilter"]["t3-f84"]["from"] = &#36;date;

&#36;listoptions["hiddenfilter"]["t3-f99"][] = "Voorzitter";
&#36;listoptions["hiddenfilter"]["t3-f99"][] = "Penningmeester";
&#36;listoptions["hiddenfilter"]["t3-f99"][] = "Secretaris";
&#36;listoptions["hiddenfiltertype"]["t3-f99"] = "NOT";

list(&#36;number_of_records, &#36;output) = make_list(&#36;listoptions);

print &#36;output;</textarea>';
}
function make_code_editor($element_id, $syntax) {
    $ret = '
    <script src="lib/codemirror-5.30.0/lib/codemirror.js"></script>
    <link rel="stylesheet" href="lib/codemirror-5.30.0/lib/codemirror.css">
    <script src="lib/codemirror-5.30.0/mode/php/php.js"></script>
    <script src="lib/codemirror-5.30.0/mode/htmlmixed/htmlmixed.js"></script>
    <script src="lib/codemirror-5.30.0/mode/xml/xml.js"></script>
    <script src="lib/codemirror-5.30.0/mode/javascript/javascript.js"></script>
    <script src="lib/codemirror-5.30.0/mode/css/css.js"></script>
    <script src="lib/codemirror-5.30.0/mode/clike/clike.js"></script>
    <script src="lib/codemirror-5.30.0/mode/sql/sql.js"></script>
    <script src="lib/codemirror-5.30.0/addon/edit/matchbrackets.js"></script>
    <script src="lib/codemirror-5.30.0/addon/scroll/simplescrollbars.js"></script>';

    if ($syntax == 'text/x-mysql') {
    //    $ret .= '<script src="lib/codemirror-5.30.0/addon/hint/show-hint.js"></script>';
    //    $ret .= '<link rel="stylesheet" href="lib/codemirror-5.30.0/addon/hint/show-hint.css">';
    }
    $ret .= '
    <script>';

    $y = array();
    $ret .= ' avail_options = [';
    foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $ds_tablename => $t) {

        if ($t['datatable']) {
            $y[] = '{text: "`CRM' . $t['name_in_database'] . '`", displayText: "' . $t['name_in_database'] . ' ' . $ds_tablename . ' ' . $t['plural'] . '"}';

            foreach ($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]["fields"] AS $ds_fieldname => $f) {
                $f['name'] = trim(f['name']);

                $y[] = '{text: "`CRM' . jsencode($t['name_in_database']) . '`.`' . jsencode($f['name_in_database']) . '`", displayText: "CRM' . jsencode($t['name_in_database']) . '.' . jsencode($f['name_in_database']) . ' ' . jsencode($t['plural']) . ' ' . jsencode($f['name']) . '"}';
                $y[] = '{text: "`@table_alias@`.`' . jsencode($f['name_in_database']) . '`", displayText: "@table_alias@.' . jsencode($f['name_in_database']) . ' ' . jsencode($t['plural']) . ' ' . jsencode($f['name']) . '"}';

                $y[] = '{text: "`' . jsencode($f['name_in_database']) . '`", displayText: "' . jsencode($f['name_in_database']) . ' ' . jsencode($t['plural']) . ' ' . jsencode($f['name']) . '"}';
            }
        }
    }

    $ret .= implode(",\n", $y);
    $ret .= '];
        $(document).ready(function() {
            var editor = CodeMirror.fromTextArea(document.getElementById(\'' . $element_id . '\'),
            {
                mode: "' . $syntax . '",
                lineNumbers: true,
                lineWrapping: true,
                matchBrackets: true,
                hintOptions: {"completeSingle": true, "completeOnSingleClick": true}
            });
            editor.on("cursorActivity", function(instance, options){

                var typedword = editor["display"]["input"]["prevInput"];

                console.log(typedword);
                if (typedword.length > 2) {

                    var found_options = [];
                    for (index = 0; index < avail_options.length; ++index) {
                        if (stristr(avail_options[index]["text"], typedword) || stristr(avail_options[index]["displayText"], typedword)) {
                            found_options.push(avail_options[index]);
                        }
                    }

                      var options = {
                        hint: function() {
                          return {
                              /* we moeten replacen; niet aanvullen. lengthe van typedword eraf dus */
                            from: {line: editor.getDoc().getCursor()["line"], ch: editor.getDoc().getCursor()["ch"] - typedword.length },
                            to: editor.getDoc().getCursor(),
                            list: found_options
                          }
                        }
                } /* end length check */
              };
              editor.showHint(options);
            });
        });
    </script>

    <style type="text/css">
        .CodeMirror {
            height: auto;
            min-height: 10em;
            border: 1px solid #808080;
        }
    </style>
    ';

    return $ret;

}
function TableHasProperty($table, $literal_property)
{
    if (substr($table, 0, 3) != 'CRM') {
        $table = 'CRM'.$table;
    }

    $ar = db_GetArray('SHOW CREATE TABLE '.$table);
    $ar = explode("\n", $ar[0][1]);
    $cr = $ar[count($ar) - 1];
    if (stristr($cr, $literal_property)) {
        return true;
    } else {
        return false;
    }
}
function TableHasIndex($table, $fields)
{

    if (substr($table, 0, 3) != 'CRM') {
        $table = 'CRM'.$table;
    }

    $ar = db_GetArray('SHOW CREATE TABLE '.$table);
    $key = '(`'.implode($fields, '`,`').'`)';
    $ar = explode("\n", $ar[0][1]);
    $found = false;
    $key = '(`'.implode($fields, '`,`').'`)';
    foreach ($ar as $cr) {
        $cr = trim($cr);

        if ((substr($cr, 0, 3) == 'KEY' || substr($cr, 0, 10) == 'UNIQUE KEY' || substr($cr, 0, 11) == 'PRIMARY KEY') && (substr($cr, strlen($cr) - strlen($key), strlen($key)) == $key || substr($cr, strlen($cr) - strlen($key) - 1, strlen($key)) == $key)) {
            $found = true;
            break;
        }
    }

    if ($found) {
        return $found;
    }
    $key = '(`'.implode($fields, '`,`').'`(64))';
    foreach ($ar as $cr) {
        $cr = trim($cr);
        if ((substr($cr, 0, 3) == 'KEY' || substr($cr, 0, 10) == 'UNIQUE KEY' || substr($cr, 0, 11) == 'PRIMARY KEY') && (substr($cr, strlen($cr) - strlen($key), strlen($key)) == $key || substr($cr, strlen($cr) - strlen($key) - 1, strlen($key)) == $key)) {
            $found = true;
            break;
        }
    }

    return $found;
}

function TableHasIndexByName($table, $keyname)
{
    if (substr($table, 0, 3) != 'CRM') {
        $table = 'CRM'.$table;
    }

    foreach (db_GetArray('SHOW INDEXES FROM '.$table) as $index) {
        if ($index['Key_name'] == $keyname) {
            return true;
        }
    }

    return false;
}

function FieldHasProperty($table, $field, $property)
{
    if (substr($table, 0, 3) != 'CRM') {
        $table = 'CRM'.$table;
    }

    $ar = db_GetArray('SHOW CREATE TABLE '.$table);
    $key = '`'.$field.'`';
    $ar = explode("\n", $ar[0][1]);
    $found = 'no';
    foreach ($ar as $cr) {
        $cr = trim($cr);
        if (substr($cr, 0, strlen($key)) == $key) {
            if (stristr($cr, $property)) {
                if (substr($cr, strlen($cr) - 1, 1) == ',') {
                    $cr = substr($cr, 0, strlen($cr) - 1);
                }

                return $cr;
            } else {
                return false;
            }
        }
    }

    return $found;
}

function TableHasField($table, $field, $type, $defaultvalue = '')
{
    // Smerige hack, niet schadelijk
    $type = trim(str_replace('PRIMARY KEY', '', $type));
    $type = trim(str_replace('FIRST', '', $type));

    if (substr($table, 0, 3) != 'CRM') {
        $table = 'CRM'.$table;
    }
    $ar = db_GetArray('SHOW CREATE TABLE '.$table);
    $key = '`'.$field.'`';
    $ar = explode("\n", $ar[0][1]);
    $found = 'no';
    foreach ($ar as $cr) {
        $cr = trim($cr);
        if (substr($cr, 0, strlen($key)) == $key) {
            /* dirty hack to exclude collation */
            $cr = str_replace(' COLLATE utf8mb4_unicode_ci', '', $cr);

            //print 'CMP look for "' . $type . '" in "' . $cr . '"<br>';
            if ($type == false || stristr($cr, $type)) {
                if (($defaultvalue != '' && stristr($cr, $defaultvalue)) || $defaultvalue == '') {
                    return 'yes';
                } else {
                    return 'wrongtype';
                }
            } else {
                return 'wrongtype';
            }
        }
    }

    return $found;
}
function SchemaHasTable($table)
{
    $cnt = db_GetArray("SHOW TABLES LIKE '".$table."'");
    if (count($cnt) > 0) {
        return true;
    }

    return false;
}
function DeleteExpiredTempFiles()
{

    //$dir = ini_get("session.save_path") . "/";
    $dir = GetSetting('TMP_FILE_PATH');
    if ($dir == '/') {
        qlog(ERROR, 'ERROR fetching temporary file space. Temp files left behind cannot be deleted.');
        log_msg("DeleteExpiredTempFiles::Error fetching temporary file space. Temp files left behind cannot be deleted. This will also cause problems when using exports and such. Check if your php.ini variable 'session.save_path' is set to a proper location.");
    } else {
        if ($dir[(strlen($dir) - 1)] != '/') {
            $dir .= '/';
        } //check for trailing slash

        $date = date(U);
        if ($d = @dir($dir)) {
            while ($f = $d->read()) {
                $date2 = @filemtime($dir.$f); //change to A C or M
                if (($date - $date2) > 120) { // 120 seconds

                    if (strstr($f, 'CRM_TMP_') && $f != '.') {
                        if (@unlink($dir.$f)) {
                            qlog(INFO, 'Deleted expired temp file '.$dir.$f);
                            log_msg('DeleteExpiredTempFiles::Deleted expired temporary file '.$dir.$f);
                        } else {
                            qlog(INFO, 'NOT Deleted expired temp file '.$dir.$f.' - unknown error - probably no access');
                            log_msg('DeleteExpiredTempFiles::NOT Deleted expired temp file '.$dir.$f.' - unknown error - probably no access');
                        }
                    }
                }
            }
            $d->close();
        } else {
            qlog(ERROR, 'ERROR - Unable to access '.$dir);
            log_msg('DeleteExpiredTempFiles::ERROR - Unable to access '.$dir.' (is your TMP_FILE_PATH setting correct?)');
        }
    }
}
function DeleteExpiredCacheRecords()
{
    // Now delete expired temp records from the cache table:

    $sql = 'DELETE FROM CRMcache WHERE timestamp_last_change< DATE(DATE_SUB(NOW(), INTERVAL 1 day))';
    mcq($sql);
}
function check_config()
{
    $fixed = false;

    $p = array();
    foreach (db_GetArray('SELECT * FROM CRMsettings') as $resarr) {
        if (in_array($resarr['setting'], $p)) {
            echo fillout(GetSetting('title'), 60).': Double config entry for '.$resarr['setting']." found - fixed by deleting the last one.\n";
            $sql = "DELETE FROM CRMsettings WHERE settingid=" . $resarr['settingid'];
            mcq($sql);
            $fixed = true;
        }
        $p[] = $resarr['setting'];
    }
    if (!$fixed) {
        echo fillout(GetSetting('title'), 60).": the configuration is consistant, no double entries found.\n";
    }
}
function ExportSettings()
{
    MustBeAdmin();

    qlog(INFO, 'Exporting settings');
    $outp = '';
    foreach (db_GetArray('SELECT setting,value,discription FROM CRMsettings') as $row) {
        $outp .= base64_encode($row['setting']).','.base64_encode($row['value']).','.base64_encode($row['discription'])."\n";
    }

    $filename = 'Exported_settings_'.$GLOBALS['PRODUCT'].'_'.rawurlencode(GetSetting('title')).'-'.date('Fj-Y-Hi').'.crm';
    header('Content-Type: CSV');
    header('Content-Disposition: attachment; filename='.$filename);
    header('Content-Description: '.$GLOBALS['PRODUCT'].' Generated Data');
    header('Window-target: _top');
    echo $outp;
}
function ImportSettings()
{
    MustBeAdmin();

    qlog(INFO, 'Importing users');
    $sarr = array();
    if ($_FILES['userfile']['tmp_name'] && $_FILES['userfile']['name']) {
        $fp = fopen($_FILES['userfile']['tmp_name'], 'rb');
        $filecontent = fread($fp, filesize($_FILES['userfile']['tmp_name']));
        fclose($fp);
        $arr = explode("\n", $filecontent);
        foreach ($arr as $line) {
            $element_count = 0;
            $set_row = explode(',', $line);

            $sql = 'INSERT INTO CRMsettings(setting,value,discription) VALUES (';
            foreach ($set_row as $element) {
                $sql .= "'".mres(base64_decode($element))."',";
                ++$element_count;
            }
            $sql .= ')';
            $sql = str_replace(',)', ')', $sql);
            if ($element_count == 3) {
                // 1st element is the account name, and it may not already exist.
                    array_push($sarr, $sql);
            } else {
                qlog(INFO, 'Ignoring record with '.$element_count.' instead of 3 elements');
            }
        }

        if (sizeof($sarr) == 0) {
            qlog(INFO, 'No valid accounts to import found');
            echo 'No valid setting records to import found in this file.<br><br>';
        } else {
            qlog(INFO, 'Importing '.sizeof($sarr).' setting records');
            mcq('TRUNCATE TABLE CRMsettings');
            foreach ($sarr as $query) {
                mcq($query);
            }
            echo sizeof($sarr).' setting records imported.';
            log_msg(sizeof($sarr).' setting records imported.');
        }
    } else {
        echo '<h2>Import global settings (ALL CURRENT GLOBAL SETTNGS WILL BE REMOVED!)</h2>';
        echo 'Select file for upload:';
        echo "<form enctype='multipart/form-data' id='IU' method='post' action=''><input name='userfile' type='file'>";
        echo " <input type='submit' value='Upload'>";
        echo '</form>';
    }
}
function CheckIfShell()
{
    // This should NOT be run via the web!
    if ($_SERVER['REQUEST_URI']) {
        ?>
			<script type="text/javascript">
				alert('You tried to access a shell (command-line) script through the web. Redirecting.');
				window.location.href='index.php';
			</script>
			<?php
            EndHTML();
        exit;
    }
}

function ProcessMailQueue()
{
    // This function processes the mail queue. This is done by updating it first to set a hash value as identification.
    // After that, the row having the hash will be processed and send.

    // Set the maximum number of rows to process per function run
    $max = 200;
    $curuser = $GLOBALS['USERID'];

    //we use strtolower because this database column in not binary. to prevent cases where worker_hash "abcde" would also match "ABCDE" or "ABcdE", etc
    $worker_hash = strtolower(randomstring(32));
    mcq("UPDATE CRMmailqueue SET worker_hash ='".$worker_hash."' WHERE worker_hash ='' AND `status` = 'unsent' LIMIT ".$max);
    $qtp = db_GetFlatArray("SELECT queueid FROM CRMmailqueue WHERE worker_hash = '".$worker_hash."' ORDER BY RAND()");

    $lastuser = 0;
    $error = '';
    foreach ($qtp as $qe) {
        $row = db_GetRow("SELECT * FROM CRMmailqueue WHERE queueid = '".$qe."'");

        // Load user context (important!)
        if ($lastuser != $row['user']) {
            $GLOBALS['USERID'] = $row['user'];
            $GLOBALS['NO_MSG'] = true;
            InitUser($row['user']);
        }

        // Actually send the e-mail here
        if ($row['template'] != '' && $row['to'] != '') {
            $parse = true;
            if ($row['parse'] == 'n') {
                $parse = false;
            }
            echo date('r').': Process mail to '.$row['to'].' subject '.$row['subject'].': '.$parse.' table '.$row['table']."<br>\n";
            if (ipi($row['entity']) && !ipi($row['flextablerecord'])) {
                /* transitioning RealRealMail to only use $flextablerecord (later to be renamed) and $dstable */
                $row['flextablerecord'] = $row['entity'];
            }
            // Pass e-mail to e-mail function, this will actually deliver it to the mail server
            $adj = RealRealMail($row['template'], $row['from'], $row['fromname'], $row['to'], $row['PDF'], $row['subject'], $row['attach_to_dossier'], $row['attach_as_filename'], $row['report_attach'], $row['flextablerecord'], $parse, unserialize($row['files_to_attach']), $row['table']);

            if ($adj[1] == true) {

                // Mark the e-mail as sent
                mcq("UPDATE CRMmailqueue SET worker_hash='n/a', status='sent', date_sent=NOW() WHERE queueid=".$qe);
                log_msg('Sending email from '.$row['from'].' to '.$row['to'].' subject '.str_replace('WARNING', 'WARN', str_replace('ERROR', 'ERR', $row['subject'])));
            } else {
                // Mark the e-mail as error
                mcq("UPDATE CRMmailqueue SET worker_hash='".mres($adj[0])."', status='error' WHERE queueid=".$qe);
                log_msg('ERROR: '.$adj[0].' queue id '.$qe);
            }

            //print ("Sending email from " . $row['from'] . " to " . $row['to'] . " subject " . $row['subject']);
        } else {
            log_msg('ERROR: template, to or from not set in msg id '.$qe);
            $error = 'template, to or from not set in msg id '.$qe;
        }

        $lastuser = $row['user'];
    }
    // Set all remaining messages to "error"
    mcq("UPDATE CRMmailqueue SET worker_hash='".mres($error)."', status='error' WHERE worker_hash = '".$worker_hash."'");

    if (is_numeric($curuser)) {
        $GLOBALS['USERID'] = $curuser;
        $GLOBALS['NO_MSG'] = false;
        InitUser();
    }
}
function RealRealMail($template_id, $From, $Fromname, $To, $PDF, $Subject, $attach_to_dossier, $attach_as_filename, $report_attach, $flextablerecord, $parse = true, $files_to_attach = array(), $dstablename = '')
{
    require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/phpmailer/PHPMailerAutoload.php';
    //require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/class.smtp.php';

    $To = trim($To);
    $add_to_journal = '';
    $stylesheet = '';
    $template = '';
    //$Subject = "";

    if ($GLOBALS['DISABLEMAIL']) {
        return array('DISABLED', true);
    } // deze kan alleen in email_in.php gezet worden voor testdoeleinden, heeft verder geen functie

    /* convert to data structure type stuff */
    $recordid = 0;
    $flextableid = '';

    if ($dstablename == '') {
    } else {
        $recordid = $flextablerecord;
        $flextableid = str_replace("t", "", $dstablename);
    }

    if (ipi($template_id)) {

        /* normal template from templates table */
        $template = GetTemplate($template_id);
        $Subject = GetTemplateSubject($template_id);
    } else {

        /* a given html template inside $template_id. not pretty but supported */
        $template = $template_id;
    }

    $force_autoform = false;

    if ($parse) {
        /* get_parsed_template_with_given_template supports being called with an empty $table var  */
        $template = get_parsed_template_with_given_template($dstablename, $recordid, array(), array(), $force_autoform, '', $template, 'TEMPLATE_HTML');
        $Subject = html2plaintext(get_parsed_template_with_given_template($dstablename, $recordid, array(), array(), $force_autoform, '', $Subject, 'TEMPLATE_PLAIN'));
    }




    if (ipi($template_id)) {
        if (ReturnTemplateStyleSheet($template_id) == '') {
            $stylesheet = ReturnStyleSheet(GetSetting('SYSWIDECSS'));
        } else {
            $stylesheet = ReturnTemplateStyleSheet($template_id);
        }
        // The stylesheet will be included in the header later on
    }

    $also_attach_generated_reports = false;
    if (strstr($report_attach, '+2')) {
        $also_attach_generated_reports = true;
        $report_attach = str_replace('+2', '', $report_attach);
        qlog(INFO, 'Also attaching generated report to the record');
    }

    $do_attach_all_files = false;
    if (strstr($report_attach, '+all')) {
        $do_attach_all_files = true;
        $report_attach = str_replace('+all', '', $report_attach);
        qlog(INFO, 'Also attaching all record attachments');
    }
    if (strstr($report_attach, 'ALL_ATTM') && $report_attach != 'ALL_ATTM') {
        $do_attach_all_files = true;
        $report_attach = str_replace('ALL_ATTM', '', $report_attach);
    }

    if (is_numeric($report_attach)) {
        $tname = GetTemplateName($report_attach);
        $extension1 = explode('.', $tname);
        $extension = $extension1[count($extension1) - 1];

        if ($extension == 'xml' || $extension == 'csv' || $extension == 'xls' || $extension == 'txt') {
            $GLOBALS['DONTFORMATNUMBERS'] = true;
        }
    }

    if (!is_array($GLOBALS['email_send_to'])) {
        $GLOBALS['email_send_to'] = array();
    }

    if (strstr($To, '<') && strstr($To, '>')) {
        $tmp = explode('<', $To);
        $tmp = str_replace('>', '', $tmp[1]);
        $To = trim($tmp);
        qlog(INFO, 'Email address fixed');
    } else {
        qlog(INFO, 'Email addess is ok ('.$To.')');
    }

    /* catch for development */
    if (GetSetting('DevelopmentOrProduction') == 'Development') {

        /* add original to-address to subject, this way the receiver can still make up to whom it was */
        $Subject .= ' ['.$To.']';

        /* test, so re-route all mails to set address */
        $To = GetSetting('AddressToSendAllMailsToWhenInDevelopmentMode');

        /* very important; also set from-address in case an error message is sent back */
        $From = GetSetting('AddressToSendAllMailsToWhenInDevelopmentMode');
    }

    if (ValidateEmail($To)) {
        if ($template != '') {
            $mail = new PHPMailer();
            $mail->SMTPSecure = false;
            $mail->SMTPAutoTLS = false;
            $mail->CharSet = 'UTF-8';

            if ($From != '') {
                $mail->From = $From;
            } else {
                $mail->From = GetSetting('admemail');
            }

            if (trim($Fromname) != '') {
                $mail->FromName = $Fromname;
            } else {
                $mail->FromName = $GLOBALS['PRODUCT'].' Notification Manager';
            }

            if (strstr(GetSetting('UNIFIED_FROMADDRESS'), '@') && GetSetting('DevelopmentOrProduction') != 'Development') {
                $ar = ParseFormattedEmailAddress(GetSetting('UNIFIED_FROMADDRESS'));
                $mail->From = $ar['fromemail'];
                $mail->FromName = $ar['fromname'];
            }
            if (ValidateEmail(GetSetting('BCCAllOutgoingQueuedMailToAddr'))) {
                $mail->AddBCC(GetSetting('BCCAllOutgoingQueuedMailToAddr'));
            }
            if (ValidateEmail(GetSetting('CCAllOutgoingQueuedMailToAddr'))) {
                $mail->AddCC(GetSetting('CCAllOutgoingQueuedMailToAddr'));
            }

            if (($report_attach == 'ALL_ATTM' || $do_attach_all_files) && $recordid) {
                $select_ins = " AND version_belonging_to='0' ";

                if ($flextableid > 0) {
                    $fids = db_GetArray("SELECT fileid FROM CRMbinfiles WHERE koppelid='".mres($flextablerecord)."' AND type='flextable".$flextableid."' ".$select_ins);
                    foreach ($fids as $file) {
                        if (CheckTableRecordAccess('files', $file['fileid']) != 'nok') {
                            $templateXX = GetFileContent($file['fileid']);
                            $filename = GetFileName($file['fileid']);
                            if (substr($filename, strlen($filename)-11, 11) == '.interleave') {

                                $filename = substr($filename, 0, strlen($filename)-11) . ".pdf";

                                /* an interleave specific doument ending in .interleave - it's plain html but we serve it as pdf */

                                list($templateXX, $files_to_delete) = replace_images_for_pdf_and_mails($templateXX, 'html');

                                $templateXX = HTML2PDF($templateXX);

                                foreach ($files_to_delete AS $ftd) {
                                    unlink($ftd);
                                }

                            }
                            $mail->AddStringAttachment($templateXX, $filename);
                        }
                    }
                }
            }

            foreach ($files_to_attach as $file) {
                if (CheckTableRecordAccess('files', $file) != 'nok') {
                    $templateXX = GetFileContent($file);
                    $filename = GetFileName($file);
                    if (substr($filename, strlen($filename)-11, 11) == '.interleave') {

                        $filename = substr($filename, 0, strlen($filename)-11) . ".pdf";

                        /* an interleave specific doument ending in .interleave - it's plain html but we serve it as pdf */

                        list($templateXX, $files_to_delete) = replace_images_for_pdf_and_mails($templateXX, 'html');

                        $templateXX = HTML2PDF($templateXX);

                        foreach ($files_to_delete AS $ftd) {
                            unlink($ftd);
                        }

                    }
                    $mail->AddStringAttachment($templateXX, $filename);
                    qlog(INFO, 'Attached file '.GetFileName($file));
                }
            }
            if ($attach_to_dossier != '') {
                $ins = '';
                if (!ValidateEmail($To)) {
                    $ins = "<span class='errmsg'>E-mail NOT sent! E-mail address is not a valid internet email address!</span><br>";
                }
                $total = $GLOBALS['PRODUCT'].' E-mail merge '.date('Fj-Y-Hi').'<br>'.$ins;
                $total .= 'To: '.$To.'<br>';
                $total .= 'Subject: '.$Subject.'<br><br>'.$template;
                $filename = '';
                if (!$attach_as_filename) {
                    $filename = $GLOBALS['PRODUCT'].'-HTML_file-'.date('Fj-Y-Hi').'h.HTML';
                } else {
                    $filename = $attach_as_filename;
                }

                if ($attach_to_dossier != '') {
                    $attachment = AttachFile($recordid, $filename, $total, ds_tablename_to_binfiles_table($dstablename), 'HTML', false, true, false, false, true);
                    $add_to_journal .= "\nAttached file ".$attachment.' to record '.$recordid.' table '.$dstablename;
                }
            }

            if (ipi($report_attach)) {
                $filename = '';
                $report_template = '';

                $template_type = GetTemplateType($report_attach);
                if ($template_type == 'TEMPLATE_REPORT' || $template_type == 'TEMPLATE_PLAIN' || $template_type == 'TEMPLATE_XML') {

                    /* get filename, parse it, clean it */
                    $filename = clean_filename(html2plaintext(get_parsed_template_with_given_template($dstablename, $recordid, array(), array(), false, '', GetTemplateSubject($report_attach), 'TEMPLATE_PLAIN')));

                    /* cut off extension */
                    $tmp_fn = explode('.', $filename);
                    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1)]);
                    unset($tmp_fn);

                    if ($ext == '.xlsx' || $ext == '.xlsm' || $ext == '.docx' || $ext == '.odt' || $ext == '.ods') {

                            /* zipped template. we need to unzip it, parse the content rather smart, and zip it again */

                            $report_template = ParseZippedContent($report_attach, false, false, $flextableid, $flextablerecord);
                    } else {

                            /* plain template, could be anything actually */
                            $passthru = array();
                        $passthru['template_to_use'] = $report_attach;

                        $report_template = get_parsed_template($dstablename, $recordid, $passthru, $recordid, false, 'ok');
                    }
                } elseif (GetTemplateType($report_attach) == 'TEMPLATE_REPORT_PDF') {
                    $tmp = GetPDFReport($report_attach, $dstablename, $recordid);
                    $filename = $tmp['filename'];
                    $report_template = $tmp['pdf'];
                }

                if (trim($report_template) == '') {
                    /* file is empty, can't be good */
                    log_msg("ERROR: We're attaching a report to an e-mail but the generated report (".$filename.') is empty. Table '.$dstablename.' record '.$recordid.'.');
                }
                $mail->AddStringAttachment($report_template, $filename);

                if ($also_attach_generated_reports) {

                    /* attach generated report to record */
                    $attachment = AttachFile($recordid, $filename, $report_template, ds_tablename_to_binfiles_table($dstablename), '', false, true, false, false, true);
                    $add_to_journal .= "\nAttached file ".$attachment.' to record '.$recordid.' table '.$dstablename;
                }
            }

            $mail->Host = GetSetting('SMTPserver');
            $mail->Port = 25;
            if (strtolower(GetSetting('MailMethod')) == 'smtp') {
                    $mail->isSMTP();

            }
            //$mail->SMTPDebug = 3;
            $mail->SMTPAutoTLS = false;
            if (GetSetting('MailUser') != '' && GetSetting('MailPass') != '') {
                //$mail->AuthType = 'LOGIN';
                $mail->Username = GetSetting('MailUser');
                $mail->Password = GetSetting('MailPass');
            }
            $mail->IsHTML(true);

            $nt = '<!DOCTYPE html><html>';
            $nt .= "<head>\n";
            $nt .= '<meta charset="UTF-8">';
            $nt .= '<title>'.$Subject."</title>\n";
            if ($stylesheet != '') {
                // The stylesheet already has script header & footer
                $nt .= $stylesheet."\n";
            }
            $nt .= "</head>\n<body>\n".$template."\n</body>\n</html>\n";

            list($nt, $dummy) = replace_images_for_pdf_and_mails($nt, 'html');

            /* end replace */

            $mail->Body = $nt;
            $mail->AltBody = html2plaintext($template);
            $sto = '';
            $rec = 0;

            if (is_array($To)) {
                foreach ($To as $recipient) {
                    if (ValidateEmail($recipient)) {
                        if ((!in_array($To, $GLOBALS['email_send_to'])) || GetSetting('ONEMAILPERTRIGGER') == 'No') {
                            $mail->AddAddress($recipient, $recipient);
                            $sto .= ','.$recipient;
                            ++$rec;
                            array_push($GLOBALS['email_send_to'], $recipient);
                            $add_to_journal .= "\nEmail sent to ".$recipient;
                            log_msg('Triggered e-mail send to '.$recipient);
                        } elseif (GetSetting('ONEMAILPERTRIGGER') == 'Yes') {
                            qlog(INFO, 'Skipping '.$recipient.', already send this guy something');
                            log_msg('Skipping '.$recipient.', already send this guy something');
                            $add_to_journal .= "\nSkipping ".$recipient.', already send this guy something';
                        } else {
                            log_msg("ERROR: Don't know what to do with this triggered e-mail (1)");
                            qlog(ERROR, "ERROR: Don't know what to do with this triggered e-mail (1)");
                        }
                    } else {
                        qlog(INFO, 'Skipping '.$recipient.', this email address is not a valid internet email address.');
                        log_msg('Skipping '.$recipient.', this email address is not a valid internet email address.');
                        $add_to_journal .= "\nSkipping ".$recipient.', this email address is not a valid internet email address.';
                    }
                }
            } else {
                if (ValidateEmail($To)) {
                    if ((!in_array($To, $GLOBALS['email_send_to'])) || GetSetting('ONEMAILPERTRIGGER') == 'No') {
                        $mail->AddAddress($To, $To);
                        $sto = $To;
                        array_push($GLOBALS['email_send_to'], $To);
                        ++$rec;
                        $add_to_journal .= "\nEmail sent to ".$To;
                    } elseif (GetSetting('ONEMAILPERTRIGGER') == 'Yes') {
                        qlog(INFO, 'Skipping '.$To.', already send this guy something');
                        log_msg('Skipping '.$To.', already send this guy something');
                        $add_to_journal .= "\nSkipping ".$To.', already send this guy something';
                    } else {
                        log_msg("ERROR: Don't know what to do with this triggered e-mail (2)");
                        qlog(ERROR, "ERROR: Don't know what to do with this triggered e-mail (2)");
                    }
                } else {
                    qlog(INFO, 'Skipping '.$To.', this email address is not a valid internet email address.');
                    log_msg('Skipping '.$To.', this email address is not a valid internet email address.');
                    $add_to_journal .= "\nSkipping ".$To.', this email address is not a valid internet email address.';
                }
            }

            $mail->Subject = $Subject;
            $mail->XMailer = ' ';
            if ($rec > 0) {
                if (!$mail->Send()) {
                    echo "<span class='errmsg'>There has been a mail error sending to ".$sto.': '.$mail->ErrorInfo.'. Please contact your system administrator.</span><br>';
                    log_msg('ERROR: Sending e-mail to '.$sto.' failed:'.$mail->ErrorInfo);
                    $add_to_journal .= "\nSending e-mail to ".$sto.' failed:'.$mail->ErrorInfo;

                    return array($mail->ErrorInfo, false);
                } else {
                    log_msg('Notification e-mail sent to '.$sto);
                    //if ($entity) journal($entity, "E-mail was successfully delivered to mail server: " . $To . "(trigger " . $event[6] . ")");
                    qlog(INFO, 'An e-mail was sent.');
                }
            }

            $mail->ClearAddresses();
            $mail->ClearAttachments();
        } else {
            log_msg('ERROR: No template received! Not Mailing.');

            //journal($entity, "WARNING: Tried to mail but template is incorrect or empty! " . $To);
            return array('No template received. Quitting.', false);
        }
    } else {
        log_msg('ERROR: Tried to mail but e-mail address is incorrect or empty! '.$To);

        //journal($entity, "WARNING: Tried to mail but e-mail address is incorrect or empty! " . $To);
    }

    return array($add_to_journal, true);
}
function CountTotalNumOfRecords()
{
    $enum = 0;
    foreach ($GLOBALS['UC']['PersonalDataStructure'] as $table => $props) {
        $enum += db_GetValue('SELECT COUNT(*) FROM `CRM'.$props['name_in_database'].'`');
    }

    return $enum;
}
function CheckDatabaseSettings()
{
    $ret = '';

    if (GetSetting('cronpassword') == '*NONE*' || GetSetting('cronpassword') == '') {
        $ret .= "WARNING : The cron password is not set!\n";
    }
    if ($GLOBALS['logtext'] == true) {
        $ret .= 'WARNING : LOGTEXT is enabled. This slows '.$GLOBALS['PRODUCT']." down by 25%!\n";
    }
    if ($GLOBALS['logqueries'] == true) {
        $ret .= "WARNING : LOGQUERIES is enabled. This slows stuff down.\n";
    }
    $fp = @fopen('qlist.txt', 'r');
    if ($fp) {
        $ret .= "WARNING : SECURITY HAZARD: Your qlst.txt file is world-readable.\n";
        fclose($fp);
    }

    if (ini_get('magic_quotes_gpc') == 1) {
        $ret .= "ERROR   : Magic quotes is on! Should be off!\n";
    } else {
        //$ret .= "ERROR   : Magic quotes is off!\n";
    }

    if (GetSetting('TimestampLastDuedateCron') < (date('U') - 86400)) {
        $ret .= "ERROR   : It's more than a day ago since the duedate notifier script ran! (last run: ".date('Y-m-d H:i:s', GetSetting('TimestampLastDuedateCron')).")\n";
    }
    if (GetSetting('TimestampLastHousekeeping') < (date('U') - 3600)) {
        $ret .= "ERROR   : It's more than an hour ago since the housekeeping script ran! (last run: ".date('Y-m-d H:i:s', GetSetting('TimestampLastHousekeeping')).")\n";
    }

    if ($ret) {
        return $ret."\n";
    } else {
        return "No messages\n\n";
    }
}

function CheckDB($run_db_upgrade = true, $web = false)
{
    global $short, $serr, $auto;
    unset($serr);

    $deldoubles = array();
    if ($_REQUEST['input']) {
        // OK two arrays of to-delete data were submitted.
        // Namely:
        // file_td	:	files to delete

        $file_td = unserialize(base64_decode($_REQUEST['file_td']));

        $deldoubles = unserialize(base64_decode($_REQUEST['deldoubles']));

        $queries = array();

        foreach ($file_td as $file) {
            array_push($queries, "DELETE FROM CRMbinfiles WHERE fileid='".mres($file)."'");
            array_push($queries, "DELETE FROM CRMblobs WHERE fileid='".mres($file)."'");
        }

        //print_r($queries);

        $queries = array_merge($queries, $deldoubles);

        foreach ($queries as $sql) {
            mcq($sql);
        }

        echo '<pre>'.sizeof($queries)." database queries executed.\n</pre>";
    } else {
        AdminChangesDropCache();
        if ($web) {
            echo '<pre>';
        }
        // Check required ref-to-flex fields
        /*
        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table) {
            foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field) {
                if (($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["required"]) && ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["relation_to"] != "")) {
                    //do check
                }
            }
        }
        */
/*
        $list = db_GetArray("SELECT id, name, options, tabletype FROM CRMextrafields WHERE fieldtype ='Reference to FlexTable' AND forcing ='y' AND deleted='n'");
        foreach ($list AS $row) {
            if (is_numeric($row['tabletype'])) {
                $table = "CRMflextable" . $row['tabletype'];
            } elseif ($row['tabletype'] == "user") {
                $table = "CRMloginusers";
            } elseif ($row['tabletype'] == "group") {
                $table = "CRMuserprofiles";
            } elseif ($row['tabletype'] == "files"){
                $table = "CRMbinfiles";
            } else {
                $table = "CRM" . $row['tabletype'];
            }
            $cnt = db_GetValue("SELECT COUNT(*) FROM " . $table . " WHERE EFID" . $row['id'] . "=0");

            if ($cnt > 0) {
                print "BIG WARNING: Field " . $row['id'] . " (" . htme($row['name']) . ") is required, ref-to-flex but found " . $cnt . " empty records!";
                if ($web) {
                    print "<br>";
                } else {
                    print "\n";
                }
            }
        }
        $mr = FindMissingReferences();
        if ($web) {
            print $mr;
        } else {
            print strip_tags($mr);
        }
*/
        $ftd = array();

        if (!isset($_REQUEST['CheckColumnsOnly'])) {
            $tit = GetSetting('title');
            echo "\nStarting recursive reference check - repository \"".$tit."\".\n";

            $blobids = array();
            $binids = array();
            if (!$short) {
                echo "\nChecking binary large object references (blobs table)...\n";
            }
            $binids = db_GetFlatArray('SELECT fileid FROM CRMbinfiles');
            $blobids = db_GetFlatArray('SELECT fileid FROM CRMblobs');
            $xc = 0;
            foreach ($blobids as $id) {
                ++$xc;
                if (!$web) {
                    if (!$short) {
                        echo "\015".$xc.'/'.sizeof($blobids);
                    }
                }
                if (!in_array($id, $binids)) {
                    if (!$short) {
                        echo "\nFile ID ".$id." exists in BLOB table, but it doesn't exist in BIN table (binary content will be deleted)\n";
                    }
                    array_push($ftd, $id);
                    $serr = 1;
                }
            }
            if (!$short) {
                echo "\nChecking binary large object references (binfiles table)...\n";
            }
            $xxc = 0;
            foreach ($binids as $id) {
                ++$xxc;
                if (!$web) {
                    if (!$short) {
                        echo "\015".$xxc.'/'.sizeof($blobids);
                    }
                }
                if (!in_array($id, $blobids)) {
                    if (!$short) {
                        echo "\nFile ID ".$id." exists in BIN table, but it doesn't exist in BLOB table (file will be empty)\n";
                    }
                }
            }
            if (!$short) {
                echo "\n";
            }

            if (!$short) {
                echo 'Checking for double language tags....';
            }

            $deldoubles = array();
            foreach (db_GetArray("SELECT DISTINCT(CONCAT(LANGID,';',TEXTID)) AS ErrorneousValues FROM CRMlanguages GROUP BY ErrorneousValues HAVING COUNT(CONCAT(LANGID,TEXTID)) > 1") as $res2) {
                $item = explode(';', $res2[0]);
                $delnums = array();
                echo 'Language '.$item[0].', tag '.$item[1]." - double entry. Oldest must be deleted.\n";
                if ($item[0]) {
                    $delnums = db_GetFlatArray("SELECT id FROM CRMlanguages WHERE LANGID='".mres($item[0])."' AND TEXTID='".mres($item[1])."'");
                }
                @sort($delnums);

                array_push($deldoubles, "DELETE FROM CRMlanguages WHERE LANGID='".mres($item[0])."' AND TEXTID='".mres($item[1])."' AND id<".$delnums[sizeof($delnums) - 1].' AND id!='.$delnums[sizeof($delnums) - 1]);
                $serr = 1;
            }

            if (!$short) {
                echo "\n".sizeof($deldoubles)." double entries found. Oldest values will be deleted.\n";
            }

            qlog(INFO, 'Checking database');
        }

        // Check if all fields are represented all flextables

        $list = GetFlexTableDefinitions();

        foreach ($list as $flextable) {
            echo 'Checking extra flextable '.$flextable['recordid']." field columns...\n";
            $efs = GetExtraFlextableFields($flextable['recordid']);

            $tmp = db_GetArray('SHOW FIELDS FROM CRMflextable'.$flextable['recordid']);
            foreach ($efs as $ef) {
                $found = false;
                foreach ($tmp as $row) {
                    if ($row['Field'] == 'EFID'.$ef['id']) {
                        $found = true;
                    }
                }
                if (!$found) {
                    $ft = '';
                    $add = '';
                    if ($ef['fieldtype'] == 'date/time') {
                        $ft = 'DATETIME';
                        $add = " DEFAULT '0000-00-00 00:00:00'";
                    } else {
                        $ft = 'LONGTEXT';
                    }
                    mcq('ALTER TABLE CRMflextable'.$flextable['recordid'].' ADD EFID'.$ef['id'].' '.$ft.' NOT NULL'.$add);
                    echo 'Fixed missing column in flextable '.$flextable['recordid'].' for field EFID'.$ef['id']."\n";
                }
            }
            echo "OK.\n";
        }

        if (!isset($_REQUEST['CheckColumnsOnly'])) {
            echo "\n\nFiles which can be deleted: ".sizeof($ftd)."\n";
            echo 'Unused language tags which will be deleted: '.sizeof($deldoubles)."\n";

            if (!$web && !$serr) {
                echo "\nNothing to do. Bye!\n\n";

                return 'exit';
            }

            if ($web) {
                echo '</pre>';

                if ($serr) {
                    echo "<form id='cont' method='post' action=''>";
                    echo "<input name='file_td' type='hidden' value='".base64_encode(serialize($ftd))."'>";

                    echo "<input name='deldoubles' type='hidden' value='".base64_encode(serialize($deldoubles))."'>";

                    echo "<input name='input' type='hidden' value='1'>";
                    echo "<input name='checkdb' type='hidden' value='1'>";
                    echo "<input type='submit' value='Delete excess data (back-up first)' class='deletebutton'></form>";
                } else {
                    echo 'No errors found which can be fixed automatically.<br><br>';
                }
            } else {
                if (!$auto) {
                    echo 'Return status: '.$serr."\n";
                    echo "\nDo you want to delete these (obviously unreachable) records? [y|n]\n".$GLOBALS['PRODUCT'].' > ';
                    $a = readln();
                    if (strtoupper($a) != 'Y') {
                        echo "\nOK\n";

                        return 'exit';
                    }
                    unset($serr);
                }

                $queries = array();

                foreach ($ftd as $file) {
                    array_push($queries, "DELETE FROM CRMbinfiles WHERE fileid='".mres($file)."'");
                    array_push($queries, "DELETE FROM CRMblobs WHERE fileid='".mres($file)."'");
                }
                $queries = array_merge($queries, $deldoubles);
                //print_r($queries);
                $sqlc = 0;
                foreach ($queries as $sql) {
                    mcq($sql);
                    //print $sql . "\n\n";
                    ++$sqlc;
                    if (!$web) {
                        echo 'Executing queries, please be patient. ('.$sqlc.'/'.sizeof($queries).")\015";
                    }
                }
                echo "\n".sizeof($queries)." database queries executed.\n";

                unset($queries);
                $x = 0;
                foreach ($GLOBALS['UC']['PersonalDataStructure'] as $table => $props) {
                    if (!$web) {
                        echo "\015Optimizing tables..(".$x.'/'.sizeof($GLOBALS['UC']['PersonalDataStructure']).')';
                    }
                    $sql = 'OPTIMIZE TABLE `CRM'.$props['name_in_database'].'`';
                    mcq($sql);
                }
                ++$x;
                echo " ... done\n\n";
                log_msg('Database checked. '.sizeof($queries).' delete statements executed');
                qlog(INFO, 'Database checked. '.sizeof($queries).' delete statements executed');
            }
        }
    } // End if not submitted
    if (!isset($_REQUEST['CheckColumnsOnly'])) {
	require "dbupgrade.php";
        echo '<pre>';
        PerformDatabaseMaintenance(true);
        echo '</pre>';
    }
} //end function CheckDB
function GetCurrentDBTotalSize()
{
    $size = 0;
    foreach (db_GetArray('SHOW TABLE STATUS') as $stat) {
        $size += $stat['Data_length'];
        $size += $stat['Index_length'];
    }

    return ceil(($size / 1024) / 1024);
}
function AdminChangesDropCache($force = false)
{

    if (GetAttribute('user','AutoDropDS', $GLOBALS['userid']) != 'No' || $force) {

        //print '<h1>DS Actually dropped</h1>';

        SetAttribute('user', 'UserNeedsToDropDS', 'No', $GLOBALS['USERID'], array('No', 'Yes'));

        DropPersonalDataStructure(0);
        unset($GLOBALS['UC']['PersonalDataStructure']);
        CheckAndCreateSystemDataStructure();
        InitUser();
    } else {
        SetAttribute('user', 'UserNeedsToDropDS', 'Yes', $GLOBALS['USERID'], array('No', 'Yes'));
    }
}
function ProcessArchiving()
{
    // File compression level
    // A  - Don't compress at all (except for old versions)
    // B1 - Compress files older than 1 year
    // C1 - Compress files older than 6 months
    // D  - Compress all files

    $now = date('U');
    $halfyearago = $now - 15811200;
    $yearago = $now - 31536000;

    //GetSetting("FILECOMPRESSIONLEVEL") = "C2";

    $sql = '';
    switch (GetSetting('FILECOMPRESSIONLEVEL')) {
        case 'A':
            qlog(INFO, 'Not compressing any files.');

            return true;
            break;
        case 'B1':
            $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$yearago."' AND gz!='y' AND CRMbinfiles.fileid!=0";
            break;
        case 'C1':
            $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$halfyearago."' AND gz!='y' AND CRMbinfiles.fileid!=0";
            break;
        case 'D':
            $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND gz!='y' AND CRMbinfiles.fileid!=0";
            break;
        default:
            log_msg('ERROR: Not able to determine compression level. Quitting. -> '.GetSetting('FILECOMPRESSIONLEVEL'));
            echo 'ERROR: Not able to determine compression level. Quitting. -> '.GetSetting('FILECOMPRESSIONLEVEL');

            return true;
            break;
    }
    /* it's useless to compress already compressed file types */
    $sql .= " AND CRMbinfiles.filetype NOT LIKE '%image/%' AND CRMbinfiles.filetype NOT LIKE '%word%' AND CRMbinfiles.filetype NOT LIKE '%excel%' AND CRMbinfiles.filetype NOT LIKE '%openoffice%'";

    $list = db_GetArray($sql);

    foreach ($list as $file) {
        echo "\015Compressing file ".$file['fileid'].'   ';
        CompressFile($file['fileid']);
    }

    $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND version_no > 1 AND gz!='y' AND CRMbinfiles.fileid!=0";
    $list = db_GetArray($sql);
    foreach ($list as $file) {
        CompressFile($file['fileid']);
        echo "\015Compressing file ".$file['fileid'].' (old version)   ';
    }
    echo "\n";
    mcq('OPTIMIZE TABLE CRMblobs');

    echo "Done.\n";
}
function DropUnusedFieldsFromDatabase()
{
    MustBeAdmin();

    // Array to hold the result
    $q = array();
    $ql = array();
    $qs = array();
    $add_last = '';
    $totalsize = 0;
    $views = array();

    // What it should be
    $efs = array();
    foreach (db_GetArray("SELECT tabletype, CONCAT('EFID', id) FROM CRMextrafields WHERE deleted='n'") as $row) {
        if (is_numeric($row['tabletype'])) {
            $row['tabletype'] = 'flextable'.$row['tabletype'];
        }
        if ($row['tabletype'] == 'user') {
            $row['tabletype'] = 'loginusers';
        }
        if ($row['tabletype'] == 'group') {
            $row['tabletype'] = 'userprofiles';
        }
        if ($row['tabletype'] == 'files') {
            $row['tabletype'] = 'binfiles';
        }

        $row['tabletype'] = 'CRM'.$row['tabletype'];
        $efs[$row['tabletype']][] = $row[1];
    }
    $fts = db_GetFlatArray("SELECT CONCAT('CRMflextable', recordid) FROM CRMflextabledefs");
    $fts[] = 'CRMloginusers';
    $fts[] = 'CRMuserprofiles';
    $fts[] = 'CRMbinfiles';

    // What it is
    $ftz = array();
    $efst = db_GetFlatArray('SHOW TABLES');
    foreach ($efst as $tab) {
        if (substr($tab, 0, 12) == 'CRMflextable' && $tab != 'CRMflextabledefs') {
            $ftz[] = $tab;
            if (!in_array($tab, $fts)) {
                $tmp = db_GetArray("SHOW TABLE STATUS LIKE '".$tab."'");

                $totalsize += ($tmp[0]['Index_length'] + $tmp[0]['Data_length']);

                $q[] = array('table' => $tab, 'size' => number_format(($tmp[0]['Index_length'] + $tmp[0]['Data_length']) / 1024 / 1024, 2).' M', 'rows' => $tmp[0]['Rows']);

                $qs[] = 'DROP TABLE '.$tab;
                $qs[] = "DELETE FROM CRMstats WHERE item='flextable".str_replace('CRMflextable', '', $tab)."'";
            }
        }
    }

    $ftz[] = 'CRMloginusers';
    $ftz[] = 'CRMuserprofiles';
    $ftz[] = 'CRMbinfiles';

    foreach ($fts as $table) {
        if (!in_array($table, $views)) {
            $sql = 'SHOW FIELDS FROM '.mres($table)." WHERE Field LIKE 'EFID%'";

            $ef = db_GetFlatArray($sql);
            foreach ($ef as $field) {
                if (!in_array($field, $efs[$table])) {
                    $size = db_GetRow('SELECT SUM(LENGTH('.$field.')), COUNT(*) FROM '.$table.' WHERE '.$field." != ''");
                    $totalsize += $size[0];
                    $q[] = array('table' => $table, 'field' => $field, 'size' => number_format($size[0]).' Bytes', 'rows' => $size[1], 'name' => db_GetValue("SELECT name FROM CRMextrafields WHERE id='".str_replace('EFID', '', $field)."'"), 'type' => db_GetValue("SELECT fieldtype FROM CRMextrafields WHERE id='".str_replace('EFID', '', $field)."'"));
                    $ql[$table][] = $field;
                }
            }
        }
    }
    echo 'Total size on disk to gain: '.FormatNumber($totalsize / 1024 / 1024)."MB. <a onclick=\"toggleLayer('queries');\">Show/hide queries</a>";
    echo '<div id="queries" style="display: none;">';
    echo '<textarea cols="100" rows="10">';
    foreach ($qs as $qbla) {
        echo $qbla.";\n";
    }
    foreach ($ql as $table => $fields) {
        $extra = 'ALTER TABLE '.$table.'';
        $nf = false;
        foreach ($fields as $field) {
    	    foreach (array($field . '_deleted', $field) AS $keyname) {
        		if (TableHasIndexByName($table, $keyname)) {
            	    if ($nf) {
        		        $extra .= ', ';
            	    }
            	    $extra .= ' DROP INDEX `'.$field.'`';
            	    $nf = true;
            	}
    	    }
	    }
        $extra.= ";\n";
	    if ($nf) print $extra;
        echo 'ALTER TABLE '.$table.'';
        $nf = false;
        foreach ($fields as $field) {
            if ($nf) {
                echo ', ';
            }
            echo ' DROP `'.$field.'`';
            $nf = true;
        }
        echo ";\n";


    }
    echo $add_last;

    echo '</textarea>';
    echo '</div>';
    echo '<table class="crm sortable"><thead><tr><th>Table</th><th>Field</th><th>Name</th><th>Size on disk</th><th>Rows</th><th>Type</th><th>Times found</th></tr></thead>';
    foreach ($q as $row) {
        echo '<tr>';
        foreach (array('table', 'field', 'name', 'size', 'rows', 'type') as $el) {
            echo '<td>'.htme($row[$el]).'</td>';
        }
        echo '<td>';
        echo db_GetValue("SELECT (CONCAT('Templates: ', (SELECT GROUP_CONCAT(CRMtemplates.templateid) FROM CRMtemplates WHERE (CRMtemplates.content LIKE '%".str_replace('CRMflextable', 't', $row['table']).'-f'.str_replace('EFID', '', $row['field'])."%' OR CRMtemplates.content LIKE '%".$row['field']."%') AND version_belonging_to =0), ' Modules: ', (SELECT GROUP_CONCAT(CRMmodules.mid) FROM CRMmodules WHERE (CRMmodules.module_code LIKE '%".str_replace('CRMflextable', 't', $row['table']).'-f'.str_replace('EFID', '', $row['field'])."%' OR CRMmodules.module_code LIKE '%".$row['field']."%') AND version_belonging_to =0)))");
        echo '</td>';
        echo '</tr>';
    }

    echo '</table>';
}
function ValidatePHPSyntax($code)
{
    $fn = tempnam(GetSetting("TMP_FILE_PATH"), 'INTLV_MODPARSE');
    $fp = fopen($fn, 'w');
    if (substr($code, 0, 5) != '<?php') {
        $code = "<?php\n".$code."\n?>";
    }
    fputs($fp, $code);
    ob_start();
    system('php -d display_errors=1 -l '.$fn);
    unlink($fn);

    $resultPHPcheck = ob_get_contents();
    ob_end_clean();

    $resultPHPcheck = str_replace("\nParse error", 'Parse error', $resultPHPcheck);
    $resultPHPcheck = str_replace('in '.$fn, '', $resultPHPcheck);

    return $resultPHPcheck;
}
function MailQueueManager()
{
    MustBeAdmin();
    $tabbs = array();
    $tabbs[] = array('admin.php?MailQueueManager', 'Waiting');
    $tabbs[] = array('admin.php?MailQueueManager&amp;Sent', 'Sent');
    $tabbs[] = array('admin.php?MailQueueManager&amp;Failed', 'Failed');
    $tabbs[] = array('admin.php?MailQueueManager&amp;All', 'All');
    $tabbs_actions = array();
    $tabbs_actions[] = array('admin.php?MailQueueManager&amp;Failed&amp;DropFailed', 'Delete all failed messages');
    $tabbs_actions[] = array('admin.php?MailQueueManager&amp;ProcessMailQueue', 'Process mail queue now');
    $tabbs_actions[] = array('admin.php?MailQueueManager&amp;DeleteUnsentMailQueue', 'Delete waiting mails from queue');

    $tabbs[] = array('#', 'Actions', $tabbs_actions);

    if (isset($_REQUEST['DropBodies'])) {
        $sql = "UPDATE CRMmailqueue SET template='' WHERE status='sent' AND LENGTH(template) > 10";
        mcq($sql);
    } elseif (isset($_REQUEST['DropTheRest'])) {
        $sql = "DELETE FROM CRMmailqueue WHERE status='sent'";
        mcq($sql);
/*
} elseif ($_REQUEST['DeleteQueueItem']) {
        $sql = "DELETE FROM CRMmailqueue WHERE queueid='" . mres($_REQUEST['DeleteQueueItem']) . "'";
        mcq($sql);
*/
    }

    if ($_REQUEST['dropmailto']) {
        echo 'Deleting all mail sent to address '.htme($_REQUEST['dropmailto']);
        $sql = "DELETE FROM CRMmailqueue WHERE `to`='".mres($_REQUEST['dropmailto'])."'";
        mcq($sql);
    }

    PlainNav($tabbs);

    $customheader = '';
    $lo = array('table' => 'mailqueue');

    if (isset($_REQUEST['Failed'])) {
        if (isset($_REQUEST['DropFailed'])) {
            if (isset($_REQUEST['Sure'])) {
                mcq("DELETE FROM CRMmailqueue WHERE status='error'");
            } else {
                echo "<p><a class='warnmsg' href='admin.php?MailQueueManager&amp;Failed&amp;DropFailed&amp;Sure'>Are you sure? ".FormatNumber(db_GetValue("SELECT COUNT(*) FROM CRMmailqueue WHERE status='error'"), 0).' messages will be permanently deleted.</a></p>';
            }
        }
        $customheader = 'E-mails which were not sent';
        $lo['hiddenfilter']['mailqueue-status'] = array('error');
    } elseif (isset($_REQUEST['All'])) {
    } elseif (isset($_REQUEST['Sent'])) {
        $customheader = 'Sent e-mails';

        $lo['hiddenfilter']['mailqueue-status'] = array('sent');

        //$sumofsend = db_GetValue("SELECT COUNT(*) FROM CRMmailqueue WHERE status='sent'");
        //print "Total number of sent mails : " . FormatNumber($sumofsend,0) . "";

        echo '<br>';

        $sumofsend_bodies = db_GetValue("SELECT SUM(LENGTH(template)) FROM CRMmailqueue WHERE status='sent' AND LENGTH(template) > 10");
        echo 'Total megabytes in mailbodies: '.round(ceil($sumofsend_bodies / 1024 / 1024), 2).' [<a href="admin.php?MailQueueManager&amp;Sent&amp;DropBodies">drop mailbodies but keep the rest</a>]<br>';

        $sumofsend_bodies = db_GetValue("SELECT SUM(LENGTH(CONCAT(template,user,`from`,fromname,`to`,PDF,subject,attach_to_dossier,attach_as_filename,report_attach,flextableid,flextablerecord,date_sent,status,worker_hash,date_queued))) FROM CRMmailqueue WHERE status='sent' AND LENGTH(template) > 10");
        echo 'Total megabytes overall : '.round(ceil($sumofsend_bodies / 1024 / 1024), 2).' [<a href="admin.php?MailQueueManager&amp;Sent&amp;DropTheRest">drop all sent mail</a>]<br>';

        echo "Drop all mail sent to address: <form id='mailqform' method='post' action='admin.php?MailQueueManager&amp;Sent'><input type='text' size='50' name='dropmailto' id='JS_dropmailto'> <input type='submit' id='JS_mailqform_submit' value='Ok'></form>";
    } else {
        if (isset($_REQUEST['ProcessMailQueue'])) {
            ProcessMailQueue();
            echo 'Mail queue processed<br>';
        } elseif (isset($_REQUEST['DeleteUnsentMailQueue'])) {
            mcq("UPDATE CRMmailqueue SET worker_hash='Deleted from queue by admin', status='error' WHERE status='unsent' and worker_hash = ''");
            echo '<div class="okmsg">Unsent mail queue emptied</div>';
        }

        $lo['hiddenfilter']['mailqueue-status'] = array('unsent');
        $customheader = 'E-mails waiting to be sent';
        echo '<h2>Messages which are in the queue for more than 2 hours will be moved to the error queue, regardless the reason.</h2>';
    }

    $lo['customheader'] = $customheader;

    echo '<a href="admin.php?editsetting=BCCAllOutgoingQueuedMailToAddr&amp;fromlist=' . base64_encode($_SERVER["REQUEST_URI"]) . '">BCC all outgoing e-mail to (queued e-mail only): '.htme(GetSetting('BCCAllOutgoingQueuedMailToAddr')) . '</a>';
    echo ' | <a href="admin.php?editsetting=SMTPserver&amp;fromlist=' . base64_encode($_SERVER["REQUEST_URI"]) . '">Currently using smtp: '.htme(GetSetting('SMTPserver')) . '</a>';
    if (GetSetting('DevelopmentOrProduction') == 'Development') {
        echo '<div class="warnmsg"><a href="admin.php?editsetting=AddressToSendAllMailsToWhenInDevelopmentMode&amp;fromlist=' . base64_encode($_SERVER["REQUEST_URI"]) . '">This repository is in Development mode, when processing the queue all mails will be redirected to: '.htme(GetSetting('AddressToSendAllMailsToWhenInDevelopmentMode')).'</a></div>';
    }

    list($number_of_records, $output) = make_list($lo);
    echo $output;
}
function LogStats($print = false)
{

    // This functions aims to log stats about the whole database

    /*
    +-----------------------+---------------+------+-----+-------------------+-------+
    | Field                 | Type          | Null | Key | Default           | Extra |
    +-----------------------+---------------+------+-----+-------------------+-------+
    | item                  | varchar(20)   | NO   |     | NULL              |       |
    | value                 | varchar(1024) | NO   |     | NULL              |       |
    | count                 | int(11)       | NO   |     | NULL              |       |
    | sum                   | int(11)       | NO   |     | NULL              |       |
    | avg                   | int(11)       | NO   |     | NULL              |       |
    | timestamp_last_change | timestamp     | NO   |     | CURRENT_TIMESTAMP |       |
    +-----------------------+---------------+------+-----+-------------------+-------+
    */

    $stats = array();
    /* make sure we only log once a day */
    mcq("DELETE FROM CRMstats WHERE DATE(timestamp_last_change) = DATE(NOW())");

    $stats[] = array('users', '', db_GetValue("SELECT COUNT(*) FROM CRMloginusers WHERE active='yes'"), '', '');
    $stats[] = array('groups', '', db_GetValue('SELECT COUNT(*) FROM CRMuserprofiles'), '', '');

    $yesterday = date('U') - (3600 * 24);
    $ystd = date('Y-m-d', $yesterday);

    $stats[] = array('datajournal_inserts', '', db_GetValue("SELECT COUNT(*) FROM CRMdatajournal WHERE DATE(timestamp_last_change) = '".$ystd."'"), '', '');
    $stats[] = array('journal_inserts', '', db_GetValue("SELECT COUNT(*) FROM CRMjournal WHERE DATE(timestamp_last_change) = '".$ystd."'"), '', '');
    $stats[] = array('logins', '', db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE UNIX_TIMESTAMP(timestamp_last_change) > '".$yesterday."' AND qs LIKE 'Login%'"), '', '');
    $stats[] = array('file_downloads', '', db_GetValue("SELECT COUNT(*) FROM CRMuselog WHERE UNIX_TIMESTAMP(timestamp_last_change) > '".$yesterday."' AND qs LIKE 'downloaded%'"), '', '');


    foreach ($GLOBALS['UC']['PersonalDataStructure'] as $table => $props) {
        if ($props['datatable']) {
            $sql = 'SELECT COUNT(*) FROM CRM'.$props['name_in_database'];
            if ($props['logical_delete']) {
                $sql .= ' WHERE deleted="n"';
            }
            $stats[] = array($props['name_in_database'], '', db_GetValue($sql), '', '');
        }
    }
    $sql = 'INSERT INTO CRMstats(item,value,count,sum, avg) VALUES ';
    $nnf = false;
    foreach ($stats as $line) {
        if ($nnf) {
            $sql .= ',';
        }
        $sql .= '(';
        $nf = false;
        foreach ($line as $row) {
            if ($nf) {
                $sql .= ',';
            }
            $sql .= "'".mres($row)."'";
            $nf = true;
        }
        $sql .= ')';
        $nnf = true;
    }

    mcq($sql);

    $ef = db_GetArray("SELECT id,fieldtype, tabletype FROM CRMextrafields WHERE deleted='n' AND log_stats='y'");

    //AND (fieldtype IN ('numeric', 'drop-down', 'Reference to FlexTable') OR fieldtype LIKE 'User%')");

    foreach ($ef as $field) {
        $table = '';
        if ($field['tabletype'] == 'user') {
            $table = 'CRMloginusers';
        } elseif ($field['tabletype'] == 'group') {
            $table = 'CRMuserprofiles';
        } else {
            $table = 'CRMflextable'.$field['tabletype'];
        }

        mcq("INSERT INTO CRMstats(item, value, count, sum, avg) SELECT '".$field['id']."',EFID".$field['id'].', COUNT(*), SUM(EFID'.$field['id'].'), AVG(EFID'.$field['id'].') FROM '.$table.' GROUP BY EFID'.$field['id']);
    }

    if ($print) {
        PHT('SELECT name, tabletype, fieldtype, item,value,count,sum,avg,CRMstats.timestamp_last_change FROM CRMstats LEFT OUTER JOIN CRMextrafields ON (item=id OR id IS NULL)');
    }
}

function OffloadFilesToDisk()
{
    $now            = date('U');
    $yearago        = $now - 31536000;
    $halfyearago    = $now - 15811200;
    $threemonthsago = $now - 7948800;
    $onemonthago    = $now - 2635200;
    $oneweekago     = $now - 604800;
    $onedayago      = $now - 86400;

    $localpath = GetSetting('OffloadLocalPath');

    if ($localpath == '') {
        return false;
    } else {
        $sql = '';
        switch (GetSetting('OffloadFilesPolicy')) {
            case "Don't offload files to disk":
                qlog(INFO, 'Not offloading any files.');

                return true;
                break;
            case 'After a year':
                $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$yearago."' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
                break;
            case 'After 6 months':
                $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$halfyearago."' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
                break;
            case 'After 3 months':
                $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$threemonthsago."' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
            case 'After 1 month':
                $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$onemonthago."' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
                break;
            case 'After 1 week':
                $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$oneweekago."' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
                break;
            case 'After 1 day':
                $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE UNIX_TIMESTAMP(CRMbinfiles.timestamp_last_change) < '".$onedayago."' AND CRMbinfiles.offloaded='n' AND CRMbinfiles.fileid!=0";
                break;
            default:
                return true;
            break;

        }

        $sql .= "  AND CRMbinfiles.type NOT IN ('system', 'generalpurpose', 'public')";

        $hash = GetSetting('OffLoadedFilesDirectoryHash');
        $key = GetSetting('OffLoadedFilesSSLKey');

        if ($hash == '') {
            $hash = md5(GetSetting('title').date('U'));
	    UpdateSetting("OffLoadedFilesDirectoryHash", $hash);
        }

        if (!is_dir($localpath.'/'.$hash)) {
            mkdir($localpath.'/'.$hash);
            echo "\015".date('r').': Created directory '.$localpath.'/'.$hash."\n";
        }
        $list = db_GetArray($sql);

        foreach ($list as $file) {

            $filename = $localpath.'/'.$hash.'/'.$file['fileid'];
            $efilename = $localpath.'/'.$hash.'/e'.$file['fileid'];

            $filecontent = db_GetValue('SELECT content FROM CRMblobs WHERE fileid='.$file['fileid']);

            /* we bluntly overwrite what might by already there - this is by design. files in the db can be changed on rare occasions (imgrotate),
                and when they do, the offloaded flag is set to "no". the database is always leading */

            file_put_contents($filename, $filecontent);
            $check = '';

            if ($key != '') { // file is, or must be, encrypted
                echo  date('r').': Offloading and encrypting file '.$file['fileid'].' in '.$efilename." \n ";

                system('cat '.$filename.' | openssl aes-256-cbc -k '.$key.' > '.$efilename);

                $check = `cat $efilename | openssl aes-256-cbc -d -k $key`;

                unlink($filename);
            } else {
                echo date('r').': Offloading file '.$file['fileid'].' in '.$filename.'  ';

                $check = file_get_contents($filename);
            }

            if ($check == $filecontent) {
                echo " (validated, all ok)\n";

                mcq("UPDATE CRMblobs SET CRMblobs.content='', CRMblobs.timestamp_last_change=CRMblobs.timestamp_last_change WHERE CRMblobs.fileid=".$file['fileid']);

                mcq("UPDATE CRMbinfiles SET offloaded='y', timestamp_last_change=timestamp_last_change WHERE fileid='".$file['fileid']."'");
            } else {
                echo " (validation failed, rollback)\n";
            }
        }

        mcq("UPDATE CRMblobs, CRMbinfiles SET offloaded='n', CRMbinfiles.timestamp_last_change=CRMbinfiles.timestamp_last_change, CRMblobs.timestamp_last_change=CRMblobs.timestamp_last_change where CRMbinfiles.fileid=CRMblobs.fileid AND CRMblobs.content!='' AND offloaded='y'");

        //print "Done.\n";
    }
}
function LoadOffloadedFilesBackIntoDB()
{
    $hash = GetSetting('OffLoadedFilesDirectoryHash');

    if ($hash == '') {
        echo "\015".date('r').": Error: hash not found!\n";
    } else {
        $sql = "SELECT CRMblobs.fileid FROM CRMblobs,CRMbinfiles WHERE CRMblobs.fileid=CRMbinfiles.fileid AND CRMbinfiles.offloaded='y' AND CRMblobs.fileid!=0 AND CRMblobs.content = ''";

        //$localpath = GetSetting("OffloadLocalPath");
        $localpath = GetSetting('OffloadFilesURL');
        $key = GetSetting('OffLoadedFilesSSLKey');

        foreach (db_GetFlatArray($sql) as $fileid) {
            $filename_on_disk = $localpath.'/'.$hash.'/'.$fileid;
            $efilename_on_disk = $localpath.'/'.$hash.'/e'.$fileid;

            $fc = '';
            if ($key != '') {
                echo "\015".date('r').': Fetching, decrypting and inserting '.$efilename_on_disk."...\n";
                $fc = `cat $efilename_on_disk | openssl aes-256-cbc -d -k $key`;
            } else {
                echo "\015".date('r').': Fetching and inserting '.$filename_on_disk."...\n";
                $fc = file_get_contents($filename_on_disk);
            }

            if ($fc != '') {
                mcq("UPDATE CRMblobs, CRMbinfiles SET content='".mres($fc)."',CRMbinfiles.offloaded='n', CRMbinfiles.timestamp_last_change=CRMbinfiles.timestamp_last_change, CRMblobs.timestamp_last_change=CRMblobs.timestamp_last_change WHERE CRMblobs.fileid=".$fileid);
            } else {
                echo "\015".date('r').': Error: File '.$fileid." not found in offload storage location!\n";
            }
        }
    }
    echo "\015".date('r').": Files on disk are untouched. Delete them manually if required.\n";
}
function ArchiveLog($log, $date_from)
{
    mcq("UPDATE CRMuselog SET qs='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(qs) > 2097152");
    mcq("UPDATE CRMjournal SET message='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(message) > 2097152");
    mcq("UPDATE CRMdatajournal SET from_val='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(from_val) > 2097152");
    mcq("UPDATE CRMdatajournal SET to_val='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(to_val) > 2097152");
    mcq("UPDATE CRMmailqueue SET template='{{deleted}}', timestamp_last_change=timestamp_last_change WHERE LENGTH(template) > 2097152");

    if ($log == '') {
        print '<h1>Archive rows</h1>';
        print '<p>This function will put rows into a file (SQL), zip that file and attach it as a system file to save space. After the file is zipped this procedure will unzip the file and make 100% sure it is uploaded correctly before actually purging a table (physical deletes; not logical). Needless to say this is a tricky function. The system-files page offers the option to re-import these files.</p>';
        print '<table class="crm filtertable">';
        print "<thead><tr><th>Table</th><th>DB Name</th><th class='num'>Rows</th><th class='num'>Size (M)</th><th>Oldest record</th><th>Archive before date</th></tr></thead>";
	print '<tbody>';

        /*
        print "<tr><td>Uselog</td><td>" . FormatNumber(GetTableRows("CRMuselog"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMuselog") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMuselog LIMIT 1") . "</td><td><form method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMuselog'><input type='text' class='datepicker' name='date_from' id='JS_date_from1'> <input type='submit' name='go' value='go'></form></td></tr>";

        print "<tr><td>Mail queue</td><td>" . FormatNumber(GetTableRows("CRMmailqueue"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMmailqueue") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMmailqueue LIMIT 1") . "</td><td><form method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMmailqueue'><input type='text' class='datepicker' name='date_from' id='JS_date_from2'> <input type='submit' name='go' value='go'></form></td></tr>";

        print "<tr><td>Journal</td><td>" . FormatNumber(GetTableRows("CRMjournal"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMjournal") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMjournal LIMIT 1") . "</td><td><form method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMjournal'><input type='text' class='datepicker' name='date_from' id='JS_date_from3'> <input type='submit' name='go' value='go'></form></td></tr>";

        print "<tr><td>Data journal</td><td>" . FormatNumber(GetTableRows("CRMdatajournal"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMdatajournal") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMdatajournal LIMIT 1") . "</td><td><form method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMdatajournal'><input type='text' class='datepicker' name='date_from4' id='JS_date_from'> <input type='submit' name='go' value='go'></form></td></tr>";

        print "<tr><td>Statistics</td><td>" . FormatNumber(GetTableRows("CRMstats"), 0) . "</td><td>" . FormatNumber(GetTableSize("CRMstats") / 1024 / 1024) . "</td><td>" . db_GetValue("SELECT timestamp_last_change FROM CRMstats LIMIT 1") . "</td><td><form method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRMstats'><input type='text' class='datepicker' name='date_from' id='JS_date_from5'> <input type='submit' name='go' value='go'></form></td></tr>";
        */
	$tel = 5;
        foreach ($GLOBALS['UC']['PersonalDataStructure'] as $table => $props) {
            $dbname = $table;
            if ($props['name_in_database'] != '') {
                $dbname = $props['name_in_database'];
            }
            print '<tr><td>'.htme($props['plural']).'</td><td>CRM'.$dbname."</td><td class='num'>".FormatNumber(GetTableRows('CRM'.$dbname), 0)."</td><td class='num'>".FormatNumber(GetTableSize('CRM'.$dbname) / 1024 / 1024).'</td><td>'.db_GetValue('SELECT timestamp_last_change FROM CRM'.$dbname.' ORDER BY timestamp_last_change LIMIT 1')."</td><td><form method='post' action='admin.php?ArchiveLog'><input type='hidden' name='log' value='CRM".$dbname."'><input type='text' class='datepicker' name='date_from' id='JS_date_from" . $tel++ . "'> <input type='submit' name='go' value='go'></form></td></tr>";
        }
	print '</tbody>';
        print '</table>';
    } else {
        if ($date_from == '') {
            PrintAD('Log received but no date. Quitting.');
        } else {
            $date = NLDate2INTLDate(FormattedDateToNLDate($date_from));
            echo '<h1>Archive all from '.$log.' logged before '.$date.'</h1>';
//			exit;
            $file = tempnam(GetSetting("TMP_FILE_PATH"), 'log_archive_');
            echo 'Writing to temp file '.$file.'<br>';
            $filetowriteto = fopen($file, 'w');

            $fields = array();
            $sql = 'EXPLAIN '.$log;
            $qu = '';
            $first_done = false;
            foreach (db_GetArray($sql) as $row2) {
                if (!$first_done) {
                    $first_done = true;
                } else {
                    $qu .= ',';
                }
                $qu .= '`'.$row2['Field'].'`';
                array_push($fields, $row2['Field']);
            }

            $first_done = false;
            $sql = 'SELECT * FROM '.mres($log)." WHERE DATE(timestamp_last_change) < '".mres($date)."'";
            $res = mcq($sql);
            $num = 0;
            /* use mysqli_fetch_array, not db_GetArray, to save memory (will crash) */
            while ($row = mysqli_fetch_array($res)) {
                ++$num;
                $str = 'INSERT INTO '.$log.'('.$qu.') VALUES (';
                foreach ($fields as $field) {
                    if (!$first_done) {
                        $first_done = true;
                    } else {
                        $str .= ', ';
                    }
                    $str .= "'".mres($row[$field])."'";
                }

                $str .= ')';
                fwrite($filetowriteto, $str.";\n");
                //print $str;
                unset($str);
            }

            fclose($filetowriteto);

            $file2 = tempnam(GetSetting("TMP_FILE_PATH"), 'log_archive_compressed_');

            scmd('tar -cvzf '.$file2.' '.$file);

            $fileid = AttachFile(0, $log.'_archive_b4_'.$date.'.tgz', $file2, 'system', 'application/x-tar', '', true, true, false, true);

            $file4 = CopyFileToDisk($fileid);

            if (md5_file($file2) == md5_file($file4)) {
                echo '<br>Exported file from database, extracted, compaired, all ok. ('.$file2.' = '.$file4.')<br>';
                $sql = 'DELETE FROM '.mres($log)." WHERE DATE(timestamp_last_change) < '".mres($date)."'";
                mcq($sql);
                echo '<br>Log cleaned, archiving done.';
            } else {
                echo '<br>'.$file2.' is not equal to '.$file4.'. Not taking any changes. Files on disk deleted, no database changes made.<br>';
            }
            scmd('rm '.$file);
            scmd('rm '.$file2);
            scmd('rm '.$file4);
            echo '<p><a href="admin.php?ArchiveLog">Back to log archive page</a></p>';
        }
    }
}
function GetAlterQueryBasedOnFieldType($ds_fieldname, $ds_tablename, $type, $resulttype = 'auto', $syntax = 'mysql', $name = '')
{
    if ($syntax != 'percona') {
        $syntax = 'mysql';
    }
    //print_r(debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS));


    $table = '';
    if (preg_match("/^t(\d+)$/", $ds_tablename, $match)) {
        //	ft nummer zit nu in match[1]
        $table = 'CRMflextable'.$match[1];
    } else {
        if ($ds_tablename == 'users' || $ds_tablename == 'user') {
            $table = 'CRMloginusers';
        } elseif ($ds_tablename == 'groups' || $ds_tablename == 'group') {
            $table = 'CRMuserprofiles';
        } elseif ($ds_tablename == 'files') {
            $table = 'CRMbinfiles';
        } else {
            $table = 'CRM'.$ds_tablename;
        }
    }

    $fieldnum = 0;
    if (preg_match("/^f(\d+)$/", $ds_fieldname, $match)) {
        //	f nummer zit nu in match[1]
        $fieldnum = $match[1];
    }

    if (ipi($fieldnum) && in_array($type, GetFieldTypes())) {
        $dbto = '';

        $fieldprops = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".$fieldnum."'");
        // Strip any interleave-related tags
        $fieldprops['defaultval'] = preg_replace("/(@|#|\$)([A-Za-z0-9\_\-\|]+)\\1/", '', $fieldprops['defaultval']);

        /* if the default value contains php or interleave tags, don't tell the database */
        if (strstr($fieldprops['defaultval'], '<?')) {
            $fieldprops['defaultval'] = '';
        }
        if (count(get_tags($fieldprops['defaultval'])) >0) {
            $fieldprops['defaultval'] = '';
        }
        switch ($type) {
            case 'Button':
                $dbto = "BIT(1) NOT NULL DEFAULT b'0'";
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;
            case 'date (iso)':
                if ($fieldprops['defaultval'] == '') {
                    $dbto = 'DATE NOT NULL';
                }
                if ($fieldprops['defaultval'] != '') {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                } else {
                    $dbto .= " DEFAULT '0000-00-00'";
                }

            break;
            case 'comment':
                $dbto = "BIT(1) NOT NULL DEFAULT b'0'";
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;
            case 'date':
                $dbto = 'VARCHAR(10) NOT NULL';
                $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;
            case 'numeric':

                $dbformat = 'varchar(21)';
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
                $add_to_default = '';
                if (GetAttribute('extrafield', 'NumericDatabaseField', $fieldnum) == 'Yes') {
                    $decimals = 0;
                    if ((preg_match('/^currency/', $fieldprops['number_format'])) || ($fieldprops['number_format'] == 'normal')) {
                        $decimals = 2;
                    } elseif (preg_match("/^(\d+) decimal/", $fieldprops['number_format'], $match)) {
                        $decimals = $match[1];
                    }

                    if ($decimals == 0) {

                        //afhankelijk van het attribuut MaximumValue zouden we TINYINT, SMALLINT, MEDIUMINT of BIGINT moeten gebruiken
                        $dbformat = 'int(11)';
                    } else {
                        $LengthNatural = GetAttribute('extrafield', 'LengthNatural', $fieldnum);
                        $natlen = 10;
                        if (ipi($LengthNatural)) {
                            $natlen = $LengthNatural;
                        }
                        /* mysql DECIMAL(x,y) : x=TOTAL LENGTH (incuding decimals), y=DECIMAL LENGTH */
                        $natlen += $decimals;

                        //afhankelijk van het attribuut MaximumValue zouden we het DECIMAL formaat groter of kleiner moeten maken
                        $dbformat = 'decimal('.$natlen.','.$decimals.')';
                        $add_to_default = '.'.str_repeat('0', $decimals);
                    }

                    //$dbformat .= " SIGNED";
                }
                $dbto = $dbformat.' NOT NULL';
                if ($fieldprops['defaultval']) {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                } else {
                    if (GetAttribute('extrafield', 'NumericDatabaseField', $fieldnum) == 'Yes') {
                        $dbto .= " DEFAULT '0".$add_to_default."'";
                    } else {
                        $dbto .= " DEFAULT ''";
                    }
                }
            break;
            case 'Reference to FlexTable':

                $dbto = 'int(11) NOT NULL';
                if (is_positive_integer_or_zero($fieldprops['defaultval'])) {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                } else {
                    $dbto .= " DEFAULT '0'";
                }
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;
            case 'date/time':

                $dbto = 'datetime NOT NULL';
                if ($fieldprops['defaultval'] != '') {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                } else {
                    $dbto .= " DEFAULT '0000-00-00 00:00:00'";
                }
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;
            case $type == 'User-list of all CRM-CTT users' || substr($type, 0, 16) == 'Users of profile':
                $dbto = 'int(11) NOT NULL';
                if (is_positive_integer_or_zero($fieldprops['defaultval'])) {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                } else {
                    $dbto .= " DEFAULT '0'";
                }
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;

            case 'List of all groups':
                $dbto = 'int(11) NOT NULL';
                if (is_positive_integer_or_zero($fieldprops['defaultval'])) {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                } else {
                    $dbto .= " DEFAULT '0'";
                }
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
            break;
            case 'checkbox':
                $options = array();
                $options[] = $fieldprops['options'];
                $options[] = $fieldprops['defaultval'];

                if (TableHasField($table, 'EFID'.$fieldnum, false, $fieldprops['defaultval']) != 'no') {
                    $extra = db_GetFlatArray('SELECT EFID'.$fieldnum.' FROM '.$table.' GROUP BY EFID'.$fieldnum);
                    foreach ($extra as $value) {
                        if (!in_array($value, $options)) {
                            $options[] = $value;
                        }
                    }
                }
                //array_walk($options, 'mres');
                $mressedoptions = array();
                foreach ($options as $walk) {
                    $mressedoptions[] = mres($walk);
                }
                $dbto = "enum('".implode("','", $mressedoptions)."') NOT NULL";
                if (GetAttribute('extrafield', 'CheckBoxCheckedByDefault', $fieldnum) == 'Yes') {
                    $dbto .= " DEFAULT '".mres($fieldprops['options'])."'";
                } else {
                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                }
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);

            break;
            case 'drop-down':
                if (substr($fieldprops['options'], 0, 18) == '%POPULATE_BY_CODE%') {
                    // LONGTEXT velden mogen geen default hebben
                    $dbto = 'longtext NOT NULL';
                } else {
                    $options = unserialize($fieldprops['options']);
                    for ($i = 0; $i < count($options); ++$i) {
                        $options[$i] = mres($options[$i]);
                    }
                    /* add "" to beginning of array */
                    array_unshift($options, '');

                    // Check if field already exists, and if so, fetch distinct values
                    if (TableHasField($table, 'EFID'.$fieldnum, false, $fieldprops['defaultval']) != 'no') {
                        $extra = db_GetFlatArray('SELECT EFID'.$fieldnum.' FROM '.$table.' GROUP BY EFID'.$fieldnum);
                        foreach ($extra as $value) {
                            if (!in_array($value, $options)) {
                                $options[] = mres($value);
                            }
                        }
                    }

                    //array_walk($options, 'mres');
                    $dbto = "enum('".implode("','", $options)."') NOT NULL";

                    $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                }
                SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);

            break;
            default:
                if ($type == 'textbox' || $type == 'mail' || $type == 'hyperlink' || $type == 'phone number') {
                    $MaximumLength = GetAttribute('extrafield', 'MaximumLength', $fieldnum);
                    $CurrentMaximum = 0;
                    if ($MaximumLength == '') {
                        if (TableHasField($table, 'EFID'.$fieldnum, false, $fieldprops['defaultval']) != 'no') { // Field exists already
                            //print "SELECT MAX(LENGTH(EFID" . $fieldnum . ")) FROM " . $table;
                            $CurrentMaximum = db_GetValue('SELECT MAX(LENGTH(EFID'.$fieldnum.')) FROM '.$table);
                        }
                        if ($CurrentMaximum > 200) {
                            $dbto = 'longtext NOT NULL';
                            SetAttribute('extrafield', 'MaximumLength', '{{none}}', $fieldnum);
                        } else {
                            SetAttribute('extrafield', 'MaximumLength', '255', $fieldnum);
                            $MaximumLength = 255;
                            $dbto = 'varchar('.$MaximumLength.') NOT NULL';
                            $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                        }
                    } else {
                        if ((TableHasField($table, 'EFID'.$fieldnum, $dbto, $fieldprops['defaultval']) == 'wrongtype' && $resulttype == 'auto') || $resulttype == 'change') {
                            $CurrentMaximum = db_GetValue('SELECT MAX(LENGTH(EFID'.$fieldnum.')) FROM '.$table);
                        }
                        if ($CurrentMaximum > $MaximumLength) {
                            $MaximumLength = $CurrentMaximum;
                        }
                        $dbto = 'varchar('.$MaximumLength.') NOT NULL';
                        $dbto .= " DEFAULT '".mres($fieldprops['defaultval'])."'";
                    }
                } else {
                    if ($type == 'text area') {
                        SetAttribute('extrafield', 'MaximumLength', '{{none}}', $fieldnum);
                    } else {
                        SetAttribute('extrafield', 'MaximumLength', '', $fieldnum);
                    }
                    // LONGTEXT velden mogen geen default hebben
                    $dbto = 'longtext NOT NULL';

                    if ($syntax == 'percona') {
                        /*
                        workaround for percona pt-online-schema-change needing a default even on types which don't accept one

                        [10/03/16 11:35:44] Hidde .: https://www.percona.com/blog/2012/06/21/pt-online-schema-change-and-default-values/
                        [10/03/16 11:44:23] Hidde .: OK dit is weird. pt-o-s-c geeft een fout als je een longtext aanmaakt en GEEN default meegeeft. MySQL geeft een fout als je het WEL doet:

                        alter table CRMflextable1 ADD EFID367 longtext NOT NULL DEFAULT 'hidde test';
                        ERROR 1101 (42000): BLOB/TEXT column 'EFID367' can't have a default value

                        geef je echter DEFAULT '' mee:

                        alter table CRMflextable1 ADD EFID367 longtext NOT NULL DEFAULT '';
                        Query OK, 0 rows affected, 1 warning (49.92 sec)
                        Records: 0  Duplicates: 0  Warnings: 1

                        Warning (Code 1101): BLOB/TEXT column 'EFID367' can't have a default value

                        � dan krijg je dus (terecht) een warning. Gaat dus op beide manieren mis. Maar die error 1364 is OOK een warning. Op 1364 crasht pt-o-s-c, maar op 1101 dus blijkbaar niet (want zo deden we het altijd al). Ik heb dus alle LONGTEXT alters nu een DEFAULT '' gegeven, ook al is dat NIET goed.

                        */

                        $dbto .= " DEFAULT ''";
                    }
                }
            break;
        }
        if ($fieldprops['calculation_type'] == 'calculated on display' && $fieldprops['calculation'] != '') {
            $dbto = "BIT(1) NOT NULL DEFAULT b'0'";
        }
        $sql = '';
        if (TableHasField($table, 'EFID'.$fieldnum, $dbto, $fieldprops['defaultval']) == 'yes' && $resulttype == 'auto') {
            if ($syntax == 'mysql') {
                $sql = 'SELECT 1+1';
            } elseif ($syntax == 'percona') {
                $sql = '';
            }
        } elseif ((TableHasField($table, 'EFID'.$fieldnum, $dbto, $fieldprops['defaultval']) == 'wrongtype' && $resulttype == 'auto') || $resulttype == 'change') {
            if ($syntax == 'mysql') {
                $sql = 'ALTER TABLE '.$table.' CHANGE `EFID'.$fieldnum.'` `EFID'.$fieldnum.'` '.$dbto;
                if ($name != '') {
                    $sql .= " COMMENT '".mres($name)."'";
                }
            } elseif ($syntax == 'percona') {
                $sql = 'PTONLINESCHEMACHANGE '.base64_encode('CHANGE EFID'.$fieldnum.' EFID'.$fieldnum.' '.($dbto).' --execute D=QQQTARGET_DBQQQQ,t='.$table);
            }
        } else {
            if ($syntax == 'mysql') {
                $sql = 'ALTER TABLE '.$table.' ADD `EFID'.$fieldnum.'` '.$dbto;
                if ($name != '') {
                    $sql .= " COMMENT '".mres($name)."'";
                }
            } elseif ($syntax == 'percona') {
                $sql = 'PTONLINESCHEMACHANGE '.base64_encode('ADD EFID'.$fieldnum.' '.($dbto).' --execute D=QQQTARGET_DBQQQQ,t='.$table);
            }
        }

        return $sql;
    } else {
        echo "# GetAlterQueryBasedOnFieldType only for EF's (".$fieldnum.') OR type ('.$type.') wrong';
    }
}
function NormalizeField($field, $action = '')
{
    echo '<h1>Normalize field</h1>';
    if ($action == '') {
        echo '<form name="normalizeform" id="JS_normalizeform" method="post" action="admin.php?nonavbar=1">';
        echo '<p><input type="hidden" name="normalize" id="JS_normalize" value="'.htme($field).'">';
        echo '<select name="action" id="JS_action">';
        echo '<option value="info">Info only</option><option value="new_table">Create a completely new table</option>';
        foreach (db_GetArray('SELECT * FROM CRMextrafields') as $ef) {
            // Check of het een FT veld is
            if (ipi($ef['tabletype'])) {
                echo '<option value="t'.$ef['tabletype'].'-f'.$ef['id'].'">Map to field '.$ef['id'].' ('.htme($ef['name']).') in table '.$ef['tabletype'].' ('.GetFlextableName($ef['tabletype']).')</option>';
            }
        }
        echo '</select>';
        echo ReturnDropDownSearchField('JS_action');
        echo '&nbsp;<input type="submit" name="submit" id="JS_submit" value="Ok"><br><br>When mapping to an existing field, non-existing values will be added to the table!';
        echo '</p></form>';
    } else {
        $ef = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".$field."'");
        echo '<h2>Field '.htme($ef['name']).' of table '.$ef['tabletype'].'</h2>';
        $tablename = '';
        $table_id = 0;
        if (ipi($ef['tabletype'])) {
            $tablename = 'CRMflextable'.$ef['tabletype'];
        } else {
            $tablename = 'CRM'.$ef['tabletype'];
        }

        $sql = 'SELECT EFID'.$ef['id'].' FROM '.$tablename.' GROUP BY EFID'.$ef['id'];
        $options_in_db = db_GetFlatArray($sql);
        $options_in_def = unserialize($ef['options']);
        $options = array_unique(array_merge($options_in_def, $options_in_db));
        echo '<h1>Options</h1><ul>';
        $maxsize = 0;
        foreach ($options as $opt) {
            if (strlen($opt) > $maxsize) {
                $maxsize = strlen($opt);
            }
            echo '<li>'.htme($opt);
            if ($opt == '') {
                echo '"" (empty)';
            }
            if (!in_array($opt, $options_in_def)) {
                echo ' <span class="errmsg">only found in database, not in field definition!</span>';
            }
            echo '</li>';
        }
        echo '</ul>';
        // Check if field is required. If it is, also create an empty record when needed. If not, set these to 0.

        $required_field = false;
        if ($ef['forcing'] == 'y') { // Field IS required
            $required_field = true;
        }

        $map = array();
        $qb4nd = array();

        if ($action == 'info') {
        } elseif ($action == 'new_table') {
            $qb4nd = GetAttribute('system', 'QueriesBeforeNextDeploy', 1);
            if (($ef['fieldtype'] == 'drop-down' || $ef['fieldtype'] == 'checkbox') && ipi($maxsize)) {
                $qb4nd[] = 'ALTER TABLE '.$tablename.' CHANGE `EFID'.$ef['id'].'` `EFID'.$ef['id'].'` VARCHAR('.$maxsize.') NOT NULL;';
            }

            // Create flextable definition
            mcq("INSERT INTO `CRMflextabledefs` (`tablename`, `formid`, `refer_field_layout`, `comment`, `maxrowsperpage`, `addlinktext`, `add_in_popup`, `sort_on`, `sort_direction`, `tableheaderrepeat`, `stayinformaftersave`, `timestamp_last_change`) VALUES('".mres($ef['name'])."', 0, '', '', 100, 'Add ".mres($ef['name'])."', 'y', 0, 'Ascending', 0,'', NOW());");
            $table_id = db_GetInsertId();

            SetAttribute("flextable", "UsePhysicalDelete", "Yes", $table_id, array("No", "Yes"));

            // Create physical table
            mcq('CREATE TABLE CRMflextable'.$table_id." (recordid INT(11) NOT NULL auto_increment, deleted ENUM('n','y') NOT NULL DEFAULT 'n', timestamp_last_change TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (recordid)) ENGINE=InnoDB DEFAULT CHARSET=UTF8");

            // Create field to hold values
            $sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,defaultval,sort,size,showsearchbox,excludefromfilters,number_format) VALUES ('','".mres(trim($ef['name']))."','10','textbox',".$table_id.",'n','','n','','n','y','don\'t format')";
            mcq($sql);
            $created_field = db_GetInsertId();

            // Alter table to create field
            mcq('ALTER TABLE CRMflextable'.$table_id.' ADD `EFID'.$created_field.'` LONGTEXT NOT NULL');

            mcq("UPDATE CRMflextabledefs SET refer_field_layout='@t" . $table_id . "-f".$created_field."@' WHERE recordid=".$table_id);

            // Insert unique values into new flextable

            foreach ($options as $option) {
                if (trim($option) != '' || $required_field) {
                    mcq('INSERT INTO CRMflextable'.$table_id.'(EFID'.$created_field.") VALUES('".mres($option)."')");
                    $map[$option] = db_GetInsertId();
                }
            }
            if (!$required_field) {
                $map[''] = 0;
            }
        } else {
            $qb4nd = GetAttribute('system', 'QueriesBeforeNextDeploy', 1);
            if (($ef['fieldtype'] == 'drop-down' || $ef['fieldtype'] == 'checkbox') && ipi($maxsize)) {
                $qb4nd[] = 'ALTER TABLE '.$tablename.' CHANGE `EFID'.$ef['id'].'` `EFID'.$ef['id'].'` VARCHAR('.$maxsize.') NOT NULL;';
            }

            $t = explode('-', $action);
            $newtablename = 'CRMflextable'.str_replace('t', '', $t[0]);
            $table_id = str_replace('t', '', $t[0]);
            $dstable = $t[0];

            $fieldname = 'EFID'.str_replace('f', '', $t[1]);
            foreach ($options as $option) {
                $sql = 'SELECT recordid FROM '.$newtablename.' WHERE '.$fieldname." ='".mres($option)."'";
                if ($GLOBALS['UC']['PersonalDataStructure'][$dstable]['logical_delete']) {
                    $sql .= " AND deleted='n'";
                }
                $num = db_GetValue($sql);
                if (!ipi($num) && (trim($option) != '' || $required_field)) {
                    // Bestaat niet in die table, toevoegen dus
                    mcq('INSERT INTO '.$newtablename.'('.$fieldname.") VALUES('".mres($option)."')");
                    $map[$option] = db_GetInsertId();
                    echo 'Added option '.htme($option).' to table '.$newtablename.'<br>';
                } else {
                    echo 'Found option '.htme($option).' in table '.$newtablename.' : '.$num.'<br>';
                    $map[$option] = $num;
                }
            }
            if (!$required_field) {
                $map[''] = 0;
            }
        }

        if ($action != 'info') {
            echo '<h1>Mapping table</h1>';
            DA($map);

            $qfnd = GetAttribute('system', 'QueriesForNextDeploy', 1);

            // Update the values in the old field to the corresponding index number DIT MOET IN DE BEFORE!!
            foreach ($map as $oldoption => $newnumber) {
                $sql = 'UPDATE '.$tablename.' SET timestamp_last_change=timestamp_last_change, EFID'.$ef['id']." ='".$newnumber."' WHERE EFID".$ef['id']." = '".mres($oldoption)."';";
                mcq($sql);
                $qb4nd[] = $sql;
            }

            SetAttribute('system', 'QueriesForNextDeploy', $qfnd, 1);
            SetAttribute('system', 'QueriesBeforeNextDeploy', $qb4nd, 1);

            // Change the data type of the field we started with
            mcq("UPDATE CRMextrafields SET fieldtype='Reference to FlexTable', options='".$table_id."' WHERE id='".$ef['id']."'");

            // Make sure write access is not inherited
            SetAttribute('extrafield', 'InheritWriteAccessFromParent', 'No', $ef['id'], array('No', 'Yes'));

            // Change the actual data type
            $sql = 'ALTER TABLE '.$tablename.' CHANGE `EFID'.$ef['id'].'` `EFID'.$ef['id']."` INT(11) NOT NULL DEFAULT '0'";
            mcq($sql);

            // Mark the table as part of the configuration set
            SetAttribute('flextable', 'TableIsPartOfConfiguration', 'Yes', $table_id, array('No', 'Yes'));

            // Generally, these tables don't need file attachments
            SetAttribute('flextable', 'HasFileAttachments', 'No', $table_id, array('No', 'Yes'));

            // Drop datastructure
            AdminChangesDropCache();

            echo 'Done';
        }
    }
}
function find_and_delete_orphaned_files_in_db_and_on_disk($do = false)
{
    MustBeAdmin();
    ini_set('display_errors', 1);
    if (!$do) {
        echo '<p><a href="admin.php?checkfiles=1&amp;do_deletes=1">actually delete these files</a></p>';
    }
    $totalsize = 0;
    $ds = &$GLOBALS['UC']['PersonalDataStructure'];
    $to_delete = array();
    foreach ($ds as $name => $table) {
        $sql = "SELECT `CRMbinfiles`.`fileid` FROM `CRMbinfiles` WHERE `CRMbinfiles`.`type`='".ds_tablename_to_binfiles_table($name)."' AND `CRMbinfiles`.`koppelid` NOT IN (SELECT `CRM".$table['name_in_database'].'`.`'.$table['primary'].'` FROM `CRM'.$table['name_in_database'].'`';
        if ($table['logical_delete']) {
            $sql .= ' WHERE `CRM'.$table['name_in_database']."`.`deleted` ='n'";
        }
        $sql .= ')';
        //print $sql . '<br>';
        $orphaned_files = db_GetFlatArray($sql);
        if (ipi(count($orphaned_files))) {
            echo 'Table '.$name.' has '.count($orphaned_files).' orphaned files. Deleting them.<br>';
            foreach ($orphaned_files as $f) {
                $to_delete[] = $f;
                $totalsize += db_GetValue("SELECT filesize FROM CRMbinfiles WHERE fileid='".$f."'");
            }
        }
    }

    if (ipi(count($to_delete))) {
        $sql = 'DELETE FROM CRMbinfiles WHERE fileid IN ('.implode(',', $to_delete).')';
        if ($do) {
            mcq($sql);
        }
        echo $sql.'<br>';
        $sql = 'DELETE FROM CRMblobs WHERE fileid IN ('.implode(',', $to_delete).')';
        if ($do) {
            mcq($sql);
        }
        echo $sql.'<br>';
        echo '<br>';
    }

    /* loop through offloaded disk files. if deleted from the database, delete them from disk */

    $localpath = GetSetting('OffloadLocalPath');
    $hash = GetSetting('OffLoadedFilesDirectoryHash');
    if ($hash != '') {
        trace($hash);
        $prep = array();
        $path = $localpath.'/'.$hash.'/';
        $list = scandir($path);
        foreach ($list as $possible_fileid) {
            if (ipi($possible_fileid)) {
                $prep[] = $possible_fileid;
            }
        }

        $list_of_valid_files = db_GetFlatArray('SELECT `CRMbinfiles`.`fileid` FROM `CRMbinfiles`');
        foreach ($prep as $diskfileid) {
            if (!in_array($diskfileid, $list_of_valid_files)) {
                echo 'rm '.$path.$diskfileid.'<br>';
                $totalsize += filesize($path.$diskfileid);
                if ($do) {
                    unlink($path.$diskfileid);
                }
            }
        }
    }

    echo 'Total '.round($totalsize / 1024 / 1024, 2).'MB <br>';
}

function create_access_rules_for_fields_in_table($table, $posted_values)
{

    /*
    +-----------------------+------------------------------+------+-----+-------------------+-----------------------------+
    | Field                 | Type                         | Null | Key | Default           | Extra                       |
    +-----------------------+------------------------------+------+-----+-------------------+-----------------------------+
    | id                    | int(11)                      | NO   | PRI | NULL              | auto_increment              |
    | groupid               | int(11)                      | NO   |     | NULL              |                             |
    | field                 | int(11)                      | NO   |     | NULL              |                             |
    | value                 | varchar(300)                 | NO   |     | NULL              |                             |
    | rule                  | enum('readonly','invisible') | NO   |     | invisible         |                             |
    | operand               | enum('IS','IS NOT')          | NO   |     | IS                |                             |
    | timestamp_last_change | timestamp                    | NO   |     | CURRENT_TIMESTAMP | on update CURRENT_TIMESTAMP |
    | only_apply_for_field  | int(11)                      | NO   |     | 0                 |                             |
    +-----------------------+------------------------------+------+-----+-------------------+-----------------------------+
    */
    if (is_array($posted_values['group'])) {
        $ran = 0;
        $arr = $posted_values['field'];
        if (count($arr) == 0) {
            $arr[] = '';
        }
        foreach ($arr as $only_apply_for_field) {
            $only_apply_for_field = str_replace('f', '', $only_apply_for_field);
            foreach ($posted_values['group'] as $group) {
                if ($posted_values['rulefield'] == 'RECORD') {
                    /* a plain field access rule field */
                    $read = 0;
                    $write = 0;
                    if ($posted_values['rule'] == 'readonly') {
                        $read = 1;
                    } elseif ($posted_values['rule'] == 'read + write') {
                        $write = 1;
                        $read = 1;
                    }


                    $sql = "DELETE FROM `CRMfieldaccessrules` WHERE `group` = '".mres($group)."' AND `field`='".mres($only_apply_for_field)."'";
                    mcq($sql);

                    $sql = "INSERT INTO `CRMfieldaccessrules` (`group`, `field`, `read`, `write`) VALUES ('".mres($group)."','".mres($only_apply_for_field)."','".$read."','".$write."')";

                    mcq($sql);
                    ++$ran;

                    $list = db_GetFlatArray("SELECT id FROM CRMuserprofiles WHERE id !='".mres($group)."'");
                    foreach ($list as $gtd) {
                        $cnt = db_GetValue("SELECT COUNT(*) FROM CRMfieldaccessrules WHERE `group` ='".$gtd."' AND `field` = '".mres($only_apply_for_field)."'");
                        if ($cnt == 0) {
                            $sql = "INSERT INTO `CRMfieldaccessrules` (`group`, `field`, `read`, `write`) VALUES ('".mres($gtd)."','".mres($only_apply_for_field)."','0','0')";

                            mcq($sql);
                            ++$ran;
                        }
                    }
                } else {
                    $sql = "INSERT INTO `CRMextendedprivsgroup` (groupid,field,value,rule,operand,only_apply_for_field) VALUES ('".mres($group)."','".mres(str_replace('f', '', $posted_values['rulefield']))."','".mres($posted_values['value'])."','".mres($posted_values['rule'])."','".mres($posted_values['operand'])."','".mres($only_apply_for_field)."')";
    //				print $sql . '<br>';
                    mcq($sql);
                    ++$ran;
                }
            }
        }
        echo '<h1>'.htme($ran).' rules created</h1>';
    } else {
        echo '<h1>Insert set of access rules</h1>';
        echo '<h2>Check groups  [<a onclick="invert_all_boxes_with_class(\'groupboxes\');">invert</a>]</h2>';
        echo '<form name="createrules" method="post" action="">';
        foreach (GetGroups() as $group) {
            echo '<input type="checkbox" class="groupboxes" name="group[]" id="group'.$group['id'].'" value="'.$group['id'].'"><label for="group'.$group['id'].'">'.htme($group['name']).'</label><br>';
        }
        echo '<h2>Check fields to apply rule to [<a onclick="invert_all_boxes_with_class(\'fieldboxes\');">invert</a>]</h2>';
        echo '<div id="fieldboxesdiv">';
        foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'] as $field => $props) {
            if (substr($field, 0, 1) == 'f') {
                echo '<input type="checkbox" class="fieldboxes" name="field[]" id="field'.$field.'" value="'.$field.'"><label for="field'.$field.'">'.$field.' '.htme($props['name']).'</label><br>';
            }
        }
        echo '</div>';
        echo '<h2>Field to base rule on</h2><select name="rulefield" id="JS_rulefield">';
        echo '<option value="RECORD">Complete record: plain access rule for all selected fields</option>';
        foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'] as $field => $props) {
            if (substr($field, 0, 1) == 'f') {
                echo '<option value="'.$field.'">'.$field.' '.$props['name'].'</option>';
            }
        }
        echo '</select> '.ReturnDropDownSearchField('JS_rulefield');
        echo '<h2>Operand</h2><select name="operand"><option>IS</option><option>IS NOT</option></select>';
        echo '<h2>Value</h2>';
        echo '<input type="text" size="20" name="value">';
        echo '<h2>Rule</h2><select name="rule"><option>readonly</option><option>read + write</option><option>invisible</option></select>';
        echo '<br><br><input type="submit" name="subm" value="Create rules" class="addbutton">';
        echo '</form>';
    }
}

function convert_diary_to_flextable($efid)
{
    global $lang;
    /*
        deze functie moet een willekeurige diary field kunnen omzetten naar een flextable met alles er op en er aan.
    */
    $ef = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".$efid."'");

    // Create flextable definition
    $sql = "INSERT INTO `CRMflextabledefs` (`tablename`, `formid`, `refer_field_layout`, `comment`, `maxrowsperpage`, `headerhtml`, `addlinktext`, `add_in_popup`, `sort_on`, `sort_direction`, `tableheaderrepeat`, `stayinformaftersave`, `timestamp_last_change`) VALUES('".mres($ef['name'])."', 0, '', '', 100, '', 'Add ".mres($ef['name'])."', 'y', '', 'Ascending', 0,'', NOW())";
    mcq($sql);
    echo $sql.'<br>';
    $table_id = db_GetInsertId();

    // Create physical table
    $sql = 'CREATE TABLE CRMflextable'.$table_id." (recordid INT(11) NOT NULL auto_increment, deleted ENUM('n','y') NOT NULL DEFAULT 'n', timestamp_last_change TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, PRIMARY KEY (recordid)) ENGINE=InnoDB DEFAULT CHARSET=UTF8";
    echo $sql.'<br>';
    mcq($sql);

    // Create fields to hold values
    $sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,defaultval,sort,size,showsearchbox,excludefromfilters,number_format) VALUES ('".$ef['tabletype']."','".mres($GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef['tabletype'])]['plural'])."','10','Reference to FlexTable',".$table_id.",'n','','n','','n','y','don\'t format')";
    echo $sql.'<br>';
    mcq($sql);
    $ref = db_GetInsertId();

    // Create fields to hold values
    $sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,defaultval,sort,size,showsearchbox,excludefromfilters,number_format) VALUES ('','".mres($lang['user'])."','10','User-list of all CRM-CTT users',".$table_id.",'n','@USERID@','n','','n','y','don\'t format')";
    echo $sql.'<br>';
    mcq($sql);
    $user = db_GetInsertId();
    foreach (GetGroups() as $g) {
        if ($g['id'] > 0) {
            $sql = "INSERT INTO CRMfieldaccessrules(`field`, `group`, `read`, `write`) VALUES('".$user."', '".$g['id']."', '1', '0')";
            echo $sql.'<br>';
            mcq($sql);
        }
    }

    $sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,defaultval,sort,size,showsearchbox,excludefromfilters,number_format) VALUES ('','".mres($lang['date'])."','10','date/time',".$table_id.",'n','','n','','n','y','don\'t format')";
    echo $sql.'<br>';
    mcq($sql);
    $timestamp = db_GetInsertId();

    $calculation = "IF ((@table_alias@.EFID".$timestamp."='0000-00-00 00:00:00'), NOW(), @table_alias@.EFID".$timestamp.")";

    $sql = "UPDATE CRMextrafields SET calculation = '".mres($calculation)."' WHERE id=".$timestamp;
    echo $sql.'<br>';
    mcq($sql);

    /* recreate triggers */
    $triggers = return_mysql_trigger_queries();
    foreach ($triggers as $sql) {
        mcq($sql);
    }

    $sql = "INSERT INTO CRMextrafields(options,name,ordering,fieldtype,tabletype,forcing,defaultval,sort,size,showsearchbox,excludefromfilters,number_format) VALUES ('60:4:n','".mres($lang['remarks'])."','10','text area',".$table_id.",'n','','n','','n','y','don\'t format')";
    echo $sql.'<br>';
    mcq($sql);
    $comments = db_GetInsertId();

    // Alter table to create field
    mcq('ALTER TABLE CRMflextable'.$table_id.' ADD `EFID'.$ref."` INT(11) NOT NULL DEFAULT '0'");
    mcq('ALTER TABLE CRMflextable'.$table_id.' ADD `EFID'.$user."` INT(11) NOT NULL DEFAULT '0'");
    mcq('ALTER TABLE CRMflextable'.$table_id.' ADD `EFID'.$timestamp."` datetime NOT NULL DEFAULT '0000-00-00 00:00:00'");
    mcq('ALTER TABLE CRMflextable'.$table_id.' ADD `EFID'.$comments."` LONGTEXT NOT NULL DEFAULT ''");
    mcq("UPDATE CRMflextabledefs SET refer_field_layout='@t" . $table_id . "-f".$timestamp."@' WHERE recordid=".$table_id);

    SetAttribute('flextable', 'IncludeInSystemWideSearches', 'Yes', $table_id, array('Yes', 'No'));
    SetAttribute('flextable', 'HasFileAttachments', 'No', $table_id, array('Yes', 'No'));
    SetAttribute('flextable', 'AddRowEnabledOnSublistsOnAutoForms', 'Yes', $table_id, array('No', 'Yes'));
    SetAttribute('flextable', 'AddRowEnabledOnSublistsOnAutoForms', 'Yes', $table_id, array('No', 'Yes'));
    SetAttribute("flextable", "UsePhysicalDelete", "Yes", $table_id, array("No", "Yes"));

    /* insert values */
    $table = 'flextable'.$ef['tabletype'];
    $sql = "SELECT ".mres($GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef['tabletype'])]['primary']).', EFID'.$efid.' FROM CRM'.$table;

    if ($GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef['tabletype'])]['logical_delete']) {
        $sql .= " WHERE deleted='n'";
    }
    $res = mcq($sql);
    while ($a = mysqli_fetch_array($res)) {
        $b = unserialize($a['EFID'.$efid]);
        foreach ($b as $row) {
            $sql = 'INSERT INTO CRMflextable'.$table_id.' (EFID'.$ref.',EFID'.$user.',EFID'.$timestamp.',EFID'.$comments.") VALUES('".$a[$GLOBALS['UC']['PersonalDataStructure'][ef_tabletype_to_ds_tablename($ef['tabletype'])]['primary']]."','".mres($row[1])."','".mres(date('Y-m-d H:i:s', $row[0]))."','".mres($row[2])."')";
            mcq($sql);
            echo $sql.'<br>';
        }
    }

    /* compose list tag */
    $tag = '#LIST|table=t'.$table_id.'|type_of_list=sublist|hiddenfilter_t'.$table_id.'-f'.$ref.'=@t' . $ef['tabletype'] . '-recordid@|hide_all=1|sortby=t'.$table_id.'-recordid|sortdirection=desc|perpage=10|hide_addrow=0|listlayoutcolumns=t'.$table_id.'-f'.$timestamp.',t'.$table_id.'-f'.$user.',t'.$table_id.'-f'.$comments.'#';

    $sql = "UPDATE CRMtemplates SET content = REPLACE(content, '#EFID".$efid."#', '".mres($tag)."')";
    echo $sql.'<br>';
    mcq($sql);

    $sql = "UPDATE CRMtemplates SET content = REPLACE(content, '#".ef_tabletype_to_ds_tablename($ef['tabletype']).'-f'.$efid."#', '".mres($tag)."')";
    echo $sql.'<br>';
    mcq($sql);

    AdminChangesDropCache();

    echo '<h1>'.$tag.'</h1>';
}
function CheckAndSetAttributes($eftable_fieldnum, $eftable_fieldtype, $is_new = false)
{
    if ($eftable_fieldtype == 'Button') {
        $ButtonClickConfirmMessage = GetAttribute('extrafield', 'ButtonClickConfirmMessage', $eftable_fieldnum);
        if ($ButtonClickConfirmMessage == '') {
            SetAttribute('extrafield', 'ButtonClickConfirmMessage', '{{none}}', $eftable_fieldnum);
        }
        $BackToListAfterSave = GetAttribute('extrafield', 'BackToListAfterSave', $eftable_fieldnum);
        if ($BackToListAfterSave == '') {
            SetAttribute('extrafield', 'BackToListAfterSave', '{{default}}', $eftable_fieldnum, array('{{default}}', 'No', 'Yes'));
        }
        $FieldsOnFormWhichMustHaveAValueCSV = GetAttribute('extrafield', 'FieldsOnFormWhichMustHaveAValueCSV', $eftable_fieldnum);
        if ($FieldsOnFormWhichMustHaveAValueCSV == '') {
            SetAttribute('extrafield', 'FieldsOnFormWhichMustHaveAValueCSV', '{{none}}', $eftable_fieldnum);
        }
        $NotAllRequiredFieldsAreEnteredMessage = GetAttribute('extrafield', 'NotAllRequiredFieldsAreEnteredMessage', $eftable_fieldnum);
        if ($NotAllRequiredFieldsAreEnteredMessage == '') {
            SetAttribute('extrafield', 'NotAllRequiredFieldsAreEnteredMessage', 'To use this button you must enter the highlighted fields.', $eftable_fieldnum);
        }
        $JavascriptActionAfterSubmit = GetAttribute('extrafield', 'JavascriptActionAfterSubmit', $eftable_fieldnum);
        if ($JavascriptActionAfterSubmit == '') {
            SetAttribute('extrafield', 'JavascriptActionAfterSubmit', '{{none}}', $eftable_fieldnum);
        }
        $FieldsToAskInJSPopupCSV = GetAttribute('extrafield', 'FieldsToAskInJSPopupCSV', $eftable_fieldnum);
        if ($FieldsToAskInJSPopupCSV == '') {
            SetAttribute('extrafield', 'FieldsToAskInJSPopupCSV', '{{none}}', $eftable_fieldnum);
        }
    } else {
        SetAttribute('extrafield', 'ButtonClickConfirmMessage', '', $eftable_fieldnum);
    }
    $ChangeAlertMessage = GetAttribute('extrafield', 'ChangeAlertMessage', $eftable_fieldnum);
    if ($ChangeAlertMessage == '') {
        SetAttribute('extrafield', 'ChangeAlertMessage', '{{none}}', $eftable_fieldnum);
    }

    if ($eftable_fieldtype == 'date' || $eftable_fieldtype == 'date/time' || $eftable_fieldtype == 'date (iso)') {
        $UsePlanningCalendar = GetAttribute('extrafield', 'UsePlanningCalendar', $eftable_fieldnum);
        if ($UsePlanningCalendar == '') {
            SetAttribute('extrafield', 'UsePlanningCalendar', 'No', $eftable_fieldnum, array('No', 'Yes'));
        }
        $UsePlanningCalendarMatchOnFields = GetAttribute('extrafield', 'UsePlanningCalendarMatchOnFields', $eftable_fieldnum);
        if ($UsePlanningCalendarMatchOnFields == '') {
            SetAttribute('extrafield', 'UsePlanningCalendarMatchOnFields', '{{none}}', $eftable_fieldnum);
        }
        $UsePlanningCalendarColor = GetAttribute('extrafield', 'UsePlanningCalendarColor', $eftable_fieldnum);
        if ($UsePlanningCalendarColor == '') {
            SetAttribute('extrafield', 'UsePlanningCalendarColor', '{{none}}', $eftable_fieldnum);
        }
        $UsePlanningCalendarDescription = GetAttribute('extrafield', 'UsePlanningCalendarDescription', $eftable_fieldnum);
        if ($UsePlanningCalendarDescription == '') {
            SetAttribute('extrafield', 'UsePlanningCalendarDescription', '{{none}}', $eftable_fieldnum);
        }
        $UsePlanningCalendarView = GetAttribute('extrafield', 'UsePlanningCalendarView', $eftable_fieldnum);
        if ($UsePlanningCalendarView == '') {
            SetAttribute('extrafield', 'UsePlanningCalendarView', 'Month', $eftable_fieldnum, array('Month', 'Week'));
        }
        $UsePlanningCalendarTitleText = GetAttribute('extrafield', 'UsePlanningCalendarTitleText', $eftable_fieldnum);
        if ($UsePlanningCalendarTitleText == '') {
            SetAttribute('extrafield', 'UsePlanningCalendarTitleText', '{{none}}', $eftable_fieldnum);
        }
    }
    if ($eftable_fieldtype == 'date' || $eftable_fieldtype == 'date/time') {
        $ShowFromToFieldsInListFilters = GetAttribute('extrafield', 'ShowFromToFieldsInListFilters', $eftable_fieldnum);
        if ($ShowFromToFieldsInListFilters == '') {
            SetAttribute('extrafield', 'ShowFromToFieldsInListFilters', 'No', $eftable_fieldnum, array('No', 'Yes'));
        }
    }
    if ($eftable_fieldtype == 'date/time') {
        $ShowSeconds = GetAttribute('extrafield', 'ShowSeconds', $eftable_fieldnum);
        if ($ShowSeconds == '') {
            SetAttribute('extrafield', 'ShowSeconds', 'No', $eftable_fieldnum, array('No', 'Yes'));
        }
    }

    if ($eftable_fieldtype == 'textbox' || $eftable_fieldtype == 'numeric' || $eftable_fieldtype == 'mail' || $eftable_fieldtype == 'hyperlink' || $eftable_fieldtype == 'checkbox' || $eftable_fieldtype == 'date' || $eftable_fieldtype == 'date/time') {
        $Placeholder = GetAttribute('extrafield', 'Placeholder', $eftable_fieldnum);

        if ($Placeholder == '') {
            SetAttribute('extrafield', 'Placeholder', '{{none}}', $eftable_fieldnum);
        }
    }
    if ($_REQUEST['newtype'] == 'drop-down (populate by code)') {
        $RepopulateByAjax = GetAttribute('extrafield', 'RepopulateByAjax', $eftable_fieldnum);
        if ($RepopulateByAjax == '') {
            SetAttribute('extrafield', 'RepopulateByAjax', 'Yes', $eftable_fieldnum, array('Yes', 'No'));
        }
    }
    if ($_REQUEST['newtype'] == 'checkbox') {
        $CheckBoxCheckedByDefault = GetAttribute('extrafield', 'CheckBoxCheckedByDefault', $eftable_fieldnum);
        if ($CheckBoxCheckedByDefault == '') {
            SetAttribute('extrafield', 'CheckBoxCheckedByDefault', 'No', $eftable_fieldnum, array('No', 'Yes'));
        }
    }
    //if ($_REQUEST['newtype'] == "comment") {
        $RefreshByAjaxOnChangeOfField = GetAttribute('extrafield', 'RefreshByAjaxOnChangeOfField', $eftable_fieldnum);
    if ($RefreshByAjaxOnChangeOfField == '') {
        SetAttribute('extrafield', 'RefreshByAjaxOnChangeOfField', 'No', $eftable_fieldnum);
    }
    //}

    if ($_REQUEST['newtype'] == 'diary') {
        $AutoUpdateDiaryField = GetAttribute('extrafield', 'AutoUpdateDiaryField', $eftable_fieldnum);
        if ($AutoUpdateDiaryField == '') {
            SetAttribute('extrafield', 'AutoUpdateDiaryField', 'Yes', $eftable_fieldnum, array('Yes', 'No'));
        }
    }

    if ($eftable_fieldtype == 'numeric') {
        $MaximumValue = GetAttribute('extrafield', 'MaximumValue', $eftable_fieldnum);
        if ($MaximumValue == '') {
            SetAttribute('extrafield', 'MaximumValue', '{{none}}', $eftable_fieldnum);
        }

        $MinimumValue = GetAttribute('extrafield', 'MinimumValue', $eftable_fieldnum);
        if ($MinimumValue == '') {
            SetAttribute('extrafield', 'MinimumValue', '{{none}}', $eftable_fieldnum);
        }
        $LengthNatural = GetAttribute('extrafield', 'LengthNatural', $eftable_fieldnum);
        if ($LengthNatural == '') {
            SetAttribute('extrafield', 'LengthNatural', '10', $eftable_fieldnum);
        }
        $NumericDatabaseField = GetAttribute('extrafield', 'NumericDatabaseField', $eftable_fieldnum);
        if ($NumericDatabaseField == '') {
            if ($is_new) {
                SetAttribute('extrafield', 'NumericDatabaseField', 'Yes', $eftable_fieldnum, array('Yes', 'No'));
            } else {
                SetAttribute('extrafield', 'NumericDatabaseField', 'No', $eftable_fieldnum, array('Yes', 'No'));
            }
        }
    }
    $ShowFieldHistory = GetAttribute('extrafield', 'ShowFieldHistory', $eftable_fieldnum);
    if ($ShowFieldHistory == '') {
        SetAttribute('extrafield', 'ShowFieldHistory', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }

    $CustomValidationFunctionPHP = GetAttribute('extrafield', 'CustomValidationFunctionPHP', $eftable_fieldnum);
    if ($CustomValidationFunctionPHP == '') {
        SetAttribute('extrafield', 'CustomValidationFunctionPHP', '{{none}}', $eftable_fieldnum);
    }

    $IgnoreCellClick = GetAttribute('extrafield', 'IgnoreCellClick', $eftable_fieldnum);
    if ($IgnoreCellClick == '') {
        SetAttribute('extrafield', 'IgnoreCellClick', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }

    $Interactive = GetAttribute('extrafield', 'Interactive', $eftable_fieldnum);
    if ($Interactive == '') {
        SetAttribute('extrafield', 'Interactive', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }
    $InteractiveAlwaysInline = GetAttribute('extrafield', 'InteractiveAlwaysInline', $eftable_fieldnum);
    if ($InteractiveAlwaysInline == '') {
        SetAttribute('extrafield', 'InteractiveAlwaysInline', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }
    $InteractiveDontReloadListOnChange = GetAttribute('extrafield', 'InteractiveDontReloadListOnChange', $eftable_fieldnum);
    if ($InteractiveDontReloadListOnChange == '') {
        SetAttribute('extrafield', 'InteractiveDontReloadListOnChange', 'No', $eftable_fieldnum, array('Yes', 'No'));
    }
    $FormComment = GetAttribute('extrafield', 'FormComment', $eftable_fieldnum);
    if ($FormComment == '') {
        SetAttribute('extrafield', 'FormComment', '{{none}}', $eftable_fieldnum);
    }
    $FieldGroupName = GetAttribute('extrafield', 'FieldGroupName', $eftable_fieldnum);
    if ($FieldGroupName == '') {
        SetAttribute('extrafield', 'FieldGroupName', '{{none}}', $eftable_fieldnum);
    }

    $AddIdentifierClass = GetAttribute('extrafield', 'AddIdentifierClass', $eftable_fieldnum);
    if ($AddIdentifierClass == '') {
        SetAttribute('extrafield', 'AddIdentifierClass', '{{none}}', $eftable_fieldnum, array('No', 'Yes'));
    }
    $DisableAutoSave = GetAttribute('extrafield', 'DisableAutoSave', $eftable_fieldnum);
    if ($DisableAutoSave == '') {
        SetAttribute('extrafield', 'DisableAutoSave', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }
    $AutoSizeOnInput = GetAttribute('extrafield', 'AutoSizeOnInput', $eftable_fieldnum);
    if ($AutoSizeOnInput == '') {
        SetAttribute('extrafield', 'AutoSizeOnInput', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }

    $AlwaysRecalculateWhenNightlyCronIsRan = GetAttribute('extrafield', 'AlwaysRecalculateWhenNightlyCronIsRan', $eftable_fieldnum);
    if ($AlwaysRecalculateWhenNightlyCronIsRan == '') {
        SetAttribute('extrafield', 'AlwaysRecalculateWhenNightlyCronIsRan', 'No', $eftable_fieldnum, array('No', 'Yes'));
        $AlwaysRecalculateWhenNightlyCronIsRan = 'No';
    }
    $value = 'No';
    $force_set = false;
    $ExcludeFromSearches = GetAttribute('extrafield', 'ExcludeFromSearches', $eftable_fieldnum);

    if (db_GetValue("SELECT 1 FROM CRMextrafields WHERE id='" .$eftable_fieldnum . "' AND calculation !=''") == 1) {
        /* ok, this is a calculation. we never search through calcs */
        $value = 'Yes';
        if ($ExcludeFromSearches == 'No') {
            $force_set = true;
        }
    } elseif ($ExcludeFromSearches == 'Yes') {
        print '<span class="warnmsg">This field is excluded from searches!</span>';
    }

    if ($ExcludeFromSearches == '' || $force_set) {
        SetAttribute('extrafield', 'ExcludeFromSearches', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }

    $PerFieldSearchEnable = GetAttribute('extrafield', 'PerFieldSearchEnable', $eftable_fieldnum);
    if ($PerFieldSearchEnable == '') {
        SetAttribute('extrafield', 'PerFieldSearchEnable', 'No', $eftable_fieldnum, array('No', 'Yes'));
    }

    $allowed_to_change_once_set = GetAttribute('extrafield', 'allowed_to_change_once_set', $eftable_fieldnum);
    if ($allowed_to_change_once_set == '') {
        SetAttribute('extrafield', 'allowed_to_change_once_set', 'Yes', $eftable_fieldnum, array('Yes', 'No'));
    }

    if ($eftable_fieldtype == 'Reference to FlexTable' || $eftable_fieldtype == 'Reference to FlexTable (multiselect)' || $eftable_fieldtype == 'User-list of all CRM-CTT users' || substr($eftable_fieldtype, 0, 8) == 'Users of') {
        if ($eftable_fieldtype == 'Reference to FlexTable' || $eftable_fieldtype == 'Reference to FlexTable (multiselect)') {
            $UseThisFieldForAccessRestriction = GetAttribute('extrafield', 'UseThisFieldForAccessRestriction', $eftable_fieldnum);
            if ($UseThisFieldForAccessRestriction == '') {
                SetAttribute('extrafield', 'UseThisFieldForAccessRestriction', 'No', $eftable_fieldnum, array('No', 'Read access', 'Write access'));
            }
        }
        $InheritWriteAccessFromParent = GetAttribute('extrafield', 'InheritWriteAccessFromParent', $eftable_fieldnum);
        if ($InheritWriteAccessFromParent == '') {
            SetAttribute('extrafield', 'InheritWriteAccessFromParent', 'Yes', $eftable_fieldnum, array('Yes', 'No'));
        }

        $ExtraSelectCondition = GetAttribute('extrafield', 'ExtraSelectCondition', $eftable_fieldnum);
        if ($ExtraSelectCondition == '') {
            SetAttribute('extrafield', 'ExtraSelectCondition', '{{none}}', $eftable_fieldnum);
        }

        $ListOptionsForChildTable = GetAttribute('extrafield', 'ListOptionsForChildTable', $eftable_fieldnum);
        if ($ListOptionsForChildTable == '') {
            SetAttribute('extrafield', 'ListOptionsForChildTable', '{{none}}', $eftable_fieldnum);
        }

        if ($eftable_fieldtype == 'Reference to FlexTable' || $eftable_fieldtype == 'Reference to FlexTable (multiselect)') {
            $InlineAddIconURLExtras = GetAttribute('extrafield', 'InlineAddIconURLExtras', $eftable_fieldnum);
            if ($InlineAddIconURLExtras == '') {
                SetAttribute('extrafield', 'InlineAddIconURLExtras', '{{none}}', $eftable_fieldnum);
            }
            $BlindReferenceFieldLayout = GetAttribute('extrafield', 'BlindReferenceFieldLayout', $eftable_fieldnum);
            if ($BlindReferenceFieldLayout == '') {
                SetAttribute('extrafield', 'BlindReferenceFieldLayout', '{{none}}', $eftable_fieldnum);
            }
        }
    }
}
function FQNhasNewName($rulesmap)
{
    //use this function if you have moved a field (to another table) and you want to keep all set filters and selections users have made

/*
    EXAMPLE
    $rulesmap = array();
    $rulesmap["t1-f3"] = "t1-f90";
*/

//                print '<h1>translate list layouts...</h1>';
  foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'List-layout-%'") as $attribute) {
      $fold = unserialize($attribute['value']);
      $fnew = array();
      foreach ($fold as $f) {
          foreach ($rulesmap as $old => $new) {
              $f = preg_replace("/\b$old\b/", $new, $f);
          }
          $fnew[] = $f;
      }
      if ($fnew != $fold) {
          echo '<h2>old</h2>';
          pre($fold);
          echo '<h2>new</h2>';
          pre($fnew);
          SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
      }
  }

//		print '<h1>translate last views...</h1>';
                foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'List-lastview-%'") as $attribute) {
                    $fold = unserialize($attribute['value']);
                    $fnew = $fold;
                    foreach (array('searchperfield', 'filter', 'filtertype') as $field) {
                        $newvars = array();
                        foreach ($fnew[$field] as $key => $val) {
                            foreach ($rulesmap as $old => $new) {
                                $key = preg_replace("/\b$old\b/", $new, $key);
                            }
                            $newvars[$key] = $val;
                        }
                        $fnew[$field] = $newvars;
                    }
                    foreach ($rulesmap as $old => $new) {
                        $fnew['sortby'] = preg_replace("/\b$old\b/", $new, $fnew['sortby']);
                    }
                    if ($fnew != $fold) {
                        /*			    print '<h2>old</h2>';
        	            pre($fold);
                            print '<h2>new</h2>';
                            pre($fnew);*/
                SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
                    }
                }

//	print '<h1>translate selections...</h1>';
    foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'SelectionNew%'") as $attribute) {
        $fold = unserialize($attribute['value']);
        $fnew = $fold;
        foreach ($fnew as $name => $vars) {
            foreach (array('searchperfield', 'filter', 'filtertype') as $field) {
                $newvars = array();
                foreach ($vars[$field] as $key => $val) {
                    foreach ($rulesmap as $old => $new) {
                        $key = preg_replace("/\b$old\b/", $new, $key);
                    }
                    $newvars[$key] = $val;
                }
                $fnew[$name][$field] = $newvars;
            }
        }
        if ($fnew != $fold) {
            /*			print '<h2>old</h2>';
            pre($fold);
                        print '<h2>new</h2>';
                        pre($fnew);*/
            SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
        }
    }
}

function FieldHasNewValue($field_to_translate, $translate)
{
    //use this function when a field has a new value and you want to keep filters and saved selections of users available
    //especially useful when a dropdown is normalized

/*
    EXAMPLE
    $field_to_translate = "f123";
    $translate = array();
    $translate["Open"] = 1;
    $translate["In progress"] = 4;
    $translate["Closed"] = 7;
*/

    echo '<h1>last view</h1>';
    foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'List-lastview-%'") as $attribute) {
        $fold = unserialize($attribute['value']);
        $fnew = $fold;
        foreach (array('searchperfield', 'filter') as $field) {
            $newvars = array();
            foreach ($fnew[$field] as $key => $val) {
                if (preg_match("/\-".$field_to_translate.'$/', $key)) {
                    foreach ($val as $item) {
                        if ($translate[$item] != '') {
                            echo 'translate '.$field.' FROM '.$item.' TO '.$translate[$item].'<br>';
                            $item = $translate[$item];
                        }
                        $newvars[$key][] = $item;
                    }
                } else {
                    $newvars[$key] = $val;
                }
            }
            $fnew[$field] = $newvars;
        }
        if ($fnew != $fold) {
            /*						print '<h2>old</h2>';
            pre($fold);
            print '<h2>new</h2>';
            pre($fnew);*/
            SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
        }
    }

    echo '<h1>selection</h1>';
    foreach (db_GetArray("select * from CRMattributes WHERE attribute like 'SelectionNew%'") as $attribute) {
        $fold = unserialize($attribute['value']);
        $fnew = $fold;
        foreach ($fnew as $name => $vars) {
            foreach (array('searchperfield', 'filter') as $field) {
                $newvars = array();
                foreach ($vars[$field] as $key => $val) {
                    if (preg_match("/\-".$field_to_translate.'$/', $key)) {
                        foreach ($val as $item) {
                            if ($translate[$item] != '') {
                                echo 'translate '.$field.' FROM '.$item.' TO '.$translate[$item].'<br>';
                                $item = $translate[$item];
                            }
                            $newvars[$key][] = $item;
                        }
                    } else {
                        $newvars[$key] = $val;
                    }
                }
                $fnew[$name][$field] = $newvars;
            }
        }
        if ($fnew != $fold) {
            /*						print '<h2>old</h2>';
            pre($fold);
            print '<h2>new</h2>';
            pre($fnew);*/
            SetAttribute($attribute['identifier'], $attribute['attribute'], $fnew, $attribute['entity']);
        }
    }
}

function FindMissingReferences()
{
    //we werken met de SystemDataStructure
        $SystemDataStructure = GetSystemDataStructure();

    $total_missing_references = 0;

    $ret = '';

    foreach (array_keys($SystemDataStructure) as $table) {
        foreach (array_keys($SystemDataStructure[$table]['parents']) as $parent_table) {
            foreach ($SystemDataStructure[$table]['parents'][$parent_table] as $field) {
                $table_db = $SystemDataStructure[$table]['name_in_database'];
                $field_db = $SystemDataStructure[$table]['fields'][$field]['name_in_database'];

                $parent_table_db = $SystemDataStructure[$parent_table]['name_in_database'];
                $parent_field = $SystemDataStructure[$parent_table]['primary'];
                $parent_field_db = $SystemDataStructure[$parent_table]['fields'][$parent_field]['name_in_database'];

                $primary_field = $SystemDataStructure[$table]['primary'];
                                //niet nodig; deze is altijd gelijk aan primary_field; geen andere name in database
                                $primary_field_db = $SystemDataStructure[$table]['fields'][$primary_field]['name_in_database'];

                $selects = array();
                $wheres = array();
                $ors = array();

                $selects[] = '`child`.`'.$primary_field_db.'`';
                $selects[] = '`child`.`'.$field_db.'`';

                                //niet gezette referenties zijn toegestaan; VOOR STRIKTERE CHECK DEZE CONDITIE WEGHALEN
                                //velden die niet verplicht zijn mogen 0 zijn
                                //TODO geen ondersteuning voor conditional requirement
                                if (!$SystemDataStructure[$table]['fields'][$field]['required']) {
                                    $wheres[] = '`child`.`'.$field_db.'`>0';
                                }

                                //we negeren deleted flextable records; eigenlijk zouden de referenties van deze records net zo goed moeten kloppen; VOOR STRIKTERE CHECK DEZE CONDITIE WEGHALEN
                                if ((preg_match("/^t\d+$/", $table)) && ($GLOBALS['UC']['PersonalDataStructure'][$table]["logical_delete"])) {
                                    $wheres[] = "`child`.`deleted`='n'";
                                }

                $ors[] = '`parent`.`'.$parent_field_db.'` IS NULL';
                if ((preg_match("/^t\d+$/", $parent_table)) && ($GLOBALS['UC']['PersonalDataStructure'][$parent_table]["logical_delete"])) {
                    //als dit record verwijst naar een logisch gedelete parent record dan melden we het ook alszijnde een missende referentie (uit applicatie oogpunt IS dat namelijk ook zo)
                                        $selects[] = '`parent`.`deleted`';
                    $ors[] = "`parent`.`deleted`='y'";
                }

                $wheres[] = '('.implode(' OR ', $ors).')';

                $query = 'SELECT '.implode(', ', $selects).' FROM `CRM'.$table_db.'` `child` LEFT JOIN `CRM'.$parent_table_db.'` `parent` ON `parent`.`'.$parent_field_db.'`=`child`.`'.$field_db.'`';
                if (count($wheres) > 0) {
                    $query .= ' WHERE '.implode(' AND ', $wheres);
                }
                $query .= ' ORDER BY `child`.`'.$primary_field_db.'`';

                $records = db_GetArray($query);
                $total_missing_references += count($records);
                if (count($records) > 0) {
                    $ret .= '<h1>Missing references from child '.htme($SystemDataStructure[$table]['singular']).' ('.$table.') to parent '.htme($SystemDataStructure[$parent_table]['singular']).' ('.$parent_table.') via field '.htme($SystemDataStructure[$table]['fields'][$field]['name']).' ('.$field_db.')</h1>'."\n";
                    $ret .= '<pre>'.$query.'</pre>'."\n";
                    $ret .= '<ol>';
                    $ids = array();
                    foreach ($records as $record) {
                        $ret .= '<li>'.$record[$primary_field_db].' - ';
                        if ($record[$field_db] == 0) {
                            $ret .= 'empty required field';
                            $ids['empty required field'][] = $record[$primary_field_db];
                        } elseif ($record['deleted'] == 'y') { //only if logical_delete is true
                            $ret .= '<span class="errmsg">parent '.$record[$field_db].' is logically deleted</span>';
                            $ids['logically deleted'][] = $record[$primary_field_db];
                        } else {
                            $ret .= '<span class="errmsg">parent '.$record[$field_db].' does not exist</span>';
                            $ids['does not exist'][] = $record[$primary_field_db];
                        }
                        $ret .= '</li>'."\n";
                    }
                    $ret .= '</ol>';

                    foreach (array_keys($ids) as $key) {
                        $fixquery = 'UPDATE `CRM'.$table_db.'` SET `timestamp_last_change`=`timestamp_last_change`, `'.$field_db.'`=[FILL IN VALUE] WHERE `'.$primary_field_db.'` IN ('.implode(', ', $ids[$key]).');';
                        $ret .= '<div><strong>sql fix for '.$key.' BE CAREFUL:</strong></div><div>'.htme($fixquery).'</div>'."\n";
                    }
                }
            }
        }
    }

    $ret .= '<h1>Total missing references: '.$total_missing_references.'</h1>';

    return $ret;
}

function search_all_admin_tables($search, $whole_word_only = false)
{
    $hits = array();
    if ($search != '') {
        foreach (db_GetFlatArray('SHOW TABLES') as $table) {
            //MOET met CRM beginnen om custom tabellen (zoals postcodeafstand) te excluden
                        if ((preg_match('/^CRM/', $table)) && (!preg_match("/^CRMflextable\d+/", $table)) && ($table != 'CRMbinfiles') && ($table != 'CRMblobs') && ($table != 'CRMcache') && ($table != 'CRMjournal') && ($table != 'CRMdatajournal') && ($table != 'CRMuselog') && ($table != 'CRMinternalmessages') && ($table != 'CRMdatastructures') && ($table != 'CRMmailqueue') && ($table != 'CRMstats') && ($table != 'CRMsessions') && ($table != 'CRMtodo')) {
                            $primary = ''; //gemakshalve gaan we er vanuit dat dit de primary key is. dat hoeft niet; zeker niet bij compound primary keys
                                foreach (db_GetArray('SHOW FIELDS FROM `'.$table.'`') as $fieldrow) {
                                    $field = $fieldrow['Field'];
                                    if ($primary == '') {
                                        $primary = $field;
                                    }

                                    $sql = 'SELECT `'.$primary.'`, `'.$field.'`';
                                    if ($table == 'CRMattributes') {
                                        $sql .= ', `identifier`, `attribute`, `value`';
                                    }
                                    $sql .= ' FROM `'.$table.'` WHERE `'.$field.'` ';
                                    if ($whole_word_only) {
                                        //TODO hier moet ook nog geescaped worden
                                                $sql .= "REGEXP '[[:<:]]".mres($search)."[[:>:]]'";
                                    } else {
                                        //escapen want deze karakters zijn operator in de Mysql LIKE functie
                                                $searchpart_escaped = $search;
                                        $searchpart_escaped = str_replace('%', '\\%', $searchpart_escaped);
                                        $searchpart_escaped = str_replace('_', '\\_', $searchpart_escaped);
                                        $sql .= "LIKE '%".mres($searchpart_escaped)."%'";
                                    }
                                    if (($table == 'CRMmodules') || ($table == 'CRMtemplates')) {
                                        $sql .= ' AND `version_belonging_to`=0';
                                    } elseif ($table == 'CRMextrafields') {
                                        $sql .= " AND `deleted`='n'";
                                    } elseif ($table == 'CRMattributes') {
                                        $sql .= " AND attribute NOT IN ('TriggerQueriesForDeploy', 'DataStructureAccessReasons')";
//                                              $sql .= " AND identifier!='user'";
                                    }
//                                      $hits[] = $sql;
                                        foreach (db_GetArray($sql) as $row) {
                                            $str = $table.' '.$primary.'='.$row[$primary];
                                            if ($table == 'CRMattributes') {
                                                $str .= ', identifier='.$row['identifier'].', attribute='.$row['attribute'].', value='.$row['value'];
                                            } else {
                                                $str .= ', '.$field.'='.$row[$field];
                                            }
                                            $hits[] = $str;
                                        }
                                }
                        }
        }
    }

    return $hits;
}


function recalc_calculations($which_field = '', $print = false, $all_fields = false)
{
    //MOET runnen als administrator
    //als which_field == "" doet hij alle recalcs via cron; anders alleen die ene efid, bijvoorbeeld "f12"

    $maxdepth = 0;
    $tabledepth = array();
    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
    {
	if ($table != "files")
	{
	        $depth = get_table_depth($table);
	        $tabledepth[$depth][] = $table;
	        if ($depth > $maxdepth)
	        {
	            $maxdepth = $depth;
	        }
	}
    }
    $maxdepth++;
    //to recalculate files first; get_table_depth() does not know at what level the files are; because there is not a standard relation in the files table
    $tabledepth[$maxdepth][] = "files";

//    pre($tabledepth);

    disable_mysql_triggers();

    //deze lus is nogal lomp wanneer er wel een which_field is opgegeven
    for ($depth = $maxdepth; $depth >= 0; $depth--)
    {
        foreach ($tabledepth[$depth] as $table)
	{
            $parts = array();
            foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]['fields']) as $field) {
                        if (($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['calculation'] != '') && ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['calculation_type'] == 'database trigger')) {
                            $add = false;
                            if ($all_fields) {
                                $add = true;
                            } elseif (($which_field == '') && ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['RecalculateDaily'])) {
                                $add = true;
                            } elseif ($which_field == $field) {
                                $add = true;
                            }

                            if ($add) {
                                $this_calculation = $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['calculation'];
                                $this_calculation = str_replace("@table_alias@", $table, $this_calculation);
                                $parts[] = "`" . $table . "`.`" . $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database']. "`=(" . $this_calculation . ")";
                            }
                        }
            }

            if (count($parts) > 0) {
                $parts[] = "`" . $table . "`.`timestamp_last_change`=`" . $table . "`.`timestamp_last_change`";

                $query = "UPDATE `CRM".$GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database']."` `" . $table . "` SET ".implode(", ", $parts);
                if ((preg_match("/^t\d+$/", $table)) && ($GLOBALS['UC']['PersonalDataStructure'][$table]["logical_delete"])) {
                    $query .= " WHERE `" . $table . "`.`deleted`='n'";
                }
//		$query .= " LIMIT 100";

                if ($print) {
                    echo date('r').': recalc: '.$table . " (" . count($parts) . " fields)...\n";
                }
                mcq($query);
                if ($print) {
                    echo date('r').': recalc: '.$table." (" . count($parts) . " fields) DONE\n";
                }
            }
        }
    }

    enable_mysql_triggers();
}

function return_mysql_trigger_queries($use_delimiter = false, $return_droptrigger = true, $return_createtrigger = true)
{
    //MOET runnen als administrator

        /*
        - triggers kunnen alleen parents updaten met (geaggregeerde) data uit childs, niet childs met data uit parents
        - Circulaire referenties (alsmede triggers die childs updates) zijn niet mogelijk vanwege: Can't update table 'CRMflextable25' in stored function/trigger because it is already used by statement which invoked this stored function/trigger.
        - ALLE calculations runnen in 1x voor een record, terwijl die lang niet altijd nodig zal zijn (omdat we weten dat de uitkomst gelijk is). om dit te ondersteunen moet er veel meer logica in die triggers ziten en dat is nu niet zo. jammer dan; dit runt toch snel genoeg (voorlopig)
        - EFID1 kan een calculations zijn, EFID2 kan een andere calculations zijn met waarde "EFID1*2" -> dit werkt zolang de ordering van velden juist is (EFID2 moet NA EFID1 staan)
        - worden gebruikt voor berekeningen, bijvoorbeeld totaal = prijs_per_stuk * aantal
        - resultaat wordt *niet* gejournaled
        - calculations worden ook in parents herberekend bij een update op de child (wanneer er een factuur wordt toegevoegd in de child, kan bijvoorbeeld de totaalsom van alle facturen in de klanten tabel (parent) herberekend worden. een update op een grandchild herbekerend ook de grandparent WANNEER de parent ook herberekend wordt (omdat er in die parent in calculations gerefereed wordt aan de grandchild. als dat niet zo is, dan wordt de grandparent ook niet herberekend). Stel Klant -> Project -> Facturen; maak in dat geval niet ALLEEN een totaaltelling van facturen op klantnivo; maar maar een totaaltelling van facturen PER project en SUM die weer bij de Klant. dan calct alles door
        - calculations herberkenen NIET de childs van een record. dit lijkt ook niet waarschijnlijk te zijn dat je dat wilt. Om dat wel te doen zou je een eindeloze recursie hebben
        - calculation velden zijn altijd readonly, ook voor admin
        - calcs CRMbinfiles en hun parents worden ook ondersteund
        - de binfiles calcs kunen efficienter; op een update van een bestand wordt de parent 2x herberekend omdat type en koppelid nooit zullen wijzigen (in de Interleave) interface). Dit zou efficienter kunnen (door NEW met OLD te vergelijken) maar dat maakt de triger logica complexer
                IF OLD.`type`='flextable23' THEN
                UPDATE `CRMflextable23` SET `CRMflextable23`.`timestamp_last_change`=`CRMflextable23`.`timestamp_last_change` WHERE `CRMflextable23`.`recordid`=OLD.`koppelid`;
                END IF;
                IF NEW.`type`='flextable23' THEN
                UPDATE `CRMflextable23` SET `CRMflextable23`.`timestamp_last_change`=`CRMflextable23`.`timestamp_last_change` WHERE `CRMflextable23`.`recordid`=NEW.`koppelid`;
                END IF;
        - efficientere triggers door NEW met OLD te vergelijken en alleen te runnen op een verschil
	- er MOET @table_alias@ gebruikt worden om te refereren naar de naam van de eigen tabel
        */

        $queries_to_run = array();

    $delimiter = ';';
        //is nodig voor als de queries over de commandline runnen via een deploy
        if ($use_delimiter) {
            $delimiter = '//';
            $queries_to_run[] = 'delimiter '.$delimiter;
        }

    if ($return_droptrigger) {
        //deze heeft geen data structure nodig
                foreach (db_GetArray('SHOW TRIGGERS') as $row) {
                    $query = 'DROP TRIGGER IF EXISTS `'.$row['Trigger'].'`'.$delimiter;
                    $queries_to_run[] = $query;
                }
    }

    if ($return_createtrigger) {
        foreach (@array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table) {
            //alleen in deze tabellen kunnen efids zitten; alleen efids kunnen calculations bevatten
                        if (($GLOBALS['UC']['PersonalDataStructure'][$table]['datatable']) || ($table == 'files') || ($table == 'users') || ($table == 'groups')) {
                            foreach (array('BEFORE', 'AFTER') as $timing) {
                                foreach (array('INSERT', 'UPDATE', 'DELETE') as $event) {
                                    $types = array();
                                    if (($event == 'DELETE') || ($event == 'UPDATE')) {
                                        $types[] = 'OLD';
                                    }
                                    if (($event == 'INSERT') || ($event == 'UPDATE')) {
                                        $types[] = 'NEW';
                                    }

                                        //TODO: als er in acc een trigger zat op een veld wat gedropt is, dan wordt die niet mee gedeployed naar prod waardoor die oude trigger blijft bestaan
/*                                      if ($return_droptrigger)
                                        {
                                                $query = "DROP TRIGGER IF EXISTS `" . $table . "_" . $event . "_" . $timing . "`" . $delimiter;
                                                $queries_to_run[] = $query;
                                        }*/

//                                      if ($return_createtrigger)
//                                      {
                                                $query = '';

                                    if ($timing == 'BEFORE') {
                                        //we doen niks; we verwijderen het record immers dus we hoeven geen update op de eigen tabel meer te doen, nog WEL op bovenliggende tabellen
                                                        if ($event != 'DELETE') {
                                                            $parts = array();
                                                            foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]['fields']) as $field) {
                                                                //hierin staat bijvoorbeeld @table_alias@.EFID3*@table_alias@.EFID4
                                                                        if (($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['calculation'] != '') && ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['calculation_type'] == 'database trigger')) {
                                                                            //replace want je mag niet de eigen tabel updaten in deze context; door de NEW. te zetten wordt ie in 1x goed geinsert/update
                                                                            $this_calculation = $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['calculation'];
                                                                            $this_calculation = str_replace("@table_alias@", "NEW", $this_calculation);

                                                                            $parts[] = 'NEW.`'.$GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database'].'`=('.$this_calculation.')';
                                                                        }
                                                            }
                                                            if (count($parts) > 0) {
                                                                //dit is de daadwerkelijke trigger; deze maakt data changes; alle andere logica in deze functie is er alleen maar voor om andere tabellen te triggeren onderstaande queries uit te voeren
                                                                        $query .= 'SET '.implode(', ', $parts).";\n";
                                                            }
                                                        }
                                    }
                                                //IN DE AFTER DOEN WE DE BOVENLIGGENDE TABELLEN
                                                else {
                                                    //de files table wijst op een afwijkende manier naar zijn parents
                                                        if ($table == 'files') {
                                                            foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $parent_table) {
                                                                if ($GLOBALS['UC']['PersonalDataStructure'][$parent_table]['HasFileAttachments']) {
                                                                    //code duplicatie: 2x in deze functie
                                                                    $do_parent_recalc = false;
                                                                    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$parent_table]['fields']) as $parent_field) {
                                                                        //in de parent calculation wordt de tabel genoemd waarin we nu zitten; we moeten de parent dus recalcen
                                                                                        //we hoeven hier geen @table_alias@ te replacen want we kijken niet naar DIE tabelnaam
                                                                                        if ((preg_match("/\bCRM".$GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database']."\b/", $GLOBALS['UC']['PersonalDataStructure'][$parent_table]['fields'][$parent_field]['calculation'])) && ($GLOBALS['UC']['PersonalDataStructure'][$parent_table]['fields'][$parent_field]['calculation_type'] == 'database trigger')) {
                                                                                            $do_parent_recalc = true;
                                                                                            break;
                                                                                        }
                                                                    }
                                                                                //code duplicatie: 2x in deze functie

                                                                                if ($do_parent_recalc) {
                                                                                    foreach ($types as $type) {
                                                                                        $query .= 'IF '.$type.".`type`='".$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database']."' THEN\n";

                                                                                                //we TOUCHEN hier alleen het parent record zodat die zijn eigen triggers runt voor updates in zijn eigen tabel
                                                                                                //met een update van t_l_c naar NOW() zouden de parent een bijgewerkte timestamp kunnen krijgen
                                                                                                $query .= 'UPDATE `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'` SET `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'`.`timestamp_last_change`=`CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'`.`timestamp_last_change` WHERE `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'`.`'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['primary'].'`='.$type.".`koppelid`;\n";

                                                                                        $query .= "END IF;\n";
                                                                                    }
                                                                                }
                                                                }
                                                            }
                                                        } else {
                                                            foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]['parents']) as $parent_table) {
                                                                //code duplicatie: 2x in deze functie
                                                                $do_parent_recalc = false;
                                                                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$parent_table]['fields']) as $parent_field) {
                                                                    if ((preg_match("/\bCRM".$GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database']."\b/", $GLOBALS['UC']['PersonalDataStructure'][$parent_table]['fields'][$parent_field]['calculation'])) && ($GLOBALS['UC']['PersonalDataStructure'][$parent_table]['fields'][$parent_field]['calculation_type'] == 'database trigger')) {
                                                                        //in de parent calculation wordt de tabel genoemd waarin we nu zitten; we moeten de parent dus recalcen
                                                                        $do_parent_recalc = true;
                                                                        break;
                                                                    }
                                                                }
                                                                        //code duplicatie: 2x in deze functie

                                                                        if ($do_parent_recalc) {
                                                                            //er kunnen meerdere links zijn naar deze parent
                                                                                $parent_records_to_update = array();
                                                                            foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['parents'][$parent_table] as $field) {
                                                                                foreach ($types as $type) {
                                                                                    $parent_records_to_update[] = $type.'.`'.$GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['name_in_database'].'`';
                                                                                }
                                                                            }
                                                                                //parent_records_to_update bevat nu bijvoorbeeld OLD.EFID2, NEW.EFID2, OLD.EFID17, NEW.EFID17 -> indien er 2 links naar deze parent bestaand vanuit deze child
                                                                                //als hier 4x hetzelfde id in staat (omdat ie niet is gewijzigd) dan zou mysql die update maar 1x moeten draaien (ontdubbeling in de IN() - denk ik)
                                                                                //we TOUCHEN hier alleen het parent record zodat die zijn eigen triggers runt voor updates in zijn eigen tabel
                                                                                //met een update van t_l_c naar NOW() zouden alle parents een bijgewerkte timestamp kunnen krijgen (waarschijnlijk onwenselijk)
                                                                                $query .= 'UPDATE `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'` SET `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'`.`timestamp_last_change`=`CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'`.`timestamp_last_change` WHERE `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['name_in_database'].'`.`'.$GLOBALS['UC']['PersonalDataStructure'][$parent_table]['primary'].'` IN ('.implode(', ', $parent_records_to_update).");\n";
                                                                        }
                                                            }
                                                        }
                                                }

                                    if ($query != '') {
                                        $trigger_query = 'CREATE TRIGGER `'.$table.'_'.$event.'_'.$timing.'` '.$timing.' '.$event.' ON `CRM'.$GLOBALS['UC']['PersonalDataStructure'][$table]['name_in_database']."` FOR EACH ROW\n";
                                        $trigger_query .= "BEGIN\n";
                                        $trigger_query .= "IF @interleave_disable_trigger IS NULL THEN\n";
                                        $trigger_query .= $query;
                                        $trigger_query .= "END IF;\n";
                                        $trigger_query .= 'END'.$delimiter;

                                        $queries_to_run[] = $trigger_query;
                                    }
//                                      }
                                }
                            }
                        }
        }
    }

    if ($use_delimiter) {
        $delimiter = ';';
        $queries_to_run[] = 'delimiter '.$delimiter;
    }

    return $queries_to_run;
}

function showchilds($table, $recordid)
{
//zelf refereenrende elementen negeren; BIJVOORBEELD: een veld wat zichzelf noemt in een calc kan genegeerd worden; dus zichzelf uitsluiten


	$str = '';
	$childs_found = 0;
	$queries = array();
	if ((is_array($GLOBALS['UC']['PersonalDataStructure'][$table])) && (is_positive_integer($recordid)))
	{
		foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"]) as $child_table)
		{
			foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["childs"][$child_table] as $child_field)
			{
				$queries[] = array($child_table, $child_field, "SELECT `" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["primary"] . "` FROM `CRM" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["name_in_database"] . "` WHERE `" . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name_in_database"] . "`=" . $recordid);
			}
		}
		if ($table == "modules")
		{
//moduletoincludeoneverypageload
//listmodule

//@ gaat mis met de word boundary van mysql; daarom weggelaten, = kan wel want dit staat niet aan het begin of eind van de string
//			foreach (array("@MODULE" . $recordid . "@", "mid=" . $recordid) as $search)
			foreach (array("MODULE" . $recordid, "mid=" . $recordid) as $search)
			{
				$child_table = "templates";
				foreach (array("template_subject", "content") as $child_field)
				{
					$queries[] = array($child_table, $child_field, "SELECT `templateid` FROM `CRMtemplates` WHERE `version_belonging_to`=0 AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
				}
			}
		}
                if ($table == "templates")
                {
//page id's
//syswide css
//menu templates in group -> should be real ref
//dashboard template in group -> should be real ref
//style sheet in templates -> kan die weg? is die ooit nog wel in gebruik?
//form to use op tabel niveau -> should be real ref
//ook zoeken naar GetTemplate($recordid) ??? of alle php code negeren?
//			foreach (array("@TEMPLATE" . $recordid . "@", "template_to_use=" . $recordid, "template_to_use_open=" . $recordid, "template=" . $recordid, "template_id=" . $recordid) as $search)
			foreach (array("TEMPLATE" . $recordid, "template_to_use=" . $recordid, "template_to_use_open=" . $recordid, "template=" . $recordid, "template_id=" . $recordid) as $search)
			{
    	                	$child_table = "templates";
				foreach (array("template_subject", "content") as $child_field)
				{
					$queries[] = array($child_table, $child_field, "SELECT `templateid` FROM `CRMtemplates` WHERE `version_belonging_to`=0 AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
	                        }
			}

			$child_table = "fields";
			$child_field = "options";
			$queries[] = array($child_table, $child_field, "SELECT `id` FROM `CRMextrafields` WHERE `fieldtype`='comment' AND `options`=" . $recordid);
                }
                if ($table == "fields")
                {
//listlayout
//php code in custom validatie
//calender summary etc; ALLE TE PARSEN VELDEN; ZIE DAARVOOR OLD2NEW TAGS
//default val of other field
//fields that must have a value on click of button attribute
			foreach (array("EFID" . $recordid, "f" . $recordid) as $search)
			{
				$child_table = "templates";
				foreach (array("template_subject", "content") as $child_field)
				{
					$queries[] = array($child_table, $child_field, "SELECT `templateid` FROM `CRMtemplates` WHERE `version_belonging_to`=0 AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
				}
				$child_table = "modules";
				$child_field = "module_code";
				$queries[] = array($child_table, $child_field, "SELECT `mid` FROM `CRMmodules` WHERE `version_belonging_to`=0 AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");

                                $child_table = "fields";
				$child_field = "calculation";
				$queries[] = array($child_table, $child_field, "SELECT `id` FROM `CRMextrafields` WHERE `deleted`='n' AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
			}

			//zoeken naar EFID123 is niet nodig in deze tabellen; alleen naar f123
			foreach (array("f" . $recordid) as $search)
			{
				$child_table = "ruleconditions";
				$child_field = "field";
				$queries[] = array($child_table, $child_field, "SELECT id FROM CRMruleconditions WHERE `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");

				$child_table = "ruleactions";
				$queries[] = array($child_table, $child_field, "SELECT id FROM CRMruleactions WHERE `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");

				$child_table = "ruleactionconditions";
				$queries[] = array($child_table, $child_field, "SELECT id FROM CRMruleactionconditions WHERE `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");

				$child_table = "calendars";
				foreach (array("ref_start_date_time", "ref_end_date_time", "ref_organiser") as $child_field)
				{
					$queries[] = array($child_table, $child_field, "SELECT `id` FROM `CRMcalendars` WHERE `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
				}

//DIT WERKT NOG NIET
/*
				$child_table = "attributes";
				$child_field = "value";
				$queries[] = array($child_table, $child_field, "SELECT `identifier` FROM `CRMattributes` WHERE `attribute` LIKE 'List-layout-%' AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
*/

			}
                }
		if ($table == "tables")
		{
//rules hangen ook aan een table, toch?
//listlayout
//php code in custom validatie
//calender summary etc
                        $child_table = "templates";
			$search = "t" . $recordid;
			foreach (array("template_subject", "content") as $child_field)
			{
				$queries[] = array($child_table, $child_field, "SELECT `templateid` FROM `CRMtemplates` WHERE `version_belonging_to`=0 AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");
			}

			$search = "CRMflextable" . $recordid;
                        $child_table = "modules";
			$child_field = "module_code";
			$queries[] = array($child_table, $child_field, "SELECT `mid` FROM `CRMmodules` WHERE `version_belonging_to`=0 AND `" . $child_field . "` REGEXP '[[:<:]]" . mres($search) . "[[:>:]]'");

			$child_table = "fields";
			$child_field = "tabletype";
			$queries[] = array($child_table, $child_field, "SELECT `id` FROM `CRMextrafields` WHERE `tabletype`=" . $recordid);

			$child_table = "fields";
			$child_field = "options";
			$queries[] = array($child_table, $child_field, "SELECT `id` FROM `CRMextrafields` WHERE `fieldtype` IN ('Reference to FlexTable', 'Reference to FlexTable (multiselect)') AND `options`=" . $recordid);
		}

		$str .= '<h2>Childs</h2><ul>';
		foreach ($queries as $query_arr)
		{
			$child_table = $query_arr[0];
			$child_field = $query_arr[1];
			$query = $query_arr[2];
//			$str .= '<li><pre>' . htme($query) . '</pre></li>';
			foreach (db_GetFlatArray($query) as $child_recordid)
			{
				$str .= '<li>';
				$str .= htme($GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"][$child_field]["name"] . ' for ' . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["singular"]);
				$str .= ' <a href="' . $GLOBALS['UC']['PersonalDataStructure'][$child_table]["openlink"] . $child_recordid . '">';
				//dit wordt waarchijnlijk te traag
				$str .= get_refer_layout_for_record($child_table, $child_recordid);
//				$str .= $child_recordid;
				$str .= '</a>';
				$str .= '</li>';
				$childs_found++;
			}
		}
		$str .= '</ul>';
		if ($childs_found == 0)
		{
			$str = '';
		}

	}

	return $str;
}

//deze functie zet GEEN refs om naar hun component parts; deze functie moet als admin gerunt worden op templates, default values, rules, etc. en mag daarna weg
//MUST BE RUN AS ADMIN
function oldtags2newtags($template = "", $currentpath = "")
{
        //TODO dit is duur om iedere keer te doen voor een te parsen veld
        $efid_in_which_table = array();
        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $tableX)
        {
                foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$tableX]["fields"]) as $fieldX)
                {
                        //alleen EFID tags
                        if (preg_match("/^f\d+$/", $fieldX))
                        {
                                $efid_in_which_table[$fieldX] = $tableX;
                        }
                }
        }

    foreach (db_GetFlatArray("SELECT `id` FROM `CRMextrafields` WHERE `deleted`='n' AND `tabletype`='user'") as $efid) {
	$template = str_replace("@EFID" . $efid . "@", "@users-f" . $efid . "@", $template);
	$template = str_replace("%EFID" . $efid . "%", "%users-f" . $efid . "%", $template);
	$template = str_replace("@f" . $efid . "@", "@users-f" . $efid . "@", $template);
	$template = str_replace("%f" . $efid . "%", "%users-f" . $efid . "%", $template);
    }


	$template = preg_replace("/\[\[EFID(\d+)\]\]/", "[[f\\1]]", $template);

	$allreplaces = array();
	$warnings = '';

        //PARSINGFUNCTIE
        //deze accepteert zowel oude tags als nieuwe tags als input; dat is nodig omdat IN een layout een verwijzing naar een ANDERE layout kan staan die al geparsed is
        //update 2014-11-25 in 1 regexp, ook support voor ^ tags voor urlcodering. backreference gebruikt in pattern om geen #EFID12% meer te matchen
        $count = preg_match_all("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]+)\\1/", $template, $matches);
	$count_recorddata_tags_in_flextables = 0;
        for ($x = 0; $x < $count; $x++)
        {
                $open_char = $matches[1][$x];
                //deze kan namelijk gechanged worden
                $orig_open_char = $open_char;
                $oldtag = $matches[2][$x];

                $table_parts = explode("-", $oldtag);
                $last_field = $table_parts[count($table_parts)-1];

		//these tags are "global"; not depended on current path; we need to ignore them
		if ($table_parts[0] == "users")
		{
			continue;
		}

                $target = "";
                //deze tag is al geparsed; want hij bevat de nieuwe layout: t1-f2
                if (count($table_parts) > 1)
                {
                        $target = $oldtag;
                }
                else if (preg_match("/^(EFID|f)(\d+)$/", $last_field, $efidmatch))
                {
                        $target_field = "f" . $efidmatch[2];
                        $target = $efid_in_which_table[$target_field] . "-" . $target_field;
			$count_recorddata_tags_in_flextables++;
                }
                else if (($last_field == "RECORDID") || ($last_field == "RECORD"))
                {
                        //we weten niet WELKE tabel hiervoor moet staan. dat is afhankelijk van currentpath
                        $target = "recordid";
			$count_recorddata_tags_in_flextables++;
                }
                else if ($last_field == "LASTUPDATE")
                {
                        $target = "timestamp_last_change";
			$count_recorddata_tags_in_flextables++;
                }

                $matchkey = "";
                //niks gevonden
                if ($target != "")
                {
                        $table_parts_target = explode("-", $target);
                        $first_table = $table_parts_target[0];

                        //eventueel het currentpath als voorvoegsel gebruiken
                        if (($currentpath != "") && (!preg_match("/^" . preg_quote($currentpath . "-", "/") . "/", $target)))
                        {
                                $table_parts = explode("-", $currentpath);
                                $last_field = $table_parts[count($table_parts)-1];
                                $last_table = $table_parts[count($table_parts)-2];

                                $first_table = $table_parts[0];

                                //dit is wat lomp; maar door de volgorde van omzetten van oude naar nieuwe tags; kan dit al een nieuwe zijn; als we dit niet doen dan staat de naam van de tabel/veld er 2x in t17-f188-t4-f54-t4-f54-t5-f46
                                //ik weet niet 100% zeker of dit wel goed gaat op 3, 4 of N laags tabellen
                                if (($table_parts_target[0] == $last_table) && ($table_parts_target[1] == $last_field))
                                {
                                        $target = implode("-", array_slice($table_parts_target, 2));
                                }

                                $target2 = $currentpath . "-" . $target;
                                //hij matcht na het toevoegen van het voorvoegsel (currentpath)
                                if (in_array($target2, $GLOBALS['UC']['PersonalDataStructure'][$first_table]["allfields"]))
                                {
                                        $matchkey = $target2;
                                }
                                //hij matcht niet, in dit geval moet er nog een tabel tussenzitten die we niet "kennen". we zoeken hier het kortste path op
                                else
                                {
                                        //hij moet beginnen met currentpath, gevolgd door 1 of meer tabellen, en hij moet EINDIGEN op target
                                        $match = "^" . preg_quote($currentpath . "-", "/") . "(.*)" . preg_quote($target, "/") . "$";
//print 'zoek ' . $match . '<br>';
                                        foreach ($GLOBALS['UC']['PersonalDataStructure'][$first_table]["allfields"] as $key)
                                        {
                                                if (preg_match("/" . $match . "/", $key))
                                                {
                                                        if ($matchkey == "")
                                                        {
                                                                $matchkey = $key;
                                                                //update 2014-09-26; we nemen de eerste referentie die we vinden
                                                                //break;
                                                        }
							else
							{
								$warnings .= '<div class="warnmsg">WARN: multiple match for ' . $match . ': ' . $matchkey . ' AND ' . $key . ' (WE USE THE FIRST KEY THAT MATCHES)</div>';
							}
                                                }
                                        }
                                }
                        }
                        //hij matcht volledig
                        else if (in_array($target, $GLOBALS['UC']['PersonalDataStructure'][$first_table]["allfields"]))
                        {
                                $matchkey = $target;
                        }
                }

                //de target begint niet met het currentpath. bijvoorbeeld bij een circulaire referentie.
                //target: t1-f4
                //t1-f2 verwijst naar t1
                //currentpath is dan: t1-f2
                //target wordt dan: t1-f2-t1-f4

                $newtag = "";

                if ($matchkey != "")
                {
                     $newtag = $open_char . $matchkey . $open_char;
                }

                //als de key niet gevonden is blijft newtag leeg en zou hij verdwijnen hij uit het template, daarom zetten we de originele tag weer terug
                if ($newtag == "")
                {
                        //dit kunnen tags zijn zoals GROUPONLY, XONLY en ARROWS die we onveranderd willen laten
                        $newtag = $orig_open_char . $oldtag . $orig_open_char;
                }

		if ($newtag == "")
		{
			$warnings .= '<div class="errmsg">ERR: ' . $orig_open_char . $oldtag . $orig_open_char . ' not found</div>';
		}

		$oldtag_full = $orig_open_char . $oldtag . $orig_open_char;

		if ($oldtag_full != $newtag)
		{
                    $template = str_replace($oldtag_full, $newtag, $template);
        		$allreplaces[$oldtag_full] = $newtag;
		}
        }


	if (($count_recorddata_tags_in_flextables > 0) && ($currentpath == ""))
	{
		$warnings .= '<div class="errmsg">ERR: currentpath unknown</div>';
	}

        return array($template, $warnings, $allreplaces);
}

function convert_serialized_multiselects_remove_base64($htmloutput = true)
{
	print "THE convert_serialized_multiselects_remove_base64() FUNCTION IS DISABLED";
	return false;
	foreach (db_GetArray("SELECT id, tabletype FROM CRMextrafields WHERE deleted='n' AND fieldtype IN ('drop-down (multiselect)', 'Reference to FlexTable (multiselect)', 'SQL Query (multiselect)')") as $field)
	{
		if ($htmloutput)
		{
			pre($field);
		}
		else
		{
			print $field["id"] . " " . $field["tabletype"] . "\n";
		}
		$table = "";
		$primary = "";
		if ($field["tabletype"] == "user")
		{
			$table = "CRMloginusers";
			$primary = "id";
		}
		else if ($field["tabletype"] == "group")
		{
			$table = "CRMuserprofiles";
			$primary = "id";
		}
		else if (is_numeric($field["tabletype"]))
		{
			$table = "CRMflextable" . $field["tabletype"];
			$primary = "recordid";
		}
		else
		{
			print '<div class="errmsg">unknown tabletype</div>';
		}

		if ($table != "")
		{
			foreach (db_GetArray("SELECT " . $primary . ", EFID" . $field["id"] . " FROM " . $table . " WHERE EFID" . $field["id"] . " NOT IN ('', 'a:0:{}')") as $row)
			{
				$arr = array();
				foreach (unserialize($row["EFID" . $field["id"]]) as $val_b64)
				{
					$val = base64_decode($val_b64);
					if ($val != "{{{null}}}")
					{
						$arr[] = $val;
					}
				}
				$query = "UPDATE " . $table . " SET timestamp_last_change=timestamp_last_change, EFID" . $field["id"] . "='" . mres(serialize($arr)) . "' WHERE " . $primary . "=" . $row[$primary];
				if ($htmloutput)
				{
					pre($query);
				}
				else
				{
					print $query . "\n";
				}
				mcq($query);
			}
		}
	}
}

function get_table_for_template($template_id)
{
	//this function tries to find out to which table this template belongs; it should not be used in a production environment. We might want to add a true reference to "tables" from the templates table.
	$table = "";
	$tmp = db_GetValue("SELECT recordid FROM CRMflextabledefs WHERE formid=" . $template_id);
	if (is_positive_integer($tmp))
	{
		$table = "t" . $tmp;
	}
	if ($table == "")
	{
		$tmp = db_GetValue("SELECT CRMrules.table FROM CRMrules, CRMruleactions WHERE CRMruleactions.rule=CRMrules.id AND CRMruleactions.template=" . $template_id);
		if ($tmp != "")
		{
			$table = $tmp;
		}
	}
	if ($table == "")
	{
		$tmp = db_GetValue("SELECT CRMrules.table FROM CRMrules, CRMruleactions WHERE CRMruleactions.rule=CRMrules.id AND CRMruleactions.attach=" . $template_id);
		if ($tmp != "")
		{
			$table = $tmp;
		}
	}
	if ($table == "")
	{
		$tmp = db_GetValue("SELECT tabletype FROM CRMextrafields WHERE fieldtype='comment' AND deleted='n' AND options=" . $template_id);
		if (is_positive_integer($tmp))
		{
			$table = "t" . $tmp;
		}
	}
//template could also contain only text; which does not mean it belongs to this table
/*
	if ($table == "")
	{
		$tmp = db_GetValue("SELECT tabletype FROM CRMextrafields WHERE deleted='n' AND defaultval LIKE '%@TEMPLATE" . $template_id . "@%'");
		if (is_positive_integer($tmp))
		{
			$table = "t" . $tmp;
		}
	}
*/
	if ($table == "")
	{
		//no detection of endless recursion; be careful!
		foreach (db_GetFlatArray("SELECT templateid FROM CRMtemplates WHERE version_belonging_to=0 AND (content LIKE '%@TEMPLATE" . $template_id . "@%' OR template_subject LIKE '%@TEMPLATE" . $template_id . "@%')") as $parent_template_id)
		{
			//we'll use the first one that matches
			if ($table == "")
			{
				$table = get_table_for_template($parent_template_id);
			}
		}
	}
	if ($table == "")
	{
		$possible_tables = array();
		$maxdepth = -1;
		$template = db_GetValue("SELECT CONCAT(template_subject, ' ', content) FROM CRMtemplates WHERE version_belonging_to=0 AND templateid=" . $template_id);
		$count = preg_match_all("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]+)\\1/", $template, $matches);
		for ($x = 0; $x < $count; $x++)
		{
	                $oldtag = $matches[2][$x];

    	        	$table_parts = explode("-", $oldtag);
        	        $last_field = $table_parts[count($table_parts)-1];
//a fully qualified tag
			if (count($table_parts) > 2)
			{
//this is the first table
				$tmp = $table_parts[0];
				if (($tmp != "users") && (!in_array($tmp, $possible_tables)))
				{
					$depth = get_table_depth($tmp);
					//we use the lowest table (grand-grand-child) so all tags can match
					if ($depth > $maxdepth)
					{
						$maxdepth = $depth;
						$table = $tmp;
					}
					$possible_tables[] = $tmp;
				}
			}

	                if (preg_match("/^(EFID|f)(\d+)$/", $last_field, $efidmatch))
    	                {
				$tmp = get_ds_tablename_for_field($efidmatch[2]);
				//ignore users table; this is a global table; and not part of recordparsing
				if (($tmp != "users") && (!in_array($tmp, $possible_tables)))
				{
					$depth = get_table_depth($tmp);
					//we use the lowest table (grand-grand-child) so all tags can match
					if ($depth > $maxdepth)
					{
						$maxdepth = $depth;
						$table = $tmp;
					}
					$possible_tables[] = $tmp;
				}
	                }
		}
	}

	return $table;
}

function AddFieldnamesToTags($template)
{
    //2017-06-16 THIS MUST GO EFID123 LANG TAGS ARE DEPRECATED; ONLY f123 IS SUPPORTED
    $template = preg_replace_callback("/\[\[(f|EFID)(\d+)\]\]/", function ($matches) {
        return '[[f'.$matches[2].' '.preg_replace('/\W/', '_', GetExtraFieldName($matches[2])).']]';
    }, $template);

    //let op de "f" op het eind van match[2]
    $template = preg_replace_callback("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]*f)(\d+)\\1/", function ($matches) {
    //in 1 staat het control karakter; @, #, % of %
    //in 2 staat de tag ZONDER het veldnummer; EFID, f of t2-f5-t10-f, etc
    //in 3 staat het veldnummer; 2, 17, 129, etc
    return $matches[1].$matches[2].$matches[3].' '.preg_replace('/\W/', '_', db_GetValue("SELECT name from CRMextrafields WHERE deleted='n' AND id=".$matches[3])).$matches[1];
    }, $template);

    return $template;
}
function RemoveFieldnamesFromTags($template)
{
    $template = preg_replace("/\[\[f(\d+)( \w+)?\]\]/", '[[f${1}]]', $template);
    $template = preg_replace("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]+)(\d+)( \w+)?\\1/", '${1}${2}${3}${1}', $template);
    return $template;
}

function is_assoc(array $array)
{
    // Keys of the array
    $keys = array_keys($array);

    // If the array keys of the keys match the keys, then the array must
    // not be associative (e.g. the keys array looked like {0:0, 1:1...}).
    return array_keys($keys) !== $keys;
}

function UpdateSetting($setting, $value)
{
    mcq("UPDATE CRMsettings SET value='".mres($value)."' WHERE setting='".mres($setting)."'");
}

function GetDefaultSettings()
{
	//when adding a Setting, you may add the options (like Yes, No) to this block of code in admin.php elseif ($_GET["editsetting"] != "") { }
	$settings = array();
	//setting, value, description
	$settings[] = array('title', '', 'Title of your application.');
	$settings[] = array('admemail', '', 'The administrators e-mail address.');
	$settings[] = array('cronpassword', '', 'The password used by the HTTP-GET crond job (duedate-notify-cron.php).');
	$settings[] = array('timeout', '20', 'Number of minutes before a user is automatically logged off when there is no activity.');
	$settings[] = array('Logon message', '', 'This message will be displayed after a user logs in.');
	$settings[] = array('SMTPserver', 'localhost', 'The hostname or IP address of your SMTP (outgoing e-mail) server.');
	$settings[] = array('DateFormat', 'dd-mm-yyyy', 'Choose your preferred date format.');
	$settings[] = array('EnableEntityLocking', 'Yes', 'Set this to Yes to enable record locking to prevent two people from editing the same record at the same time.');
	$settings[] = array('MailMethod', 'smtp', 'The method to use for sending e-mail, can be either sendmail or smtp.');
	$settings[] = array('MailUser', '', 'The username of your authenticated SMTP-server (only when using authenticated SMTP).');
	$settings[] = array('MailPass', '', 'The password of your authenticated SMTP-server (only when using authenticated SMTP).');
	$settings[] = array('CAL_MINHOUR', '7', 'Starting hour of day for calendar.');
	$settings[] = array('CAL_MAXHOUR', '18', 'Ending hour of day for calendar (24h format: for 6pm use 18).');
	$settings[] = array('DBVERSION', '', 'The current database version - DO NOT EDIT THIS VALUE.');
	$settings[] = array('TMP_FILE_PATH', '', 'The path to the directory where Interleave (the user under which your webserver runs) can store temporary files.');
	$settings[] = array('BODY_URGENTMESSAGE', '', 'When set, this message will be displayed above all pages, use this for urgent matters.');
	$settings[] = array('UNIFIED_FROMADDRESS', '', 'An address entered here, will always overwrite the from address in e-mails. All e-mails will have this from address.');
	$settings[] = array('MAINTENANCE_MODE', 'No', 'When set to Yes, only administrators can log in. Required when upgrading.');
	$settings[] = array('PAGINATEOPTIONSLIST', '5,10,25,50,100', 'The options of rows-per-page, comma separated.');
	$settings[] = array('DASHBOARDTEMPLATE', '', 'The default dashboard template file. This setting can be overruled on a group basis.');
	$settings[] = array('ENABLEFILEVERSIONING', 'Yes', 'Set this variable to Yes to enable the file versioning functions for files attached to records.');
	$settings[] = array('ENABLEIMAGETHUMBNAILS', 'Yes', 'Set this variable to Yes to enable the thumbnail popup when hovering the mouse over an image file name.');
	$settings[] = array('ALLOWEDIPADRESSES', '', 'Enter semicolon-separated list of allowed IP adresses to use this application (careful!).');
	$settings[] = array('PASSWORDEXPIRE', '90', 'The number of days it takes for a password to expire. The user will be forced to change it if it expires.');
	$settings[] = array('ONEMAILPERTRIGGER', 'No', 'Set this option to Yes to send only one triggered e-mail per recipient per trigger.');
	$settings[] = array('FILECOMPRESSIONLEVEL', 'A', 'File compression level.');
	$settings[] = array('ALLOWLOGONPAGEPASSCHANGE', 'Yes', 'Set this to No to disable the logon-page change-password functionality.');
	$settings[] = array('USE_AUTOSAVE', 'Yes', 'Set this value to Yes to enable automatic saving of fields in the background.');
	$settings[] = array('EXCELFILEFORMAT', '2007', 'Select Excel export file format - XLS vs. XLSX.');
	$settings[] = array('BODY_ADMIN_ERRORMSG', '', 'Put HTML in this field to replace the form a user gets with Access Denied event.');
	$settings[] = array('MINIMUMPASSWORDSTRENGTH', '3', 'The required password strength for users.');
	$settings[] = array('SUBTITLE', '', 'The description or subtitle of this application.');
	$settings[] = array('ENTITYLOCKTIMEOUT', '3600', 'The number of seconds a record lock lasts.');
	$settings[] = array('BASEURL', '', 'The base URL to this application. If using UseURLBeautification this setting must be set first.');
	$settings[] = array('SYSWIDECSS', '', 'Custom stylesheet for application. It will be loaded after UseSkinCSS.');
	$settings[] = array('ShowMinimalErrorMessages', 'No', 'Set this option to Yes to hide technical details from SQL- and internal Interleave error messages.');
	$settings[] = array('UseMailQueue', 'Yes', 'Set this option to No to send e-mails in the user session, Yes to let housekeeping send the e-mails.');
	$settings[] = array('TimestampLastHousekeeping', '', 'Internal - refers to last time housekeeping ran.');
	$settings[] = array('TimestampLastDuedateCron', '', 'Internal - refers to last time duedate-notify-cron ran.');
	$settings[] = array('MenuTemplateId', '', 'The default menu template. This setting can be overruled on a group basis.');
	$settings[] = array('LoginPageMessage', '', 'This messages is displayed on the login page.');
	$settings[] = array('AddressToSendAllMailsToWhenInDevelopmentMode', '', 'When set, all e-mails going out will be send to this address when in development mode. When not set, no e-mails will be send.');
	$settings[] = array('AllowFoldersInFilelists', 'Yes', 'When enabled, users are allowed to create folders when adding files.');
	$settings[] = array('BindSessionToIP', 'Yes', 'For extra security; the IP address must remain the same while the session lasts.');
	$settings[] = array('DefaultExcel2007Font', 'Tahoma', 'The default font for new MS Excel 2007-style spreadsheets.');
	$settings[] = array('DefaultExcel2007FontSize', '11', 'The default font size for new MS Excel 2007-style spreadsheets.');
	$settings[] = array('DefaultPhoneNumberCountryCode', '', 'The most common country code for a phone number, e.g. \'31\'.');
	$settings[] = array('DevelopmentOrProduction', 'Development', 'Specifies this servers purpose.');
	$settings[] = array('HighlightSearchesInForms', 'Yes', 'Set to Yes to highlight list searches also in forms and file lists.');
	$settings[] = array('ImageThumbailCopyrightMessage', '', 'A short message which will be included as a copyright watermark on thumbnails of images.');
	$settings[] = array('ModuleToEvaluateOnEveryListBuild', '', 'Module to evaluate every time a list is created for a table.');
	$settings[] = array('NumberOfModuleToIncludeInAllPageloads', '', 'The module to include in all pageloads.');
	$settings[] = array('OffLoadedFilesDirectoryHash', '', 'The hash for this applications disk directory for offloaded files. Generated automatically.');
	$settings[] = array('OffLoadedFilesSSLKey', '', 'The key to feed to SSL (Linux servers only) to encrypt disk files with. If you loose this key, you loose your files. No key means no encryption.');
	$settings[] = array('OffloadFilesPolicy', 'Don\'t offload files to disk', 'Set when files are offloaded to disk.');
	$settings[] = array('OffloadFilesURL', '', 'The URL to the files to fetch them when offloaded (not mandatory; if not set, OffloadLocalPath will be used).');
	$settings[] = array('OffloadLocalPath', '', 'The local path to store offloaded files.');
	$settings[] = array('RequireTwoPhaseAuthenticationForEveryOne', 'No', 'Set to Yes to require TPA for everyone.');
	$settings[] = array('RequireTwoPhaseAuthenticationPerIPForAdmins', 'No', 'Set to Yes to require TPA for admins only, per IP only.');
	$settings[] = array('SendundeliverableEmailsToEmailAddress', '', 'Set a valid e-mail address to forward all undeliverable e-mails to.');
	$settings[] = array('ShortName', '', 'A short name for this application.');
	$settings[] = array('TemplateNoOfJavascriptFileToIncludeInEveryPage', '', 'Javascript template to include in all pageloads.');
	$settings[] = array('TwoPhaseAuthenticationModuleNum', '', 'TPA module.');
	$settings[] = array('TwoPhaseAuthenticationRequired', '', 'When to require TPA (if at all).');
	$settings[] = array('TwoPhaseAuthenticationTrustAllLocalIPRanges', 'No', 'Set to Yes to trust 127.*, 10.*. 192.168.* and 172.[16-31].* when using TPA.');
	$settings[] = array('UseBrowserPreferredLanguage', 'No', 'Whether or not to use the browser preferred language (if available).');
	$settings[] = array('UserImportTableHTML', '', 'HTML which is displayed on the import page.');
	$settings[] = array('UseSkinCSS', 'Black and blue', 'Skin stylesheet for application. It will be loaded before SYSWIDECSS.');
	$settings[] = array('UseURLBeautification', 'No', 'Use Apaches mod_rewrite to be able to use /Tablename/Recordnum. Set BASEURL before setting this setting.');
	$settings[] = array('WebAppBackgroundColor', '', 'WebApp background color.');
	$settings[] = array('WebAppCSS', '', 'WebApp stylesheet.');
	$settings[] = array('WebAppEnabled', 'No', 'WebApp enabled (NOTE: the WebApp is not part of the open source distribution of Interleave).');
	$settings[] = array('WebAppRedirectMobileClients', 'No', 'WebApp redirect mobile clients.');
	$settings[] = array('WebAppThemeColor', '', 'WebApp theme color.');
	$settings[] = array('DefaultLanguage', 'ENGLISH', 'Default language. Users can overrule this setting (if more than 1 language is available).');
	$settings[] = array('CalendarAvailableViews', 'month,week,day', 'Available calender views.');
	$settings[] = array('DisableAllInternalMessagePopups', 'No', 'Set to Yes to disable popups when a message arrives.');
	$settings[] = array('WRONGSERVERMESSAGE', '', 'The message which is shown when a user is not working on the server mentioned in BASEURL.');
	$settings[] = array('BCCAllOutgoingQueuedMailToAddr', '', 'When set and valid, all queued e-mail will be sent BCC to this address.');
	$settings[] = array('CCAllOutgoingQueuedMailToAddr', '', 'When set and valid, all queued e-mail will be sent CC to this address.');
	$settings[] = array('SecurePDFsWithRandomPassword', 'Yes', 'When set, all PDFs will be secured with a random password.');
	$settings[] = array('ResizeImagesToMaxPx', '', 'When set, all images will be resized to this maximum height or width depending on their orientation.');
	$settings[] = array('NotificationsEnabled', 'No', 'When set, support for notifications is enabled. WebAppEnabled must be set to Yes.');
	$settings[] = array('NotificationsAskForPermission', '', 'When set, a two-step approval is requested to send notifications to allow for a softfail to substribe. If not set; a single step approval is requested.');
	$settings[] = array('NotificationsAlertOnFailure', '', 'When set, this alert is displayed on a hard fail to subscribe a user (i.e. when a user clicks BLOCK). Only set this when NotificationsAskForPermission is also set!');
	$settings[] = array('NotificationsAlertOnSuccess', '', 'When set, this alert is displayed when a user successfully subscribes to notifications.');
	return $settings;
}

function resize_images() {
    /* this function resizes all images (currently only JPEG) to the max size set in ResizeImagesToMaxPx. it will process 1.000 images at a time max */

    $mp = GetSetting("ResizeImagesToMaxPx");

    $list = db_GetAssocArray("SELECT entity, value FROM CRMattributes WHERE attribute='ResizeImagesToMaxPx' AND identifier='flextable' AND CAST(value AS DECIMAL) >0");

    if (ipi($mp)) {
        $list['all'] = $mp;
    }



    if (count($list) > 0) {
        foreach ($list AS $tablename => $mp) {

            $sql = "SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE CRMbinfiles.resized='n' AND CRMbinfiles.filetype IN ('image/jpeg')";

            if ($tablename == 'all') {
                /* here we must exclude all other tables having a setting */
                $sql .= " AND CRMbinfiles.type NOT IN ('";
                $segments = array();
                foreach ($list AS $tmptable => $tmpmaxpx) {
                    if ($tmptable != 'all') {
                        $segments[] = "flextable" . $tmptable;
                    }
                }
                $sql .= implode("','", $segments);
                $sql .= "')";
            } else {
                $sql .= " AND CRMbinfiles.type = 'flextable" . $tablename . "'";

            }

            $sql .= " LIMIT 1000";


            if (1==1) {
                foreach (db_GetFlatArray($sql) AS $fileid) {

                    /* mark as resized. whatever happens, we don't it back the next time around. due to GD2 bug (see duedate-notify) the script might crash later on */
                    mcq("UPDATE CRMbinfiles SET CRMbinfiles.resized='y' WHERE fileid='" . mres($fileid) . "'");

                    /* GetFileContent is offlo
                    ad-aware */
                    $old = GetFileContent($fileid);

                    /* since we need to get the dimensions, we might as well resize it immediately */
                    $new = ResizeImage($old, 0, 0, '0,0,0', '104,104,104', false, true, $mp);

                    if ($old != $new) {

                        print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . ' File ' . $fileid . ' was changed; old size ' . strlen($old) . ', new size ' . strlen($new) . "\n";

                        /* SetFileContent is offload-aware */
                        SetFileContent($fileid, $new, true);

                    }
                }
            }
        }
    } else {
        print date('r') . " " . round(memory_get_usage() / 1024 / 1024, 2) . " No ResizeImagesToMaxPx setting found, not resizing.\n";
    }

}


?>
