<?php
/* *****************************************************************
 * Interleave
 * Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file is the core of Interleave. It is always needed. It contains only functions and includes some other files.
 *
 * Check http://www.interleave.nl/ for more information
 *
 * BUILD / RELEASE :: 7.2.0.20180308
 *
 **********************************************************************
*/
if (empty($GLOBALS['CONFIGFILE'])) {
    $GLOBALS['CONFIGFILE'] = $GLOBALS['PATHTOINTERLEAVE'].'config/config.inc.php';
}
/*
 * functies/files te verwijderen
 *
 *	assist.php			wacht op ajaxbox (en dan nog checken)
 *	AjaxBox()
 *	egrep -n "AjaxBox\(" * 2>/dev/null

        V functions.php:1377:		if (strstr($template, "#MESSAGES#")) $template = str_replace("#MESSAGES#",AjaxBox("ShowMessagesList", true, false, false, "MessagesList"), $template);
        functions.php:7921:	return(AjaxBox("attrib-assist", false, "&identifier=" . $identifier . "&entity=" . $entity . "&attribute=" . $attribute, false, false, 0, "showinlineblock"));
        import.php:237:					print AjaxBox("ValidateInput", true, "&Worker=" . $worker . "&Header=" . ($headerId) . "&Table=" . $mem['table'], false, "AjaxDivHeader" . $headerId);
        modules.php:164:					print AjaxBox("RunModule", false, "&ExecInsModule=" . $_REQUEST['mid']);
 *
 *	populate.php
 *
 *
*/

// Version and author information (do not change)

// This version number is automatically a adjusted by the build routine. DO NOT ALTER IT BY HAND unless you know what you're doing.
// At least make sure it always ends with 8 characters representing the last build date (YYYY-MM-DD).
// NEVER (I MEAN *NEVER*) CHANGE THE DATE IN THIS VERSION BY HAND. FOR RELEASE TEST PURPOSES CHANGE SOMETHING ELSE BUT THE
// RELEASE DATE MUST ALWAYS BE 100% THE SAME AS THE RELEASE VERSION DATE MENTIONED IN EVERY FILE HEADER.
$GLOBALS['VERSION'] = '7.2.0.20180308'; // The main version
if (!isset($GLOBALS['PRODUCT'])) {
    $GLOBALS['PRODUCT'] = '';
}

// Some concats
$GLOBALS['CRM_VERSION'] = $GLOBALS['PRODUCT'].' '.$GLOBALS['VERSION'].' (c) 2001-2016';

require_once 'dbfunctions-mysqli.php';
require_once 'listfunctions.php';
require_once 'rules-functions.php';
require_once 'record-functions.php';
require_once 'form-functions.php';
require_once 'show_calendar.php';

/* atomos specific functions. only available on atomos infrastructure */
if (stream_resolve_include_path('atomos.php') != '') {

    require_once $GLOBALS['PATHTOINTERLEAVE'] . 'atomos.php';
} else {
    //print 'NOT INCLUDING ' . $GLOBALS['PATHTOINTERLEAVE'] . 'atomos.php : does not exist' . "\n";
}

function IntermediateDatabaseUpgrade()
{
    require_once 'dbupgrade.php';
    // Function moved to separate file
    IntermediateDatabaseUpgrade2();
}

function FlattenArray($arr)
{
    /*
        this function deletes all empty elements from an array
    */
    $flattened = array();
    foreach ($arr as $element) {
        if ($element) {
            array_push($flattened, $element);
        }
    }

    return $flattened;
}

/* MySQL error handling function (only for failed database queries) */
function handle_error($mysqlerror, $mysqlerrorno, $sql)
{

    /*
    Per 20160212 this function will always lead to an exit; the first MySQL query which crashes
    crashes the whole page load. There's zero tolerance. Future will tell if will work out.

    */

    /* handle_error should only run once */

    static $handle_error_is_running = false;

    /* compose message about error */
    $errmsg = '';
    $errmsg .= 'MySQL Error: '.$mysqlerror."\n";
    $errmsg .= 'MySQL Error id: '.$mysqlerrorno."\n";
    $errmsg .= "Query:\n".$sql."\n";

    /* if this status is already set */
    if ($handle_error_is_running) {

        /* if a query resulted in a second error there's probably something wrong with the database */
        $errmsg .= "\n";
        $errmsg .= 'User id: '.$GLOBALS['USERID']."\n";
        $errmsg .= 'User name: '.$GLOBALS['USERNAME']."\n";
        $errmsg .= 'Date/time: '.date('Y-m-d H:i:s')."\n";
        $errmsg .= "\n";
        $errmsg .= "GET\n";
        $errmsg .= print_r($_GET, true);
        $errmsg .= "\n";
        $errmsg .= "POST\n";
        $errmsg .= print_r($_POST, true);
        $errmsg .= "\n";
        $errmsg .= "COOKIE\n";
        $errmsg .= print_r($_COOKIE, true);
        $errmsg .= "\n";
        $errmsg .= "SERVER\n";
        $errmsg .= print_r($_SERVER, true);
        $errmsg .= "\n";
        $errmsg .= "BACKTRACE\n";
        $errmsg .= GetBackTrace();
        $errmsg .= "\n";

        mail('root@localhost', 'SQL error '.$_SERVER['HTTP_HOST'], $errmsg);

        if ($GLOBALS['Installer']) {

            /* show more technical details, only if admin or in development mode */
            print '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme($errmsg).'</pre>';

            /* HF20160804 backtrace added, only a a query error is practically useless */
            print '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme(GetBackTrace(true)).'</pre>';
        }

        exit;
    } else {
        $handle_error_is_running = true;
    }

    /* print an error message informing the user about what just happened */
    //"faileddatabasequery" is here for ProcessMessageReply()
    print '<!-- faileddatabasequery --><div class="errmsg" style="font-size: 200%;"><span class="fa fa-exclamation-triangle"></span> We\'re sorry. Something went wrong. Your administrator has been notified.</div>';

    /* log the message. this could lead to a second query error, in which case the handle_error_is_running flag will cause the script to exit */
    log_msg("ERROR: A user encountered an SQL error\n".$errmsg);

    /* ShowMinimalErrorMessages should be Yes on production systems. this check could lead to a second query error, in which case the handle_error_is_running flag will cause the script to exit */

    if (GetSetting('ShowMinimalErrorMessages') != 'Yes' || is_administrator() || $GLOBALS['Installer']) {

        /* show more technical details, only if admin or in development mode */
        print '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme($errmsg).'</pre>';

        /* HF20160804 backtrace added, only a a query error is practically useless */
        print '<pre style="background-color: #eee; padding: 5px; font-size: 90%;">'.htme(GetBackTrace(true)).'</pre>';
    }
    //print_r(debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS));
    /* bye bye */
    exit;
}

function htme($x)
{
    return htmlspecialchars($x, ENT_QUOTES, 'UTF-8');
}
function array_size($a)
{
    $size = 0;
    while (list($k, $v) = each($a)) {
        $size += is_array($v) ? array_size($v) : strlen($v);
    }

    return $size;
}
function string_r($array) {

    $tabsize = '    ';
    $arg = func_get_args();
    $indent = $arg[1];
    if (func_num_args() == 1) {
        $indent = $tabsize;
    }
    $contentString = '';
    foreach ($array as $name => $value) {
        if (is_array($value)) {
            $contentString .= $indent.'['.$name.'] => Array'."\n".$indent.$tabsize."(\n";
            $contentString .= string_r($value, $indent.$tabsize.$tabsize);
            $contentString .= $indent.$tabsize.")\n\n";
        } else {
            $contentString .= $indent.'['.$name.']'.'  =>  '.$value."\n";
        }
    }
    if (func_num_args() == 1) {
        $contentString = "Array\n(\n".$contentString.")\n";
    }

    return $contentString;
}

function GetUserLoginNameByID($id)
{
    if ($id != '') {
        return db_GetValue("SELECT name FROM CRMloginusers WHERE id='".mres($id)."'");
    }
}
function GetUserID($username)
{
    if ($username != '') {
        return db_GetValue("SELECT id FROM CRMloginusers WHERE name='".mres($username)."'");
    }
}
function GetUsersOfGroup($groupid)
{
    $row = '';
    if ($groupid == 0 || $groupid == '0' || $groupid == 'admin') {
        $row = db_GetFlatArray("SELECT id FROM CRMloginusers WHERE administrator='yes' AND active='yes'");
    } elseif ($groupid > 0) {
        $row = db_GetFlatArray("SELECT id FROM CRMloginusers WHERE PROFILE='".mres($groupid)."' AND active='yes'");
    }

    return $row;
}
function GetGroups()
{
    $list = db_GetArray('SELECT name, id FROM CRMuserprofiles ORDER BY name');
    $list[] = array('name' => 'Administrators', 'id' => '0');

    return $list;
}
function GetGroup($userid)
{
    if ($userid != '') {
        return db_GetValue("SELECT PROFILE FROM CRMloginusers WHERE id='".mres($userid)."'");
    }
}
function GetGroupName($groupid)
{
    if ($groupid == 0) {
        return 'Administrators';
    } elseif ($groupid != '') {
        return db_GetValue("SELECT name FROM CRMuserprofiles WHERE id='".mres($groupid)."'");
    }
}
function GetUserAccountName($userid)
{
    if (is_numeric($userid)) {
        return db_GetValue("SELECT name FROM CRMloginusers WHERE id='".mres($userid)."'");
    }
}
function GetUserName($userid)
{
    $username = '';
    //als HideUserNames aan staat mag je alleen je eigen username zien; deze logica zit zowel in de het opbouwen van de DS als ook in GetUserName()
    if (($GLOBALS['USERID'] == $userid) || (CheckFunctionAccess('HideUserNames') != 'ok')) {
        $username = db_GetValue("SELECT FULLNAME FROM CRMloginusers WHERE id='".mres($userid)."'");
    }

    return $username;
//dit werkt niet want dit kan tot eindeloze recursie leiden bij opbouwen van DS
//    return get_refer_layout_for_record("users", $userid);
}
function GetUserProfiles($specific_id = false)
{
    $profs = array();
    $res = db_GetArray("SELECT id, name FROM CRMuserprofiles WHERE active='yes' ORDER BY name");

    foreach ($res as $row) {
        array_push($profs, array($row['id'], $row['name']));
        if ($specific_id == $row['id']) {
            return $row['name'];
        }
    }
    array_push($profs, array('0', 'Administrators'));

    return $profs;
}
function GetProfiles()
{
    $row = db_GetArray("SELECT * FROM CRMuserprofiles WHERE active='yes'");
    $row[] = array('id' => '0', 'name' => 'Administrators', 'administrator' => 'yes');

    return $row;
}
function GetProfileArray($prof_num)
{
    return db_GetRow("SELECT * FROM CRMuserprofiles WHERE id='".mres($prof_num)."' AND active='yes'");
}
function GetUserEmail($userid)
{
    return db_GetValue("SELECT EMAIL FROM CRMloginusers WHERE id='".mres($userid)."'");
}
function GetFileName($fileid)
{
    if (is_positive_integer($fileid)) {
        return db_GetValue('SELECT filename FROM CRMbinfiles WHERE fileid='.$fileid);
    } else {
        return false;
    }
}
function GetTemplateByPageId($template_page_id)
{
    if ($template_page_id != '') {
        $templateid = db_GetValue("SELECT templateid FROM CRMtemplates WHERE page_id='".mres($template_page_id)."' AND templatetype='TEMPLATE_HTML' AND version_belonging_to=0");
        if (CheckTemplateAccess($templateid) == 'ok') {
            return $templateid;
        } else {
            return false;
        }
    } else {
        return false;
    }
}
function GetTemplateName($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT templatename FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function GetTemplateType($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT templatetype FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function CheckTemplateAccess($templateid)
{
    $access = 'nok';
    if (ipi($templateid)) {
        $templateid2 = db_GetValue('SELECT `templateid` FROM `CRMtemplates` WHERE `templateid`='.$templateid.' AND `version_belonging_to`=0');
        if (ipi($templateid2)) {
            if (is_administrator()) {
                $access = 'ok';
            } elseif ((db_GetValue('SELECT COUNT(*) FROM `CRMtemplateaccessrules` WHERE `template`='.$templateid2) == 0) || (db_GetValue('SELECT COUNT(*) FROM `CRMtemplateaccessrules` WHERE `template`='.$templateid2." AND `group`='".$GLOBALS['GROUPID']."' AND `read`='1'") > 0)) {
                $access = 'ok';
            }
        }
    }

    return $access;
}
function GetFileType($fileid)
{
    if (is_positive_integer($fileid)) {
        return db_GetValue('SELECT filetype FROM CRMbinfiles WHERE fileid='.$fileid);
    } else {
        return false;
    }
}
function SetFileContent($fileid, $content, $resized = false, $compressed = false)
{

    if (is_positive_integer($fileid)) {

        $resized_value = 'n';
        $compressed_value = 'n';
        $upd_ins = '';
        if ($resized || $compressed) {
            if ($resized) {
                $resized_value = 'y';
            }
            if ($compressed) {
                $compressed_value = 'y';
            }

        } else {

            $upd_ins = "
            CRMblobs.thumbnail='',
            CRMblobs.minithumbnail='',
            ";

        }

        $dontupdateindb = true;


        if (db_GetValue("SELECT offloaded FROM CRMbinfiles WHERE fileid='" . $fileid . "'")) {

            /* this file is offloaded. we need to delete it from the offloaded storage */

            $hash = GetSetting('OffLoadedFilesDirectoryHash');
            $localpath = GetSetting('OffloadFilesURL');
            if ($localpath == '') {
                $localpath = GetSetting('OffloadLocalPath');
            }
            $path = $localpath.'/'.$hash.'/'.$fileid;

            if (is_writable($path)) {

                /* update locally saved file. when running cron, and rsync should take care of the rest if you're clustering. always rsync after cron */
                file_put_contents($path, $content);

                mcq("

                    UPDATE CRMbinfiles, CRMblobs
                    SET CRMbinfiles.filesize='" . strlen($content) . "',
                    " . $upd_ins . "
                    CRMbinfiles.resized='" . mres($resized_value) . "',
                    CRMblobs.gz='" . mres($compressed_value) . "'
                    WHERE CRMblobs.fileid=CRMbinfiles.fileid
                    AND CRMbinfiles.fileid= '" . mres($fileid) . "'"

                );

            } else {

                /* fall back to database */
                $dontupdateindb = false;

            }

        }

        if (!$dontupdateindb) {
            mcq("UPDATE CRMblobs, CRMbinfiles SET CRMblobs.content='".mres($content)."',CRMbinfiles.offloaded='n',CRMbinfiles.filesize='".strlen($content)."'," . $upd_ins . "CRMbinfiles.resized='" . mres($resized_value) . "',CRMblobs.gz='" . mres($compressed_value) . "' WHERE CRMblobs.fileid=CRMbinfiles.fileid AND CRMblobs.fileid=".$fileid);
        }

        return true;

    } else {

        log_msg('ERROR: SetFileContent called with non-numeric file id.');

        return false;
    }
}
function GetTemplate($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        $selfield = '';
        if (GetTemplateType($templateid) == 'TEMPLATE_PLAIN') {
            $selfield = 'binary_content';
        } else {
            $selfield = 'content';
        }
        /*
        $cnt = GetAttribute("template", "TemplateUseCount", $templateid);
        if (!is_numeric($cnt)) {
        $cnt = 1;
        } else {
        $cnt++;
        }
        SetAttribute("template", "TemplateUseCount", $cnt, $templateid);
        */
        //2016-03-01: AND version_belonging_to=0
        $template = db_GetRow('SELECT templateid, '.$selfield.' FROM CRMtemplates WHERE templateid='.$templateid);

        if ($template["templateid"] == '') {
            log_msg('ERROR: GetTemplate searched for template "'.$templateid.'" but it returned empty!');
        }

        return $template[$selfield];
    } else {
        return false;
    }
}
function GetBlobLastModificationDate($fileid)
{
    return db_GetValue("SELECT `CRMblobs`.`timestamp_last_change` FROM `CRMblobs` WHERE `CRMblobs`.`fileid` = '".mres($fileid)."'");
}
function GetTemplateLastModificationDate($templateid)
{
    return db_GetValue("SELECT `CRMtemplates`.`timestamp_last_change` FROM `CRMtemplates` WHERE `CRMtemplates`.`templateid` = '".mres($templateid)."'");
}
function GetFileContent($fileid)
{

    if (ipi($fileid)) {
        $row = db_GetRow('SELECT * FROM CRMblobs, CRMbinfiles WHERE CRMblobs.fileid=CRMbinfiles.fileid AND CRMblobs.fileid='.$fileid);
        if ($row['fileid'] == 0) {
            log_msg('WARNING: GetFileContent Searched for file '.$fileid.' but got zero rows!');
        } elseif ($row['offloaded'] == 'y') { // This file is offloaded to secondary storage
            $hash = GetSetting('OffLoadedFilesDirectoryHash');
            $localpath = GetSetting('OffloadFilesURL');
            if ($localpath == '') {
                $localpath = GetSetting('OffloadLocalPath');
            }
            $path = $localpath.'/'.$hash.'/'.$fileid;
            $epath = $localpath.'/'.$hash.'/e'.$fileid;

            $key = GetSetting('OffLoadedFilesSSLKey');

            if ($key != '') { // file is, or must be, encrypted
                if (is_file($epath)) {

                    // File is encrypted and available
                    $row['content'] = `cat $epath | openssl aes-256-cbc -d -k $key`;

                    // Delete any unencrypted versions of the same file
                    if (is_file($path)) {
                        unlink($path);
                    }
                } elseif (is_file($path)) {
                    $row['content'] = file_get_contents($path);
                }
            } else {

                $row['content'] = file_get_contents($path);


            }
            if ($row['gz'] == 'y') {
                $b = strlen($row['content']);
                $row['content'] = gzinflate($row['content']);
                $a = strlen($row['content']);
            }

            if (!is_file($path) && GetSetting('DevelopmentOrProduction') != 'Development') {
                log_msg('ERROR: Searched for offloaded file '.$path." but couldn't find it!");
            }
        } elseif ($row['gz'] == 'y') {
            qlog(INFO, 'GetFileContent Requested file is compressed, uncompressing');
            $b = strlen($row['content']);
            $row['content'] = gzinflate($row['content']);
            $a = strlen($row['content']);
            qlog(INFO, 'GetFileContent Filesize was '.$b.', is now '.$a);
        }

        qlog(INFO, 'Returning file of '.strlen($row['content']).' bytes');

        return $row['content'];
    } else {
        return false;
    }
}
function GetTemplateSubject($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT template_subject FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function GetClearanceLevel($userid)
{
    $ret = '';

    if ($userid > 0) {
        $acr = '';

        $row = db_GetRow("SELECT CLLEVEL, PROFILE FROM CRMloginusers WHERE id='".mres($userid)."'");
        $acr = unserialize($row['CLLEVEL']);
        $bcr = $row['PROFILE'];

        if (is_numeric($bcr)) {
            $ccr = unserialize(db_GetValue("SELECT CLLEVEL FROM CRMuserprofiles WHERE id=" . $bcr));
            qlog(INFO, 'Clearance level override by profile in effect. ('.$userid.': '.$acr.', profile: '.$bcr.')');
            if (is_administrator($acr)) {
                qlog(INFO, 'This is an administrator with a profile! (regarding group setting)');
            } else {
                $acr = $ccr;
            }
            $ret = $acr;
        } else {
            qlog(INFO, 'No profile override...');
            $ret = $acr;
        }

    } else {
        $ret = '[unknown]';
        qlog(INFO, 'Function called with empty userid param!');
    }

    return $ret;
}
function is_administrator($userid = false)
{
    $response = false;

    if (!$userid) {
        $userid = $GLOBALS['USERID'];
    }

    if (isset($GLOBALS['PageCache']['ADMINARRAY'][$userid])) {
        $response = $GLOBALS['PageCache']['ADMINARRAY'][$userid];
    } else {

        // Caching all users makes no sense here, it's hardly ever queried
        $weigh = db_GetRow("SELECT administrator, CLLEVEL FROM CRMloginusers WHERE id='".mres($userid)."'");

        $cllevel = unserialize($weigh['CLLEVEL']);

        if ($weigh['administrator'] == 'yes') {
            $response = true;
        }

        if (@in_array('OnlyDevelopmentAdmin', $cllevel)) {
            if (GetSetting('DevelopmentOrProduction') != 'Development') {
                $response = false;
            } else {
                $response = true;
            }
        }

        $GLOBALS['PageCache']['ADMINARRAY'][$userid] = $response;
    }

    return $response;
}
function EndSession()
{
    if (!$GLOBALS['SesMemDontCommit']) {
        $cur = unserialize(db_GetValue("SELECT sessioncache FROM CRMsessions WHERE temp='".mres($GLOBALS['sessionid'])."'"));
        if ($cur != $GLOBALS['SesMem']) {
            mcq("UPDATE CRMsessions SET sessioncache='".mres(serialize($GLOBALS['SesMem']))."' WHERE temp='".mres($GLOBALS['sessionid'])."'");
        }
    }
}
function EndHTML($print = true)
{
    global $lang;
    static $ItHasEnded;

    if (GetSetting('DevelopmentOrProduction') == 'Development' || is_administrator()) {
        if ($print && $GLOBALS['SesMem']['ShowReasons'] && ($GLOBALS['AccessDeniedReason'] != '' || count($GLOBALS['DECISIONTRACE']) > 0)) {
            print "<pre>Reasons:\n\n";
            print $GLOBALS['AccessDeniedReason']."\n\n";
            foreach ($GLOBALS['DECISIONTRACE'] as $line) {
                print '---&gt; '.$line."\n";
            }
            print '</pre>';
        }
    }

    if ($ItHasEnded) {
        if ($print) {
            print '<h1>Warning: EndHTML called twice!</h1>';
        }

        return false;
    }

    $ItHasEnded = true;

    if ($print && $GLOBALS['sessionid'] != '') {
        $st = microtime_float();
        $list = ProcessOldTodos();
        $et = microtime_float();
        if (($et - $st) > 1) {
            log_msg("WARNING: Processing old todos in a user session took more than a second. This seriously degrades user experience. " . string_r($list));
        }
    }

    if ($print) {
        EndSession();
    }

    if ($GLOBALS['logrequests']) {
        @$fp = fopen('querylog.txt', 'a');
        @fputs($fp, $GLOBALS['USERNAME'].':'.$_SERVER['SCRIPT_NAME'].' '.$_SERVER['QUERY_STRING'].' id: '.$GLOBALS['page_id']." DONE\n");
        @fclose($fp);
    }


    if ($print) {
        print '</div>'; //Close MainContent div
    }

    if ($print || $GLOBALS['BYAJAX']) { /* if BYAJAX is set, we mean contents_only, so print javascript */
        if (is_array($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS']) || $GLOBALS['url_to_redirect_to'] != '') {
            print '<script type="text/javascript">';
            print '$(document).ready(function() {';
            if (is_array($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'])) {
                foreach ($GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'] as $ajaxBoxElement) {
                    print $ajaxBoxElement;
                }
            }

            if ($GLOBALS['url_to_redirect_to'] != '') {
                print "\n";
                print 'window.location.href = add_base_to_url(add_sessionid_to_url("' . jsencode($GLOBALS['url_to_redirect_to']) . '"));';
            }

            print '});';
            print '</script>';

        }
    }

    if ($print) {
        if ((is_positive_integer($_REQUEST['toX'])) || (is_positive_integer($_REQUEST['toY']))) {
            print JS('window.scrollTo('.$_REQUEST['toX'].','.$_REQUEST['toY'].')');
        }

        if (is_array($GLOBALS['DECISIONTRACE']) && $GLOBALS['logtext'] && $print) {
            foreach ($GLOBALS['DECISIONTRACE'] as $line) {
                print '<!-- '.$line." -->\n";
            }
        }
    }

    LogPageInfo();

    if ($GLOBALS['LogoutOnPageEnd']) {
        SetAttribute('user', 'LastLogout', date('U'), $GLOBALS['USERID']);
        //jh 2015-12-02 sessionid cookie is niet te unsetten want er is al output gestuurd
        log_msg('Logoff '.$GLOBALS['USERNAME']);
        $sql = "DELETE FROM CRMsessions WHERE temp='".mres($GLOBALS['sessionid'])."'";
        mcq($sql);
    }
    if ($GLOBALS['starttime'] && ((is_administrator()) && (GetAttribute('user', 'OnlineEditMode-ShowInlineLinks', $GLOBALS['USERID']) == 'Yes')) && $print) {
        $time_in_seconds = round(microtime_float() - $GLOBALS['starttime'], 5);
        $mpu = memory_get_peak_usage();
        $mp = '';
        if ($mpu > 20000000) {
            $mp .= '<span class="errmsg">';
        } elseif ($mpu > 10000000) {
            $mp .= '<span class="warnmsg">';
        }

        $mp .= FormatNumber($mpu,0);
        if ($mpu > 7000000) {
            $mp .= '</span>';
        }
        $qcu = $GLOBALS['mysql_query_counter'];
        $qc = '';
        if ($qcu > 600) {
            $qc .= '<span class="errmsg">';
        } elseif ($qcu > 300) {
            $qc .= '<span class="warnmsg">';
        }
        $qc .= FormatNumber($qcu,0);
        if ($qcu > 300) {
            $qc .= '</span>';
        }


        print '<div id="inlineeditmessages">Serve time: '.$time_in_seconds.'s SQL Queries: ' . 	$qc . ' Mem peak: ' . $mp . ' User: ' .htme($GLOBALS['USERNAME']) . ' App: ' . htme(GetSetting('title')) . '</div>';
    }

    if ($print) {
        if ($GLOBALS['qlog_onscreen'] && is_administrator()) {
            print '<pre>'.htme($GLOBALS['tracelog']).'</pre>';
        }
        print '</body></html>';
    }
    /* journal messages are stored in memory and inserted in 1 go */
    commit_journal();
    db_CloseConnection();
}
function CheckFunctionAccess($privilege)
{
    if (is_administrator() && $privilege != 'requiretpa') {
        return 'admin';
    }
    $cl = GetClearanceLevel($GLOBALS['USERID']);
    $ret = '';
    if (in_array($privilege, $cl)) {
        $ret = 'ok';
    } else {
        $ret = 'nok';
    }
    qlog(INFO, 'Access to privilege '.$privilege.': '.$ret);

    return $ret;
}

function RealExcel($excel, $CSVseparator, $filename = '')
{
    // HANDLES CSV OUTPUT SEPARATED BY @@@REALEXCEL@@@@ ASSUMES FIRST LINE IS LEGEND
    // $WrappedCellsEachLine must contain array with horiz. fields list (numbers) of cells
    // that must be wrapped
    if (GetSetting('EXCELFILEFORMAT') != '2003') {
        qlog(INFO, 'Going to 2007 mode..');
        require 'excel2007.php';
        //require ("phpspreadsheet.php");
        RealExcel2007($excel, $CSVseparator, 'xlsx', '', $filename);
    } else {
        require_once 'lib/excel2003/Writer.php';
        //print($GLOBALS['PATHTOINTERLEAVE'] . 'lib/Writer.php');
        $filename = str_replace(' ', '_', GetSetting('title')).'-'.$GLOBALS['PRODUCT'].'-export-'.date('m-j-Y-Hi').'h.xls';
        $summ = $GLOBALS['PRODUCT'].'-export';
        // Creating a workbook
        $workbook = new Spreadsheet_Excel_Writer();
        // sending HTTP headers
        $workbook->send($filename);
        // Creating a worksheet
        $worksheet = &$workbook->addWorksheet($summ);
        $worksheet->setLandscape();
        $worksheet->setHeader($summ);
        $format_normal = &$workbook->addFormat();
        $format_normal->setSize(9);
        //s	$format_normal -> setBorder(1);
        $format_bold = &$workbook->addFormat();
        $format_bold->setBold();
        $format_bold->setColor('white');
        $format_bold->setPattern(1);
        $format_bold->setFgColor('blue');
        $format_bold->setSize(9);
        //	$format_bold -> setBorder(1);
        $format_wrapped = &$workbook->addFormat();
        $format_wrapped->setTextWrap();
        $format_wrapped->setSize(9);
        //	$format_wrapped -> setBorder(1);
        $format_rowheader = &$workbook->addFormat();
        $format_rowheader->setBold();
        $format_rowheader->setFgColor('gray');
        $format_rowheader->setSize(9);
        //	$format_rowheader -> setBorder(1);
        $line = 0;
        $max_col_width = array();
        // Create header in format_bold
        $header = array();
        if ($CSVseparator != 'array') {
            $header = explode($CSVseparator, $excel[0]);
        } else {
            $header = $excel[0];
        }
        for ($i = 0; $i < sizeof($header); ++$i) {
            $worksheet->write(0, $i, $header[$i], $format_bold);
            $max_col_width[$i] = strlen($header[$i]);
        }
        $linecount = 1;
        for ($i = 1; $i < sizeof($excel); ++$i) {
            if ($CSVseparator != 'array') {
                $line = explode($CSVseparator, $excel[$i]); // get current line and array' it
            } else {
                $line = $excel[$i];
                $line[] = '';
            }

            for ($u = 0; $u < sizeof($line); ++$u) {
                if ($line[$u]) {
                    if ($u == 0) {
                        if (is_numeric($line[$u])) {
                            $worksheet->writeNumber($linecount, $u, $line[$u], $format_rowheader);
                            // qlog(INFO, "CHOOSE 1NUM for val " . $line[$u]);
                        } else {
                            $worksheet->writeString($linecount, $u, $line[$u], $format_rowheader);
                            // qlog(INFO, "CHOOSE 1STR for val " . $line[$u]);
                        }
                    } elseif (stristr($line[$u], '@@@@WRAPPED@@@@')) {
                        $line[$u] = str_replace('@@@@WRAPPED@@@@', '', $line[$u]);
                        if (substr($line[$u], 0, 1) == '@') {
                            $line[$u] = "'".$line[$u];
                        }

                        if (is_numeric($line[$u])) {
                            $worksheet->writeNumber($linecount, $u, $line[$u], $format_wrapped);
                            // qlog(INFO, "CHOOSE 2NUM for val " . $line[$u]);
                        } else {
                            $worksheet->writeString($linecount, $u, $line[$u], $format_wrapped);
                            // qlog(INFO, "CHOOSE 2STR for val " . $line[$u]);
                        }
                    } elseif (stristr($line[$u], '@@@@HEXCOLOR')) {
                        $tmp = explode('@@@@HEXCOLOR', $line[$u]);

                        $hex = ltrim($tmp[1], '#');
                        $tmpvar = 'format_'.$hex;

                        if (!$$tmpvar) {
                            $$tmpvar = &$workbook->addFormat();
                        }
                        $ExcelColor = GetExcelColorName($hex);
                        $$tmpvar->setSize(9);
                        $$tmpvar->setBorder(1);
                        $$tmpvar->setFgColor($ExcelColor);
                        if (substr($line[$u], 0, 1) == '@') {
                            $line[$u] = "'".$line[$u];
                        }
                        if (is_numeric($tmp[2])) {
                            $worksheet->writeNumber($linecount, $u, $tmp[2], $$tmpvar);
                            // qlog(INFO, "CHOOSE 3NUM for val " . $tmp[2]);
                        } else {
                            $worksheet->writeString($linecount, $u, $tmp[2], $$tmpvar);
                            // qlog(INFO, "CHOOSE 3STR for val " . $tmp[2]);
                        }
                    } else {
                        if (substr($line[$u], 0, 1) == '@') {
                            $line[$u] = "'".$line[$u];
                        }
                        if (is_numeric($line[$u])) {
                            $worksheet->writeNumber($linecount, $u, $line[$u], $format_normal);
                            // qlog(INFO, "CHOOSE 4NUM for val " . $line[$u]);
                        } else {
                            $worksheet->writeString($linecount, $u, $line[$u], $format_normal);
                            // qlog(INFO, "CHOOSE 4STR for val " . $line[$u]);
                        }
                    }
                    if ($max_col_width[$u] < strlen($header[$u])) {
                        $max_col_width[$u] = strlen($header[$u]);
                    }
                }
            }
            ++$linecount;
        }

        // Now adjust the cell width
        for ($i = 0; $i < sizeof($max_col_width); ++$i) {
            if ($max_col_width[$i]) {
                $worksheet->setColumn($i, $i, ($max_col_width[$i] * 2));
            }
        }
        // Let's send the file
        $workbook->close();
    }
}
function GetExcelColorName($hex)
{
    // array met excel kleuren
    $color = array();
    array_push($color, array('00', '00', '00', 8)); // 8
    array_push($color, array('ff', 'ff', 'ff', 9)); // 9
    array_push($color, array('ff', '00', '00', 10)); // 10
    array_push($color, array('00', 'ff', '00', 11)); // 11
    array_push($color, array('00', '00', 'ff', 12)); // 12
    array_push($color, array('ff', 'ff', '00', 13)); // 13
    array_push($color, array('ff', '00', 'ff', 14)); // 14
    array_push($color, array('00', 'ff', 'ff', 15)); // 15
    array_push($color, array('80', '00', '00', 16)); // 16
    array_push($color, array('00', '80', '00', 17)); // 17
    array_push($color, array('00', '00', '80', 18)); // 18
    array_push($color, array('80', '80', '00', 19)); // 19
    array_push($color, array('80', '00', '80', 20)); // 20
    array_push($color, array('00', '80', '80', 21)); // 21
    array_push($color, array('c0', 'c0', 'c0', 22)); // 22
    array_push($color, array('80', '80', '80', 23)); // 23
    array_push($color, array('99', '99', 'ff', 24)); // 24
    array_push($color, array('99', '33', '66', 25)); // 25
    array_push($color, array('ff', 'ff', 'cc', 26)); // 26
    array_push($color, array('cc', 'ff', 'ff', 27)); // 27
    array_push($color, array('66', '00', '66', 28)); // 28
    array_push($color, array('ff', '80', '80', 29)); // 29
    array_push($color, array('00', '66', 'cc', 30)); // 30
    array_push($color, array('cc', 'cc', 'ff', 31)); // 31
    array_push($color, array('00', '00', '80', 32)); // 32
    array_push($color, array('ff', '00', 'ff', 33)); // 33
    array_push($color, array('ff', 'ff', '00', 34)); // 34
    array_push($color, array('00', 'ff', 'ff', 35)); // 35
    array_push($color, array('80', '00', '80', 36)); // 36
    array_push($color, array('80', '00', '00', 37)); // 37
    array_push($color, array('00', '80', '80', 38)); // 38
    array_push($color, array('00', '00', 'ff', 39)); // 39
    array_push($color, array('00', 'cc', 'ff', 40)); // 40
    array_push($color, array('cc', 'ff', 'ff', 41)); // 41
    array_push($color, array('cc', 'ff', 'cc', 42)); // 42
    array_push($color, array('ff', 'ff', '99', 43)); // 43
    array_push($color, array('99', 'cc', 'ff', 44)); // 44
    array_push($color, array('ff', '99', 'cc', 45)); // 45
    array_push($color, array('cc', '99', 'ff', 46)); // 46
    array_push($color, array('ff', 'cc', '99', 47)); // 47
    array_push($color, array('33', '66', 'ff', 48)); // 48
    array_push($color, array('33', 'cc', 'cc', 49)); // 49
    array_push($color, array('99', 'cc', '00', 50)); // 50
    array_push($color, array('ff', 'cc', '00', 51)); // 51
    array_push($color, array('ff', '99', '00', 52)); // 52
    array_push($color, array('ff', '66', '00', 53)); // 53
    array_push($color, array('66', '66', '99', 54)); // 54
    array_push($color, array('96', '96', '96', 55)); // 55
    array_push($color, array('00', '33', '66', 56)); // 56
    array_push($color, array('33', '99', '66', 57)); // 57
    array_push($color, array('00', '33', '00', 58)); // 58
    array_push($color, array('33', '33', '00', 59)); // 59
    array_push($color, array('99', '33', '00', 60)); // 60
    array_push($color, array('99', '33', '66', 61)); // 61
    array_push($color, array('33', '33', '99', 62)); // 62
    array_push($color, array('33', '33', '33', 63)); // 63
    $ir = hexdec(substr($hex, 0, 2));
    $ig = hexdec(substr($hex, 2, 2));
    $ib = hexdec(substr($hex, 4, 2));
    $currnaast = 255 * 255 * 255; // max wat naast is
    $currkleurnaam = 'fout!';
    for ($i = 0; $i < sizeof($color); ++$i) {
        $r = $color[$i][0];
        $g = $color[$i][1];
        $b = $color[$i][2];
        $kleurnaam = $color[$i][3];
        $tmpnaast = (abs($ir - hexdec($r)) + abs($ig - hexdec($g)) + abs($ib - hexdec($b)));
        if ($tmpnaast < $currnaast) {
            $currkleurnaam = $kleurnaam;
            $currnaast = $tmpnaast;
        }
    }

    return $currkleurnaam;
}
function MustBeAdmin()
{
    if (!is_administrator($GLOBALS['USERID'])) {
	PrintAD('You do not have the required clearance level to access this page/function.');
        EndHTML();
        exit;
        // Yes, i know this is dirty.
    }
}
function fillout($var, $len, $nofill = false)
{
    if (strlen($var) >= $len) {
        return substr($var, 0, ($len - 3)).'...';
    } elseif (!$nofill) {
        return str_pad($var, $len, ' ');
    } else {
        return $var;
    }
}
function FormattedDateToNLDate($date)
{
    if (strlen($date) == 10) {
        $dates = explode('-', $date);
        $d = '';
        $m = '';
        $y = '';
        if ($GLOBALS['UC']['DateFormat'] == 'dd-mm-yyyy') {
            $d = $dates[0];
            $m = $dates[1];
            $y = $dates[2];
        } elseif ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
            $d = $dates[1];
            $m = $dates[0];
            $y = $dates[2];
        } elseif ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
            $d = $dates[2];
            $m = $dates[1];
            $y = $dates[0];
        }

        return $d.'-'.$m.'-'.$y;
    }
}
function StrDateTime2IsoDateTime($strdatetime)
{
    $strdatetime = trim($strdatetime);
    //meerdere spaties naar 1 spatie
    $strdatetime = preg_replace('/  +/', ' ', $strdatetime);

    $parts = explode(' ', $strdatetime);
    $strdate = '';
    $strtime = '';
    //zodat "10 5 14 23:55" ingevoegd kan worden; de spatie is ook een datum separator
    if (count($parts) == 4) {
        $strtime = array_pop($parts);
        $strdate = implode(' ', $parts);
    } else {
        $strdate = $parts[0];
        $strtime = $parts[1];
    }

    $isodate = StrDate2IsoDate($strdate);
    $isotime = '';

    //een lege tijd wordt geaccepteerd
    if ($strtime == '') {
        $isotime = '00:00:00';
    }
    //er kan alleen een 24 uur klok worden ingevoerd; geen support voor am/pm
    //support voor : als separator, of niks ""
    //er kan worden ingevoerd MET secondes of ZONDER secondes
    //2:03 -> 02:03:00
    //1:05:00 -> 01:05:00
    //24:0 -> "" FOUT
    //930 -> 09:30:00
    //000002:000000000:00000000019 -> "" FOUT
    elseif (preg_match("/^(\d{1,2})\:?(\d{2})(\:?(\d{2}))?$/", $strtime, $matches)) {
        $hour = $matches[1];
        $minute = $matches[2];
        $second = $matches[4];

        //seconde moet eigenlijk <= 60 zijn ivm mogelijke schrikkelsecondes
        if (($hour <= 23) && ($minute <= 59) && ($second <= 59)) {
            $isotime = sprintf('%02d:%02d:%02d', $hour, $minute, $second);
        }
    }

    $isodatetime = '';
    if (($isodate != '') && ($isotime != '')) {
        $isodatetime .= $isodate.' '.$isotime;
    }

    return $isodatetime;
}
function StrDate2IsoDate($strdate)
{
    $strdate = trim($strdate);
    $accept_2_digit_year = true;

    $dateparts = array();

    $dateformat = array();
    if ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
        $dateformat = array('y', 'm', 'd');
    } elseif ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
        $dateformat = array('m', 'd', 'y');
    } else {
        //dd-mm-yyyy
        $dateformat = array('d', 'm', 'y');
    }

    /*
    01-05-2014 = 2014-05-01
    01052014   = 2014-05-01
    1-5-2014   = 2014-05-01
    010514     = 2014-05-01
    1/5/14     = 2014-05-01
    1.5.2014   = 2014-05-01
    28/07/1949 = 1949-07-28
    1214       = 2014-02-01
    01022014   = 2014-02-01
    010214     = 2014-02-01
    4 8 21     = 1921-08-04
    9 12 20    = 2020-12-09
    */

    foreach (array('-', '/', '.', ' ', '') as $separator) {
        $regexp = '/^';
        $partcounter = 0;
        foreach ($dateformat as $dateformatpart) {
            if ($partcounter > 0) {
                $regexp .= preg_quote($separator, '/');
            }
            if ($dateformatpart == 'y') {
                //jaar: 2 of 4 cijfers
                if ($accept_2_digit_year) {
                    $regexp .= "(\d{2}(\d{2})?)";
                } else {
                    $regexp .= "(\d{4})";
                }
            } else {
                //dag of maand; 1 of 2 cijfers
                $regexp .= "(\d{1,2})";
            }
            ++$partcounter;
        }
        $regexp .= '$/';

        if (preg_match($regexp, $strdate, $match)) {
            $partcounter = 0;
            foreach ($dateformat as $dateformatpart) {
                ++$partcounter;
                $dateparts[$dateformatpart] = $match[$partcounter];
                if (($accept_2_digit_year) && ($dateformatpart == 'y')) {
                    //because of extra nested ( ) condition in regexp
                    ++$partcounter;
                    //2 digit year
                    if ($dateparts[$dateformatpart] < 100) {
                        //Y2K bug fix; assuming 1921 to 2020
                        if ($dateparts[$dateformatpart] > 20) {
                            $dateparts[$dateformatpart] += 1900;
                        } else {
                            $dateparts[$dateformatpart] += 2000;
                        }
                    }
                }
            }
            break;
        }
    }

    $isodate = '';
    if (checkdate($dateparts['m'], $dateparts['d'], $dateparts['y'])) {
        $isodate = sprintf('%04d-%02d-%02d', $dateparts['y'], $dateparts['m'], $dateparts['d']);
    }

    return $isodate;
}
function SQLDateTimeToFormattedDateTime($datetime)
{
    $ret = '';
    if ($datetime != '') {
        $valAr = array();
        $valAr[0] = substr($datetime, 0, 10);
        $valAr[1] = substr($datetime, 11, 5);

        $valAr[0] = TransformDate(INTLDate2NLDate($valAr[0]));
        $valAr[1] = TransformTime($valAr[1]);

        $ret = $valAr[0].' '.$valAr[1];
    }

    return $ret;
}
function IsFormattedDate($date = false)
{
    // $date is in format dd-mm-yyyy
    if (strlen($date) != 10) {
        return false;
    }

    $dates = explode('-', $date);
    $d = '';
    $m = '';
    $y = '';

    if ($GLOBALS['UC']['DateFormat'] == 'dd-mm-yyyy') {
        $d = $dates[0];
        $m = $dates[1];
        $y = $dates[2];
    } elseif ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
        $d = $dates[1];
        $m = $dates[0];
        $y = $dates[2];
    } elseif ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
        $d = $dates[2];
        $m = $dates[1];
        $y = $dates[0];
    }
    // bool checkdate ( int month, int day, int year)
    if (@checkdate($m, $d, $y)) {
        return true;
    } else {
        return false;
    }
}
function randomstring($length, $humanreadable = false)
{
    $randomstring = '';
    $randomchars = array();
    if ($humanreadable) {
        //geen cijfers
        //$randomchars = array("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");

        //zonder "0", "1", "2", "a", "e", "i", "l", "o", "u", "y", "z" -> die chars kunnen verwarring geven OF kunnen woorden vormen (alle klinkers zijn eruit)
        //specifiek bedoeld voor het maken van wachtwoorden
        $randomchars = array('3', '4', '5', '6', '7', '8', '9', 'b', 'c', 'd', 'f', 'g', 'h', 'j', 'k', 'm', 'n', 'p', 'q', 'r', 's', 't', 'v', 'w', 'x', 'B', 'C', 'D', 'F', 'G', 'H', 'J', 'K', 'M', 'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'X');
    } else {
        // volledige alfabet (zowel upper als lowercase); 62 karakters
        $randomchars = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
    }
    // alleen hexadecimale karakters; slechts 16 karakters en dus een stuk minder goed beveiligd
    // $randomchars = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f");
    $maxpos = count($randomchars) - 1;
    for ($x = 0; $x < $length; ++$x) {
        $randomstring .= $randomchars[mt_rand(0, $maxpos) ];
    }

    return $randomstring;
}
function readln()
{
    // 4092 max on win32 fopen
    //$fp=fopen("php://stdin", "r");
    //$in=fgets($fp,4094);
    //fclose($fp);
    $in = fgets(STDIN);

    // strip newline
    (PHP_OS == 'WINNT') ? ($read = str_replace("\r\n", '', $in)) : ($read = str_replace("\n", '', $in));

    return $read;
}
function Author()
{
    require_once $GLOBALS['PATHTOINTERLEAVE'].'ath.php';
    exit;
}
function PushStashValue($value)
{
    // This function puts a stash (cache) value into the database and returns the reference number
    //qlog(INFO, 'Start pushing stash value');
    if (is_array($value)) {
        $value = serialize($value);
    }
    $id = 0;

    if (strlen($value) > 0) {
        $epoch = date('U');
        $sql = "INSERT INTO CRMcache(value,epoch,session) VALUES('".mres($value)."','".mres($epoch)."', '".mres($GLOBALS['sessionid'])."')";
        mcq($sql);
        $id = db_GetInsertId();
        qlog(INFO, 'Pushed stash value '.$id);
    } else {
        qlog(ERROR, 'ERROR - cannot push empty variable!');
    }

    return $id;
}
function PopStashValue($stashid)
{
    // This function retreives a stash (cache) value from the database and returns the contents of the record
    $val = db_GetValue("SELECT value FROM CRMcache WHERE stashid='".mres($stashid)."' AND session='".mres($GLOBALS['sessionid'])."'");

    qlog(INFO, 'Popped stash value '.$stashid);
    $ar = unserialize($val);
    if (is_array($ar)) {
        $val = $ar;
    }

    return $val;
}

function UpdateStashValue($stashid, $value)
{
    // This function deletes a stash (cache) value from the database
    if (is_array($value)) {
        $value = serialize($value);
    }
    $epoch = date('U');
    $sql = "UPDATE CRMcache SET value='".mres($value)."',epoch='".$epoch."' WHERE stashid='".mres($stashid)."' AND session='".mres($GLOBALS['sessionid'])."'";
    mcq($sql);
    qlog(INFO, 'Updated stash value '.$stashid);

    return true;
}
function GetBackTrace($args = true)
{
    ob_start();
    if ($args) {
        debug_print_backtrace();
    } else {
        debug_print_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
    }
    $ret = ob_get_contents();
    ob_end_clean();
    //2016-02-11
    //return "\n\n" . $ret;
    return $ret;
}
function pdf($imp)
{
    //jh 2016-05-27 deze kan 80% zeker weg
    // LEAVE IN PLACE
//deze warning erin gezet op 2016-12-21; als we 2017-01-31 nog geen warnings hebben gehad dan kan de functie weg
log_msg('ERROR: function pdf() called! remove this call');

    return $imp;
}
function plain($imp)
{
    //jh 2016-05-27 deze kan 99% zeker weg
    // LEAVE IN PLACE
//deze warning erin gezet op 2016-12-21; als we 2017-01-31 nog geen warnings hebben gehad dan kan de functie weg
log_msg('ERROR: function plain() called! remove this call');

    return $imp;
}

function ParseInlineAddFormTags($template)
{
    // Fetch all tags from template
    // Syntax: #INLINEADD|table=tX|template=Y|t12-f56=XX|reload_on_submit=|open_after_add=1|0#
    preg_match_all('/\#INLINEADD(.*?)\#/', $template, $matches);
    foreach ($matches[0] as $listoptions_string) {
        $table_id = '';
        $template_id = '';
        $submitbuttontext = '';
        $listtoreloadaftersubmit = '';
        $open_after_add = '';

        // Strip tag open name
        $clean = str_replace('#INLINEADD', '', $listoptions_string);

        // Stip closing #
        $clean = substr($clean, 0, strlen($clean) - 1);

        // Tag directives are seperated by |'s
        $ar = explode('|', $clean);

        $tagvals = array();

        foreach ($ar as $argument) {

            // Key/value pairs are seperated by ='s
            list($key, $val) = explode('=', $argument);

            if ($key == 'table') {
                $table_id = $val;
            } elseif ($key == 'template') {
                $template_id = $val;
            } elseif ($key == 'submitbuttontext') {
                $submitbuttontext = $val;
            } elseif ($key == 'reload_on_submit') {
                $listtoreloadaftersubmit = $val;
            } elseif ($key == 'open_after_add') {
                $open_after_add = $val;
            }

            $tagvals[$key] = $val;
        }
        $tagvals['outerdiv'] = $table_id.'-_new_';

        $template = str_replace($listoptions_string, '<div id="'.$tagvals['outerdiv'].'">'.escape_interleave_characters(InlineSimpleAddForm($table_id, $template_id, $submitbuttontext, $tagvals, $listtoreloadaftersubmit, '', $open_after_add)).'</div>', $template);
    }

    return $template;
}
function get_list_options_and_descriptions()
{
    return array(

    'outputtype' => array('Description' => 'The output type', 'Valid' => array('table', 'tile'), 'Default' => 'table'),

    'RemoveExtraSelectCondition' => array('Description' => 'When set removes the Extra Select Condition', 'Valid' => array(true, false), 'Default' => false),

    'disable_click_record_to_open' => array('Description' => 'When set, clicking a row in the table will do nothing', 'Valid' => array(true, false), 'Default' => false),

    'filter' => array('Description' => 'Filters to set', 'Valid' => '', 'Example' => 'filter_t12-f34=Yes', 'Default' => ''),

    'filtertype' => array('Description' => 'The type of the filter', 'Valid' => array('IS', 'NOT'), 'Default' => ''),

    'hiddenfilter' => array('Description' => 'Hidden filters to set. Hidden filters cannot be disabled by users.', 'Valid' => '', 'Example' => 'hiddenfilter_t12-f34=Yes', 'Default' => ''),

    'hiddenfiltertype' => array('Description' => 'The hidden filter type', 'Valid' => array('IS', 'NOT'), 'Default' => ''),

    'hide_add_up_total' => array('Description' => 'When true, the column add-up will not be shown.', 'Valid' => array(true, false), 'Default' => false),

    'hide_addlink' => array('Description' => 'When true, the add-a-record link will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_addrow' => array('Description' => 'When false, the first row of a table will be a form to add a record', 'Valid' => array(true, false), 'Default' => true),

    'hide_all' => array('Description' => 'When set, hides everything there is to hide except the table itself', 'Valid' => array(true, false), 'Default' => false),

    'hide_bottom_pagination' => array('Description' => 'When set, the bottom prev/next arrow and page selector will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_filters' => array('Description' => 'When set, column filters will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_header' => array('Description' => 'When set, the table title header and html as set on the table preference page will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'customheader' => array('Description' => 'Overrules default header', 'Valid' => '', 'Default' => ''),

    'hide_human_readable_filter' => array('Description' => 'When set, the human-readable filters will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_id_input' => array('Description' => 'When set, the input field used to open a record by entering its id will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'id_input_in_search' => array('Description' => 'Uses search box for recordid input, when 123 is a valid record, it is opened, otherwise it is searched for. to search for a literal number, use quotes; "123"', 'Valid' => array(true, false), 'Default' => false),

    'hide_listlayout' => array('Description' => 'When set, select-columns icon will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_listlayoutselector' => array('Description' => 'When set, the list-layout-selector will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_modules' => array('Description' => 'When set, icons to run modules will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_must_be_must_not_be_filter' => array('Description' => "When set, users won't have the options MUST BE and MUST NOT BE in the filters", 'Valid' => array(true, false), 'Default' => false),

    'hide_outputtype_excel' => array('Description' => 'When set, the excel-download icon will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_outputtype_table' => array('Description' => 'When set, the table view link will not be shown', 'Valid' => array(true, false), 'Default' => true),

    'hide_outputtype_tile' => array('Description' => 'When set, the tile view link will not be shown', 'Valid' => array(true, false), 'Default' => true),

    'hide_outputtype_tsv' => array('Description' => 'When set, the TSV-download icon will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_outputtype_xml' => array('Description' => 'When set, the XML-download icon will not be shown', 'Valid' => array(true, false), 'Default' => ''),

    'hide_pagination_if_only_1_page' => array('Description' => 'When set, page navigation elements will not be shown if the results fit on one page', 'Valid' => array(true, false), 'Default' => false),

    'hide_perpage' => array('Description' => 'When set, the number-of-results-to-show-per-page box will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_recent' => array('Description' => 'When set, the option to show the most recently accessed records will not be shown', 'Valid' => array(true, false), 'Default' => true),

    'hide_recordcounter' => array('Description' => 'When set, the total sum of found records and current page window count will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_search' => array('Description' => 'When set, the search-box will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_selections' => array('Description' => 'When set, the selections drop-down and create-selections items will not be shown', 'Valid' => array(true, false), 'Default' => false),

    'hide_sortby' => array('Description' => 'When set, sorting will not be possible (icons will be hidden and column name will not sort that column)', 'Valid' => array(true, false), 'Default' => false),

    'listid' => array('Description' => 'The DOM id of the list (leave empty)', 'Valid' => '', 'Default' => ''),

    'listlayoutcolumns' => array('Description' => 'When given, these columns will be shown, any list layout will be ignored', 'Valid' => '', 'Example' => 't1-f12,t23-f34', 'Default' => ''),

    'listname' => array('Description' => 'The identifier for this list, mainly used for fetching the layout', 'Valid' => '', 'Example' => 'Any name', 'Default' => ''),

    'perpage' => array('Description' => 'The number of rows to show per page', 'Valid' => explode(',', GetSetting('PAGINATEOPTIONSLIST')), 'Default' => ''),

    'recent' => array('Description' => 'The number of recently opened records to show', 'Valid' => '', 'Example' => '50 (any number above zero)', 'Default' => ''),

    'sameresultandpage' => array('Description' => 'When set, the user will be brought back to EXACT the same place as last shown', 'Valid' => array(true, false), 'Default' => false),

    'search' => array('Description' => 'A search query', 'Valid' => '', 'Default' => ''),

    'search_highlight_only' => array('Description' => 'When set, all records will be shown, but records which match [search] will be highlighted (first column)', 'Valid' => array(true, false), 'Default' > false),

    'hiddensearch' => array('Description' => 'A search query (hidden)', 'Valid' => '', 'Default' => ''),

    'search_childs' => array('Description' => 'Whether or not to also descend to childs when searching', 'Valid' => array(true, false), 'Default' => true),

    'search_files' => array('Description' => 'Whether or not to also descend to attachments when searching', 'Valid' => array(true, false), 'Default' => true),

    'search_parents' => array('Description' => 'Whether or not to also ascend to parents when searching', 'Valid' => array(true, false), 'Default' => true),

    'searchperfield' => array('Description' => 'An array containing the searches per field', 'Valid' => '', 'Example' => 'searchperfield[t1-f2]=test', 'Default' => ''),

    'hiddensearchperfield' => array('Description' => 'An array containing the searches per field (hidden)', 'Valid' => '', 'Example' => 'hiddensearchperfield[t1-f2]=test', 'Default' => ''),

    'selectionnew' => array('Description' => 'The selection to load (visible)', 'Valid' => '', 'Example' => 'Any valid selection name', 'Default' => ''),

    'sortby' => array('Description' => 'The column to sort by', 'Valid' => '', 'Example' => 't12-f23', 'Default' => ''),

    'sortdirection' => array('Description' => 'The sort direction', 'Valid' => array('asc', 'desc'), 'Default' => 'asc'),

    'table' => array('Description' => 'The table to show', 'Valid' => '', 'Required' => true, 'Example' => 't12', 'Default' => ''),

    'tabletype' => array('Description' => 'Select-table or normal table', 'Valid' => array('normal', 'select', 'plain'), 'Default' => 'normal'),

    'start' => array('Description' => 'The record to start with', 'Valid' => '', 'Default' => ''),

    'type_of_list' => array('Description' => 'The list type', 'Valid' => array('mainlist', 'sublist'), 'Default' => 'mainlist'),

    'use_adaptive_filters' => array('Description' => 'When set, filter result counts will show the remaining number of matches and filters will only show values left in the current result set', 'Valid' => array(true, false), 'Default' => true),

    'ignorelastview' => array('Description' => 'When set, ignores last set filters, selection, search, etc.', 'Valid' => array(true, false), 'Default' => true),

    'BYAJAX' => array('Description' => 'When set, the first list will be loaded using ajax', 'Valid' => array(false, true), 'Default' => false),

    'hidetableheaderwhennoresults' => array('Description' => 'When set, the table column header will not be displayed when the result set contains 0 rows', 'Valid' => array(false, true), 'Default' => false),

    'hidetableheader' => array('Description' => 'When set, the table column header will not be displayed at all', 'Valid' => array(false, true), 'Default' => false),

    'hide_tablewhennoresults' => array('Description' => 'When set and if the record set contains zero records, the table will not be shown, the file browse box or add link will however still be shown', 'Valid' => array(false, true), 'Default' => false),

    'hide_massupdate' => array('Description' => 'When set, the massupdate checkboxes will not be shown', 'Valid' => array(false, true), 'Default' => false),

    'countonly' => array('Description' => 'When set, the function will only return a count', 'Valid' => array(false, true), 'Default' => false),

    'add_class_to_each_cell' => array('Description' => 'Adds class="fXXX" to each td, dt or dd. Useful for css styling of particular columns. Does cause quite a lot of extra html data.', 'Valid' => array(false, true), 'Default' => false),

    'group' => array('Description' => 'Return multiple lists grouped by this field tX-fY', 'Valid' => '', 'Default' => ''),

    'hide_groupedcolumn' => array('Description' => 'Hides the grouped column', 'Valid' => array(false, true), 'Default' => true),

    'hide_empty_cells' => array('Description' => 'Hide empty <td></td>, default true for tile <dd></dd>. Sets hidetableheader to true. Do not use in conjunction with add_up_total. It is much better to use td:empty{display: none;} instead of this setting, however, this kind of css is not supported in the current version of mpdf', 'Valid' => array(false, true), 'Default' => false),

    'continuous_scroll' => array('Description' => 'Use continuous scrolling (=infinite scrolling) instead of pagination', 'Valid' => array(false, true), 'Default' => false),

    'template_id' => array('Description' => 'Template id to be used as parsed list output, only in combination with outputtype=template', 'Valid' => '', 'Default' => 0),

    'template_to_use_open' => array('Description' => 'Template id to be used to open the record', 'Valid' => '', 'Default' => 0),

    'selectvia' => array('Description' => 'example: selectvia: t3-f33-f2-f22-t1-recordid t1 = companies, t2 = contactpersons, t3 = invoice. an invoice is linked to a contactperson of a company. With this selectvia we select a company first and then drilldown to choose a contactperson who works at the selected company', 'Valid' => '', 'Default' => ''),

    'selectviafilter' => array('Description' => 'selectvia filters; these are created automatically; no need to fill them manually', 'Valid' => '', 'Default' => ''),

    'childrecordid' => array('Description' => 'child record id only for selectvia lists', 'Valid' => '', 'Default' => 0),

    'watch' => array('Description' => 'Loads new records into list automatically every N seconds', 'Valid' => '', 'Default' => 0),

    'do_not_check_write_access' => array('Description' => 'Skips checking of write access; is in use for calendars, downloads of lists, among other places can only be set for an internal list call (not via GET)', 'Valid' => array(false, true), 'Default' => false),

    );
}
function ConvertTagOptionsToListOptions($listoptions_string)
{

    /* html encoded entities could exist in this template */
    $listoptions_string = html_entity_decode($listoptions_string);

    // Fetch possible list options
    $possible_list_options = get_list_options_and_descriptions();

    // Array to hold the assoc array as input for make_list
    $listoptions = array();

    // Tag directives are seperated by |'s
    $ar = explode('|', $listoptions_string);

    foreach ($ar as $argument) {

        // Key/value pairs are seperated by ='s
        list($key, $val) = explode('=', $argument);

        if (substr($key, 0, 7) == 'filter_') {
            $key = substr($key, 7, strlen($key) - 7);
            $elementname = '';
            if (strstr($key, '_from')) {
                $elementname = 'from';
                $key = str_replace('_from', '', $key);
            } elseif (strstr($key, '_to') && substr($key, strlen($key) - 20, 20) != 'version_belonging_to') {
                $elementname = 'to';
                $key = str_replace('_to', '', $key);
            }
            if ($elementname != '') {
                $listoptions['filter'][$key][$elementname] = $val;
            } else {
                $listoptions['filter'][$key][] = $val;
            }
        } elseif (substr($key, 0, 11) == 'filtertype_') {
            $key = substr($key, 11, strlen($key) - 11);
            $listoptions['filtertype'][$key] = $val;
        } elseif (substr($key, 0, 13) == 'hiddenfilter_') {
            $key = substr($key, 13, strlen($key) - 13);
            if (strstr($key, '_from')) {
                $key = str_replace('_from', '', $key);
                $listoptions['hiddenfilter'][$key]['from'] = $val;
            } elseif (strstr($key, '_to') && substr($key, strlen($key) - 20, 20) != 'version_belonging_to') {
                $key = str_replace('_to', '', $key);
                $listoptions['hiddenfilter'][$key]['to'] = $val;
            } else {
                $listoptions['hiddenfilter'][$key][] = $val;
            }
        } elseif (substr($key, 0, 17) == 'hiddenfiltertype_') {
            $key = substr($key, 17, strlen($key) - 17);
            $listoptions['hiddenfiltertype'][$key] = $val;
        } elseif ($key == 'countonly' && $val == '1') {
            // This means the function should return a count only, not an actual list
            $listoptions[$key] = $val;
        } elseif ($key == 'reporttype') {
            // This an option for the #REPORT tag
            if ($val == 'excel') {
                $listoptions[$key] = $val;
            } elseif ($val == 'pdf') {
                $listoptions[$key] = $val;
            } elseif ($val == 'html') {
                $listoptions[$key] = $val;
            } elseif ($val == 'json') {
                $listoptions[$key] = $val;
            } elseif ($val == 'xml') {
                $listoptions[$key] = $val;
            } else {
                print Alert('Invalid value of key reporttype: ['.$val.']');
            }
        } elseif ($key == 'filename') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key == 'alldata') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key == 'linktext') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key == 'table') {
            // This an option for the #REPORT tag
            $listoptions[$key] = $val;
        } elseif ($key != '') {
            if (!is_array($possible_list_options[$key]) && $val != '') {
                print Alert('Parse error in LIST tag: '.$key.' having value '.$val.' : option unknown');
            }
            // It's a regular key/value pair
            $listoptions[$key] = $val;
        }
    }

    return $listoptions;
}
function ParseTemplateListTags($template)
{
    // Example: #LIST|table=t1|filter_t1-f3=@t2-recordid@#
    // Fetch all tags from template
    preg_match_all('/#LIST(.*?)#/', $template, $matches);
    $lists = array_unique($matches[1]);

    // Loop through tags
    foreach ($lists as $listoptions_string) {
        $listoptions = array();
        $return_count = false;

        $listoptions = ConvertTagOptionsToListOptions($listoptions_string);

        // Check if it's a count
        if ($listoptions['countonly'] == 1) {
            $return_count = true;
        }

        // Flag as internal
        $listoptions['internallistcall'] = true;

        if (!isset($listoptions['sameresultandpage'])) {
            $listoptions['sameresultandpage'] = $_GET['sameresultandpage'];
        }
        $listoptions['hl'] = $_GET['hl'];

        $html = '';
        if ($listoptions['BYAJAX'] == 1) {
            $url = 'list.php?';
            //			$listoptions['BYAJAX'] = 1;
            //dit is een heel lelijk stuk code maar ik weet niet hoe het anders kan; de listoptions array bestaat uit maximaal 3 dimensies
            foreach (array_keys($listoptions) as $key) {
                if (is_array($listoptions[$key])) {
                    foreach (array_keys($listoptions[$key]) as $key2) {
                        if (is_array($listoptions[$key][$key2])) {
                            foreach ($listoptions[$key][$key2] as $val) {
                                $url .= rawurlencode($key).'['.rawurlencode($key2).'][]='.rawurlencode($val).'&';
                            }
                        } else {
                            $url .= rawurlencode($key).'['.rawurlencode($key2).']='.rawurlencode($listoptions[$key][$key2]).'&';
                        }
                    }
                } else {
                    $url .= rawurlencode($key).'='.rawurlencode($listoptions[$key]).'&';
                }
            }
            $html = AjaxBoxSimple($url);
        } else {
            if ($listoptions['outputtype'] == 'array') {
                //JH 2016-09-04 om de data kommagescheiden eruit te krijgen; dit is handig wanneer je een veld in een ft wilt selecteren op basis van een USERID
                //#LIST|table=t1|hiddenfilter_t1-f255=@USERID@|listlayoutcolumns=t1-recordid|outputtype=array#
                $array = make_list($listoptions);
                $tel = 0;
                foreach ($array as $record) {
                    foreach ($record as $key => $value) {
                        if ($tel > 0) {
                            $html .= ', ';
                        }
                        $html .= htme($value);
                        ++$tel;
                    }
                }
            } else {
                list($number_of_records, $output) = make_list($listoptions);

                if ($return_count) {
                    $html = FormatNumber($number_of_records, 0);
                } else {
                    $html = $output;
                }
            }
        }
        /* TODO: hier excluden dat een sublist zonder geldig hiddenfilter niet kan? */
        $template = str_replace('#LIST'.$listoptions_string.'#', escape_interleave_characters($html), $template);

//JH DEBUG
//$template = str_replace('#LIST'.$listoptions_string.'#', 'LIST'.$listoptions_string . escape_interleave_characters($html), $template);

    }

    return $template;
}

function AjaxBoxSimple($url)
{
    $str = '';
    $id = 'A'.randomstring(8);
    $str .= '<div id="'.$id.'"></div>';
    $str .= '<script type="text/javascript">'."\n";
    $str .= 'refresh_contents_of_div(\''.$id.'\', \''.jsencode($url).'\', \'\', false, \'GET\');'."\n";
    $str .= '</script>'."\n";

    return $str;
}

function ParseTemplateInclusions($template) {
    $lus = 0;
    $old_template = "";
    while (($old_template != $template) && ($lus < 5)) {
    $old_template = $template;

        $template = preg_replace_callback("/\@TEMPLATE([0-9]+)\@/", function ($matches) {
            return GetTemplate($matches[1]);
        }, $template);

    //to prevent endless recursion
    $lus++;
    }

    return $template;

}
function ParseTemplateGeneric($template)
{

    /*
    *
    * Handles:
    *
    * Time, user, userid, group, groupid tags
    * Calendar tags
    * Info tags
    * Inline add form tags
    * Default value tags
    * Template inclusions
    * STATIMG tags
    * User and group fieldsyes
    * Absolutely addressedd ifields
    *
    */
    if (strlen($template) == 0) {
        return '';
    }

    $template = str_replace('@XDEBUG@', 'XDEBUG ENABLED: <input size="2" type="text" name="XDEBUG_PROFILE" value="1">', $template);

    $template = ParseTemplateInclusions($template);

    //this used to be ParseDefaultValueTags()
    $template = str_replace('@BASEURL@', escape_interleave_characters(htme(GetSetting('BASEURL'))), $template);
    $template = str_replace('@REPOSNUM@', escape_interleave_characters(htme($GLOBALS['repository'])), $template);
    $template = str_replace('@ADMINEMAIL@', escape_interleave_characters(htme(GetSetting('admemail'))), $template);
    $template = str_replace('@ADMEMAIL@', escape_interleave_characters(htme(GetSetting('admemail'))), $template);
    $template = str_replace('@WEBHOST@', escape_interleave_characters(htme(getenv('HOSTNAME'))), $template);
    $template = str_replace('@TITLE@', escape_interleave_characters(htme(GetSetting('title'))), $template);

    $template = str_replace('@DATE@', TransformDate(date('d-m-Y')), $template);
    $template = str_replace('@UNFORMATTED_DATE@', date('d-m-Y'), $template);
    $template = str_replace('@TODAY@', TransformDate(date('d-m-Y')), $template);
    $template = str_replace('@TODAYISO@', date('Y-m-d'), $template);
    $template = str_replace('@ISODATE@', date('Y-m-d'), $template);
    $template = str_replace('@NOW@', date('Y-m-d').' '.date('H:i:s'), $template);
    $template = str_replace('@ISODATETIME@', date('Y-m-d').' '.date('H:i:s'), $template);
    $template = str_replace('@TODAY_UNFORMATTED@', date('d-m-Y'), $template);
    $template = str_replace('@NOW_FORMATTED@', TransformDate(date('d-m-Y')).' '.date('H:i:s'), $template);
    $template = str_replace('@NOW_UNFORMATTED@', date('Y-m-d').' '.date('H:i:s'), $template);
    $template = str_replace('@EPOCH@', date('U'), $template);
    $template = str_replace('@YESTERDAY@', TransformDate(date('d-m-Y', (date('U') - 86400))), $template);
    $template = str_replace('@TOMORROW@', TransformDate(date('d-m-Y', (date('U') + 86400))), $template);
    $template = str_replace('@YESTERDAY_UNFORMATTED@', date('d-m-Y', (date('U') - 86400)), $template);
    $template = str_replace('@TOMORROW_UNFORMATTED@', date('d-m-Y', (date('U') + 86400)), $template);
    $template = str_replace('@YESTERDAYISO@', date('Y-m-d', (date('U') - 86400)), $template);
    $template = str_replace('@TOMORROWISO@', date('Y-m-d', (date('U') + 86400)), $template);
    $template = str_replace('@TIME@', date('H:i:s'), $template);


    // Parse user and group fields
    $template = ParseTemplateUserAndGroupFields($template);

    preg_match_all('/#CALENDAR(.*?)#/', $template, $matches);
    foreach ($matches[1] as $calendaroptions_string) {
        $calendaroptions = array();
        foreach (explode('|', html_entity_decode($calendaroptions_string)) as $argument) {
            list($key, $val) = explode('=', $argument);
            $calendaroptions[$key] = $val;
        }

        $listid_div_exists = false;
        $template = str_replace('#CALENDAR'.$calendaroptions_string.'#', escape_interleave_characters(ShowCalendar($calendaroptions['listid'], $calendaroptions['view'], $calendaroptions['startdate'], $listid_div_exists, $calendaroptions['cals_to_show'])), $template);
    }

    $template = str_replace('@INFO@', '<div class="formcomment"><span class="fa fa-info-circle"></span><div>', $template);
    $template = str_replace('@ENDINFO@', '</div></div>', $template);

    /* check if there are QR code requests */
    preg_match_all('/@QR@(.*?)@ENDQR@/', $template, $matches);

    foreach ($matches[1] as $qrcode) {

        /* if so, include the library */
        require_once 'lib/phpqrcode/qrlib.php';

        /* the lib cannot return binary files, so we'll have to save it on disk first and delete it afterwards */
        $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_QRCODE');

        /* this creates the QR and saves it to disk. THIS IS A SECURITY HAZERD though very limited */
        QRcode::png($qrcode, $fn);

        /* replace the tag with an inline PNG image */
        $template = str_replace('@QR@' . $qrcode . '@ENDQR@','<img src="data:image/png;base64,' . htme(base64_encode(file_get_contents($fn))) . '">', $template);

        /* delete the file */
        unlink($fn);
    }

    // Parse absolutely addressed ifields and normal fields
    //preg_match_all('/#|@|%.*#|@|%/', $template, $matches);
    preg_match_all("/(\@|\#|\%|\^)([a-zA-Z0-9\-\_]+)\\1/", $template, $matches);

    foreach ($matches[0] as $el => $tag) {

        $type = 'ifield';
        $rep = '#';
        if (substr($tag, 0, 1) == '%') {
            $type = 'raw';
            $rep = '%';
        } elseif (substr($tag, 0, 1) == '@') {
            $type = 'normal';
            $rep = '@';
        }

        list($table, $field, $record) = explode('-', str_replace($rep, '', $tag));

        if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]) && ipi($record)) {

	        $value = '';
            $localrecord = getrecord($table, $record, false, false, array($table.'-'.$field));
            /* check if it's writeable */
            if ($type == 'ifield' && $localrecord['*'.$table.'-'.$field] == 1) {
                $value = return_ifield($table.'-'.$field, $record, $localrecord[$table.'-'.$field], '', false, false);

            } else {
                /* not writeable, or not an ifield */
                if ($type == 'raw') {
                    $value = $localrecord[$table.'-'.$field];
                } else {
                    $value = formatvalue($localrecord[$table.'-'.$field], $table.'-'.$field);
                }

            }

            $template = str_replace($tag, $value, $template);
        }
    }

    return $template;
}
function StripLanguageOnlyTags($template)
{
    /* strips all text enclosed in @LANGxxxONLY@ .. @ENDLANGxxxONLY@ tags, when xxx != current user language */
    return preg_replace_callback("/\@LANG([A-Z]+)ONLY\@(.*?)\@ENDLANG\\1ONLY\@/s", function ($matches) {
        if ($matches[1] == $GLOBALS['LANGUAGE']) {
            return $matches[2];
        } else {
            return '';
        }
    }, $template);
}
function StripGroupOnlyTags($template)
{
    $groups = GetGroups();

    if (!is_administrator()) {
        foreach ($groups as $group) {
            if ($group['id'] != $GLOBALS['GROUPID']) {
                $template = preg_replace('/@GROUP'.$group['id'].'ONLY@(.*?)@ENDGROUP'.$group['id'].'ONLY@/s', '', $template);
            } else {
                $template = preg_replace('/@GROUP'.$group['id'].'NOT@(.*?)@ENDGROUP'.$group['id'].'NOT@/s', '', $template);
            }
        }
        $template = preg_replace('/@GROUPADMINONLY@(.*?)@ENDGROUPADMINONLY@/s', '', $template);
    } else {
        $template = preg_replace('/@GROUPADMINNOT@(.*?)@ENDGROUPADMINNOT@/s', '', $template);
    }
    // Important! Clean up matching rows.
    foreach ($groups as $group) {
        $template = str_replace('@GROUP'.$group['id'].'ONLY@', '', $template);
        $template = str_replace('@ENDGROUP'.$group['id'].'ONLY@', '', $template);
        $template = str_replace('@GROUP'.$group['id'].'NOT@', '', $template);
        $template = str_replace('@ENDGROUP'.$group['id'].'NOT@', '', $template);
    }
    $template = str_replace('@GROUPADMINONLY@', '', $template);
    $template = str_replace('@ENDGROUPADMINONLY@', '', $template);
    $template = str_replace('@GROUPADMINNOT@', '', $template);
    $template = str_replace('@ENDGROUPADMINNOT@', '', $template);

    return $template;
}

function StripExistingOnlyTags($template)
{
//    qlog(INFO, 'Tags only for existing records stripped from template');
    $template = preg_replace('/@XONLY@(.*?)@ENDXONLY@/s', '', $template);
    $template = str_replace('@XONLY@', '', $template);
    $template = str_replace('@ENDXONLY@', '', $template);
    $template = str_replace('@NEWONLY@', '', $template);
    $template = str_replace('@ENDNEWONLY@', '', $template);
    return $template;
}
function StripNewOnlyTags($template)
{
//    qlog(INFO, 'Tags only for new records stripped from template');
    $template = preg_replace('/@NEWONLY@(.*?)@ENDNEWONLY@/s', '', $template);
    $template = str_replace('@NEWONLY@', '', $template);
    $template = str_replace('@ENDNEWONLY@', '', $template);
    $template = str_replace('@XONLY@', '', $template);
    $template = str_replace('@ENDXONLY@', '', $template);
    return $template;
}
function StripRWOnlyTags($template)
{
//    qlog(INFO, 'Tags only for read-write records stripped from template');
    $template = preg_replace('/@RWONLY@(.*?)@ENDRWONLY@/s', '', $template);
    $template = str_replace('@RWONLY@', '', $template);
    $template = str_replace('@ENDRWONLY@', '', $template);
    $template = str_replace('@ROONLY@', '', $template);
    $template = str_replace('@ENDROONLY@', '', $template);
    return $template;
}
function StripROOnlyTags($template)
{
//    qlog(INFO, 'Tags only for read-only records stripped from template');
    $template = preg_replace('/@ROONLY@(.*?)@ENDROONLY@/s', '', $template);
    $template = str_replace('@ROONLY@', '', $template);
    $template = str_replace('@ENDROONLY@', '', $template);
    $template = str_replace('@RWONLY@', '', $template);
    $template = str_replace('@ENDRWONLY@', '', $template);
    return $template;
}
function StripLockedOnlyTags($template)
{
//    qlog(INFO, 'Tags only for read-only records stripped from template');
    $template = preg_replace('/@LOCKEDONLY@(.*?)@ENDLOCKEDONLY@/s', '', $template);
    $template = str_replace('@LOCKEDONLY@', '', $template);
    $template = str_replace('@ENDLOCKEDONLY@', '', $template);
    return $template;
}
function ParseTemplateLanguageTags($template)
{
    global $lang;
//    qlog(INFO, "Start replace language tags in template");

    preg_match_all('/\[\[([A-Za-z0-9_\-]+)\]\]/', $template, $matches);

    foreach ($matches[1] as $tag) {
	$replace = "";

	//JH 2017-06-16 ALL THIS CODE MUST GO; EFID (AND FLEXTABLE!!) TAGS THIS USER HAS NO ACCESS TO SHOULD NO BE IN $lang!!
	if (preg_match("/^f(\d+)$/", $tag, $match))
	{
		$efid = $match[1];
		if (CheckExtraFieldAccess($efid) != 'nok')
		{
			if ($lang["f" . $efid] != "")
			{
				$replace = $lang["f" . $efid];
			}
			//JH 2017-10-17 this should go; we have to convert language tags from "EFID123" to "f123"
			else if ($lang["EFID" . $efid] != "")
			{
				$replace = $lang["EFID" . $efid];
			}
		}
	}
	else
	{
		$replace = $lang[$tag];
	}

	$template = str_replace("[[" . $tag . "]]", $replace, $template);
    }
//    qlog(INFO, "Done replace language tags in template");
    return $template;
}
function GetStyleSheets($id = false)
{
    //this is a admin function, so no check on CheckTemplateAccess
    if (ipi($id)) {
        return db_GetArray("SELECT templateid, templatename, template_subject FROM CRMtemplates WHERE templatetype='TEMPLATE_CSS' AND version_belonging_to=0 AND templateid=".$id);
    } else {
        return db_GetArray("SELECT templateid, templatename, template_subject FROM CRMtemplates WHERE templatetype='TEMPLATE_CSS' AND version_belonging_to=0");
    }
}
function GetAllButtons($id = false)
{
    if ($id) {
        return db_GetArray("SELECT * FROM CRMextrafields WHERE fieldtype='Button' AND deleted='n' AND id='".mres($id)."'");
    } else {
        return db_GetArray("SELECT * FROM CRMextrafields WHERE fieldtype='Button' AND deleted='n'");
    }
}
function CheckModuleAccess($module_id)
{
    $acc = 'nok';

    $val = db_GetValue("SELECT version_belonging_to FROM CRMmodules WHERE mid='".mres($module_id)."'");
    if (ipi($val)) { // not main version
    } elseif (is_administrator($GLOBALS['USERID'])) {
        $acc = 'ok';
    } else {
        $rules = db_GetArray("SELECT `group`, `execute` FROM `CRMmoduleaccessrules` WHERE `CRMmoduleaccessrules`.`module`='".mres($module_id)."'");
        if (count($rules) == 0) {
            /* no rules means everybody has access */
        $acc = 'ok';
        } else {
            foreach ($rules as $rule) {
                if ($rule['group'] == $GLOBALS['GROUPID'] && $rule['execute'] == 1) {
                    /* a rule exists, and excute rights are granted */
            $acc = 'ok';
                }
            }
        }
        //print 'No specific rules found, but rules DO exist, denied. Checking group ' . $GLOBALS['GROUPID'] . " for user " . $GLOBALS['USERID'] . "\n";
        //DA($rules);
    }

    return $acc;
}

function pre($txt)
{
    print '<pre>';
    if (is_array($txt)) {
        print htme(print_r($txt, true));
    } else {
        print htme($txt);
    }
    print '</pre>';
}
function GetExtraFlexTableFields($flextable_nr, $efid = false, $include_buttons = false, $no_cache = false)
{
    global $lang;
    $no_cache = true;

    if ($no_cache) {
        unset($GLOBALS['PageCache']['ExtraFlexTableFields']);
    }

    $sql_ins = '';
    if ((!stristr($_SERVER['SCRIPT_NAME'], 'flextable.php')) && (!stristr($_SERVER['SCRIPT_NAME'], 'admin.php')) && !$include_buttons) {
        $sql_ins .= " AND fieldtype!='Button'  AND underwaterfield!='y'";

        qlog(INFO, 'Buttons are excluded (this page != flextable.php)');
    }
    $ret = array();

    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE tabletype='".$flextable_nr."' ".$sql_ins." AND deleted='n' ORDER BY ordering") as $row) {
        $row['name'] = strip_tags(br2nl($row['name']));
        if (CheckExtraFieldAccess($row['id']) == 'ok' || CheckExtraFieldAccess($row['id']) == 'readonly') {
            $row['name'] = $lang['EFID'.$row['id']];
            $row['displaylistname'] = $lang['EFID'.$row['id'].'DLN'];
            $ret[$row['id']] = $row;
        } else {
            //$ret[$row['id']] = "ACCESS DENIED";
        }
    }

    qlog(INFO, 'fields for table '.$flextable_nr.' returned ('.sizeof($ret).' fields)');

    $GLOBALS['PageCache']['ExtraFlexTableFields'][$flextable_nr] = $ret;

    if ($efid) {
        $return = array();
        if (!is_array($ret[$efid])) {
            $ret[$efid] = array('Field '.$efid.' not found!');
        }
        $return[0] = $ret[$efid];

        return $return;
    }

    return $ret;
}
function GetExtraUserFields()
{
    global $lang;
    $ret = array();
    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE tabletype='user' AND deleted='n' ORDER BY ordering") as $row) {
        $row['name'] = $lang['EFID'.$row['id']];
        $row['displaylistname'] = $lang['EFID'.$row['id'].'DLN'];
        array_push($ret, $row);
    }

    return $ret;
}
function GetExtraFilesFields($efid = false)
{
    global $lang;
    $ret = array();
    foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE tabletype='files' AND deleted='n' ORDER BY ordering") as $row) {
        $row['name'] = $lang['EFID'.$row['id']];
        $row['displaylistname'] = $lang['EFID'.$row['id'].'DLN'];
        array_push($ret, $row);
    }

    return $ret;
}
// Returns a timestamp from a string.  Assumes en_GB format where ambiguous.
function NLDateToTimestamp($value, $add = false)
{
    // If it looks like a UK date dd/mm/yy, reformat to US date mm/dd/yy so strtotime can parse it.
    $reformatted = preg_replace("/^\s*([0-9]{1,2})[\/\. -]+([0-9]{1,2})[\/\. -]+([0-9]{1,4})/", '\\2/\\1/\\3', $value);

    return strtotime($reformatted.$add);
}
/**
 * Function TransformTime.
 *
 * Transforms a given time to the american format
 * if the date format is set to mm-dd-yyyy (global setting)
 *
 * @param	date_to_print	The european-formatted date in dd-mm-yyyy format
 */
function TransformTime($time_to_print)
{
    if ($time_to_print == '' || strstr($time_to_print, 'none')) {
        return '';
    } else {
        $h = substr($time_to_print, 0, 2);
        $m = substr($time_to_print, 3, 2);
        $Return = '';

        if ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
            if (strlen($time_to_print) != 5) {
                $Return = $time_to_print;
            } else {
                if ($h > 12) {
                    $h = ($h - 12);

                    $m .= ' pm';
                } elseif ($h == 12) {
                    $m .= ' pm';
                } else {
                    $m .= ' am';
                }
                if (strlen($h) == 1) {
                    $h = '0'.$h;
                }
                $Return = $h.':'.$m;
            }
        } else {
            $Return = $h.':'.$m;
        }
        qlog(INFO, 'Return: '.$Return);

        return $Return;
    }
}
/**
 * Function TransformDate.
 *
 * Transforms a given date to the american format
 * if the date format is set to mm-dd-yyyy (global setting)
 *
 * @param	date_to_print	The european-formatted date in dd-mm-yyyy format
 */
function TransformDate($date_to_print)
{
    $date_to_print = substr($date_to_print, 0, 10);
    if (substr($date_to_print, 0, 10) == '00-00-0000') {
        return '';
    } elseif (!is_valid_nl_date($date_to_print)) {
        return $date_to_print;
    } elseif ($date_to_print == '' || strstr($date_to_print, 'none')) {
        return '';
    } else {
        $Return = '';
        if ($GLOBALS['UC']['DateFormat'] == 'mm-dd-yyyy') {
            if (strlen($date_to_print) != 10) {
                $Return = $date_to_print;
            } else {
                $d = substr($date_to_print, 0, 2);
                $m = substr($date_to_print, 3, 2);
                $y = substr($date_to_print, 6, 4);
                $Return = $m.'-'.$d.'-'.$y;
            }
        } elseif ($GLOBALS['UC']['DateFormat'] == 'yyyy-mm-dd') {
            if (strlen($date_to_print) != 10) {
                qlog(ERROR, 'ERROR parsing date: '.$date_to_print);
                $Return = $date_to_print;
            } else {
                $d = substr($date_to_print, 0, 2);
                $m = substr($date_to_print, 3, 2);
                $y = substr($date_to_print, 6, 4);
                $Return = $y.'-'.$m.'-'.$d;
            }
        } else {
            $Return = $date_to_print;
        }
      //  qlog(INFO, "Return: " . $Return);
        return $Return;
    }
}
function NLDate2Epoch($date)
{
    if ($date == '' || strlen($date) != 10) {
        return false;
    } else {
        $tmp = explode('-', $date);
        if (is_array($tmp)) {
            return mktime(0, 0, 0, $tmp[1], $tmp[0], $tmp[2]);
        } else {
            return false;
        }
    }
}
function NLDate2INTLDate($date)
{
    if ($date == '') {
        return '';
    }

    $d = substr($date, 0, 2);
    $m = substr($date, 3, 2);

    $y = substr($date, 6, 4);

    return $y.'-'.$m.'-'.$d;
}
function INTLDate2NLDate($date)
{
    if ($date == '') {
        return '';
    }

    $d = substr($date, 8, 2);
    $m = substr($date, 5, 2);
    $y = substr($date, 0, 4);

    return $d.'-'.$m.'-'.$y;
}
function ParseFormattedEmailAddress($str)
{
    $return = array();

    $tmp = explode('<', str_replace('>', '', $str));

    if (ValidateEmail(trim($tmp[1]))) {

        // This probably is in format Firstname Lastname <e@mail.com>
        $return['fromemail'] = trim($tmp[1]);

        $name = trim($tmp[0]);
        if ($name == '') {
            $return['fromname'] = $return['fromemail'];
        } else {
            $return['fromname'] = $name;
        }
    } else {
        $return['fromname'] = $str;
        $return['fromemail'] = $str;
    }

    return $return;
}
function microtime_float()
{
    list($usec, $sec) = explode(' ', microtime());

    return (float) $usec + (float) $sec;
}
// The supporting qlog function to log custom text to qlist.txt
function qlog($loglevel, $msg)
{
    if (!$GLOBALS['logtext'] && !$GLOBALS['qlog_onscreen']) {
        return true;
    }

    $rule = '';
    if (isset($GLOBALS['DISABLE_DECISIONS'])) {
        $GLOBALS['DECISIONTRACE'] = array();
    }
    $do_log = false;

    if (is_numeric($GLOBALS['logtext'])) {
        if (($loglevel >= $GLOBALS['logtext']) && ($loglevel != DEBUG)) {
            $do_log = true;
        } elseif (($GLOBALS['logtext'] == DEBUG) && (($loglevel == DEBUG) || ($loglevel == ERROR) || ($loglevel == WARNING))) {
            $do_log = true;
        }
        if (($loglevel == ERROR) && ($GLOBALS['logtext'] == DEBUG)) {
            $msg .= "\n\n".GetBackTrace()."\n";
        }
    } else {
        if (($GLOBALS['logtext'] == true) || ($GLOBALS['ShowTraceLink'] == true) || ($GLOBALS['UC']['PERSONALTRACE'] == 'On') || $GLOBALS['qlog_onscreen']) {
            $do_log = true;
        }
    }

    if ($do_log) {
        if (is_array($msg)) {
            $msg2 = "Array:\n";
            $msg2 .= string_r($msg);
            $msg = $msg2;
        }

        if (strstr($msg, 'ACCESS DECISION')) {
            if (!is_array($GLOBALS['DECISIONTRACE'])) {
                $GLOBALS['DECISIONTRACE'] = array();
            }
            array_push($GLOBALS['DECISIONTRACE'], $msg);
        }
        if ($GLOBALS['ShowFunctionTrace']) {
            ob_start();
            debug_print_backtrace();
            $t = ob_get_contents();
            ob_end_clean();
            $msg .= "\n###################################################################################################################\nBacktrace of this message:\n-------------------------------------------------------------------------------------------------------------------\n".$t."\n\n###################################################################################################################";
        }
        $name = '';
        if ($GLOBALS['USERNAME']) {
            $name = $GLOBALS['USERNAME'];
        } else {
            $name = 'NOUSER';
        }
        if ($GLOBALS['tracelogused'] == '') {
            $GLOBALS['tracelogused'] = true;
            qlog(INFO, $GLOBALS['PRODUCT'].' '.$GLOBALS['VERSION'].' on '.$_SERVER['SERVER_NAME'].' chatting with '.$_SERVER['REMOTE_ADDR']);
        }
        $bla = debug_backtrace();

        $file = $bla[1]['file'];
        // Strip path from filename (UNIX)
        $file = explode('/', $file);
        $file = $file[sizeof($file) - 1];
        // Strip path from filename (Windows)
        $file = explode('\\', $file);
        $file = $file[sizeof($file) - 1];
        $func = fillout($file.':'.$bla[0]['line'], 35).'   '.$bla[1]['function'];
        if ($file != '' && $bla[1]['function'] != 'require_once') {
        } else {
            $file = $bla[0]['file'];

            // Strip path from filename (UNIX)
            $file = explode('/', $file);
            $file = $file[sizeof($file) - 1];
            // Strip path from filename (Windows)
            $file = explode('\\', $file);
            $file = $file[sizeof($file) - 1];
            $func = fillout($file.':'.$bla[0]['line'], 35).'  '.$bla[0]['function'];
        }
        $curmem = round(memory_get_usage() / 1024 / 1024, 2);
        if ($curmem > 100) {
            $curmem = 'WARN:'.$curmem;
        }
        $rule .= date('Ymd H:i:s').' '.fillout(microtime_float(), 16).' MEM:'.fillout($curmem, 15).' '.fillout($name, 8).' '.$func.'::'.$msg."\n";

        if (!strstr($msg, 'CACHE ')) {
            $GLOBALS['tracelog'] .= $rule;
        }

        $fp = @fopen('qlist.txt', 'a');
        @fputs($fp, strip_tags($rule));
        @fclose($fp);

        if ($GLOBALS['UC']['PERSONALTRACE'] == 'On') {
            mcq("INSERT INTO CRMcache(value,epoch) VALUES('TRACE".mres($GLOBALS['repository'].$GLOBALS['USERID']).': '.mres($rule)."','".date('U')."')");
        }
    }

    return 0;
}
function RealMail($template, $entity_dummy, $customer_dummy, $From, $Fromname, $To, $PDF, $Subject, $attach_to_dossier = false, $attach_as_filename = false, $report_attach = false, $flextableid_dummy = false, $record = false, $parse = true, $files_to_attach = array(), $dstablename = '')
{
    /* de dummys hier moeten weg. wordt nu nog afgevangen */
    if (ipi($entity_dummy) || ipi($customer_dummy) || ipi($flextableid_dummy)) {

        log_msg("ERROR: Wrong RealMail call: ($entity_dummy) || ($customer_dummy) || ($flextableid_dummy)");

        /* temporary safeguards */
        if (ipi($flextableid_dummy) && $dstablename == '') $dstablename = "t" . $flextableid_dummy;
        if (ipi($entity_dummy) && !ipi($record)) $record = $entity_dummy;

    }

    if (GetSetting('UseMailQueue') == 'Yes') {
        $parse_flag = 'y';
        if (!$parse) {
            $parse_flag = 'n';
        }

        $tmp = '';
        // Double entry check
        $dcheck = "SELECT queueid FROM CRMmailqueue WHERE status='unsent' AND `template` = '".mres($template)."' AND `user`  = '".mres($GLOBALS['USERID'])."' AND `from`  = '".mres($From)."' AND `fromname` = '".mres($Fromname)."' AND `to`  = '".mres($To)."' AND `subject`  = '".mres($Subject)."' AND `attach_to_dossier`  = '".mres($attach_to_dossier)."' AND `attach_as_filename`  = '".mres($attach_as_filename)."' AND `report_attach` = '".mres($report_attach)."' AND `flextablerecord` = '".mres($record)."' AND `files_to_attach` = '".mres(serialize($files_to_attach))."' AND `table`='".mres($dstablename)."'";

        $tmp = db_GetValue($dcheck);
        $sql = "INSERT INTO CRMmailqueue(`template`,`user`,`from`,`fromname`,`to`,`PDF`,`subject`,`attach_to_dossier`,`attach_as_filename`,`report_attach`,`flextableid`,`flextablerecord`, `date_queued`, `status`, `parse`, `files_to_attach`, `table`)";
        $sql .= " VALUES('".mres($template)."','".$GLOBALS['USERID']."','".mres($From)."','".mres($Fromname)."','".mres($To)."','".mres($PDF)."','".mres($Subject)."','".mres($attach_to_dossier)."','".mres($attach_as_filename)."',";
        $sql .= "'".mres($report_attach)."','','".mres($record)."',NOW(),'unsent', '".$parse_flag."','".mres(serialize($files_to_attach))."','".mres($dstablename)."')";

        if (!is_numeric($tmp)) {
            mcq($sql);
        } else {
            /* prevent looping */


            if (!strstr($Subject, 'ERROR: Double message added to mailqueue')) {
            //    log_msg('ERROR: Double message added to mailqueue. Skipped. Message is the same as message ' . $tmp . '. SQL Below<br><br>' . $sql);
            }
        }
    } else {

        require_once 'adminfunctions.php';

        $adj = RealRealMail($template, $From, $Fromname, $To, $PDF, $Subject, $attach_to_dossier, $attach_as_filename, $report_attach, '', $record, $parse, $files_to_attach, $dstablename);

        if ($adj[1] == true) {
            log_msg('Sending email from '.$From.' to '.$To.' subject '.str_replace('WARNING', 'WARN', str_replace('ERROR', 'ERR', $Subject)));
        } else {
            log_msg('ERROR: '.$adj[0].' Sending email from '.$From.' to '.$To.' subject '.str_replace('WARNING', 'WARN', str_replace('ERROR', 'ERR', $Subject)));
        }
    }
}

function SimpleMail($from, $to, $subject, $body, $file_attachment_array)
{
    //require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/class.phpmailer.php';
    //require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/class.smtp.php';
    require_once $GLOBALS['PATHTOINTERLEAVE'].'lib/phpmailer/PHPMailerAutoload.php';

    qlog(INFO, 'MXR Called to send a mail to '.$to.' with subject '.$subject);
    $mail = new PHPMailer();
    $mail->SMTPSecure = false;
    $mail->SMTPAutoTLS = false;
    $mail->CharSet = 'UTF-8';
    $mail->XMailer = ' ';

    $UNIFIED_FROMADDRESS = GetSetting('UNIFIED_FROMADDRESS');
    if (strstr($UNIFIED_FROMADDRESS, '@')) {
        $ar = ParseFormattedEmailAddress($UNIFIED_FROMADDRESS);

        $mail->From = $ar['fromemail'];
        $mail->FromName = $ar['fromname'];
    } else {
        $mail->From = $from;
        $mail->FromName = $from;
    }

    $mail->Host = GetSetting('SMTPserver');
    $mail->Mailer = GetSetting('MailMethod');
    if (GetSetting('MailUser') != '' && GetSetting('MailPass') != '') {
        $mail->Username = GetSetting('MailUser');
        $mail->Password = GetSetting('MailPass');
    }
    $mail->IsHTML(true);
    $mail->Body = $body;
    $mail->AltBody = html2plaintext($body);
    /* catch for development */
    if (GetSetting('DevelopmentOrProduction') == 'Development') {
        $subject .= ' ['.$to.']';
        $To = GetSetting('AddressToSendAllMailsToWhenInDevelopmentMode');
        $From = GetSetting('AddressToSendAllMailsToWhenInDevelopmentMode');
        $mail->AddAddress($To, $To);
    } else {
        if (is_array($to)) {
            foreach ($to as $too) {
                if ($too != '') {
                    $mail->AddAddress($too, $too);
                }
            }
        } else {
            $mail->AddAddress($to, $to);
        }
    }
    $mail->Subject = $subject;

    if (is_array($file_attachment_array)) {
        foreach ($file_attachment_array as $file) {
            if (CheckTableRecordAccess('files', $file) != 'nok') {
                $mail->AddStringAttachment(GetFileContent($file), GetFileName($file));
            }
        }
    }
    if (!$mail->Send()) {
        log_msg('WARNING: Sending e-mail to '.$to.' failed:'.$mail->ErrorInfo);
        qlog(INFO, 'E-mail NOT sent.. ERROR: '.$mail->ErrorInfo);
    } else {
        log_msg('Notification e-mail sent to '.$to);
        qlog(INFO, 'An e-mail was sent.');
    }
}
function log_msg($comment)
{
    if ($GLOBALS['NO_INSERTS_TO_LOG']) {
        return true;
    } elseif (strlen($comment) > 524288) {
        // This is dangerous, the uselog table could fill up
        return false;
    }

    $ip = '';
    if (getenv(HTTP_X_FORWARDED_FOR)) {
        $ip = getenv(HTTP_X_FORWARDED_FOR);
    } else {
        $ip = getenv(REMOTE_ADDR);
    }

    $url = $_SERVER['REQUEST_URI'];

    $query = "INSERT INTO CRMuselog (ip, url, useragent, qs, user) VALUES ('".mres($ip)."', '".mres($url)."', '".mres($_SERVER['HTTP_USER_AGENT'])."' , '".mres($comment)."','".mres($GLOBALS['USERID'].' -- '.GetUserName($GLOBALS['USERID']))."')";

    mcq($query);

    if (strstr($comment, 'NOTICE') || strstr($comment, 'WARNING') || strstr($comment, 'ERROR')) {
        $txt_to_email = '';
        $txt_to_email .= 'IP-address: '.$ip."\n";
        $txt_to_email .= 'Repository: '.GetSetting('title')."\n";
        $txt_to_email .= 'Time: '.date('Y-m-d H:i:s')."\n";
        $txt_to_email .= 'User: '.$GLOBALS['USERNAME']."\n";
        $txt_to_email .= "Message:\n".$comment."\n";

        $tmp = '';
        $no_trace = false;

        if (isset($_REQUEST['password'])) {
            $tmp = $_REQUEST['password'];
            $_REQUEST['password'] = '(deleted)';
            $no_trace = true;
        }

        if (!$no_trace) {
            $txt_to_email .= "BACKTRACE:\n".string_r(debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS))."\n";
        }

        $txt_to_email .= 'Request'.string_r($_REQUEST)."\n";
        $txt_to_email .= "Server relevants:\n";
        $txt_to_email .= 'REMOTE_ADDR '.$_SERVER['REMOTE_ADDR']."\n";
        $txt_to_email .= 'SERVER_NAME '.$_SERVER['SERVER_NAME']."\n";
        $txt_to_email .= 'SCRIPT_FILENAME '.$_SERVER['SCRIPT_FILENAME']."\n";
        $txt_to_email .= 'HTTP_REFERER '.$_SERVER['HTTP_REFERER']."\n";
        $txt_to_email .= 'REQUEST_URI '.$_SERVER['REQUEST_URI']."\n";
        $txt_to_email .= 'DATABASE_NAME '.db_GetValue('SELECT DATABASE()')."\n";

        if ($tmp) {
            $_REQUEST['password'] = $tmp;
        }

        $subj = $comment;
        if (strlen($subj) > 203) {
            $subj = substr($comment, 0, 200).'...';
        }

        $rules = array();
        $type = '';
        if (strstr($comment, 'NOTICE')) {
            AddMessage('admin', $GLOBALS['USERID'], $subj, $txt_to_email);
        } elseif (strstr($comment, 'WARNING')) {
            $comment = str_replace('WARNING: ', '', $comment);
            AddMessage('admin', $GLOBALS['USERID'], $subj, $txt_to_email);
            $type = 'A warning was issued: '.GetSetting('title');
            $rules = db_GetFlatArray("SELECT `CRMruleactions`.`value` FROM `CRMruleactions`, `CRMrules`, `CRMruleconditions` WHERE `CRMruleactions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`condition` = 'system generates warning'");
            if (GetSetting('DevelopmentOrProduction') == 'Development') {
                if (!in_array('alert("An error occurred. See messages.");', $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'])) {
                    $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = 'alert("An error occurred. See messages.");';
                }
            }
        } elseif (strstr($comment, 'ERROR') && !stristr($comment, 'added to entity')) {
            $comment = str_replace('ERROR: ', '', $comment);
            AddMessage('admin', $GLOBALS['USERID'], $subj, $txt_to_email);
            $type = 'An error occured: '.GetSetting('title');
            $rules = db_GetFlatArray("SELECT `CRMruleactions`.`value` FROM `CRMruleactions`, `CRMrules`, `CRMruleconditions` WHERE `CRMruleactions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`rule` = `CRMrules`.`id` AND `CRMruleconditions`.`condition` = 'system generates error'");

            if (GetSetting('DevelopmentOrProduction') == 'Development') {
                if (!in_array('alert("An error occurred. See messages.");', $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'])) {
                    $GLOBALS['JavascriptToPrintAtEndOfPage_OnlyJS'][] = 'alert("An error occurred. See messages.");';
                }
            }
        }

        foreach ($rules as $email) {
            $email = unescape_interleave_characters(ParseTemplateGeneric($email));
            qlog(INFO, 'Mail to '.$email.' because error or warning occured');

            /* 2016-02-20 RealMail uses html, so we have to encode $txt_to_email with htme() */
            RealMail('<pre>'.htme($txt_to_email).'</pre>', 0, 0, GetSetting('admemail'), 'INTERLEAVE', $email, false, $type, false, false, false, false, false, false);
        }
    }
}
function clean($string) {
   $string = str_replace(' ', '-', $string); // Replaces all spaces with hyphens.
   return preg_replace('/[^A-Za-z0-9\-]/', '', $string); // Removes special chars.
}
function PrintExtraFieldForceJavascript($current_dstable)
{
    /*
    $current_dstable is only used to pass through to generate_hideandshow_javascript
    */

    // This function prints the javascript needed to check for missing values.
    $output = '';

    /* use ds? */
    $groups = array();
    $subgroups = array();

    $list_of_fields_in_table = db_GetFlatArray("SELECT id FROM CRMextrafields WHERE tabletype='" . mres(str_replace('t', '', $dstable)) . "'");
    $list_of_fields_in_table[] = 0;

    $list = db_GetArray("SELECT CRMattributes.entity, CRMattributes.value FROM CRMattributes, CRMextrafields WHERE CRMattributes.identifier='extrafield' AND CRMattributes.attribute='FieldGroupName' AND CRMattributes.value NOT IN ('', '{{none}}') AND CRMattributes.entity = CRMextrafields.id AND CRMextrafields.tabletype ='" . mres(str_replace("t", "", $current_dstable)) . "'");

    if (count($list) > 0) {

        foreach ($list AS $num) {

            /* group names can be devided by ' - ' */
            $t = explode(" - ", $num['value']);
            if (!is_array($groups[$t[0]])) {
                $groups[$t[0]] = array();
            }
            $groups[$t[0]][] = ".container-f" . $num['entity'];

            /* sub groups - we currently support only 1 level deep */
            if ($t[1] != '') {
                if (!is_array($subgroups[$t[1]])) {
                    $subgroups[$t[1]] = array();
                }

                $subgroups[$t[1]][] = ".container-f" . $num['entity'];
            }
        }
        $output .= '';


        /* container-f249 */
        foreach ($groups AS $groupname => $fids) {
            $output .= '$("' . implode(", ", $fids) . ' ").wrapAll( "<div class=\'iltab hide_content\' id=\'subnav-' . htme(clean($groupname)) . '_content\' />");';
            //' $("#subnav-' . htme(clean($groupname)) . '_content").prepend(\'<h2>' . htme($groupname) . '</h2>\');';
        }
        foreach ($subgroups AS $groupname => $fids) {
            $output .= '$("' . implode(", ", $fids) . ' ").wrapAll( "<div class=\'subgroup\' id=\'fieldgroup-' . htme(clean($groupname)) . '_content\' />");$("#fieldgroup-' . htme(clean($groupname)) . '_content").prepend(\'<h3>' . htme($groupname) . '</h3>\');';
        }

        /* because we count the ENABLED elements in a tab, we NEED to run hideshowallelements FIRST */

        reset($groups);
        $first_group = key($groups);

        $output .= '

            var last_groupnav = "";

            function hideshowautonavtabs() {

            var groupnav = "<nav class=\"submenu iltabs\"><ul>";
            var some_groupnav = false;
            ';

            foreach ($groups AS $groupname => $fids) {

                $output .= 'var x = $(\'#subnav-' . inline_jsencode(clean($groupname)) . '_content\').find($(\'input:enabled,select:enabled,textarea:enabled\')).length;
                    if (x > 0) {
                        groupnav += "<li><a id=\"subnav-' . htme(clean($groupname)) . '\" class=\"";

                        groupnav += "\">' . htme($groupname) . ' (" + x + ")</a></li>";
                        some_groupnav = true;
                    }
                  ';
            }

            $output .= 'groupnav += "</ul></nav>";

                if (some_groupnav) {


                    /* we always need an autoformheader */
                    if ($(".autoformheader").length) {
                        if ($("#inserted_autonav").length == 0) {

                            $(".autoformheader").after("<div id=\'inserted_autonav\'></div>");
                        }

                        if (groupnav.replace("active", "") != last_groupnav.replace("active", "")) {

                            //alert("nav refreshed: " + groupnav + " neq " + last_groupnav);
                            last_groupnav = groupnav;

                            /* emtpty current groupnav and replace it */
                            $("#inserted_autonav").empty().append(groupnav);

                            /* hide any other iltbas below. don\'t remove */
                            $(".iltabs ul").not(":first").hide();

                            /* remove subnav-main if it exists */
                            $(".iltabs ul").not(":first").children("li:first").has("#subnav-main").remove();

                            /* clone all other tabs (sublists, files) and append them on the new nav
                               we use clone() here so we can to this more than once without having to reload the page
                               LET OP: vanwege clone worden ook id\'s gedupliceerd. nog checken
                                */

                            $(".iltabs ul").not(":first").children("li").clone().appendTo(".iltabs ul:first");

                        } else {

                        }
                    }
                } else {
                }
            }
        ';
    } else {
        $output .= '
            function hideshowautonavtabs() {
                return true;
                }';

    }


    /* the rest */

    foreach ($GLOBALS['UC']['PersonalDataStructure'] as $dstable => $prop) {
        foreach ($prop['fields'] as $dsfield => $field) {
            $fieldnum = str_replace('f', '', $dsfield);

            if ($field['fieldtype_in_extrafields_table'] == 'Button') {
                $fs = explode(',', $field['FieldsOnFormWhichMustHaveAValueCSV']);
                $fs2 = explode(',', $field['FieldsToAskInJSPopupCSV']);

                $output .= "\nfunction ValidateButtonClick".$fieldnum."() {\n";

                if (is_numeric($fs[0]) || is_numeric($fs2[0])) {
                    $output .= "	var ok = true;\n";
                    foreach ($fs as $checkfield) {
                        if (ipi($checkfield)) {
                            $output .= ' /* add rule for field '.htme($checkfield)." */\n";

                            $output .= "if (
											$('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').length)
											&&
                                            (
											$('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val()).val()==''
";
/* on reference fields, zero means empty, which in this case is wrong */
if ($GLOBALS['UC']['PersonalDataStructure'][$dstable]["fields"]["f" . $checkfield]["relation_to"] != "") {

$output .="                                            ||
                                            $('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val()).val()=='0'";
                                            }
                                            $output .= "




                                            )

											) {\n";

                            $output .= "		set_error('".$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val());\n";

                            $output .= "		ok = false;\n";
                            $output .= "}\n\n";
                            $output .= "

											else {
												/* alert($('#JS_" .$dstable.'-f'.$checkfield."-' + $('#JS_concerningrecord').val()).val()); */
											}


								";
                        }
                    }

                    foreach ($fs2 AS $field_to_ask_for_input) {
    			        if (ipi($field_to_ask_for_input)) {

                            $output .= "var ask" . $field_to_ask_for_input . " = prompt('" . jsencode($GLOBALS['UC']['PersonalDataStructure'][$dstable]['fields']["f" . $field_to_ask_for_input]["name"]) . "', get_field_value('" . $dstable . "-f" . $field_to_ask_for_input . "',$('#JS_concerningrecord').val()));\n";

                            $output .= "

                                if (ask" . $field_to_ask_for_input . " == '') {
                                    ok = false;
                                } else {
                                    if (general_element_validate('" . $dstable . "-f" . $field_to_ask_for_input . "-' + $('#JS_concerningrecord').val(), $('#JS_concerningrecord').val(), '', ask" . $field_to_ask_for_input . ")) {
                                        if ($('#JS_" . $dstable . "-f" . $field_to_ask_for_input . "-' + $('#JS_concerningrecord').val()).length) {
                                            $('#JS_" . $dstable . "-f" . $field_to_ask_for_input . "-' + $('#JS_concerningrecord').val()).val(ask" . $field_to_ask_for_input . ");
                                        } else {

                                            $('<input>').attr({
                                                type: 'hidden',
                                                id: 'JS_" . $dstable . "-f" . $field_to_ask_for_input . "-' + $('#JS_concerningrecord').val(),
                                                name: '" . $dstable . "-f" . $field_to_ask_for_input . "-' + $('#JS_concerningrecord').val(),
                                                value: ask" . $field_to_ask_for_input . "
                                            }).appendTo($('#" . $dstable . "-' + $('#JS_concerningrecord').val()));
                                        }
                                    } else {

                                        ok = false;
                                    }
                                }";
    			        }
                    }


                    $output .= "	if (ok === true) {\n";
                    $output .= "		return(true);\n";
                    $output .= "	} else {\n";

                    $output .= "		alert('".EscapeSQ(html2plaintext(unescape_interleave_characters(ParseTemplateLanguageTags(GetAttribute('extrafield', 'NotAllRequiredFieldsAreEnteredMessage', $fieldnum)))))."');\n";

                    $output .= " 	$(\"#JS_e_button\").val('');\n";
                    $output .= "		return(false);\n";

                    $output .= "	}\n";
                } else {
                    $output .= "	return(true);\n";
                }
                $output .= '}';
            }
        }
    }

    $output .= generate_hideandshow_javascript($current_dstable);

    return $output;
    //return str_replace("\n", "", str_replace("\t", "", $output));
}
function ValidateEmail($email)
{
    return filter_var($email, FILTER_VALIDATE_EMAIL);
}
function RemoveExpiredLocks()
{
    mcq('DELETE FROM CRMentitylocks WHERE timestamp_last_change<DATE_ADD(NOW(), INTERVAL -20 SECOND)');
}
function GetCustomCSS($in_admin = false, $authenticated = true, $rawcontent = false, $returnarray = false)
{
    /*
    deze functie wordt op 5 mogelijke manieren gebruikt;
    1. DisplayCSS authenticated
    2. DisplayCSS unauthenticated
    3. dav.php rawcontent
    4. make_html_editor() in_admin = false en returnarray = true
    5. vanuit install.php met in_admin = true
    */
    $cssfiles = array();

    /* $in_admin werkt niet -- global die er toch al was gebruikt */
    if (!$GLOBALS['Installer']) $skin = GetSetting('UseSkinCSS');
    $return = '';

    if ($in_admin) {
	$cssfiles[] = 'css/colorful.css';
	//$cssfiles[] = 'css/blackandblue.css';
    } elseif ($skin == 'Apple') {
        $cssfiles[] = 'css/crm_dft.css';
        $cssfiles[] = 'css/apple.css';
    } elseif ($skin == 'Black and blue') {
        $cssfiles[] = 'css/blackandblue.css';
    } elseif ($skin == 'Colorful') {
        $cssfiles[] = 'css/colorful.css';
    } elseif ($skin == 'Yes') {
        $cssfiles[] = 'css/crm_dft.css';
        $cssfiles[] = 'css/skincrm.css';
    } elseif ($skin == 'No') {
        $cssfiles[] = 'css/crm_dft.css';
    }

    //alleen in gebruik bij dav.php
    if ($rawcontent) {
        foreach ($cssfiles as $cssfile) {
            $return .= '<style type="text/css">'.file_get_contents($cssfile).'</style>';
        }
    } else {
        foreach ($cssfiles as $cssfile) {
            $return .= '<link rel="stylesheet" href="'.$cssfile.'?'.filemtime($cssfile).'" type="text/css">';
        }
    }

    //we laden de SYSWIDECSS niet in de admin sectie
    if (!$in_admin && !$GLOBALS['Installer']) {
        $swc = GetSetting('SYSWIDECSS');
        if (ipi($swc)) {
            //voor op de login en forgotpassword pagina (unauthenticaed), en voor in dav.php
            if ((!$authenticated) || ($rawcontent)) {
                //2016-03-01 GetTemplate is now secured; SYSWIDECSS is readable for everyone, even unauthenticated users
                $return .= '<style type="text/css">'.db_GetValue('SELECT content FROM CRMtemplates WHERE templateid='.$swc.' AND version_belonging_to=0').'</style>';
            } else {
                $cssfile = add_sessionid_to_url('csv.php?GetCSS=default&amp;'.strtotime(GetTemplateLastModificationDate($swc)));
                $return .= '<link rel="stylesheet" href="'.$cssfile.'" type="text/css">';
                $cssfiles[] = $cssfile;
            }
        }
    }

    //alleen in gebruik in make_html_editor()
    if ($returnarray) {
        return $cssfiles;
    } else {
        return $return;
    }
}

function DisplayCSS($return = false, $authenticated = true)
{
    $str = '';
    //load_syswidecss staat op false wanneer die via login forgotpasswd e.d. wordt ingeladen want dan is er geen db verbinding
    $str .= '<link rel="stylesheet" type="text/css" href="js/jquery-fancybox/source/jquery.fancybox.css?1">';

    //http://fortawesome.github.io/Font-Awesome/
    $str .= '<link rel="stylesheet" href="font-awesome/css/font-awesome.min.css">';

    $in_admin = false;
    if ($GLOBALS['InAdminSection']) {
        $in_admin = true;
        /* not the right location to do this */
        require_once 'adminfunctions.php';
    }

    $str .= GetCustomCSS($in_admin, $authenticated);

    if ($return) {
        return $str;
    } else {
        print $str;
    }
}
function admin_inpage_nav($navs, $pagetitle)
{
    $html = '';
    $html .= '<h1>'.$pagetitle.'</h1>';
    $html .= '<ul class="multicol admininpagenav">';
    foreach ($navs as $nav) {
        $html .= '<li><a href="'.$nav[0].'">'.$nav[1].'</a></li>';
    }
    $html .= '</ul>';

    return $html;
}
function PlainNav($navs, $dontskipnav = false, $nested = false)
{
    if (!$nested) {
        print '<nav class="adminnav';
            if (GetSetting('DevelopmentOrProduction') != 'Development') {
                print ' adminmainnavdiv-production';
            }
	print '">';
    }
    print '<ul';
    if ($nested)
    {
	print ' class="twocolumns submenu"';
    }
    print '>';
    foreach ($navs as $nav) {
        print '<li';
        if ($nav[3] != '') { /* contains class */
            print ' class="' . $nav[3] . '"';
        }
        print '>';

        $url = $nav[0];
        $text = $nav[1];

        if ($url != '') {
		print '<a href="'.$url.'">';
        }

        print $text;
	if ($url != '') {
		print '</a>';
	}

        if (is_array($nav[2])) {
            PlainNav($nav[2], false, true);
        }
        print '</li>';
    }
    print '</ul>';
    if (!$nested) {
        print '</nav>';
    }
}
function CreateFolder($koppelid, $type, $folder_name, $parent_folder)
{
    $ac = '';
    $ft = str_replace('flextable', '', $type);
    $ac = CheckTableRecordAccess('t'.$ft, $koppelid);

    if (is_administrator()) {
        $ac = 'ok';
    }
    if ($ac == 'ok') {
        $sql = 'INSERT INTO CRMbinfiles(koppelid,filename,filetype,type,folder, username) VALUES('.mres($koppelid).",'".mres($folder_name)."','{{{folder}}}','".mres($type)."','".$parent_folder."','" . $GLOBALS['USERID'] . "')";
        mcq($sql);

        return db_GetInsertId();
    } else {
        PrintAD('Access denied');

        return false;
    }
}
function CheckIfAttachingIsAllowed($recordid, $tabletype)
{

    $ac = '';
    if ($recordid == '_new_') {
        $ac = 'ok';
    } elseif (substr($tabletype, 0, 1) == 't' && (ipi($recordid) || $recordid == '_new_')) {
        $ac = CheckTableRecordAccess($tabletype, $recordid);
    } elseif (($tabletype == 'system' || $tabletype == 'generalpurpose' || $tabletype == 'public') && is_administrator()) {
        $ac = 'ok';
    }
    if ($ac == 'ok') {
        return true;
    } else {
        return false;
    }
}
function AttachFile($recordid, $filename, $content, $type, $filetype = 'Unknown', $subj = '', $no_triggers = false, $is_path = false, $folder = false, $skip_security = false)
{

    $ac = false;
    if ($skip_security) {
        $ac = true;
    } else {
        // Checking UPLOAD ACCESS, not read access. Result MUST be "ok".
        $t = str_replace('flextable', '', $type);
        if (ipi($t)) {
            $t = 't'.$t;
        }
        $ac = CheckIfAttachingIsAllowed($recordid, $t);
    }

    if (GetFileType($folder) != '{{{folder}}}') {
        $folder = '';
    }

    if (!$ac) {
        log_msg('ERROR: Tried to attach file '.$filename.' to record '.$recordid.' of table '.$type.' but access is denied');

        return false;
    } else {
        $filesize = 0;
        if ( $filetype == 'image/jpeg') {

          $mp = GetAttribute("flextable", "ResizeImagesToMaxPx", str_replace('flextable', '', $type));

          if (!ipi($mp)) $mp = GetSetting("ResizeImagesToMaxPx");

          if (ipi($mp)) {
              /* since we need to get the dimensions, we might as well resize it immediately */
              $new = ResizeImage($content, 0, 0, '0,0,0', '104,104,104', false, true, $mp);

              if ($new != $content) {
                  $content = $new;
                  unset($new);
              }

          }
        }
        if ($is_path) {
            $filesize = filesize($content);
        } else {
            $filesize = strlen($content);
        }

        qlog(INFO, 'Saving file '.$filename);
        $sql = "INSERT INTO CRMbinfiles(koppelid,filename,filesize,filetype,username,type,version_belonging_to, timestamp_last_change, folder, offloaded) VALUES ('".mres($recordid)."','".mres($filename)."','".$filesize."','".mres($filetype)."','".mres($GLOBALS['USERID'])."','".mres($type)."',0, NOW(),'".$folder."','n')";
        mcq($sql);

        $a = db_GetInsertId();
        if ($is_path) {
            mcq('INSERT INTO CRMblobs(fileid,content) VALUES('.$a.",'".mres(file_get_contents($content))."')");
        } else {
            mcq('INSERT INTO CRMblobs(fileid,content) VALUES('.$a.",'".mres($content)."')");
            unset($content);
        }

        if (!$GLOBALS['Installer']) {
            journal($recordid, 'File id '.$a.' ['.$filename.'] added', $type);
            log_msg('File  '.$_FILES['userfile']['name'].' added to entity '.$recordid.' (type '.$type.')');
        }

        if ((memory_get_usage() / 1024 / 1024) < 30) {
            /* extract any ASCII for search purposes */
            /*
                dirty workaround; in a loop, the pdfparser function leaks memory, so only do this if we're below 30)
                this is safe, the nightly cron will index all files not already indexed

            */
            ExtractIndexData($a);
        }

        /* try to find GPS information in EXIF data */
        IndexGPSCoordinates($a);

        /* set the correct mime type */
        SetMimeType($a);

        if ($folder > 0) {
            foreach (db_GetArray('SELECT folder, SUM(filesize) FROM CRMbinfiles WHERE folder>0 AND filesize > 0 GROUP BY folder ORDER BY folder DESC') as $fol) {
                mcq("UPDATE CRMbinfiles SET filesize='".$fol[1]."' WHERE fileid='".$fol[0]."' AND filetype='{{{folder}}}'");
            }
        }

        return $a;
    }
}

function IsValidFlexTableRecord($recordid, $flextableid)
{
    /* DEZE FUNCTIE MOET WEG => CheckTableRecordAccess($table, $id) of iets dergelijks */
    if ($recordid > 0 && $flextableid > 0) {
        $sql = 'SELECT recordid FROM CRMflextable'.mres($flextableid)." WHERE recordid='".mres($recordid)."'";
        if ($GLOBALS['UC']['PersonalDataStructure']["t" . $flextableid]['logical_delete']) {
            $sql .= " AND deleted='n'";
        }
        $check = db_GetValue($sql);

        if ($check == $recordid) {
            return true;
        } else {
            return false;
        }
    }
}
function GetTemplateStyleSheet($templateid)
{
    if (CheckTemplateAccess($templateid) == 'ok') {
        return db_GetValue('SELECT stylesheet FROM CRMtemplates WHERE templateid='.$templateid);
    } else {
        return false;
    }
}
function ReturnStyleSheet($stylesheet_id)
{
    qlog(INFO, 'Fetching CSS id '.$stylesheet_id);
    if ($stylesheet_id != 0) {
        $css = GetTemplate($stylesheet_id);
        if ($css != '' && $css != '0') {
            // This CSS must be printed inline (for now) because it can also be e-mailed!
            $sheet = '<style type="text/css">'."\n";
            $sheet .= $css."\n";
            $sheet .= '</style>'."\n";

            return $sheet;
        } else {
            qlog(INFO, "Couldn't find any CSS template");

            return false;
        }
    } else {
        qlog(INFO, "Couldn't find any CSS template");

        return false;
    }
}
function ReturnTemplateStyleSheet($templateid)
{
    qlog(INFO, 'Fetching CSS for template '.$templateid);

    if (CheckTemplateAccess($templateid) == 'ok') {
        $id = GetTemplateStyleSheet($templateid);
        if (($id == 2147483647) || ($id == 0)) { // Means no CSS at all, also no <style> tags etc
            return ' ';
        } else {
            $css = GetTemplate($id);
            if ($css != '' && $css != '0' && $css != 'NO_CSS') {
                // This CSS must be printed inline (for now) because it can also be e-mailed!
                $sheet = '<style type="text/css">'."\n";
                $sheet .= $css."\n";
                $sheet .= '</style>'."\n";

                return $sheet;
            } elseif ($css == 'NO_CSS') {
                return ' ';
            } else {
                qlog(INFO, "Couldn't find any CSS template");

                return false;
            }
        }
    } else {
        qlog(INFO, "Couldn't find any CSS template");

        return false;
    }
}
function ParseTemplateUserAndGroupFields($template)
{
    //2017-06-14 group fields are no longer parsed because Atomos doesn't use these
    //user fields are never formatted but displayed plain text; regardless of %users-f1% or @users-f1@
    //it is probably faster to match known fields from the extrafields table against the template than vice versa, because we usually have many fields in an template and few fields in the user table
    //user fields that are mentioned twice in the same template are parsed twice; we should consolidate first
    //this function is data structure unaware; which is good, because it can be called to make sql security parts INSIDE the data structure

    $template = str_replace("@USERID@", $GLOBALS["USERID"], $template);
    $template = str_replace("@GROUPID@", $GLOBALS["GROUPID"], $template);

    //@USERNAME@ should go! only @USER@ should be used
    $template = str_replace("@USERNAME@", "@USER@", $template);
    if (strstr($template, "@USER@"))
    {
        //we use htme() but we might also be parsing a sql query here; FIX!
        $template = str_replace("@USER@", escape_interleave_characters(htme(GetUserName($GLOBALS["USERID"]))), $template);
    }

    if (strstr($template, "@USER_EMAIL@"))
    {
        //we use htme() but we might also be parsing a sql query here; FIX!
        $template = str_replace("@USER_EMAIL@", escape_interleave_characters(htme(GetUserEmail($GLOBALS["USERID"]))), $template);
    }

    //jh 2017-08-29 caching because this function can be called many times during one pageload
    if (!is_array($GLOBALS["PageCache"]["fields_in_user_table"]))
    {
		$GLOBALS["PageCache"]["fields_in_user_table"] = db_GetFlatArray("SELECT `id` FROM `CRMextrafields` WHERE `deleted`='n' AND `tabletype`='user'");
    }

    //user fields are written as @users-f1@ or %users-f123%
    foreach ($GLOBALS["PageCache"]["fields_in_user_table"] as $efid) {
        if (preg_match('/(\@|\%)users\-f'.$efid.'\\1/', $template)) {
            $value = db_GetValue('SELECT `EFID'.$efid.'` FROM `CRMloginusers` WHERE `id`='.$GLOBALS['USERID']);
            $template = preg_replace('/(\@|\%)users\-f'.$efid.'\\1/', escape_interleave_characters(htme($value)), $template);
        }
    }

    return $template;
}
function PrintAD($msg)
{
    log_msg('WARNING: '.$msg);

    if (GetSetting('BODY_ADMIN_ERRORMSG') == '') {
	print '<div class="errmsg">' . htme($msg) . '</div>';
    } else {
	print str_replace('@ERRORMSG@', htme($msg), GetSetting('BODY_ADMIN_ERRORMSG'));
    }
}
function AddMessage($to, $from, $subject, $body)
{
    // Adds a message to the message table
    // Returns message number
    if (strlen($body) > 0) {
        if ($to == 'admin') {
            $to = 0;
        }
        if ($from == '') {
            $from = '0';
        }

        $subbody = substr($body, 0, 500);

        $res = db_GetRow("SELECT id FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($to)."' AND `from`='".mres($from)."' AND `subject`='".mres($subject)."' AND LEFT(body, 500) = '".mres($subbody)."'");

        if ($res['id'] > 0) {
            mcq("UPDATE CRMinternalmessages SET dub_count = (dub_count+1), `read`='n' WHERE id=".$res['id'].'');
        } else {
            mcq('INSERT INTO CRMinternalmessages(`to`, `from`, `subject`, `body`, `read`) VALUES ('.mres($to).','.mres($from).",'".mres($subject)."','".mres($body)."','n')");
        }
        $msgnum = db_GetInsertId();

        return $msgnum;
    }
}
function GetMessage($user, $id = 'all', $direction = 'to', $max = 99999999)
{
    // returns all or 1 messages in an array
    $sql_ins = '';
    if ($direction == 'from') {
        $sql_ins = " WHERE `from=`'".mres($user)."' ";
    } else {
        if (is_administrator()) {
            $sql_ins = ' WHERE 1=1 ';
        } else {
            $sql_ins = " WHERE `to`='".mres($user)."' ";
        }
    }
    if ($id == 'all') {
        if ($user == 'admin') {
            $user = 0;
        }

        $retarray = db_GetArray("SELECT *, date_format(timestamp_last_change, '%a %M %e, %Y %H:%i') AS time_formatted FROM CRMinternalmessages ".$sql_ins.' ORDER BY id DESC LIMIT '.$max.' ');

        return $retarray;
    } elseif (is_numeric($id)) {
        // returns 1 message row in an array
        return db_GetRow("SELECT *, date_format(timestamp_last_change, '%a %M %e, %Y %H:%i') AS time_formatted FROM CRMinternalmessages ".$sql_ins." AND id='".mres($id)."' ORDER BY id DESC");
    }
}
function DeleteMessage($id, $user, $direction, $readorall)
{
    if ($user == 'admin') {
        $user = '0';
    }
    qlog(INFO, 'Deleting internal message '.$id.' of user '.$user);
    if ($id == 'all') {
        if ($readorall == 'read') {
            if ($direction == 'from') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.from='".mres($user)."' AND `read`='y'");
            } elseif ($direction == 'to') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($user)."' AND `read`='y'");
            }
        } elseif ($readorall == 'all') {
            if ($direction == 'from') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.from='".mres($user)."'");
            } elseif ($direction == 'to') {
                mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($user)."'");
            }
        }
    } elseif (is_numeric($id) || $id == '0') {
        mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='".mres($user)."' AND id='".mres($id)."'");
        if (is_administrator()) {
            mcq("DELETE FROM CRMinternalmessages WHERE CRMinternalmessages.to='0' AND id='".mres($id)."'");
        }
    }
}
function MarkMessageRead($id, $user)
{
    if ($id == 'all') {
        mcq("UPDATE CRMinternalmessages SET `read`='y', `timestamp_last_change`=`timestamp_last_change` WHERE CRMinternalmessages.to='".mres($user)."' AND `read`='n'");
    } elseif ($id > 0) {
        mcq("UPDATE CRMinternalmessages SET `read`='y', `timestamp_last_change`=`timestamp_last_change` WHERE id='".mres($id)."'");
    }
}
function UserMessage()
{
    /* switched off, only for administrators, because we were giving away usernames */
    if (is_administrator()) {
        global $lang;

        print '<div id="usermessages">';

        if ($_REQUEST['UserMessageBody'] && $_REQUEST['UserMessageTo']) {

            /*
            $cl = GetClearanceLevel($GLOBALS['USERID']);
            if (in_array("SendMessagesToAllUsers", $cl)) {
            print "<option value='all_users'>- all users -</option>";
            foreach (GetGroups() AS $group) {
            print "<option value='group_" . $group['id'] . "'>- all users in group " . htme($group['name']) ." -</option>";
            }
            }
            */
            $msg_id = '';

            if ($_REQUEST['UserMessageTo'] == 'all_users' || substr($_REQUEST['UserMessageTo'], 0, 6) == 'group_') {
                $group_ins = '';
                if (substr($_REQUEST['UserMessageTo'], 0, 6) == 'group_') {
                    $group_ins = " AND PROFILE='".str_replace('group_', '', $_REQUEST['UserMessageTo'])."'";
                }
                $cl = GetClearanceLevel($GLOBALS['USERID']);
                if (in_array('SendMessagesToAllUsers', $cl) || is_administrator()) {
                    $sndcnt = 0;
                    foreach (db_GetFlatArray("SELECT * FROM CRMloginusers WHERE active='yes' ".$group_ins) as $user) {
                        AddMessage($user, $GLOBALS['USERID'], $_REQUEST['UserMessageSubject'], $_REQUEST['UserMessageBody']);
                        ++$sndcnt;
                    }
                    $msg_id = '('.$sndcnt.' messages send)';
                } else {
                    PrintAD("You're not allowed to send messages to multiple recipients.");
                    EndHTML();
                    exit;
                }
            } else {
                $msg_id = AddMessage($_REQUEST['UserMessageTo'], $GLOBALS['USERID'], $_REQUEST['UserMessageSubject'], $_REQUEST['UserMessageBody']);
            }
            print '<h2>'.$lang['yourmessagewassend'].' '.$msg_id.'</h2>';
            $_REQUEST['ReadInternalMessage'] = '';
            $_REQUEST['ComposeNewMessage'] = '';
            if ($_REQUEST['nonavbar']) {
                print JS("CloseMe();WhosMyDaddy().window.location.href='index.php?UserMessage';");
            }
        }
        if ($_REQUEST['PurgeMessages'] == 'readtome') {
            //		DeleteMessage("all", $GLOBALS['USERID'], "from", "read");
        } elseif ($_REQUEST['PurgeMessages'] == 'readfromme') {
            DeleteMessage('all', $GLOBALS['USERID'], 'to', 'read');
            if (is_administrator()) {
                DeleteMessage('all', 'admin', 'to', 'read');
            }
        } elseif ($_REQUEST['PurgeMessages'] == 'allfromme') {
            DeleteMessage('all', $GLOBALS['USERID'], 'to', 'all');
            if (is_administrator()) {
                DeleteMessage('all', 'admin', 'to', 'all');
            }
        } elseif (is_numeric($_REQUEST['PurgeMessages'])) {
            DeleteMessage($_REQUEST['PurgeMessages'], $GLOBALS['USERID'], 0, 0);
            if ($_REQUEST['nonavbar']) {
                print JS("CloseMe();WhosMyDaddy().window.location.href='index.php?UserMessage';");
            }
        } elseif (isset($_REQUEST['MarkAllRead'])) {
            MarkMessageRead('all', $GLOBALS['USERID']);
            if ($_REQUEST['nonavbar']) {
                print JS("CloseMe();WhosMyDaddy().window.location.href='index.php?UserMessage';");
            }
        }
        if (is_numeric($_REQUEST['ReadInternalMessage'])) {
            $msg = GetMessage($GLOBALS['USERID'], $_REQUEST['ReadInternalMessage'], 'to');
            if (!is_array($msg) && is_administrator()) {
                $msg = GetMessage('admin', $_REQUEST['ReadInternalMessage'], 'to');
            }
            print '<div id="messageform">';

            print '<h1>'.htme(($msg['subject'])).'</h1>';
            print '<p>';
            if (!$_REQUEST['nonavbar']) {
                print "[<a href='index.php?UserMessage'>".htme($lang['messageinbox']).'</a>] &nbsp;';
            }
            print "[<a href=\"#\" onclick=\"toggleLayer('messagediv');toggleLayer('replyform');\">reply</a>] [<a href='index.php?UserMessage&amp;PurgeMessages=".$msg['id'].'&amp;nonavbar='.htme($_REQUEST['nonavbar'])."'>".htme($lang['delete']).'</a>] &nbsp; ';

            print 'From: '.htme(GetUserName($msg['from'])).'';
            if ($msg['to'] > 0) {
                print ', to: '.htme(GetUserName($msg['to'])).'';
            } else {
                print ', to admin';
            }
            print ', on: '.htme($msg['time_formatted']).'';
            if ($msg['to'] == 0) {
                print ', times received: '.htme($msg['dub_count']).'';
            }
            print '</p>';
            if ($msg['from'] != 0) {
                print '<div id="replyform" class="hide_content">';
                print '<h2>Reply</h2>';
                print '<table class="crm5">';

                print "<tr><td colspan='2'><form id='UserMessageForm' method='post' action=''><input type='hidden' name='UserMessage' value='Yes'>";
                print "<input type='hidden' name='UserMessageTo' value='".htme($msg['from'])."'>";
                print '<tr><td>To:</td><td>'.htme(GetUserName($msg['from'])).'</td></tr>';
                print "<tr><td>Subject:</td><td><input type='text' name='UserMessageSubject' size='50' value='RE: ".htme(($msg['subject']))."'></td>";
                print "<tr><td colspan='2'>Message:<br><textarea rows='10' cols='100' name='UserMessageBody'>\n\n\n-------------------\n".htme($msg['body']).'</textarea>';
                print "<tr><td></td><td class=\"rightalign\"><input type='submit' value='".$lang['sendmessage']."'></td></tr></table>";
                print '</div>';
            }
            print '<div id="messagediv">';
            print '<h2>Message</h2>';

            print '<table class="crm5">';
            print "<tr><td colspan='2'><pre>".htme(($msg['body'])).'</pre></td></tr>';
            print '</table>';
            print '</div>';
            print '</div>';
            qlog(INFO, 'Reading message '.$msg['id'].' - marking it as read');
            MarkMessageRead($msg['id'], $GLOBALS['USERID']);
        } elseif ($_REQUEST['ComposeNewMessage']) {
            print '<div id="messageform">';
            print "<form id='UserMessageForm' method='post' action=''><input type='hidden' name='UserMessage' value='Yes'>";
            print '<table><tr><td>To</td><td>';
            $result = select_refer_field_options('messages', 'to', 0);

            print "<select name='UserMessageTo' id='JS_UserMessageTo'>";

            print "<option value='admin'>- any administrator -</option>";
            $cl = GetClearanceLevel($GLOBALS['USERID']);
            if (in_array('SendMessagesToAllUsers', $cl) || is_administrator()) {
                print "<option value='all_users'>- all users -</option>";
                foreach (GetGroups() as $group) {
                    print "<option value='group_".$group['id']."'>- all users in group ".htme($group['name']).' -</option>';
                }
            }
            foreach ($result as $value => $text) {
                if ($text != '') {
                    print "<option value='".$value."'>".htme($text).'</option>';
                }
            }
            print '</select>&nbsp;'.ReturnDropDownSearchField('JS_UserMessageTo').'</td></tr>';
            print "<tr><td>Subject</td><td><input type='text' name='UserMessageSubject' size='80'><input type='hidden' name='nonavbar' value='1'></td>";
            print "<tr><td class=\"topalign\">Message</td><td><textarea cols='80' rows='15' name='UserMessageBody'></textarea></td></tr>";
            print "<tr><td></td><td class=\"rightalign\"><input type='submit' value='".htme($lang['go'])."'></td></tr>";
            print '</form></table>';
            print '</div>';
        } else {
            print "[<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a>] &nbsp;';
            print "[<a href='index.php?UserMessage&amp;PurgeMessages=allfromme'>".htme($lang['deleteallfrominbox']).'</a>]&nbsp;';
            print '<div id="messageslist">';

            list($number_of_records, $output) = make_list(array('table' => 'messages'));
            print $output;

            print '</div>';
        }
        print '</div>';
    }
}
function do_language()
{
    $system_language = GetSetting("DefaultLanguage");
    $user_language = '';

    if ($GLOBALS['USERID'] > 0) {
        $user_language = GetAttribute('user', 'LanguagePack', $GLOBALS['USERID']);
        if ($user_language == '') {
            SetAttribute('user', 'LanguagePack', '{{system}}', $GLOBALS['USERID']);
        }
    }

    $ltl = '';

    if ($user_language != '{{system}}' && $user_language != '') {
        $ltl = $user_language;
    } else {
        //jh 2015-10-07 als een user geen eigen lang voorkeur heeft opgegegeven in Interleave dan geven we voorrang aan de ingestelde browser language (mits die beschikbaar is in interleave), zo niet, dan nemen we de system language
        //hierdoor is de login page in de geprefereerde taal van de bezoeker
        $preferred_browser_lang = '';
        if (GetSetting('UseBrowserPreferredLanguage') == 'Yes') {
            $preferred_browser_lang = get_preferred_browser_lang();
        }
        if ($preferred_browser_lang != '') {
            $ltl = $preferred_browser_lang;
        } else {
            $ltl = $system_language;
        }
    }

    $GLOBALS['LANGUAGE'] = $ltl;

    //deze codes zouden in de languages tabel opgeslagen moeten zijn; let op; deze array staat 2x in functions.php
    $interleave_language_to_2_letter_codes = array('ENGLISH' => 'en', 'NEDERLANDS' => 'nl', 'FRANCAIS' => 'fr', 'DEUTSCH' => 'de', 'ESPANOL' => 'es');

    if ($interleave_language_to_2_letter_codes[$ltl] != '') {
        $GLOBALS['LANGUAGE_2_LETTER_CODE'] = $interleave_language_to_2_letter_codes[$ltl];
    }

    $lang = array();

    // TODO; Dit is qua security niet netjes. Tabel- en veldnamen kunnen worden exposed
    foreach (db_GetArray('SELECT recordid, tablename FROM CRMflextabledefs') as $ft) {
        $lang['flextable'.$ft['recordid'].'plural'] = $ft['tablename'];
    }
    foreach (db_GetArray("SELECT id, name, displaylistname FROM CRMextrafields WHERE deleted='n'") as $extrafield) {
        $lang['EFID'.$extrafield['id']] = $extrafield['name'];
        $lang['EFID'.$extrafield['id'].'DLN'] = $extrafield['name'];
        if ($extrafield['displaylistname'] != '') {
            $lang['EFID'.$extrafield['id'].'DLN'] = $extrafield['displaylistname'];
        }
    }
    foreach (db_GetArray("SELECT TEXTID, TEXT FROM CRMlanguages WHERE LANGID='".mres($ltl)."' ORDER BY TEXTID") as $row) {
        $lang[$row['TEXTID']] = $row['TEXT'];
        //om ook de display list name te overschrijven; we hebben georderd by TEXTID, dus we overschrijven hier alleen de DLN van de standaard language
        if (preg_match("/^EFID\d+$/", $row['TEXTID'])) {
            $lang[$row['TEXTID'].'DLN'] = $row['TEXT'];
        }
    }
    //	qlog(INFO, "Loaded language " . $ltl . " (" . $tel . " tags)");
    /*
    if (($mtl != "") && ($mtl != "-") && ($mtl != $ltl)) {
    $tel = 0;

    foreach (db_GetArray("SELECT TEXTID, TEXT FROM CRMlanguages WHERE LANGID='" . mres($mtl) . "'") AS $row) {
    $lang[$row['TEXTID']] = $row['TEXT'];
    $tel++;
    }
    qlog(INFO, "Loaded language mask " . $mtl . " (" . $tel . " tags)");
    }
    */

    /*
    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']) as $table)
    {
    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"]) as $field)
    {
    if (preg_match("/^f(\d+)$/", $last_field, $efidmatch))
    {
    $lang["EFID" . $efidmatch[1]] = $GLOBALS['UC']['PersonalDataStructure'][$table]["fields"][$field]["name"];
    }
    }
    }
    */

    return $lang;
}

function get_preferred_browser_lang()
{
    //code from http://www.thefutureoftheweb.com/blog/use-accept-language-header
    $langs = array();

    if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
        // break up string into pieces (languages and q factors)
	$lang_parse = array(); //only here to prevent false positive in undeclared var checker
        preg_match_all('/([a-z]{1,8}(-[a-z]{1,8})?)\s*(;\s*q\s*=\s*(1|0\.[0-9]+))?/i', $_SERVER['HTTP_ACCEPT_LANGUAGE'], $lang_parse);

        if (count($lang_parse[1])) {
            // create a list like "en" => 0.8
            $langs = array_combine($lang_parse[1], $lang_parse[4]);

            // set default to 1 for any without q factor
            foreach ($langs as $lang => $val) {
                if ($val === '') {
                    $langs[$lang] = 1;
                }
            }

            // sort list based on value
            arsort($langs, SORT_NUMERIC);
        }
    }

    //deze codes zouden in de languages tabel opgeslagen moeten zijn; let op; deze array staat 2x in functions.php
    $interleave_language_to_2_letter_codes = array('ENGLISH' => 'en', 'NEDERLANDS' => 'nl', 'FRANCAIS' => 'fr', 'DEUTSCH' => 'de', 'ESPANOL' => 'es');

    $available_interleave_languages = array();

    foreach (db_GetFlatArray("SELECT DISTINCT(LANGID) FROM CRMlanguages") as $lang) {
        if ($interleave_language_to_2_letter_codes[$lang] != '') {
            $available_interleave_languages[$interleave_language_to_2_letter_codes[$lang]] = $lang;
        }
    }

    // look through sorted list and use first one that matches our languages
    foreach ($langs as $lang => $val) {
        list($part1, $part2) = explode('-', $lang);
        if ($available_interleave_languages[$part1] != '') {
            return $available_interleave_languages[$part1];
        }
    }

    return '';
}

// FIX FOR: "Unknown function: memory_get_usage()"
// FIX -BEGIN-
if (!function_exists('memory_get_usage')) {
    function memory_get_usage()
    {
        return false;
    }
}
// FIX -END-
// MODULE INCLUDE EXTRA CODE
function GetModules()
{
    return db_GetArray('SELECT * FROM CRMmodules WHERE version_belonging_to=0');
}

function RunModule($mid, $eid = false, $return = false, $flextablerecord = false, $flextableid = false, $customerid = false, $dqs = '', $ds_table = '')
{
    global $lang, $secure_modules;

    if ($secure_modules[$GLOBALS['repository']] == 'yes') {
        /* deze kan weg eigenlijk */
        if (GetSetting('DevelopmentOrProduction') == 'Development') {
            $ls = new SaferScript('<?php ?>'.db_GetValue("SELECT module_code FROM CRMmodules WHERE mid='".mres($mid)."'").'<?php ?>');
            $ls->allowHarmlessCalls();
            $res = $ls->parse();
            if (count($res) > 0) {
                // illegal function calls found
                if ($return) {
                    return 'illegal function calls - not executing module: '.string_r($res);
                } else {
                    print 'illegal function calls - not executing module: ';
                    DA($res);
                }
            }
        }
    }
    /*
    Disabled for performance

    $cnt = GetAttribute("module", "ModuleRunCount", $mid);
    if (!is_numeric($cnt)) {
    $cnt = 1;
    } else {
    $cnt++;
    }
    SetAttribute("module", "ModuleRunCount", $cnt, $mid);
    */
    $dbname1 = db_GetValue('SELECT DATABASE()');

    $recordid = 0;
    if ($ds_table == '') {
        if (ipi($flextablerecord)) {
            $ds_table = 't'.$flextableid;
            $recordid = $flextablerecord;
        }
    } else {
        $recordid = $flextablerecord;
        $eid = 0;
        $cid = 0;
    }
    /*



    print "Recordid $recordid<br>";
    print "flextablerecord $flextablerecord<br>";
    */

    $DontFetchDQS = GetAttribute('module', 'DontFetchDQS', $mid);
    $DontBufferOutput = GetAttribute('module', 'DontBufferOutput', $mid);

    //	if (is_numeric($_REQUEST['dqs'])) {
    if ($dqs > 0 && $DontFetchDQS != 'Yes') {
        $q = PopStashValue($dqs);
        //print "Query: " . $q;
        if (trim($q) != '') {
            $list_of_records = db_GetFlatArray($q);

            $GLOBALS['eids'] = array();
            $GLOBALS['ftids'] = array();
            $GLOBALS['recordids'] = array();
            foreach ($list_of_records as $row) {
                $GLOBALS['eids'][] = $row;
                $GLOBALS['recordids'][] = $row;
            }
        } else {
            log_msg('WARNING: A dqs record was given, though returned empty. This affects the users functionality.');
        }
    }

    $tmp = CheckModuleAccess($mid);
    if ($tmp == 'ok') {
        if (!$mid) {
            qlog(ERROR, 'ERROR : No module ID received');
            log_msg('ERROR : No module ID received');
            $return = false;
        } else {
            qlog(INFO, 'Running module '.$mid);

            $cur_user = 0;
            $revert_user = false;
            $RunAsUser = GetAttribute('module', 'RunAsUser', $mid);
            if (is_numeric($RunAsUser) && $RunAsUser != $GLOBALS['USERID']) {
                // This module needs to be ran using the credentials of another user
                $cur_user = $GLOBALS['USERID'];
                $GLOBALS['USERID'] = $RunAsUser;
                InitUser();
                $revert_user = true;
            }

            $module = db_GetRow("SELECT module_code,module_name,mid FROM CRMmodules WHERE mid='".mres($mid)."'");

            if (ipi($module['version_belonging_to'])) {
                /* this means it's an old version of a module. not allowed */
                log_msg('ERROR: This module ('.$mid.') is an old version of another module. Not allowed to run directly.');

                return '';
            }

            $code = $module['module_code'];

/*            $unique_command_id = 'user_'.$GLOBALS['USERID'].'_module_'.$mid;
            if (!max_one_concurrent_load_start($unique_command_id)) {
                return '<div class="errmsg">This module is already loading. Please be patient.</div>';
            }*/
            if ($DontBufferOutput != 'Yes') {
                ob_start();
            } else {
                //print date('r').': Disabled output buffering'."\n";
            }

            eval('?>'.$code);

            $output = '';

            if ($DontBufferOutput != 'Yes') {
                $output = ob_get_contents();
            }

            if ($DontBufferOutput != 'Yes') {
                ob_end_clean();
            }
            if (!$return) {
                if ($DontBufferOutput != 'Yes') {
                    print $output;
                }
            }

            qlog(INFO, 'Done running module');
            $dbname2 = db_GetValue('SELECT DATABASE()');

            // If current database != initinal database
            if ($dbname1 != $dbname2) {
                // Restore privileges to avoid hacking.
                include $GLOBALS['CONFIGFILE'];

                SwitchToRepos($GLOBALS['repository']);
            } else {
                //$output .= "no-STR";
            }

            if ($revert_user) {
                $GLOBALS['USERID'] = $cur_user;
                InitUser();
            }

            $lr = date('U');
            if (stristr($output, "eval()'d code")) {
                mcq("UPDATE CRMmodules SET module_last_run_date='".$lr."', timestamp_last_change = timestamp_last_change, module_last_run_result='ERROR' WHERE mid='".mres($module['mid'])."'");
            } else {
                //		print "No errors detected while running this module";
                mcq("UPDATE CRMmodules SET module_last_run_date='".$lr."', timestamp_last_change = timestamp_last_change, module_last_run_result='OK' WHERE mid='".mres($module['mid'])."'");
            }

//            max_one_concurrent_load_finish($unique_command_id);

            if ($return) {
                return $output;
            }
        }
    } else {
        qlog(INFO, 'Running module '.$mid.' denied because of insufficient access rights');
        log_msg('Running module '.$mid.' denied because of insufficient access rights');
        if (!$return) {
            PrintAD("You don't have access to this module (".$mid.')');
        } else {
            return '<!-- No access -->';
        }
    }
}

function ReturnReposList()
{
    include $GLOBALS['CONFIGFILE'];
    $a = '';
    $a .= " MM = Maintenance mode Yes/No. F/O = Fail-over database configured Yes/No\n";
    $a .= "--------------------------------------------------------------------------------------------------------------------------\n";
    $a .= " Num |  Version         | Database name        |  MM   | F/O | Size   | Repository                               |\n";
    $a .= "--------------------------------------------------------------------------------------------------------------------------\n";
    for ($t = 0; $t < 64; ++$t) {
        if (DB_Connect($t) && $host[$t]) {
            $database[$t] = trim($database[$t]);

            $title = GetSetting('title');
            $version = GetSetting('DBVERSION');
            $mm = GetSetting('MAINTENANCE_MODE');
            if ($version == '') {
                $version = 'Prior to 1.9.0.';
            }

            $fo = 'N/A';

            $size = GetCurrentDBTotalSize();
            //											ver dbnam ent mm
            $a .= ' '.fillout($t, 3).' |  '.fillout($version, 15).' | '.fillout($database[$t], 20).' | '.fillout($mm, 4).' | '.$fo.' | '.fillout($size, 5).'M | '.fillout($title, 40)." |\n";
        }
    }
    $a .= "--------------------------------------------------------------------------------------------------------------------------\n";

    return $a;
}
function SwitchToRepos($repository_nr)
{
    include $GLOBALS['CONFIGFILE'];
    global $lang;

    if ($host[$repository_nr]) {
        qlog(INFO, 'Trying to connect to repository '.$repository_nr);
        if (DB_Connect($repository_nr)) {
            qlog(INFO, 'Using mysql://'.$user[$repository_nr].'@'.$host[$repository_nr].':'.$database[$repository_nr].'/CRM*');
            $GLOBALS['repository'] = $repository_nr;
        } else {
            qlog(INFO, 'Connection error');

            return false;
        }

        qlog(INFO, 'Connection succeeded');

        if (is_numeric($GLOBALS['USERID'])) {
	    $lang = array();
            $lang = do_language();
            InitUser();
        }

        return true;
    } else {
        return false;
    }
}
function GetFileEarlierVersions($fileid)
{
    return db_GetArray("SELECT * FROM CRMbinfiles WHERE version_belonging_to='".mres($fileid)."' ORDER BY timestamp_last_change DESC, fileid DESC");
}
function GetSetting($setting)
{
	if (!is_array($GLOBALS["settings"]))
	{
		$GLOBALS['settings'] = db_GetAssocArray("SELECT setting, value FROM CRMsettings");
	}
	return $GLOBALS["settings"][$setting];
}
function ShowClock()
{
    return "<span id=\"js_clock\"> <script type=\"text/javascript\"> function js_clock(){ var clock_time = new Date(); var clock_hours = clock_time.getHours(); var clock_minutes = clock_time.getMinutes(); var clock_seconds = clock_time.getSeconds(); var clock_suffix = \"\"; if (clock_hours > 11){ clock_suffix = \"\"; clock_hours = clock_hours; } if (clock_hours < 10){ clock_hours = \"0\" + clock_hours; } if (clock_minutes < 10){ clock_minutes = \"0\" + clock_minutes; } if (clock_seconds < 10){ clock_seconds = \"0\" + clock_seconds; } var clock_div = document.getElementById('js_clock'); clock_div.innerHTML = '".TransformDate(date('d-m-Y'))." ' + clock_hours + \":\" + clock_minutes + \":\" + clock_seconds + \" \" + clock_suffix; setTimeout(\"js_clock()\", 1000); } js_clock(); </script> </span> ";
}
function ShowMessagesList()
{
    global $lang;
    $outp = '<div id="messageslist">';
    $outp .= "<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a>';
    $outp .= "<table class='crm'>";
    $outp .= '<thead><tr><th><strong>From</strong></th><th><strong>Subject</strong></th><th><strong>Date/time</strong></th></tr></thead>';
    $msglist = GetMessage($GLOBALS['USERID'], 'all', 'to', 8);
    $x = 0;
    foreach ($msglist as $msg) {
        $font_ins1 = '';
        $font_ins2 = '';
        if ($msg['read'] == 'n') {
            $font_ins1 = "<span style='color: #3300FF;'>";
            $font_ins2 = '</span>';
        }
        $outp .= "<tr onclick=\"window.location.href='index.php?UserMessage&amp;ReadInternalMessage=".$msg['id']."'\" class='pointer' onmouseover=\"style.background='#cccccc';\"  onmouseout=\"style.background='#ffffff';\"><td>".$font_ins1.GetUserName($msg['from']).$font_ins2.'</td><td>'.$font_ins1.$msg['subject'].$font_ins2.'</td><td>'.$font_ins1.$msg['time_formatted'].$font_ins2.'</td></tr>';
        ++$x;
    }
    if (is_administrator()) {
        $msglist = GetMessage('admin', 'all', 'to', 8);
        foreach ($msglist as $msg) {
            $font_ins1 = '';
            $font_ins2 = '';
            if ($msg['read'] == 'n') {
                $font_ins1 = "<span style='color: #3300FF;'>";
                $font_ins2 = '</span>';
            }
            $outp .= "<tr onclick=\"window.location.href='index.php?UserMessage&amp;ReadInternalMessage=".$msg['id']."'\" class='pointer' onmouseover=\"style.background='#cccccc';\"  onmouseout=\"style.background='#ffffff';\"><td>".$font_ins1.GetUserName($msg['from']).$font_ins2.'</td><td>'.$font_ins1.$msg['subject'].$font_ins2.'</td><td>'.$font_ins1.$msg['time_formatted'].$font_ins2.'</td></tr>';
            ++$x;
        }
    }
    $outp .= '</table></div>';
    if ($x > 0) {
        return $outp;
    } else {
        return "<a href='index.php?UserMessage'>".$lang['messageinbox'].'</a><br><br>'.$lang['nomessages'];
    }
}

function GenerateImageThumbnails($fileid = 0, $print = false)
{
    if (GetSetting('ENABLEIMAGETHUMBNAILS') == 'Yes') {
        $sql = '';
        if (ipi($fileid)) {
            if ($print) print date('r') . " Generating thumbnail by file id...\n";
            $sql = "SELECT CRMbinfiles.fileid,CRMbinfiles.filetype FROM CRMblobs, CRMbinfiles WHERE CRMbinfiles.filetype IN ('image/jpeg','image/gif','image/png') AND CRMbinfiles.fileid=".$fileid . " AND CRMblobs.fileid = CRMbinfiles.fileid";
        } else {
            if ($print) print date('r') . " Generating all thumbnails (new only)...\n";
            $sql = "SELECT CRMbinfiles.fileid,CRMbinfiles.filetype FROM CRMblobs, CRMbinfiles WHERE CRMbinfiles.filetype IN ('image/jpeg','image/gif','image/png') AND CRMblobs.thumbnail='' AND CRMblobs.fileid = CRMbinfiles.fileid";
        }

        $res = mcq($sql);
        $ret = '';

        while ($row = mysqli_fetch_array($res)) {
            if ($print) print "\015" . date('r') . " thumbnail created for file ".$row['fileid'].' '.GetSetting('title').' '.$row['filetype'].'';
            $fn = CopyFileToDisk($row['fileid']);
            $tn = CreateImageThumbnail($fn, $row['filetype'], 200);
            unlink($fn);

            if (strlen($tn) > 1) {
                mcq("UPDATE CRMblobs SET thumbnail='".mres($tn)."' WHERE fileid=".$row['fileid']."");
                if (is_positive_integer($fileid)) {
                    $ret = $tn;
                    qlog(INFO, 'Returning thumbnail ...');
                }
                if ($print) {
                    print "\015" . date('r') . " thumbnail created for file ".$row['fileid'].' '.GetSetting('title').' '.$row['filetype'].'';
                }
            } else {
                if ($print) {
                    print "\015" . date('r') . " FAILED to create a thumbnail for file ".$row['fileid'].' '.GetSetting('title')."\n";
                }
                if (is_positive_integer($fileid)) {
                    $ret = $tn;
                    qlog(INFO, 'NOT Returning thumbnail (failed!)');
                }
            }
            unset($tn);
        }
        if ($print) {
            print "\015" . date('r') . " Done.                                                                                                          \n";
        }

        qlog(INFO, 'Finished thumbing...');
        return $ret;

    } else {

        qlog(INFO, 'Image thumbnailing is disabled');
        return false;

    }
}
function GetImageThumbnail($fileid)
{
    if (GetSetting('ENABLEIMAGETHUMBNAILS') == 'Yes') {
        $row = db_GetRow("SELECT thumbnail FROM CRMblobs WHERE fileid='".mres($fileid)."' AND thumbnail!=''");
        if ($row['thumbnail'] != '') {
            qlog(INFO, 'Fetched thumbnail '.$fileid.'from database');

            return $row['thumbnail'];
        } else {
            qlog(INFO, 'Generating thumbnail '.$fileid.' on the fly');


            return GenerateImageThumbnails($fileid);
        }
    } else {
        qlog(INFO, 'Image thumbnailing is disabled');

        return false;
    }
}
function GetMiniThumbnail($fileid)
{
    if (is_positive_integer($fileid)) {
        $row = db_GetRow('SELECT minithumbnail FROM CRMblobs WHERE fileid='.$fileid." AND minithumbnail!=''");
        if ($row['minithumbnail'] != '') {

            qlog(INFO, 'Fetched minithumbnail '.$fileid.'from database');
            return $row['minithumbnail'];

        } else {

            qlog(INFO, 'Generating minithumbnail '.$fileid.' on the fly');
            $fileondisk = CopyFileToDisk($fileid);
            $img = CreateImageThumbnail($fileondisk, GetFileType($fileid), 26);
            unlink($fileondisk);
            mcq("UPDATE CRMblobs SET minithumbnail='".mres($img)."' WHERE fileid=".$fileid);
            return $img;
        }
    } else {
        return false;
    }
}
function CreateImageThumbnail($img_path, $format, $max_width_or_height = 240)
{
    if (GetSetting('ENABLEIMAGETHUMBNAILS') == 'Yes') {
        if (!ipi($max_width_or_height)) {
            $max_width_or_height = 240;
        }
        $copyrightmsg = GetSetting('ImageThumbailCopyrightMessage');
        $autorotate = true;
        //print $img_path . " SIZE " . filesize($img_path) . "\n\n";
        return ResizeImage(file_get_contents($img_path), 0, 0, '255,255,255', '104,104,104', $copyrightmsg, $autorotate, $max_width_or_height);
    } else {
        qlog(INFO, 'Image thumbnailing is disabled');

        return false;
    }
}
function SetMimeType($fileid)
{
    mcq("UPDATE CRMbinfiles SET filetype='".mres(GetMimeType($fileid))."' WHERE fileid='".mres($fileid)."'");

    return true;
}
function GetMimeType($fileid)
{
    $fn = CopyFileToDisk($fileid);
    $finfo = finfo_open(FILEINFO_MIME_TYPE);
    $mime = finfo_file($finfo, $fn);
    finfo_close($finfo);
    unlink($fn);

    return $mime;
}
function DeleteOldVersions()
{
    PrintAD('This feature is not (yet) implemented');
}
function DropPersonalDataStructure($userid)
{
    global $lang;

    if ($userid > 0) {
        mcq("DELETE FROM CRMdatastructures WHERE userid='".mres($userid)."'");
    } else {
        mcq('TRUNCATE TABLE CRMdatastructures');
        CreateSystemDataStructure();
        mcq('INSERT INTO CRMdatastructures(userid, datastructure) VALUES ('.$GLOBALS['USERID'].",'".mres(serialize(get_data_structure()))."') ON DUPLICATE KEY UPDATE userid=userid");
    }
}
function DropAllUserCache($user)
{
    foreach (db_GetFlatArray("SELECT temp FROM CRMsessions WHERE userid='".mres($user)."'") as $sess) {
        mcq("DELETE FROM CRMcache WHERE session='".mres($sess)."'");
    }
    DropPersonalDataStructure($user);
}
function DropAllCache()
{
    mcq('TRUNCATE TABLE CRMcache');
    mcq("UPDATE CRMsessions SET sessioncache=''");
    DropPersonalDataStructure(0);
    DeleteExpiredTempFiles();
    AdminChangesDropCache();
}
function GetExtraFieldType($fieldname)
{
    $fieldname = str_replace('EFID', '', $fieldname);

    if ($GLOBALS['PageCache']['ExtraFieldTypes'][$fieldname] != '') {
        return $GLOBALS['PageCache']['ExtraFieldTypes'][$fieldname];
    } else {
        qlog(INFO, 'Fetch fields from db...');

        foreach (db_GetArray("SELECT * FROM CRMextrafields WHERE deleted='n'") as $f) {
            $GLOBALS['PageCache']['ExtraFieldTypes'][$f['id']] = $f['fieldtype'];
        }

        return $GLOBALS['PageCache']['ExtraFieldTypes'][$fieldname];
    }
}
function GetExtraFieldOptions($fieldname)
{
    $ret = '';
    if (is_numeric($fieldname)) {
        $t = db_GetRow("SELECT options,fieldtype FROM CRMextrafields WHERE id='".mres($fieldname)."'");
        if ($tmp = unserialize($t[0])) {
            $ret = $tmp;
        } else {
            $ret = $t[0];
        }
    }

    return $ret;
}
function GetExtraFieldTableType($fieldname)
{ // returns "34" or "userprofiles", or "loginusers", or "files"
    $fieldname = str_replace('EFID', '', $fieldname);
    $fieldname = str_replace('JS_', '', $fieldname);

    if (is_numeric($fieldname)) {
        $t = db_GetRow("SELECT tabletype FROM CRMextrafields WHERE id='".mres(str_replace('EFID', '', $fieldname))."'");
        if ($t[0] == 'user') {
            $t[0] = 'loginusers';
        }
        if ($t[0] == 'group') {
            $t[0] = 'userprofiles';
        }

        return $t[0];
    } else {
        return false;
    }
}
function GetExtraFieldName($fieldid, $flextable = false)
{
    global $lang;
    if (is_numeric($fieldid)) {
        return $lang['EFID'.$fieldid];
    } else {
        return $fieldid;
    }
}

function GetFlextableFieldValue($rid, $fid, $tid, $raw = false, $html = true, $pregiven_value = false, $pregiven_value_given = false)
{
    // This function is here for compaitbility only.
    return GetExtraFieldValue($rid, $fid, $html, $raw, $pregiven_value, $pregiven_value_given);
}

function GetExtraFieldValue($eid, $fid, $html = true, $raw = false, $pregiven_value = '', $pregiven_value_given = false)
{
    qlog(INFO, GetBackTrace(false));
    if ($eid == '' || $eid == '_new_') {
        return '';
    } else {
        $field = db_GetRow("SELECT * FROM CRMextrafields WHERE deleted='n' AND id='".mres($fid)."'");

        $table = $field['tabletype'];

        if ($table == 'user') {
            $table = 'loginusers';
        }
        if ($table == 'group') {
            $table = 'userprofiles';
        }
        $id = '';

        if ($table == 'loginusers') {
            $id = 'id';
        } elseif ($table == 'userprofiles') {
            $id = 'id';
        } elseif ($table == 'files') {
            $id = 'fileid';
            $table = 'binfiles';
        } elseif (is_numeric($table)) {
            $id = 'recordid';
            $flextableid = $table;
            $table = 'flextable'.$table;
        } else {
            log_msg("ERROR: GetExtraFieldValue couldn't determine table type of field ".$fid.' of recordid '.$eid);

            return false;
        }
        $dontformatnumbers = false;
        if ($raw == 'dontformatnumbers' && strlen($raw) == 17) {
            unset($raw);
            $dontformatnumbers = true;
        } elseif ($raw) {
            //	$raw = true;
            qlog(INFO, 'Processing RAW');
        }

        if ($eid == 'new') {
            if ($field['defaultval']) {
                return EvaluateTemplatePHP($field['defaultval']);
            } else {
                return '';
            }
        }
        $val = '';
        if ($pregiven_value_given) {
            $val = trim($pregiven_value);
            qlog(INFO, 'Using pre-given value, not fetching from database');
        } else {
            $sql = 'SELECT EFID'.$fid.' FROM CRM'.$table.' WHERE '.$id.'='.$eid;
            $val = db_GetValue($sql);
            //print "FETCH. SHOULD NOT FETCH. UNHAPPY! Rec $eid, table $table, field . " . $field['id'] . "<br>";
        }

        if ($field['fieldtype'] == 'text area') {
        } elseif ($field['fieldtype'] == 'Reference to FlexTable') {
            if ($val == 0) {
                $val = '';
            }
            if (!$raw) {
                $table = $field['options'];
                $y = GetFlexTableDefinitions($table);
                $layout = $y[0]['refer_field_layout'];

                $tmp = GetAttribute('extrafield', 'BlindReferenceFieldLayout', $fid);
                if ($tmp != '') {
                    $layout = $tmp;
                }

                //if (trim($val) != "") {
                if ($val > 0) {
                    if (IsValidFlexTableRecord($val, $table)) {
                        $val = unescape_interleave_characters(ParseTemplateRecordData($layout, 't'.$table, $val));
                        if (!$html) {
                            $val = html2plaintext($val);
                        }
                    } else {
                        $val = '[unknown] ('.$val.' '.$table.')';
                        //$val = "";
                    }
                } else {
                    $val = '';
                }
            } else {
                $val = $val;
                qlog(INFO, 'Returning RAW flexref value');
            }
        } elseif ($field['fieldtype'] == 'Reference to FlexTable (multiselect)') {
            $table = $field['options'];
            $y = GetFlexTableDefinitions($table);
            $layout = $y[0]['refer_field_layout'];

            $tmp = GetAttribute('extrafield', 'BlindReferenceFieldLayout', $fid);
            if ($tmp != '') {
                $layout = $tmp;
            }

            $tmp = unserialize($val);
            unset($val);

            $vals = array();

            foreach ($tmp as $element) {
                if (!$raw) {
                    if (IsValidFlexTableRecord($element, $table)) {
                        $val = unescape_interleave_characters(ParseTemplateRecordData($layout, 't'.$table, $element));
                        if (!$html) {
                            $val = html2plaintext($val);
                        }
                        $vals[] = $val;
                    }
                } else {
                    $vals[] = ($element);
                }
            }
            if (!$raw) {
                $val = implode(', ', $vals);
            } elseif ($raw) {
                $val = implode(';', $vals);
            }
        } elseif ($field['fieldtype'] == 'List of all groups' && !$raw) {
            $val = GetGroupName($val);
        } elseif (substr($field['fieldtype'], 0, 16) == 'Users of profile' && !$raw) {
            $val = GetUserName($val);
        } elseif ($field['fieldtype'] == 'drop-down (multiselect)' || $field['fieldtype'] == 'SQL Query (multiselect)') {
            $tmp = unserialize($val);
            unset($val);
            if ($raw) {
                $val = array();
            }

            $first = false;
            foreach ($tmp as $element) {
                if ($raw) {
                    $val[] = $element;
                } else {
                    if ($first) {
                        $val .= ', ';
                    }
                    $val .= $element;
                    $first = true;
                }
            }
        } elseif ($field['fieldtype'] == 'date' && !$raw) {
            $val = TransformDate($val);
        } elseif ($field['fieldtype'] == 'date/time') {
            if ($val == '0000-00-00 00:00:00') {
                $val = '';
            } else {
                if (!$raw) {
                    $val = SQLDateTimeToFormattedDateTime($val);
                }
            }
        } elseif ((strstr($field['fieldtype'], 'User-list') || substr($field['fieldtype'], 0, 16) == 'Users of profile') && !$raw) {
            $val = GetUserName($val);
        } elseif ($field['fieldtype'] == 'List of values') {
            $val = string_r(unserialize($val));
        } elseif ($field['fieldtype'] == 'diary' && !$raw) {
            $val2 = unserialize($val);
            if (!is_array($val2)) {
                $val2 = array();
            }
            $opt = array_reverse($val2);
            $val = '';
            if ($html) {
                $val = '<div class="diarycontainer">';
                $val .= '<table class="diarytable">';
                $grey = false;
                if (count($opt) % 2) { //not even
                    $grey = true;
                }
                foreach ($opt as $diary_remark) {
                    $ins = '';
                    if ($grey) {
                        $ins = " style='background: #E0E0E0'";
                        $grey = false;
                    } else {
                        $grey = true;
                    }
                    if ($diary_remark[2] != '') {
                        $val .= '<tr'.$ins.'><td class="diarycell">'.TransformDate(date('d-m-Y', $diary_remark[0])).' '.date('H:i', $diary_remark[0]).'h</td><td class="diarycell">'.GetUserName($diary_remark[1]).'</td><td class="diarycellcontent">'.nl2br(htme($diary_remark[2])).'</td></tr>';
                    }
                }
                $val .= '</table>';
                $val .= '</div>';
            } else {
                foreach ($opt as $diary_remark) {
                    $val .= TransformDate(date('d-m-Y', $diary_remark[0])).' '.date('H:i', $diary_remark[0]).'h : '.GetUserName($diary_remark[1]).' : '.$diary_remark[2]."\n";
                }
            }
        } elseif (!$raw && is_numeric($val) && $field['number_format'] != "don't format" && $field['number_format'] != '' && !$dontformatnumbers && $field['fieldtype'] == 'numeric') {
            $val = FormatNumber($val, 2, $field['id']);
        } else {
            $val = $val;
        }

        return $val;
    } // end if !access
}
function FormatNumber($num, $decimals = 2, $field_id = false, $returnZero = false, $dummy = false, $dummy2 = false)
{
    if ($num == '' && !$returnZero) {
        return '';
    } elseif ($num == '') {
        $num = '0';
    } elseif (!is_numeric($num)) {
        return $num;
    }

    if (!$GLOBALS['DONTFORMATNUMBERS']) {
        $tmp = '';
        if ($field_id) {
            if ($GLOBALS['PageCache']['NumberFormats'][$field_id] == '') {
                $tmp = db_GetArray('SELECT id, number_format FROM CRMextrafields');
                foreach ($tmp as $row) {
                    $GLOBALS['PageCache']['NumberFormats'][$row['id']] = $row['number_format'];
                }
                $tmp = $GLOBALS['PageCache']['NumberFormats'][$field_id];
            } else {
                $tmp = $GLOBALS['PageCache']['NumberFormats'][$field_id];
            }
            if ($tmp == "don't format") {
                return $num;
            } elseif ($tmp == 'no decimals') {
                $decimals = 0;
            } elseif ($tmp == '1 decimal') {
                $decimals = 1;
            } elseif ($tmp == '3 decimals') {
                $decimals = 3;
            } elseif ($tmp == '4 decimals') {
                $decimals = 4;
            } elseif ($tmp == '5 decimals') {
                $decimals = 5;
            } elseif (substr($tmp, 0, 8) == 'currency') {
                $decimals = 2;
            }
            /*
            "normal"		=> "Normal",
            "don't format"	=> "Don't format",
            "currency"		=> "Currency (without sign)",
            "currency EUR"	=> "Currency &euro;",
            "currency DOL"	=> "Currency $",
            "currency BRP"	=> "Currency &pound;",
            "currency YEN"	=> "Currency &yen;",
            "no decimals"	=> "No decimals",
            "1 decimal"		=> "1 decimal",
            "3 decimals"		=> "3 decimals",
            "4 decimals"		=> "4 decimals",
            "5 decimals"		=> "5 decimals",
            */
        }
        if ($GLOBALS['UC']['DateFormat'] == 'dd-mm-yyyy') {
            $num = number_format($num, $decimals, ',', '.');
        } else {
            $num = number_format($num, $decimals, '.', ',');
        }

        if ($tmp == 'currency EUR' && $num != '') {
            $num = '€ '.$num;
        } elseif ($tmp == 'currency DOL' && $num != '') {
            $num = '$ '.$num;
        } elseif ($tmp == 'currency BRP' && $num != '') {
            $num = '£ '.$num;
        } elseif ($tmp == 'currency YEN' && $num != '') {
            $num = '¥ '.$num;
        }
    }

    return $num;
}
function GetFlexTableDefinitions($tableid = false, $orientation = false, $no_cache = false, $type = 'both')
{
    if ($tableid) {
        $tableid = str_replace('flextable', '', $tableid); // just to be sure
    }

    if (is_array($GLOBALS['PageCache']['FlextableDefinitions'][$tableid]) && is_numeric($tableid) && !$no_cache) {
        qlog(INFO, 'CACHE Called with table '.$tableid);

        return $GLOBALS['PageCache']['FlextableDefinitions'][$tableid];
    } elseif (is_array($GLOBALS['PageCache']['FlextableDefinitions-'.$orientation]) && !$no_cache) {
        qlog(INFO, 'CACHE Called with table '.$tableid);

        return $GLOBALS['PageCache']['FlextableDefinitions-'.$orientation];
    } elseif (is_array($GLOBALS['PageCache']['FlextableDefinitionsAll']) && !$no_cache && !$tableid && !$orientation) {
        qlog(INFO, 'CACHE All tables');

        return $GLOBALS['PageCache']['FlextableDefinitionsAll'];
    } else {
        //		qlog(INFO, "No cache, determine");
        $sqladd = '';
        if (is_numeric($tableid)) {
            $sqladd = " WHERE recordid='".mres($tableid)."'";
        }

        $sql = 'SELECT * FROM CRMflextabledefs '.$sqladd;
        $sql .= ' ORDER BY `ordering`, `recordid`';

        $t = db_GetArray($sql);

        if ($tableid) {
            qlog(INFO, 'Returned flextable definitions for table '.$tableid);
        } else {
            qlog(INFO, 'Returned flextable definitions for all tables');
        }
        if ($tableid) {
            $GLOBALS['PageCache']['FlextableDefinitions'][$tableid] = $t;
        } else {
            $GLOBALS['PageCache']['FlextableDefinitionsAll'] = $t;
        }

        return $t;
    }
}
function GetFlexTableName($tableid)
{
    global $lang;
    if (is_numeric($tableid)) {
        $tmp = GetFlexTableNames($tableid);

        return $tmp[0];
    } else {
        return false;
    }
}
function GetFlexTableNames($tableid = false)
{
    $sqladd = '';
    if (is_numeric($tableid)) {
        $sqladd = " WHERE recordid='".mres($tableid)."'";
    }

    return db_GetFlatArray('SELECT tablename FROM CRMflextabledefs'.$sqladd);
}
if (!function_exists('debug_print_backtrace')) {
    function debug_print_backtrace()
    {
        return 'Your PHP version is too old. It cannot print backtraces.';
    }
}
function CheckIfPasswordMustBeChanged()
{
    $max_exp = GetSetting('PASSWORDEXPIRE') * 86400; // Days, in seconds
    if ($max_exp > 10 && is_numeric($GLOBALS['USERID'])) {
        $lastchange = db_GetRow("SELECT UNIX_TIMESTAMP(LASTPASSCHANGE), FORCEPASSCHANGE FROM CRMloginusers WHERE id='".mres($GLOBALS['USERID'])."'");
        if ((($lastchange[0] + $max_exp) < date('U')) || $lastchange['FORCEPASSCHANGE'] == 'y') {
            qlog(INFO, 'Password is expired and must be renewed.');
            if (GetAttribute('user', 'PasswordNeverExpires', $GLOBALS['USERID']) != 'True') {
                return true;
            } else {
                // Password is expired but no problem
                return false;
            }
        } else {
            qlog(INFO, 'Password is NOT expired.');

            return false;
        }
    }
}
function ReturnDropDownSearchField($ElementID)
{
    global $lang;

    return "&nbsp;<span class=\"fa fa-search search_img\"></span><input type='search' class='search_input search_input_small' onkeydown=\"JSearch('".$ElementID."',this.value);\" onkeyup=\"JSearch('".$ElementID."',this.value);\" onblur=\"if (typeof document.getElementById('".$ElementID."').onchange == 'function') { document.getElementById('".$ElementID."').onchange(); } \" placeholder=\"".htme($lang['search']).'">';
}
function ClearAllRunningCache()
{
    unset($GLOBALS['PageCache']);
    unset($GLOBALS['settings']);
}
function UnCompressFile($fileid)
{
    $result1 = db_GetRow("SELECT * FROM CRMblobs, CRMbinfiles WHERE CRMblobs.fileid='".mres($fileid)."' AND CRMblobs.fileid=CRMbinfiles.fileid");

    if ($result1['gz'] == 'y' && $result1['offloaded'] == 'n') {
        qlog(INFO, 'Requested file is compressed, uncompressing');
        $b = strlen($result1['content']);
        $blob = gzinflate($result1['content']);
        $a = strlen($blob);
        qlog(INFO, 'Filesize was '.$b.', is now '.$a);
        $sql = "UPDATE CRMblobs SET content='".mres($blob)."', gz='n' WHERE fileid='".mres($fileid)."'";
        mcq($sql);
    } elseif ($result1['offloaded'] == 'y') {
        print "Can't uncompress, file is offloaded";
    }
}
function UnCompressAllFiles()
{
    $t = db_GetArray("SELECT fileid FROM CRMblobs WHERE gz='y'");
    foreach ($t as $file) {
        UnCompressFile($file['fileid']);
        print "\015Uncompressing file ".$file['fileid'].'   ';
    }
    mcq('OPTIMIZE TABLE CRMblobs');
    print "\n";
}

function CompressFile($fileid)
{
    if (is_positive_integer($fileid)) {

        $blob = GetFileContent($fileid);

        qlog(INFO, 'File size before compression: '.strlen($blob));

        $gzblob = gzdeflate($blob, 9);

        SetFileContent($fileid, $gzblob, false, true);

        $blobgz = GetFileContent($fileid); // GetFileContent decompresses it automatically!

        if ($blob == $blobgz) {
            // Values are the same
            $a = strlen($blob);
            $b = strlen($gzblob);
            print date('r') . ' : Successfully compressed file '.$fileid.'. Was: '.$a.' bytes, is now '.$b.' bytes.' . "\n";
        } else {
            // Decode test didn't match; re-set to old values
            $a = strlen($blob);
            $b = strlen($blobgz);
            print date('r') . ' : WARNING: Compressing file '.$fileid.' failed! (restored) '.$a.' '.$b . "\n";
            SetFileContent($fileid, $blob, false, false);
        }
    } else {
        log_msg('ERROR: CompressFile called with non-numeric file id!');
    }
}
function ProcessOldTodos()
{
    // Add locking
    //we use strtolower because this database column in not binary. to prevent cases where worker_hash "abcde" would also match "ABCDE" or "ABcdE", etc
    $worker_hash = strtolower(randomstring(32));

    /* get all todo's 5 seconds and older */
    $sql = "UPDATE CRMtodo SET worker_hash='".mres($worker_hash)."' WHERE worker_hash='' AND UNIX_TIMESTAMP(timestamp_last_change) < (UNIX_TIMESTAMP(NOW()) - 5)";
    mcq($sql);

    $Todo = db_GetArray("SELECT todoid, onchange, to_value, eid, user, UNIX_TIMESTAMP(timestamp_last_change) AS tp FROM CRMtodo WHERE worker_hash='".mres($worker_hash)."'");

    $changed_already_done = array();

    foreach ($Todo as $do) {
        mcq("DELETE FROM CRMtodo WHERE todoid='".mres($do['todoid'])."'");
        $current_user = $GLOBALS['USERID'];
        qlog(INFO, 'Todo: switching to user credentials of user '.$do['user']);

        $GLOBALS['USERID'] = $do['user'];
        $GLOBALS['NO_MSG'] = true;
        InitUser($do['user']);
        $ft = false;
        if (ipi(GetExtraFieldTableType($do['onchange']))) {
            $ft = GetExtraFieldTableType($do['onchange']);
        } elseif (strstr($do['onchange'], '-added')) {
            $ft = str_replace('-added', '', str_replace('t', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-changed')) {
            $ft = str_replace('-changed', '', str_replace('-t', '', $do['onchange']));
        } elseif (strstr($do['onchange'], '-deleted')) {
            $ft = str_replace('-deleted', '', str_replace('-t', '', $do['onchange']));
        }

        if ($do['eid']) {
            $dsname = '';

            if (!ipi($ft)) {
                $dsname = $ft;
            } else {
                $dsname = 'f'.$ft;
            }

            if ($do['onchange'] == $dsname.'-changed') {

                if (!$changed_already_done[$ft.'='.$do['eid']]) {
                    Processrules($dsname, $do['eid'], '', 'changed', $do['to_value']);
                    $changed_already_done[$ft.'='.$do['eid']] = true;
                }
            } elseif ($do['onchange'] == $dsname.'-added') {
                Processrules($dsname, $do['eid'], '', 'added', $do['to_value']);

            } elseif ($do['onchange'] == $dsname.'-deleted') {
                Processrules($dsname, $do['eid'], '', 'deleted', $do['to_value']);

            } else {
                Processrules($dsname, $do['eid'], 'f'.str_replace('EFID', '', $do['onchange']), 'changed', $do['to_value']);
            }
        } else {
            log_msg('ERROR: Todo item found without recordid: '.$do['onchange'].' value '.$do['to_value'].' recordid '.$do['eid']);
        }

        qlog(INFO, 'Todo: switching back user credentials of user '.$current_user);
        $GLOBALS['USERID'] = $current_user;
        InitUser($current_user);

        $GLOBALS['NO_MSG'] = false;


    }
    return($Todo);
}
function AddToDo($onchange, $to_value, $eid, $from_value)
{
    /* static; we want to load this only once */
    static $fields_in_rules;

    if ($eid == 0 || $eid == '') {
        log_msg('ERROR: A ToDo was just logged with an empty recordid! _REQ: '.string_r($_REQUEST));

        return true;
    } else {
        qlog(INFO, 'AddToDo : Add to-do On_cha '.$onchange.' To_val '.$to_value.' recordid '.$eid.' From_val '.$from_value);
    }
    //elseif ($to_value == $from_value) {
    //	return false;
    //}
    $parts = explode('-', $onchange);

    /* if it is an FQN check if the field has any rule conditions before logging the todo. */
    if (ipi(str_replace("t", "", $parts[0])) && ipi(str_replace("f", "", $parts[1]))) {
        if (!is_array($fields_in_rules)) {
            $fields_in_rules = db_GetFlatArray("SELECT `CRMruleconditions`.`field` FROM `CRMruleconditions` WHERE `CRMruleconditions`.`field` LIKE 't%' AND `CRMruleconditions`.`field` LIKE '%-f%'");
        }
        if (!in_array($onchange, $fields_in_rules)) {

            /* a change for a field, but not a single rule is depending on this field. skip logging it alltogether */

            return true;
        }
    }


    $t = db_GetRow("SELECT * FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange='".mres($onchange)."' AND user='".mres($GLOBALS['USERID'])."' AND from_value='".mres($to_value)."'");

    if ($t['eid'] && (!strstr($onchange, '-changed') && !strstr($onchange, '-added') && !strstr($onchange, '-deleted'))) {
        qlog(INFO, "Todo's cancel each other out!");
        $sql = "DELETE FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange='".mres($onchange)."' AND user='".mres($GLOBALS['USERID'])."'";
        mcq($sql);
        // Check if there are more than 1 actions waiting. If it's only "xxx_change", delete that one too
        $t = db_GetArray("SELECT * FROM CRMtodo WHERE eid='".mres($eid)."'");
        $something_else = false;
        foreach ($t as $todo) {
            if (!strstr($todo['onchange'], '-changed')) {
                $something_else = true;
            }
        }
        if (!$something_else) {
            if (strstr($onchange, '-changed')) {
                // Concerns flextable
                mcq("DELETE FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange LIKE '%-changed' AND user='".mres($GLOBALS['USERID'])."'");
            }
        }
    } else {
        mcq("DELETE FROM CRMtodo WHERE eid='".mres($eid)."' AND onchange='".mres($onchange)."' AND user='".mres($GLOBALS['USERID'])."'");
        $sql = "INSERT INTO CRMtodo(eid, onchange, to_value, from_value, user, timestamp_last_change) VALUES('".mres($eid)."', '".mres($onchange)."','".mres($to_value)."','".mres($from_value)."','".mres($GLOBALS['USERID'])."',NOW())";

        mcq($sql);
    }

    return true;
}

function GetFileTableType($file_id)
{
    return db_GetValue("SELECT type FROM CRMbinfiles WHERE fileid='".mres($file_id)."'");
}
function RevertToFile($fileid)
{
    $row = db_GetRow("SELECT * FROM CRMbinfiles, CRMblobs WHERE CRMbinfiles.fileid=CRMblobs.fileid AND CRMbinfiles.fileid='".mres($fileid)."' AND version_belonging_to != '0'"); // file to revert to MUST be an "older" version
    $acc = CheckTableRecordAccess('files', $row['version_belonging_to']);

    if (ipi($row['version_belonging_to']) && $acc == 'ok') {

        // Add old file as most recent version
        $new_file = AttachFile($row['koppelid'], $row['filename'], $row['content'], $row['type'], $row['filetype'], '', true, false, false, false);

        foreach (array_keys($GLOBALS['UC']['PersonalDataStructure']['files']['fields']) as $field) {
            //alleen EFID tags
            if (preg_match("/^f\d+$/", $field)) {
                $sql = 'UPDATE CRMbinfiles SET '.$GLOBALS['UC']['PersonalDataStructure']['files']['fields'][$field]['name_in_database']."='".mres(db_GetValue('SELECT '.$GLOBALS['UC']['PersonalDataStructure']['files']['fields'][$field]['name_in_database']." FROM CRMbinfiles WHERE fileid='".mres($fileid)."'"))."' WHERE fileid='".mres($new_file)."'";

                mcq($sql);
            }
        }

        $t = db_GetRow("SELECT version_no FROM CRMbinfiles WHERE fileid='".mres($row['version_belonging_to'])."'");
        $newversion = $t[0] + 1;
        mcq("UPDATE CRMbinfiles SET version_belonging_to='".$new_file."', timestamp_last_change=timestamp_last_change WHERE version_belonging_to='".mres($row['version_belonging_to'])."'");
        mcq("UPDATE CRMbinfiles SET version_belonging_to='".$new_file."', timestamp_last_change=timestamp_last_change WHERE fileid='".mres($row['version_belonging_to'])."'");
        mcq("UPDATE CRMbinfiles SET version_no='".$newversion."', version_belonging_to=0, timestamp_last_change=timestamp_last_change WHERE fileid=".$new_file);

        list($tt, $record) = db_GetRow("SELECT type, koppelid FROM CRMbinfiles WHERE fileid='".$row['version_belonging_to']."'");

        if (substr($tt, 0, 9) == 'flextable') {
            journal($record, 'Reverted to file id '.$fileid.' ['.$row['filename'].']', $tt);
        }

        return $new_file;
    } else {
        print 'error '.$acc.' parent '.$row['version_belonging_to'];

        return false;
    }
}
function DeleteFile($file_id, $skip_security = false, $skip_revert = false)
{
    if (!is_numeric($file_id)) {
        exit;
    } // SQL injection prevention (sort of)

    $type = GetFileTableType($file_id);
    $pass = false;
    if ($skip_security || CheckTableRecordAccess('files', $file_id) == 'ok') {
        $pass = true;
    }

    if (GetFileType($file_id) == '{{{folder}}}') {
        $count = db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE folder='".$file_id."'");
        if ($count > 0) {
            print '<span class="errmsg">Error: folder not empty. Not deleted.</span><br>';
            $pass = false;
        }
    }

    if ($pass) {
        journal(db_GetValue("SELECT koppelid FROM CRMbinfiles WHERE fileid='".mres($file_id)."'"), 'File id '.$file_id.' ['.GetFilename($file_id).'] deleted', GetFileTableType($file_id));
        GetFileTableType($file_id);

        $sql = "DELETE FROM CRMbinfiles WHERE fileid='".mres($file_id)."'";
        mcq($sql);
        $sql = "DELETE FROM CRMblobs WHERE fileid='".mres($file_id)."'";
        mcq($sql);

        // Fetch least-old version, if appliccable
        $t = db_GetRow("SELECT * FROM CRMbinfiles WHERE version_belonging_to='".mres($file_id)."' ORDER BY timestamp_last_change DESC");

        if ($t && !$skip_revert) {
            mcq('UPDATE CRMbinfiles SET version_belonging_to=0,timestamp_last_change=timestamp_last_change WHERE fileid='.$t['fileid']);
            mcq("UPDATE CRMbinfiles SET version_belonging_to='".$t['fileid']."',timestamp_last_change=timestamp_last_change WHERE version_belonging_to='".mres($file_id)."'");
            journal(db_GetValue("SELECT koppelid FROM CRMbinfiles WHERE fileid='".mres($file_id)."'"), 'Reverted to file id '.$t['fileid'].' ['.GetFileName($t['fileid']).']', $type);
        }
    } else {
        qlog(INFO, 'User tried to delete file '.$file_id.' but access was denied');
    }
}
function UpdateDiaryField($eid, $fieldname, $dummy, $value, $commenthash)
{
    if ($value != '') {
        $tabletype = GetExtraFieldTableType($fieldname);
        $id = '';
        $journaltype = '';
        $ft = '';
        $accesstype = '';

        if (is_numeric($tabletype)) {
            $id = 'recordid';
            $ft = $tabletype;
            $tabletype = 'flextable'.$tabletype;
            $journaltype = $tabletype;
        } elseif ($tabletype == 'loginusers') {
            if (CheckFunctionAccess('UserAdmin') != 'ok' && !is_administrator()) {
                $accesstype = 'nok';
            } else {
                $accesstype = 'ok';
            }
            $id = 'id';
            $journaltype = 'user';
        } elseif ($tabletype == 'userprofiles') {
            if (CheckFunctionAccess('UserAdmin') != 'ok' && !is_administrator()) {
                $accesstype = 'nok';
            } else {
                $accesstype = 'ok';
            }

            $id = 'id';
            $journaltype = 'group';
        }

        $ef_array = array();
        if (is_numeric($eid)) {
            $ef_array = db_GetRow('SELECT EFID'.$fieldname.' AS value FROM CRM'.$tabletype.' WHERE '.$id."='".mres($eid)."'");
        }
        $val = $ef_array['value'];
        $val_ar = unserialize($val);
        $add_ar = array(date('U'), $GLOBALS['USERID'], $value);
        $what = '';
        if ($commenthash == '') {
            $val_ar[] = $add_ar;
            $what = 'added';
        } elseif ((CheckFunctionAccess('AllowedToAlterDiaryContents') == 'ok') || (is_administrator())) {
            for ($lus = 0; $lus < count($val_ar); ++$lus) {
                $commenthash_this_row = md5($val_ar[$lus][0].$val_ar[$lus][1].$val_ar[$lus][2]);
                if ($commenthash == $commenthash_this_row) {
                    $val_ar[$lus][2] = $value;
                    $what = 'updated';
                    break;
                }
            }
        }

        $to = serialize($val_ar);
        $test = unserialize($to);

        if (count($test) > 0) {
            $sql = 'UPDATE CRM'.$tabletype.' SET EFID'.$fieldname."='".mres($to)."' WHERE ".$id."='".mres($eid)."'";
            mcq($sql);

            journal($eid, 'A record was  '.$what.' to diary field '.$fieldname.'. Text: '.mres($value), $journaltype);
            DataJournal($eid, '{{add}} ', $value, $fieldname);

            // puinhoop
            if ($ft > 0) {
                AddToDo('t'.$ft.'-changed', '', $eid, '');
                AddToDo('t'.$ft.'-f'.$fieldname, $value, $eid, '');
            }
        } else {
            log_msg('ERROR: A diary field was undecodable after unserializing. Not saved. Serialized value is '.$to.', input was '.string_r($val_ar));
        }
    }
}
function PrintHeaderJavascript()
{
    print '<script type="text/javascript" src="js/jquery.js?1"></script>';
    print '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
    print '<script type="text/javascript" src="js/jquery-fancybox/source/jquery.fancybox.pack.js?1"></script>';
    print '<script type="text/javascript" src="js/sorttable.js"></script>';
    print '<script type="text/javascript" src="js/highcharts/js/highcharts.js?2"></script>';

    //	print '<script type="text/javascript" src="js/highcharts/js/modules/exporting.js?1"></script>';
    print '<script type="text/javascript" src="js/functions.js?'.filemtime('js/functions.js').'"></script>';

    $jstemplate = GetSetting('TemplateNoOfJavascriptFileToIncludeInEveryPage');
    if (ipi($jstemplate)) {
        print '<script type="text/javascript" src="' . add_sessionid_to_url('csv.php?getcustomjs=1&amp;'.strtotime(GetTemplateLastModificationDate($jstemplate))) .'"></script>';
    }
    print '<script type="text/javascript" src="js/jquery.autosize.input.js"></script>';

    /* all annotators scripts. unfortunately we have to include them here - but they should be cached */

    print '
    <link rel="stylesheet" type="text/css" href="lib/annotator/2.x/imgareaselect-default.css?1424888816">
    <link rel="stylesheet" type="text/css" href="lib/annotator/2.x/annotator.min.css?1424888816">
    ';

    //print '<script type="text/javascript" src="' . add_sessionid_to_url('csv.php?GetJS&amp;' . date('U')) . '"></script>';
    print '<script type="text/javascript">';
    //print '$(window).unload(function(){}); /* Does nothing but break the bfcache */';
    print ReturnStandardJavascript();
    print '</script>';
}
function PrintUnauthenticatedHeaderJavascript()
{
    DisplayCSS(false, false);
    print '<script type="text/javascript" src="js/jquery.js?1"></script>';
    print '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
    print '<script type="text/javascript" src="js/sorttable.js"></script>';
    print '<script type="text/javascript" src="js/jquery-fancybox/source/jquery.fancybox.pack.js"></script>';
    print '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
    print '<script type="text/javascript" src="js/highcharts/js/highcharts.js?2"></script>';
    //	print '<script type="text/javascript" src="js/highcharts/js/modules/exporting.js?1"></script>';
    print '<script type="text/javascript" src="js/functions.js?'.filemtime('js/functions.js').'"></script>';
    print '<script type="text/javascript" src="js/jquery.autosize.input.js"></script>';
}
function ReturnStandardJavascript()
{
    global $lang;

    $sec = GetSetting('ENTITYLOCKTIMEOUT');
    if ($sec == '' || $sec < 10 || $sec > 3600) {
        $sec = 3600;
    }
    // 60
    $sec = $sec / 15; // Update runs every 15 seconds
    $ret = "

	var my_rep_hash = '" .md5(db_GetValue('SELECT DATABASE()'))."';
    /* this var is previously declared in functions.js to avoid an undeclared check on the login page */
    DevelopmentOrProduction = '" . GetSetting('DevelopmentOrProduction') . "';
	function UpdateRecordLock() {
		if (LockCounter > " .$sec.")
		{
			$('#lostlockmsg').removeClass('hide_content');
		} else {
            if ($('#JS_concerningrecord').val() == LockRecord && $('#JS_concerningtable').val() == LockTable) {
    			$.ajax({
    				type: 'POST',
    				url: add_sessionid_to_url('assist.php?UpdateRecordLock'),
    				data: 'UpdateRecordLock=1&record=' + LockRecord + '&table=' + LockTable,
    				success: ProcessMessageReply
    			});
    			setTimeout('UpdateRecordLock()', LockInterval);
    			LockCounter = LockCounter + 1;
            }
		}
	}
	";

    $ret .= "var mytitle ='".jsencode(GetSetting('title')).' :: '.jsencode($GLOBALS['PRODUCT'])."';";

    /* we don't check user messages when running an unauthenticated module because there won't be a session causing the user to be redirected to the login screen after interval */
    if (!$GLOBALS["run_unauthenticated_module"]) {
        $ret .= 'var interval = 20000;setTimeout("CheckMessages(interval)", interval);';
    }
    $ret .= 'var messages = '.json_encode(get_user_messages(false)).';';
    $ret .= '$(document).ready(function() { ProcessMessageReply(JSON.stringify(messages)); });';
    $ret .= 'var InterleaveDateFormat=\'' . jsencode($GLOBALS['UC']['DateFormat']) . '\';';


    $ret .= "

    $(document).ready(function() {

        $('#quicksearch').keyup(function(e) {

        clearTimeout(typingTimer);
        typingTimer = setTimeout(search_on_server, doneTypingInterval);

        $('nav li a').each(function () {

            var mainname = $(this).closest('ul').closest('li').find('a').html();
            var linktext = $(this).text();

            if (typeof mainname !== 'undefined') {
                linktext = mainname + ' &raquo; ' + $(this).text();
            } 
            if ($(this).attr('href') != '' && typeof $(this).attr('href') !== 'undefined') {
                options[$(this).attr('href')] = linktext;
            }

        });

        ";
        if (is_administrator()) {
            foreach (db_GetFlatArray("SELECT SETTING FROM CRMsettings") AS $setting) {
                $ret .= "options[\"admin.php?editsetting=" . htme($setting) . "\"] = 'Settings &raquo; " . jsencode($setting) . "';\n";
            }
            $ret .= "
            options['?DisableOnlineEditModeInlineLinks'] = 'Disable online edit mode';
            options['?EnableOnlineEditModeInlineLinks'] = 'Enable online edit mode';
            options['?debug=1'] = 'Enable debug mode';
            options['?nodebug=1'] = 'Disable debug mode';
            options['?reaons=1'] = 'Enable reasons mode';
            options['?noreaons=1'] = 'Disable reasons mode';
            ";
        }

        $ret .= "



    if (e.keyCode !== 13 && e.keyCode !== 38 && e.keyCode !== 40){
            var inp = $('#quicksearchsearch').val();

            if (inp != LastSearchedFor) {
                var outp = '<ul id=\"quicksearchsearchul\">';
                if (inp != '') {
                    var count =0;

                    for (var key in options) {
                      if (options.hasOwnProperty(key)) {
                          if (stristr(options[key], inp)) {
                              outp += '<li><a href=\"' + key + '\">' + options[key] + '</a></li>';
                              count = count +1;
                          }
                      }
                    }
                } else {
                    $('#quicksearchresult').hide(20);
                }
                outp += '</ul>';
                if (inp != '') {
                    $('#quicksearchresult').show(20);

                }


                if (inp.length > 3 ) {
                    outp += '<span id=\"quicksearchmessage\">Searching ...</span>';
                }

                $('#quicksearchresult').html(outp);



                liSelected = '';
                li = $('#quicksearchresult li');
            }
    }

        if (typeof liSelected == 'object' && typeof $(liSelected).get(0) !== 'undefined') {
            /* zorg dat de geselecteerde waarde in beeld is */
            $(liSelected).get(0).scrollIntoView(false);
        }

    });

});";


    return $ret;
}
function PrintHTMLHeader()
{
    header('Content-Type: text/html; charset=UTF-8');
    print '<!DOCTYPE html>';
    print '<html';
    if ($GLOBALS['LANGUAGE_2_LETTER_CODE'] != '') {
        print ' lang="'.$GLOBALS['LANGUAGE_2_LETTER_CODE'].'"';
    }
/*    if ($GLOBALS['webapp']) {
	print ' manifest="webapp.appcache.php"';
    }*/
    print '>';
    print '<head>';
    if ($GLOBALS['BASE'] != '') {
        print '<base href="'.$GLOBALS['BASE'].'">';
    }
    print '<meta charset="UTF-8">';
    print "\n<!--
* Interleave Business Process Automation
* Copyright (c) 2001-2016 Atomos Applications The Netherlands - www.atomos.nl - info@atomos.nl - www.interleave.nl - info@interleave.nl
* Licensed under the GNU GPL. For full terms see http://www.gnu.org/
*
* Check http://www.interleave.nl/ for more information about Interleave or
* visit Atomos Applications (http://atomos.nl) for support and/or consultancy.
*
* Looking for support or just haven't found the *perfect* solution for your
* business administration needs yet? With Interleave you can automate any
* process currently relying on spreadsheets, e-mails, and the knowledge of that
* one special colleague who happens to be on holiday just when you need him ;-)
*
* Interleave is open-source software. However, this implementation may contain copyrighted,
* non-free and/or non-open (closed) material made by Interleave for a customer or made by
* a customer or Interleave user him/herself. In other words; don't take anything for granted
* but check first before you copy.
*
* Anyway, thanks for checking out the source!
-->\n";
}
function PDFDownloadLink($htmltoconvert, $linktext, $orientation, $discon1, $discon2 = false, $discon3 = false, $discon4 = false, $filename = false, $discon5 = 'helvetica', $discon6 = '8', $discon7 = false, $showimg = true, $discon8 = false, $discon9 = 'tcpdf')
{
    // Call this function with any HTML - a link to download it in PDF format will be returned  (valid for 10 minutes)
    $obj = array();

    $obj['html'] = $htmltoconvert;
    $obj['filename'] = $filename;

    $num = PushStashValue($obj);
    $img = '';
    if ($showimg) {
        $img = '<span class="fa fa-file-pdf-o"></span>';
    }

    return "<a href='" . add_sessionid_to_url("csv.php?cpdf=".$num)."' onclick='window.open(this.href);return false;'>".$img.' '.htme($linktext).'</a>';
}
function ExcelDownloadLink($sheetarray, $linktext, $filename = '', $format = 'xlsx')
{
    // Call this function with any 2D-array  - a link to download it in MS Excel format will be returned (valid for 10 minutes)
    // Format can be xlsx, xls, or pdf
    $num = PushStashValue(array('sheet' => $sheetarray, 'filename' => $filename));
    $fn = 'fa-file-excel-o';

    return "<a href='" . add_sessionid_to_url("csv.php?cxlsx=".$num)."'><span class=\"fa ".$fn.'">&nbsp;</span> '.$linktext.'</a>';
}
function ExcelRows()
{
    $bla = explode(' ', 'A B C D E F G H I J K L M N O P Q R S T U V W X Y Z');
    $rows = array();
    foreach ($bla as $a) {
        array_push($rows, $a);
    }
    foreach ($bla as $a) {
        foreach ($bla as $b) {
            array_push($rows, $a.$b);
        }
    }

    return $rows;
}
function HTML2PDF($html)
{
    require_once 'lib/mpdf/vendor/autoload.php';

    $mpdf = new \Mpdf\Mpdf([
         'mode' => 'utf-8',
         'orientation' => $orientation,
         'tempDir' => GetSetting("TMP_FILE_PATH"),
    ]);

    $mpdf->SetDisplayMode('fullpage');
    if (GetSetting("SecurePDFsWithRandomPassword") != "No") $mpdf->SetProtection(array('copy','print', 'print-highres'));
    $mpdf->WriteHTML($html);

    return $mpdf->Output('document.pdf', \Mpdf\Output\Destination::STRING_RETURN);
}
function ParseTemplateMenu($template_id)
{
    global $lang;
    $menu = GetTemplate($template_id);

    //fix jeroen 2011-04-20
    if (strstr($menu, '@SEARCH@')) {
        $search = '<form action="list.php" method="get">
        <input type="hidden" name="searchalltables" value="1">
        <input type="hidden" name="search_parents" value="0">
        <input type="hidden" name="search_childs" value="0">
        <input type="hidden" name="search_files" value="1">
        <input type="search" class="search_input" name="search" onchange="this.form.submit()" placeholder="' . htme($lang["search"]) . '"></form>';

        $menu = str_replace('@SEARCH@', escape_interleave_characters($search), $menu);
    }

    if (strstr($menu, '@R@')) {
        $menu = str_replace('@R@', escape_interleave_characters(CreateReposSwitcher()), $menu);
    }

    if ($GLOBALS['SesMem']['InlineEditMode_InlineLinks'] == 'On') {
        $menu = '<div class="showinline" style="position: relative"><div class="showinline InlineEditModeDiv" style="position: absolute;z-index:100000;"><a href="admin.php?templates=1&amp;editHTMLtemplate='.$template_id.' &amp;fromlist='.base64_encode($_SERVER['REQUEST_URI']).'"><span class="fa fa-edit"></span></a></div></div>'.$menu;
    }

    /* must go last, this function unescapes */
    $menu = get_parsed_template_with_given_template('', '', array(), '', false, '', $menu, 'TEMPLATE_PLAIN');

    //jeroen 2015-06-07 dit is tricky maar hiermee wordt whitespace tussen li's voorkomen, die zichtbaar is wanneer ze als inline-block worden weergegeven
    //alle whitespace om ul of li elementen weg
    $menu = preg_replace("/\s+(\<(li|ul))/", '\\1', $menu);
    $menu = preg_replace("/(\<\/(li|ul)>)\s+/", '\\1', $menu);

    return $menu;
}


function CreateReposSwitcher()
{
    $html = '';
    include $GLOBALS['CONFIGFILE'];

    if (count($host) > 0) {
        $curpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE name='".mres($GLOBALS['USERNAME'])."'");

	$html .= '<span class="fa fa-database"></span><ul>';
        for ($x = 0; $x < count($host); ++$x) {
            if (DB_Connect($x)) {
                $foreignpassword = db_GetValue("SELECT password FROM CRMloginusers WHERE name='".mres($GLOBALS['USERNAME'])."'");
                if ($curpassword == $foreignpassword) {
                    //er zou ook GetSetting('title') gebruikt kunnen worden, maar dat is trager want die laadt alle settings in; db_connect gooit alle settings bij iedere connect eerst leeg
                    $html .= '<li><a href="index.php?switchtorepos='.$x.'">'.htme(db_GetValue("SELECT value FROM CRMsettings WHERE setting='title'")).'</a></li>';
                }
                db_CloseConnection();
            }
        }
	$html .= '</ul>';
        SwitchToRepos($GLOBALS['repository']);
    }

    return $html;
}
function GetImageFileTypeIcon($fileid, $listid)
{
    $filename = strtolower(GetFileName($fileid));
    $filetype = GetFileType($fileid);

    $current_annotations = GetAttribute('files', "Annotations", $fileid);

    $annotations = '';
    if (count($current_annotations) > 0) {
        $annotations = ' <sup title="Annotations">' . count($current_annotations) . '</sup>';
    }

    $tmp_fn = explode('.', $filename);
    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);
    if ($filetype == 'image/jpg' || $filetype == 'image/jpeg' || $filetype == 'image/gif'  || $filetype == 'image/png') {

        $output = '';

        if (GetSetting('ENABLEIMAGETHUMBNAILS') == "Yes") {

            $output .= '<img src="' . add_sessionid_to_url('csv.php?minitn=' . $fileid) . '" alt="" class="minitn"><img src="' . add_sessionid_to_url('csv.php?tn=' . $fileid) . '" alt="" class="tn">';

            /* see if we can get GPS coordinates (TIFF supports this also, but nobody supports TIFF) */
            if ($filetype == "image/jpeg")
            {
                $gps = GetFileGPSCoordinates($fileid);
                if ($gps != '')
                {
                    $output .= '<a href="https://maps.google.com/maps?z=12&t=m&q=loc:'. htme($gps) . '" rel="noreferrer" target="_blank" class="stoppropagation googlemapslink"><span class="fa fa-map-marker" aria-hidden="true"></span></a>';
                } else {

                }

            }



        }

        return '<a title="View and annotate this image online" onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showphoto(' . $fileid . ',\'' . inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');">' . $output . '</a>' . $annotations;

    } elseif ($filetype == 'video/quicktime' || $filetype == 'video/mp4' || $filetype == 'application/x-mpegURL' || $filetype == 'video/MP2T' || $filetype == 'video/3gpp' || $filetype == 'video/x-msvideo' || $filetype == 'video/x-ms-wmv') {

        /* a movie. embed */
        return '<span class="fa fa-film"></span>&nbsp;<a onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showmovie(' . $fileid . ',\'' .inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');"><span class="fa fa-eye"></span></a>';

    } elseif ($filetype == '{{{folder}}}') {

        return '<span class="fa fa-folder-o"></span>';

    } else {
        switch ($ext) {
        case '.pdf':
            return '<a title="View and annotate this document online" onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;PopFancyBoxExtraLarge(\''. inline_jsencode($filename) . '\',\'viewpdf.php?fileid='.$fileid.'\');"><span class="fa fa-file-pdf-o"></span></a>' . $annotations;
        case '.doc':
            return '<span class="fa fa-file-word-o"></span>';
        case '.docx':
                return '<a title="View and annotate this document online" onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;PopFancyBoxExtraLarge(\''. inline_jsencode($filename) . '\',\'viewdocx.php?fileid='.$fileid.'&amp;nonavbar=1\');"><span class="fa fa-file-word-o"></span></a>' . $annotations;
        case '.interleave':
            return '<a title="Edit this document online" onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;PopFancyBoxExtraLarge(\''. inline_jsencode($filename) . '\',\'viewdocx.php?fileid='.$fileid.'&amp;nonavbar=1\');"><img src="images/interleave128.png" height="16" width="16" alt="Edit online"></a>' . $annotations;
        case '.html':
            return '<span class="fa fa-code"></span>';

        case '.xls':
            return '<span class="fa fa-file-excel-o"></span>';
        case '.xlsx':
            return '<span class="fa fa-file-excel-o"></span>';
        case '.xlsm':
            return '<span class="fa fa-file-excel-o"></span>';
        case '.jpg':
            return '<span class="fa fa-file-image-o"></span>';
        case '.jpeg':
            return '<span class="fa fa-file-image-o"></span>';
        case '.gif':
            return '<span class="fa fa-file-image-o"></span>';
        case '.png':
            return '<span class="fa fa-file-image-o"></span>';
        case '.tif':
            return '<span class="fa fa-file-image-o"></span>';
        case '.txt':
            return '<a onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showtextfile(' . $fileid . ',\'' . inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');"><span class="fa fa-file-text-o"></span></a>';

        case '.zip':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.tar.gz':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.tgz':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.arj':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.7z':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.tar':
            return '<span class="fa fa-file-archive-o"></span>';
        case '.wav':
            return '<span class="fa fa-file-audio-o"></span>';
        case '.mp3':
            return '<audio controls="" preload="none" src="' . add_sessionid_to_url('csv.php?fileid='.htme($fileid)).'">&nbsp;</audio>';
        case '.asc':
            return '<a onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showtextfile(' . $fileid . ',\'' . inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');"><span class="fa fa-file-text-o"></span></a>';
        case '.xml':
            return '<a onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showtextfile(' . $fileid . ',\'' . inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');"><span class="fa fa-file-code-o"></span></a>';
        case '.sql':
            return '<a onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showtextfile(' . $fileid . ',\'' . inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');"><span class="fa fa-file-code-o"></span></a>';
        case '.php':
            return '<a onclick="if(event.stopPropagation){event.stopPropagation();}event.cancelBubble=true;showtextfile(' . $fileid . ',\'' . inline_jsencode($filename) . '\',\'' . inline_jsencode($listid) . '\');"><span class="fa fa-file-code-o"></span></a>';

        case '.ppt':
            return '<span class="fa fa-file-powerpoint-o"></span>';
        case '.pptx':
            return '<span class="fa fa-file-powerpoint-o"></span>';
        default:
            return '<span class="fa fa-file-o"></span>';
        }
    }
}
function CalculateNumberOfWorkingDaysBetweenDates($StartTime, $EndTime)
{
    $WorkingDays = 0;
    while ($StartTime <= $EndTime) {
        if (date('D', $StartTime) == 'Sat' || date('D', $StartTime) == 'Sun') {
            //$IgnorDays++;
        } else {
            ++$WorkingDays;
        }
        $StartTime = $StartTime + 86400;
    }

    return $WorkingDays;
}
function EvaluateTemplatePHP($code, $eid = false, $flextable = false, $flextablerecord = false)
{
    global $secure_modules;
    $recordid = $flextablerecord;
    $table = $flextable;
    $flextable = str_replace('t', '', $flextable);
    $flextableid = str_replace('t', '', $flextable);

    if (ipi(str_replace('t', '', $flextable))) {
        $flextable = str_replace('t', '', $flextable);
    }

        //require $GLOBALS['PATHTOINTERLEAVE'] . "config/config.inc.php";
        //print 'secure_modules : ' . $secure_modules[$GLOBALS['repository']];
        if ($secure_modules[$GLOBALS['repository']] == 'yes') {
            /* deze kan weg eigenlijk */
            if (GetSetting('DevelopmentOrProduction') == 'Development') {
                $ls = new SaferScript('<?php ?>'.$code.'<?php ?>');
                $ls->allowHarmlessCalls();
                $res = $ls->parse();
                if (count($res) > 0) {
                    // illegal function calls found
                    return 'illegal function calls - not executing code: '.string_r($res);
                }
            }
        }

    qlog(INFO, 'Evaluating this template ... ');

    ob_start();

    eval('?>'.$code);

    $ret = ob_get_contents();
    ob_end_clean();

    if ($ret == '') {
        // Something went horribly wrong
            return $code;
    } else {
        return $ret;
    }
}
function br2nl($text)
{
    return preg_replace("/\<br( )?(\/)?\>/i", "\n", $text);
}
function journal($eid, $msg, $type)
{
    if (strlen($msg) > 524288) {
        // This is dangerous, the journal table could fill up
        return false;
    }

    if (trim($msg) == '') {
        $msg = GetBackTrace();
    }
    if (!is_array($GLOBALS['AddToJournal'])) {
        $GLOBALS['AddToJournal'] = array();
    }

    $tmp = array();
    $tmp['record'] = $eid;
    $tmp['user'] = $GLOBALS['USERID'];
    $tmp['message'] = $msg;
    $tmp['type'] = $type;
    $tmp['isodatetime'] = date('Y-m-d H:i:s');

    $GLOBALS['AddToJournal'][] = $tmp;

    return true;
}
function commit_journal()
{
    if (count($GLOBALS['AddToJournal']) > 0) {
        $sql = 'INSERT INTO CRMjournal(eid,user,message,type,timestamp_last_change) VALUES ';
        $nf = false;
        foreach ($GLOBALS['AddToJournal'] as $row) {
            if ($nf) {
                $sql .= ', ';
            }
            $sql .= " ('".mres($row['record'])."','".mres($row['user'])."','".mres($row['message'])."','".mres($row['type'])."','".mres($row['isodatetime'])."')";
            $nf = true;
        }
        mcq($sql);
        //  DA($sql);
        unset($GLOBALS['AddToJournal']);
    }
}
function year_weeknumber_to_mondaydate($year, $weeknumber)
{
    //een jaar begint altijd op 1 januari
    //een week begint altijd op maandag
    //week 1 van een jaar is de week "with more than 3 days this year" ISO 8601; wanneer 1 januari op een donderdag valt dan is DAT week 1, valt 1 januari op een vrijdag dan hoort 1 januari in W52 (of 53) van het afgelopen jaar
    //week 1 van 2013 kan in 2012 beginnen
    $jan1 = $year.'-01-01';

    //1 (for Monday) through 7 (for Sunday)
    $weekday_of_jan1 = date('N', strtotime($jan1));

    $days_to_first_monday = 0;

    //1 jan = maandag: week 1 begint op maandag 1 januari
    if ($weekday_of_jan1 == 1) {
        $days_to_first_monday = 0;
    }
    //1 jan = dinsdag: week 1 begint op maandag 31 december van het afgelopen jaar
    elseif ($weekday_of_jan1 == 2) {
        $days_to_first_monday = -1;
    }
    //1 jan = woensdag: week 1 begint op maandag 30 december van het afgelopen jaar
    elseif ($weekday_of_jan1 == 3) {
        $days_to_first_monday = -2;
    }
    //1 jan = donderdag: week 1 begint op maandag 29 december van het afgelopen jaar
    elseif ($weekday_of_jan1 == 4) {
        $days_to_first_monday = -3;
    }
    //1 jan = vrijdag: week 1 begint op maandag 4 januari (1, 2 en 3 januari vallen in de laatste week (52 of 53) van het afgelopen jaar)
    elseif ($weekday_of_jan1 == 5) {
        $days_to_first_monday = 3;
    }
    //1 jan = zaterdag: week 1 begint op maandag 3 januari (1 en 2 januari vallen in de laatste week (52 of 53) van het afgelopen jaar)
    elseif ($weekday_of_jan1 == 6) {
        $days_to_first_monday = 2;
    }
    //1 jan = zondag: week 1 begint op maandag 2 januari (1 januari valt in de laatste week (52 of 53) van het afgelopen jaar)
    elseif ($weekday_of_jan1 == 7) {
        $days_to_first_monday = 1;
    }

    $mondaydate_of_week1 = date('Y-m-d', strtotime($jan1.' +'.$days_to_first_monday.' day'));

    $mondaydate_of_requested_week = date('Y-m-d', strtotime($mondaydate_of_week1.' +'.($weeknumber - 1) * 7 .' day'));

    return $mondaydate_of_requested_week;
}
function CopyFileToDisk($fileid, $fc = false)
{
    if (!$fc) {
        $fc = GetFileContent($fileid);
    }
    $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEX_');
    $fp = fopen($fn, 'w');
    fputs($fp, $fc);
    fclose($fp);
    return $fn;
}
function CopyTemplateToDisk($fileid)
{
    $fc = GetTemplate($fileid);
    $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEX_');
    $fp = fopen($fn, 'w');
    fputs($fp, $fc);
    fclose($fp);

    return $fn;
}
function CleanupExtractedAscii($out)
{
    if ($out == '{0}') {
        return $out;
    }

    $out = strtolower($out);
    $out = preg_replace("/\W/", ' ', $out);
    $out = str_replace('_', ' ', $out);
    $out = preg_replace("/\s+/", ' ', $out);
    $out = implode(' ', array_unique(explode(' ', $out)));

    return $out;
}
function SetExtractedAsciiData($fileid, $data)
{
    $data = CleanupExtractedAscii($data);

    if (is_positive_integer($fileid) && trim($data) != '') {
        mcq("UPDATE CRMbinfiles SET extractedascii='".mres($data)."',timestamp_last_change=timestamp_last_change WHERE fileid=".$fileid);
    }
}
function ProcessZipArchive($diskfile)
{
    $ascii = '';
    $zip = zip_open($diskfile);
    while ($zip_entry = zip_read($zip)) {
        $entry_name = zip_entry_name($zip_entry);
        qlog(INFO, 'CASH Processing '.$entry_name);
        $tmp_fn = explode('.', $entry_name);
        $entry_ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

        $entry_content = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
        $fn = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEX_');
        $fp = fopen($fn, 'w');
        fputs($fp, $entry_content);
        fclose($fp);

        if ($entry_ext == '.zip') {
            $ascii .= ProcessZipArchive($fn);
        } else {
            if ($GLOBALS['CMDLINE']) {
                //                print "Updated info of file " . $diskfile . " : " . fillout(strlen($ret['ascii']), 7) . " bytes of ascii data extracted from ZIP-archive.\n";
        print 'Processing '.$entry_name." from zip file\n";
            }
            $ret = GetIndexData($fn, $entry_name);
            $ascii .= $entry_name.' '.$ret['ascii'];
        }

        unlink($fn);
    }
    zip_close($zip);

    return $ascii;
}
function ExtractIndexData($fileid = false, $updateonly = false)
{
    $to_process = array();

    if ($fileid == false && $updateonly) {
        $to_process = db_GetFlatArray("SELECT fileid FROM CRMbinfiles WHERE extractedascii='' AND koppelid>0 ORDER BY fileid");
    } elseif ($fileid == false) {
        $to_process = db_GetFlatArray('SELECT fileid FROM CRMbinfiles WHERE koppelid>0 ORDER BY fileid');
    } elseif (is_positive_integer($fileid)) {
        array_push($to_process, $fileid);
    }
    foreach ($to_process as $filenum) {
        $fn = GetFileName($filenum);

        if ($GLOBALS['CMDLINE']) {
            print date('r').': Extract ascii fileid '.$filenum.' ('.$fn.') (MB: '.round(memory_get_usage() / 1024 / 1024, 2).")\n";
        }

        // Catch compressed archives here
        $tmp_fn = explode('.', $fn);
        $ext = strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

        //LockFileForAsciiExtraction($filenum);
        mcq("UPDATE CRMbinfiles SET extractedascii='{0}',timestamp_last_change=timestamp_last_change WHERE fileid=".$filenum);

        $diskfile = CopyFileToDisk($filenum);
        if (filesize($diskfile) > 0) {
            $ascii = '';

            if ($ext == 'zip') {
                $ascii = ProcessZipArchive($diskfile);
            } else {
                $ret = GetIndexData($diskfile, $fn);
                $ascii = $ret['ascii'];
            }

            if ($ascii != '') {
                SetExtractedAsciiData($filenum, $ascii);
            }

            /* try to find GPS coordinates -> KAN DIT NIET BETER IN 2 STAPPEN? */
            mcq("UPDATE `CRMbinfiles` SET `CRMbinfiles`.`coordinates` = '".mres(GetGPSCoordinates($diskfile))."', `CRMbinfiles`.`timestamp_last_change`=`CRMbinfiles`.`timestamp_last_change` WHERE `CRMbinfiles`.`fileid`=".$filenum);
        }

        unlink($diskfile);
    }
}
function GetIndexData($file_to_pass, $fn)
{
    $ascii = '';
    $type = '';

    $tmp_fn = explode('.', $fn);
    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

    qlog(INFO, 'Working on '.$file_to_pass);
    switch ($ext) {
    case '.xlsx':
        $ascii = ExtractExcelAscii($file_to_pass);
        $type = $ext.': MS Excel 2007+';
        break;
    case '.xlsm':
        $ascii = ExtractExcelAscii($file_to_pass);
        $type = $ext.': MS Excel 2007+';
        break;
    case '.pptx':
        $ascii = ExtractPowerpointAscii($file_to_pass);
        $type = $ext.': MS Powerpoint 2007+';
        break;
    case '.docx':
        $ascii = ExtractWordAscii($file_to_pass);
        $type = $ext.': MS Word 2007+';
        break;
    case '.pdf':
        $ascii = ExtractPDFAscii($file_to_pass);
        $type = $ext.': Portable Document Format';
        break;
    case $ext == '.odf' || $ext == '.ods' || $ext == '.odp' || $ext == '.odt':
        $ascii = ExtractOOAscii($file_to_pass);
        $type = $ext.': OpenOffice OpenDocument';
        break;
    case '.rtf':
        $ascii = ExtractRTFAscii($file_to_pass);
        $type = $ext.': Rich Text Format';
        break;
    case '.exe':
        $type = $ext.": we don't index executables";
    break;
    case '.jpg':
        $type = $ext.": we don't index images";
    break;
    case '.jpeg':
        $type = $ext.": we don't index images";
    break;
    case '.gif':
        $type = $ext.": we don't index images";
    break;
    case '.bmp':
        $type = $ext.": we don't index images";
    break;
    case '.png':
    $type = $ext.": we don't index images";
    break;
    case '.tiff':
        $type = $ext.": we don't index images";
        break;
    case '.tif':
    $type = $ext.": we don't index images";
    break;
    case $ext == '.gz' || $ext == '.arj' || $ext == '.7z' || $ext == '.bzip2' || $ext == '.tgz':
        $ascii = '';
        $type = $ext.': unsupported compressed file';
        break;
    case $ext == '.html' || $ext == '.htm' || $ext == '.xml':
    $ascii = html2plaintext(file_get_contents($file_to_pass));
    $type = $ext.': html/xml';
    break;
    case $ext == '.txt' || $ext == '.asc' || $ext == '.csv' || $ext == '.xslt' || $ext == '.sql' || $ext == '.ini' || $ext == '.php' || $ext == '.asp' || $ext == '.pl' || $ext == '.css' || $ext == '.msg' || $ext == '.eml':
        $ascii = file_get_contents($file_to_pass);
        $type = $ext.': plain text';
        break;
    default:
        $ascii = ExtractBinAscii($file_to_pass);
        $type = $ext.': no parser for this file extension, treating as binary file';
        break;
    }

    $ret = array();
    $ret['ascii'] = $ascii;
    $ret['type'] = $type;

    return $ret;
}
function ExtractPowerpointAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (substr(zip_entry_name($zip_entry), 0, 16) == 'ppt/slides/slide') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractExcelAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (zip_entry_name($zip_entry) == 'xl/sharedStrings.xml') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractWordAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (zip_entry_name($zip_entry) == 'word/document.xml') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractOOAscii($file)
{
    $extracted_content = '';
    $zip = zip_open($file);
    while ($zip_entry = zip_read($zip)) {
        if (zip_entry_name($zip_entry) == 'content.xml') {
            $xml = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
//            $xml = str_replace("</text:p>", " </text:p>", $xml);
            $extracted_content .= ' '.strip_tags_to_space($xml);
        }
    }
    zip_close($zip);

    return $extracted_content;
}
function ExtractRTFAscii($file)
{
    require_once 'lib/parsertf.class.php';
    $r = new rtf(file_get_contents($file));
    $r->output('html');
    $r->parse();
    $ascii = '';
    //jh 2016-11-11 er komt soms een hoop data mee als er afbeeldingen in rtf's staan; daarom gooien we hier alles weg wat langer is dan 24 karakters
    foreach (explode(' ', html2plaintext($r->out)) as $word) {
        if (strlen($word) <= 24) {
            $ascii .= $word.' ';
        }
    }

    return $ascii;
    /*
    $extracted_content = "";
    $extracted_content = file_get_contents($file);
    print "RTF SIZE: " . strlen($extracted_content) ."\n";
    $extracted_content = str_replace("({\\)(.+?)(})|(\\)(.+?)(\b)", "", $extracted_content);
    print "RTF SIZE: " . strlen($extracted_content). " (after)\n";
    return $extracted_content;
    */
}
function command_exist($cmd)
{
    $returnVal = shell_exec('which '.$cmd);

    return empty($returnVal) ? false : true;
}
function ExtractPDFAscii($file)
{
    $ascii = '';
    /* check if pdftotext is installed on this system. if so, use it, it's better */
    if (command_exist('pdftotext')) {

        /* create target filename (pdftotext limitation) */
        $target = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_FILEINDEXP2T_');

        /* execute command, output goes to $target */
        $cmd = 'pdftotext -nopgbrk -q '.$file.' '.$target;
        system($cmd);

        /* fetch result in 1 go (should we check for too large files here?) */
        $ascii = file_get_contents($target);

        //print date('r') . ": Extracted " . strlen($result) . " bytes of ascii\n";
        //print date('r') . ": Extracted " . substr($result,0,10) . " \n";
        /* delete temporary file */
        unlink($target);
    } else {
        include 'lib/pdfparser/include.php';
        //print "Work $file";
        // Parse pdf file and build necessary objects.
//		$result = array();
        try {
            $parser = new \Smalot\PdfParser\Parser();
            $pdf = $parser->parseFile($file);
            // De parse pdf code is aangepast zodat deze geen exceptions meer throw'd maar een false returned. Vandaar deze check. Slordig,
            // maar parse pdf klapt er anders helemaal uit wat bij batchverwerking duedate_notify_cron de nek omdraait.
            if (is_object($pdf)) {
                $ascii = $pdf->getText();
/*
                $ar = explode(" ", $text);
                $text = "";
                $result = array();
                foreach ($ar AS $word) {
                    if (strlen($word) > 3 && !in_array($word, $result)) {
                        $result[] = $word;
                    }
                }
*/
                // Retrieve all details from the pdf file.
                $details = $pdf->getDetails();

                // Loop over each property to extract values (string or array).
                foreach ($details as $property => $value) {
                    /*					if (is_array($value)) {
                        $value = implode(', ', $value);
                    }
                    $result[] = $value;*/
                    $ascii .= ' '.$value;
                }
            }
        } catch (Exception $e) {
            // don't do anything
        }
    }

    return $ascii;
}
function ExtractBinAscii($file)
{
    $total_record = '';
    $record_buffer = '';

    $fp = fopen($file, 'r');
    while (!feof($fp)) {
        $line = fgets($fp, 108096);
        $len = strlen($line);
        for ($x = 1; $x < $len; ++$x) {
            $char = $line[$x];
            $asc = ord($char);
//spatie, 0-9 A-Z a-z
//            if ($asc == 32 || ($asc > 47 && $asc < 58) || ($asc > 64 && $asc < 91) || ($asc > 96 && $asc < 123)) { // ASCII Default character found, start recording
        if (($asc > 47 && $asc < 58) || ($asc > 64 && $asc < 91) || ($asc > 96 && $asc < 123)) { // ASCII Default character found, start recording
                $record_buffer .= $char;
        } else {
            if ((strlen($record_buffer) >= 4) && (strlen($record_buffer) <= 24)) {
                $total_record .= ' '.$record_buffer;
            }
            $record_buffer = '';
        }
//JH 2016-11-10 uitgezet; deze draait VOOR IEDERE BYTE in het te parsen bestand. veel te duur. en met 128mb memory limit is dat sowieso voldoende
/*            if ((memory_get_usage() / 1024 / 1024) > 32) {
                return $total_record;
            }*/
        }
    }
    fclose($fp);

    return $total_record;
}
function strip_tags_to_space($str)
{
    //jh deze doet het beter dan een preg_replace wanneer er nog < > in de tags zelf staan
    return strip_tags(str_replace('<', ' <', $str));
}
function getDataArray($data, $start_word, $end_word)
{
    $start = 0;
    $end = 0;
    $a_result = array();

    while ($start !== false && $end !== false) {
        $start = strpos($data, $start_word, $end);
        if ($start !== false) {
            $end = strpos($data, $end_word, $start);
            if ($end !== false) {
                // data is between start and end
                $a_result[] = substr($data, $start, $end - $start + strlen($end_word));
            }
        }
    }

    return $a_result;
}
function ParseZippedContent($fileid, $eid, $cid, $flextable, $flextablerecord, $extraparsefunc = false, $raw = false)
{
    $fn = GetTemplateName($fileid);
    $tmp_fn = explode('.', $fn);
    $ext = '.'.strtolower($tmp_fn[(count($tmp_fn) - 1) ]);

    $ftp = array(); // Files in archive to run through parser
    switch ($ext) {
    case '.xlsx':
        $ftp[] = '/xl/sharedStrings.xml';
        for ($x = 0; $x < 64; ++$x) {
            $ftp[] = '/xl/worksheets/sheet'.$x.'.xml';
        }
        $raw = 'dontformatnumbers';
        break;

    case '.xlsm':
        $ftp[] = '/xl/sharedStrings.xml';
        for ($x = 0; $x < 64; ++$x) {
            $ftp[] = '/xl/worksheets/sheet'.$x.'.xml';
        }
        $raw = 'dontformatnumbers';
        break;

    case '.docx':
        $ftp[] = '/word/document.xml';
        break;

    case '.odt':
        $ftp[] = '/content.xml';
        break;

    case '.ods':
        $ftp[] = '/content.xml';
        $raw = 'dontformatnumbers';
        break;

    }
    if (GetTemplateType($fileid) == 'TEMPLATE_REPORT_PDF' || GetTemplateType($fileid) == 'TEMPLATE_PLAIN') {
        $fn = GetAttribute('template', 'FormatNumbers', $fileid);
        if ($fn == 'Yes') {
            $raw = false;
        }
    }

    return ParseZipFile($fileid, $ftp, $eid, $cid, $flextable, $flextablerecord, $extraparsefunc, $raw);
}
function RmRFDir($path)
{
    if (is_dir($path) === true) {
        $files = array_diff(scandir($path), array('.', '..'));
        foreach ($files as $file) {
            RmRFDir(realpath($path).'/'.$file);
        }

        return rmdir($path);
    } elseif (is_file($path) === true) {
        return unlink($path);
    }

    return false;
}
function ParseZipFile($fileid, $Array_files_in_zip_to_parse, $eid, $cid, $flextable, $flextablerecord, $extraparsefunc = false, $raw = false)
{
    $diskfile = CopyTemplateToDisk($fileid);
    $GLOBALS['logtext'] = false; // IMPORTANT! If qlogging is enabled, the qlist.txt file will be zipped in the archive and we don't want that
    $name = md5($diskfile).date('U');
    mkdir(GetSetting('TMP_FILE_PATH').'/'.$name);
    copy($diskfile, GetSetting('TMP_FILE_PATH').'/'.$name.'/'.$name.'.INTLV');
    $newdiskfile = GetSetting('TMP_FILE_PATH').'/'.$name.'/'.$name.'.INTLV';
    chdir(GetSetting('TMP_FILE_PATH').'/'.$name.'/');
    UnZip($newdiskfile, GetSetting('TMP_FILE_PATH').'/'.$name.'/');

    unlink($newdiskfile);
    unlink($diskfile);

    foreach ($Array_files_in_zip_to_parse as $pFile) {
        $fContent = file_get_contents('.'.$pFile);

        if ($fContent != '') {
            if (function_exists($extraparsefunc)) {
                $fContent = $extraparsefunc($fContent);
            }
            $fContent = ParseTemplateLanguageTags($fContent);

            if (is_numeric($flextable) && IsValidFlexTableRecord($flextablerecord, $flextable)) {
                $fContent = ParseTemplateRecordData($fContent, 't'.$flextable, $flextablerecord);
            }

            $fContent = unescape_interleave_characters(ParseTemplateGeneric($fContent));
        }

        $fp = fopen('.'.$pFile, 'w');
        fputs($fp, $fContent);
        fclose($fp);
    }
    $t = Zip(GetSetting('TMP_FILE_PATH').'/'.$name.'.done', GetSetting('TMP_FILE_PATH').'/'.$name.'/');
    RmRFDir(GetSetting('TMP_FILE_PATH').'/'.$name.'/');

    return $t;
}
function Zip($filename, $path)
{

    // create object
    $zip = new ZipArchive();

    // open archive
    if ($zip->open($filename, ZIPARCHIVE::CREATE) !== true) {
        die('Could not open archive');
    }

    chdir($path);
    // initialize an iterator
    // pass it the directory to be processed

    $iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator('.'));

    // iterate over the directory
    // add each file found to the archive
    foreach ($iterator as $key => $value) {
        if (substr($key, strlen($key) - 3, 3) != '/..' && substr($key, strlen($key) - 2, 2) != '/.') {
            $zip->addFile(realpath($key), str_replace('./', '', $key)) or die('ERROR: Could not add file: '.$key);
        }
        //		print "Add file " . realpath($key) . " == " . str_replace("./", "", $key) . "\n\n";
    }

    // close and save archive
    $zip->close();

    $zipfile = file_get_contents($filename);
    unlink($filename);

    return $zipfile;
}
function UnZip($zipFile, $to_dir)
{
    define(DIRECTORY_SEPARATOR, '/');

    $zipDir = $to_dir;
    $zip = zip_open($zipFile);
    $dirFromZip = '';
    if ($zip) {
        while ($zip_entry = zip_read($zip)) {
            $completePath = $zipDir.dirname(zip_entry_name($zip_entry));
            $completeName = $zipDir.zip_entry_name($zip_entry);

            // Walk through path to create non existing directories
            // This won't apply to empty directories ! They are created further below
            if (!file_exists($completePath) && preg_match('#^'.$dirFromZip.'.*#', dirname(zip_entry_name($zip_entry)))) {
                $tmp = '';
                foreach (explode('/', $completePath) as $k) {
                    $tmp .= $k.'/';
                    if (!file_exists($tmp)) {
                        @mkdir($tmp, 0777);
                    }
                }
            }

            if (zip_entry_open($zip, $zip_entry, 'r')) {
                if (preg_match('#^'.$dirFromZip.'.*#', dirname(zip_entry_name($zip_entry)))) {
                    if ($fd = @fopen($completeName, 'w+')) {
                        fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
                        fclose($fd);
                    } else {
                        // We think this was an empty directory
                        mkdir($completeName, 0777);
                    }
                    zip_entry_close($zip_entry);
                }
            }
        }
        zip_close($zip);
    }

    return true;
}

function make_html_editor($id, $protectedSource, $templatecss, $enter_is_div, $height = '500', $width = '100%', $table = '', $record = '')
{
    static $included;

    $str = '';
    $str .= "<script>var CKEDITOR_BASEPATH = '".$GLOBALS['BASE']."lib/ckeditor/';</script>";
    if (!$included) {
        $str .= '<script type="text/javascript" src="'.$GLOBALS['BASE'].'lib/ckeditor/ckeditor.js?'.filemtime($GLOBALS['BASE'].'js/ckeditor/ckeditor.js').'"></script>';
    }
    $included = true;

    $str .= '<input type="hidden" name="mostlikelytable" id="mostlikelytable" value="' . $table . '">';
    $str .= '<script type="text/javascript">';
    $str .= '$(document).ready(function() {';

    $str .= "CKEDITOR.config.docType = '<!DOCTYPE html>';\n";
    $str .= "CKEDITOR.config.contentsCss = [''";
    //2015-06-10 Jeroen: als een template een eigen css heeft dan is dat de ENIGE css die ingeclude wordt; dit zou alleen maar voor moeten komen bij emails; die dan ook alleen DIE css mee gestuurd krijgen
    if ($templatecss != '') {
        $str .= ",'".$templatecss."'";
    } else {
        foreach (GetCustomCSS(false, true, false, true) as $css) {
            $str .= ",'".$GLOBALS['BASE'].$css."'";
        }
    }
    $str .= ",'.cke_contents { background: none;background-image: none;}'];\n";

    if ($GLOBALS['BASE'] != '') {
        $str .= "CKEDITOR.config.baseHref = '".$GLOBALS['BASE']."';\n";
    }
    $str .= "CKEDITOR.config.width = '".$width."';\n";

    $str .= "CKEDITOR.config.height = '".$height."';\n";
    $str .= "CKEDITOR.config.allowedContent = true;\n";
    $str .= "CKEDITOR.config.extraPlugins = 'colorbutton,image,interleavetag';\n";
    //$str .= "CKEDITOR.config.removePlugins = 'dragdrop,basket';\n";


    //if ($GLOBALS['UC']['PersonalDataStructure'][$table] && ipi($record)) {
    $str .= "CKEDITOR.config.filebrowserBrowseUrl = 'file.php?select=1&nonavbar=1&fqn=".$table.'-timestamp_last_change&recordid='.$record."';\n";
    //}
    //$str.= "filebrowserUploadUrl: '/uploader/upload.php'
    //$str.= "CKEDITOR.config.simpleImageBrowserURL = 'record-ajax.php?method=get_images&fqn=' + $('#JS_concerningtable').val() + '-timestamp_last_change&recordid=' + $('#JS_concerningrecord').val();\n";

    if ($enter_is_div) {
        $str .= "CKEDITOR.config.enterMode = CKEDITOR.ENTER_DIV;\n";
    }

    $str .= "CKEDITOR.config.protectedSource.push( /<\?[\s\S]*?\?>/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@NEWONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDNEWONLY@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@XONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDXONLY@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@GROUP\d+ONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUP\d+ONLY@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@GROUP\d+NOT@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUP\d+NOT@/g );\n";

    $str .= "CKEDITOR.config.protectedSource.push( /@GROUPADMINONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUPADMINONLY@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@GROUPADMINNOT@/g );\n";
    $str .= "CKEDITOR.config.protectedSource.push( /@ENDGROUPADMINNOT@/g );\n";



    $str .= 'CKEDITOR.config.toolbar =';
    $str .= '[';
    $str .= "['Source'],";
    $str .= "['Cut','Copy','Paste','PasteText','PasteFromWord','-','Print'],";
    //$str .= "['Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat'],";
    $str .= "['Bold','Italic','Underline'],";
    /* ,'Strike','-','Subscript','Superscript'],"; */
    $str .= "['NumberedList','BulletedList','-','Outdent','Indent'],";
    $str .= "['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],";
    $str .= "['Link','Unlink'],";
    $str .= "['Table','HorizontalRule','SpecialChar','PageBreak'],";
    $str .= "['Styles','Format','Font','FontSize'],";
    $str .= "['TextColor','BGColor'],";
    $str .= "['Maximize', 'ShowBlocks'],";
    $str .= "['interleavetag']";
    $str .= "];\n";

    //$str .= "CKEDITOR.replace('".$id."');\n";

    $str .= "CKEDITOR.on( 'instanceReady', function( ev )
		{
		// The writing rules for the <p> tag.
		ev.editor.dataProcessor.writer.setRules( 'p',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		ev.editor.dataProcessor.writer.setRules( 'div',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		ev.editor.dataProcessor.writer.setRules( 'h1',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
		ev.editor.dataProcessor.writer.setRules( 'h2',
			{
				// Indicates that this tag causes indentation on line breaks inside of it.
				indent : true,

				// Inserts a line break before the <p> opening tag.
				breakBeforeOpen : true,

				// Inserts a line break after the <p> opening tag.
				breakAfterOpen : true,

				// Inserts a line break before the </p> closing tag.
				breakBeforeClose : true,

				// Inserts a line break after the </p> closing tag.
				breakAfterClose : true
			});
    	});";

    $str .= '});';

    $str .= "CKEDITOR.replace('" . $id . "');\n";

    $str .= "

    CKEDITOR.plugins.add( 'interleavetag', {

        init: function( editor ) {
            editor.addCommand( 'interleavetag', {
                exec: function( editor ) {

                        showTagSidebar(editor.name, $('#mostlikelytable').val(), '" . $table . "-timestamp_last_change', '" . $record . "');

                    }
            });
           editor.ui.addButton( 'interleavetag', {
    			label: 'interleave tag',
    			command: 'interleavetag',
    			toolbar: 'insert',
                icon: '../../images/interleave128.png',

    		});
        }
    });


    ";
    $str .= '</script>';
    return $str;

}
function tail_file($file, $lines)
{
    //global $fsize;
    $handle = fopen($file, 'r');
    $linecounter = $lines;
    $pos = -2;
    $beginning = false;
    $text = array();
    while ($linecounter > 0) {
        $t = ' ';
        while ($t != "\n") {
            if (fseek($handle, $pos, SEEK_END) == -1) {
                $beginning = true;
                break;
            }
            $t = fgetc($handle);
            --$pos;
        }
        --$linecounter;
        if ($beginning) {
            rewind($handle);
        }
        $text[$lines - $linecounter - 1] = fgets($handle);
        if ($beginning) {
            break;
        }
    }
    fclose($handle);

    return array_reverse($text);
}
function KeyName(array $a, $pos)
{
    $temp = array_slice($a, $pos, 1, true);

    return key($temp);
}
function ShowHeaders()
{
    global $lang;
    ob_start();

    PrintHTMLHeader();

    $title = GetSetting('title');
    $base = GetSetting('BASEURL'); //ook als beautify uit staat hebben we deze nodig

    if ($GLOBALS['webapp']) {
        $description = GetSetting('SUBTITLE');

        $filename144 = db_GetValue("SELECT filename FROM CRMbinfiles WHERE type='public' AND filename LIKE 'applogo144x144.png' AND filetype='image/png'");
        if ($filename144 != '') {
            $filename144 = 'publicfile.php?filename='.$filename144;
        } else {
            $filename144 = 'images/interleave144.png';
        }

        $filename192 = db_GetValue("SELECT filename FROM CRMbinfiles WHERE type='public' AND filename LIKE 'applogo192x192.png' AND filetype='image/png'");
        if ($filename192 != '') {
            $filename192 = 'publicfile.php?filename='.$filename192;
        } else {
            $filename192 = 'images/interleave192.png';
        }

        print '<meta http-equiv="X-UA-Compatible" content="IE=edge">';
        print '<meta name="description" content="'.htme($description).'">';
        //print '<meta name="viewport" content="width=device-width, initial-scale=1">';
        print '<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">';
        print '<link rel="canonical" href="'.htme($base).'webapp.php">';
        print '<title>'.htme($title).'</title>';
        //todo fix
        print '<link rel="manifest" href="manifest.json?'.date('U').'">';
        print '<meta name="mobile-web-app-capable" content="yes">';

        print '<meta name="application-name" content="'.htme($title).'">';
        print '<link rel="icon" sizes="192x192" href="'.$filename192.'">';
        print '<meta name="apple-mobile-web-app-capable" content="yes">';
        //print '<meta name="apple-mobile-web-app-status-bar-style" content="default">';
	//jh 2017-12-11 "black-translucent" is deprecated and does not work well on iPhone10
        print '<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">';

        print '<meta name="apple-mobile-web-app-title" content="'.htme($title).'">';
        print '<link rel="apple-touch-icon" href="'.$filename192.'">';
        print '<meta name="msapplication-TileImage" content="'.$filename144.'">';

        $background_color = GetSetting('WebAppBackgroundColor');
        if ($background_color == '') {
            $background_color = '#ffffff';
        }

        print '<meta name="msapplication-TileColor" content="'.$background_color.'">';
        $theme_color = GetSetting('WebAppThemeColor');
        if ($theme_color == '') {
            $theme_color = '#000000';
        }
        print '<meta name="theme-color" content="'.$theme_color.'">';

        print '<meta property="og:title" content="'.htme($title).'">';
        print '<meta property="og:type" content="website">';
        print '<meta property="og:image" content="'.$filename192.'">';
        print '<meta property="og:url" content="'.htme($base).'webapp.php">';
        print '<meta property="og:description" content="'.htme($description).'">';
        /*
        print '<meta name="twitter:card" content="summary">';
        print '<meta name="twitter:url" content="' . htme($base) . 'webapp.php">';
        print '<meta name="twitter:title" content="' . htme($title) . '">';
        print '<meta name="twitter:description" content="' . htme($description) . '">';
        print '<meta name="twitter:image" content="' . $filename192 . '">';
        print '<meta name="twitter:creator" content="">'; //interleave heeft geen twitter account
        */
        print '<link rel="shortcut icon" href="favicon.ico">'; //mogelijkheid tot eigen icoon opnemen?
        print '<link rel="stylesheet" href="font-awesome/css/font-awesome.min.css?'.filemtime('font-awesome/css/font-awesome.min.css').'">';
        print '<link rel="stylesheet" href="webapp.css?'.filemtime('webapp.css').'">';

    	$webappcss = GetSetting('WebAppCSS');
    	if ($webappcss > 0)
    	{
    		//always inline, so it also works on the webapp login page
    		print '<style type="text/css">'.db_GetValue('SELECT content FROM CRMtemplates WHERE templateid='.$webappcss.' AND version_belonging_to=0').'</style>';
    	}

        //PrintHeaderJavascript();
        //print '<script type="text/javascript" src="js/jquery-fancybox/source/jquery.fancybox.pack.js"></script>';

        print '<script type="text/javascript" src="js/jquery.js"></script>';
        print '<script type="text/javascript" src="js/jquery-ui/jquery-ui-1.10.4/js/jquery-ui-1.10.4.custom.min.js"></script>';
        //print '<script type="text/javascript" src="js/sorttable.js"></script>';
        print '<script type="text/javascript" src="js/highcharts/js/highcharts.js?2"></script>';

	    print '<script type="text/javascript" src="js/functions.js?'.filemtime('js/functions.js').'"></script>';

        print '<script type="text/javascript" src="js/jquery.autosize.input.js"></script>';

        $jstemplate = GetSetting('TemplateNoOfJavascriptFileToIncludeInEveryPage');
        if (ipi($jstemplate)) {
            print '<script type="text/javascript" src="' . add_sessionid_to_url('csv.php?getcustomjs=1&amp;'.strtotime(GetTemplateLastModificationDate($jstemplate))) .'"></script>';
        }

        print '<script type="text/javascript" src="js/jquery.mobile.custom.min.js"></script>';

        print '<script type="text/javascript" src="lib/annotator/2.x/annotator.js?1424888816"></script>
        <script type="text/javascript" src="lib/annotator/2.x/jquery.imgareaselect.js?1424888816"></script>
        <script type="text/javascript" src="lib/annotator/2.x/annotator.imgselect.min.js"></script>
        <link rel="stylesheet" type="text/css" href="lib/annotator/2.x/imgareaselect-default.css">
        <link rel="stylesheet" type="text/css" href="lib/annotator/2.x/annotator.min.css">';

        print '</head>';

        print '<body class="group' . $GLOBALS["GROUPID"] . '">';

        print '<div id="wait" class="hide_content"><span class="fa fa-circle-o-notch fa-spin"></span></div>';

	print '<div>'; // this is MainContent but without the id


    } else {
        $timeoutsec = GetSetting('timeout') * 60;

        //jh 2015-12-05 title wordt toch via js overschreven met de eerste h1, door getsetting weg te laten scheelt dit 1 query; echter niet alle pagina's hebben een h1, daarom uitgezet
        print '<title>'.htme($title).' :: '.$GLOBALS['PRODUCT'].'</title>';
        //print '<meta http-equiv="refresh" content="' . $timeoutsec . '; url=' . $base . 'index.php">';
        print '<link rel="shortcut icon" href="favicon.ico">';

        //ook voor desktop
        print '<meta name="viewport" content="width=device-width, initial-scale=1">';

        PrintHeaderJavascript();

        DisplayCSS();
        print '</head>';

        print '<body id="ilbody"';
        if (!$_REQUEST['nonavbar']) {
            print ' class="mainbody';
	    if ($GLOBALS["InAdminSection"]) {
		    print ' in_admin';
	    }
	    print ' group' . $GLOBALS["GROUPID"] . '"';
        } else {
            print ' class="subbody group' . $GLOBALS["GROUPID"] . '"';
        }
        print '>';

        if (!$_REQUEST['nonavbar']) {

            if ($GLOBALS["InAdminSection"]) {
                print '<div id="minifiedmenu" class="hide_content">';
            }
	        print '<div id="navigation">';
            print create_menu();
	        print '</div>';

            if ($GLOBALS["InAdminSection"]) {
                print '</div>';
                if (is_administrator()) {
                    PlainNav(get_admin_nav_items());
                }
            } elseif (is_administrator()) {
                print '<div class="hide_content"><nav><ul>';
                    PlainNav(get_admin_nav_items());
                print '</div>';

            }

    		if (is_administrator()) {
    			if (isset($_GET['EnableOnlineEditModeInlineLinks'])) {
    				SetAttribute('user', 'OnlineEditMode-ShowInlineLinks', 'Yes', $GLOBALS['USERID']);
    			} elseif (isset($_GET['DisableOnlineEditModeInlineLinks'])) {
    				SetAttribute('user', 'OnlineEditMode-ShowInlineLinks', 'No', $GLOBALS['USERID']);
    			}

    			if (isset($_GET['EnableOnlineQlog'])) {
    				SetAttribute('user', 'OnlineEditMode-OnlineQLOG', 'Yes', $GLOBALS['USERID']);
    			} elseif (isset($_GET['DisableOnlineQlog'])) {
    				SetAttribute('user', 'OnlineEditMode-OnlineQLOG', 'No', $GLOBALS['USERID']);
    			}

    			$attribinlinelinks = GetAttribute('user', 'OnlineEditMode-ShowInlineLinks', $GLOBALS['USERID']);
    			$attribonlineqlog = GetAttribute('user', 'OnlineEditMode-OnlineQLOG', $GLOBALS['USERID']);
    			if ($attribonlineqlog == 'Yes') {
    				$GLOBALS['qlog_onscreen'] = true;
    			}

    			$GLOBALS['SesMem']['InlineEditMode'] = 'On';
    			if ($attribinlinelinks == 'Yes') {
    				$GLOBALS['SesMem']['InlineEditMode_InlineLinks'] = 'On';
    			} else {
    				$GLOBALS['SesMem']['InlineEditMode_InlineLinks'] = 'Off';
    			}

    			$url = $_SERVER['REQUEST_URI'];
    			$url = str_replace('&EnableOnlineEditModeInlineLinks', '', $url);
    			$url = str_replace('&DisableOnlineEditModeInlineLinks', '', $url);
    			$url = str_replace('&DisableOnlineQlog', '', $url);
    			$url = str_replace('&EnableOnlineQlog', '', $url);

    			if (!strstr($url, '?')) {
    				$url .= '?';
    			}

    			print '<nav class="InlineEditModeSwitch"><ul>';
    			print '<li><a href="admin.php"><span class="fa fa-wrench fa-fw"></span></a></li>';
    			print '<li><a onclick="showTagSidebar();"><span class="fa fa-info fa-fw"></span></a></li>';

    			print '<li><a href="'.htme($url).'&amp;';
    			if ($attribinlinelinks == 'Yes') {
    				print 'DisableOnlineEditModeInlineLinks';
    			} else {
    				print 'EnableOnlineEditModeInlineLinks';
    			}
    			print '"';
    			if ($attribinlinelinks == 'Yes') {
    				print ' class="active"';
    			}
    			print '><span class="fa fa-eye fa-fw"></span></a></li>';
    			print '<li><a href="'.htme($url).'&amp;';
    			if ($attribonlineqlog == 'Yes') {
    				print 'DisableOnlineQlog';
    			} else {
    				print 'EnableOnlineQlog';
    			}
    			print '"';
    			if ($attribonlineqlog == 'Yes') {
    				print ' class="active"';
    			}
    			print '><span class="fa fa-book fa-fw"></span></a></li>';

    			print '<li><a><span class="fa fa-bars fa-fw"></span></a><ul>';
    			$navs = get_admin_nav_items();
    			foreach ($navs as $item) {
    				print '<li>';
    				if ($item[0] != "")
    				{
    					print '<a href="'.$item[0].'">';
    				}
    				print $item[1];
    				if ($item[0] != "")
    				{
    					print '</a>';
    				}
    				print '</li>';
    			}
    			print '</ul></li>';
    			print '</ul></nav>';
    		}
            print '<div id="quicksearch" class="hide_content"><span class="fa fa-search" aria-hidden="true"></span><input type="text" id="quicksearchsearch" placeholder="Search"><div id="quicksearchsearchhelptext">alt-space opens this screen, esc closes</div><div id="quicksearchresult"></div></div>';
            print '<style>

                #quicksearch {
                    position: fixed;
                    margin-top: 10%;
                    margin-left: auto;
                    margin-right: auto;
                    top: 0;
                    right: 0;
                    bottom: 0;
                    left: 0;
                    width: 54em;
                    height: 6em;
                    background:rgba(0,0,0,0.7);
                    border-radius: 5px;
                    z-index: 999999999;
                    box-shadow: 20px 20px 60px #cccccc;

                }
        		#quicksearchsearchhelptext {
        		    float: right;
        		    color: #777777;
        		    padding-right: 1em;
        		    top: 0;
        		}
                #quicksearch .fa-search {
                    font-size: 300%;
                    color: white;
                    padding: 0.25em;
                }
                #quicksearchresult {
                    background:rgba(0,0,0,0.7);
                    color: white;
                    border-radius: 5px;
                    display: none;
                    max-height: 40em;
                    overflow: scroll;
                    width: 50em;
                    padding-left: 2em;
                    padding-right: 2em;
                    margin-top: 0.1em;
                }
                #quicksearchresult ul {
                    list-style-type: none;
                    padding: 0;
                }
                #quicksearchresult a, #quicksearchmessage {
                    color: white;
                    font-size: 150%;

                }
                #quicksearchresult li {
                    padding: 0.25em;
                }
                #quicksearchresult span {
                    color: white;

                    padding: 0.25em;
                }
                #quicksearch input {
                    font-size: 300%;
                    background: transparent;
                    border: none;
                    padding: 0.25em;
                    color: white;
                }
                #quicksearch input:focus {
                    outline-width: 0;
                }
                .selectedadminmenu {
                    border: 1px solid white;
                    border-radius: 3px;
                }
                .quicksearchspacer {
                    background-color: white;
                    color: black;
                    font-size: 150%;
                    margin-top: 0.25em;
                    margin-bottom: 0.25em;

                }

            </style>';

            print "<script>







            </script>";

    	    if ($GLOBALS['BODY_URGENTMESSAGE'] != '') {
                    print '<div id="UrgentMessage">'.htme(unescape_interleave_characters(ParseTemplateGeneric($GLOBALS['BODY_URGENTMESSAGE']))).'</div>';
                }
    	}

        print '<div id="wait" class="hide_content"><span class="fa fa-refresh fa-spin waitrefresh"></span><div class="WaitImageDiv"></div></div>';
        print '<div id="JS_tagdiv" class="resizeable"></div>';
        print '<div id="MessagesDiv" class="hide_content"></div>';

        if ($GLOBALS['WRONGSERVERMESSAGE'] != '' && $base != '' && !$_REQUEST['nonavbar']) {
            $connected_url = $_SERVER['HTTP_HOST'];

            if (preg_match("/^http(s)?:\/\/$connected_url/", $base) == false) {
                print "<div class='errmsg'>".$GLOBALS['WRONGSERVERMESSAGE'].'</div>';
                log_msg('ERROR: User '.$GLOBALS['USERID'].' ('.GetUserName($GLOBALS['USERID']).') is using '.$title.' by accessing '.$connected_url.' instead of '.$base);
            }
        }

        print '<div id="MainContent"';
        if ($_REQUEST['nonavbar']) {
            print ' class="popupwindow"';
        }
        print '>';
    }

    print '<div id="connectionerror" class="errmsg hide_content">Connection lost, please check your settings</div>';

    if ($GLOBALS['SesMem']['Blur']) {
	print '<style type="text/css">
	input[type=text], select, p, .crm td, .crm th label, textarea, .diarycellcontent {
	color: transparent;
	text-shadow: 0 0 4px rgba(0,0,0,0.8);
	}
	</style>';
    }

}
function ShowDashboard()
{
    $template = '';

    $template_id = 0;
    if ($GLOBALS['GROUPID'] > 0)
    {
	$template_id = db_GetValue('SELECT `DASHBOARDFILEID` FROM `CRMuserprofiles` WHERE `id`='.$GLOBALS['GROUPID']);
    }
    if ($template_id == 0)
    {
	$template_id = GetSetting('DASHBOARDTEMPLATE');
    }

    if ($template_id > 0) {
        $template = GetTemplate($template_id);
        if ($GLOBALS['SesMem']['InlineEditMode_InlineLinks'] == 'On') {
            print '<div class="InlineEditModeDivContainer"><div class="InlineEditModeDiv"><a href="admin.php?templates=1&amp;editHTMLtemplate='.$GLOBALS['UC']['DASHBOARDTEMPLATE'].' &amp;fromlist='.base64_encode($_SERVER['REQUEST_URI']).'"><span class="fa fa-edit"></span></a></div></div>';
        }
    } else {
        $template = '<h1>
			@TITLE@ #CLOCK#</h1>
		<div>
			<div id="calendar">
				#CALENDAR#</div>
			<div id="InternalMessages">
				#MESSAGES#</div>
			<div>
				<a href="admin.php?templates=1&amp;nav=dashtemplates&amp;t1=dash">Edit this dashboard template</a></div>
		</div>';
    }

    return get_parsed_template_with_given_template('', '', array(), '', false, '', $template, 'TEMPLATE_DASHBOARD');
}
function SetAttribute($item, $attr, $val, $record, $allowedoptions = false)
{

    //print "SetAttribute($item, $attr, $val, $record, $allowedoptions=false)";
    if (is_array($val) && count($val) > 0) {
        $val = serialize($val);
    } elseif (is_array($val) && count($val) == 0) {
        $val = '';
    }
    $attr = trim($attr);
    $val = trim($val);

    if ((ipi($record) || $record === 0) && trim($val) != '' && trim($attr) != '') {
        $allowed_values = '';
        if (is_array($allowedoptions)) {
            $allowed_values = serialize($allowedoptions);
        } else {
            $allowed_values = serialize(GetAttributeAllowedOptions($item, $attr));
        }

        mcq("INSERT INTO CRMattributes (entity, identifier, attribute, value, allowed_values) VALUES('".mres($record)."','".mres($item)."','".mres($attr)."','".mres($val)."','".mres($allowed_values)."') ON DUPLICATE KEY UPDATE value='".mres($val)."', allowed_values='".mres($allowed_values)."'");
    } elseif (is_numeric($record) && trim($val) == '') {
        mcq("DELETE FROM CRMattributes WHERE entity='".mres($record)."' AND identifier='".mres($item)."' AND attribute='".mres($attr)."'");
    }
}
function AttributeAjaxEditElement($identifier, $attribute, $entity, $reload = false)
{
    $printvalue = GetAttribute($identifier, $attribute, $entity);

    if ($printvalue == '') {
        $printvalue = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    } else {
        $printvalue = htme($printvalue);
    }

    $ts = '';
    if (!$reload) {
        $ts .= '<span class="interactive_cell stoppropagation" id="JS_attr_'.$identifier.'-'.$attribute.'-'.$entity.'">';
    }

    $ts .= '<span style="cursor: pointer;" onclick="load_attribute_field(\''.$identifier.'\',\''.$attribute.'\',\''.$entity.'\');return(false);">'.$printvalue.'</span>';

    if (!$reload) {
        $ts .= '</span>';
    }

    return $ts;
}
function GetAttribute($item, $attr, $record)
{
    if ($attr == '%') {
        $ret = array();
        $t = db_GetArray("SELECT attribute, value FROM CRMattributes WHERE entity='".mres($record)."' AND identifier='".mres($item)."'");
        foreach ($t as $u) {
            $ret[$u['attribute']] = $u['value'];
        }
        ksort($ret);

        return $ret;
    } else {
        $sql = "SELECT value FROM CRMattributes WHERE entity='".mres($record)."' AND identifier='".mres($item)."' AND attribute='".mres($attr)."'";
        //print '<br>' . $sql;
        $t = db_GetValue($sql);
        $t2 = unserialize($t);

        //MaximumValue === null wanneer het attribuut niet in de db staat
        //MaximumValue === false wanneer het attribuut wel in de db staat maar {{none}} bevat
        //MaximumValue === "" wanneer het een lege waarde bevat in de db
        //we gebruiken is_numeric om alle situaties af te vangen, MaximumValue en MinimumValue kan ook gebroken getallen bevatten 12.78 of -1293.99
        if ($t2) {
            return $t2;
        } elseif (strtolower($t) == 'a:0:{}') {
            return array();
        } elseif (strtolower($t) == '{{none}}') {
            return false;
        } else {
            return $t;
        }
    }
}
function GetAttributeAllowedOptions($item, $attr)
{
    $sql = "SELECT allowed_values FROM CRMattributes WHERE attribute='".mres($attr)."' AND identifier='".mres($item)."' AND allowed_values!='' ORDER BY timestamp_last_change DESC, LENGTH(allowed_values) DESC";
    $t = db_GetValue($sql);
    $t2 = unserialize($t);
    if ($t2) {
        return $t2;
    } elseif (strtolower($t) == 'a:0:{}') {
        return false;
    } else {
        return false;
    }
}
function GetMissingAttributes($item, $record)
{
    $ret = db_GetFlatArray("SELECT DISTINCT(attribute) FROM CRMattributes WHERE identifier='".mres($item)."' AND entity!='".mres($record)."' AND attribute NOT LIKE 'SaveComments%'");
    sort($ret);

    return $ret;
}
function AttributeLink($item, $record, $linktext = 'Attributes', $opendirect = '', $likebutton = false)
{
    $html = "<a onclick=\"PopEditAttributesWindow('".$item."', ".$record.",'".inline_jsencode($opendirect)."');\"";
    if ($likebutton) {
        $html .= ' class="likebutton"';
    }
    $html .= '>'.htme($linktext).'</a>';

    return $html;
}
function ValidateInputHelper($worker, $header_id, $selected_field, $flextable = false)
{
    $error = false;
    $selected_field = str_replace('EFID', '', $selected_field);
    if ($selected_field != '') {
        $mem = PopStashValue($worker);
        if (is_array($mem)) {
            $cnt = 0;
            $test = array();
            $wrong_value = '';
            foreach ($mem['arrayData'] as $row) {
                if ($cnt > 0 && $selected_field != 'none') {
                    $test = ValidateFieldInput($selected_field, trim($row[$header_id]), $flextable);

                    if ($test[0] == 'nok') {
                        $wrong_value = $row[$header_id];
                        $error = true;
                        break;
                    }
                } else {
                    // skip header row
                }
                ++$cnt;
            }
            if ($error) {
                print '<span class="errmsg">{{'.$selected_field.'}} Error on line '.($cnt + 1).', value ['.substr(trim($wrong_value), 0, 40).'] failed. Result message (if any) : '.$test[1].'</span>';
            } elseif ($selected_field == 'none') {
                print 'n/a';
            } else {
                print '<span class="fa fa-check"></span>';
            }
        } else {
            print '?';
        }
    } else {
        print 'n/a';
    }
}

function is_valid_number($number)
{
    $is_valid_number = false;

    $return_number = '';

    //we trimmen spaties eraf
    $number = trim($number);

    //een leeg nummer wordt geinterpreteerd als "0"
    //if ($number == "") {
    //	$number = 0;
    //}
    //een valide nummer:
    //1) MAG met een + of een - beginnen
    //2) MOET 1 of meerdere digits (0-9) hebben
    //3) MAG gevolgd worden door een punt of een komma waarachter 1 of meerdere digits MOETEN staan
    if (preg_match("/^([\+\-])?(\d+)([\,\.](\d+))?$/", $number, $matches)) {
        //		print_r($matches);
        /*
        $number = "1234,23";

        matches:
        Array
        (
        [0] => 1234,23
        [1] =>
        [2] => 1234
        [3] => ,23
        [4] => 23
        )
        */
        $is_valid_number = true;
        $sign = $matches[1];
        $integer_part = $matches[2];
        //we halen leading zeroes eraf
        $integer_part = preg_replace('/^0+/', '', $integer_part);
        //er blijft niks over, dus weer een 0 terug
        if ($integer_part == '') {
            $integer_part = 0;
        }

        $decimal_part = $matches[4];

        if ($sign == '-') {
            $return_number .= '-';
        }
        $return_number .= $integer_part;
        if ($decimal_part != '') {
            $return_number .= '.'.$decimal_part;
        }
    }

    return array($is_valid_number, $return_number);
}
function is_valid_nl_date($nldate)
{
    $valid = false;
    if (preg_match("/^(\d{1,2})\-(\d{1,2})\-(\d{4})$/", $nldate, $match)) {
        $valid = checkdate($match[2], $match[1], $match[3]);
    }

    return $valid;
}
function is_valid_iso_date($date)
{
    $valid = false;
    //2016-2-20 is not a valid date, 2016-02-20 *is*; this is inconsistent with is_valid_nl_date()
    if (preg_match("/^(\d{4})\-(\d{2})\-(\d{2})$/", $date, $match)) {
        $valid = checkdate($match[2], $match[3], $match[1]);
    }

    return $valid;
}
function ValidateFieldInputDataStructureOnly($field, $data, $check_for_required_fields = false, $recordid = false)
{

    /* temporary test */
    //if ($GLOBALS['DEVELOPMENT']) {

    //	return validate_field_input($field, $data, $recordid, $check_for_required_fields);
    //}
    list($table, $field) = explode('-', $field);

    $dsfield = $table.'-'.$field;

    $msg = '';
    $pass = 'ok';

    if (substr($field, 0, 1) == 'f' && ipi(str_replace('f', '', $field))) { // It's a regular field

        list($pass, $msg, $data) = ValidateFieldInput($dsfield, $data, false, $check_for_required_fields, $recordid);
    } else {
        $prop = $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field];

        if ($prop['required'] == true && $data == '') {
            $pass = 'nok';
            $msg = '';
        }
        if (is_array($prop['options']) && !in_array($data, $prop['options'])) {
            if (!$prop['required'] && $data == '') {
                $pass = 'ok';
            } else {
                $pass = 'nok';
                $msg = 'Value '.$data.' not found in options list';
            }
        }
        if ($prop['use_populator_function']) {
            if (!$prop['required'] && $data == '') {
                $pass = 'ok';
            } elseif (!array_key_exists($data, get_field_options($field, $table, $recordid, $data))) {
                // field has a custom populator call but the value isn't in the list
                $pass = 'nok';
                $msg = 'Value '.$data.' not found in result of populator function';
            }
        }
    }

    return array($pass, $msg, $data);
}
function ValidateFieldInput($field, $data, $flextable = false, $check_for_required_fields = false, $recordid = false)
{
    global $lang;
    $msg = '';
    $origdata = $data;
    $errortext = '';
    if (trim($field == '')) {
        return array('nok', false, $data);
    }

    $ds_tablename = '';
    $fieldnum = '';
    $table = '';
    if (strstr($field, '-')) { // Probably fully qualified DS field. But you never know these days.
        $f = explode('-', $field);
        if (preg_match("/^t(\d+)$/", $f[0], $match)) {
            //	ft nummer zit nu in match[1]
            $table = $match[1];
            $flextable = $match[1];
            if (ipi($match[1])) {
                $ds_tablename = 't'.$match[1];
            } else {
                $ds_tablename = $match[1];
            }
        } else {
            $table = $f[0];
            $ds_tablename = $f[0];
        }

        if (preg_match("/^f(\d+)$/", $f[1], $match)) {
            //	f nummer zit nu in match[1]
            $field = $match[1];
        } else {
            $field = $f[1];
        }

        $fieldnum = $field;
    } else {
        $type = GetExtraFieldTableType($field);
        $fieldnum = str_replace('EFID', '', $field);
        $fieldnum = str_replace('f', '', $field);
        if (ipi($type)) {
            $ds_tablename = 't'.$type;
        } elseif ($type == 'loginusers') {
            $ds_tablename = 'users';
        } elseif ($type == 'userprofiles') {
            $ds_tablename = 'groups';
        } elseif ($type == 'files') {
            $ds_tablename = 'files';
        } else {
            $ds_tablename = $type;
        }
    }
    $ds_fieldname = $field;
    if (ipi($field)) {
        $ds_fieldname = 'f'.$field;
    }

    /* don't check for required fields on the users and groups page, for admins. */
    if (($ds_tablename == 'users' || $ds_tablename == 'groups') && is_administrator()) {
        $check_for_required_fields = false;
    }

    // Als er niks gevonden is, check dan de DS om te kijken of het veld daar in voor komt
    // Zo ja, pass naar DS check function
    // ValidateFieldInputDataStructureOnly($field, $data, $check_for_required_fields=false, $recordid=false)

    if ($ds_tablename == '' && is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field])) {
        return ValidateFieldInputDataStructureOnly($table.'-'.$field, $data, $check_for_required_fields, $recordid);
    } else {

         /* don't check for required fields on the users and groups page, for admins. */
        /*
         * 	we weten nog niet of dit beter is. nu weer ff uit.
         *
         *if (is_administrator()) {
            $check_for_required_fields = false;
        }
        */

        if (!ipi($flextable)) {
            $flextable = false;
        }
        if (ipi(GetExtraFieldType($field))) {
            $flextable = GetExtraFieldType($field);
        }

        $some_data = false;

        if (is_array($data)) {
            foreach ($data as $line) {
                if ($line != '') {
                    $some_data = true;
                }
            }
        } elseif ($data != '') {
            $some_data = true;
            $data = trim($data);
        }

        if ($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname]['relation_to'] != '' && ($data == '0' || $data == '')) {
            $some_data = false;
        }
        if (ipi($recordid) || $recordid == '_new_') {
            $code = '';
            $type = '';

            /// Start by checking for CustomValidationFunctionPHP
            if (ipi($fieldnum)) {
                $code = GetAttribute('extrafield', 'CustomValidationFunctionPHP', $fieldnum);
                $type = GetExtraFieldTableType($fieldnum);
            } else {
                log_msg('ERROR: THIS WILL POTENTIALLY MAKE FORMS UNUSEABLE - TAKE ACTION AEAF2 ValidateFieldInput called with unknown field: '.$field);

                return array('nok', false, $origdata);
            }

            if (trim($code) != '') {

//JH 2017-07-11 PARSING OF TAGS IN PHP CODE SHOULD BE DISABLED; BUT WE STILL HAVE A COUPLE OF CASES WHERE WE USE THIS

                $flextableid = 0;
                if (ipi($type)) {
                    $record = $recordid;
                    $flextable = $type;
                    $flextableid = $type;
                    $code = ParseTemplateRecordData($code, 't'.$flextable, $recordid);
                } elseif ($type == 'user') {
                    $code = ParseTemplateUserAndGroupFields($code);
                } elseif ($type == 'files') {
                } else {
                    log_msg('ERROR: ValidateFieldInput called with unknown field table type: '.$type);

                    return array('nok', '', $origdata);
                }
                $code = unescape_interleave_characters($code);

                $result = '';
                $res = '';
                $msg = '';
                $value = $data;
                @eval($code);

                if (is_array($result)) {
                    $res = $result[0];
                    $msg = $result[1];
                    if (isset($result[2])) {
                        $origdata = $result[2];
                    }
                } else {
                    $res = $result;
                    $msg = false;
                }

                qlog(INFO, 'Evaluating custom PHP validation for field '.$field.' result:'.$res);

                if ($res == 'ok') {

                    //return array("ok", $msg, $origdata);
                } else {
                    if ($res == '') {
                        $msg = 'Validaton returned no result. Defaulting to NOK.';
                    }

                    return array('nok', $msg, trim($origdata));
                }
            }
            /// End check CustomValidationFunctionPHP
        }

        if (!$some_data && $check_for_required_fields) {
            if (ipi($field)) {
                // Check field definitions to see if this field is required since it's posted empty
                $tmp = db_GetValue("SELECT forcing FROM CRMextrafields WHERE id='".mres($field)."'");
                if ($tmp == 'y') {
                    // Field is required but not entered
                    return array('nok', false, $origdata);
                } else {
                    // Field is not required and NOT entered
                    return array('ok', false, $origdata);
                }
            }
        }

        switch ($field) {

        case 'PROFILE':
            $profid = db_GetValue("SELECT id FROM CRMuserprofiles WHERE (id='".mres($data)."' OR name='".mres($data)."')");
            if (ipi($profid)) {
                return array('ok', $msg, $profid);
            } else {
                //print "Group could not be found<br>";
            }
            break;

        case 'PASSWORD':
            return array('ok', $msg, $origdata);
            break;

        case 'name':
            $test = db_GetValue("SELECT name FROM CRMloginusers WHERE name='".mres($data)."'");
            if ($test != $data) {
                return array('ok', $msg, trim($origdata));
            } else {
                //print "Duplicate user name<br>";
            }
            break;

        case 'EMAIL':
            if (ValidateEmail(trim($origdata)) || $data == '') {
                return array('ok', $msg, trim($origdata));
            }
            // print $data ." not valid<br>";
            break;

        default:
            $type = GetExtraFieldType($fieldnum);
            if ($type == 'List of all groups') {
                $profid = db_GetValue("SELECT id FROM CRMuserprofiles WHERE (id='".mres($data)."' OR name='".mres($data)."')");
                if (ipi($profid)) {
                    return array('ok', $msg, $profid);
                } else {
                }
            } elseif ($type == 'color') {
                if (preg_match('/^#[a-f0-9]{6}$/i', $data)) { // hex color is valid
                    return array('ok', $msg, $origdata);
                }
            } elseif ($type == 'drop-down') {
                $tmp = db_GetValue("SELECT options FROM CRMextrafields WHERE id='".mres($field)."'");

                if (substr($tmp, 0, 18) == '%POPULATE_BY_CODE%') {
                    // Don't take any chances
                    return array('ok', $msg, $origdata);
                }

                $options = GetExtraFieldOptions($fieldnum);
                if (in_array(trim($data), $options)) {
                    return array('ok', $msg, $origdata);
                }
            } elseif ($type == 'User-list of all CRM-CTT users' || $type == 'assignee' || $type == 'owner') {
                if (ipi($data)) {
                    $val = db_GetValue("SELECT id FROM CRMloginusers WHERE id='".mres($data)."'");
                    if (ipi($val)) {
                        return array('ok', $msg, $origdata);
                    } else {
                        $errortext = ' not_numeric';
                    }
                } else {
                    $val = db_GetValue("SELECT id FROM CRMloginusers WHERE name='".mres($data)."'");
                    if (ipi($val)) {
                        return array('ok', $msg, $origdata);
                    } else {
                        $val = db_GetValue("SELECT id FROM CRMloginusers WHERE FULLNAME='".mres($data)."'");

                        if (ipi($val)) {
                            return array('ok', $msg, $origdata);
                        } else {
                            $errortext = ' not_numeric';
                        }
                    }
                }
            } elseif ($type == 'numeric') {
                $num = is_valid_number(trim($data));

                if ($num[0]) {
                    if ($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname]['fieldtype'] == 'number') {

                        //return array("nok", "table = " . $table . " field = " . $field, "");
                        list($whole, $decimals) = explode('.', $num[1]);
                        if (strlen($decimals) > $GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname]['decimals']) {
                            return array('nok', $lang['too_many_decimals'], '');
                        } else {
                            $MaximumValue = GetAttribute('extrafield', 'MaximumValue', $fieldnum);
                            $MinimumValue = GetAttribute('extrafield', 'MinimumValue', $fieldnum);
                            //MaximumValue === null wanneer het attribuut niet in de db staat
                            //MaximumValue === false wanneer het attribuut wel in de db staat maar {{none}} bevat
                            //MaximumValue === "" wanneer het een lege waarde bevat in de db
                            //we gebruiken is_numeric om alle situaties af te vangen, MaximumValue en MinimumValue kan ook gebroken getallen bevatten 12.78 of -1293.99. Beiden kunnen ook "0" bevatten!
                            if (is_numeric($MaximumValue) && $num[1] > $MaximumValue) {
                                return array('nok', $lang['number_too_high'].' '.$MaximumValue.'.', '');
                            } elseif (is_numeric($MinimumValue) && $num[1] < $MinimumValue) {
                                return array('nok', $lang['number_too_low'].' '.$MinimumValue.'.', '');
                            } else {
                                return array('ok', $msg, $num[1]);
                            }
                        }
                    } else {
                        return array('ok', $msg, $num[1]);
                    }
                } else {
                    $errortext = ' not_numeric';
                    //$msg = " " . $origdata . " is not a valid number";
                }
            } elseif ($type == 'date' || $type == 'date (iso)' || $field == 'duedate') {
                // At this point, we're sure that IF the date is correct, it will be formatted correctly

                if (is_valid_nl_date($data) || $data == '') {
                    return array('ok', $msg, trim($data));
                }

                // TransformDate
            } elseif ($type == 'Reference to FlexTable') {

                if ($data == '') {
                    return array('ok', $msg, $origdata);
                } else {
                    if ($origdata == '0') {
                        // Zero means empty
                        return array('ok', $msg, trim($origdata));
                    } else {
                        $childtable = $ds_tablename;
                        $childfield = 'f'.$fieldnum;
                        $childrecordid = $recordid; //select_refer_field_options() voegt de huidige gekozen waarde toe aan de opties ook indien die momenteel niet meer gekozen mag worden
                        $check_if_exists_recordids = array($data);

                        $possible_values = select_refer_field_options($childtable, $childfield, $childrecordid, false, $check_if_exists_recordids);

                        //print '<h1>xxx childtable=' . $childtable . ',childfield=' . $childfield . ',childrecordid=' . $childrecordid . ',check_if_exists=' . string_r($check_if_exists_recordids) . '</h1>';
                        //pre($possible_values);

                        //het is er maar 1 maar op deze manier is de code gelijk aan de multiselect check
                        foreach ($check_if_exists_recordids as $check_if_exists_recordid) {
                            if (!array_key_exists($check_if_exists_recordid, $possible_values)) {
                                log_msg('ERROR: A user selected a value in a reference field, the value is not in the list of options. (record '.$check_if_exists_recordid.' in table '.$GLOBALS['UC']['PersonalDataStructure'][$childtable]['fields'][$childfield]['relation_to'].' referenced by field '.$childfield.' in table '.$childtable.')');

                                return array('nok', '');
                            }
                        }
                        //data == check_if_exists_recordids[0]
                        return array('ok', $msg, $data);
                    }
                }
            } elseif ($type == 'mail') {
                if (ValidateEmail(trim($origdata)) || $data == '') {
                    return array('ok', $msg, trim($origdata));
                }
                $errortext = $data.' not valid';
            } elseif ($type == 'date/time') {
                $test = StrDateTime2IsoDateTime($data);

                if ($test != '') {
                    return array('ok', $msg, $test);
                }
            } elseif ($type == 'checkbox') {
                return array('ok', $msg, trim($origdata));
            } elseif (substr($type, 0, 17) == 'Users of profile ') {
                if (in_array($data, GetUsersOfGroup(str_replace('Users of profile ', '', $type)))) {
                    return array('ok', $msg, $data);
                } else {
                    $errortext = ' not a valid group member';
                }
            } elseif ($type == 'diary') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'Button') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'startdate' || $field == 'entity-startdate' || $field == 'startdate') {
                if (is_valid_nl_date($data)) {
                    return array('ok', $msg, trim($data));
                }
            } elseif ($type == 'content' || $field == 'content') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'deleted') {
                if ($data == 'n' || $data == 'y') {
                    return array('ok', $msg, trim($data));
                }
            } elseif ($type == 'drop-down (multiselect)') {
                if (!is_array($data)) {
                    return array('nok', 'Not_array (DDMS) '.$data, '');
                } else {
                    $extrafield = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".mres($field)."'");

                    /* remove empty elements */
                    $data = FlattenArray($data);

                    if ($extrafield['forcing'] == 'y' && count($data) == 0) {
                        /* this field is required but no options are set. deny */
                        return array('nok', $msg, array());
                    } else {
                        $options = get_selectfield_options(ef_tabletype_to_ds_tablename($extrafield['tabletype']).'-'.'f'.str_replace('EFID', '', $field), $recordid);

                        foreach ($data as $selected_option) {
                            if (!array_key_exists($selected_option, $options[0])) {
                                log_msg('ERROR: A user selected a value in a drop-down multiselect field, the value is not in the list of options. (option '.$selected_option.' in field '.$field.')');

                                return array('nok', $msg, array());
                            }
                        }

                        return array('ok', $msg, $data);
                    }
                }
            } elseif ($type == 'Reference to FlexTable (multiselect)') {
                if (!is_array($data)) {
                    return array('nok', 'Not_array (F2FMS) '.$data, '');
                } else {
                    $extrafield = db_GetRow("SELECT * FROM CRMextrafields WHERE id='".mres($field)."'");

                    /* remove empty elements */
                    $data = FlattenArray($data);

                    if ($extrafield['forcing'] == 'y' && count($data) == 0) {
                        /* this field is required but no options are set. deny */
                        $msg .= 'Field is required';

                        return array('nok', $msg, array());
                    } else {
                        $childtable = $ds_tablename;
                        $childfield = 'f'.$fieldnum;
                        $childrecordid = $recordid; //select_refer_field_options() voegt de huidige gekozen waarde toe aan de opties ook indien die momenteel niet meer gekozen mag worden
                        $check_if_exists_recordids = $data;
                        $possible_values = select_refer_field_options($childtable, $childfield, $childrecordid, false, $check_if_exists_recordids);

                        //print '<h1>xxx childtable=' . $childtable . ',childfield=' . $childfield . ',childrecordid=' . $childrecordid . ',check_if_exists=' . string_r($check_if_exists_recordids) . '</h1>';
                        //pre($possible_values);

                        //het is er maar 1 maar op deze manier is de code gelijk aan de multiselect check
                        foreach ($check_if_exists_recordids as $check_if_exists_recordid) {
                            if (!array_key_exists($check_if_exists_recordid, $possible_values)) {
                                log_msg('ERROR: A user selected a value in a reference field, the value is not in the list of options. (record '.$check_if_exists_recordid.' in table '.$GLOBALS['UC']['PersonalDataStructure'][$childtable]['fields'][$childfield]['relation_to'].' referenced by field '.$childfield.' in table '.$childtable.')');

                                return array('nok', '', array());
                            }
                        }
                        //data == check_if_exists_recordids[0]
                        return array('ok', '', $data);
                    }
                }
            } elseif ($type == 'textbox') {
                return array('ok', $msg, trim($origdata));
            } elseif ($type == 'phone number') {
                list($ok, $ret) = IsValidPhonenumber($origdata);
                if ($ok) {
                    return array('ok', $msg, $ret);
                } else {
                    return array('nok', $msg, trim($origdata));
                }
            } elseif ($type == 'SQL Query') {
                return array('ok', $msg, $origdata);
            } elseif ($type == 'hyperlink') {
                if (substr($data, 0, 7) != 'http://' && substr($data, 0, 8) != 'https://') {
                    $data = 'http://'.$data;
                    $origdata = 'http://'.$origdata;
                }
                if (IsValidURL($data)) {
                    return array('ok', $msg, trim($origdata));
                } else {
                    $errortext = " URL didn't validate";
                }
            } elseif ($type == 'text area' || $type == 'text area (rich text)') {
                return array('ok', $msg, trim($origdata));
            } else {
                log_msg("WARNING: Validation of field '".$field."' assumed OK; don't know how to validate field type '".$type."' : GEFT ".GetExtraFieldType($field).' fieldnum '.$fieldnum);

                return array('ok', $msg, trim($origdata));
            }
            break;
        }

        return array('nok', $msg, $origdata);
    } // end if field found / DS fallback
}
function IsValidURL($url)
{
    if (filter_var($url, FILTER_VALIDATE_URL)) {
        if (count(explode('.', $url)) > 1) {
            return true;
        }
    }

    return false;
}
function LogPageInfo()
{
    if ($GLOBALS['logtext'] == true || $GLOBALS['qlog_onscreen'] == true) {
        $time_in_seconds = 0;
        if ($GLOBALS['starttime']) {
            $time_in_seconds = microtime_float() - $GLOBALS['starttime'];
        }
        qlog(INFO, 'Page report');

        //		qlog(INFO, "\n\n" . CheckPageLoadTiming($GLOBALS['tracelog'])) . "\n\n";
        qlog(INFO, '------------------------------------------------------------------');
        qlog(INFO, 'QS                              : '.$_SERVER['SCRIPT_NAME'].' '.$_SERVER['QUERY_STRING']);
        qlog(INFO, 'Repository                      : '.GetSetting('title'));
        qlog(INFO, 'Username                        : '.$GLOBALS['USERNAME']);
        qlog(INFO, 'RAM allocated (current)         : '.number_format(memory_get_usage()).' bytes');
        qlog(INFO, 'RAM allocated (peak)            : '.number_format(memory_get_peak_usage()).' bytes');
        qlog(INFO, 'Total SQL queries on this page  : '.$GLOBALS['mysql_query_counter']);
        qlog(INFO, 'Total SQL connects on this page : '.$GLOBALS['TIMES_DB_CONNECTS']);
        qlog(INFO, 'End of this page                : '.$time_in_seconds.' seconds total processing time');
        qlog(INFO, '------------------------------------------------------------------');
    }
}

function ReturnClassnameForTextColorBasedOnBackgroundColor($backgroundColor, $threshold = 382)
{
    if ($backgroundColor == '') {
        return 'black';
    } else {
        $c = str_replace('#', '', $backgroundColor);
        $rgb = array();
        $rgb[0] = hexdec(substr($c, 0, 2));
        $rgb[1] = hexdec(substr($c, 2, 2));
        $rgb[2] = hexdec(substr($c, 4, 2));
        if ($rgb[0] + $rgb[1] + $rgb[2] < $threshold) {
            return 'white';
        } else {
            return 'black';
        }
    }
}
function CheckPageLoadTiming($log)
{
    $ar = explode("\n", $log);
    $Functions = array();

    $last_func = '';
    $last_mt = '';
    $starttime = '';
    $endtime = '';
    foreach ($ar as $line) {
        $line = explode('::', $line);
        $tmp = explode(' ', $line[0]);
        $mt = $tmp[2];
        $function = $tmp[sizeof($tmp) - 1];

        if ($function == $last_func) {
            // Keep counting
        } else {
            if (is_numeric($mt) && is_numeric($last_mt)) {
                $Functions[$function]['time'] += ($mt - $last_mt);
            }
            $last_mt = $tmp[2];
        }

        ++$Functions[$function]['count'];
        $last_func = $function;
        if ($starttime == '') {
            $starttime = $tmp[2];
        }
        if ($tmp[2] != '') {
            $endtime = $tmp[2];
        }
    }
    asort($Functions);
    $Functions = array_reverse($Functions);

    $time = 0;
    $ret = '';
    $ret .= "-------------------------------------------------------------------------\n";
    $ret .= " Function calling               | Log lines | Time consumed             |\n";
    $ret .= "-------------------------------------------------------------------------\n";
    foreach ($Functions as $name => $row) {
        if (function_exists(trim($name))) {
            $ret .= ' '.fillout($name, 30).' | '.fillout($row['count'], 9).' | '.fillout($row['time'], 25)." |\n";
            $time += $row['time'];
        }
    }
    $ret .= "-------------------------------------------------------------------------\n";

    $diff = ($endtime - $starttime);

    //	$ret .=  "Start time       : " . $starttime . "\n";
    //	$ret .=  "End time         : " . $endtime . "\n";
    $ret .= 'Time span        : '.$diff." seconds\n";
    $ret .= 'Time measured    : '.$time." seconds\n";
    $ret .= 'Time unaccounted : '.($diff - $time)." seconds\n";
    $ret .= 'Log lines parsed : '.sizeof($ar)."\n";

    return $ret;
}
function GetAccessibleCalendars()
{
    $sql = "SELECT * FROM `CRMcalendars`";
    if (!is_administrator()) {
        $sql .= " WHERE 	id IN (
		SELECT `CRMcalendaraccessrules`.`calendar` FROM `CRMcalendaraccessrules` WHERE `CRMcalendaraccessrules`.`group` = '" .$GLOBALS['GROUPID']."' AND `CRMcalendaraccessrules`.`read` = '1') OR
		(SELECT COUNT(*) FROM `CRMcalendaraccessrules` WHERE `CRMcalendaraccessrules`.`calendar` = `CRMcalendars`.`id`) = 0";
    }
    $sql .= " ORDER BY `CRMcalendars`.`sortorder`";

    $cals = array();
    foreach (db_GetArray($sql) as $cal) {
        $defined_cal = array();

	$defined_cal["ref_start_date_time"] = $cal["ref_start_date_time"];
	$defined_cal["ref_end_date_time"] = $cal["ref_end_date_time"];

	if ($defined_cal["ref_start_date_time"] == "")
	{
		$defined_cal["ref_start_date_time"] = $cal["ref_end_date_time"];
	}

	$defined_cal["ref_organiser"] = $cal["ref_organiser"];

        $defined_cal['id'] = $cal['calendar_object'];
        if ($defined_cal['id'] == '') {
            $defined_cal['id'] = 'cal'.$cal['id'];
        }
        $defined_cal['description'] = ParseTemplateLanguageTags($cal['description']);

        $defined_cal['location'] = $cal['location'];
        $defined_cal['resource'] = $cal['resource'];
        $defined_cal['show_popup'] = $cal['display_popup'];
        $defined_cal['calendar_color'] = $cal['color_in_legend'];
        $defined_cal['show_popup'] = $cal['minutes_before_csv'];
        $defined_cal['display_popup'] = $cal['display_popup'];
        $defined_cal['comment'] = $cal['comment'];
        $defined_cal['summary'] = $cal['summary'];
        $defined_cal['listoptions'] = $cal['listoptions'];
        $defined_cal['appointment_click_action'] = $cal['appointment_click_action'];
        $defined_cal['show_calendar_in_legend'] = $cal['show_calendar_in_legend'];
        $defined_cal['show_add_option'] = $cal['show_add_option'];
        $defined_cal['add_option_url_extras'] = $cal['add_option_url_extras'];

	list ($endtable, $endfield) = explode("-", $cal["ref_end_date_time"]);
        /* some added security; field must be visible */
        if ($GLOBALS['UC']['PersonalDataStructure'][$endtable]['fields'][$endfield]) {
            $cals[$defined_cal['id']] = $defined_cal;
	} else {
	     log_msg("ERROR: user has access to calendar " . $defined_cal['id'] . " but not to field " . $cal["ref_end_date_time"] . " which is needed. THIS IS INCORRECT.");
	}
    }

    return $cals;
}
function DA($ar = false, $trace = true)
{
    if ($ar == '') {
        $ar = $_REQUEST;
    }
    print '<pre>';
    if (is_array($ar)) {
        print htme(print_r($ar, true));
    } else {
        print '<h1>'.htme($ar).'</h1>';
    }
    if ($trace) {
        debug_print_backtrace();
    }
    print '</pre>';
}
function trace($msg, $also_as_non_admin = false)
{
    if (!is_administrator() && !$also_as_non_admin) {
        return '';
    }

    if ($msg != '' && !is_array($msg)) {
        print '<h2>'.htme($msg).'</h2>';
    } elseif (is_array($msg)) {
        print '<pre>';
        print_r($msg);
        print '</pre>';
    }
    print '<pre>';
    debug_print_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
    print '</pre>';
}
function Alert($msg)
{
    return '<script type="text/javascript">alert(\''.jsencode($msg).'\');</script>';
}
function JS($msg)
{
    return '<script type="text/javascript">'.$msg.'</script>';
}
function CreateHighChartFromSQLNEW($title, $subtitle, $sqls, $type, $height = '', $width = '', $FillDateGaps = '', $chartid = '', $vertical = true)
{
    //FillDateGaps = vult gaten op uit een group by van mysql
    //year: (2012, 2014, 2015) -> voegt 2013 toe ("year" kan ook gebruikt worden om gaten in iedere reeks van integers op te vullen)
    //quarter: (2015Q2, 2015Q4) -> voegt 2015Q3 toe
    //month: (2014-12, 2015-03, 2015-04) -> voegt 2015-01 en 2015-02 toe
    //week: (2015W52, 2016W02) -> voegt 2015W53 en 2016W01 toe
    //day: (2016-02-28, 2016-03-01) -> voegt 2016-02-29 toe
    $series = array();
    if (!is_array($sqls)) {
        $sqls = array($sqls);
    }

    foreach ($sqls as $sql) {
        foreach (db_GetArray($sql) as $row) {
            //each column exists twice; once numeric and once textual; this is the way mysqli_query returns db values
            $columns = count($row);
            //if (($columns == 4) || ($type == "pie"))
            if ($type == 'pie') {
                //volgorde sql select: CATEGORIE, Y-AS
                //$series["Open"] = 23;
                //$series["Closed"] = 7;
                //$series["Canceled"] = 90;
                $series[$row[0]] = $row[1];
            } elseif (($columns == 6) && ($vertical)) {
                //volgorde sql select: CATEGORIE, X-AS, Y-AS
                //$series["Open"]["2016-01"] = 23;
                //$series["Open"]["2016-02"] = 17;
                //$series["Closed"]["2016-01"] = 7;
                //$series["Closed"]["2016-04"] = 2;
                //$series["Canceled"]["2016-01"] = 90;
                //$series["Canceled"]["2016-03"] = 101;
                $series[$row[0]][$row[1]] = $row[2];
            } else {
                //HORIZONTAL
                //volgorde sql select: X-AS, CATEGORIE-1, Y-AS-1, CATEGORIE-2, Y-AS-2, CATEGORIE-3, Y-AS-3, etc.
                $count = 0;
                $firstkey = '';
                foreach ($row as $key => $val) {
                    //1 om numerieke keys uit mysql te onderdrukken
                    //2 om de eerste kolom te onderdrukken
                    if (!is_numeric($key)) {
                        if ($count == 0) {
                            $firstkey = $val;
                        } else {
                            $series[$key][$firstkey] = $val;
                        }
                        ++$count;
                    }
                }
            }
        }
    }

    return CreateHighChartNEW($title, $subtitle, $series, $type, $height, $width, $FillDateGaps, $chartid);
}
function CreateHighChartNEW($title, $subtitle, $series, $type, $height = '', $width = '', $FillDateGaps = '', $chartid = '')
{
    global $lang;

    /*

    //INPUT 1
    $series["Open"] = 23;
    $series["Closed"] = 7;
    $series["Canceled"] = 90;

    //OF
    $series["2016-W01"] = 23;
    $series["2016-W02"] = 7;
    $series["2016-W04"] = 90;

    //INPUT 2
    $series["Open"]["2016-01"] = 23;
    $series["Open"]["2016-02"] = 17;
    $series["Closed"]["2016-01"] = 7;
    $series["Closed"]["2016-04"] = 2;
    $series["Canceled"]["2016-01"] = 90;
    $series["Canceled"]["2016-03"] = 101;

    */

    $legend = false;
    $allowsubzero = false;

    //print '<h1>series</h1>';
    //pre($series);
    $second_keys = array();
    foreach ($series as $name => $values) {
        foreach ($values as $key => $val) {
            //	print "name:" . $name . " key:" . $key . " val:" . $val . "<br>";
            if ($val < 0) {
                $allowsubzero = true;
            }
            if (!in_array($key, $second_keys)) {
                $second_keys[] = $key;
            }
        }
    }

    if ($FillDateGaps != '') {
        sort($second_keys);
        $last_date_count = 0;
        $dates_added = false;
        foreach ($second_keys as $second_key) {
            $this_date_count = 0;
            $this_date_add = 1;
            if ($FillDateGaps == 'day') {
                $this_date_count = db_GetValue("SELECT TO_DAYS('".mres($second_key)."')");
            } elseif ($FillDateGaps == 'week') {
                //SELECT STR_TO_DATE("2015W53 Monday", "%xW%v %W");
                //2015-12-28
                $this_date_count = db_GetValue("SELECT TO_DAYS(STR_TO_DATE('".mres($second_key)." Monday', '%xW%v %W'))");
                $this_date_add = 7;
            } elseif ($FillDateGaps == 'month') {
                list($this_year, $this_month) = explode('-', $second_key);
                $this_date_count = $this_year * 12 + $this_month - 1;
            } elseif ($FillDateGaps == 'quarter') {
                list($this_year, $this_quarter) = explode('Q', $second_key);
                $this_date_count = $this_year * 4 + $this_quarter - 1;
            }
            //ook toepasbaar voor om gaten in integers op te vullen
            elseif ($FillDateGaps == 'year') {
                $this_date_count = $second_key;
            }

            if ($last_date_count > 0) {
                for ($x = $last_date_count + $this_date_add; $x < $this_date_count; $x += $this_date_add) {
                    $dates_added = true;
                    //we vullen hier de second_keys array terwijl we erover itereren, dat kan want foreach maakt een copy
                    if ($FillDateGaps == 'day') {
                        $second_keys[] = db_GetValue("SELECT FROM_DAYS('".mres($x)."')");
                    } elseif ($FillDateGaps == 'week') {
                        //$label = floor($x / 52) . "W" . sprintf("%02d", ($x % 52 + 1));
                        $second_keys[] = db_GetValue('SELECT CONCAT(LEFT(YEARWEEK(FROM_DAYS('.$x."), 3),4),'W',RIGHT(YEARWEEK(FROM_DAYS(".$x.'), 3),2))');
                    } elseif ($FillDateGaps == 'month') {
                        $second_keys[] = sprintf('%04d-%02d', floor($x / 12), $x % 12 + 1);
                    } elseif ($FillDateGaps == 'quarter') {
                        $second_keys[] = sprintf('%04dQ%d', floor($x / 4), $x % 4 + 1);
                    } elseif ($FillDateGaps == 'year') {
                        $second_keys[] = $x;
                    }
                }
            }
            $last_date_count = $this_date_count;
        }
        if ($dates_added) {
            sort($second_keys);
        }
    }

    $xAxisCategories = $second_keys;

    if (count($series) > 1) {
        $legend = true;
    }

    $stack = false;
    $stackarea = false;
    if ($type == '') {
        $type = 'line';
    } elseif ($type == 'stacked column') {
        $stack = true;
        $type = 'column';
    } elseif ($type == 'stacked area') {
        $type = 'area';
        $stackarea = true;
    }

    if ($chartid == '') {
        //	$chartid = preg_replace("/\W/", "", $title);
        $chartid = 'C'.randomstring(8);
    }

    $styles = '';
    if ($width != '') {
        $styles .= 'width: '.$width.';';
    }
    if ($height != '') {
        $styles .= 'height: '.$height.';';
    }

    $js = '';

/*
    $js .= '<table class="crm">';
    $js .= '<thead>';
    $js .= '<tr>';
    $js .= '<th></th>';
    $num_series = 0;
    foreach (array_keys($series) as $key)
    {
	$js .= '<th class="num">' . htme($key) . '</th>';
	$num_series++;
    }
    $show_horizontal_total = false;
    if (($num_series > 1) && (($stack) || ($stackarea)))
    {
	$show_horizontal_total = true;
    }
    if ($show_horizontal_total)
    {
        $js .= '<th class="num">' . htme($lang["total"]) . '</th>';
    }
    $js .= '</tr>';
    $js .= '</thead>';
    $js .= '<tbody>';
    $total_vertical = array();
    $num_rows = 0;
    foreach ($second_keys as $second_key)
    {
	$num_rows++;
	$total = 0;
	$js .= '<tr><td>' . htme($second_key) . '</td>';
	foreach (array_keys($series) as $key)
	{
		$js .= '<td class="num">' . $series[$key][$second_key] . '</td>';
		$total += $series[$key][$second_key];
		$total_vertical[$key] += $series[$key][$second_key];
	}
	if ($show_horizontal_total)
	{
		$js .= '<td class="num">' . $total . '</td>';
	}
	$js .= '</tr>';
    }
    $js .= '</tbody>';
    if ($num_rows > 1)
    {
	$total = 0;
	$js .= '<tfoot><tr><td>' . htme($lang["total"]) . '</td>';
	foreach (array_keys($series) as $key)
	{
		$js .= '<td class="num">' . $total_vertical[$key] . '</td>';
		$total += $total_vertical[$key];
	}
	if ($show_horizontal_total)
	{
		$js .= '<td class="num">' . $total . '</td>';
	}
	$js .= '</tr></tfoot>';
    }
    $js .= '</table>';
*/

//var chart" . $chartid . ";
//$(document).ready(function() {

    $js .= '<div id="'.$chartid.'" class="ILHC"';
    if ($styles != '') {
        $js .= ' style="'.$styles.'"';
    }
    $js .= '></div>';
    $js .= "<script type=\"text/javascript\">
    var chart" . $chartid . " = new Highcharts.Chart({
	chart: {
	    renderTo: '" .$chartid."',
	    type: '" .$type."',";

if (!$GLOBALS['webapp'])
{
	$js .= "zoomType: 'x',";
}

$js .= "backgroundColor: null
	},
	credits: {
	    enabled: false
	},
	title: {
	    text: '" .EscapeSQ($title)."'
	},";
    if ($subtitle != '') {
        $js .= "
	subtitle: {
	    text: '" .EscapeSQ($subtitle)."'
	},";
    }
    $js .= '
	xAxis: {
	    categories: [';
    $nf = false;
    foreach ($xAxisCategories as $xac) {
        $js .= $nf ? ',' : '';
        $nf = true;
        $js .= "'".EscapeSQ($xac)."'";
    }
    $js .= '],
	    labels: {
		rotation: -45
	    }
	},
	yAxis: {
	    title: {
		text: null
	    },
	    ';
    if ($allowsubzero == false) {
        $js .= 'min: 0,
		';
    }
    $js .= '},';

if (!$GLOBALS['webapp'])
{
    if ($type == 'pie') {
        $js .= "tooltip: {
		    formatter: function() {
			return '<strong>' + this.point.name + '</strong>: ' + this.y + ' (' + Math.round(this.percentage,2) + '%)';
			}
		    },
		    plotOptions: {
			pie: {
			    allowPointSelect: true,
			    cursor: 'pointer',
			    dataLabels: {
				enabled: true,
				color: '#000000',
				connectorColor: '#000000',
				formatter: function() {
				    return '<strong>' + this.point.name + '</strong>: ' + Math.round(this.percentage,2) + '%';
			    }
                    }
                 }
                  },";
    } else {
        $js .= '
                                          tooltip: {';
        if ($stackarea) {
            $js .= "shared: true,
                                useHTML: true,
                                formatter: function() {
                var s = this.x + '<table>';
                sum = 0;
                $.each(this.points, function(i, point) {
                    s += '<tr><td>'+ point.series.name +'</td><td class=\"num\">'+
                        point.y + '</td></tr>';
                    sum += point.y;
                });
                s += '<tr><td></td><td class=\"num\">'+sum +'</td></tr></table>';
                return s;
            },
            ";
        } else {
            $js .= "
                         formatter: function() {
                               return '<strong>' + this.series.name + '</strong><br>' + this.x + ': ' + this.y;
                         }";
        }
        $js .= '
                  },
                  ';
    }
}
else
{
$js .= "tooltip: { enabled: false },";
}

    if ($stack) {
        $js .= "
                        plotOptions: {
                         column: {
                                stacking: 'normal',
                         }
                  },
                        ";
    } elseif ($stackarea) {
        $js .= "
                        plotOptions: {
                         area: {
                                stacking: 'normal',
                                lineWidth: 1,
                marker: {
                                        enabled: false
                }
                         }
                  },
                        ";
    }
    //                $js .= "},";
    if (!$legend) {
        $js .= '
                  legend: {
                        enabled: false
                  },';
    }
    $js .= '
                series: [';

    $ms = false;
    if (count($second_keys) == 0) {
        $js .= '{data:[';
        foreach ($series as $seriesName => $seriesData) {
            if ($ms) {
                $js .= ',';
            }
            $js .= "['".EscapeSQ($seriesName)."',".$seriesData.']';
            $ms = true;
        }
        $js .= ']}';
    } else {
        foreach ($series as $seriesName => $seriesData) {
            if ($ms) {
                $js .= ',';
            }
            $js .= "{name:'".EscapeSQ($seriesName)."',data:[";
            $nf = false;
            foreach ($second_keys as $second_key) {
                if ($nf) {
                    $js .= ',';
                }
                $value = $series[$seriesName][$second_key];
                if ($value == '') {
			if ($stackarea)
			{
				$value = 0;
			}
			else
			{
				$value = 'null';
			}
                }
                $js .= $value;
                $nf = true;
            }
            $js .= ']}';
            $ms = true;
        }
    }
    $js .= ']
});
</script>';
//});

    return $js;
}
function DataJournal($record, $from, $to, $field, $table = false)
{
    if ($from != $to) {
        if (ipi(str_replace('f', '', $field))) {
            $field = str_replace('f', '', $field);
        }

        if (!$table) {
            $table = GetExtraFieldTableType($field);
        } else {
            $table = str_replace('flextable', '', $table);
        }

        mcq("INSERT INTO CRMdatajournal(record, from_val, to_val, by_user, field, timestamp_last_change, `table`) VALUES('".mres($record)."','".mres(trim($from))."','".mres(trim($to))."','".$GLOBALS['USERID']."','".mres($field)."', NOW(), '".mres($table)."')");
    }
}
function EscapeSQ($str)
{
    $str = str_replace('\\', '\\\\', $str);
    $str = str_replace('\'', '\\\'', $str);

    return $str;
}
function jsencode($str)
{
    $str = str_replace('\\', '\\\\', $str);
    $str = str_replace('\'', '\\\'', $str);
    $str = str_replace('"', '\\"', $str);

    return $str;
}
function split_with_quotes($string_to_split, $split_char = ',', $quote_char = '"', $escape_char = '\\')
{
    $parts = array();
    $partcounter = 0;
    $quote_open = false;
    $next_char_escaped = false;
    for ($x = 0; $x < strlen($string_to_split); ++$x) {
        $char = substr($string_to_split, $x, 1);
        if ($next_char_escaped) {
            $next_char_escaped = false;
            $parts[$partcounter] .= $char;
        } elseif (($quote_open) && ($char == $escape_char)) {
            $next_char_escaped = true;
        } elseif (($quote_open == false) && ($char == $split_char)) {
            ++$partcounter;
            $parts[$partcounter] = '';
        } elseif ($char == $quote_char) {
            $quote_open = !$quote_open;
        } else {
            $parts[$partcounter] .= $char;
        }
    }

    return $parts;
}

function ExcelSplit($excel, $fieldnames_in_first_row = false, $record_seperator_char = "\n", $field_seperator_char = "\t", $quote_char = '"')
{
    //copy paste vanuit Excel is tabgescheiden, record zijn gescheiden met een enter
    /*
    Een copy paste vanuit Excel gaat niet goed wanneer een cel begint met een quote char, als je dit letterlijk intypt en copy paste uit Excel dan komt het er zo uit:
    a	"b
    c	d"

    paste je deze tekst weer terug in Excel dan krijg je:
    a	b/cd

    Excel ZOU in eerste instantie dit moeten copy/pasten (de cellen waar quotes in staan moeten omringd worden door quotes, en de quotes IN de cellen moeten geescaped worden met een andere quote)
    a	"""b"
    c	"d"""

    Als je bovenstaande weer terugplakt in Excel dan gaat het goed, je krijgt dan weer dit te zien:
    a	"b
    c	d"

    We KUNNEN hier niet omheen werken; als een cel begint met een double quote en je copy paste dat uit Excel dan GAAT HET MIS bij het inlezen in Interleave, net zo goed als het ook mis gaat wanneer je dat terugleest in Excel
    */

    //RULE 1: record MOETEN worden gescheiden door record_seperator_char (\n)
    //RULE 2: fields MOETEN worden gescheiden door field_seperator_char (\t)
    //RULE 3: er MOGEN record_seperator_char (\n) en field_seperator_char (\t) in de data staan, maar dan MOETEN er quote_char (") OM de data staan, de quote_chars zijn geen onderdeel van de data
    //RULE 4: er MOGEN quote chars in de data staan maar dan moet de hele data omringd worden door quote chars, en moeten de quote chars IN de data voorafgegaan worden door nog een quote char
    //RULE 4 DOET EXCEL NIET GOED, excel zet er alleen quote chars omheen bij de situatie in rule 3, maar niet in rule 4; hierdoor kan het mis gaan wanneer een string in excel begint met een dubbel quote -> hier is niks aan te doen
    //fix jeroen 2014-11-14
    $excel = preg_replace("/\r\n/", "\n", $excel);

    /* HF20180123 replace \u00a0 with " " (nbsp for normal space) */
    $excel = str_replace( chr( 194 ) . chr( 160 ), ' ', $excel );

    $data = array();
    $record_counter = 0;
    $field_counter = 0;
    $num_chars = 0;
    $fieldnames = array();
    $fieldname = '';
    $num_chars = 0;
    $data_is_quoted = false;
    $quote_open = false;

    for ($x = 0; $x < strlen($excel); ++$x) {
        $char = substr($excel, $x, 1);

        $char_is_data = true;
        if ($char == $quote_char) {
            if (!$quote_open) {
                //de quote staat helemaal aan het begin, of dit is een dubbele quote in een string waarvan er ook een quote aan het begin stond: "bedrijf ""de reus"""\t"test"\t"eind"
                if (($num_chars == 0) || ($data_is_quoted)) {
                    $quote_open = true;
                    //zo niet dan is het een dubbele quote die letterlijk in de string gezet moet worden
                    if ($num_chars == 0) {
                        $char_is_data = false;
                    }
                    $data_is_quoted = true;
                }
            } else {
                $quote_open = false;
                $char_is_data = false;
            }
        }
        /*else
        {
        $next_quote_char_is_escaped = false;
        }*/

        if ($char_is_data) {
            if (!$quote_open) {
                if ($char == $field_seperator_char) {
                    ++$field_counter;
                    $char_is_data = false;
                    $num_chars = 0;
                    $data_is_quoted = false;
                } elseif ($char == $record_seperator_char) {
                    ++$record_counter;
                    $field_counter = 0;
                    $char_is_data = false;
                    $num_chars = 0;
                    $data_is_quoted = false;
                }
            }

            //laatste conditie is erg lomp maar die voorkomt dat er een nieuw array element wordt aangemaakt voor de laatste enter in de Excel copy-paste
            if (((!$char_is_data) || ($x == 0)) && ($x < strlen($excel) - 1)) {
                if (($record_counter == 0) && ($fieldnames_in_first_row)) {
                    $fieldnames[$field_counter] = '';
                } else {
                    $fieldname = $field_counter;
                    if ($fieldnames_in_first_row) {
                        $fieldname = $fieldnames[$field_counter];
                    }
                    $data[$record_counter][$fieldname] = '';
                }
            }

            if ($char_is_data) {
                if (($record_counter == 0) && ($fieldnames_in_first_row)) {
                    $fieldnames[$field_counter] .= $char;
                } else {
                    $data[$record_counter][$fieldname] .= $char;
                }
                ++$num_chars;
            }
        }
    }

    return $data;
}
function gps($coordinate, $hemisphere)
{
    for ($i = 0; $i < 3; ++$i) {
        $part = explode('/', $coordinate[$i]);
        if (count($part) == 1) {
            $coordinate[$i] = $part[0];
        } elseif (count($part) == 2) {
            $coordinate[$i] = floatval($part[0]) / floatval($part[1]);
        } else {
            $coordinate[$i] = 0;
        }
    }
    list($degrees, $minutes, $seconds) = $coordinate;
    $sign = ($hemisphere == 'W' || $hemisphere == 'S') ? -1 : 1;

    return $sign * ($degrees + $minutes / 60 + $seconds / 3600);
}
function IndexGPSCoordinates($fileid = false)
{

    $sql_ins = '';
    if (ipi($fileid)) {
        $sql_ins = " AND `CRMbinfiles`.`fileid`='".$fileid."'";
    }
    foreach (db_GetFlatArray("SELECT `CRMbinfiles`.`fileid` FROM `CRMbinfiles` WHERE `CRMbinfiles`.`coordinates` = '' AND `CRMbinfiles`.`filetype`='image/jpeg' ".$sql_ins) as $fileid) {
        $path = CopyFileToDisk($fileid);
        mcq("UPDATE `CRMbinfiles` SET `CRMbinfiles`.`coordinates` = '".mres(GetGPSCoordinates($path))."', `CRMbinfiles`.`timestamp_last_change`=`CRMbinfiles`.`timestamp_last_change` WHERE `CRMbinfiles`.`fileid` = '".$fileid."'");
        unlink($path);
    }
}
function GetGPSCoordinates($filepath)
{
    /*
     * tries to find GPS coordinates from a file already on disk (during ExtractIndexData process)
     */

    $exif = @exif_read_data($filepath);
    $latitude = gps($exif['GPSLatitude'], $exif['GPSLatitudeRef']);
    $longitude = gps($exif['GPSLongitude'], $exif['GPSLongitudeRef']);

    if ($latitude != '' && $longitude != '') {

        return $latitude.'+'.$longitude;

    } else {
        /* we store this in the database to mark the image as checked but no gps found */

        return '{0}';
    }
}
function GetFileGPSCoordinates($fileid)
{
    /* fetches the saved GPS coordinates */
    $gps = db_GetValue("SELECT `CRMbinfiles`.`coordinates` FROM `CRMbinfiles` WHERE `CRMbinfiles`.`fileid`='".mres($fileid)."'");
    if ($gps != '' && $gps != '{0}') {
        return $gps;
    } else {
        return '';
    }
}
function RotateImage($fileid, $angle=90)
{
    /* rotates an image by fileid */
    $imageurl = CopyFileToDisk($fileid);

    // reading image
    $image = getimagesize($imageurl, $info); // $info, only to handle problems with earlier php versions...

    $func = '';
    $img = "";

    if ($image[2] == 1) {
        $img = imageCreateFromGIF($imageurl);
    } elseif ($image[2] == 2) {
        $img = imageCreateFromJPEG($imageurl);
    } elseif ($image[2] == 3) {
        $img = imageCreateFromPNG($imageurl);
    }

    $rotate = imagerotate($img, $angle, 0);

    ob_start();

    if ($image[2] == 1) {
        imagegif($rotate);
    } elseif ($image[2] == 2) {
        imagejpeg($rotate);
    } elseif ($image[2] == 3) {
        imagepng($rotate);
    }

    $imagevariable = ob_get_contents();
    ob_end_clean();

    unlink($imageurl);

    if ($imagevariable != '') {

        SetFileContent($fileid, $imagevariable);
        GenerateImageThumbnails($fileid);
        return true;

    } else {
        return false;
    }
}

function ResizeImage($imageBin, $horizontalPx, $verticalPx, $bgFillColor = '0,0,0', $fgFillColor = '104,104,104', $copyrightmsg = false, $autorotate = true, $max_width_or_height = 0)
{
    if ($imageBin == '') {

        return false;

    } else {

        $info = array(); //om undeclared warnings te voorkomen, getImageSize ZET deze var zelf ook
        // Save image to disk
        $imageurl = tempnam(GetSetting('TMP_FILE_PATH'), 'INTLV_IMGRESIZE');
        file_put_contents($imageurl, $imageBin);

        $font = 1;

        // reading image
        $image = getimagesize($imageurl, $info); // $info, only to handle problems with earlier php versions...

        $func = '';

        if ($image[2] == 1) {
            $func = 'imageCreateFromGIF';
        } elseif ($image[2] == 2) {
            $func = 'imageCreateFromJPEG';
        } elseif ($image[2] == 3) {
            $func = 'imageCreateFromPNG';
        }
        $infotext = string_r($image);

        if ($func == '') {
            return false;
        }
        if ($autorotate && function_exists('exif_read_data')) {
            /* GD throws fatal if the image is undecodable or wrong in any way. we need to catch that, especially for cron (mails will not be sent) */
                try {
                    $img = $func($imageurl);
                } catch (Exception $e) {
                    unlink($imageurl);
                    return $imageBin;
                }
            $exif = exif_read_data($imageurl);
            $ort = $exif['Orientation'];
            $info = '';
            switch ($ort) {

            case 3: // 180 rotate left
                $img = imagerotate($img, 180, 0);
                $infotext = 'Use func rotate 180 degrees';
                break;

            case 6: // 90 rotate right
                $img = imagerotate($img, -90, 0);
                $infotext = 'Use func rotate -90 degrees';
                break;

            case 8: // 90 rotate left
                $img = imagerotate($img, 90, 0);
                $infotext = 'Use func rotate 90 degrees';
                break;

            default:
                $infotext = 'Use func rotate NO ROTATE HOWEVER REQUESTED: ort is '.$ort;
                break;
            }

            $ifunc = '';
            if ($image[2] == 1) {
                $ifunc = 'imageGIF';
            } elseif ($image[2] == 2) {
                $ifunc = 'imageJPEG';
            } elseif ($image[2] == 3) {
                $ifunc = 'imagePNG';
            }

            $ifunc($img, $imageurl);
            $image = getimagesize($imageurl, $info); // $info, only to handle problems with earlier php versions...

        } else {
            $infotext = 'Use func rotate NOT PERFORMED ON REQUEST';
        }


    	$original_width = $image[0];
    	$original_height = $image[1];

    	if (is_positive_integer($max_width_or_height))
    	{
    		//default; no resize
    		$horizontalPx = $original_width;
    		$verticalPx = $original_height;

    		//image width is greater than (or equal to) image height (landscape)
    		if ($original_width >= $original_height)
    		{
    			//image is larger than desired size; so we resize it
    			if ($original_width > $max_width_or_height)
    			{
    				$horizontalPx = $max_width_or_height;
    				$verticalPx = $max_width_or_height / $original_width * $original_height;
    			}
    		}
    		//image height is greater than image width (portrait)
    		else
    		{
    			//image is larger than desired size; so we resize it
    			if ($original_height > $max_width_or_height)
    			{
    				$verticalPx = $max_width_or_height;
    				$horizontalPx = $max_width_or_height / $original_height * $original_width;
    			}
    		}
    	} else if (!is_numeric($horizontalPx) && !is_numeric($verticalPx)) {

            // standard width & height if not given; no resize
    		$horizontalPx = $original_width;
    		$verticalPx = $original_height;

        } elseif (is_numeric($horizontalPx) && !is_numeric($verticalPx)) {

            /* only width given, calculate height */
              $verticalPx = $horizontalPx / $original_width * $original_height;

        } elseif (!is_numeric($horizontalPx) && is_numeric($verticalPx)) {

            /* only height given, calculate width */
            $horizontalPx = $verticalPx / $original_height * $original_width;
        }

    	//convert to integers
    	$horizontalPx = round($horizontalPx);
    	$verticalPx = round($verticalPx);

        /* GD throws fatal if the image is undecodable or wrong in any way. we need to catch that, especially for cron (mails will not be sent) */
        try {
            $timg = $func($imageurl);
        } catch (Exception $e) {
            unlink($imageurl);
            return $imageBin;
        }

        // creating new image with given sizes
        $imgh = imagecreatetruecolor($horizontalPx, $verticalPx);

        // setting colours
        $cols = explode(',', $bgFillColor);
        $bgcol = imagecolorallocate($imgh, trim($cols[0]), trim($cols[1]), trim($cols[2]));

        $cols = explode(',', $fgFillColor);
        $fgcol = imagecolorallocate($imgh, trim($cols[0]), trim($cols[1]), trim($cols[2]));

        // fill background
        imagefill($imgh, 0, 0, $bgcol);

        // Make the background transparent
        //imagecolortransparent($imgh, imagecolorallocate($imgh, 0, 0, 0));
        // create small copy of the image

        imagecopyresampled($imgh, $timg, 0, 0, 0, 0, $horizontalPx, $verticalPx, $original_width, $original_height);


        // writing copyright note
        if ($copyrightmsg != '') {
            imagestringup($imgh, $font, $horizontalPx - 9, $verticalPx - 3, $copyrightmsg, $fgcol);
        }
        // output
        ob_start();

        if ($image[2] == 1) {
            // GIF image
            imagegif($imgh);
        } elseif ($image[2] == 2) {
            // JPEG image
            imagejpeg($imgh, null, 95);
        } elseif ($image[2] == 3) {
            // PNG image
            imagepng($imgh);
        }

        $imagevariable = ob_get_contents();
        ob_end_clean();

        // cleaning cache
        imagedestroy($timg);
        imagedestroy($imgh);

        unlink($imageurl);

        return $imagevariable;
    }
}
function CustomerRFCiFrameAuthenticated($username, $password, $text = 'Open hulp- en wijzigingsverzoeken', $html = false)
{
    $ret = '<a onclick=\'window.open("https://admin.interleave.nl/index.php?username='.htme($username).'&amp;password='.htme($password).'&amp;curus='.base64_encode(GetUserName($GLOBALS['USERID'])).'&amp;curem='.base64_encode(GetUserEmail($GLOBALS['USERID'])).'");\'>';
    if (!$html) {
        $ret .= htme($text);
    } else {
        $ret .= $text;
    }
    $ret .= '</a>';

    return $ret;
}
function ReturnLockJavascript($record, $table)
{
    if (GetSetting('EnableEntityLocking') == 'Yes' && ipi($record)) {
        return '<script type="text/javascript">var LockInterval = 15000;var LockRecord='.htme($record).'; var LockCounter=1;var LockTable="'.htme($table).'";UpdateRecordLock();</script>';
    }
}
function PHT($query, $link = '', $idname = 'id', $class = 'crm sortable', $tablestyle = '', $print = true)
{
    $output = '';
    // sending query
    $result = db_GetArray($query);
    if (count($result) == 0) {
        return '';
    }

    //$fields_num = count($result[0]);
    if ($link == '') {
        $class .= ' noclick';
    }

    $output .= '<table';
    if ($class != '') {
        $output .= ' class="'.$class.'"';
    }
    if ($tablestyle != '') {
        $output .= ' style="'.$tablestyle.'"';
    }
    $output .= '>';
    $output .= '<thead><tr>';

    $fields = array();
    foreach ($result[0] as $field => $value) {
        if (!is_numeric($field)) {
            $output .= '<th>'.htme($field).'</th>';
            $fields[] = $field;
        }
    }
    $output .= '</tr></thead>';
    // $output .= ing table rows
    foreach ($result as $row) {
        $output .= '<tr';
        if ($link != '') {
            $output .= " onclick=\"window.location.href='".str_replace('@ID@', $row[$idname], $link)."';\"";
        }
        $output .= '>';

        foreach ($fields as $cell) {
            $output .= '<td';
            if (is_numeric($row[$cell])) {
                $output .= ' class="num"';
            }
            $output .= '>'.htme($row[$cell]).'</td>';
        }

        $output .= '</tr>';
    }
    $output .= '</table>';

    if ($print) {
        print $output;
    } else {
        return $output;
    }
}
function GetTableSize($tablename)
{
    $res = db_GetArray("SHOW TABLE STATUS LIKE '".mres($tablename)."'");

    return $res[0]['Data_length'];
}
function GetTableRows($tablename)
{
    return db_GetValue('SELECT COUNT(*) FROM '.$tablename);
}
function scmd($s)
{
    print '&nbsp;'.$s.'<br>';
    system($s);
}
function IsValidPhonenumber($phonenumber)
{
    //returns internation valid phonenumber. " 06 - 12 34  5 6 78 " is returned as "+31612345678"
    $is_valid_phonenumber = false;
    $is_international_phonenumber = false;

    //spaties (en tabs) weg
    $phonenumber = preg_replace("/\s/", '', $phonenumber);

    //streepjes weg
    $phonenumber = preg_replace("/\-/", '', $phonenumber);

    //(0) weg; voor +31 (0)6 12345678
    $phonenumber = preg_replace("/\(0\)/", '', $phonenumber);

    //leidende + weg
    $phonenumber = preg_replace("/^\+/", '', $phonenumber, -1, $count);
    if ($count > 0) {
        $is_international_phonenumber = true;
    }

    //2014-12-01 toegevoegd; alle niet nummers eruit
    $phonenumber = preg_replace("/\D/", '', $phonenumber);

    //leidende dubbele 0 weg
    $phonenumber = preg_replace('/^00/', '', $phonenumber, -1, $count);
    if ($count > 0) {
        $is_international_phonenumber = true;
    }

    //leidende enkele 0 weg
    $phonenumber = preg_replace('/^0/', '', $phonenumber);

    if ($is_international_phonenumber == false) {
	$DefaultPhoneNumberCountryCode = GetSetting('DefaultPhoneNumberCountryCode');
        //defaulteren naar Nederland
        if ($DefaultPhoneNumberCountryCode == '') {
            $DefaultPhoneNumberCountryCode = '31';
        }

        $phonenumber = $DefaultPhoneNumberCountryCode.$phonenumber;
        //NU is het phonenumber WEL international
        $is_international_phonenumber = true;
    }

    //een valide telefonnummer bestaat minimaal uit 4 (?) en maximaal uit 15 cijfers
    $min_length = 4;
    $max_length = 15;
    //dit is een Nederlands nummer
    if (preg_match('/^31/', $phonenumber)) {
        //landcode gevolgd door 9 nummers
        $min_length = 11;
        $max_length = 11;
    }

    if (preg_match("/^\d{".$min_length.','.$max_length.'}$/', $phonenumber)) {
        $is_valid_phonenumber = true;
        $phonenumber = '+'.$phonenumber;
    }

    if (!$is_valid_phonenumber) {
        //niks retourneren in 2e element van array
        $phonenumber = '';
    }

    return array($is_valid_phonenumber, $phonenumber);
}

function GetSystemDataStructure()
{
    $sds = unserialize(db_GetValue('SELECT datastructure FROM CRMdatastructures WHERE userid=0'));
    if (count($sds) == 0) {
        CreateSystemDataStructure();
        $sds = unserialize(db_GetValue('SELECT datastructure FROM CRMdatastructures WHERE userid=0'));
    }

    return $sds;
}
function CheckAndCreateSystemDataStructure()
{
    if (db_GetValue("SELECT COUNT(*) FROM CRMdatastructures WHERE userid=0 AND datastructure != ''") != 1) {
        CreateSystemDataStructure();
    }
}
function CreateSystemDataStructure()
{
    $curuser = false;

    if (!is_administrator()) {
        $curuser = $GLOBALS['USERID'];

        // Sudo to first admin
        $tmp = db_GetRow("SELECT id FROM CRMloginusers WHERE administrator='yes' AND active='yes'");

        InitUser($tmp['id']);
    }

    mcq("INSERT INTO CRMdatastructures(userid, datastructure) VALUES (0,'".mres(serialize(get_data_structure()))."') ON DUPLICATE KEY UPDATE userid=userid");

    if ($curuser) {
        InitUser($curuser);
    }
}

function InlineSimpleAddForm($table_id, $template_id, $submitbuttontext, $tagvals, $listtoreloadaftersubmit, $htmltemplate = '', $open_after_add = 0)
{
    if (!$GLOBALS['UC']['PersonalDataStructure'][$table_id]['allowed_to_add']) {
        return '<!-- not allowed '.$table_id.' //-->';
    } else {
        $template = '';
        if ($htmltemplate != '') {
            $template = $htmltemplate;
        } else {
            $template = GetTemplate($template_id);
        }

        $template = ParseTemplateLanguageTags($template);
        $elements = array();

        $tagvals['listtoreloadaftersubmit'] = $listtoreloadaftersubmit;


        preg_match_all('/#(.*?)#/', $template, $matches);

        foreach ($matches[1] as $field_name) {
            $field_id = '';
            if (substr($field_name, 0, 4) == 'EFID') {
                $field_id = 'f'.str_replace('EFID', '', $field_name);
            } elseif (substr($field_name, 0, 1) == 'f' && ipi(str_replace('f', '', $field_name))) {
                $field_id = $field_name;
            } elseif (substr($field_name, 0, 1) == 't' && count(explode("-", $field_name)) == 2) {
                list($dummy, $field_id) = explode("-", $field_name);
            }
            if ($field_id != '') {
                $element = '';
                if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table_id]["fields"][$field_id])) {
                    $element = '<div class="formfieldcontainer" id="ffc-'.$table_id.'-'.$field_id.'">'.get_form_element($table_id.'-'.$field_id, '', '', array('enter2blur'), true).'</div>';
                    $elements[] = $table_id.'-'.$field_id;
                }
                $template = str_replace('#'.$field_name.'#', $element, $template);
            }
        }

    //    $template = '<h1>Geparsed met PTRD</h1>' . ParseTemplateRecordData($template, $table_id, 0, 0);

        /*
            HF20170301
            the $elements array is (was) used to check whether or not a field was already shown in the template. if it was, it wouldn't be put in again as a hidden field. but that means we need template logic here which we don't want so we left in the check, but the array will always be empty. just don't put a field in both the template and as a given field in the tag.

            UPDATE: re-enabled everything the old way. PTRD places default values after submitting, it's just not compatible.
        */
        //$elements[] = array();


        if ($submitbuttontext == '') {
            $submitbuttontext = 'No submit button text set in INLINE form tag';
        }

        //in ff ging dit mis wanneer het een <button></button> was ZONDER type="button", daarom omgezet naar een standaard input tag
        //$submitbutton = '<button type="button" onclick="SubmitInlineForm(document.getElementById(\'' . $tagvals['outerdiv'] . '\'), \'' . $listtoreloadaftersubmit . '\',\'_new\')">' . htme($submitbuttontext) . '</button>';
        $submitbutton = '<input id="inlineadd-'.$table_id.'" onclick="
				if (general_form_submit(\'' .$tagvals['outerdiv'].'\', \'_new_\')) {
					SubmitInlineForm(document.getElementById(\'' .$tagvals['outerdiv'].'\'), \''.$listtoreloadaftersubmit.'\',\'_new_\', \''.$open_after_add.'\', \''.$table_id.'\');
					}
		" type="button" value="' .htme($submitbuttontext).'" class="addbutton">';

        $t = '';
        if ($htmltemplate == '') {
            $t = '<div class="inlineadddiv">';
        }
        $t .= $template;
        $extra = '';
        foreach ($tagvals as $name => $value) {
            if (!in_array($name, $elements) && $name != '') { // Don't put in hidden elements which were already shown in the template (DISABLED see above)
                //id=\"JS_" . htme($name) . "\"
                list($loctable, $locfield) = explode('-', $name);

                /* test if it's in de ds */
                if ($GLOBALS['UC']['PersonalDataStructure'][$loctable]['fields'][$locfield]) {
                    if ($name == $loctable.'-'.$locfield) {
                        $name .= '-_new_';
                    }
                    /* place field in form, hidden */
                    $extra .= '<input type="hidden" name="'.htme($name).''.'" id="JS_'.htme($name).''.'"  value="'.htme($value).'">';

                    /* place default value in form, it will be given back to this function after submit */
                    $extra .= '<input type="hidden" name="default_'.htme($name).''.'" id="JS_default_'.htme($name).''.'"  value="'.htme($value).'">';

                } elseif ($name == 'listtoreloadaftersubmit' || $name == 'table' || $name == '1BYAJAX' || $name == 'submitbuttontext' || $name == 'template' || $name == 'outerdiv' || $name == 'reload_on_submit') {
                    /* standard fields in this context */
                    $extra .= '<input type="hidden" name="'.htme($name).''.'" id="JS_'.htme($name).''.'"  value="'.htme($value).'">';

                } else {
                    /* ignore the rest */
                    //print "SKIP $name<br>";
                }
            }
        }
        if ($open_after_add == 1) {
            $extra .= '<input type="hidden" name="open_after_add" id="JS_open_after_add"  value="1">';
        }
        $t = str_replace('#SAVEBUTTON#', $submitbutton.$extra, $t);
        if ($htmltemplate == '') {
            $t .= '</div>';
        }
        return $t;
    }
}
function ParseTemplateCreateDefaultReportTags($template)
{
    // Fetch all tags from template
    preg_match_all('/#REPORT(.*?)#/', $template, $matches);

    // Loop through tags
    foreach ($matches[1] as $listoptions_string) {
	//exclude #REPORTICON#
	if ($listoptions_string != "ICON") {
    	    $listoptions = ConvertTagOptionsToListOptions($listoptions_string);
    	      //    $template = str_replace('#REPORT'.$listoptions_string.'#', escape_interleave_characters(CreateDefaultReport($listoptions['table'], $listoptions['reporttype'], $listoptions['filename'], $listoptions['linktext'], $listoptions, $listoptions['alldata'])), $template);

            /* HF20171107 dit gaat nu via een url (csv.php) waardoor deze parse functie eigenlijk wat overbodig is want je kan net zogoed
               de url zelf in je template zetten */
            $template = str_replace('#REPORT'.$listoptions_string.'#',"<a href='csv.php?GetDefaultReport&amp;table=" . $listoptions['table'] . "&amp;reporttype=" . $listoptions['reporttype'] . "&amp;filename=" . htme($listoptions['filename']) . "&amp;listoptions=" . htme($listoptions_string) . "&amp;alldata=" . htme($listoptions['alldata']) . "'>" . htme($listoptions['linktext']) . '</a>', $template);
	}
    }
    return $template;
}
function CreateDefaultReportAddChildTables($table, $outputtype, $alldata, $row) {

    foreach (array_keys($GLOBALS['UC']['PersonalDataStructure'][$table]['childs']) as $child_table) {
        if ($child_table != $table && $GLOBALS['UC']['PersonalDataStructure'][$child_table]["datatable"]) {
            foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]['childs'][$child_table] as $child_field) {
                $listoptionslocal = array();
                $listoptionslocal['table'] = $child_table;
                $listoptionslocal['outputtype'] = 'array';
                $listoptionslocal['type_of_list'] = 'sublist';
                $listoptionslocal['perpage'] = 0;
                // Flag as internal
                $listoptionslocal['internallistcall'] = true;
                $listoptionslocal['hiddenfilter'][$child_table.'-'.$child_field][] = $row[$table.'-'.$GLOBALS['UC']['PersonalDataStructure'][$table]['primary']];
                if ($alldata) {
                    $fields = array();
                    foreach ($GLOBALS['UC']['PersonalDataStructure'][$child_table]["fields"] AS $field => $props) {
                        $fields[] = $child_table . "-" . $field;
                    }
                    $listoptionslocal['listlayoutcolumns'] = implode(",", $fields);
                }

                $locallist = make_list($listoptionslocal);

                $localsheet = array('');

                if ($outputtype == 'excel') {
                    $localsheet[] = array('', '[[bold]]'.$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']);
                } elseif ($outputtype == 'json' || $outputtype == 'xml') {
                    //$json[$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']][$row[$child_table . '-' . $GLOBALS['UC']['PersonalDataStructure'][$child_table]['primary']]][$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']] = array();
                } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
                    $localsheet[] = array('', '[[mergerest]]<h2>'.htme($GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']).'</h2>');
                }

                // Add fields
                $header = array('');
                foreach ($locallist[0] as $f => $ig) {
                    if ($outputtype == 'excel') {
                        $header[] = '[[italic]]'.$GLOBALS['UC']['PersonalDataStructure'][$child_table]['fields'][str_replace($child_table.'-', '', $f) ]['name'];
                    } elseif ($outputtype == 'json' || $outputtype == 'xml') {
                        /* no header */
                    } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
                        $header[] = ''.$GLOBALS['UC']['PersonalDataStructure'][$child_table]['fields'][str_replace($child_table.'-', '', $f) ]['name'].'';
                    }
                }

                $localsheet[] = $header;
                $some_sheet = false;

                foreach ($locallist as $localrow) {
                    // Add emtpty first column (for layout puposes only -> not for JSON
                    if ($outputtype != 'json' && $outputtype != 'xml') {
                        array_unshift($localrow, '');
                    }
                    if ($outputtype == 'pdf' || $outputtype == 'html') {
                        foreach ($localrow AS $l1 => $l2) {
                            /* this also encodes raw html fields ... */
                            $localrow[$l1] = htme($l2);
                        }

                    } elseif ($outputtype == 'excel') {

                        foreach ($localrow AS $l1 => $l2) {
                            $localrow[$l1] = strip_tags($l2);
                        }

                    }

                    if ($outputtype == 'json' || $outputtype == 'xml') {
                        $ljson = array();
                        foreach ($localrow AS $name => $element) {


                            $fieldname = $GLOBALS['UC']['PersonalDataStructure'][$child_table]['fields'][str_replace($child_table.'-', '', $name)]['name'];
                            $ljson[$name] = array('Name' => $fieldname, 'Value' => strip_tags($element));

                        }
                        $json[$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']][$localrow[$child_table . '-' . $GLOBALS['UC']['PersonalDataStructure'][$child_table]['primary']]] = $ljson;

                    } else {
                        $some_sheet = true;
                        $localsheet[] = array_values($localrow);
                    }

                    if ($some_sheet) {
                        foreach ($localsheet AS $rowy) {
                            $sheet[] = $rowy;
                        }
                        $localsheet = array();
                    }

                    list($a, $b) = CreateDefaultReportAddChildTables($child_table, $outputtype, $alldata, $localrow);
                    foreach ($a AS $rowx) {
                        $sheet[] = array_merge(array(''), $rowx);
                    }
                    if (count($b) > 0) {


                        $i = 2;
                        foreach ($b AS $name => $child) {
                            if ($json[$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']][$localrow[$child_table . '-' . $GLOBALS['UC']['PersonalDataStructure'][$child_table]['primary']]][$name] != '') {
                                $name .= '_' . $i;
                                $i++;
                            }

                            $json[$GLOBALS['UC']['PersonalDataStructure'][$child_table]['plural']][$localrow[$child_table . '-' . $GLOBALS['UC']['PersonalDataStructure'][$child_table]['primary']]][$name] = $child;
                        }
                    } else {
                        //print 'skip add table '. $table . ' zero rows<br>';
                    }
                }
            }

        }
    }

    return array($sheet, $json);
}
function CreateDefaultReport($table, $outputtype = 'excel', $filename = 'download', $linktext = 'download report', $listoptions = array(), $alldata = false, $directoutput = false)
{


    if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table])) {

        if ($outputtype == 'json' || $outputtype == 'xml') {
            $sjon = array($GLOBALS['UC']['PersonalDataStructure'][$table]['plural']);
        }
        $listoptions['table'] = $table;
        $listoptions['outputtype'] = 'array';
        $listoptions['perpage'] = 0;
        // Flag as internal
        $listoptions['internallistcall'] = true;
        if ($alldata) {
            $fields = array();
            foreach ($GLOBALS['UC']['PersonalDataStructure'][$table]["fields"] AS $field => $props) {
                $fields[] = $table . "-" . $field;
            }
            $listoptions['listlayoutcolumns'] = implode(",", $fields);
        }

        $base = make_list($listoptions);

        $sheet = array();
        foreach ($base as $row) {
            // Add fields
            $header = array();
            foreach ($base[0] as $f => $ig) {
                if ($outputtype == 'excel') {
                    $header[] = '[[border-bottom]][[bold]]'.$GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][str_replace($table.'-', '', $f) ]['name'];
                } elseif ($outputtype == 'json' || $outputtype == 'xml') {
                    /* no header */
                } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
                    /* pdf and html */
                    $header[] = '<strong>'.htme($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][str_replace($table.'-', '', $f) ]['name']).'</strong>';
                }
            }
            $sheet[] = $header;

            $lrow = array();

            foreach ($row as $name => $element) {

                if ($outputtype == 'excel') {
                    $lrow[] = '[[fontsize16]]'.$element;
                } elseif ($outputtype == 'json' || $outputtype == 'xml') {
                    $fieldname = $GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][str_replace($table.'-', '', $name) ]['name'];

                    $json[$GLOBALS['UC']['PersonalDataStructure'][$table]['plural']][$row[$table . '-' . $GLOBALS['UC']['PersonalDataStructure'][$table]['primary']]][$name] = array('Name' => $fieldname, 'Value' => strip_tags($element));

                } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
                    /* this also encodes raw html fields ... */
                    $lrow[] = '<h1>'.htme($element).'</h1>';
                }
            }
            $sheet[] = $lrow;

            list($a, $b) = CreateDefaultReportAddChildTables($table, $outputtype, $alldata, $row);


            foreach ($a AS $rowx) {
                $sheet[] = $rowx;
            }

            foreach ($b AS $name => $child) {
                $json[$GLOBALS['UC']['PersonalDataStructure'][$table]['plural']][$row[$table . '-' . $GLOBALS['UC']['PersonalDataStructure'][$table]['primary']]][$name] = $child;
            }
            $sheet[] = array('');

        }


        if ($outputtype == 'excel') {
            //DA($sheet, false);
            //exit;
            $sheet[] = array('[[fittowidth]]');

            require_once 'excel2007.php';
            return RealExcel2007($sheet, "array", 'xlsx', '', $filename, !$directoutput);

        } elseif ($outputtype == 'pdf' || $outputtype == 'html') {
            $html = '';
            $html = '<table border=0>';
            $maxdepth = 0;
            foreach ($sheet as $line) {
                if (count($line) > $maxdepth) {
                    $maxdepth = count($line);
                }
            }
            foreach ($sheet as $line) {
                $cn = 0;
                $html .= '<tr>';
                $filled = false;
                foreach ($line as $col) {
                    $html .= '<td ';
                    if (strstr($col, '[[mergerest]]')) {
                        $html .= 'colspan="' . ($maxdepth - $cn) . '"';
                        $filled = true;
                        $col = str_replace('[[mergerest]]', '', $col);

                    }

                    $html .= '>'.($col).'</td>';
                    $cn++;
                }
                if (!$filled) {
                    for ($i=$cn;$i<$maxdepth;$i++) {
                        $html .= '<td></td>';
                    }
                }
                $html .= '</tr>';
            }

            $html .= '</table>';
            ;
            if ($outputtype == 'pdf') {
                $html = '<html><body>' . $html . '</body></html>';
                $pdf = HTML2PDF($html);

                if (strtolower(substr($filename, strlen($filename)-4, 4)) != ".pdf") $filename .= ".pdf";

                if ($directoutput) {
                    header("Content-Type: application/pdf");
                    header("Content-Disposition: attachment; filename=\"" . clean_filename($filename) . "\"");
                    print $pdf;
                } else {
                    return $pdf;
                }

            } else {
                $html = '<html><body>' . $html . '</body></html>';
                if ($directoutput) {
                    print $html;
                } else {
                    return $html;
                }
            }
        } elseif ($outputtype == 'json') {
            //DA($json, false);
            //exit;
            if ($directoutput) {
                header("Content-type: application/json; charset=UTF-8");
                print json_encode($json);
            } else {
                return json_encode($json);
            }

        }  elseif ($outputtype == 'xml') {



            // creating object of SimpleXMLElement
            $xml_data = new SimpleXMLElement('<?xml version="1.0"?><interleave></interleave>');

            // function call to convert array to xml
            array_to_xml($json,$xml_data);

            // print generated xml

            if ($directoutput) {
                header("Content-type: application/xml; charset=UTF-8");
                print $xml_data->asXML();
            } else {
                return $xml_data->asXML();
            }


        } else {
            return 'Unknown output type';
        }
    }
}
function array_to_xml( $data, &$xml_data ) {
    foreach( $data as $key => $value ) {
        if( is_numeric($key) ){
            $key = 'record_'.$key; //dealing with <0/>..<n/> issues
        }
        if( is_array($value) ) {
            $subnode = $xml_data->addChild($key);
            array_to_xml($value, $subnode);
        } else {
            $xml_data->addChild("$key",htmlspecialchars("$value"));
        }
     }
}
function html2plaintext($str)
{
    return html_entity_decode(strip_tags_to_space(br2nl($str)), ENT_QUOTES);
}
function ps2txt($ps_data)
{
    $result = '';
    $a_data = getDataArray($ps_data, '[', ']');
    if (is_array($a_data)) {
        foreach ($a_data as $ps_text) {
            $a_text = getDataArray($ps_text, '(', ')');
            if (is_array($a_text)) {
                foreach ($a_text as $text) {
                    $result .= substr($text, 1, strlen($text) - 2);
                }
            }
        }
    } else {
        // the data may just be in raw format (outside of [] tags)
        $a_text = getDataArray($ps_data, '(', ')');
        if (is_array($a_text)) {
            foreach ($a_text as $text) {
                $result .= substr($text, 1, strlen($text) - 2);
            }
        }
    }

    return $result;
}
function GetFieldTypes()
{
    $ft = array('', 'diary', 'drop-down', 'drop-down (multiselect)', 'drop-down (populate by code)', 'drop-down (populate by code multiselect)', 'checkbox', 'textbox', 'text area', 'text area (rich text)', 'numeric', 'mail', 'hyperlink', 'comment', 'date', 'date (iso)', 'date/time', 'Button', 'SQL Query', 'SQL Query (multiselect)', 'Reference to FlexTable', 'Reference to FlexTable (multiselect)', 'User-list of all CRM-CTT users', 'List of all groups', 'color', 'phone number');

    foreach (GetProfiles() as $profile) {
        $ft[] = 'Users of profile '.$profile['id'];
    }

    return $ft;
}
function CheckExtraFieldAccess($field_id)
{
    $access = 'nok';
    $table = '';
    $field = '';

    if (ipi($field_id)) {
        $table = get_ds_tablename_for_field($field_id);
        $field = 'f'.$field_id;
    } else {
        $table = GetExtraFieldTableType($field_id);
        $field = $field_id;
    }
    if (is_array($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field])) {
        if ($GLOBALS['UC']['PersonalDataStructure'][$table]['fields'][$field]['allowed_to_write']) {
            $access = 'ok';
        } else {
            $access = 'readonly';
        }
    }

    return $access;
}
function normal_chars($string = '', $is_filename = true)
{
    // Replace all weird characters with dashes
    $string = preg_replace('/[^\w\-'.($is_filename ? '~_\.' : '').']+/u', '-', $string);

    $string = str_replace(':', '-', $string);
    // Only allow one dash separator at a time
    return preg_replace('/--+/u', '-', $string);
}
function ipi($i)
{
    return is_positive_integer($i);
}
function GetDownloadFileNameForTable($tablename)
{

    // Deze functie moet nog uitgebreid worden met nettere namen voor tabellen anders dan flextables
    // Default filename
    $default = str_replace(' ', '_', GetSetting('title')).'-'.$GLOBALS['PRODUCT'].'-export-'.date('m-j-Y-Hi').'h';

    if ($tablename == 'user') {
        return $default;
    } elseif ($tablename == 'group') {
        return $default;
    } else {
        $t = str_replace('t', '', $tablename);
        if (ipi($t)) { // flextable
            $at = GetAttribute('flextable', 'FilenameForDownloadsTemplate', $t);
            if ($at != '') {
                return unescape_interleave_characters(ParseTemplateGeneric(EvaluateTemplatePHP($at)));
            } else {
                return $default;
            }
        } else { // One of the other system tables
            return $default;
        }
    }
}
function DisplayFileList($record, $table)
{
    $dstable = '';
    if (ipi($table)) {
        $dstable = 't'.$table;
    } elseif (ipi(str_replace('t', '', $table))) { // ds-style table id
        $table = str_replace('t', '', $table);
        $dstable = 't'.$table;
    } elseif ($table == 'generalpurpose') {
        $dstable = 'generalpurpose';
    } elseif ($table == 'system') {
        $dstable = 'system';
    } else {
        return 'Unable to determine table type ('.htme($table).')';
    }

    $folder = 0;
    if (ipi($_REQUEST['folder'])) {
        $folder = $_REQUEST['folder'];
    }

    return list_filebox($dstable, $record, $folder);
}

function FileUploadBox($table, $record, $folder = 0, $disable_versioning = false)
{
    global $lang;

    $ds_tablename = '';
    $binfiles_tablename = '';
    if (ipi($table)) {
        $ds_tablename = 't'.$table;
        $binfiles_tablename = 'flextable'.$table;
    } elseif (ipi(str_replace('t', '', $table))) { // ds-style table id
        $table = str_replace('t', '', $table);
        $ds_tablename = 't'.$table;
        $binfiles_tablename = 'flextable'.$table;
    } elseif ($table == 'generalpurpose') {
        $ds_tablename = 'generalpurpose';
        $binfiles_tablename = $ds_tablename;
    } elseif ($table == 'public') {
        $ds_tablename = 'public';
        $binfiles_tablename = $ds_tablename;
    } elseif ($table == 'system') {
        $ds_tablename = 'system';
        $binfiles_tablename = $ds_tablename;
    } else {
        return 'Unable to determine table type ('.htme($table).')';
    }
    $suffix = '-'.$ds_tablename;

    // Return nothing if the user has no access to the record
    if (!CheckIfAttachingIsAllowed($record, $ds_tablename)) {
        return '';
    }
    /*

    <input type="file" accept="image/*" capture="camera">
    */

    /* HF20170102 we uploaden niet automatisch wanneer er velden zijn die verplicht zijn. als alle velden *NIET* verplicht zijn uploaden we *WEL* */
    $automatically_upload = true;
    foreach ($GLOBALS['UC']['PersonalDataStructure']['files']['fields'] as $name => $field) {
        if ($field['fieldtype_in_extrafields_table'] != '' && $field['allowed_to_write'] == true && $field['required'] == true) {
            $automatically_upload = false;
        }
    }

    $str = '';

//    $str .= '<input type="button" id="JS_uploadbutton' . $suffix . '" onclick="$(\'#JS_file_upload'.$suffix.'\').trigger(\'click\');" value="' . htme($lang['attachfile']) . '">';

    /*
    $str .= "<script>
    $('#JS_uploadbutton" . $suffix . "').on(
        'dragover',
        function(e) {
            e.preventDefault();
            e.stopPropagation();
        }
    )
    $('#JS_uploadbutton" . $suffix . "').on(
        'dragenter',
        function(e) {
            e.preventDefault();
            e.stopPropagation();
        }
    )
    $('#JS_uploadbutton" . $suffix . "').on(
    'drop',
    function(e){
        if(e.originalEvent.dataTransfer){
            if(e.originalEvent.dataTransfer.files.length) {
                e.preventDefault();
                e.stopPropagation();
                //UPLOAD FILES HERE
                //upload(e.originalEvent.dataTransfer.files);
                console.log(e.originalEvent.dataTransfer.files);
                $('#JS_file_upload".$suffix."').val(e.originalEvent.dataTransfer.files);
            }
        }
    }
);
    </script>";
*/

    //$str .= '    <!-- <div class="fileUpload btn btn-primary">    <span>' . htme($lang['attachfile']) . '</span> //-->';

    $str .= '<div class="hide_contentNIET"><input type="file" name="file_upload[]" class="upload" id="JS_file_upload'.$suffix.'" multiple="multiple"';


    // accept="image/*" capture="camera"'
    $onchange = '';
    if (count(GetExtraFilesFields()) == 0 || $automatically_upload) {
        if ($record !== '_new_') {
            $onchange .= ' upload_files("'.$suffix.'");';
        } else {
            //	print "err record $record";
        }
    } else {
        //	print "err count " . count(GetExtraFilesFields());
    }
    if ($onchange != '') {
        $str .= ' onchange=\''.$onchange.'\'';
    }
    $str .= '></div>';
    //<!-- </div> //-->';

/*
    $str .=' <style>

.fileUpload {
    position: relative;
    overflow: hidden;
    margin: 10px;
}
.fileUpload input.upload {
    position: absolute;
    top: 0;
    right: 0;
    margin: 0;
    padding: 0;
    font-size: 20px;
    cursor: pointer;
    opacity: 0;
    filter: alpha(opacity=0);
}
</style>';
*/

    if (!$disable_versioning) {
        $str .= '<input type="hidden" name="file_VersionTypeChanged'.$suffix.'" id="JS_file_VersionTypeChanged" value="no">';

    }
    $str .= '<input type="hidden" name="file_table" id="JS_file_table'.$suffix.'" value="'.htme($ds_tablename).'">';
    $str .= '<input type="hidden" name="file_record" id="JS_file_record'.$suffix.'" value="'.htme($record).'">';

    if (!$disable_versioning && GetSetting('ENABLEFILEVERSIONING') == 'Yes' && $record != '_new_' && db_GetValue("SELECT COUNT(*) FROM CRMbinfiles WHERE type='".$binfiles_tablename."' AND koppelid='".mres($record)."'") > 0) {

        $str .= " <select id='JS_file_NewOrNewVersionOf".$suffix."' name='file_NewOrNewVersionOf' onchange=\"document.forms['UploadFile'].elements['VersionTypeChanged'].value='yes'\"><option value='match' selected>Match by filename</option><option value='new_file'>New file</option>";

        $str .= '</select>';
    } else {
        $str .= ' ';
    }
    $str .= '<div id="upload_files_efids'.$suffix.'" class="showinline">';
    $automatically_upload = true;
    foreach ($GLOBALS['UC']['PersonalDataStructure']['files']['fields'] as $name => $field) {
        if ($field['fieldtype_in_extrafields_table'] != '' && $field['allowed_to_write'] == true) {
            $str .= get_form_element('files-'.$name, '', '_new_', array(), true, false, '');
            if ($field['required'] == 1) {
                $automatically_upload = false;
            }
        }
    }
    $str .= '</div>';

    if ($record === '_new_') {
    } else {
        if (count(GetExtraFilesFields()) > 0) {
            $str .= '<input type="button" class="uploadbutton addbutton" onclick="upload_files(\''.$suffix.'\');" value="'.htme($lang['go']).'">';
        }
        $str .= '<progress id="JS_uploadprogress'.$suffix.'" class="uploadprogress"></progress>';
    }

    $mic = '';
    $vid = '';

    if (ipi($record) && GetSetting('DevelopmentOrProduction') == 'Development') {

        /* dit werkt en is in principe klaar voor productie */
        $mic = '&nbsp;<a onclick="PopFancyBoxSmall(\'\', \'audio.php?table='.$ds_tablename.'&amp;record='.$record.'&amp;nonavbar=1\');"><span class="fa fa-microphone" aria-hidden="true"></span></a>';

        /* dit nog niet!! */
        //$vid = '&nbsp;<a onclick="PopFancyBox(\'\', \'video.php?table='.$ds_tablename.'&amp;record='.$record.'&amp;nonavbar=1\');"><span class="fa fa-camera" aria-hidden="true"></span></a>';
    }

    return '<div class="uploadfiles" id="JS_uploadfiles'.$suffix.'">'.$str.$mic.$vid.'</div>';
}

function SaveFiles($files_array, $record, $table, $folder, $nv_type = 'match', $newfolder = '', $skip_security = false, $newdocument='')
{
    /* HF20161120 Starting today this function is fed with a DS-tablename! */
    if (!ipi($folder)) {
        $folder = 0;
    }

    $binfiles_tablename = '';

    if (ipi(str_replace('t', '', $table))) {
        $binfiles_tablename = 'flextable'.str_replace('t', '', $table);
    } else {
        $binfiles_tablename = $table;
    }

    if ($newfolder != '') {
        // CreateFolder is secured, no need to check security here
        $num = CreateFolder($record, $binfiles_tablename, $newfolder, $folder);
        /*
        if (!is_positive_integer($folder)) {
        $folder = PushStashValue(array($num));
        } else {
        $path = PopStashValue($folder);
        $path[] = $num;
        UpdateStashValue($folder, $path);
        }
        */
        $folder = $num;
    } elseif ($newdocument != '') {
        /* a call to create a new, empty document */

        $contents = 'This Interleave document is currently empty.';

        /* check to see if there is a setting for a template */
        $TemplateForNewEmptyInterleaveDocuments = GetAttribute("flextable", "TemplateForNewEmptyInterleaveDocuments", str_replace("t", "", $table));
        if (ipi($TemplateForNewEmptyInterleaveDocuments)) {
            $contents = '<style>' . GetTemplate(GetTemplateStyleSheet($TemplateForNewEmptyInterleaveDocuments)) . '</style>';
            $contents .= ParseTemplateGeneric(GetTemplate($TemplateForNewEmptyInterleaveDocuments));
            $contents = ParseTemplateRecordData($contents, $table, $record);
            $contents = replace_images_for_pdf_and_mails($contents, 'pdf');
        } else {
            $contents = DisplayCSS(true, false) . $contents;
        }
        AttachFile($record, $newdocument . '.interleave', $contents, $binfiles_tablename, 'text/html', '', false, false, $folder, false);
    }

    $num_of_files = count($files_array['name']);

    for ($y = 0; $y < $num_of_files; ++$y) {
        if (filesize($files_array['tmp_name'][$y]) > 0) {
            // New version of file id.
            $nv = 0;

            // nv_type can be "match" or "new_file", latter is ignored
            if ($nv_type == 'match') {
                // Reset file_NewOrNewVersionOf when count > 1 (useless)
                // or when access is not allowed for some reason (should be impossible at the moment)
                $nv = db_GetValue("SELECT fileid FROM CRMbinfiles WHERE filename='".mres($files_array['name'][$y])."' AND koppelid='".mres($record)."' AND type='".$binfiles_tablename."' AND (version_belonging_to=0 OR version_belonging_to=fileid) AND folder='".$folder."'");
            }

            $x = AttachFile($record, $files_array['name'][$y], file_get_contents($files_array['tmp_name'][$y]), $binfiles_tablename, $files_array['type'][$y], '', false, false, $folder, $skip_security);


            if (ipi($x)) { // Attaching succesful
                // Check fields
                //foreach (GetExtraFilesFields() AS $files_arrayle_efid) {
                foreach ($GLOBALS['UC']['PersonalDataStructure']['files']['fields'] as $name => $field) {
                    if ($field['fieldtype_in_extrafields_table'] != '') {
                        $post_name = 'files-'.$name.'-_new_';
                        if (isset($_POST[$post_name])) {
                            $value = $_POST[$post_name];

                            if ($field['dateformat'] == 'dd-mm-yyyy' && $value != '') {
                                $value = FormattedDateToNLDate($value);
                            } elseif ($field['fieldtype_in_extrafields_table'] == 'date/time') {
                                if ($value == '') {
                                    $value = '0000-00-00 00:00:00';
                                }
                            }

                            $ar = ValidateFieldInputDataStructureOnly($name, $value, true, $x);
                            if ($ar[0] == 'nok') {
                                // input denied
                                // delete uploaded file
                                DeleteFile($x, true);
                                $x = false;

                                break;
                            } else {
                                if ($ar[2] != '') {
                                    $value = $ar[2];
                                }
                                /* WATCH OUT: call update_field_value with BYPASS-SECURITY=true
                                 * this because the file record is already saved by AttachFile so
                                 * access rules based on calculations could already apply causing
                                 * access to be redrawn already */
                                update_field_value('files-'.$name, $x, $value, true, false, '');
                            }
                        }
                    }
                }
                if (ipi($nv) && GetSetting('ENABLEFILEVERSIONING') == 'Yes') {
                    // This is not an ordinary new file, it's a new version of an existing file!
                    // The new file will have 'version_belonging_to' = 0, but the version must be set and all earlier
                    // files must be made child of this one.
                    $t = db_GetRow("SELECT version_no FROM CRMbinfiles WHERE fileid='".mres($nv)."'");
                    $newversion = $t[0] + 1;
                    mcq('UPDATE CRMbinfiles SET version_belonging_to='.$x.", timestamp_last_change=timestamp_last_change WHERE version_belonging_to='".mres($nv)."'");
                    mcq('UPDATE CRMbinfiles SET version_belonging_to='.$x.", timestamp_last_change=timestamp_last_change WHERE fileid='".mres($nv)."'");
                    mcq('UPDATE CRMbinfiles SET version_no='.$newversion.", version_belonging_to=0, timestamp_last_change=timestamp_last_change WHERE fileid='".$x."'");
                }
                $ftf = array("files-fileid");
                foreach ($GLOBALS['UC']['PersonalDataStructure']['files']['fields'] as $name => $field) {
                    $ftf[] = "files-" . $name;
                }
                $localrecord = getrecord("files", $x, false, false, $ftf);

                Processrules("files", $x, '', 'added', '', false);
            } else {
                // Access denied
                //print "ACCESS DENIED";
            }
        }
    }

    return $folder;
}

function RecordStatusChart($ds_tablename, $record, $ds_fieldname, $exclude)
{
    $me = 'index.php?nonavbar=1&amp;FieldHistory&amp;table='.$ds_tablename.'&amp;record='.$record.'&amp;field='.$ds_fieldname;

    foreach ($exclude as $x) {
        $me .= '&amp;exclude[]='.htme($x);
    }
    $fieldid = 0;
    if (ipi(str_replace('f', '', $ds_fieldname))) {
        $fieldid = str_replace('f', '', $ds_fieldname);
    } else {
        $fieldid = $ds_fieldname;
        /* extreem goor allemaal */
        if (substr($fieldid, 0, 4) == 'EFID') {
            $ds_fieldname = 'f'.str_replace('EFID', '', $fieldid);
        }
    }
    if (CheckTableRecordAccess($ds_tablename, $record) != 'nok' && is_array($GLOBALS['UC']['PersonalDataStructure'][$ds_tablename]['fields'][$ds_fieldname])) {
        $dj_tablename = '';
        if ($ds_tablename == 'users') {
            $dj_tablename = 'user';
        } elseif (ipi(str_replace('t', '', $ds_tablename))) {
            $dj_tablename = str_replace('t', '', $ds_tablename);
        }
        $dj_fieldname = '';
        $text_fieldname = '';
        if (ipi(str_replace('f', '', $ds_fieldname))) {
            $dj_fieldname = str_replace('f', '', $ds_fieldname);
            $text_fieldname = GetExtraFieldName($dj_fieldname);
        } else {
            $dj_fieldname = $ds_fieldname;
            $text_fieldname = $ds_fieldname;
        }
        $sqle = $exclude;
        array_walk($sqle, 'mres');
        $sql_exclude = " AND CRMdatajournal.to_val NOT IN ('".implode("','", $sqle)."')";
        $sql_record = '';

        if (ipi($record)) {
            $sql_record = " AND record='".mres($record)."'";
        } else {
            exit;
        }

        $sql = "
		        SELECT  to_val,
                    DATE(timestamp_last_change) AS next_change,
                    IFNULL(
                        (SELECT DATE(timestamp_last_change) FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )
                        ,DATE(NOW())
                    ) AS date_change,
                    IFNULL(-1*DATEDIFF(timestamp_last_change, (SELECT timestamp_last_change FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )),-1*(DATEDIFF( timestamp_last_change, NOW()))
        ) AS days_value_active FROM CRMdatajournal WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."'  ORDER BY id DESC
		      ";

        //	print $sql;
        $bak = db_GetArray($sql);

	$ret = '';
	$ret .= '<table class="crm">';
        $ret .= '<thead><tr><th>'.htme($text_fieldname).'</th><th>From</th><th>To</th><th class="num">Days</th><th>Hide</th></tr></thead>';
        foreach ($bak as $line) {
            $ret .= '<tr>';
            $ret .= '<td>'.$line[0].'</td>';
            $ret .= '<td>'.$line[1].'</td>';
            $ret .= '<td>'.$line[2].'</td>';
            $ret .= '<td class="num">'.$line[3].'</td>';
            if (in_array($line[0], $exclude)) {
                $ret .= '<td><a href="'.str_replace('&amp;exclude[]='.htme($line[0]), '', $me).'">show</a></td>';
            } else {
                $ret .= '<td><a href="'.$me.'&amp;exclude[]='.htme($line[0]).'">hide</a></td>';
            }
	    $ret .= '</tr>';
        }

        $sql = "
		SELECT to_val, DATE(timestamp_last_change) AS next_change, IFNULL((SELECT DATE(timestamp_last_change) FROM CRMdatajournal a WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 ),DATE(NOW())) AS date_change, IFNULL(-1*DATEDIFF(timestamp_last_change, (SELECT timestamp_last_change FROM CRMdatajournal a WHERE `table`='".$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."' AND a.id > CRMdatajournal.id ORDER BY a.id LIMIT 1 )),-1*(DATEDIFF(
					timestamp_last_change, NOW()
				))) AS days_value_active FROM CRMdatajournal WHERE `table`='" .$dj_tablename."' ".$sql_record." AND field='".$dj_fieldname."'  ".$sql_exclude.' ORDER BY id DESC
		';
        $bak = db_GetArray($sql);

        $ret .= '</table>';

        $ret .= '<br><div id="fieldhistory" style="width: 800px; height: 400px;"></div><br>';
        $ret .= '<script type="text/javascript">';
        $ret .= "
		// THE CHART
		$('#fieldhistory').highcharts({
			chart: {
				type: 'xrange'
			},
			legend: {
					enabled: false
				},
			title: {
					 text: '" .EscapeSQ($text_fieldname)."',
					 x: -20
				  },
			 credits: {
					enabled: false
				},
			tooltip: {
				enabled: false
			},
			xAxis: {
				type: 'datetime',
			},
			yAxis: {
				categories: [";
        //		'Prototyping', 'Development', 'Testing'\
        $nf = false;
        $s = array();
        $sc = 0;
        foreach ($bak as $row) {
            if (!array_key_exists($row[0], $s)) {
                if ($nf) {
                    $ret .= ',';
                }
                $ret .= "'".$row[0]."'";
                $s[$row[0]] = $sc;
                ++$sc;
                $nf = true;
            }
        }
        $ret .= '],
				min: 0,
				max: ' .(count($s) - 1)."
			},
			series: [{
				borderRadius: 2,
				height: 0.25,

				name: '" .$text_fieldname."',
				data: [
				";
        $nf = false;
        foreach ($bak as $row) {
            if ($nf) {
                $ret .= ',';
            }
            $ret .= "{\n";
            $ret .= 'x: Date.UTC('.substr($row['next_change'], 0, 4).', '. 1 * substr($row['next_change'], 5, 2).', '. 1 * substr($row['next_change'], 8, 2)."),\n";

            if ($row['next_change'] == $row['date_change']) {
                $row['date_change'] = date('Y-m-d', strtotime($row['next_change'].' +1 day'));
            }
            $ret .= 'x2: Date.UTC('.substr($row['date_change'], 0, 4).', '. 1 * substr($row['date_change'], 5, 2).', '. 1 * substr($row['date_change'], 8, 2)."),\n";

            $ret .= 'y: '.$s[$row['to_val']]."\n";

            $ret .= '}';
            $nf = true;
        }
        $ret .= '
				]
			}]

		});
		</script>';

        $title = $text_fieldname;
        $subtitle = 'time spent in days';
        $type = 'pie';
        $height = '400px';
        $width = '800px';
        ;
        $series = array();
        foreach ($bak as $key => $value) {
            $series[$value['to_val']] = $value['days_value_active'];
        }

        return $ret.CreateHighChartNEW($title, $subtitle, $series, $type, $height, $width);
    } else {
        printAD('Access denied');
      //: field " . $ds_fieldname . " in table " . $ds_tablename . " is not accessible");
    }
}
function GetPDFReport($templateid, $table, $record)
{
    $template = '';
    $filename = '';

    $filename = GetTemplateSubject($templateid);

    /* a file name could contain @AUTO@ which should b eparsed to the default record layourt */
    $autofilename = get_refer_layout_for_record($table, $record);

    $filename = str_replace('@AUTO@', $autofilename, $filename);

    $filename = clean_filename(html2plaintext(get_parsed_template_with_given_template($table, $record, array(), '', false, '', $filename, 'TEMPLATE_PLAIN')));

    if ($table != '' && ipi($record)) {

        /* we have a record and a table; we need to parse against them */
        $passthru = array();
        $passthru['template_to_use'] = $templateid;
        $template = get_parsed_template($table, $record, $passthru, false, false, 'ok');

    } else {

        if ($template = GetTemplate($templateid)) {
            /* nothing */
        } else {
            $template = 'Template access denied or non-existent.';
        }



        /* actually parse the template here but because we don't know a record or a table we parse it only for generic tags */
        $template = get_parsed_template_with_given_template('', '', array(), '', false, '', $template, 'TEMPLATE_PLAIN');
    }

    /* nasty but ok; we don't know if the extension is correctly set in the template name */
    if (strtolower(substr($filename, strlen($filename) - 4, 4)) != '.pdf') {
        $filename .= '.pdf';
    }

    /* add stylesheet */
    $stylesheet = ReturnTemplateStyleSheet($templateid);

    $orientation = 'P';
    if (db_GetValue("SELECT orientation FROM CRMtemplates WHERE templateid='" . $templateid . "'") == 'L') {
        $orientation = 'L';
    }

    /* pass to pdf create functiion */
    return get_pdf_report_with_given_template($template, $stylesheet, $filename, $orientation);
}


function get_pdf_report_with_given_template($template, $stylesheet, $filename, $orientation = 'P')
{
    /* create full html document */
    $html = '';
    $html .= '<!DOCTYPE html><html><head><meta charset="UTF-8">';

    /* the stylesheet already has style header & footer */
    $html .= $stylesheet;
    $html .= "</head><body>\n".$template."\n</body>\n</html>\n";

    /* now parse the DOM */

    list($html, $tmpfiles) = replace_images_for_pdf_and_mails($html, "pdf");

    require_once 'lib/mpdf/vendor/autoload.php';

    $mpdf = new \Mpdf\Mpdf([
         'mode' => 'utf-8',
         'orientation' => $orientation,
         'tempDir' => GetSetting("TMP_FILE_PATH"),
    ]);

    if (GetSetting("SecurePDFsWithRandomPassword") != "No") {
        $mpdf->SetProtection(array('copy','print', 'print-highres'));
    }
    $mpdf->SetDisplayMode('fullpage');
    $mpdf->WriteHTML($html);

    $pdf = $mpdf->Output($filename, \Mpdf\Output\Destination::STRING_RETURN);

    foreach ($tmpfiles as $ftd) {
        unlink($ftd);
    }

    return array('filename' => $filename, 'pdf' => $pdf);
}
function clean_filename($filename)
{
    $filename = mb_ereg_replace("([^\w\s\d\-_~,;\[\]\(\).])", '', $filename);
    // Remove any runs of periods (thanks falstro!)
    $filename = mb_ereg_replace("([\.]{2,})", '', $filename);

    return $filename;
}
class SaferScript
{

    public $source, $allowedCalls;

    public function SaferScript($scriptText)
    {
        $this->source = $scriptText;
        $this->allowedCalls = array();
    }

    public function allowHarmlessCalls()
    {
        $this->allowedCalls = array('php', 'print', 'CustomerRFCiFrameAuthenticated', 'date', 'GetGroup', 'db_GetValue', 'mres', 'echo', 'htme', 'GetGroupName', 'db_GetArray', 'explode', 'ksort', 'str_pad', 'STR_PAD_LEFT', 'krsort', 'break', 'error_reporting', 'E_ALL', 'exit', 'str_replace', 'strlen', 'trim', 'substr', 'array_keys', 'CreateHighChart', 'CreateHighChartNEW', 'Vereniging', 'print_r', 'mcq', 'db_GetFlatArray', 'db_GetRow', 'db_GetInsertId', 'is_numeric', 'base64_encode', 'htmlspecialchars', 'GetUserName', 'NLDate2INTLDate', 'TransformDate', 'CreateHighChartFromSQL', 'CreateHighChartFromSQLNEW', 'false', 'true', 'ReturnDropDownSearchField', 'strtoupper', 'DA', 'count', 'PrintAD', 'strstr', 'UpdateDiaryField', 'RealMail', 'ShowHeaders', 'implode', 'header', 'fillout', 'round', 'strtotime', 'disable_mysql_triggers', 'enable_mysql_triggers', 'in_array', 'GetAttribute', 'GetSetting', 'filesize', 'FormatNumber', 'function', 'UpdateFT7', 'return', 'is_positive_integer', 'ob_start', 'PHT', 'ob_get_contents', 'ob_end_clean', 'ipi', 'GetTemplate', 'unescape_interleave_characters', 'ParseTemplateGeneric', 'ParseTemplateRecordData', 'db_Getrow', 'ord', 'ucwords', 'ParseTemplateLanguageTags', 'ReturnTemplateStyleSheet', 'ParseTemplateListTags', 'GetTemplateSubject', 'AttachFile', 'unserialize', 'base64_decode', 'CheckTableRecordAccess', 'HTML2PDF', 'html2plaintext', 'clean_filename');
    }

    public function parse()
    {
        $tokens = array();
        $this->parseErrors = array();
        $vcall = '';

        foreach ($tokens as $token) {
            if (is_array($token)) {
                $id = $token[0];
                switch ($id) {
                case T_VARIABLE:
                    {$vcall .= 'v';
                        break;
                    }
                case T_STRING: {
                        $vcall .= 's';
                    }
                case T_REQUIRE_ONCE:
                case T_REQUIRE:
                case T_NEW:
                case T_RETURN:
                case T_BREAK:
                case T_CATCH:
                case T_CLONE:
                case T_EXIT:
                case T_PRINT:
                case T_GLOBAL:
                case T_ECHO:
                case T_INCLUDE_ONCE:
                case T_INCLUDE:
                case T_EVAL:
                case T_FUNCTION: {
                        if (array_search($token[1], $this->allowedCalls) === false) {
                            $this->parseErrors[] = 'illegal call: '.$token[1];
                        }
                    }
                }
            } else {
                $vcall .= $token;
            }
        }

        if (stristr($vcall, 'v(') != '') {
            $this->parseErrors[] = array('illegal dynamic function call');
        }

        return $this->parseErrors;
    }

    public function execute($parameters = array())
    {
        foreach ($parameters as $k => $v) {
            $$k = $v;
        }
        if (sizeof($this->parseErrors) == 0) {
            eval($this->source);
        } else {
            print 'cannot execute, script contains errors';
        }
    }
}
function InitUser($user = 0)
{
    global $lang;

    // Drop all cache currently in memory, excluding ['UC']

    //jh 2017-08-29 we do not drop settings from memory because they cannot be changed; only PageCache is removed
    //ClearAllRunningCache();
    unset($GLOBALS['PageCache']);

    $GLOBALS['UC'] = array();

    if ($user == 0) {
        $user = $GLOBALS['USERID'];
    } else {
        $GLOBALS['USERID'] = $user;
    }

    //the language pack is already loaded by initiate.php, but we need to reload it if the user is switched (via rules or cron, etc.)
    //$lang = do_language();

    $GLOBALS['SesMem'] = array();
    if ($user == $GLOBALS['USERID']) {
        // Fetch session cache
        $GLOBALS['SesMem'] = unserialize(db_GetValue("SELECT sessioncache FROM CRMsessions WHERE temp='".mres($GLOBALS['sessionid'])."'"));
    } else {
        // The user being loaded is not the user actually owning this session, so un-set SesMem
        $GLOBALS['SesMemDontCommit'] = true;
    }

    if ((is_administrator()) || (GetSetting('DevelopmentOrProduction') == 'Development')) {
        // Check if debug must be enabled
        if (isset($_GET['debug'])) {
            $GLOBALS['SesMem']['debug'] = true;
        } elseif (isset($_GET['nodebug'])) {
            $GLOBALS['SesMem']['debug'] = false;
        }

      // Check if reasons for access must be shown
      if (isset($_GET['reasons'])) {
          $GLOBALS['SesMem']['ShowReasons'] = true;
      } else if (isset($_GET['noreasons'])) {
          $GLOBALS['SesMem']['ShowReasons'] = false;
      }
    }
    else
    {
	$GLOBALS['SesMem']['debug'] = false;
	$GLOBALS['SesMem']['ShowReasons'] = false;
    }

    $user_record = db_GetRow('SELECT `name`, `PROFILE`, `TRACE` FROM `CRMloginusers` WHERE `id`='.$user);
    //TODO dubbel
    $GLOBALS['username'] = $user_record['name'];
    $GLOBALS['USERNAME'] = $user_record['name'];
    $GLOBALS['name'] = $user_record['name'];

    //TODO dubbel
    $GLOBALS['GROUPID'] = $user_record['PROFILE'];
    $GLOBALS['UC']['GROUP'] = $user_record['PROFILE'];
    $GLOBALS['UC']['USERPROFILE'] = $user_record['PROFILE'];
    $GLOBALS['GROUP'] = $user_record['PROFILE'];
    $GLOBALS['USERPROFILE'] = $user_record['PROFILE'];

    $GLOBALS['UC']['PERSONALTRACE'] = $user_record['TRACE'];

    $GLOBALS['UC']['DateFormat'] = GetSetting('DateFormat');
    $localDF = GetAttribute('user', 'DateFormat', $user);
    if (($localDF != '') && ($localDF != '{{system}}')) {
        $GLOBALS['UC']['DateFormat'] = $localDF;
    }

    CheckAndCreateSystemDataStructure();
    $GLOBALS['UC']['PersonalDataStructure'] = unserialize(db_GetValue("SELECT `datastructure` FROM `CRMdatastructures` WHERE `userid`='".$GLOBALS['USERID']."'"));
    if (!is_array($GLOBALS['UC']['PersonalDataStructure'])) {
        $GLOBALS['UC']['PersonalDataStructure'] = get_data_structure();
        //ON DUPLICATE voor het geval dat via een andere sessie de DS inmiddels al aangemaakt is
        mcq('INSERT INTO `CRMdatastructures` (`userid`, `datastructure`) VALUES ('.$GLOBALS['USERID'].", '".mres(serialize($GLOBALS['UC']['PersonalDataStructure']))."') ON DUPLICATE KEY UPDATE `userid`=`userid`");
    }

    if (isset($_REQUEST['Blur'])) {
        $GLOBALS['SesMem']['Blur'] = true;
    } elseif (isset($_REQUEST['Unblur']) || isset($_REQUEST['Noblur'])) {
        $GLOBALS['SesMem']['Blur'] = false;
    }
}
function get_datamanagement_nav_items()
{
    $navs = array();
    $navs[] = array('dedup.php', 'De-duplicate records');
    $navs[] = array('admin.php?FindAndReplace', 'Find &amp; replace');
    $navs[] = array('admin.php?DropAllCache=1&amp;datman=1', 'Drop all cache');
    $navs[] = array('admin.php?RecalculateCalculations=1', 'Recalculate calculations');
    $navs[] = array('admin.php?RunCompression=1', 'Compress old versions and old files');
    $navs[] = array('admin.php?ArchiveLog', 'Archive table data');
    $navs[] = array('admin.php?MailQueueManager', 'Manage mail queue');
    $navs[] = array('listadmin.php?mergeparents=1&amp;datman=1', 'Merge/migrate parent records');
    $navs[] = array('attrib-assist.php', 'Attributes');
    $navs[] = array('import.php', 'Import/update records');
    $navs[] = array('admin.php?datman=1&amp;AnalyzeTables', 'Analyze all tables');
    $navs[] = array('admin.php?check_database_fields', 'Check/fix database schema');
    $navs[] = array('admin.php?datman=1&amp;recreate_mysql_triggers', 'Re-create MySQL triggers');
    $navs[] = array('admin.php?datman=1&amp;create_indices', 'Check indices');
    $navs[] = array('admin.php?IntermediateDatabaseUpgrade=1', 'Intermediate Database Upgrade');
    $navs[] = array('admin.php?checkdb=1&amp;web=1', 'Check database consistency');
    $navs[] = array('admin.php?excessfields=1', 'Excess tables &amp; fields check');
    $navs[] = array('admin.php?checkfiles=1', 'Excess files check');
    $navs[] = array('admin.php?PerformDatabaseMaintenance=1', 'Database maintenance');
    $navs[] = array('admin.php?basicstats=1', 'Basic table statistics');

    return $navs;
}
function get_adminglobal_nav_items()
{
    $navs = array();

    $navs[] = array('admin.php?settings=1', 'Settings');
    $navs[] = array('admin.php?actions=1', 'Actions');
    $navs[] = array('dictedit.php?packman=1', 'Manage language packs');
    $navs[] = array('admin.php?reposman=1&amp;resman=1&amp;manageres=1', 'Manage repositories');
    $navs[] = array('admin.php?log=1', 'View log');
    $navs[] = array('admin.php?ViewJournal=1', 'View journals');
    $navs[] = array('admin.php?ViewDataJournal=1', 'View datajournals');
    $navs[] = array('admin.php?GeneralFiles', 'General purpose files');
    $navs[] = array('admin.php?SystemFiles', 'System files');
    $navs[] = array('admin.php?PublicFiles', 'Public files');
    $navs[] = array('listadmin.php?datastructure=1&amp;datman=1', 'Data structure');
    $navs[] = array('list.php?datastructuregraphic=1&amp;datman=1', 'Data structure graphic');
    $navs[] = array('listadmin.php?tables=1&amp;datman=1', 'System/data tables');
    $navs[] = array('listadmin.php?tablecomparison=1&amp;datman=1', 'Table comparison');
    $navs[] = array('listadmin.php?fieldcomparison=1&amp;datman=1', 'Field comparison');
    $navs[] = array('listadmin.php?groupcomparison=1&amp;datman=1', 'Group comparison');
    $navs[] = array('listadmin.php?lists=1&amp;datman=1', 'Available lists');
    $navs[] = array('list.php?searchalltables=1', 'Search all tables');
    $navs[] = array('index.php?UserMessage=1', 'Messages');
    $navs[] = array('listadmin.php?renumbertables=1', 'Renumber ordering of tables');
    $navs[] = array('listadmin.php?renumberfields=1', 'Renumber ordering of fields');
    $navs[] = array('listadmin.php?showlocks=1', 'Show/delete locks');

    return $navs;
}
function get_admin_nav_items()
{
    $tables = array();
    $tables[] = array('flextable.php?EditFlexTable=new', 'New table');
    foreach ($GLOBALS['UC']['PersonalDataStructure'] as $table => $props) {
        if ($props['datatable']) {
            $tables[] = array('flextable.php?EditFlexTable='.str_replace('t', '', $table).'', $table.' '.$props['plural']);
        }
    }
    $calendars = array();
    $calendars[] = array('record.php?table=calendars', 'New calendar');
    foreach (db_GetArray("SELECT id, description FROM CRMcalendars WHERE deleted='n'") as $cal) {
        $calendars[] = array('record.php?table=calendars&amp;record='.$cal['id'].'', $cal['id'].' '.ParseTemplateLanguageTags($cal['description']));
    }
    $groups = array();

    foreach (db_GetArray('SELECT id, name FROM CRMuserprofiles') as $group) {
        $groups[] = array('useradmin.php?EditGroup='.$group['id'].'', $group['id'].' '.$group['name']);
    }
    $mods = array();
    $mods[] = array('modules.php?action=addonline', 'New module');

    foreach (db_GetArray('SELECT mid, module_name FROM CRMmodules WHERE version_belonging_to=0 ORDER BY timestamp_last_change DESC LIMIT 10') as $mod) {
        $mods[] = array('modules.php?action=edit&amp;mid='.$mod['mid'].'', $mod['mid'].' '.$mod['module_name']);
    }

    $fields = array();
    foreach (db_GetArray("SELECT id, tabletype, name FROM CRMextrafields WHERE deleted='n' ORDER BY timestamp_last_change DESC LIMIT 50") as $field) {
        $fields[] = array('extrafields.php?editextrafield='.$field['id'].'&amp;tabletype='.$field['tabletype'].'', $field['id'].': '.$field['name']);
    }
    $templates = array();
    $templates[] = array('admin.php?templates=1&amp;add=1', 'New template');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_HTML_FORM', 'Forms');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_HTML', 'HTML');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_REPORT_PDF', 'PDF');
    $templates[] = array('admin.php?templates=1&amp;t1=all&amp;type=TEMPLATE_CSS', 'CSS');
    foreach (db_GetArray('SELECT templateid, templatename FROM CRMtemplates WHERE version_belonging_to = 0 ORDER BY timestamp_last_change DESC LIMIT 50') as $t) {
        $templates[] = array('admin.php?templates=1&amp;editHTMLtemplate='.$t['templateid'], $t['templateid'].': '.$t['templatename']);
    }

    $rules = array();
    $rules[] = array('record.php?table=rules', 'New rule');
    $rules[] = array('list.php?table=ruleconditions', 'Rule conditions');
    $rules[] = array('list.php?table=ruleactions', 'Rule actions');
    $rules[] = array('list.php?table=ruleactionconditions', 'Rule action conditions');
    foreach (db_GetArray('SELECT id, name FROM CRMrules ORDER BY timestamp_last_change DESC LIMIT 50') as $t) {
        $rules[] = array('record.php?table=rules&amp;record='.$t['id'], $t['id'].': '.$t['name']);
    }

    $navs = array();
    $navs[] = array('admin.php', '<span class="fa fa-fw fa-home"></span> Main', array());
    $navs[] = array('admin.php?syscon=1', '<span class="fa fa-fw fa-wrench"></span> System configuration', get_adminglobal_nav_items());
    $navs[] = array('admin.php?datman=1', '<span class="fa fa-fw fa-database"></span> Data management', get_datamanagement_nav_items());
    $navs[] = array('useradmin.php?cur=1', '<span class="fa fa-fw fa-users"></span> Users &amp; Groups', $groups);
    $navs[] = array('extrafields.php', '<span class="fa fa-fw fa-caret-square-o-down"></span> Fields', $fields);
    $navs[] = array('flextable.php?TableAdmin=true', '<span class="fa fa-fw fa-table"></span> Tables', $tables);
    $navs[] = array('rules.php', '<span class="fa fa-fw fa-exchange"></span> Rules', $rules);
    $navs[] = array('admin.php?templates=1&amp;t1=all', '<span class="fa fa-fw fa-pencil-square-o"></span> Templates', $templates);
    $navs[] = array('admin.php?CalendarAdmin', '<span class="fa fa-fw fa-calendar"></span> Calendars', $calendars);
    $navs[] = array('modules.php', '<span class="fa fa-fw fa-code"></span> Modules', $mods);
    $navs[] = array('', '<a onclick="$(\'#minifiedmenu\').toggle(250);"><span class="fa fa-bars fa-fw"></span> App: ' . fillout(GetSetting('title'),20) . '</a>', array());
    $dropds = '<span class="fa fa-trash-o fa-fw"></span> Drop DS';
    $class = '';
    if (GetAttribute('user','UserNeedsToDropDS', $GLOBALS['userid']) == 'Yes') {
        $class = 'warnmsg';
    }
    $navs[] = array('admin.php?dropds', $dropds, array(), $class);

    $navs[] = array('http://www.atomos.nl/', '<span class="fa fa-question-circle fa-fw"></span> Get help', array());


    return $navs;
}
function get_user_messages($BYAJAX = true)
{
    global $lang;
    /* todo: get _REQUEST queries out of this function */
    $result = array();

    $stp = false;

    if ($_REQUEST['my_rep_hash'] != md5(db_GetValue('SELECT DATABASE()')) && $BYAJAX) {

        /* this means the user has a valid session, but not connected to this repository. we redirect and alert the user */
        $result['command'] = 'redirect_to_dash';
        $stp = true;
    } else {
        $result['message'] = '';

        if (GetSetting('DisableAllInternalMessagePopups') == 'Yes') {
            $stp = false;
        } else {
            if (!is_array($GLOBALS['SesMem']['ShownMessages'])) {
                $GLOBALS['SesMem']['ShownMessages'] = array();
            }
            if (!is_array($GLOBALS['SesMem']['ShownMessages']['internalmessages'])) {
                $GLOBALS['SesMem']['ShownMessages']['internalmessages'] = array();
            }

            $calendars = GetAccessibleCalendars();

            $tmp_message = '';
            foreach ($calendars as $calKey => $calObj) {
                $calendarnameprinted = false;

                if ($calObj['display_popup'] == 'Yes' && GetAttribute('user', 'HideCalendar-'.$calKey, $GLOBALS['USERID']) != 'Yes') {
                    $local_calendar = GetCalendarEvents($calKey, 'messages', date('Y-m-d'), date('Y-m-d'));

                    foreach ($local_calendar as $event) {
                        if (trim($calObj['show_popup']) == '') {
                            $calObj['show_popup'] = '30,5,0';
                        }
                        $list = explode(',', $calObj['show_popup']);

                        foreach ($list as $minute_before) {
                            $minute_before = trim($minute_before) * 1;

                            $alert_time = date('Y-m-d H:i', strtotime($event['iso_start'].' -'.$minute_before.' minutes'));

                            if ($alert_time == date('Y-m-d H:i')) { // OK, action!

                                /* can this be removed? */
                                if ($event['iso_start'] == '') {
                                    $event['iso_start'] = $event['iso_end'];
                                }

                                // Create unique id to store so we know if we already did this one
                                $id = $event['id'].' '.$event['recordid'].$minute_before;

                                if (!$GLOBALS['SesMem']['ShownMessages'][$id]) {
                                    if (!$calendarnameprinted) {
                                        $tmp_message .= '<h2>'.htme($calObj['description']).'</h2>';
                                        $calendarnameprinted = true;
                                    }

                                    $closelink = false;
                                    $tmp_message .= '<div>';
                                    if ((($calObj['appointment_click_action'] == 'Open record in current window') || ($calObj['appointment_click_action'] == 'Open record in popup')) && ($event['openlink'] != '')) {
                                        $tmp_message .= '<a href="'.htme($event['openlink']).'" onclick="ilor(this.href,0,\'\');return false;">';
                                        $closelink = true;
                                    }

                                    //summary is een html veld dus niet door htme()
                                    $tmp_message .= SQLDateTimeToFormattedDateTime($event['iso_start']).' '.$event['summary'];
                                    if ($closelink) {
                                        $tmp_message .= '</a>';
                                    }
                                    $tmp_message .= '</div>';

                                    $GLOBALS['SesMem']['ShownMessages'][$id] = true;

                                    $stp = true;
                                } else {

                                    /* not showing again: $id - " . $event['summary'] */
                                }
                            } else {

                                /*
                                    print "Alert time $alert_time != " . date('Y-m-d H:i') . ". No action needed.<br>";
                                  */
                            }
                        }
                    }
                } else {
                    /*
                     * Skipping events of calendar ' . $calKey . ', show_popup is : ' . $calObj['show_popup'] .
                     *
                     */
                }
            }
            if ($stp) {
                $result['message'] .= $tmp_message;
            }
            $sql_ins = '';
            if (is_administrator()) {
                $sql_ins = "(`to`='".$GLOBALS['USERID']."' OR `to`=0)";
            } else {
                $sql_ins = "`to`='".$GLOBALS['USERID']."'";
            }
            $to_show = db_GetFlatArray('SELECT * FROM CRMinternalmessages WHERE '.$sql_ins." AND `read`='n' AND shown_in_popup='n' ORDER BY id DESC");
            if (count($to_show) > 0) {
                $result['message'] .= '<h2><a href="index.php?UserMessage">'.htme($lang['messageinbox']).': '.count($to_show).' '.htme($lang['incomingmessages']).'</a></h2>';
                $lo = array('table' => 'messages', 'hiddenfilter' => array('messages-shown_in_popup' => array('n'), 'messages-to' => array($GLOBALS['USERID']), 'messages-read' => array('n')), 'type_of_list' => 'sublist', 'hide_all' => true);
                if (is_administrator()) {
                    $lo['hiddenfilter']['messages-to'][] = 0;
                }
                list($number_of_records, $output) = make_list($lo);
                $result['message'] .= $output;

                $sql = "UPDATE CRMinternalmessages SET shown_in_popup='y' WHERE id IN (".implode(',', $to_show).')';
                mcq($sql);
            }
        }
    }

    $result['result'] = 'ok';
    /* LEAVE: this commits the ShowMessages array to the session */
    EndSEssion();

    return $result;
}

function create_menu()
{
    $html = '';

    $template_id = 0;
    if ($GLOBALS['GROUPID'] > 0)
    {
	$template_id = db_GetValue('SELECT `MENUTOUSE` FROM `CRMuserprofiles` WHERE `id`='.$GLOBALS['GROUPID']);
    }
    if ($template_id == 0)
    {
	$template_id = GetSetting('MenuTemplateId');
    }

    if ($template_id > 0) {
        $html .= ParseTemplateMenu($template_id);

        if (is_administrator()) {
            if (!$GLOBALS['webapp']) {
                // Shortkeys for admins
                $html .= '<div class="hide_content">';
                $html .= "<a accesskey='a' href='admin.php?info=1'></a>";
                $html .= "<a accesskey='s' href='admin.php?settings=1'></a>";
                $html .= "<a accesskey='d' href='admin.php?IntermediateDatabaseUpgrade=1'></a>";
                $html .= "<a accesskey='p' href='admin.php?fysdelete=1'></a>";
                $html .= "<a accesskey='l' href='dictedit.php?packman=1'></a>";
                $html .= "<a accesskey='u' href='useradmin.php?cur=1&amp;password=&amp;adduser=1&amp;userman=1'></a>";
                $html .= "<a accesskey='p' href='admin.php?fysdelete=1'></a>";
                $html .= "<a accesskey='e' href='extrafields.php?'></a>";
                $html .= "<a accesskey='r' href='admin.php?reposman=1&amp;resman=1&amp;manageres=1'></a>";
                $html .= "<a accesskey='f' href='flextable.php?TableAdmin=true'></a>";
                $html .= '</div>';
            }
        }
    }

    return $html;
}
function Show404($message = '')
{
    header('HTTP/1.0 404 Not Found');
    header('Content-Type: text/html; charset=UTF-8');
    print '<!DOCTYPE html>';
    print '<html>';
    print '<head>';
    print '<meta charset="UTF-8">';
    print '<title>Page not found</title>';
    print '</head>';
    print '<body>';
    print '<h1>Page not found</h1>';
    print '<img src="'.GetSetting('BASEURL').'images/interleave128.png" alt="">';
    print '<p>'.htme($message).'</p>';
    print '<p>The requested URL was not found on this server.</p>';
    print '<p><a href="'.GetSetting('BASEURL').'index.php">Go back to dashboard</a></p>';

    print '</body>';
    print '</html>';
}
/* was moved to adminfunctions.php HF20161227 put back, in userside use in GFS */
function get_pastel_color_by_hash($name)
{
        $hash = md5($name);

        $color1 = hexdec(substr($hash, 8, 2));
        $color2 = hexdec(substr($hash, 4, 2));
        $color3 = hexdec(substr($hash, 0, 2));
        if ($color1 < 128) $color1 += 128;
        if ($color2 < 128) $color2 += 128;
        if ($color3 < 128) $color3 += 128;

        return dechex($color1) . dechex($color2) . dechex($color3);
}


function ShowTableTags($table, $CKEditorInstance, $type, $fqn, $recordid)
{
    global $lang;
//	print "<h1>type $type table $table fqn $fqn record $recordid</h1>";

    if ($table == 'files') {
        /* exception for files being edited directy */
        list($recordid, $table) = db_GetRow("SELECT koppelid, REPLACE(type, 'flextable', 't') FROM CRMbinfiles WHERE fileid='" . mres($recordid) . "'");
        $fqn = $table . '-timestamp_last_change';

    }

    print '<div class="tagbarclose"><a onclick="hideTagSideBar();"><span class="fa fa-times">&nbsp;</span></a></div>';
    if ($type == '') {
        if ($fqn != '' && ipi($recordid)) {
            $type = 'images';
        } else {
            $type = 'tabletags';
        }
    }
    $types = array();
    if (is_administrator() && !ipi($recordid)) {
        $types = array('tabletags' => 'Table/field tags', 'listtags' => 'List options', 'generic' => 'Generic tags', 'language' => 'Language tags');
    }
    $types['images'] = 'Images';
    print '<nav><ul>';
    foreach ($types as $typename => $name) {
        print '<li><a onclick="';
        print "refresh_contents_of_div('JS_tagdiv','flextable.php','nonavbar=1&amp;BYAJAX=1&amp;type=".htme($typename).'&amp;CKEditorInstance='.htme($CKEditorInstance).'&amp;showtags='.htme($table).'&amp;fqn='.$fqn.'&amp;record='.$recordid."',false,'GET',false,false,'');";

        print '"';
        if ($type == $typename) {
            print ' class="active"';
        }

	print '>'.htme($name).'</a></il>';
    }
    print '</ul></nav>';
    print '<div id="JS_tagdivcontents">';
    print "<table class='filtertablenohighlight'>";
//check if user is look for generic or all table
    if ($type == 'generic' || $type == 'all') {
        foreach (AvailableTags() as $arr) {
            print '<tr><td><div class="tagsof" draggable="true" ondragstart="drag(event,\''. inline_jsencode($arr[0]) . '\')">'.htme($arr[0]).'</div></td><td><button onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\''.inline_jsencode(htme($arr[0])).'\');return(false);">insert</button></td><td>'. $arr[1] .'</td></tr>';
        }
    }
//check if user is look for listtags or all table
    if ($type == 'listtags' || $type == 'all') {
        foreach ($GLOBALS['UC']['PersonalDataStructure'] as $pds => $props) {
            if ($props['datatable']) {
                print '<tr><td><div class="tagsof" draggable="true" ondragstart="drag(event,\'#LIST|table='. inline_jsencode($pds) . '\')">#LIST|table='.htme($pds).'</div></td><td><button onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'#LIST|table='.inline_jsencode($pds).'\');return(false);">insert</button></td><td>List tag: '.htme($props['plural']).'</td></tr>';
            }
        }

        foreach (get_list_options_and_descriptions() as $name => $arr) {

            /* check if valid contains an array of values */
            if (is_array($arr['Valid']) && count($arr['Valid']) > 0) {

                /* if so, walk through it */
                 foreach ($arr['Valid'] as $Valid) {

                    /* we don't want to print options having the default value - that would be useless */
                    if ($arr['Default'] !== $Valid) {

                        /* false will print noting, so if false print a zero */
                        if ($Valid === false) {
                            $Valid = '0';
                        }

                        /* print the row */
                        print '<tr><td><div class="tagsof" draggable="true" ondragstart="drag(event,\''. inline_jsencode($name) . '=' . htme($Valid) . '\')">'.htme($name).'='.htme($Valid).'</div></td><td><button onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\''.inline_jsencode($name).'='.inline_jsencode($Valid).'\');return(false);">insert</button></td><td>'.htme($arr['Description']).'</td></tr>';
                    }
                 }
            } else {

                /* if not, we just don't really know, just print the option */
                print '<tr><td><div class="tagsof"  draggable="true" ondragstart="drag(event,\''. inline_jsencode($name) . '=\')">'.$name.'=</div></td><td><button onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'|'.inline_jsencode($name).'=\');return(false);">insert</button></td><td>'.htme($arr['Description']).'</td></tr>';
            }
        }
    } /* end listtags */
//check if user is look for tabletags or all table
    if ($type == 'tabletags' || $type == 'all') {
        /* called checks if user is admin. even is he isn't, this function uses personal DS so it's secure */
        if ($table == 'undefined') $table = '';
        print '<h2>Tags for table ';

        print '<select onchange="';
        print "refresh_contents_of_div('JS_tagdiv','flextable.php','nonavbar=1&amp;BYAJAX=1&amp;type=".htme($type).'&amp;CKEditorInstance='.htme($CKEditorInstance)."&amp;showtags=' + this.value + '',false,'GET',false,false,false);\"";
        print " id=\"kiestable\">";

        print "<option value=''>All</option>";

        foreach ($GLOBALS['UC']['PersonalDataStructure'] as $pds => $props) {
            if (ipi(str_replace('t', '', $pds))) {
                print '<option value="'.htme($pds).'"';
                if ($table == $pds) {
                    print ' selected';
                }
                print '>'.$pds.': '.$props['plural'].' ('.count($GLOBALS['UC']['PersonalDataStructure'][$pds]['allfields']).')</option>';
            }
        }
        print '</select>';

        print '<input type="hidden" name="CKEditorInstance" id="CKEditorInstance" value="'.htme($CKEditorInstance).'">';
        print ReturnDropDownSearchField('kiestable');
        print '</h2>';

        foreach ($GLOBALS['UC']['PersonalDataStructure'] AS $tablets => $props) {
            if ($props['datatable'] && ($tablets == $table || $table == '')) {
                print '<tr><td colspan="4"><h2>' . htme($props['plural']) . '</h2></td></tr>';

                foreach ($GLOBALS['UC']['PersonalDataStructure'][$tablets]['allfields'] as $f) {
                    $tmp = explode("-", $f);
                    if (count($tmp) == 2 || $table != '') {

                        $tp = '<tr><td><div class="tagsof" draggable="true" ondragstart="drag(event,\''.inline_jsencode($f).'\')"><input type="text" value="'.htme($f).'"></div></td>';

                        $tp .= '<td class="nwrp">';

                        $tp .= '<button draggable="true" ondragstart="drag(event,\'#'.inline_jsencode($f).'#\')" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'#'.inline_jsencode($f).'#\');return(false);">#</button>&nbsp;';

                        $tp .= '<button draggable="true" ondragstart="drag(event,\'@'.inline_jsencode($f).'@\')" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'@'.inline_jsencode($f).'@\');return(false);">@</button>&nbsp;';

                        $tp .= '<button draggable="true" ondragstart="drag(event,\'%'.inline_jsencode($f).'%\')" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'%'.inline_jsencode($f).'%\');return(false);">%</button>&nbsp;';

                        $tp .= '<button draggable="true" ondragstart="drag(event,\'hiddenfilter_'.inline_jsencode($f).'=\')" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'hiddenfilter_'.inline_jsencode($f).'=\');return(false);">hf</button>';
                        $tp .= '</td>';

                        $tp .= '<td>';
                        $el = explode('-', $f);
                        for ($x = 0; $x < count($el); $x += 2) {
                            if (ipi(str_replace('t', '', $el[$x]))) { // it's a flextable
                                $el[$x] = GetFlextableName(str_replace('t', '', $el[$x])).' ['.$el[$x].']';
                            }
                            $el[$x] = '<strong>'.$el[$x].'</strong>';
                            if (ipi(str_replace('f', '', $el[$x + 1]))) { // it's an field
                                $eft = GetExtraFieldType(str_replace('f', '', $el[$x + 1]));
                                $eft = str_replace('Reference to FlexTable', 'REF', $eft);
                                $eft = str_replace('User-list of all CRM-CTT users', 'REF', $eft);

                                $el[$x + 1] = GetExtraFieldName(str_replace('f', '', $el[$x + 1])).' ['.$el[$x + 1].'] ['.$eft.']';
                            }
                            $tp .= ' &raquo; '.$el[$x].' &raquo; '.$el[$x + 1].'';
                        }
                        $tp .= '</td></tr>';

                        print $tp;
                    }
                }
            }
        }
    } /* end tabletags */
    //check if user is look for language or all table
    if ($type == 'language' || $type == 'all') {
        foreach ($lang as $tag => $text) {
            print '<tr><td><div class="tagsof" draggable="true" ondragstart="drag(event,\'[['.inline_jsencode($tag).']]\')">[['.$tag.']]</div></td><td><button onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\''.htme('[['.$tag.']]').'\');return(false);">insert</button></td><td>'.htme($text).'</td></tr>';
        }
    }
    /* end language */

    if ($type == 'images' || $type == 'all') {
        $extra_js = '';
        if (!ipi($recordid)) {
            /* if a user has only access to images, close after select */
            $extra_js = 'hideTagSideBar();';
        }

        list($dstable, $dsfield) = explode('-', $fqn);

        if (is_array($GLOBALS['UC']['PersonalDataStructure'][$dstable]) && CheckTableRecordAccess($dstable, $recordid) != 'nok' && ipi($recordid)) {

            $fts = array();
            $tp = array($dstable . '-' . $GLOBALS['UC']['PersonalDataStructure'][$dstable]['primary']);

            foreach ($GLOBALS['UC']['PersonalDataStructure'][$dstable]['allfields'] AS $t) {

                $s = explode('-', $t);
                $tab = $s[count($s)-4];
                $field = $s[count($s)-1];

                if (is_array($GLOBALS['UC']['PersonalDataStructure'][$tab]) && $GLOBALS['UC']['PersonalDataStructure'][$tab]['datatable'] && $field == $GLOBALS['UC']['PersonalDataStructure'][$tab]['primary']) {
                    $fts[] = $t;
                    $tp[] = $t;
                } else {
                    //print 'skip ' . $t . ' tab ' . $tab . ' != ' . $dstable . '<br>';
                }
            }

        //    DA($tp);
            $current_record = getrecord($dstable, $recordid, false, false, $fts, true); //do_not_check_write_access=true

        //    DA($current_record);


            foreach ($tp AS $toprocess) {

                $localrecord = $current_record[$toprocess];
                $tmp = explode("-", $toprocess);
                $localdstable = $tmp[count($tmp)-2];

                $localhtml = '<tr><td><h2>' . htme($GLOBALS['UC']['PersonalDataStructure'][$localdstable]['singular']) . ' ' . htme(get_refer_layout_for_record($localdstable, $localrecord)) . '</h2></td></tr>';
                $localhtml .= '<tr><td>';
                $listoptions = array();
                $listoptions['table'] = 'files';
                $listoptions['outputtype'] = 'array';
                $listoptions['perpage'] = 0;
                $listoptions['internallistcall'] = true;
                $listoptions['hiddenfilter']['files-koppelid'][] = $localrecord;
                $listoptions['hiddenfilter']['files-type'][] = ds_tablename_to_binfiles_table($localdstable);
                $listoptions['hiddenfilter']['files-filetype'][] = 'image/png';
                $listoptions['hiddenfilter']['files-filetype'][] = 'image/jpeg';
                $listoptions['hiddenfilter']['files-filetype'][] = 'image/gif';
                $sr = false;
                foreach (make_list($listoptions) as $image) {
                    $localhtml .=  '<div class="selectimage" draggable="true" ondragstart="drag(event,\'<img src=&quot;'.add_sessionid_to_url(GetSetting('BASEURL').'csv.php?fileid='.$image['files-fileid']).'&amp;displayinline=1&quot; title=&quot;'.htme($image['files-filename']).'&quot; alt=&quot;'.htme($image['files-filename']).'&quot;>\')"><img class="" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'<img src=&quot;'.add_sessionid_to_url(GetSetting('BASEURL').'csv.php?fileid='.$image['files-fileid']).'&amp;displayinline=1&quot; title=&quot;'.htme($image['files-filename']).'&quot; alt=&quot;'.htme($image['files-filename']).'&quot;>\');' . $extra_js . '" src="' . add_sessionid_to_url('csv.php?tn='.$image['files-fileid']).'&amp;displayinline=1" title="'.htme($image['files-filename']).'" alt="'.htme($image['files-filename']).'"></div>';
                    $sr = true;
                }
                $localhtml .=  '</td></tr>';
                if ($sr) {
                    print $localhtml;
                }


            }

        }


        $listoptions = array();
        $listoptions['table'] = 'files';
        $listoptions['outputtype'] = 'array';
        $listoptions['perpage'] = 0;
        $listoptions['internallistcall'] = true;
        $listoptions['hiddenfilter']['files-koppelid'][] = 0;
        $listoptions['hiddenfilter']['files-type'][] = 'generalpurpose';
        $listoptions['hiddenfilter']['files-filetype'][] = 'image/png';
        $listoptions['hiddenfilter']['files-filetype'][] = 'image/jpeg';
        $listoptions['hiddenfilter']['files-filetype'][] = 'image/gif';
        print '<tr><td><h2>General purpose files</h2></td></tr>';
        print '<tr><td>';
        foreach (make_list($listoptions) as $image) {
            print '<div class="selectimage" ><img ';

            print 'draggable="true" ondragstart="drag(event,\'<img src=&quot;'.add_sessionid_to_url(GetSetting('BASEURL').'csv.php?fileid='.$image['files-fileid']).'&amp;displayinline=1&quot; title=&quot;'.htme($image['files-filename']).'&quot; alt=&quot;'.htme($image['files-filename']).'&quot;>\')" class="" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'<img src=&quot;'.add_sessionid_to_url(GetSetting('BASEURL').'csv.php?fileid='.$image['files-fileid']).'&amp;displayinline=1&quot; title=&quot;'.htme($image['files-filename']).'&quot; alt=&quot;'.htme($image['files-filename']).'&quot;>\');' . $extra_js . '" src="' . add_sessionid_to_url('csv.php?tn='.$image['files-fileid']).'&amp;displayinline=1" title="'.htme($image['files-filename']).'" alt="'.htme($image['files-filename']).'"></div>';
        }
        print '</td></tr>';

        $listoptions = array();
        $listoptions['table'] = 'files';
        $listoptions['outputtype'] = 'array';
        $listoptions['perpage'] = 0;
        $listoptions['internallistcall'] = true;
        $listoptions['hiddenfilter']['files-koppelid'][] = 0;
        $listoptions['hiddenfilter']['files-type'][] = 'public';
        $listoptions['hiddenfilter']['files-filetype'][] = 'image/png';
        $listoptions['hiddenfilter']['files-filetype'][] = 'image/jpeg';
        $listoptions['hiddenfilter']['files-filetype'][] = 'image/gif';
        print '<tr><td><h2>Public files</h2></td></tr>';
        print '<tr><td>';
        foreach (make_list($listoptions) as $image) {
            print '<div class="selectimage"><img ';
            print 'draggable="true" ondragstart="drag(event,\'<img src=&quot;'.GetSetting('BASEURL').'publicfile.php?filename='.$image['files-filename'].'&amp;displayinline=1&quot; title=&quot;'.htme($image['files-filename']).'&quot; alt=&quot;'.htme($image['files-filename']).'&quot;>\')" class="" onclick="CKEDITOR.instances[\''.$CKEditorInstance.'\'].insertHtml(\'<img src=&quot;'.GetSetting('BASEURL').'publicfile.php?filename='.$image['files-filename'].'&amp;displayinline=1&quot; title=&quot;'.htme($image['files-filename']).'&quot; alt=&quot;'.htme($image['files-filename']).'&quot;>\');' . $extra_js . '" src="' . add_sessionid_to_url('csv.php?tn='.$image['files-fileid']).'&amp;displayinline=1" title="'.htme($image['files-filename']).'" alt="'.htme($image['files-filename']).'"></div>';
        }

        print '</td></tr>';
    } /* end images */
    print '</table>';
    print '</div>';
}
function AvailableTags()
{
    $res = array();

    $res[] = array('@BASEURL@', 'Tag to the BASEURL , like http://www.interleave.nl');
    $res[] = array('@REPOSNUM@', 'Current working repository number');
    $res[] = array('@WEBHOST@', 'The hostname of this system');
    $res[] = array('@TITLE@', 'The title of this application');
    $res[] = array('@ADMEMAIL@', 'The administrators e-mail address');
    $res[] = array('@ADMINEMAIL@', 'The current configured adminemail');
    $res[] = array('@DATE@', 'The date at the moment of processing');
    $res[] = array('@UNFORMATTED_DATE@', 'The date at the moment of processing (unformatted - dd-mm-yyyy)');
    $res[] = array('@ISODATE@', 'The date at the moment of processing (ISO format: yyyy-mm-dd)');
    $res[] = array('@ISODATETIME@', 'The date and time at the moment of processing (ISO format: yyyy-mm-dd HH:mm:ss)');
    $res[] = array('@TODAY@ ', 'The current date(dd-mm-yyyy)');
    $res[] = array('@TODAYISO@', 'The current date in ISO format(yyyy-mm-dd)');
    $res[] = array('@NOW@', 'The current date in ISO format + time (yyyy-mm-dd hh:mm:ss)');
    $res[] = array('@TODAY_UNFORMATTED@', 'The date at the moment of proccessing (unformatted - dd-mm-yyyy)');
    $res[] = array('@NOW_FORMATTED@', 'The current date formatted (formatted dd-mm-yyyy hh:mm:ss)');
    $res[] = array('@NOW_UNFORMATTED@', 'The date at the moment of proccessing (yyyy-mm-dd hh:mm:ss)');
    $res[] = array('@EPOCH@', 'Seconds since the Unix Epoch (January 1 1970 00:00:00 GMT)');
    $res[] = array('@YESTERDAY@', 'The current yesterday(dd-mm-yyyy)');
    $res[] = array('@TOMORROW@', 'The current tomorrow(dd-mm-yyyy)');
    $res[] = array('@YESTERDAY_UNFORMATTED@', 'The yesterday of the moment of proccessing(dd-mm-yyyy)');
    $res[] = array('@TOMORROW_UNFORMATTED@', ' The tomorrow of the momeent of processing(dd-mm-yyyy)');
    $res[] = array('@YESTERDAYISO@', 'The yesterday in ISO format(yyyy-mm-dd)');
    $res[] = array('@TOMORROWISO@', 'The tomorrow in ISO format(yyyy-mm-dd)');
    $res[] = array('@USERID@', 'ID of the current user');
    $res[] = array('@TIME@', ' The time at the moment of processing (24 format hh:mm:ss)');
    $res[] = array('@USER@', "The current user's full name");
    $res[] = array('%PAGEBREAK%', 'Page break (only for RTF and PDF templates)');
    $res[] = array('#MESSAGES#', 'Internal messages');
    $res[] = array('#CALENDAR#', 'Calendar');

    foreach (array('envelope', 'mobile', 'desktop', 'file-pdf-o', 'file-excel-o', 'times', 'search', 'lock', 'files-o', 'exclamation-triangle', 'check', 'external-link', 'plus', 'list-alt', 'edit', 'calendar', 'bars', 'phone', 'info-circle', 'user', 'tachometer', 'cog', 'power-off', 'book', 'line-chart', 'arrow-left', 'arrow-right', 'plus-square-o', 'minus-square-o', 'credit-card') as $awesome) {
        $html = '<span class="fa fa-'.$awesome.'">&nbsp;</span>';
        //print '<div>' . $html . ' ' . htme($html) . '</div>';
        $res[] = array($html, $html);
    }

    return $res;
}
function replace_images_for_pdf_and_mails($nt, $destination = 'html') {
    /* replace references to csv.php in this template with in inline representation or link to disk */

    $doc = new DOMDocument();
    @$doc->loadHTML($nt);
    $imgs = $doc->getElementsByTagname('img');
    $tmpfiles = array();
    $debug = '';

    /* array to hold the paths to temporary disk files. we cannot delete them here because the pdf parser needs them to be there.
       we return this array, and the files will be deleted by the pdf parse function. nasty, but the only way to do it. */
    $tmpfiles = array();

    foreach ($imgs as $img) {
        $src = $img->getAttribute('src');
        $debug .= 'Found src attribute: ' . $src . '<br>';

        list($filename, $urloptions) = explode('?', basename($src));

        if ($filename == 'csv.php' || $filename == 'publicfile.php') {

            /* this is a reference to csv.php, one of our own files in an image tag */
            parse_str($urloptions, $arguments);

	        $imgblob = '';

            /* support for public files */
            if ($filename == 'publicfile.php') {

                $arguments['fileid'] = db_GetValue("SELECT CRMbinfiles.fileid FROM CRMbinfiles WHERE CRMbinfiles.filename='" . mres($arguments['filename']) . "' AND CRMbinfiles.type='public'");

                if (CheckTableRecordAccess("files", $arguments['fileid']) != "nok") {
                    $imgblob = GetFileContent($arguments['fileid']);
                }

            } elseif (ipi($arguments['tn'])) {

                /* thumbnails */
                $arguments['fileid'] = $arguments['tn'];
                if (CheckTableRecordAccess("files", $arguments['fileid']) != "nok") {
                    $imgblob = GetImageThumbnail($arguments['tn']);
                }

            } elseif (ipi($arguments['minitn'])) {

                /* mini thumbnail */
                $arguments['fileid'] = $arguments['minitn'];
                if (CheckTableRecordAccess("files", $arguments['fileid']) != "nok") {
                    $imgblob = GetMiniThumbnail($arguments['minitn']);
                }

            } else {
                if (CheckTableRecordAccess("files", $arguments['fileid']) != "nok") {
                    $imgblob = GetFileContent($arguments['fileid']);
                }

            }

            $filetype = GetFileType($arguments['fileid']);
            if ($filetype == 'image/jpg' || $filetype == 'image/jpeg' || $filetype == 'image/gif'  || $filetype == 'image/png') {

                $autorotate = false;
                $setwidth = 'aspect';
                $setheight = 'aspect';
                $copyrightmsg = '';

                if ($arguments['autorotate'] != '') $autorotate = true;
                if (ipi($arguments['width'] != '')) $setwidth = $arguments['width'];
                if (ipi($arguments['height'] != '')) $setheight = $arguments['height'];
                if ($arguments['copyrightmessage'] != '') $copyrightmsg = $arguments['copyrightmessage'];


                if ($autorotate || ipi($setwidth) || $copyrightmsg != '') {
                    $imgblob = ResizeImage($imgblob, $setwidth, $setheight, "0,0,0", "104,104,104", $copyrightmsg, $autorotate);
                }

                if (ipi($arguments['fileid'])) {

                    /* check security */
                    $type = db_GetValue("SELECT type FROM CRMbinfiles WHERE fileid='" . $arguments['fileid'] . "'");

                    if ($type == 'public' || CheckTableRecordAccess('files', $arguments['fileid']) != 'nok') {

                        if ($destination == 'pdf') {

                            /* we now temporarily save this file to disk */
                            $path = CopyFileToDisk($arguments['fileid'], $imgblob);
                            $tmpfiles[] = $path;
                            $img->setAttribute('src', $path);

                        } else {

                            $newsrc = "data:" . GetFileType($arguments['fileid']) . ";base64," . base64_encode($imgblob);
                            $img->setAttribute('src', $newsrc);

                        }

                    } else {

                        log_msg("ERROR: A file needed to be included as an inline image in a template but access was denied: " . $arguments['fileid']);

                    }
                }
            }
        }
    }
    return array($doc->saveHTML(), $tmpfiles);
}
?>
